diff -pruN 2.14.0-2/AUTHORS.md 2.15.1-0ubuntu2/AUTHORS.md
--- 2.14.0-2/AUTHORS.md	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/AUTHORS.md	2020-10-28 14:31:59.000000000 +0000
@@ -19,6 +19,7 @@ List of all individuals having contribut
 - Despina Papadopoulou
 - Dimitri John Ledkov
 - Eberhard Pasch
+- Eduard Shishkin
 - Einar Lueck
 - Eric Sandeen
 - Erwin Vicari
@@ -97,6 +98,7 @@ List of all individuals having contribut
 - Steffen Maier
 - Steffen Thoss
 - Susanne Wintenberger
+- Sven Schnelle
 - Sven Schuetz
 - Swen Schillig
 - Taraka R. Bodireddy
diff -pruN 2.14.0-2/CHANGELOG.md 2.15.1-0ubuntu2/CHANGELOG.md
--- 2.14.0-2/CHANGELOG.md	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/CHANGELOG.md	2020-10-28 14:31:59.000000000 +0000
@@ -1,5 +1,48 @@
 Release history for s390-tools (MIT version)
 --------------------------------------------
+* __v2.15.1 (2020-10-28)__
+
+  For Linux kernel version: 5.9
+
+  Changes of existing tools:
+  - lsstp: Improve wording and fix typos in man page
+  - zkey: Ensure zkey and friends are skipped with HAVE_OPENSSL=0
+  - zkey: Add library versioning for libekmfweb and zkey-ekmfweb
+  - libutil: Add function to determine base device of a partition block device
+
+  Bug Fixes:
+  - dasdfmt: Fix bad file descriptor error when running on symlinks
+  - libdasd: Fix dasd_get_host_access_count()
+  - zipl: Fix multivolume dump
+  - zgetdump: Fix device node determination via sysfs to work with multivolume again
+  - genprotimg/boot: Fix build by disabling SSP
+  - zipl/boot: Fix build by disabling SSP
+
+* __v2.15.0 (2020-10-15)__
+
+  For Linux kernel version: 5.9
+
+  Add new tool:
+  - lsstp: A small utility to display the Server Time Protocol (STP) information present in sysfs
+
+  Changes of existing tools:
+  - dumpconf: support NVMe dump/reipl device
+  - ipl_tools: support clear attribute for nvme re-IPL
+  - zcrypt: Support new config state with lszcrypt and chzcrypt
+  - zkey: Add support for key management system plugins
+        including the KMS commands:
+            bind, unbind, info, configure, rencipher, list, import, refresh
+  - zkey: Add EKMFWeb support to remotely generate secure keys
+  - libekmfweb: Add new EKMFWeb client library
+  - libutil: Add util_file_read_va()
+  - libutil: Add util_file_read_i()/util_file_read_ui()
+
+  Bug Fixes:
+  - cpumf: Fix version and help printout when CPUMF is not installed
+  - ziomon/ziorep_printers: fix virtual adapter CSV output
+  - zipl: Fix Error when title is not the first field in BLS file
+
+
 * __v2.14.0 (2020-08-21)__
 
   For Linux kernel version: 5.7 / 5.8
diff -pruN 2.14.0-2/common.mak 2.15.1-0ubuntu2/common.mak
--- 2.14.0-2/common.mak	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/common.mak	2020-10-28 14:31:59.000000000 +0000
@@ -5,8 +5,8 @@ COMMON_INCLUDED = true
 # The variable "DISTRELEASE" should be overwritten in rpm spec files with:
 # "make DISTRELEASE=%{release}" and "make install DISTRELEASE=%{release}"
 VERSION            = 2
-RELEASE            = 14
-PATCHLEVEL         = 0
+RELEASE            = 15
+PATCHLEVEL         = 1
 DISTRELEASE        = build-$(shell date +%Y%m%d)
 S390_TOOLS_RELEASE = $(VERSION).$(RELEASE).$(PATCHLEVEL)-$(DISTRELEASE)
 export S390_TOOLS_RELEASE
@@ -163,6 +163,7 @@ USRSBINDIR      = $(INSTALLDIR)/usr/sbin
 USRBINDIR       = $(INSTALLDIR)/usr/bin
 BINDIR          = $(INSTALLDIR)/sbin
 LIBDIR          = $(INSTALLDIR)/lib
+USRLIB64DIR     = $(INSTALLDIR)/usr/lib64
 SYSCONFDIR      = $(INSTALLDIR)/etc
 MANDIR          = $(INSTALLDIR)/usr/share/man
 VARDIR          = $(INSTALLDIR)/var
@@ -172,14 +173,16 @@ ZFCPDUMP_DIR    = $(TOOLS_LIBDIR)/zfcpdu
 # Systemd support files are installed only if a directory is specified
 # for SYSTEMDSYSTEMUNITDIR (e.g. /lib/systemd/system)
 SYSTEMDSYSTEMUNITDIR =
+USRINCLUDEDIR   = $(INSTALLDIR)/usr/include
 
 INSTDIRS        = $(USRSBINDIR) $(USRBINDIR) $(BINDIR) $(LIBDIR) $(MANDIR) \
 			$(SYSCONFDIR) $(SYSCONFDIR)/sysconfig \
 			$(TOOLS_LIBDIR) $(TOOLS_DATADIR) \
-			$(ZFCPDUMP_DIR) $(SYSTEMDSYSTEMUNITDIR)
+			$(ZFCPDUMP_DIR) $(SYSTEMDSYSTEMUNITDIR) \
+			$(USRLIB64DIR) $(USRINCLUDEDIR)
 OWNER           = $(shell id -un)
 GROUP		= $(shell id -gn)
-export INSTALLDIR BINDIR LIBDIR MANDIR OWNER GROUP
+export INSTALLDIR BINDIR LIBDIR USRLIB64DIR MANDIR OWNER GROUP
 
 # Special defines for zfcpdump
 ZFCPDUMP_IMAGE	= zfcpdump-image
@@ -339,6 +342,10 @@ $(rootdir)/libvmcp/libvmcp.a: $(rootdir)
 	$(MAKE) -C $(rootdir)/libvmcp/ libvmcp.a
 .PHONY: $(rootdir)/libvmcp
 
+$(rootdir)/libekmfweb/libekmfweb.so: $(rootdir)/libekmfweb
+	$(MAKE) -C $(rootdir)/libekmfweb/ libekmfweb.so
+.PHONY: $(rootdir)/libekmfweb
+
 $(rootdir)/zipl/boot/data.o:
 	$(MAKE) -C $(rootdir)/zipl/boot/ data.o
 
diff -pruN 2.14.0-2/cpumf/chcpumf.c 2.15.1-0ubuntu2/cpumf/chcpumf.c
--- 2.14.0-2/cpumf/chcpumf.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/cpumf/chcpumf.c	2020-10-28 14:31:59.000000000 +0000
@@ -60,10 +60,6 @@ static const struct util_prg prg = {
 	}
 };
 
-/* Parse tool parameters. Fill in global variables keep_case, buffersize and
- * command according to parameters. Return VMCP_OK on success, VMCP_OPT
- * in case of parameter errors. In case of --help or --version, print
- * respective text to stdout and exit. */
 static long parse_buffersize(char *string)
 {
 	char *suffix;
@@ -91,6 +87,7 @@ static long parse_buffersize(char *strin
 
 static int read_sfb(unsigned long *min, unsigned long *max)
 {
+	unsigned long cur_min_sdb, cur_max_sdb;
 	int rc = EXIT_SUCCESS;
 	FILE *fp;
 
@@ -99,9 +96,14 @@ static int read_sfb(unsigned long *min,
 		linux_error(PERF_SFB_SIZE);
 		return EXIT_FAILURE;
 	}
-	if (fscanf(fp, "%ld,%ld", min, max) != 2) {
+	if (fscanf(fp, "%ld,%ld", &cur_min_sdb, &cur_max_sdb) != 2) {
 		fprintf(stderr, "Error: Can not parse file " PERF_SFB_SIZE);
 		rc = EXIT_FAILURE;
+	} else {
+		if (*min == 0)
+			*min = cur_min_sdb;
+		if (*max == 0)
+			*max = cur_max_sdb;
 	}
 	fclose(fp);
 	return rc;
@@ -196,6 +198,7 @@ int main(int argc, char **argv)
 	util_prg_init(&prg);
 	util_opt_init(opt_vec, NULL);
 
+	parse_args(argc, argv);
 	if (stat(PERF_PATH PERF_SF, &sbuf) != 0) {
 		fprintf(stderr,
 			"No CPU-measurement sampling facility detected\n");
@@ -203,8 +206,6 @@ int main(int argc, char **argv)
 	}
 	if (read_sfb(&min_sdb, &max_sdb))
 		return ret;
-	/* Overwrite min_sdb and/or max_sdb */
-	parse_args(argc, argv);
 	if (min_sdb >= max_sdb) {
 		fprintf(stderr, "The specified maximum must be greater "
 				"than the minimum\n");
diff -pruN 2.14.0-2/cpumf/man/lscpumf.1 2.15.1-0ubuntu2/cpumf/man/lscpumf.1
--- 2.14.0-2/cpumf/man/lscpumf.1	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/cpumf/man/lscpumf.1	2020-10-28 14:31:59.000000000 +0000
@@ -19,9 +19,11 @@ lscpumf \- display information about CPU
 .RB [ \-i | \-\-info ]
 .br
 .B lscpumf
-.RB [ \-c | \-\-list\-counters ] [ \-n ]
-.RB [ \-C | \-\-list\-all\-counters ] [ \-n ]
-.RB [ \-s | \-\-list\-sampling\-events ]
+.RB \-c | \-\-list\-counters | \-C | \-\-list\-all\-counters
+.RB [ \-n ]
+.br
+.B lscpumf
+.RB \-s | \-\-list\-sampling\-events
 .br
 .B lscpumf
 .BR \-h | \-\-help
diff -pruN 2.14.0-2/dasdfmt/dasdfmt.c 2.15.1-0ubuntu2/dasdfmt/dasdfmt.c
--- 2.14.0-2/dasdfmt/dasdfmt.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/dasdfmt/dasdfmt.c	2020-10-28 14:31:59.000000000 +0000
@@ -9,12 +9,14 @@
  */
 
 #include <linux/version.h>
+#include <stdarg.h>
 #include <sys/sysmacros.h>
 #include <sys/time.h>
 #include <sys/utsname.h>
 
 #include "lib/dasd_base.h"
 #include "lib/dasd_sys.h"
+#include "lib/util_libc.h"
 #include "lib/util_opt.h"
 #include "lib/util_prg.h"
 #include "lib/util_proc.h"
@@ -28,7 +30,6 @@
 #define SEC_PER_HOUR (60 * 60)
 
 static int filedes;
-static char dev_filename[PATH_MAX];
 static int disk_disabled;
 static format_data_t format_params;
 static format_mode_t mode;
@@ -50,6 +51,36 @@ static const struct util_prg prg = {
 	}
 };
 
+/*
+ * Global variables for program options and other relevant information
+ */
+static struct dasdfmt_globals {
+	dasd_information2_t dasd_info;
+	char *dev_path; /* device path entered by user */
+	char *dev_node; /* reliable device node determined by dasdfmt */
+	int   verbosity;
+	int   testmode;
+	int   withoutprompt;
+	int   print_progressbar;
+	int   print_hashmarks, hashstep;
+	int   print_percentage;
+	int   force;
+	int   writenolabel;
+	int   labelspec;
+	int   cdl_format;
+	int   blksize_specified;
+	int   reqsize_specified;
+	int   keep_volser;
+	int   force_host;
+	int   layout_specified;
+	int   check;
+	int   mode_specified;
+	int   ese;
+	int   no_discard;
+} g = {
+	.dasd_info = { 0 },
+};
+
 /* Defines for options with no short command */
 #define OPT_CHECK	128
 #define OPT_NOZERO	129
@@ -156,6 +187,23 @@ static struct util_opt opt_vec[] = {
 	UTIL_OPT_END
 };
 
+/* Report error, free memory, and exit */
+static void error(const char *format, ...)
+{
+	va_list args;
+
+	fprintf(stderr, "%s: ", prog_name);
+	va_start(args, format);
+	vfprintf(stderr, format, args);
+	va_end(args);
+	fprintf(stderr, "\n");
+
+	free(g.dev_node);
+	free(g.dev_path);
+
+	exit(EXIT_FAILURE);
+}
+
 /*
  * Helper function to calculate the days, hours, minutes, and seconds
  * for a given timestamp in seconds
@@ -228,8 +276,7 @@ static void print_eta(int p_new, int sta
  * Draw the progress indicator depending on what command line argument is set.
  * This can either be a progressbar, hashmarks, or percentage.
  */
-static void draw_progress(dasdfmt_info_t *info, int cyl, unsigned int cylinders,
-			  int aborted)
+static void draw_progress(int cyl, unsigned int cylinders, int aborted)
 {
 	static int hashcount;
 	static int started;
@@ -238,7 +285,7 @@ static void draw_progress(dasdfmt_info_t
 	int barlength;
 	int i;
 
-	if (info->print_progressbar) {
+	if (g.print_progressbar) {
 		printf("cyl %7d of %7d |", cyl, cylinders);
 		p_new = cyl * 100 / cylinders;
 		if (p_new != p_old || !started || aborted) {
@@ -259,14 +306,13 @@ static void draw_progress(dasdfmt_info_t
 		fflush(stdout);
 	}
 
-	if (info->print_hashmarks &&
-	    (cyl / info->hashstep - hashcount) != 0) {
+	if (g.print_hashmarks && (cyl / g.hashstep - hashcount) != 0) {
 		printf("#");
 		fflush(stdout);
 		hashcount++;
 	}
 
-	if (info->print_percentage) {
+	if (g.print_percentage) {
 		printf("cyl %7d of %7d |%3d%%\n", cyl, cylinders,
 		       cyl * 100 / cylinders);
 		fflush(stdout);
@@ -322,8 +368,7 @@ static unsigned int recs_per_track(struc
  * Evaluate errors recognized by format checks and print appropriate error
  * messages depending on the content of cdata.
  */
-static void evaluate_format_error(dasdfmt_info_t *info, format_check_t *cdata,
-				  unsigned int heads)
+static void evaluate_format_error(format_check_t *cdata, unsigned int heads)
 {
 	struct dasd_eckd_characteristics *rdc;
 	/* Special blocksize values of the first 3 records of trk 0 of cyl 0 */
@@ -336,7 +381,7 @@ static void evaluate_format_error(dasdfm
 	unsigned int kl = 0;
 	int blksize = cdata->expect.blksize;
 
-	if (info->print_progressbar || info->print_hashmarks)
+	if (g.print_progressbar || g.print_hashmarks)
 		printf("\n");
 
 	/*
@@ -345,7 +390,7 @@ static void evaluate_format_error(dasdfm
 	 * Also, reading record zero will never happen. If the record in error
 	 * is 0 nonetheless, the device is not formatted at all as well!
 	 */
-	if ((info->dasd_info.format == DASD_FORMAT_NONE && mode != QUICK) ||
+	if ((g.dasd_info.format == DASD_FORMAT_NONE && mode != QUICK) ||
 	    cdata->rec == 0) {
 		ERRMSG("WARNING: The specified device is not "
 		       "formatted at all.\n");
@@ -373,7 +418,7 @@ static void evaluate_format_error(dasdfm
 	}
 
 	rdc = (struct dasd_eckd_characteristics *)
-				&info->dasd_info.characteristics;
+				&g.dasd_info.characteristics;
 
 	rpt = recs_per_track(rdc, kl, cdata->expect.blksize);
 
@@ -412,9 +457,7 @@ static void disk_enable(void)
 
 	err = dasd_disk_enable(filedes);
 	if (err != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: (prepare device) IOCTL "
-			    "BIODASDENABLE failed (%s)\n", prog_name,
-			    strerror(err));
+		error("(prepare device) IOCTL BIODASDENABLE failed: %s", strerror(err));
 	disk_disabled = 0;
 }
 
@@ -424,9 +467,7 @@ static void disk_disable(const char *dev
 
 	err = dasd_disk_disable(device, &filedes);
 	if (err != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: (prepare device) IOCTL "
-			    "BIODASDDISABLE failed. (%s)\n", prog_name,
-			    strerror(err));
+		error("(prepare device) IOCTL BIODASDDISABLE failed: %s", strerror(err));
 	disk_disabled = 1;
 }
 
@@ -448,7 +489,7 @@ static void program_interrupt_signal(int
 	}
 
 	printf("Rereading the partition table...\n");
-	rc = dasd_reread_partition_table(dev_filename, 5);
+	rc = dasd_reread_partition_table(g.dev_node, 5);
 	if (rc) {
 		ERRMSG("%s: (signal handler) Re-reading partition table "
 		       "failed. (%s)\n", prog_name, strerror(rc));
@@ -461,76 +502,70 @@ static void program_interrupt_signal(int
 }
 
 /*
- * check given device name for blanks and some special characters
+ * Check given device name for blanks and some special characters.
+ * Retrieve reliable device node and store device information in global
+ * dev_node and dev_path accordingly.
  */
-static void get_device_name(char *devname,
-			    int optind, int argc, char *argv[])
+static void get_device_name(int optind, int argc, char *argv[])
 {
 	struct util_proc_dev_entry dev_entry;
+	unsigned int maj, min;
 	struct stat dev_stat;
 
 	if (optind + 1 < argc)
-		ERRMSG_EXIT(EXIT_MISUSE,
-			    "%s: More than one device specified!\n", prog_name);
+		error("More than one device specified!");
 
 	if (optind >= argc)
-		ERRMSG_EXIT(EXIT_MISUSE, "%s: No device specified!\n",
-			    prog_name);
+		error("No device specified!");
 
 	if (strlen(argv[optind]) >= PATH_MAX)
-		ERRMSG_EXIT(EXIT_MISUSE, "%s: device name too long!\n",
-			    prog_name);
-	strcpy(devname, argv[optind]);
-
-	if (stat(devname, &dev_stat) != 0)
-		ERRMSG_EXIT(EXIT_MISUSE, "%s: Could not get information for "
-			    "device node %s: %s\n", prog_name, devname,
-			    strerror(errno));
-
-	if (minor(dev_stat.st_rdev) & PARTN_MASK) {
-		ERRMSG_EXIT(EXIT_MISUSE, "%s: Unable to format partition %s. "
-			    "Please specify a device.\n", prog_name,
-			    devname);
-	}
+		error("device name too long!");
+	util_asprintf(&g.dev_path, argv[optind]);
+
+	if (stat(g.dev_path, &dev_stat) != 0)
+		error("Could not get information for device node %s: %s",
+		      g.dev_path, strerror(errno));
+
+	maj = major(dev_stat.st_rdev);
+	min = minor(dev_stat.st_rdev);
+	if (min & PARTN_MASK)
+		error("Unable to format partition %s. Please specify a device.", g.dev_path);
 
 	if (util_proc_dev_get_entry(dev_stat.st_rdev, 1, &dev_entry) == 0) {
 		if (strncmp(dev_entry.name, "dasd", 4) != 0)
-			ERRMSG_EXIT(EXIT_MISUSE,
-				    "%s: Unsupported device type '%s'.\n",
-				    prog_name, dev_entry.name);
+			error("Unsupported device type '%s'.", dev_entry.name);
 	} else {
 		printf("%s WARNING: Unable to get driver name for device node %s",
-		       prog_name, devname);
+		       prog_name, g.dev_path);
 	}
+	/* Get reliable device node */
+	util_asprintf(&g.dev_node, "/dev/block/%d:%d", maj, min);
 }
 
-static void get_blocksize(const char *device, unsigned int *blksize)
+static void get_blocksize(unsigned int *blksize)
 {
 	int err;
 
-	err = dasd_get_blocksize(device, blksize);
+	err = dasd_get_blocksize(g.dev_node, blksize);
 	if (err != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: the ioctl to get the blocksize "
-			    "of the device failed (%s).\n", prog_name,
-			    strerror(err));
+		error("the ioctl to get the blocksize of the device failed: %s", strerror(err));
 }
 
 /*
  * Check whether a specified blocksize matches the blocksize of the device
  */
-static void check_blocksize(dasdfmt_info_t *info, unsigned int blksize)
+static void check_blocksize(unsigned int blksize)
 {
 	unsigned int dev_blksize;
 
-	if (!info->blksize_specified ||
-	    info->dasd_info.format == DASD_FORMAT_NONE)
+	if (!g.blksize_specified ||
+	    g.dasd_info.format == DASD_FORMAT_NONE)
 		return;
 
-	get_blocksize(dev_filename, &dev_blksize);
+	get_blocksize(&dev_blksize);
 	if (dev_blksize != blksize) {
-		ERRMSG_EXIT(EXIT_FAILURE, "WARNING: Device is formatted with a "
-			    "different blocksize (%d).\nUse --mode=full to "
-			    "perform a clean format.\n", dev_blksize);
+		warnx("WARNING: Device is formatted with a different blocksize (%d).", dev_blksize);
+		error("Use --mode=full to perform a clean format.");
 	}
 }
 
@@ -538,64 +573,54 @@ static void check_blocksize(dasdfmt_info
  * Check whether a specified layout matches the layout
  * a device is formatted with.
  */
-static void check_layout(dasdfmt_info_t *info, unsigned int intensity)
+static void check_layout(unsigned int intensity)
 {
 	char layout[4];
 
-	if (!info->layout_specified ||
-	    info->dasd_info.format == DASD_FORMAT_NONE)
+	if (!g.layout_specified ||
+	    g.dasd_info.format == DASD_FORMAT_NONE)
 		return;
 
 	if ((intensity & DASD_FMT_INT_COMPAT) &&
-	    info->dasd_info.format == DASD_FORMAT_CDL)
+	    g.dasd_info.format == DASD_FORMAT_CDL)
 		return;
 
 	if (!(intensity & DASD_FMT_INT_COMPAT) &&
-	    info->dasd_info.format == DASD_FORMAT_LDL)
+	    g.dasd_info.format == DASD_FORMAT_LDL)
 		return;
 
-	if (info->dasd_info.format == DASD_FORMAT_CDL)
+	if (g.dasd_info.format == DASD_FORMAT_CDL)
 		sprintf(layout, "CDL");
-	if (info->dasd_info.format == DASD_FORMAT_LDL)
+	if (g.dasd_info.format == DASD_FORMAT_LDL)
 		sprintf(layout, "LDL");
 
-	ERRMSG_EXIT(EXIT_FAILURE, "WARNING: Device is formatted with a "
-		    "different layout (%s).\n", layout);
+	error("WARNING: Device is formatted with a different layout (%s).", layout);
 }
 
 /*
  * check for disk type and set some variables (e.g. usage count)
  */
-static void check_disk(dasdfmt_info_t *info, char *devname)
+static void check_disk(void)
 {
 	int err;
 	bool ro;
 
-	err = dasd_is_ro(devname, &ro);
+	err = dasd_is_ro(g.dev_node, &ro);
 	if (err != 0)
-		ERRMSG_EXIT(EXIT_FAILURE,
-			    "%s: the ioctl call to retrieve read/write "
-			    "status information failed (%s)\n",
-			    prog_name, strerror(err));
-
+		error("the ioctl call to retrieve read/write status information failed: %s",
+		      strerror(err));
 	if (ro)
-		ERRMSG_EXIT(EXIT_FAILURE, "Disk is read only!\n");
-
-	if (!info->force)
-		if (info->dasd_info.open_count > 1)
-			ERRMSG_EXIT(EXIT_BUSY, "Disk in use!\n");
-
-	if (strncmp(info->dasd_info.type, "ECKD", 4) != 0) {
-		ERRMSG_EXIT(EXIT_FAILURE,
-			    "%s: Unsupported disk type\n%s is not an "
-			    "ECKD disk!\n", prog_name, devname);
-	}
-
-	if (dasd_sys_raw_track_access(devname)) {
-		ERRMSG_EXIT(EXIT_FAILURE,
-			    "%s: Device '%s' is in raw-track access mode\n",
-			    prog_name, devname);
+		error("Disk is read only!");
+	if (!g.force) {
+		if (g.dasd_info.open_count > 1)
+			error("Disk in use!");
+	}
+	if (strncmp(g.dasd_info.type, "ECKD", 4) != 0) {
+		warnx("Unsupported disk type");
+		error("%s is not an ECKD disk!", g.dev_path);
 	}
+	if (dasd_sys_raw_track_access(g.dev_node))
+		error("Device '%s' is in raw-track access mode", g.dev_path);
 }
 
 /*
@@ -669,16 +694,16 @@ static int check_param(char *s, size_t b
 /*
  * Retrieve disk information and set cylinders and heads accordingly.
  */
-static void set_geo(dasdfmt_info_t *info, unsigned int *cylinders,
+static void set_geo(unsigned int *cylinders,
 		    unsigned int *heads)
 {
 	struct dasd_eckd_characteristics *characteristics;
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Retrieving disk geometry...\n");
 
 	characteristics = (struct dasd_eckd_characteristics *)
-				&info->dasd_info.characteristics;
+				&g.dasd_info.characteristics;
 	if (characteristics->no_cyl == LV_COMPAT_CYL &&
 	    characteristics->long_no_cyl)
 		*cylinders = characteristics->long_no_cyl;
@@ -690,13 +715,13 @@ static void set_geo(dasdfmt_info_t *info
 /*
  * Set VTOC label information
  */
-static void set_label(dasdfmt_info_t *info, volume_label_t *vlabel,
+static void set_label(volume_label_t *vlabel,
 		      format_data_t *p, unsigned int cylinders)
 {
 	char inp_buffer[5];
 
-	if (info->writenolabel) {
-		if (cylinders > LV_COMPAT_CYL && !info->withoutprompt) {
+	if (g.writenolabel) {
+		if (cylinders > LV_COMPAT_CYL && !g.withoutprompt) {
 			printf("\n--->> ATTENTION! <<---\n");
 			printf("You specified to write no labels to a"
 			       " volume with more then %u cylinders.\n"
@@ -714,16 +739,16 @@ static void set_label(dasdfmt_info_t *in
 			}
 		}
 	} else {
-		if (!info->labelspec && !info->keep_volser) {
+		if (!g.labelspec && !g.keep_volser) {
 			char buf[7];
 
-			sprintf(buf, "0X%04x", info->dasd_info.devno);
-			check_volser(buf, info->dasd_info.devno);
+			sprintf(buf, "0X%04x", g.dasd_info.devno);
+			check_volser(buf, g.dasd_info.devno);
 			vtoc_volume_label_set_volser(vlabel, buf);
 		}
 
 		if (p->intensity & DASD_FMT_INT_COMPAT) {
-			info->cdl_format = 1;
+			g.cdl_format = 1;
 			vtoc_volume_label_set_label(vlabel, "VOL1");
 			vtoc_volume_label_set_key(vlabel, "VOL1");
 			vtoc_set_cchhb(&vlabel->vtoc, 0x0000, 0x0001, 0x01);
@@ -736,19 +761,19 @@ static void set_label(dasdfmt_info_t *in
 /*
  * Check whether hashsteps are within the correct interval.
  */
-static void check_hashmarks(dasdfmt_info_t *info)
+static void check_hashmarks(void)
 {
-	if (info->print_hashmarks) {
-		if (info->hashstep < reqsize)
-			info->hashstep = reqsize;
-		if ((info->hashstep < 1) || (info->hashstep > 1000)) {
+	if (g.print_hashmarks) {
+		if (g.hashstep < reqsize)
+			g.hashstep = reqsize;
+		if (g.hashstep < 1 || g.hashstep > 1000) {
 			printf("Hashmark increment is not in range <1,1000>, "
 			       "using the default.\n");
-			info->hashstep = 10;
+			g.hashstep = 10;
 		}
 
 		printf("Printing hashmark every %d cylinders.\n",
-		       info->hashstep);
+		       g.hashstep);
 	}
 }
 
@@ -756,7 +781,7 @@ static void check_hashmarks(dasdfmt_info
  * This function checks whether a range of tracks is in regular format
  * with the specified block size.
  */
-static format_check_t check_track_format(dasdfmt_info_t *info, format_data_t *p)
+static format_check_t check_track_format(format_data_t *p)
 {
 	format_check_t cdata = {
 		.expect = {
@@ -766,22 +791,20 @@ static format_check_t check_track_format
 			.stop_unit = p->stop_unit
 		}, 0
 	};
+	char msg[128] = "";
 	int err;
 
-	err = dasd_check_format(dev_filename, &cdata);
+	err = dasd_check_format(g.dev_node, &cdata);
 	if (err != 0) {
 		if (err == ENOTTY) {
-			ERRMSG("%s: Missing kernel support for format checking",
-			       prog_name);
-			if (mode == EXPAND) {
-				ERRMSG(". Mode 'expand' cannot be used");
-			} else if (!info->check) {
-				ERRMSG(" (--force to override)");
-			}
-			ERRMSG_EXIT(EXIT_FAILURE, ".\n");
+			sprintf(msg, "Missing kernel support for format checking");
+			if (mode == EXPAND)
+				strcat(msg, ". Mode 'expand' cannot be used");
+			else if (!g.check)
+				strcat(msg, " (--force to override)");
+			error("%s.", msg);
 		}
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: Could no check format: %s\n",
-			    prog_name, strerror(err));
+		error("Could not check format: %s", strerror(err));
 	}
 
 	return cdata;
@@ -790,8 +813,8 @@ static format_check_t check_track_format
 /*
  * Either do the actual format or check depending on the check-value.
  */
-static int process_tracks(dasdfmt_info_t *info, unsigned int cylinders,
-			  unsigned int heads, format_data_t *format_params)
+static int process_tracks(unsigned int cylinders, unsigned int heads,
+			  format_data_t *format_params)
 {
 	format_check_t cdata = { .expect = {0}, 0};
 	format_data_t step = *format_params;
@@ -799,7 +822,7 @@ static int process_tracks(dasdfmt_info_t
 	unsigned long cur_trk;
 	int cyl = 0, err;
 
-	check_hashmarks(info);
+	check_hashmarks();
 
 	cur_trk = format_params->start_unit;
 
@@ -811,31 +834,29 @@ static int process_tracks(dasdfmt_info_t
 		else
 			step.stop_unit = cur_trk + step_value - 1;
 
-		if (info->check) {
-			cdata = check_track_format(info, &step);
+		if (g.check) {
+			cdata = check_track_format(&step);
 			if (cdata.result) {
 				cyl = cur_trk / heads + 1;
-				draw_progress(info, cyl, cylinders, 1);
-				evaluate_format_error(info, &cdata, heads);
+				draw_progress(cyl, cylinders, 1);
+				evaluate_format_error(&cdata, heads);
 				break;
 			}
 		} else {
 			err = dasd_format_disk(filedes, &step);
 			if (err != 0)
-				ERRMSG_EXIT(EXIT_FAILURE, "%s: the ioctl call "
-					    "to format tracks failed. (%s)\n",
-					    prog_name, strerror(err));
+				error("the ioctl call to format tracks failed: %s", strerror(err));
 		}
 
 		cyl = cur_trk / heads + 1;
-		draw_progress(info, cyl, cylinders, 0);
+		draw_progress(cyl, cylinders, 0);
 
 		cur_trk += step_value;
 	}
 	/* We're done, draw the 100% mark */
 	if (!cdata.result) {
 		cyl = step.stop_unit / heads + 1;
-		draw_progress(info, cyl, cylinders, 0);
+		draw_progress(cyl, cylinders, 0);
 		printf("\n");
 	}
 
@@ -845,37 +866,35 @@ static int process_tracks(dasdfmt_info_t
 /*
  * This function checks the format of the entire disk.
  */
-static void check_disk_format(dasdfmt_info_t *info, unsigned int cylinders,
-			      unsigned int heads, format_data_t *check_params)
+static void check_disk_format(unsigned int cylinders, unsigned int heads,
+			      format_data_t *check_params)
 {
 	check_params->start_unit = 0;
 	check_params->stop_unit = (cylinders * heads) - 1;
 
 	printf("Checking format of the entire disk...\n");
 
-	if (info->testmode) {
+	if (g.testmode) {
 		printf("Test mode active, omitting ioctl.\n");
 		return;
 	}
 
-	check_blocksize(info, check_params->blksize);
-	check_layout(info, check_params->intensity);
+	check_blocksize(check_params->blksize);
+	check_layout(check_params->intensity);
 
 	/*
 	 * If no layout was specified, set the intensity
 	 * according to what the layout seems to be.
 	 */
-	if (!info->layout_specified) {
-		if (info->dasd_info.format == DASD_FORMAT_CDL)
+	if (!g.layout_specified) {
+		if (g.dasd_info.format == DASD_FORMAT_CDL)
 			check_params->intensity |= DASD_FMT_INT_COMPAT;
-		else if (info->dasd_info.format == DASD_FORMAT_LDL)
+		else if (g.dasd_info.format == DASD_FORMAT_LDL)
 			check_params->intensity &= ~DASD_FMT_INT_COMPAT;
 	}
 
-	if (process_tracks(info, cylinders, heads, check_params)) {
-		ERRMSG_EXIT(EXIT_FAILURE, "Use --mode=full to perform a "
-			    "clean format.\n");
-	}
+	if (process_tracks(cylinders, heads, check_params))
+		error("Use --mode=full to perform a clean format.");
 
 	printf("Done. Disk is fine.\n");
 }
@@ -917,10 +936,8 @@ static format_data_t ask_user_for_blksiz
 /*
  * print all information needed to format the device
  */
-static void dasdfmt_print_info(dasdfmt_info_t *info, char *devname,
-			       volume_label_t *vlabel,
-			       unsigned int cylinders, unsigned int heads,
-			       format_data_t *p)
+static void dasdfmt_print_info(volume_label_t *vlabel, unsigned int cylinders,
+			       unsigned int heads, format_data_t *p)
 {
 	char volser[6], vollbl[4];
 
@@ -928,14 +945,14 @@ static void dasdfmt_print_info(dasdfmt_i
 	       cylinders, heads, (cylinders * heads));
 
 	printf("Device Type: %s Provisioned\n",
-	       info->ese ? "Thinly" : "Fully");
+	       g.ese ? "Thinly" : "Fully");
 	printf("\nI am going to format the device ");
-	printf("%s in the following way:\n", devname);
-	printf("   Device number of device : 0x%x\n", info->dasd_info.devno);
+	printf("%s in the following way:\n", g.dev_path);
+	printf("   Device number of device : 0x%x\n", g.dasd_info.devno);
 	printf("   Labelling device        : %s\n",
-	       (info->writenolabel) ? "no" : "yes");
+	       (g.writenolabel) ? "no" : "yes");
 
-	if (!info->writenolabel) {
+	if (!g.writenolabel) {
 		vtoc_volume_label_get_label(vlabel, vollbl);
 		printf("   Disk label              : %.4s\n", vollbl);
 		vtoc_volume_label_get_volser(vlabel, volser);
@@ -947,30 +964,29 @@ static void dasdfmt_print_info(dasdfmt_i
 	       (p->intensity & DASD_FMT_INT_COMPAT) ? "yes" : "no");
 	printf("   Blocksize               : %d\n", p->blksize);
 	printf("   Mode                    : %s\n", mode_str[mode]);
-	if (info->ese) {
+	if (g.ese) {
 		printf("   Full Space Release      : %s\n",
-		       (info->no_discard || mode == FULL) ? "no" : "yes");
+		       (g.no_discard || mode == FULL) ? "no" : "yes");
 	}
-	if (info->testmode)
+	if (g.testmode)
 		printf("Test mode active, omitting ioctl.\n");
 }
 
 /*
  * get volser
  */
-static int dasdfmt_get_volser(char *devname, dasd_information2_t *dasd_info,
-			      char *volser)
+static int dasdfmt_get_volser(char *volser)
 {
 	unsigned int blksize;
 	volume_label_t vlabel;
 
-	get_blocksize(devname, &blksize);
+	get_blocksize(&blksize);
 
-	if ((strncmp(dasd_info->type, "ECKD", 4) == 0) &&
-	    !dasd_info->FBA_layout) {
+	if ((strncmp(g.dasd_info.type, "ECKD", 4) == 0) &&
+	    !g.dasd_info.FBA_layout) {
 		/* OS/390 and zOS compatible disk layout */
-		vtoc_read_volume_label(devname,
-				       dasd_info->label_block * blksize,
+		vtoc_read_volume_label(g.dev_node,
+				       g.dasd_info.label_block * blksize,
 				       &vlabel);
 		vtoc_volume_label_get_volser(&vlabel, volser);
 		return 0;
@@ -982,7 +998,7 @@ static int dasdfmt_get_volser(char *devn
 /*
  * do all the labeling (volume label and initial VTOC)
  */
-static void dasdfmt_write_labels(dasdfmt_info_t *info, volume_label_t *vlabel,
+static void dasdfmt_write_labels(volume_label_t *vlabel,
 				 unsigned int cylinders, unsigned int heads)
 {
 	int label_position;
@@ -995,33 +1011,31 @@ static void dasdfmt_write_labels(dasdfmt
 	void *ipl1_record, *ipl2_record;
 	int ipl1_record_len, ipl2_record_len;
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Retrieving dasd information... ");
 
-	get_blocksize(dev_filename, &blksize);
+	get_blocksize(&blksize);
 
 	/*
 	 * Don't rely on the cylinders returned by HDIO_GETGEO, they might be
 	 * to small. geo is only used to get the number of sectors, which may
 	 * vary depending on the format.
 	 */
-	rc = dasd_get_geo(dev_filename, &geo);
+	rc = dasd_get_geo(g.dev_node, &geo);
 	if (rc != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: (write labels) IOCTL "
-			    "HDIO_GETGEO failed (%s).\n",
-			    prog_name, strerror(rc));
+		error("(write labels) IOCTL HDIO_GETGEO failed: %s", strerror(rc));
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("ok\n");
 
 	/* write empty bootstrap (initial IPL records) */
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Writing empty bootstrap...\n");
 
 	/*
 	 * Note: ldl labels do not contain the key field
 	 */
-	if (info->cdl_format) {
+	if (g.cdl_format) {
 		/* Prepare copy with key (CDL) */
 		ipl1_record	= &ipl1;
 		ipl2_record	= &ipl2;
@@ -1035,68 +1049,59 @@ static void dasdfmt_write_labels(dasdfmt
 		ipl2_record_len	= sizeof(ipl2.data);
 	}
 
-	fd = open(dev_filename, O_RDWR);
+	fd = open(g.dev_node, O_RDWR);
 	if (fd < 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: Unable to open device "
-			    "'%s' (%s)\n", prog_name, dev_filename,
-			    strerror(errno));
+		error("Unable to open device '%s': %s", g.dev_path, strerror(errno));
 
 	if (lseek(fd, 0, SEEK_SET) != 0) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: lseek command 0 failed "
-			    "(%s)\n", prog_name, strerror(errno));
+		error("lseek command 0 failed: %s", strerror(errno));
 	}
 
 	rc = write(fd, ipl1_record, ipl1_record_len);
 	if (rc != ipl1_record_len) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: Writing the bootstrap IPL1 "
-			    "failed, only wrote %d bytes.\n", prog_name, rc);
+		error("Writing the bootstrap IPL1 failed, only wrote %d bytes.", rc);
 	}
 
 	label_position = blksize;
 	rc = lseek(fd, label_position, SEEK_SET);
 	if (rc != label_position) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: lseek command to %i failed "
-			    "(%s).\n", prog_name, label_position,
-			    strerror(errno));
+		error("lseek command to %i failed: %s", label_position, strerror(errno));
 	}
 
 	rc = write(fd, ipl2_record, ipl2_record_len);
 	if (rc != ipl2_record_len) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: Writing the bootstrap IPL2 "
-			    "failed, only wrote %d bytes.\n", prog_name, rc);
+		error("Writing the bootstrap IPL2 failed, only wrote %d bytes.", rc);
 	}
 
 	/* write VTOC */
 	vtoc_init_format4_label(&f4, geo.cylinders, cylinders, heads,
-				geo.sectors, blksize, info->dasd_info.dev_type);
+				geo.sectors, blksize, g.dasd_info.dev_type);
 
 	vtoc_init_format5_label(&f5);
 	vtoc_init_format7_label(&f7);
 	vtoc_set_freespace(&f4, &f5, &f7, '+', 0, FIRST_USABLE_TRK,
 			   (cylinders * heads - 1), cylinders, heads);
 
-	label_position = info->dasd_info.label_block * blksize;
+	label_position = g.dasd_info.label_block * blksize;
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Writing label...\n");
 
 	rc = lseek(fd, label_position, SEEK_SET);
 	if (rc != label_position) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: lseek command to %i failed "
-			    "(%s).\n", prog_name, label_position,
-			    strerror(errno));
+		error("lseek command to %i failed: %s", label_position, strerror(errno));
 	}
 
 	/*
 	 * Note: cdl volume labels do not contain the 'formatted_blocks' part
 	 * and ldl labels do not contain the key field
 	 */
-	if (info->cdl_format) {
+	if (g.cdl_format) {
 		rc = write(fd, vlabel, (sizeof(*vlabel) -
 					sizeof(vlabel->formatted_blocks)));
 	} else {
@@ -1107,15 +1112,14 @@ static void dasdfmt_write_labels(dasdfmt
 	}
 
 	if (((rc != sizeof(*vlabel) - sizeof(vlabel->formatted_blocks)) &&
-	     info->cdl_format) ||
+	     g.cdl_format) ||
 	    ((rc != (sizeof(*vlabel) - sizeof(vlabel->volkey))) &&
-	     !info->cdl_format)) {
+	     !g.cdl_format)) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: Error writing volume label "
-			    "(%d).\n", prog_name, rc);
+		error("Error writing volume label (%d).", rc);
 	}
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Writing VTOC... ");
 
 	label_position = (VTOC_START_CC * heads + VTOC_START_HH) *
@@ -1124,17 +1128,14 @@ static void dasdfmt_write_labels(dasdfmt
 	rc = lseek(fd, label_position, SEEK_SET);
 	if (rc != label_position) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: lseek command to %i failed "
-			    "(%s).\n", prog_name, label_position,
-			    strerror(errno));
+		error("lseek command to %i failed: %s", label_position, strerror(errno));
 	}
 
 	/* write VTOC FMT4 DSCB */
 	rc = write(fd, &f4, sizeof(format4_label_t));
 	if (rc != sizeof(format4_label_t)) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: Error writing FMT4 label "
-			    "(%d).\n", prog_name, rc);
+		error("Error writing FMT4 label (%d).", rc);
 	}
 
 	label_position += blksize;
@@ -1142,16 +1143,14 @@ static void dasdfmt_write_labels(dasdfmt
 	rc = lseek(fd, label_position, SEEK_SET);
 	if (rc != label_position) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: lseek to %i failed (%s).\n",
-			    prog_name, label_position, strerror(errno));
+		error("lseek to %i failed: %s", label_position, strerror(errno));
 	}
 
 	/* write VTOC FMT5 DSCB */
 	rc = write(fd, &f5, sizeof(format5_label_t));
 	if (rc != sizeof(format5_label_t)) {
 		close(fd);
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: Error writing FMT5 label "
-			    "(%d).\n", prog_name, rc);
+		error("Error writing FMT5 label (%d).", rc);
 	}
 
 	if ((cylinders * heads) > BIG_DISK_SIZE) {
@@ -1160,17 +1159,14 @@ static void dasdfmt_write_labels(dasdfmt
 		rc = lseek(fd, label_position, SEEK_SET);
 		if (rc != label_position) {
 			close(fd);
-			ERRMSG_EXIT(EXIT_FAILURE, "%s: lseek to %i failed "
-				    "(%s).\n", prog_name, label_position,
-				    strerror(errno));
+			error("lseek to %i failed: %s", label_position, strerror(errno));
 		}
 
 		/* write VTOC FMT 7 DSCB (only on big disks) */
 		rc = write(fd, &f7, sizeof(format7_label_t));
 		if (rc != sizeof(format7_label_t)) {
 			close(fd);
-			ERRMSG_EXIT(EXIT_FAILURE, "%s: Error writing FMT7 "
-				    "label (rc=%d).\n", prog_name, rc);
+			error("Error writing FMT7 label (rc=%d).", rc);
 		}
 	}
 
@@ -1178,7 +1174,7 @@ static void dasdfmt_write_labels(dasdfmt
 
 	close(fd);
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("ok\n");
 }
 
@@ -1188,8 +1184,8 @@ static void dasdfmt_write_labels(dasdfmt
  * that the device is formatted to a certain extent. Otherwise the
  * process is terminated.
  */
-static void dasdfmt_find_start(dasdfmt_info_t *info, unsigned int cylinders,
-			       unsigned heads, format_data_t *format_params)
+static void dasdfmt_find_start(unsigned int cylinders, unsigned int heads,
+			       format_data_t *format_params)
 {
 	format_check_t cdata;
 	unsigned int middle;
@@ -1197,16 +1193,15 @@ static void dasdfmt_find_start(dasdfmt_i
 	unsigned int right = (cylinders * heads) - 1;
 	unsigned int first = left;
 
-	check_blocksize(info, format_params->blksize);
+	check_blocksize(format_params->blksize);
 
 	format_params->start_unit = 0;
 	format_params->stop_unit = 4;
-	cdata = check_track_format(info, format_params);
+	cdata = check_track_format(format_params);
 
 	if (cdata.result) {
-		evaluate_format_error(info, &cdata, heads);
-		ERRMSG_EXIT(EXIT_FAILURE, "Use --mode=full to perform a "
-			    "clean format.\n");
+		evaluate_format_error(&cdata, heads);
+		error("Use --mode=full to perform a clean format.");
 	}
 
 	printf("Expansion mode active. Searching for starting position...\n");
@@ -1217,7 +1212,7 @@ static void dasdfmt_find_start(dasdfmt_i
 
 		format_params->start_unit = middle;
 		format_params->stop_unit = middle;
-		cdata = check_track_format(info, format_params);
+		cdata = check_track_format(format_params);
 		if (cdata.blksize != format_params->blksize) {
 			first = middle;
 			right = middle - 1;
@@ -1227,8 +1222,7 @@ static void dasdfmt_find_start(dasdfmt_i
 	}
 
 	if (first == 2 && cdata.blksize == format_params->blksize)
-		ERRMSG_EXIT(EXIT_FAILURE,
-			    "No unformatted part found, aborting.\n");
+		error("No unformatted part found, aborting.");
 
 	printf("Done. Unformatted part starts at track %d.\n", first);
 
@@ -1236,16 +1230,7 @@ static void dasdfmt_find_start(dasdfmt_i
 	format_params->start_unit = first;
 }
 
-/*
- * formats the disk cylinderwise
- */
-static void dasdfmt_format(dasdfmt_info_t *info, unsigned int cylinders,
-			   unsigned int heads, format_data_t *format_params)
-{
-	process_tracks(info, cylinders, heads, format_params);
-}
-
-static void dasdfmt_release_space(dasdfmt_info_t *info)
+static void dasdfmt_release_space(void)
 {
 	format_data_t r = {
 		.start_unit = 0,
@@ -1254,20 +1239,17 @@ static void dasdfmt_release_space(dasdfm
 	};
 	int err = 0;
 
-	if (!info->ese || info->no_discard)
+	if (!g.ese || g.no_discard)
 		return;
 
 	printf("Releasing space for the entire device...\n");
-	err = dasd_release_space(dev_filename, &r);
-	if (err) {
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: Could not release space (%s)\n",
-			    prog_name, strerror(err));
-	}
+	err = dasd_release_space(g.dev_node, &r);
+	if (err)
+		error("Could not release space: %s", strerror(err));
 }
 
-static void dasdfmt_prepare_and_format(dasdfmt_info_t *info,
-				       unsigned int cylinders,
-				       unsigned int heads, format_data_t *p)
+static void dasdfmt_prepare_and_format(unsigned int cylinders, unsigned int heads,
+				       format_data_t *p)
 {
 	format_data_t temp = {
 		.start_unit = 0,
@@ -1278,44 +1260,40 @@ static void dasdfmt_prepare_and_format(d
 	};
 	int err;
 
-	if (!(info->withoutprompt && (info->verbosity < 1)))
+	if (!(g.withoutprompt && g.verbosity < 1))
 		printf("Formatting the device. This may take a while "
 		       "(get yourself a coffee).\n");
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Detaching the device...\n");
 
-	disk_disable(dev_filename);
+	disk_disable(g.dev_node);
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Invalidate first track...\n");
 
 	err = dasd_format_disk(filedes, &temp);
 	if (err != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: (invalidate first track) IOCTL "
-			    "BIODASDFMT failed. (%s)\n", prog_name,
-			    strerror(err));
+		error("(invalidate first track) IOCTL BIODASDFMT failed: %s", strerror(err));
 
 	/* except track 0 from standard formatting procss */
 	p->start_unit = 1;
 
-	dasdfmt_format(info, cylinders, heads, p);
+	process_tracks(cylinders, heads, p);
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("formatting tracks complete...\n");
 
 	temp.intensity = p->intensity;
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Revalidate first track...\n");
 
 	err = dasd_format_disk(filedes, &temp);
 	if (err != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: (re-validate first track) IOCTL"
-			    " BIODASDFMT failed (%s)\n", prog_name,
-			    strerror(err));
+		error("(re-validate first track) IOCTL BIODASDFMT failed: %s", strerror(err));
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Re-accessing the device...\n");
 
 	disk_enable();
@@ -1324,24 +1302,24 @@ static void dasdfmt_prepare_and_format(d
 /*
  * This function will start the expand format process.
  */
-static void dasdfmt_expand_format(dasdfmt_info_t *info, unsigned int cylinders,
-				  unsigned int heads, format_data_t *p)
+static void dasdfmt_expand_format(unsigned int cylinders, unsigned int heads,
+				  format_data_t *p)
 {
-	if (!(info->withoutprompt && (info->verbosity < 1)))
+	if (!(g.withoutprompt && g.verbosity < 1))
 		printf("Formatting the device. This may take a while "
 		       "(get yourself a coffee).\n");
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Detaching the device...\n");
 
-	disk_disable(dev_filename);
+	disk_disable(g.dev_node);
 
-	dasdfmt_format(info, cylinders, heads, p);
+	process_tracks(cylinders, heads, p);
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Formatting tracks complete...\n");
 
-	if (info->verbosity > 0)
+	if (g.verbosity > 0)
 		printf("Re-accessing the device...\n");
 
 	disk_enable();
@@ -1351,60 +1329,56 @@ static void dasdfmt_expand_format(dasdfm
  * This function will only format the first two tracks of a DASD.
  * The rest of the DASD is untouched and left as is.
  */
-static void dasdfmt_quick_format(dasdfmt_info_t *info, unsigned int cylinders,
-				 unsigned int heads, format_data_t *p)
+static void dasdfmt_quick_format(unsigned int cylinders, unsigned int heads,
+				 format_data_t *p)
 {
 	format_check_t cdata = { .expect = {0}, 0 };
 	format_data_t tmp = *p;
 	int err;
 
-	if (info->force) {
+	if (g.force) {
 		printf("Skipping format check due to --force.\n");
-	} else if (info->ese) {
+	} else if (g.ese) {
 		printf("Skipping format check due to thin-provisioned device.\n");
 	} else {
-		check_blocksize(info, p->blksize);
+		check_blocksize(p->blksize);
 
 		printf("Checking the format of selected tracks...\n");
 
 		/* Check device format on the first and last 3 regular tracks */
 		tmp.start_unit = 2;
 		tmp.stop_unit = 4;
-		cdata = check_track_format(info, &tmp);
+		cdata = check_track_format(&tmp);
 		if (!cdata.result) {
 			tmp.start_unit = (cylinders * heads) - 3;
 			tmp.stop_unit = (cylinders * heads) - 1;
-			cdata = check_track_format(info, &tmp);
+			cdata = check_track_format(&tmp);
 		}
 		if (cdata.result) {
-			evaluate_format_error(info, &cdata, heads);
-			ERRMSG_EXIT(EXIT_FAILURE, "Use --mode=full to perform "
-				    "a clean format.\n");
+			evaluate_format_error(&cdata, heads);
+			error("Use --mode=full to perform a clean format.");
 		} else {
 			printf("Done. Disk seems fine.\n");
 		}
 	}
 
-	if (!(info->withoutprompt && (info->verbosity < 1)))
+	if (!(g.withoutprompt && g.verbosity < 1))
 		printf("Formatting the first two tracks of the device.\n");
 
 	/* Disable the device before we do anything */
-	disk_disable(dev_filename);
+	disk_disable(g.dev_node);
 
 	/* Now do the actual formatting of our first two tracks */
 	err = dasd_format_disk(filedes, p);
 	if (err != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: the ioctl to format the device "
-			    "failed. (%s)\n", prog_name, strerror(err));
+		error("the ioctl to format the device failed: %s", strerror(err));
 
 	/* Re-Enable the device so that we can continue working with it */
 	disk_enable();
 }
 
-static void do_format_dasd(dasdfmt_info_t *info, char *devname,
-			   volume_label_t *vlabel,
-			   format_data_t *p, unsigned int cylinders,
-			   unsigned int heads)
+static void do_format_dasd(volume_label_t *vlabel, format_data_t *p,
+			   unsigned int cylinders, unsigned int heads)
 {
 	char inp_buffer[5];
 	int count, err;
@@ -1419,25 +1393,25 @@ static void do_format_dasd(dasdfmt_info_
 		p->stop_unit = 1;
 		break;
 	case EXPAND: /* only the end of the disk */
-		dasdfmt_find_start(info, cylinders, heads, p);
+		dasdfmt_find_start(cylinders, heads, p);
 		p->stop_unit  = (cylinders * heads) - 1;
 		break;
 	}
 
-	if ((info->verbosity > 0) || !info->withoutprompt || info->testmode)
-		dasdfmt_print_info(info, devname, vlabel, cylinders, heads, p);
+	if (g.verbosity > 0 || !g.withoutprompt || g.testmode)
+		dasdfmt_print_info(vlabel, cylinders, heads, p);
 
-	count = dasd_get_host_access_count(devname);
-	if (info->force_host) {
+	count = dasd_get_host_access_count(g.dev_node);
+	if (g.force_host) {
 		if (count > 1) {
-			ERRMSG_EXIT(EXIT_FAILURE,
-				    "\n%s: Disk %s is online on OS instances in %d different LPARs.\n"
-				    "Note: Your installation might include z/VM systems that are configured to\n"
-				    "automatically vary on disks, regardless of whether they are subsequently used.\n\n",
-				    prog_name, devname, count);
+			printf("\n");
+			warnx("Disk %s is online on OS instances in %d different LPARs.",
+			      g.dev_path, count);
+			warnx("Note: Your installation might include z/VM systems that are configured to");
+			error("automatically vary on disks, regardless of whether they are subsequently used.\n");
 		} else if (count < 0) {
 			ERRMSG("\nHosts access information not available for disk %s.\n\n",
-			       devname);
+			       g.dev_path);
 			return;
 		}
 	} else if (count > 1)
@@ -1446,10 +1420,10 @@ static void do_format_dasd(dasdfmt_info_
 		       "Ensure that the disk is not being used by a system outside your LPAR.\n"
 		       "Note: Your installation might include z/VM systems that are configured to\n"
 		       "automatically vary on disks, regardless of whether they are subsequently used.\n",
-		       devname, count);
+		       g.dev_path, count);
 
-	if (!info->testmode) {
-		if (!info->withoutprompt) {
+	if (!g.testmode) {
+		if (!g.withoutprompt) {
 			printf("\n");
 			if (mode != EXPAND)
 				printf("--->> ATTENTION! <<---\nAll data of "
@@ -1468,24 +1442,24 @@ static void do_format_dasd(dasdfmt_info_
 
 		switch (mode) {
 		case FULL:
-			dasdfmt_prepare_and_format(info, cylinders, heads, p);
+			dasdfmt_prepare_and_format(cylinders, heads, p);
 			break;
 		case QUICK:
-			dasdfmt_release_space(info);
-			dasdfmt_quick_format(info, cylinders, heads, p);
+			dasdfmt_release_space();
+			dasdfmt_quick_format(cylinders, heads, p);
 			break;
 		case EXPAND:
-			dasdfmt_expand_format(info, cylinders, heads, p);
+			dasdfmt_expand_format(cylinders, heads, p);
 			break;
 		}
 
 		printf("Finished formatting the device.\n");
 
-		if (!(info->writenolabel || mode == EXPAND))
-			dasdfmt_write_labels(info, vlabel, cylinders, heads);
+		if (!(g.writenolabel || mode == EXPAND))
+			dasdfmt_write_labels(vlabel, cylinders, heads);
 
 		printf("Rereading the partition table... ");
-		err = dasd_reread_partition_table(dev_filename, 5);
+		err = dasd_reread_partition_table(g.dev_node, 5);
 		if (err != 0) {
 			ERRMSG("%s: error during rereading the partition "
 			       "table: %s.\n", prog_name, strerror(err));
@@ -1495,24 +1469,34 @@ static void do_format_dasd(dasdfmt_info_
 	}
 }
 
-static void eval_format_mode(dasdfmt_info_t *info)
+static void eval_format_mode(void)
 {
-	if (!info->force && info->mode_specified && info->ese && mode == EXPAND) {
-		ERRMSG_EXIT(EXIT_FAILURE,
-			    "WARNING: The specified device is thin-provisioned\n"
-			    "Format mode 'expand' is not feasible.\n"
-			    "Use --mode=full or --mode=quick to perform a clean format\n");
+	if (!g.force && g.mode_specified && g.ese && mode == EXPAND) {
+		warnx("WARNING: The specified device is thin-provisioned");
+		warnx("Format mode 'expand' is not feasible.");
+		error("Use --mode=full or --mode=quick to perform a clean format");
 	}
 
-	if (!info->mode_specified)
-		mode = info->ese ? QUICK : FULL;
+	if (!g.mode_specified)
+		mode = g.ese ? QUICK : FULL;
+}
+
+/*
+ * Set prog_name to the last component of the program name to be in line with
+ * err() and warn() function (and its derivatives).
+ */
+static void set_prog_name(char *s)
+{
+	char *p = strrchr(s, '/');
+
+	if (p == NULL)
+		prog_name = s;
+	else
+		prog_name = p + 1;
 }
 
 int main(int argc, char *argv[])
 {
-	dasdfmt_info_t info = {
-		.dasd_info = {0},
-	};
 	volume_label_t vlabel;
 	char old_volser[7];
 
@@ -1532,7 +1516,7 @@ int main(int argc, char *argv[])
 	signal(SIGQUIT, program_interrupt_signal);
 
 	/******************* initialization ********************/
-	prog_name = argv[0];
+	set_prog_name(argv[0]);
 
 	util_prg_init(&prg);
 	util_opt_init(opt_vec, NULL);
@@ -1550,51 +1534,49 @@ int main(int argc, char *argv[])
 
 		switch (rc) {
 		case 'F':
-			info.force = 1;
+			g.force = 1;
 			break;
 		case 'd':
 			if (strcasecmp(optarg, "cdl") == 0) {
 				format_params.intensity |= DASD_FMT_INT_COMPAT;
-				if (info.writenolabel) {
-					printf("WARNING: using the cdl "
-					       "format without writing a "
-					       "label doesn't make much "
-					       "sense!\n");
-					exit(1);
+				if (g.writenolabel) {
+					error("WARNING: using the cdl "
+					      "format without writing a "
+					      "label doesn't make much "
+					      "sense!");
 				}
 			} else if (strcasecmp(optarg, "ldl") == 0) {
 				format_params.intensity &= ~DASD_FMT_INT_COMPAT;
 			} else {
-				printf("%s is not a valid option!\n", optarg);
-				exit(1);
+				error("%s is not a valid option!", optarg);
 			}
-			info.layout_specified = 1;
+			g.layout_specified = 1;
 			break;
 		case 'y':
-			info.withoutprompt = 1;
+			g.withoutprompt = 1;
 			break;
 		case OPT_NOZERO:
 			format_params.intensity |= DASD_FMT_INT_FMT_NOR0;
 			break;
 		case 't':
-			info.testmode = 1;
+			g.testmode = 1;
 			break;
 		case 'p':
-			if (!(info.print_hashmarks || info.print_percentage))
-				info.print_progressbar = 1;
+			if (!(g.print_hashmarks || g.print_percentage))
+				g.print_progressbar = 1;
 			break;
 		case 'm':
-			if (!(info.print_progressbar || info.print_percentage)) {
+			if (!(g.print_progressbar || g.print_percentage)) {
 				hashstep_str = optarg;
-				info.print_hashmarks = 1;
+				g.print_hashmarks = 1;
 			}
 			break;
 		case 'P':
-			if (!(info.print_hashmarks || info.print_progressbar))
-				info.print_percentage = 1;
+			if (!(g.print_hashmarks || g.print_progressbar))
+				g.print_percentage = 1;
 			break;
 		case 'v':
-			info.verbosity = 1;
+			g.verbosity = 1;
 			break;
 		case 'h':
 			util_prg_print_help();
@@ -1608,30 +1590,29 @@ int main(int argc, char *argv[])
 			if (check_volser(buf, 0) < 0)
 				break;
 			vtoc_volume_label_set_volser(&vlabel, buf);
-			info.labelspec = 1;
+			g.labelspec = 1;
 			break;
 		case 'L':
 			if (format_params.intensity & DASD_FMT_INT_COMPAT) {
-				printf("WARNING: using the cdl format "
-				       "without writing a label doesn't "
-				       "make much sense!\n");
-				exit(1);
+				error("WARNING: using the cdl format "
+				      "without writing a label doesn't "
+				      "make much sense!");
 			}
-			info.writenolabel = 1;
+			g.writenolabel = 1;
 			break;
 		case 'b':
 			blksize_param_str = optarg;
-			info.blksize_specified = 1;
+			g.blksize_specified = 1;
 			break;
 		case 'r':
 			reqsize_param_str = optarg;
-			info.reqsize_specified = 1;
+			g.reqsize_specified = 1;
 			break;
 		case 'k':
-			info.keep_volser = 1;
+			g.keep_volser = 1;
 			break;
 		case 'C':
-			info.force_host = 1;
+			g.force_host = 1;
 			break;
 		case 'M':
 			if (strcasecmp(optarg, "full") == 0)
@@ -1641,104 +1622,91 @@ int main(int argc, char *argv[])
 			else if (strcasecmp(optarg, "expand") == 0)
 				mode = EXPAND;
 			else
-				ERRMSG_EXIT(EXIT_FAILURE,
-					    "%s: The specified mode '%s' is "
-					    "invalid. Consult the man page for "
-					    "more information.\n",
-					    prog_name, optarg);
-			info.mode_specified = 1;
+				error("The specified mode '%s' is invalid. "
+				      "Consult the man page for more information.",
+				      optarg);
+			g.mode_specified = 1;
 			break;
 		case OPT_NODISCARD:
-			info.no_discard = 1;
+			g.no_discard = 1;
 			break;
 		case OPT_CHECK:
-			info.check = 1;
+			g.check = 1;
 			break;
 		case -1:
 			/* End of options string - start of devices list */
 			break;
 		default:
-			ERRMSG_EXIT(EXIT_MISUSE, "Try '%s --help' for more"
-				    " information.\n", prog_name);
+			error("Try '%s --help' for more information.");
 		}
 
 		if (rc == -1)
 			break; /* exit loop if finished */
 	}
 
-	CHECK_SPEC_MAX_ONCE(info.blksize_specified, "blocksize");
-	CHECK_SPEC_MAX_ONCE(info.labelspec, "label");
-	CHECK_SPEC_MAX_ONCE(info.writenolabel, "omit-label-writing flag");
+	CHECK_SPEC_MAX_ONCE(g.blksize_specified, "blocksize");
+	CHECK_SPEC_MAX_ONCE(g.labelspec, "label");
+	CHECK_SPEC_MAX_ONCE(g.writenolabel, "omit-label-writing flag");
 
-	if (info.blksize_specified)
+	if (g.blksize_specified)
 		PARSE_PARAM_INTO(format_params.blksize, blksize_param_str, 10,
 				 "blocksize");
-	if (info.reqsize_specified) {
+	if (g.reqsize_specified) {
 		PARSE_PARAM_INTO(reqsize, reqsize_param_str, 10, "requestsize");
 		if (reqsize < 1 || reqsize > 255)
-			ERRMSG_EXIT(EXIT_FAILURE,
-				    "invalid requestsize %d specified\n",
-				    reqsize);
+			error("invalid requestsize %d specified", reqsize);
 	} else {
 		reqsize = DEFAULT_REQUESTSIZE;
 	}
 
-	if (info.print_hashmarks)
-		PARSE_PARAM_INTO(info.hashstep, hashstep_str, 10, "hashstep");
+	if (g.print_hashmarks)
+		PARSE_PARAM_INTO(g.hashstep, hashstep_str, 10, "hashstep");
 
-	get_device_name(dev_filename, optind, argc, argv);
+	get_device_name(optind, argc, argv);
 
-	rc = dasd_get_info(dev_filename, &info.dasd_info);
+	rc = dasd_get_info(g.dev_node, &g.dasd_info);
 	if (rc != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: the ioctl call to retrieve "
-			    "device information failed (%s).\n",
-			    prog_name, strerror(rc));
+		error("the ioctl call to retrieve device information failed: %s", strerror(rc));
 
-	info.ese = dasd_sys_ese(dev_filename);
-	eval_format_mode(&info);
+	g.ese = dasd_sys_ese(g.dev_node);
+	eval_format_mode();
 
 	/* Either let the user specify the blksize or get it from the kernel */
-	if (!info.blksize_specified) {
+	if (!g.blksize_specified) {
 		if (!(mode == FULL ||
-		      info.dasd_info.format == DASD_FORMAT_NONE) || info.check)
-			get_blocksize(dev_filename, &format_params.blksize);
+		      g.dasd_info.format == DASD_FORMAT_NONE) || g.check)
+			get_blocksize(&format_params.blksize);
 		else
 			format_params = ask_user_for_blksize(format_params);
 	}
 
-	if (info.keep_volser) {
-		if (info.labelspec) {
-			ERRMSG_EXIT(EXIT_MISUSE, "%s: The -k and -l options "
-				    "are mutually exclusive\n", prog_name);
-		}
-		if (!(format_params.intensity & DASD_FMT_INT_COMPAT)) {
-			printf("WARNING: VOLSER cannot be kept "
-			       "when using the ldl format!\n");
-			exit(1);
-		}
+	if (g.keep_volser) {
+		if (g.labelspec)
+			error("The -k and -l options are mutually exclusive");
+		if (!(format_params.intensity & DASD_FMT_INT_COMPAT))
+			error("WARNING: VOLSER cannot be kept when using the ldl format!");
 
-		if (dasdfmt_get_volser(dev_filename,
-				       &info.dasd_info, old_volser) == 0)
+		if (dasdfmt_get_volser(old_volser) == 0)
 			vtoc_volume_label_set_volser(&vlabel, old_volser);
 		else
-			ERRMSG_EXIT(EXIT_FAILURE,
-				    "%s: VOLSER not found on device %s\n",
-				    prog_name, dev_filename);
+			error("VOLSER not found on device %s", g.dev_path);
 	}
 
-	check_disk(&info, dev_filename);
+	check_disk();
 
 	if (check_param(str, ERR_LENGTH, &format_params) < 0)
-		ERRMSG_EXIT(EXIT_MISUSE, "%s: %s\n", prog_name, str);
+		error("%s", str);
 
-	set_geo(&info, &cylinders, &heads);
-	set_label(&info, &vlabel, &format_params, cylinders);
+	set_geo(&cylinders, &heads);
+	set_label(&vlabel, &format_params, cylinders);
 
-	if (info.check)
-		check_disk_format(&info, cylinders, heads, &format_params);
+	if (g.check)
+		check_disk_format(cylinders, heads, &format_params);
 	else
-		do_format_dasd(&info, dev_filename, &vlabel,
-			       &format_params, cylinders, heads);
+		do_format_dasd(&vlabel, &format_params, cylinders, heads);
+
+	free(g.dev_path);
+	free(g.dev_node);
 
 	return 0;
 }
diff -pruN 2.14.0-2/dasdfmt/dasdfmt.h 2.15.1-0ubuntu2/dasdfmt/dasdfmt.h
--- 2.14.0-2/dasdfmt/dasdfmt.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/dasdfmt/dasdfmt.h	2020-10-28 14:31:59.000000000 +0000
@@ -65,47 +65,24 @@ static const char mode_str[3][10] = {
 	"is in invalid format\n",prog_name);}
 
 typedef struct bootstrap1 {
-        u_int32_t key;
-        u_int32_t data[6];
+	u_int32_t key;
+	u_int32_t data[6];
 } __attribute__ ((packed)) bootstrap1_t;
 
 typedef struct bootstrap2 {
-        u_int32_t key;
-        u_int32_t data[36];
+	u_int32_t key;
+	u_int32_t data[36];
 } __attribute__ ((packed)) bootstrap2_t;
 
-typedef struct dasdfmt_info {
-	dasd_information2_t dasd_info;
-        int   verbosity;
-        int   testmode;
-        int   withoutprompt;
-        int   print_progressbar;
-        int   print_hashmarks, hashstep;
-	int   print_percentage;
-        int   force;
-        int   writenolabel;
-        int   labelspec;
-        int   cdl_format;
-        int   blksize_specified;
-	int   reqsize_specified;
-        int   keep_volser;
-	int   force_host;
-	int   layout_specified;
-	int   check;
-	int   mode_specified;
-	int   ese;
-	int   no_discard;
-} dasdfmt_info_t;
-
 
 /*
 C9D7D3F1 000A0000 0000000F 03000000  00000001 00000000 00000000
 */
 static bootstrap1_t ipl1 = {
-        0xC9D7D3F1, {
-                0x000A0000, 0x0000000F, 0x03000000,
-                0x00000001, 0x00000000, 0x00000000
-        }
+	0xC9D7D3F1, {
+		0x000A0000, 0x0000000F, 0x03000000,
+		0x00000001, 0x00000000, 0x00000000
+	}
 };
 
 /*
@@ -116,21 +93,20 @@ C9D7D3F2 07003AB8 40000006 31003ABE  400
 00000000 00000000 00000000 00000000  00000000
 */
 static bootstrap2_t ipl2 = {
-        0xC9D7D3F2, {
-                0x07003AB8, 0x40000006, 0x31003ABE,
-                0x40000005, 0x08003AA0, 0x00000000,
-                0x06000000, 0x20000000, 0x00000000,
-                0x00000000, 0x00000400, 0x00000000,
-                0x00000000, 0x00000000, 0x00000000,
-                0x00000000, 0x00000000, 0x00000000,
-                0x00000000, 0x00000000, 0x00000000,
-                0x00000000, 0x00000000, 0x00000000,
-                0x00000000, 0x00000000, 0x00000000,
-                0x00000000, 0x00000000, 0x00000000,
-                0x00000000, 0x00000000, 0x00000000,
-                0x00000000, 0x00000000, 0x00000000
-        }
+	0xC9D7D3F2, {
+		0x07003AB8, 0x40000006, 0x31003ABE,
+		0x40000005, 0x08003AA0, 0x00000000,
+		0x06000000, 0x20000000, 0x00000000,
+		0x00000000, 0x00000400, 0x00000000,
+		0x00000000, 0x00000000, 0x00000000,
+		0x00000000, 0x00000000, 0x00000000,
+		0x00000000, 0x00000000, 0x00000000,
+		0x00000000, 0x00000000, 0x00000000,
+		0x00000000, 0x00000000, 0x00000000,
+		0x00000000, 0x00000000, 0x00000000,
+		0x00000000, 0x00000000, 0x00000000,
+		0x00000000, 0x00000000, 0x00000000
+	}
 };
 
 #endif /* DASDFMT_H */
-
diff -pruN 2.14.0-2/debian/changelog 2.15.1-0ubuntu2/debian/changelog
--- 2.14.0-2/debian/changelog	2020-08-23 16:46:01.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/changelog	2020-11-18 14:23:24.000000000 +0000
@@ -1,3 +1,51 @@
+s390-tools (2.15.1-0ubuntu2) hirsute; urgency=medium
+
+  * Package libekmfweb library.
+  * Do not use /usr/lib64 prefix.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 18 Nov 2020 14:23:24 +0000
+
+s390-tools (2.15.1-0ubuntu1) hirsute; urgency=medium
+
+  * New upstream release. LP: #1902865, LP: #1902047, LP: #1892824, LP: #1887920, LP: #1887806
+  * Drop .triggers, and initramfs override. Triggers to update initramfs
+    are desired in both packages that ship hooks.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 12 Nov 2020 15:10:44 +0000
+
+s390-tools (2.14.0-2ubuntu1) hirsute; urgency=medium
+
+  * Merge from Debian unstable (LP: #1903688).  Remaining changes:
+    - lower priority to optional
+    - add libsnmp-dev, libglib2.0-dev build-deps
+    - add support for signed zipl
+    - use z Systems branding in descriptions
+    - package cpuplugd, osasnmpd, statd, zkey
+    - drop ziomon package, shipped in the main package
+    - ship zdev in udeb
+    - update copyright file
+    - fix kernel installer script integration, to skip calling zipl without initrd
+    - load monwriter kernel module for mon_statd/mon_fsstatd
+    - do not run dumpconf in lxc
+    - ziomon change exit code to 0 for version and help
+    - add zkey initramfs hook
+    - change zkey default back to argon2i
+    - drop patch that disables building osasnmpd
+    - drop udevadm-path.patch to init script, systemd units are used instead
+    - enable hardening
+    - enable initramfs & dracut integration
+    - setup users/groups for mon_*, iucvterm, zkey
+    - install more utilities and zdev initramfs integration
+    - setup crashkernel integration
+  * Update debian/not-installed file for additional files in debian/tmp
+  * debian/rules:
+    - drop unneeded "--parallel --with systemd" dh args
+    - clean zipl/boot/.stage*.d files
+    - avoid dh_installinitramfs to install additional triggers
+  * s390-tools.docs: ship CHANGELOG.md (as Debian does)
+
+ -- Lukas Märdian <lukas.maerdian@canonical.com>  Mon, 09 Nov 2020 16:04:40 +0100
+
 s390-tools (2.14.0-2) unstable; urgency=medium
 
   * Bump debhelper compat to v13.
@@ -5,6 +53,34 @@ s390-tools (2.14.0-2) unstable; urgency=
 
  -- Philipp Kern <pkern@debian.org>  Sun, 23 Aug 2020 12:46:01 -0400
 
+s390-tools (2.14.0-1ubuntu1) groovy; urgency=medium
+
+  * Merge from Debian, remaining changes:
+    - add libssl-dev, libglib2.0-dev build-deps
+    - add support for signed zipl
+    - package cpuplugd, osasnmpd, statd, zkey
+    - update copyright file
+    - fix kernel installer script integration, to skip calling zipl without initrd
+    - load monwriter kernel module for mon_statd/mon_fsstatd
+    - do not run dumpconf in lxc
+    - ziomon change exit code to 0 for version and help
+    - add zkey initramfs hook
+    - change zkey default back to argon2i
+    - drop patch that disables building osasnmpd
+    - drop udevpath patch to init script, systemd units are used instead
+    - enable hardening
+    - enable initramfs & dracut integration
+    - install more utilities and zdev initramfs integration
+    - setup users/groups for mon_*, iucvterm, zkey
+    - setup crashkernel integration
+    - ship zdev in udeb
+    - drop ziomon package, shipped in the main package
+
+  * New upstream release fixes LP: #1892350, LP: #1888231, LP: #1884773,
+    LP: #1884744, LP: #1884721
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 26 Aug 2020 11:11:23 +0100
+
 s390-tools (2.14.0-1) unstable; urgency=medium
 
   * New upstream release.
@@ -19,34 +95,366 @@ s390-tools (2.3.0-2) unstable; urgency=m
 
  -- Philipp Kern <pkern@debian.org>  Sun, 16 Aug 2020 10:36:02 -0400
 
-s390-tools (2.3.0-1) unstable; urgency=medium
+s390-tools (2.12.0-0ubuntu6) groovy; urgency=medium
 
-  * New upstream release.
-    - Drop debian/patches/zipl-no-pie.patch: applied upstream.
-  * Add a watch file.
-  * Package ziomon/ziorep reporting tools. (Closes: #812588)
+  * Rebuild against new json-c5.
+
+ -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jul 2020 19:56:05 +0200
+
+s390-tools (2.12.0-0ubuntu5) groovy; urgency=medium
+
+  * lsluns: fix udevadm calls to settle LP: #1873973.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 10 Jul 2020 12:44:00 +0100
+
+s390-tools (2.12.0-0ubuntu4) groovy; urgency=medium
+
+  * Don't run dumpconf service in LXC
+    It just fails to start in unprivileged containers
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 20 May 2020 14:34:58 +0200
+
+s390-tools (2.12.0-0ubuntu3) focal; urgency=medium
+
+  * Update patch series to master tip:
+    - PVM / genprotimg LP: #1834534, FFe LP: #1866866
+    - zipl/libc: Fix potential buffer overflow LP: #1865032
+    - zipl: Fix secureboot documentation LP: #1864654
+    - Many other smaller bugfixes
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 20 Mar 2020 12:08:13 +0000
+
+s390-tools (2.12.0-0ubuntu2) focal; urgency=medium
+
+  * Cherrypick more patches from upstream.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Feb 2020 15:39:48 +0000
+
+s390-tools (2.12.0-0ubuntu1) focal; urgency=medium
+
+  * New upstream release, plus cherrypick patches from master.
+    LP: #1860574 LP: #1860531 LP: #1859018 LP: #1853308
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 29 Jan 2020 22:27:05 +0000
+
+s390-tools (2.11.0-0ubuntu2) focal; urgency=medium
 
- -- Philipp Kern <pkern@debian.org>  Sun, 04 Feb 2018 13:29:22 -0500
+  * Rebuild for libsnmp35.
 
-s390-tools (2.2.0-1) unstable; urgency=medium
+ -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Tue, 14 Jan 2020 18:04:49 +0000
+
+s390-tools (2.11.0-0ubuntu1) eoan; urgency=medium
+
+  * New upstream release LP: #1830731
+    - update from master snapshot, to v2.11.0 final
+    - only minor bugfixes and clarifications included
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 10 Sep 2019 16:36:31 +0100
+
+s390-tools (2.10.0-0ubuntu2) eoan; urgency=medium
+
+  * Cherrypick patches from master since v2.10.0.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 19 Aug 2019 20:07:27 +0100
+
+s390-tools (2.10.0-0ubuntu1) eoan; urgency=medium
+
+  * New upstream release LP: #1836862, LP: #1836608
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 31 Jul 2019 23:43:34 -0400
+
+s390-tools (2.9.0-0ubuntu4) eoan; urgency=medium
+
+  * Rebuild against new libjson-c4.
+
+ -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 01 Jul 2019 15:02:17 +0200
+
+s390-tools (2.9.0-0ubuntu3) eoan; urgency=medium
+
+  * Fix FTBFS LP: #1833238
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 19 Jun 2019 14:28:12 +0100
+
+s390-tools (2.9.0-0ubuntu2) eoan; urgency=medium
+
+  * Add secure initial programme load signing. LP: #1829749
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Jun 2019 13:20:45 +0100
+
+s390-tools (2.9.0-0ubuntu1) eoan; urgency=medium
 
   * New upstream release
-    - Drop debian/patches/systemd-bindto.patch: applied upstream.
-    - lsmem/chmem were moved to util-linux.
-    - Ship upstream's changelog.
 
- -- Philipp Kern <pkern@debian.org>  Sun, 14 Jan 2018 15:36:29 +0100
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 22 May 2019 21:19:21 +0100
+
+s390-tools (2.8.0-0ubuntu6) eoan; urgency=medium
+
+  * Cherrypick v2.9.0 patches.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 08 May 2019 20:15:17 +0100
+
+s390-tools (2.8.0-0ubuntu5) disco; urgency=medium
+
+  * zkey: on Ubuntu, use default benchmarked Argon2i with LUKS2. LP:
+    #1820049
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 15 Mar 2019 13:50:25 +0000
+
+s390-tools (2.8.0-0ubuntu4) disco; urgency=medium
+
+  * Guard against needlesly resetting cpi vars. LP: #1805841
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 13 Mar 2019 23:44:33 +0000
+
+s390-tools (2.8.0-0ubuntu3) disco; urgency=medium
 
-s390-tools (1.37.1-1) unstable; urgency=medium
+  * Import zkey bugfixes to support more cryptsetup options, and generate
+    valid plain entries.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 07 Mar 2019 14:45:58 +0000
+
+s390-tools (2.8.0-0ubuntu2) disco; urgency=medium
+
+  * Restore missing history and, more importantly, the zz-zipl fix.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Thu, 28 Feb 2019 10:54:06 -0700
+
+s390-tools (2.8.0-0ubuntu1) disco; urgency=medium
 
   * New upstream release
-    - Pass in the default CPPFLAGS/LDFLAGS from debian/rules.
-  * Drop the libsysfs-dev build-dependency; it is no longer used.
-    (Closes: #856062)
-  * Check for udevadm in /bin, not /sbin. (Closes: #852572)
-  * Replace BindTo with BindsTo in systemd unit file. (Closes: #857190)
 
- -- Philipp Kern <pkern@debian.org>  Sun, 09 Jul 2017 10:07:15 +0200
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 21 Feb 2019 13:58:39 +0100
+
+s390-tools (2.7.1-0ubuntu1) disco; urgency=medium
+
+  * New upstream release:
+    - zkey: Enhance error message about missing CCA library. LP: #1808520
+    - Extended access controls for AP queue LP: #1804019
+    - PCI error reporting tool LP: #1802499
+    - zcrypt DD: introduce APQN tags to support deterministic driver
+    binding LP: #1800867
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 15 Jan 2019 14:23:22 +0000
+
+s390-tools (2.6.0-0ubuntu10) disco; urgency=medium
+
+  * On Ubuntu, PATH is reset to a known secure path, when running programs
+    as root, thus there is no need to reset PATH in zkey before calling
+    system(). This fixes zkey failing to find cryptsetup. LP: #1803958
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 23 Nov 2018 02:45:09 +0000
+
+s390-tools (2.6.0-0ubuntu9) disco; urgency=medium
+
+  * No-change rebuild to fix wrong versioned dep on net-snmp.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 05 Nov 2018 13:25:09 -0800
+
+s390-tools (2.6.0-0ubuntu8) disco; urgency=medium
+
+  * zz-zipl: Handle removed-but-not-purged state by checking for zipl first.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Mon, 05 Nov 2018 11:44:08 -0700
+
+s390-tools (2.6.0-0ubuntu7) cosmic; urgency=medium
+
+  * zdev: Trigger generic_ccw devices on any kernel module loads. LP:
+    #1794308
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Oct 2018 10:23:35 +0100
+
+s390-tools (2.6.0-0ubuntu6) cosmic; urgency=medium
+
+  * Add a zkeyadm group, and make it own the default zkey repository
+    directories. LP: #1794290
+  * Cherrypick zdev initramfs hook rename
+  * Cherrypick zkey initramfs hook LP: #1794346
+  * Make zkey package activate update-initramfs trigger
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 02 Oct 2018 14:15:29 +0100
+
+s390-tools (2.6.0-0ubuntu5) cosmic; urgency=medium
+
+  * Cherrypick upstream patches for:
+    - lstape, lsluns multiple paths fixes LP: #1790831
+    - zkey documentation update
+    - zfcpdump incompatible cast fix
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 05 Sep 2018 11:42:43 +0100
+
+s390-tools (2.6.0-0ubuntu4) cosmic; urgency=medium
+
+  * Add s390-tools-zkey-udeb package with zkey utilities for d-i. LP:
+    #1766865
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 04 Sep 2018 16:58:09 +0100
+
+s390-tools (2.6.0-0ubuntu3) cosmic; urgency=medium
+
+  * Make initramfs-tools zdev hooks not conflict with zfs. LP: #1788314
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 22 Aug 2018 18:05:29 +0100
+
+s390-tools (2.6.0-0ubuntu2) cosmic; urgency=medium
+
+  * Add zdev initramfs hooks to initialize firmware provided devices by
+    default. LP: #1776631
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 21 Aug 2018 15:06:21 +0100
+
+s390-tools (2.6.0-0ubuntu1) cosmic; urgency=medium
+
+  * New upstream release.
+  * Add a zkey subpackage LP: #1786460.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 21 Aug 2018 14:29:58 +0100
+
+s390-tools (2.5.0-0ubuntu1) cosmic; urgency=medium
+
+  * New upstream release LP: #1776907 LP: #1775627 LP: #1775632
+  * Drop udevadm patch, no longer needed
+  * Refresh patches
+  * Import upstream patches since v2.5.0 LP: #1777600
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 24 Jul 2018 17:00:03 +0100
+
+s390-tools (2.3.0-0ubuntu4) cosmic; urgency=medium
+
+  * No-change rebuild for ncurses soname changes.
+
+ -- Matthias Klose <doko@ubuntu.com>  Thu, 03 May 2018 14:18:56 +0000
+
+s390-tools (2.3.0-0ubuntu3) bionic; urgency=medium
+
+  * zz-zipl: Do not run if non-optional initrds don't exist yet (LP: #1766727)
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Wed, 25 Apr 2018 09:34:18 -0600
+
+s390-tools (2.3.0-0ubuntu2) bionic; urgency=medium
+
+  * Do not instead 60-readahead.rules, uses obsolete WAIT_FOR.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 28 Mar 2018 12:07:14 +0100
+
+s390-tools (2.3.0-0ubuntu1) bionic; urgency=medium
+
+  * New upstream release LP: #1746272
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 27 Feb 2018 10:49:21 +0000
+
+s390-tools (2.2.0-0ubuntu1) bionic; urgency=medium
+
+  * New upstream release.
+  * Cherry-pick debian change:
+    - Check for udevadm in /bin, not /sbin. (Closes: #852572)
+  * Add watch file
+  * Update copyright file
+  * Do not use fail-missing, fails on conf-files
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 05 Jan 2018 11:09:26 +0000
+
+s390-tools (1.39.0-0ubuntu4) artful; urgency=medium
+
+  * Drop the depracated '-f device' and use required position 'device'
+    only. -f flag got removed post v1.37. Otherwise zipl fails to
+    determine correct underlying device topology and fails to IPL root on
+    LVM or multipath. LP: #1723541
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 17 Oct 2017 18:09:49 +0100
+
+s390-tools (1.39.0-0ubuntu3) artful; urgency=medium
+
+  * Fix ftbfs.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 24 Aug 2017 00:14:43 +0100
+
+s390-tools (1.39.0-0ubuntu1) artful; urgency=medium
+
+  * New upstream release.
+  * Drop patches applied upstream:
+    + debian/patches/fix-ftbfs-link-order.patch
+    + debian/patches/v1.37.1-updates.patch
+  * Refresh patches.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 23 Aug 2017 17:28:21 +0100
+
+s390-tools (1.37.0-0ubuntu7) artful; urgency=medium
+
+  * Drop chmem/lsmem utilities, moved to util-linux.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 02 Aug 2017 16:59:54 +0300
+
+s390-tools (1.37.0-0ubuntu6) artful; urgency=medium
+
+  * Set cpi vars (system name, type, level and sysplex name) via systemd
+    generator.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Jul 2017 12:41:57 +0100
+
+s390-tools (1.37.0-0ubuntu5) artful; urgency=medium
+
+  * Revert 1.37.0-0ubuntu2 "chzdev/qeth: set bridge_role after the device
+    is online", as one must specify layer2 parameter when specifying layer
+    specific parameters. LP: #1618463.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 24 May 2017 17:03:44 +0100
+
+s390-tools (1.37.0-0ubuntu4) artful; urgency=medium
+
+  * chzdev: Fix ineffective zfcp-lun udev rule preventing activation of
+    unordered WWPNs. LP: #1683808
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 May 2017 12:25:08 +0100
+
+s390-tools (1.37.0-0ubuntu3) zesty; urgency=medium
+
+  * Cherrypick v1.37.1 point release bug fixes LP: #1671497, LP: #1669785
+    - dbginfo.sh: Add Docker debug data
+    - lsdasd: Replace continue with return
+    - lscss: Allow to specify devices from subchannel set 3
+    - mon_fsstatd: Only use physical filesystems
+    - mon_fsstatd: Fix double free in error path
+    - mon_procd: Fix segmentation fault
+    - mon_procd: Bump buffer size to 4096
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Mar 2017 16:10:35 +0100
+
+s390-tools (1.37.0-0ubuntu2) zesty; urgency=medium
+
+  * chzdev/qeth: set bridge_role after the device is online to avoid a
+    race condition when setting qeth attributes on boot. LP: #1618463.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 14 Mar 2017 09:26:12 +0000
+
+s390-tools (1.37.0-0ubuntu1) zesty; urgency=medium
+
+  * New upstream release LP: #1657166 LP: #1656809
+  * Drop no-wait-for.patch, fixed upstream.
+  * Reintroduce GNU_SOURCE and -rdynamic via dpkg-buildflags, as they are
+    lost in the buildsystem.
+  * Fix linking order in dump2tar Makefile.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 30 Jan 2017 12:37:45 +0000
+
+s390-tools (1.36.1-1ubuntu1) zesty; urgency=medium
+
+  * Merge s390-tools 1.36.1-1 from debian, remaining changes:
+    - lower priority to optional
+    - build-depend on libsnmp-dev
+    - add cpuplugd, statd, osasnmpd subpackages
+    - use z Systems branding in descriptions
+    - ship monwriter
+    - Apply patch to exit 0 on help for ziomon
+    - Drop unused patches from debian/patches
+    - Add CondifitionVirtualization to cpacfstatsd unit
+    - Drop disable.patch
+    - Drop WAIT_FOR stanzas in udev rules
+    - Apply spelling patch
+    - add update-initramfs -u zdev-root-update integration to zdev
+    - Ship zdev in udeb
+    - Add monitoring systemd units
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 30 Jan 2017 11:41:42 +0000
 
 s390-tools (1.36.1-1) unstable; urgency=medium
 
@@ -59,6 +467,32 @@ s390-tools (1.36.1-1) unstable; urgency=
 
  -- Philipp Kern <pkern@debian.org>  Tue, 24 Jan 2017 03:29:35 -0500
 
+s390-tools (1.36.1-0ubuntu3) zesty; urgency=medium
+
+  * Add update-initramfs -u integration for chzdev.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 14 Nov 2016 16:49:11 +0000
+
+s390-tools (1.36.1-0ubuntu2) yakkety; urgency=medium
+
+  * Fix exit codes. LP: #1616596
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 15 Sep 2016 13:05:09 +0100
+
+s390-tools (1.36.1-0ubuntu1) yakkety; urgency=medium
+
+  * New upstream point release. LP: #1609435
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 01 Sep 2016 18:04:11 +0100
+
+s390-tools (1.36.0-0ubuntu1) yakkety; urgency=medium
+
+  * New upstream release. LP: #1614579
+  * Merge debian changes up to 1.34.0-2.
+  * Refresh patches
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 24 Aug 2016 12:20:46 +0100
+
 s390-tools (1.34.0-2) unstable; urgency=medium
 
   [ Hendrik Brueckner ]
@@ -86,6 +520,117 @@ s390-tools (1.34.0-1) unstable; urgency=
 
  -- Philipp Kern <pkern@debian.org>  Sun, 20 Mar 2016 22:54:33 +0100
 
+s390-tools (1.34.0-0ubuntu11) yakkety; urgency=medium
+
+  * zipl: Import off-by-one patch to resolve failure to start subchannel
+    in FBA loader. LP: #1592990.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 24 Jun 2016 12:41:30 +0100
+
+s390-tools (1.34.0-0ubuntu10) yakkety; urgency=medium
+
+  * Fix ts-shell maintainer scripts LP: #1567473:
+    - create /var/log/ts-shell directory with the right permissions
+    - remove errorous directory
+  * Install iuctty-login@.service systemd unit, with a correct path LP:
+    #1580226
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 06 Jun 2016 12:37:33 +0100
+
+s390-tools (1.34.0-0ubuntu9) yakkety; urgency=medium
+
+  * Cherrypick upstream fix for buffer overflow in dasdfmt. LP: #1582728
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 06 Jun 2016 11:51:16 +0100
+
+s390-tools (1.34.0-0ubuntu8) xenial; urgency=medium
+
+  * Ship dumpconf legacy init script, and sysconfig file. LP: #1564690
+  * Integrate ts-shell. LP: #1567473
+  * Recommend statd package, and mention it by mon_statd name too to aid
+    discovery.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 14 Apr 2016 14:26:16 +0100
+
+s390-tools (1.34.0-0ubuntu7) xenial; urgency=medium
+
+  * Add statd subpackage with modules-load.d snippet and
+    mon_fstatd/mon_procd units to enable statd daemons. LP: #1569454.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 13 Apr 2016 13:51:49 +0100
+
+s390-tools (1.34.0-0ubuntu6) xenial; urgency=medium
+
+  * Drop more obsolete WAIT_FOR udev rules stanzas.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 12 Apr 2016 12:36:06 +0100
+
+s390-tools (1.34.0-0ubuntu5) xenial; urgency=medium
+
+  * Add condition to cpacfstatsd.service to only start on LPARs (which may
+    still fail, if LPAR is not configured with the right counters).
+  * Add a system group for cpacfstatsd.service.
+  * Reluctantly Bump crashkernel to 196M, as otherwise 128M is not enough
+    by default to collect a kdump on any LPAR, defeating the intended
+    purpose in the first place. (LP: #1564475)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 11 Apr 2016 12:51:36 +0100
+
+s390-tools (1.34.0-0ubuntu4) xenial; urgency=medium
+
+  * Inlcude chzdev & lzdev utilities in the udeb.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 08 Apr 2016 11:55:01 +0100
+
+s390-tools (1.34.0-0ubuntu3) xenial; urgency=medium
+
+  * Ship all tools, mostly harmless LP: #1555167, LP: #1564690, LP: #1564696
+  * Add snmp build-dependency to build osasnmpd as a separate
+    package LP: #1564699
+  * Add cpuplugd, with patches to default config, as a separate
+    package LP: #1564496
+  * Update branding from "S/390" to "z Systems"
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 06 Apr 2016 02:12:04 +0100
+
+s390-tools (1.34.0-0ubuntu2) xenial; urgency=medium
+
+  * Upgrade /etc/zipl.conf to include crashkernel parameter by default
+    (LP: #1555159)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 18 Mar 2016 17:58:20 +0000
+
+s390-tools (1.34.0-0ubuntu1) xenial; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * New upstream release LP: #1558274. LP: #1559188.
+
+  [ Hendrik Brueckner ]
+  * Added missing lsscm command to display Storage-Class Memory,
+    aka. Flash Express  (Closes: #818381) LP: #1558273
+  * Added tools to display information about the CPU-measurement counter
+    and sampling facilities.  This includes a database with hardware
+    counter information.  (Closes: #818385) LP: #1558277
+  * Added zdsfs and hmc drive FUSE file systems (Closes: #818495) LP: #1558709
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 18 Mar 2016 17:20:08 +0000
+
+s390-tools (1.33.0-1ubuntu2) xenial; urgency=medium
+
+  * Include debian ifupdown networking information. LP: #1551819
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 16 Mar 2016 12:14:51 +0000
+
+s390-tools (1.33.0-1ubuntu1) xenial; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Add zfcp monitoring and reporting tools (ziomon).
+    - ship dbginfo.sh
+    - fix bashism in dbginfo
+    - ship chzdev and lszdev tools
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 07 Mar 2016 11:57:02 +0000
+
 s390-tools (1.33.0-1) unstable; urgency=medium
 
   [ Philipp Kern ]
@@ -99,6 +644,84 @@ s390-tools (1.33.0-1) unstable; urgency=
 
  -- Philipp Kern <pkern@debian.org>  Sun, 14 Feb 2016 13:53:07 +0100
 
+s390-tools (1.33.0-0ubuntu2) xenial; urgency=medium
+
+  [ Hendrik Brueckner ]
+  * Add zfcp monitoring and reporting tools (ziomon) (Closes: #812588)
+    LP: #1540425.
+
+  [ Dimitri John Ledkov ]
+  * Drop dependencies/recommendencies for ziomon to Suggests, to avoid
+    pulling those large packages, on all installation types (including
+    virtual machines, cloud images, lxc/lxd/docker containers)
+
+  * Possibly it is time to split s390-tools into essential, and optional
+    binary packages with correct dependencies.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 09 Feb 2016 11:38:46 +0000
+
+s390-tools (1.33.0-0ubuntu1) xenial; urgency=medium
+
+  * New upstream release LP: #1542338.
+  * Drop dbginfo.sh patches LP: #1539719.
+  * Fix bashism in the new dbginfo.sh.
+  * Ship chzdev and lszdev tools.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 09 Feb 2016 11:27:28 +0000
+
+s390-tools (1.32.0-2ubuntu4) xenial; urgency=medium
+
+  * debian/control: drop the libsysfs-dev Build-Depends; it's not in fact used
+    at all anymore due to being deemed too unstable. Reaching the sysfs
+    attributes directly instead works (documented in README).
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Wed, 03 Feb 2016 17:51:16 -0500
+
+s390-tools (1.32.0-2ubuntu3) xenial; urgency=medium
+
+  * unbreak zipl.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Feb 2016 01:37:01 +0000
+
+s390-tools (1.32.0-2ubuntu2) xenial; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * Support DESTDIR in the makefiles.
+  * Modernise packaging.
+  * Apply patch to build zipl without PIE, even if enabled by
+    default in the toolchain.
+  * Enable verbose builds
+  * Enable support for CFLAGS, and thus build optimized binaries,
+    with debug symbols stored in debugsymbols package.
+  * Enable hardening build flags.
+  * Enable parallel build.
+  * Fix spelling in binaries.
+  * Fix one more LO macro in vmur man page.
+  * Simplify synopsis.
+
+  [ dann frazier ]
+  * Add dbginfo.sh. (Closes: #807442, LP: #1539719)
+    - dbginfo.sh-umask.patch: Avoid leaking content to unprivileged users.
+    - dbginfo.sh-warn.patch: Warn users about the sensitivity of the data
+      this tool collects.
+
+  [ Hendrik Brueckner ]
+  * Clean up lsluns comment leftovers
+  * Install additional management utilities: lschp, chchp, dasdstat,
+    cio_ignore, and znetconf with its related files. (Closes: #812092, LP:
+    1536559)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 02 Feb 2016 14:13:33 +0000
+
+s390-tools (1.32.0-2ubuntu1) xenial; urgency=high
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Set -no-pie flags to fix miscompilation on ubuntu/s390x which has
+    pie enabled by default.
+    - Make build verbose.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 14 Dec 2015 11:14:08 +0000
+
 s390-tools (1.32.0-2) unstable; urgency=medium
 
   [ Hendrik Brueckner ]
@@ -427,3 +1050,4 @@ s390-tools (0.0.20010629-1) unstable; ur
   * Composed zipl manpage from "zipl -h" output.
 
  -- Jochen Röhrig <jr@debian.org>  Mon, 23 Jul 2001 20:24:37 +0200
+
diff -pruN 2.14.0-2/debian/control 2.15.1-0ubuntu2/debian/control
--- 2.14.0-2/debian/control	2020-08-23 14:36:37.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/control	2020-11-18 13:43:49.000000000 +0000
@@ -1,17 +1,20 @@
 Source: s390-tools
 Section: admin
-Priority: important
-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
+Priority: optional
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
 Uploaders: Bastian Blank <waldi@debian.org>, Philipp Kern <pkern@debian.org>
-Build-Depends: debhelper-compat (= 13), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev, libssl-dev, libcurl4-openssl-dev, libcryptsetup-dev, libjson-c-dev
-Standards-Version: 3.8.3
+Build-Depends: debhelper-compat (= 13), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev, libssl-dev, libcurl4-openssl-dev, libcryptsetup-dev, libjson-c-dev, libsnmp-dev, libglib2.0-dev
+Standards-Version: 3.9.7
 Homepage: http://www.ibm.com/developerworks/linux/linux390/s390-tools.html
 
 Package: s390-tools
-Architecture: s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}, perl, gawk
+Architecture: s390 s390x
+Priority: important
+Depends: ${shlibs:Depends}, ${misc:Depends}, perl, ${signing:Depends}, gawk
 Recommends: sg3-utils
-Description: Set of fundamental utilities for Linux on S/390
+Suggests: s390-tools-cpuplugd, s390-tools-osasnmpd, s390-tools-statd, multipath-tools, lsscsi, rsync, blktrace
+Description: fundamental utilities for Linux on z Systems
  The package contains:
   * dasdfmt, which is used to low-level format ECKD-DASDs with either
     the classic disk layout or the new zSeries compatible disk layout.
@@ -24,21 +27,73 @@ Description: Set of fundamental utilitie
   * zgetdump, which is used to retrieve system dumps from either tapes
     or dasds.
 
+Package: s390-tools-cpuplugd
+Architecture: s390 s390x
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: cpuplugd utility for Linux on z Systems
+ The package contains cpuplugd hotplug daemon from the s390-tools
+ collection of utilities.
+
+Package: s390-tools-statd
+Architecture: s390 s390x
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: s390-tools (<<1.34.0-0ubuntu7~)
+Replaces: s390-tools (<<1.34.0-0ubuntu7~)
+Description: mon_statd monitoring daemons for Linux on z Systems
+ The package contains mon_procd and mon_fsstatd z/VM monitoring
+ daemons for Linux on z Systems from the s390-tools collection of
+ utilities. These tools are also known as mon_statd.
+
+Package: s390-tools-osasnmpd
+Architecture: s390 s390x
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: osasnmpd utility for Linux on z Systems
+ The package contains osasnmpd monitoring daemon from the s390-tools
+ collection of utilities.
+
+Package: s390-tools-zkey
+Architecture: s390 s390x
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: zkey utilities for Linux on z Systems
+ The package contains zkey and zkey-cryptsetup from the s390-tools
+ collection of utilities.
+
+Package: libekmfweb1
+Architecture: s390 s390x
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: integration with IBM Enterprise Key Management Foundation
+ This package contains library to integrate with IBM Enterprise Key
+ Management Foundation. It is used by zkey plugin for pervasive
+ encryption support.
+ .
+ This package contains the runtime library.
+
+Package: libekmfweb-dev
+Architecture: s390 s390x
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: integration with IBM Enterprise Key Management Foundation (development)
+ This package contains library to integrate with IBM Enterprise Key
+ Management Foundation. It is used by zkey plugin for pervasive
+ encryption support.
+ .
+ This package contains the development library and headers.
+
 Package: s390-tools-udeb
 XC-Package-Type: udeb
 Section: debian-installer
-Priority: optional
-Architecture: s390x
+Architecture: s390 s390x
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: Set of utilities for Linux on S/390
+Description: utilities for Linux on z Systems
  This is a minimal package used by debian-installer.
- This package contains only the binaries dasdfmt and fdasd.
+ This package contains only the binaries chzdev, lszdev, dasdfmt and
+ fdasd.
 
-Package: ziomon
-Priority: optional
-Architecture: s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, blktrace, rsync
-Recommends: multipath-tools, lsscsi
-Description: Performance analysis and reports for zFCP devices
- Tool set to collect data from zFCP devices for performance analysis
- and reporting.
+Package: s390-tools-zkey-udeb
+XC-Package-Type: udeb
+Section: debian-installer
+Priority: standard
+Architecture: s390 s390x
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: zkey utilities for Linux on z Systems
+ The package contains zkey and zkey-cryptsetup from the s390-tools
+ collection of utilities for the debian-installer
diff -pruN 2.14.0-2/debian/copyright 2.15.1-0ubuntu2/debian/copyright
--- 2.14.0-2/debian/copyright	2018-02-04 18:29:22.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/copyright	2020-11-09 15:04:40.000000000 +0000
@@ -2,13 +2,15 @@ This package was debianized by Jochen R
 Mon, 23 Jul 2001 20:24:37 +0200.
 
 It was downloaded from
-http://www.ibm.com/developerworks/linux/linux390/s390-tools.html
+https://github.com/ibm-s390-tools/s390-tools/releases
+and is licensed under the MIT license
 
 Upstream Author: IBM Linux for S/390 project <linux390@de.ibm.com>
 
 Copyright:
 
-  Copyright IBM Corp. 2001, 2017
+  Copyright IBM Corp. 1999-2020
+  Copyright 2007,2010 Jan Glauber (jan.glauber@de.ibm.com)
 
 License:
 
diff -pruN 2.14.0-2/debian/kernel/zz-zipl 2.15.1-0ubuntu2/debian/kernel/zz-zipl
--- 2.14.0-2/debian/kernel/zz-zipl	2016-12-10 09:26:01.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/kernel/zz-zipl	2020-11-09 15:04:40.000000000 +0000
@@ -14,8 +14,28 @@ if [ -n "$DEB_MAINT_PARAMS" ];then
     fi
 fi
 
+which zipl >/dev/null 2>&1 || exit 0
+
 if [ -f /etc/zipl.conf ]
 then
+    for initrd in $(awk '
+      function emit() {
+        if (optional == "0" && ramdisk != "") {
+          print(ramdisk);
+        };
+        ramdisk="";
+        optional="0";
+      }
+      /^optional[ 	]*=/	{ optional=$0; sub("^optional[ 	]*=[ 	]*", "", optional); }
+      /^ramdisk[ 	]*=/	{ ramdisk=$0; sub("^ramdisk[ 	]*=[ 	]*", "", ramdisk); }
+      /^\[/			{ emit(); }
+      END			{ emit(); }
+      ' < /etc/zipl.conf); do
+        if [ ! -f "$initrd" ]; then
+            echo "Not invoking zipl: initrd doesn't exist yet" >&2
+            exit 0
+        fi
+    done
     zipl </dev/null >&2
 else
     echo "WARNING, not invoking zipl: /etc/zipl.conf not found" >&2
diff -pruN 2.14.0-2/debian/libekmfweb1.install 2.15.1-0ubuntu2/debian/libekmfweb1.install
--- 2.14.0-2/debian/libekmfweb1.install	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/libekmfweb1.install	2020-11-18 13:44:15.000000000 +0000
@@ -0,0 +1 @@
+usr/lib/s390x-linux-gnu/libekmfweb.so.1*
diff -pruN 2.14.0-2/debian/libekmfweb1.symbols 2.15.1-0ubuntu2/debian/libekmfweb1.symbols
--- 2.14.0-2/debian/libekmfweb1.symbols	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/libekmfweb1.symbols	2020-11-18 14:04:52.000000000 +0000
@@ -0,0 +1,28 @@
+libekmfweb.so.1 libekmfweb1 #MINVER#
+ LIBEKMFWEB_1.0@LIBEKMFWEB_1.0 2.15.1
+ ekmf_check_feature@LIBEKMFWEB_1.0 2.15.1
+ ekmf_check_login_token@LIBEKMFWEB_1.0 2.15.1
+ ekmf_clone_key_info@LIBEKMFWEB_1.0 2.15.1
+ ekmf_clone_template_info@LIBEKMFWEB_1.0 2.15.1
+ ekmf_curl_destroy@LIBEKMFWEB_1.0 2.15.1
+ ekmf_delete_key_tags@LIBEKMFWEB_1.0 2.15.1
+ ekmf_free_key_info@LIBEKMFWEB_1.0 2.15.1
+ ekmf_free_template_info@LIBEKMFWEB_1.0 2.15.1
+ ekmf_generate_csr@LIBEKMFWEB_1.0 2.15.1
+ ekmf_generate_identity_key@LIBEKMFWEB_1.0 2.15.1
+ ekmf_generate_key@LIBEKMFWEB_1.0 2.15.1
+ ekmf_generate_ss_cert@LIBEKMFWEB_1.0 2.15.1
+ ekmf_get_key_info@LIBEKMFWEB_1.0 2.15.1
+ ekmf_get_last_seq_no@LIBEKMFWEB_1.0 2.15.1
+ ekmf_get_public_key@LIBEKMFWEB_1.0 2.15.1
+ ekmf_get_server_cert_chain@LIBEKMFWEB_1.0 2.15.1
+ ekmf_get_settings@LIBEKMFWEB_1.0 2.15.1
+ ekmf_get_template@LIBEKMFWEB_1.0 2.15.1
+ ekmf_list_keys@LIBEKMFWEB_1.0 2.15.1
+ ekmf_list_templates@LIBEKMFWEB_1.0 2.15.1
+ ekmf_login@LIBEKMFWEB_1.0 2.15.1
+ ekmf_print_certificates@LIBEKMFWEB_1.0 2.15.1
+ ekmf_reencipher_identity_key@LIBEKMFWEB_1.0 2.15.1
+ ekmf_retrieve_key@LIBEKMFWEB_1.0 2.15.1
+ ekmf_set_key_state@LIBEKMFWEB_1.0 2.15.1
+ ekmf_set_key_tags@LIBEKMFWEB_1.0 2.15.1
diff -pruN 2.14.0-2/debian/libekmfweb-dev.install 2.15.1-0ubuntu2/debian/libekmfweb-dev.install
--- 2.14.0-2/debian/libekmfweb-dev.install	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/libekmfweb-dev.install	2020-11-18 13:56:27.000000000 +0000
@@ -0,0 +1,2 @@
+usr/lib/s390x-linux-gnu/libekmfweb.so
+usr/include
diff -pruN 2.14.0-2/debian/modules-load.d/s390-tools.conf 2.15.1-0ubuntu2/debian/modules-load.d/s390-tools.conf
--- 2.14.0-2/debian/modules-load.d/s390-tools.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/modules-load.d/s390-tools.conf	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,2 @@
+# for mon_statd/mon_fsstatd
+monwriter
diff -pruN 2.14.0-2/debian/not-installed 2.15.1-0ubuntu2/debian/not-installed
--- 2.14.0-2/debian/not-installed	2020-08-23 14:48:11.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/not-installed	2020-11-09 15:04:40.000000000 +0000
@@ -1,7 +1,12 @@
+etc/cpuplugd.conf
 etc/iucvterm/ts-audit-systems.conf
 etc/iucvterm/ts-authorization.conf
 etc/iucvterm/ts-shell.conf
 etc/iucvterm/unrestricted.conf
+etc/sysconfig/cpi
+etc/sysconfig/dumpconf
+etc/sysconfig/mon_fsstatd
+etc/sysconfig/mon_procd
 lib/s390-tools/cpictl
 lib/s390-tools/zfcpdump/zfcpdump-initrd
 lib/s390-tools/zipl.conf
@@ -16,13 +21,8 @@ usr/bin/cpacfstats
 usr/bin/dump2tar
 usr/bin/genprotimg
 usr/bin/vmconvert
-usr/bin/zkey
-usr/bin/zkey-cryptsetup
 usr/sbin/cpacfstatsd
-usr/sbin/cpuplugd
 usr/sbin/ip_watcher.pl
-usr/sbin/mon_fsstatd
-usr/sbin/mon_procd
 usr/sbin/start_hsnc.sh
 usr/sbin/xcec-bridge
 usr/share/man/man1/cpacfstats.1
@@ -30,16 +30,10 @@ usr/share/man/man1/dbginfo.sh.1
 usr/share/man/man1/dump2tar.1
 usr/share/man/man1/vmconvert.1
 usr/share/man/man1/zipl-switch-to-blscfg.1
-usr/share/man/man1/zkey-cryptsetup.1
-usr/share/man/man1/zkey.1
 usr/share/man/man4/prandom.4
-usr/share/man/man5/cpuplugd.conf.5
 usr/share/man/man8/cpacfstatsd.8
-usr/share/man/man8/cpuplugd.8
 usr/share/man/man8/dumpconf.8
 usr/share/man/man8/genprotimg.8
-usr/share/man/man8/mon_fsstatd.8
-usr/share/man/man8/mon_procd.8
 usr/share/man/man8/qethqoat.8
 usr/share/man/man8/tape390_crypt.8
 usr/share/man/man8/ttyrun.8
diff -pruN 2.14.0-2/debian/patches/0001-dumpconf-Don-t-run-the-service-in-LXC.patch 2.15.1-0ubuntu2/debian/patches/0001-dumpconf-Don-t-run-the-service-in-LXC.patch
--- 2.14.0-2/debian/patches/0001-dumpconf-Don-t-run-the-service-in-LXC.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/0001-dumpconf-Don-t-run-the-service-in-LXC.patch	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,27 @@
+From 4b03c9249d4f28597b1736f08183c44d3d1c75ff Mon Sep 17 00:00:00 2001
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Wed, 20 May 2020 14:31:16 +0200
+Subject: [PATCH] dumpconf: Don't run the service in LXC
+
+It just fails to start in unprivileged containers
+
+Signed-off-by: Balint Reczey <balint.reczey@canonical.com>
+---
+ systemd/dumpconf.service.in | 1 +
+ 1 file changed, 1 insertion(+)
+
+diff --git a/systemd/dumpconf.service.in b/systemd/dumpconf.service.in
+index 6b1b140..f27dc35 100644
+--- a/systemd/dumpconf.service.in
++++ b/systemd/dumpconf.service.in
+@@ -9,6 +9,7 @@
+ 
+ [Unit]
+ Description=Configure dump on panic for System z
++ConditionVirtualization=!lxc
+ After=network.target
+ 
+ [Service]
+-- 
+2.25.1
+
diff -pruN 2.14.0-2/debian/patches/0001-ziomon-Use-exit-code-0-for-version-and-help.patch 2.15.1-0ubuntu2/debian/patches/0001-ziomon-Use-exit-code-0-for-version-and-help.patch
--- 2.14.0-2/debian/patches/0001-ziomon-Use-exit-code-0-for-version-and-help.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/0001-ziomon-Use-exit-code-0-for-version-and-help.patch	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,134 @@
+From 68787def1dde5fe07ee3ff48ed16500e46c1fd87 Mon Sep 17 00:00:00 2001
+From: Michael Holzheu <holzheu@linux.vnet.ibm.com>
+Date: Tue, 6 Sep 2016 14:26:38 +0200
+Subject: [PATCH] ziomon: Use exit code 0 for --version and --help
+
+Besides of this also unify the exit codes for help in case of wrong
+number of parameters:
+
+ # /usr/sbin/ziomon_util
+ Usage: ziomon_util [-h] [-v] [-V] [-i n] [-s n] [-Q <msgq_path> ...
+ # echo $?
+ 255
+
+ # /usr/sbin/ziomon_mgr
+   Usage: ziomon_util [-h] [-v] [-V] [-i n] [-s n] [-Q <msgq_path> ...
+ # echo $?
+ 0
+
+With this patch we use exit code 1 (EXIT_FAILURE) in this case:
+
+ # ./ziomon_util
+ Usage: ziomon_util [-h] [-v] [-V] [-i n] [-s n] [-Q <msgq_path> ...
+ # echo $?
+ 1
+
+Signed-off-by: Michael Holzheu <holzheu@linux.vnet.ibm.com>
+---
+ ziomon/ziomon_mgr.c           | 6 +++---
+ ziomon/ziomon_util.c          | 6 +++---
+ ziomon/ziorep_traffic.cpp     | 6 +++---
+ ziomon/ziorep_utilization.cpp | 6 +++---
+ 4 files changed, 12 insertions(+), 12 deletions(-)
+
+--- a/ziomon/ziomon_mgr.c
++++ b/ziomon/ziomon_mgr.c
+@@ -304,7 +304,7 @@
+ 
+ 	if (argc <= 1) {
+ 		print_help();
+-		return 1;
++		exit(EXIT_FAILURE);
+ 	}
+ 
+ 	while ((c = getopt_long(argc, argv, "r:Q:q:u:b:z:i:l:o:x:Vhfev",
+@@ -359,7 +359,7 @@
+ 			break;
+ 		case 'h':
+ 			print_help();
+-			return 1;
++			exit(EXIT_SUCCESS);
+ 		case 'e':
+ 			print_bin_struct_sizes();
+ 			return 1;
+@@ -443,7 +443,7 @@
+ 			break;
+ 		case 'v':
+ 			print_version();
+-			return 1;
++			exit(EXIT_SUCCESS);
+ 		default:
+ 			fprintf(stderr, "Try '%s --help' for"
+ 				" more information.\n", toolname);
+--- a/ziomon/ziomon_util.c
++++ b/ziomon/ziomon_util.c
+@@ -1009,7 +1009,7 @@
+ 
+ 	if (argc <= 1) {
+ 		print_help();
+-		return -1;
++		exit(EXIT_FAILURE);
+ 	}
+ 
+ 	/* this is too much, but argc/2 is a reliable upper boundary
+@@ -1080,10 +1080,10 @@
+ 			break;
+ 		case 'v':
+ 			print_version();
+-			return 1;
++			exit(EXIT_SUCCESS);
+ 		case 'h':
+ 			print_help();
+-			return 1;
++			exit(EXIT_SUCCESS);
+ 		default:
+ 			fprintf(stderr, "%s: Try '%s --help' for more"
+ 				" information.\n", toolname, toolname);
+--- a/ziomon/ziorep_traffic.cpp
++++ b/ziomon/ziorep_traffic.cpp
+@@ -148,7 +148,7 @@
+ 
+ 	if (argc < 2) {
+ 		print_help();
+-		return 1;
++		exit(EXIT_FAILURE);
+ 	}
+ 
+ 	assert(sizeof(long long int) == sizeof(__u64));
+@@ -160,10 +160,10 @@
+ 			break;
+ 		case 'h':
+ 			print_help();
+-			return 1;
++			exit(EXIT_SUCCESS);
+ 		case 'v':
+ 			print_version();
+-			return 1;
++			exit(EXIT_SUCCESS);
+ 		case 'b':
+ 			if (get_datetime_val(optarg, &opts->begin))
+ 				return -1;
+--- a/ziomon/ziorep_utilization.cpp
++++ b/ziomon/ziorep_utilization.cpp
+@@ -126,7 +126,7 @@
+ 
+ 	if (argc < 2) {
+ 		print_help();
+-		return 1;
++		exit(EXIT_FAILURE);
+ 	}
+ 
+ 	assert(sizeof(long long int) == sizeof(__u64));
+@@ -138,10 +138,10 @@
+ 			break;
+ 		case 'h':
+ 			print_help();
+-			return 1;
++			exit(EXIT_SUCCESS);
+ 		case 'v':
+ 			print_version();
+-			return 1;
++			exit(EXIT_SUCCESS);
+ 		case 'b':
+ 			if (get_datetime_val(optarg, &opts->begin))
+ 				return -1;
diff -pruN 2.14.0-2/debian/patches/0001-zkey-add-initramfs-hook.patch 2.15.1-0ubuntu2/debian/patches/0001-zkey-add-initramfs-hook.patch
--- 2.14.0-2/debian/patches/0001-zkey-add-initramfs-hook.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/0001-zkey-add-initramfs-hook.patch	2020-11-12 15:10:44.000000000 +0000
@@ -0,0 +1,102 @@
+From 1ae3089c05cbcebd033c7ff21f2f1ef00a0690b4 Mon Sep 17 00:00:00 2001
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Tue, 2 Oct 2018 15:29:09 +0100
+Subject: [PATCH] zkey: add initramfs hook.
+
+Signed-off-by: Dimitri John Ledkov <xnox@ubuntu.com>
+---
+ zkey/Makefile                        |  1 +
+ zkey/initramfs/Makefile              | 21 +++++++++++++
+ zkey/initramfs/hooks/s390-tools-zkey | 45 ++++++++++++++++++++++++++++
+ 3 files changed, 67 insertions(+)
+ create mode 100644 zkey/initramfs/Makefile
+ create mode 100644 zkey/initramfs/hooks/s390-tools-zkey
+
+Index: s390-tools-2.15.1/zkey/Makefile
+===================================================================
+--- s390-tools-2.15.1.orig/zkey/Makefile
++++ s390-tools-2.15.1/zkey/Makefile
+@@ -99,6 +99,7 @@ zkey-cryptsetup: zkey-cryptsetup.o pkey.
+ install-common:
+ 	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
+ 	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
++	$(MAKE) -C initramfs install
+ 
+ install-zkey: zkey
+ 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey $(DESTDIR)$(USRBINDIR)
+Index: s390-tools-2.15.1/zkey/initramfs/Makefile
+===================================================================
+--- /dev/null
++++ s390-tools-2.15.1/zkey/initramfs/Makefile
+@@ -0,0 +1,21 @@
++# Common definitions
++include ../../common.mak
++
++INITRAMFSDIR := /usr/share/initramfs-tools
++HOOKDIR := $(INITRAMFSDIR)/hooks
++INITTOP := $(INITRAMFSDIR)/scripts/init-top
++
++# HAVE_INITRAMFS
++#
++# This install time parameter determines whether the zkey initramfs support is
++# installed (HAVE_INITRAMFS=1) or not (default). When installed, the module
++# performs the following functions when mkinitramfs is run:
++#
++#  - install a hook to include zkey related utilities and zkey repository in
++#    the initramfs
++#
++ifeq ($(HAVE_INITRAMFS),1)
++install:
++	$(INSTALL) -m 755 -d $(DESTDIR)/$(HOOKDIR) $(DESTDIR)/$(INITTOP)
++	$(INSTALL) -m 755 hooks/s390-tools-zkey $(DESTDIR)/$(HOOKDIR)
++endif
+Index: s390-tools-2.15.1/zkey/initramfs/hooks/s390-tools-zkey
+===================================================================
+--- /dev/null
++++ s390-tools-2.15.1/zkey/initramfs/hooks/s390-tools-zkey
+@@ -0,0 +1,45 @@
++#!/bin/sh
++#
++# Copyright IBM Corp. 2016, 2017
++# Copyright Canonical Ltd 2018
++#
++# s390-tools is free software; you can redistribute it and/or modify
++# it under the terms of the MIT license. See LICENSE for details.
++#
++# hooks/s390-tools-zkey
++#   This hook script adds zkey related utilities and zkey repository
++#   in the initramfs
++#
++
++# Needs to run after udev or resulting udev rules could be overwritten
++PREREQ="udev"
++
++prereqs()
++{
++	echo "$PREREQ"
++}
++
++case $1 in
++	prereqs)
++	prereqs
++	exit 0
++	;;
++esac
++
++. /usr/share/initramfs-tools/hook-functions
++
++# Add zcrypt modules
++zdev_modules="pkey paes_s390 zcrypt zcrypt_cex2a zcrypt_cex4 zcrypt_pcixcc"
++
++for x in $zdev_modules ; do
++	manual_add_modules ${x}
++done
++
++# copy utils
++copy_exec /sbin/chzcrypt
++copy_exec /sbin/lszcrypt
++copy_exec /usr/bin/zkey
++copy_exec /usr/bin/zkey-cryptsetup
++
++mkdir -p "${DESTDIR}/etc"
++cp -a /etc/zkey "${DESTDIR}/etc/"
diff -pruN 2.14.0-2/debian/patches/0001-zkey-on-Ubuntu-use-default-benchmarked-Argon2i-with-.patch 2.15.1-0ubuntu2/debian/patches/0001-zkey-on-Ubuntu-use-default-benchmarked-Argon2i-with-.patch
--- 2.14.0-2/debian/patches/0001-zkey-on-Ubuntu-use-default-benchmarked-Argon2i-with-.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/0001-zkey-on-Ubuntu-use-default-benchmarked-Argon2i-with-.patch	2020-11-12 15:10:44.000000000 +0000
@@ -0,0 +1,53 @@
+From bafb0d3ee98301607b6c06e67cc8860edca4185e Mon Sep 17 00:00:00 2001
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Fri, 15 Mar 2019 13:48:34 +0000
+Subject: [PATCH] zkey: on Ubuntu, use default benchmarked Argon2i with LUKS2.
+
+LP: #1820049
+---
+ zkey/keystore.c | 8 +-------
+ zkey/zkey.1     | 9 ---------
+ 2 files changed, 1 insertion(+), 16 deletions(-)
+
+Index: s390-tools-2.15.1/zkey/keystore.c
+===================================================================
+--- s390-tools-2.15.1.orig/zkey/keystore.c
++++ s390-tools-2.15.1/zkey/keystore.c
+@@ -4006,16 +4006,10 @@ static int _keystore_process_cryptsetup(
+ 				printf("%s\n", cmd);
+ 			}
+ 		} else {
+-			/*
+-			 * Use PBKDF2 as key derivation function for LUKS2
+-			 * volumes. LUKS2 uses Argon2i as default, but this
+-			 * might cause out-of-memory errors when multiple LUKS2
+-			 * volumes are opened automatically via /etc/crypttab
+-			 */
+ 			util_asprintf(&cmd,
+ 				      "cryptsetup luksFormat %s%s--type luks2 "
+ 				      "--master-key-file '%s' --key-size %lu "
+-				      "--cipher %s --pbkdf pbkdf2 %s%s%s",
++				      "--cipher %s %s%s%s",
+ 				      info->batch_mode ? "-q " : "",
+ 				      keystore->verbose ? "-v " : "",
+ 				      key_file_name, key_file_size * 8,
+Index: s390-tools-2.15.1/zkey/zkey.1
+===================================================================
+--- s390-tools-2.15.1.orig/zkey/zkey.1
++++ s390-tools-2.15.1/zkey/zkey.1
+@@ -722,15 +722,6 @@ option to generate \fBcryptsetup luksFor
+ type, this is the default. If specified for the plain volume type, then no
+ command is generated.
+ .P
+-For LUKS2 volumes, the generated \fBcryptsetup luksFormat\fP contains
+-option \fB\-\-pbkdf pbkdf2\fP to set \fBPBKDF2\fP as password based key
+-derivation function. LUKS2 volumes typically default to \fBArgon2i\fP as
+-password based key derivation function, but this might cause out-of-memory
+-errors when multiple encrypted volumes are unlocked automatically at boot
+-through /etc/crypttab. Because PAES uses secure AES keys as volume keys, the
+-security of the key derivation function used to encrypt the volume key in the
+-LUKS key slots is of less relevance. 
+-.P
+ For LUKS2 volumes, a passphrase is required. You are prompted for the
+ passphrase when running the generated commands, unless option
+ .B \-\-key\-file
diff -pruN 2.14.0-2/debian/patches/disable.patch 2.15.1-0ubuntu2/debian/patches/disable.patch
--- 2.14.0-2/debian/patches/disable.patch	2020-08-23 12:19:12.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/disable.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,13 +0,0 @@
-Index: s390-tools-2.14.0/Makefile
-===================================================================
---- s390-tools-2.14.0.orig/Makefile
-+++ s390-tools-2.14.0/Makefile
-@@ -5,7 +5,7 @@ include common.mak
- 
- LIB_DIRS = libvtoc libutil libzds libdasd libvmdump libccw libvmcp
- TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
--	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
-+	   tape390 qetharp ip_watcher qethconf scripts zconf \
- 	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
- 	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
- 	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
diff -pruN 2.14.0-2/debian/patches/install-iucvterm.patch 2.15.1-0ubuntu2/debian/patches/install-iucvterm.patch
--- 2.14.0-2/debian/patches/install-iucvterm.patch	2018-01-14 14:36:29.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/install-iucvterm.patch	2020-11-09 15:04:40.000000000 +0000
@@ -1,8 +1,6 @@
-Index: s390-tools-2.2.0/iucvterm/src/Makefile
-===================================================================
---- s390-tools-2.2.0.orig/iucvterm/src/Makefile
-+++ s390-tools-2.2.0/iucvterm/src/Makefile
-@@ -10,8 +10,8 @@ ALL_CPPFLAGS += -I../include
+--- a/iucvterm/src/Makefile
++++ b/iucvterm/src/Makefile
+@@ -10,8 +10,8 @@
  ALL_CPPFLAGS += -DUSE_NLS -DGETTEXT_TEXTDOMAIN=\"$(GETTEXT_TEXTDOMAIN)\"
  #ALL_CPPFLAGS += -D__DEBUG__
  
@@ -13,10 +11,8 @@ Index: s390-tools-2.2.0/iucvterm/src/Mak
  
  all: $(PROGRAMS) $(SYSTOOLS)
  check:
-Index: s390-tools-2.2.0/iucvterm/doc/Makefile
-===================================================================
---- s390-tools-2.2.0.orig/iucvterm/doc/Makefile
-+++ s390-tools-2.2.0/iucvterm/doc/Makefile
+--- a/iucvterm/doc/Makefile
++++ b/iucvterm/doc/Makefile
 @@ -2,7 +2,10 @@
  
  include ../../common.mak
@@ -29,7 +25,7 @@ Index: s390-tools-2.2.0/iucvterm/doc/Mak
  
  all:
  
-@@ -17,6 +20,7 @@ install-man: $(MANS)
+@@ -17,6 +20,7 @@
  	done
  
  clean:
@@ -37,10 +33,8 @@ Index: s390-tools-2.2.0/iucvterm/doc/Mak
  
  pdf: $(MANS)
  	for man in $(MANS); do \
-Index: s390-tools-2.2.0/iucvterm/doc/iucvtty.1
-===================================================================
---- s390-tools-2.2.0.orig/iucvterm/doc/iucvtty.1
-+++ s390-tools-2.2.0/iucvterm/doc/iucvtty.1
+--- a/iucvterm/doc/iucvtty.1
++++ b/iucvterm/doc/iucvtty.1
 @@ -1,11 +1,11 @@
 -.\" iucvtty.1
 +.\" iucvtty.8
@@ -55,7 +49,7 @@ Index: s390-tools-2.2.0/iucvterm/doc/iuc
  .
  .ds t \fBiucvtty\fP
  .ds i \fBiucvconn\fP
-@@ -139,7 +139,7 @@ with \fB/bin/login\fP could be:
+@@ -139,7 +139,7 @@
  .ft CW
  .in +0.25in
  .nf
@@ -64,7 +58,7 @@ Index: s390-tools-2.2.0/iucvterm/doc/iuc
  .fi
  .in -0.25in
  .ft
-@@ -150,7 +150,7 @@ with \fB/sbin/sulogin\fP in single user
+@@ -150,7 +150,7 @@
  .ft CW
  .in +0.25in
  .nf
diff -pruN 2.14.0-2/debian/patches/series 2.15.1-0ubuntu2/debian/patches/series
--- 2.14.0-2/debian/patches/series	2018-02-04 16:28:02.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/series	2020-11-18 13:38:03.000000000 +0000
@@ -1,6 +1,9 @@
-udevadm-path.patch
 install-iucvterm.patch
 bashism.patch
 zipl-optional.patch
-disable.patch
 sg3-utils.patch
+0001-ziomon-Use-exit-code-0-for-version-and-help.patch
+0001-zkey-add-initramfs-hook.patch
+0001-zkey-on-Ubuntu-use-default-benchmarked-Argon2i-with-.patch
+0001-dumpconf-Don-t-run-the-service-in-LXC.patch
+update-install-paths.patch
diff -pruN 2.14.0-2/debian/patches/sg3-utils.patch 2.15.1-0ubuntu2/debian/patches/sg3-utils.patch
--- 2.14.0-2/debian/patches/sg3-utils.patch	2020-08-23 12:19:14.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/sg3-utils.patch	2020-11-09 15:04:40.000000000 +0000
@@ -4,11 +4,11 @@ Forwarded: no
 Last-Update: 2015-12-08
 ---
 This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
-Index: s390-tools-2.14.0/zconf/lsluns
+Index: s390-tools-1.32.0/zconf/lsluns
 ===================================================================
---- s390-tools-2.14.0.orig/zconf/lsluns
-+++ s390-tools-2.14.0/zconf/lsluns
-@@ -342,7 +342,7 @@ push @port, map { @{$res_hash{$_}} } key
+--- s390-tools-1.32.0.orig/zconf/lsluns
++++ s390-tools-1.32.0/zconf/lsluns
+@@ -321,7 +321,7 @@ push @port, map { @{$res_hash{$_}} } key
  
  # checking for helper progs
  
diff -pruN 2.14.0-2/debian/patches/udevadm-path.patch 2.15.1-0ubuntu2/debian/patches/udevadm-path.patch
--- 2.14.0-2/debian/patches/udevadm-path.patch	2020-08-23 12:12:19.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/udevadm-path.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,13 +0,0 @@
-Index: s390-tools-2.14.0/etc/init.d/mon_statd
-===================================================================
---- s390-tools-2.14.0.orig/etc/init.d/mon_statd
-+++ s390-tools-2.14.0/etc/init.d/mon_statd
-@@ -31,7 +31,7 @@ if [ -f $CONFIG_FILE ]; then
- 	. $CONFIG_FILE
- fi
- 
--UDEVSETTLE=/usr/bin/udevadm
-+UDEVSETTLE=/bin/udevadm
- if [ ! -e $UDEVSETTLE ]
- then
- 	UDEVSETTLE=/sbin/udevsettle
diff -pruN 2.14.0-2/debian/patches/update-install-paths.patch 2.15.1-0ubuntu2/debian/patches/update-install-paths.patch
--- 2.14.0-2/debian/patches/update-install-paths.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/update-install-paths.patch	2020-11-18 13:38:15.000000000 +0000
@@ -0,0 +1,44 @@
+Description: update install paths
+Author: Dimitri John Ledkov <xnox@ubuntu.com>
+
+--- s390-tools-2.15.1.orig/common.mak
++++ s390-tools-2.15.1/common.mak
+@@ -163,7 +163,7 @@ USRSBINDIR      = $(INSTALLDIR)/usr/sbin
+ USRBINDIR       = $(INSTALLDIR)/usr/bin
+ BINDIR          = $(INSTALLDIR)/sbin
+ LIBDIR          = $(INSTALLDIR)/lib
+-USRLIB64DIR     = $(INSTALLDIR)/usr/lib64
++USRLIB64DIR     = $(INSTALLDIR)/usr/lib/s390x-linux-gnu
+ SYSCONFDIR      = $(INSTALLDIR)/etc
+ MANDIR          = $(INSTALLDIR)/usr/share/man
+ VARDIR          = $(INSTALLDIR)/var
+--- s390-tools-2.15.1.orig/zkey/ekmfweb/Makefile
++++ s390-tools-2.15.1/zkey/ekmfweb/Makefile
+@@ -46,11 +46,11 @@ libekmfweb.dep:
+ install: all install-libekmfweb.dep zkey-ekmfweb.so
+ 	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
+ 	$(INSTALL) -m 644 -c zkey-ekmfweb.1 $(DESTDIR)$(MANDIR)/man1
+-	$(INSTALL) -d -m 755 $(DESTDIR)$(USRLIB64DIR)
+-	$(INSTALL) -d -m 755 $(DESTDIR)$(USRLIB64DIR)/zkey
+-	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T zkey-ekmfweb.so $(DESTDIR)$(USRLIB64DIR)/zkey/zkey-ekmfweb.so
++	$(INSTALL) -d -m 755 $(DESTDIR)/usr/libexec
++	$(INSTALL) -d -m 755 $(DESTDIR)/usr/libexec/zkey
++	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T zkey-ekmfweb.so $(DESTDIR)/usr/libexec/zkey/zkey-ekmfweb.so
+ 
+ clean:
+ 	rm -f *.o zkey-ekmfweb.so install-libekmfweb.dep libekmfweb.dep
+ 
+-.PHONY: all install clean
+\ No newline at end of file
++.PHONY: all install clean
+--- s390-tools-2.15.1.orig/zkey/kms.c
++++ s390-tools-2.15.1/zkey/kms.c
+@@ -40,7 +40,7 @@
+ 
+ #define ENVVAR_ZKEY_KMS_PLUGINS		"ZKEY_KMS_PLUGINS"
+ #define DEFAULT_KMS_PLUGINS		"/etc/zkey/kms-plugins.conf"
+-#define KMS_PLUGIN_LOCATION		"/usr/lib64/zkey"
++#define KMS_PLUGIN_LOCATION		"/usr/libexec/zkey"
+ 
+ #define KMS_CONFIG_FILE			"kms.conf"
+ #define KMS_CONFIG_PROP_KMS		"kms"
diff -pruN 2.14.0-2/debian/patches/zipl-optional.patch 2.15.1-0ubuntu2/debian/patches/zipl-optional.patch
--- 2.14.0-2/debian/patches/zipl-optional.patch	2020-08-23 12:19:07.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/patches/zipl-optional.patch	2020-11-09 15:04:40.000000000 +0000
@@ -1,8 +1,8 @@
-Index: s390-tools-2.14.0/zipl/src/bootmap.c
+Index: s390-tools-2.8.0/zipl/src/bootmap.c
 ===================================================================
---- s390-tools-2.14.0.orig/zipl/src/bootmap.c
-+++ s390-tools-2.14.0/zipl/src/bootmap.c
-@@ -1006,6 +1006,12 @@ build_program_table(int fd, struct job_d
+--- s390-tools-2.8.0.orig/zipl/src/bootmap.c
++++ s390-tools-2.8.0/zipl/src/bootmap.c
+@@ -998,6 +998,12 @@ build_program_table(int fd, struct job_d
  		for (i=0; i < job->data.menu.num; i++) {
  			switch (job->data.menu.entry[i].id) {
  			case job_ipl:
@@ -15,10 +15,10 @@ Index: s390-tools-2.14.0/zipl/src/bootma
  				printf("Adding #%d: IPL section '%s'%s",
  				       job->data.menu.entry[i].pos,
  				       job->data.menu.entry[i].name,
-Index: s390-tools-2.14.0/zipl/src/scan.c
+Index: s390-tools-2.8.0/zipl/src/scan.c
 ===================================================================
---- s390-tools-2.14.0.orig/zipl/src/scan.c
-+++ s390-tools-2.14.0/zipl/src/scan.c
+--- s390-tools-2.8.0.orig/zipl/src/scan.c
++++ s390-tools-2.8.0/zipl/src/scan.c
 @@ -45,45 +45,45 @@ enum scan_key_state scan_key_table[SCAN_
   *	 ult  to   tofs e    mete file isk  ent  et   pt   out  ultm      dump
   *			     rs                                 enu
@@ -85,10 +85,10 @@ Index: s390-tools-2.14.0/zipl/src/scan.c
  };
  
  /* List of keywords that are used without an assignment */
-Index: s390-tools-2.14.0/zipl/include/job.h
+Index: s390-tools-2.8.0/zipl/include/job.h
 ===================================================================
---- s390-tools-2.14.0.orig/zipl/include/job.h
-+++ s390-tools-2.14.0/zipl/include/job.h
+--- s390-tools-2.8.0.orig/zipl/include/job.h
++++ s390-tools-2.8.0/zipl/include/job.h
 @@ -13,6 +13,8 @@
  #ifndef JOB_H
  #define JOB_H
@@ -107,11 +107,11 @@ Index: s390-tools-2.14.0/zipl/include/jo
  };
  
  struct job_segment_data {
-Index: s390-tools-2.14.0/zipl/src/job.c
+Index: s390-tools-2.8.0/zipl/src/job.c
 ===================================================================
---- s390-tools-2.14.0.orig/zipl/src/job.c
-+++ s390-tools-2.14.0/zipl/src/job.c
-@@ -825,14 +825,20 @@ out_free:
+--- s390-tools-2.8.0.orig/zipl/src/job.c
++++ s390-tools-2.8.0/zipl/src/job.c
+@@ -800,14 +800,20 @@ out_free:
  
  
  static int
@@ -134,7 +134,7 @@ Index: s390-tools-2.14.0/zipl/src/job.c
  				error_text("Image file '%s'", ipl->image);
  			} else {
  				error_text("Image file '%s' in section '%s'",
-@@ -844,7 +850,13 @@ check_job_ipl_data(struct job_ipl_data *
+@@ -819,7 +825,13 @@ check_job_ipl_data(struct job_ipl_data *
  	if (ipl->ramdisk != NULL) {
  		rc = misc_check_readable_file(ipl->ramdisk);
  		if (rc) {
@@ -149,7 +149,7 @@ Index: s390-tools-2.14.0/zipl/src/job.c
  				error_text("Ramdisk file '%s'", ipl->ramdisk);
  			} else {
  				error_text("Ramdisk file '%s' in section '%s'",
-@@ -941,9 +953,13 @@ check_job_menu_data(struct job_menu_data
+@@ -916,9 +928,13 @@ check_job_menu_data(struct job_menu_data
  		switch (menu->entry[i].id) {
  		case job_ipl:
  			rc = check_job_ipl_data(&menu->entry[i].data.ipl,
@@ -164,7 +164,7 @@ Index: s390-tools-2.14.0/zipl/src/job.c
  			break;
  		case job_print_usage:
  		case job_print_version:
-@@ -1107,7 +1123,7 @@ check_job_data(struct job_data* job)
+@@ -1067,7 +1083,7 @@ check_job_data(struct job_data* job)
  		rc = 0;
  		break;
  	case job_ipl:
@@ -173,7 +173,7 @@ Index: s390-tools-2.14.0/zipl/src/job.c
  		break;
  	case job_menu:
  		rc = check_job_menu_data(&job->data.menu);
-@@ -1399,6 +1415,8 @@ get_job_from_section_data(char* data[],
+@@ -1378,6 +1394,8 @@ get_job_from_section_data(char* data[],
  			if (rc)
  				return rc;
  		}
@@ -182,11 +182,11 @@ Index: s390-tools-2.14.0/zipl/src/job.c
  		break;
  	case section_ipl_tape:
  		/* Tape IPL job */
-Index: s390-tools-2.14.0/zipl/man/zipl.conf.5.in
+Index: s390-tools-2.8.0/zipl/man/zipl.conf.5.in
 ===================================================================
---- s390-tools-2.14.0.orig/zipl/man/zipl.conf.5.in
-+++ s390-tools-2.14.0/zipl/man/zipl.conf.5.in
-@@ -447,6 +447,22 @@ This option cannot be used together with
+--- s390-tools-2.8.0.orig/zipl/man/zipl.conf.5.in
++++ s390-tools-2.8.0/zipl/man/zipl.conf.5.in
+@@ -436,6 +436,22 @@ This option cannot be used together with
  .BR 'segment' .
  .PP
  
@@ -209,10 +209,10 @@ Index: s390-tools-2.14.0/zipl/man/zipl.c
  .B parameters
  =
  .I kernel\-parameters
-Index: s390-tools-2.14.0/zipl/include/scan.h
+Index: s390-tools-2.8.0/zipl/include/scan.h
 ===================================================================
---- s390-tools-2.14.0.orig/zipl/include/scan.h
-+++ s390-tools-2.14.0/zipl/include/scan.h
+--- s390-tools-2.8.0.orig/zipl/include/scan.h
++++ s390-tools-2.8.0/zipl/include/scan.h
 @@ -16,7 +16,7 @@
  
  
diff -pruN 2.14.0-2/debian/rules 2.15.1-0ubuntu2/debian/rules
--- 2.14.0-2/debian/rules	2020-08-23 13:16:15.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/rules	2020-11-12 15:02:14.000000000 +0000
@@ -1,22 +1,54 @@
 #!/usr/bin/make -f
 
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
-export DEB_CPPFLAGS_LDFLAGS_APPEND = -rdynamic
+export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/default.mk
+
+options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system
+
+# Enable signing in Launchpad Only for now
+SIGN_SIPL=
+ifneq (,$(wildcard /CurrentlyBuilding))
+SIGN_SIPL=yes
+endif
+SIGN_SIPL=yes
 
 %:
 	dh $@
 
+override_dh_install:
+	# no dracut
+	rm -f debian/tmp/lib/s390-tools/zdev-root-update
+	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump-initrd
+	dh_install -ps390-tools-cpuplugd
+	dh_install -ps390-tools-statd
+	dh_install -ps390-tools-osasnmpd
+	dh_install -ps390-tools-zkey -ps390-tools-zkey-udeb
+	dh_install $(if $(SIGN_SIPL),-Xstage3.bin) -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey
+	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))') >> debian/s390-tools.substvars
+
 override_dh_auto_clean:
 	rm -f zipl/boot/.*.d
-	dh_auto_clean
+	dh_auto_clean -- $(options)
 
 override_dh_auto_build:
-	make V=1
+	dh_auto_build -- $(options)
 
 override_dh_auto_install:
-	make install DESTDIR=$(CURDIR)/debian/tmp
-	dh_install
+	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)
 
-override_dh_fixperms:
-	chmod 0644 $(CURDIR)/debian/s390-tools/lib/s390-tools/stage3.bin
-	dh_fixperms
+signing=debian/s390-tools-$(DEB_VERSION)-signing/
+signingv=$(signing)/$(DEB_VERSION)
+signing_tar=$(DEB_SOURCE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).tar.gz
+override_dh_builddeb:
+	dh_builddeb
+	mkdir -p $(signingv)/control
+	echo 'tarball' >$(signingv)/control/options
+	cp debian/tmp/lib/s390-tools/stage3.bin $(signingv)/stage3.bin.sipl
+	tar -C $(signing) -czvf $(CURDIR)/../$(signing_tar) .
+	dpkg-distaddfile $(signing_tar) raw-signing -
+override_dh_clean:
+	dh_clean
+	rm -rf $(signing)
diff -pruN 2.14.0-2/debian/s390-cpi-vars 2.15.1-0ubuntu2/debian/s390-cpi-vars
--- 2.14.0-2/debian/s390-cpi-vars	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-cpi-vars	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,12 @@
+#!/bin/sh
+set -e
+# safeguard, against wiping bits
+if ! grep -q '^0x0*$' /sys/firmware/cpi/system_level; then
+	exit 0
+fi
+. /etc/os-release
+echo "$NAME" >/sys/firmware/cpi/system_name
+echo "LINUX" >/sys/firmware/cpi/system_type
+printf "0x%02x%02x%02x" $(uname -r | sed 's/-.*//;s/\./ /g') >/sys/firmware/cpi/system_level
+echo "$VERSION" | sed 's/ .*//;s/\./ /g' >/sys/firmware/cpi/sysplex_name
+echo 1 >/sys/firmware/cpi/set
diff -pruN 2.14.0-2/debian/s390-tools-cpuplugd.install 2.15.1-0ubuntu2/debian/s390-tools-cpuplugd.install
--- 2.14.0-2/debian/s390-tools-cpuplugd.install	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-cpuplugd.install	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,4 @@
+etc/cpuplugd.conf
+usr/sbin/cpuplugd
+usr/share/man/man*/cpuplugd*
+lib/systemd/system/cpuplugd.service
diff -pruN 2.14.0-2/debian/s390-tools.install 2.15.1-0ubuntu2/debian/s390-tools.install
--- 2.14.0-2/debian/s390-tools.install	2020-08-23 14:48:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools.install	2020-11-09 15:04:40.000000000 +0000
@@ -1,165 +1,33 @@
-# dasdfmt
-/sbin/dasdfmt
-/usr/share/man/man8/dasdfmt.8
-
-# dasdinfo
-/sbin/dasdinfo
-/usr/share/man/man8/dasdinfo.8
-
-# dasdview
-/sbin/dasdview
-/usr/share/man/man8/dasdview.8
-
-# dasdstat
-/sbin/dasdstat
-/usr/share/man/man8/dasdstat.8
-
-# fdasd
-/sbin/fdasd
-/usr/share/man/man8/fdasd.8
-
-# ipl_tools
-/usr/sbin/chreipl
-/usr/sbin/lsreipl
-/usr/sbin/chshut
-/usr/sbin/lsshut
-/lib/s390-tools/chreipl_helper.device-mapper
-/usr/share/man/man8/chreipl.8
-/usr/share/man/man8/lsreipl.8
-/usr/share/man/man8/chshut.8
-/usr/share/man/man8/lsshut.8
-
-# iucvterm
-/usr/bin/iucvconn
-/usr/share/man/man1/iucvconn.1
-/sbin/iucvtty
-/usr/share/man/man8/iucvtty.8
-/usr/sbin/lsiucvallow
-/usr/sbin/chiucvallow
-/usr/share/man/man8/chiucvallow.8
-/usr/share/man/man7/af_iucv.7
-/usr/share/man/man9/hvc_iucv.9
-/usr/bin/ts-shell
-/usr/share/man/man1/ts-shell.1
-
-# CPU-measurement facility
-/sbin/lscpumf /usr/bin
-/usr/share/man/man1/lscpumf.1
-/sbin/chcpumf /usr/sbin
-/usr/share/man/man8/chcpumf.8
-
-# qetharp
-/sbin/qetharp
-/usr/share/man/man8/qetharp.8
-
-# qethconf
-/sbin/qethconf
-/usr/share/man/man8/qethconf.8
-
-# znetconf
-/sbin/znetconf
-/lib/s390-tools/lsznet.raw
-/lib/s390-tools/znetcontrolunits
-/usr/share/man/man8/znetconf.8
-
-# lsluns
-/usr/sbin/lsluns
-/usr/share/man/man8/lsluns.8
-
-# channel path management
-/sbin/lschp
-/usr/share/man/man8/lschp.8
-/sbin/chchp
-/usr/share/man/man8/chchp.8
-
-# tape390
-/sbin/tape390_display
-/usr/share/man/man8/tape390_display.8
-
-# tunedasd
-/sbin/tunedasd
-/usr/share/man/man8/tunedasd.8
-
-# vmcp
-/sbin/vmcp
-/usr/share/man/man8/vmcp.8
-
-# vmur
-/usr/sbin/vmur
-/usr/share/man/man8/vmur.8
-
-# zconf
-/sbin/chccwdev
-/usr/share/man/man8/chccwdev.8
-/sbin/cio_ignore
-/usr/share/man/man8/cio_ignore.8
-/sbin/chzcrypt
-/usr/share/man/man8/chzcrypt.8
-/sbin/lscss
-/usr/share/man/man8/lscss.8
-/sbin/lsdasd
-/usr/share/man/man8/lsdasd.8
-/sbin/lsqeth
-/usr/share/man/man8/lsqeth.8
-/sbin/lstape
-/usr/share/man/man8/lstape.8
-/sbin/lszcrypt
-/usr/share/man/man8/lszcrypt.8
-/sbin/lszfcp
-/usr/share/man/man8/lszfcp.8
-/sbin/lsscm
-/usr/share/man/man8/lsscm.8
-/sbin/zcryptctl
-/usr/share/man/man8/zcryptctl.8
-/sbin/zcryptstats
-/usr/share/man/man8/zcryptstats.8
-
-# zdev
-/sbin/chzdev
-/usr/share/man/man8/chzdev.8
-/sbin/lszdev
-/usr/share/man/man8/lszdev.8
-
-# zdump
-/sbin/zgetdump
-/usr/share/man/man8/zgetdump.8
-
-# zipl
-/sbin/zipl
-/lib/s390-tools/zipl_helper.device-mapper
-/lib/s390-tools/stage3.bin
-/usr/share/man/man5/zipl.conf.5
-/usr/share/man/man8/zipl.8
-
-# hyptop
-/usr/sbin/hyptop
-/usr/share/man/man8/hyptop.8
-
-# cmsfs-fuse
-/usr/bin/cmsfs-fuse
-/usr/share/man/man1/cmsfs-fuse.1
-/etc/cmsfs-fuse/filetypes.conf
-
-# HMC removable media access
-/usr/bin/hmcdrvfs
-/usr/share/man/man1/hmcdrvfs.1
-/usr/sbin/lshmc
-/usr/share/man/man8/lshmc.8
-
-# zdsfs
-/usr/bin/zdsfs
-/usr/share/man/man1/zdsfs.1
+# tools
+sbin/
+usr/bin/
+usr/sbin/
+usr/share/man/
+lib/
+usr/share/s390-tools
 
 # kernel stuff
-../kernel/zz-zipl /etc/initramfs/post-update.d
-../kernel/zz-zipl /etc/kernel/postinst.d
-../kernel/zz-zipl /etc/kernel/postrm.d
+debian/kernel/zz-zipl /etc/initramfs/post-update.d
+debian/kernel/zz-zipl /etc/kernel/postinst.d
+debian/kernel/zz-zipl /etc/kernel/postrm.d
 
 # udev rules
-../../etc/udev/rules.d/60-readahead.rules /lib/udev/rules.d
-../../etc/udev/rules.d/59-dasd.rules /lib/udev/rules.d
-../../etc/udev/rules.d/40-z90crypt.rules /lib/udev/rules.d
-
-# debugging
-/sbin/zfcpdbf
-/usr/share/man/man1/zfcpdbf.1
+etc/udev/rules.d/*.rules /lib/udev/rules.d
+
+# good configs (no sysconfig, no init.d)
+
+etc/cmsfs-fuse/
+etc/iucvterm/
+
+# dumpconf
+etc/sysconfig/dumpconf
+etc/init.d/dumpconf
+
+# cpl
+etc/sysconfig/cpi
+
+# update-initramfs -u integration
+debian/zdev-root-update /lib/s390-tools/
+debian/s390-cpi-vars /lib/systemd/system-generators
+usr/share/initramfs-tools/
+usr/lib/dracut/
diff -pruN 2.14.0-2/debian/s390-tools-osasnmpd.install 2.15.1-0ubuntu2/debian/s390-tools-osasnmpd.install
--- 2.14.0-2/debian/s390-tools-osasnmpd.install	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-osasnmpd.install	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,3 @@
+usr/sbin/osasnmpd
+usr/share/man/man*/osasnmpd*
+etc/udev/rules.d/57-osasnmpd.rules /lib/udev/rules.d
diff -pruN 2.14.0-2/debian/s390-tools.postinst 2.15.1-0ubuntu2/debian/s390-tools.postinst
--- 2.14.0-2/debian/s390-tools.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools.postinst	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,33 @@
+#!/bin/sh
+set -e
+
+if [ "$1" = configure ]; then
+    if dpkg --compare-versions "$2" lt-nl 1.34.0-0ubuntu2; then
+	sed '/^parameters/s/$/ crashkernel=196M/' -i /etc/zipl.conf || true
+    elif dpkg --compare-versions "$2" lt-nl 1.34.0-0ubuntu5; then
+	sed '/^parameters/s/crashkernel=128M/crashkernel=196M/' -i /etc/zipl.conf || true
+    fi
+    if ! getent group cpacfstats >/dev/null; then
+	addgroup --system cpacfstats
+    fi
+    # Add each sudo user to the cpacfstats group
+    for u in $(getent group sudo | sed -e "s/^.*://" -e "s/,/ /g"); do
+	adduser "$u" cpacfstats >/dev/null || true
+    done
+    if ! getent group ts-shell >/dev/null; then
+	addgroup --system ts-shell
+    fi
+    chown root:ts-shell /etc/iucvterm/*.conf
+    chmod 0640 /etc/iucvterm/*.conf
+    if dpkg --compare-versions "$2" lt-nl 1.34.0-0ubuntu10; then
+	rmdir /3770 || :
+    fi
+    mkdir -p /var/log/ts-shell
+    chmod 3770 /var/log/ts-shell
+    chgrp -R ts-shell /var/log/ts-shell >/dev/null 2>&1 || true
+    chmod 0660 /var/log/ts-shell/* >/dev/null 2>&1 || true
+fi
+
+#DEBHELPER#
+
+exit 0
diff -pruN 2.14.0-2/debian/s390-tools-statd.install 2.15.1-0ubuntu2/debian/s390-tools-statd.install
--- 2.14.0-2/debian/s390-tools-statd.install	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-statd.install	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,10 @@
+# extra modules
+debian/modules-load.d /usr/lib/
+
+# extra units
+debian/system/* /lib/systemd/system/
+
+usr/sbin/mon_procd
+usr/sbin/mon_fsstatd
+usr/share/man/man*/mon_procd*
+usr/share/man/man*/mon_fsstatd*
diff -pruN 2.14.0-2/debian/s390-tools-statd.postinst 2.15.1-0ubuntu2/debian/s390-tools-statd.postinst
--- 2.14.0-2/debian/s390-tools-statd.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-statd.postinst	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,11 @@
+#!/bin/sh
+set -e
+
+if [ "$1" = configure ]; then
+    /lib/systemd/systemd-modules-load /usr/lib/modules-load.d/s390-tools.conf || true
+fi
+
+#DEBHELPER#
+
+exit 0
+	     
diff -pruN 2.14.0-2/debian/s390-tools-udeb.install 2.15.1-0ubuntu2/debian/s390-tools-udeb.install
--- 2.14.0-2/debian/s390-tools-udeb.install	2016-12-10 09:26:01.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-udeb.install	2020-11-09 15:04:40.000000000 +0000
@@ -1,2 +1,4 @@
 sbin/dasdfmt
 sbin/fdasd
+sbin/chzdev
+sbin/lszdev
diff -pruN 2.14.0-2/debian/s390-tools-zkey.dirs 2.15.1-0ubuntu2/debian/s390-tools-zkey.dirs
--- 2.14.0-2/debian/s390-tools-zkey.dirs	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-zkey.dirs	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,2 @@
+/etc/zkey
+/etc/zkey/repository
diff -pruN 2.14.0-2/debian/s390-tools-zkey.install 2.15.1-0ubuntu2/debian/s390-tools-zkey.install
--- 2.14.0-2/debian/s390-tools-zkey.install	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-zkey.install	2020-11-18 14:03:19.000000000 +0000
@@ -0,0 +1,5 @@
+usr/bin/zkey*
+usr/share/man/man*/zkey*
+usr/share/initramfs-tools/hooks/s390-tools-zkey
+etc/zkey/kms-plugins.conf
+usr/libexec/zkey/zkey-ekmfweb.so
diff -pruN 2.14.0-2/debian/s390-tools-zkey.postinst 2.15.1-0ubuntu2/debian/s390-tools-zkey.postinst
--- 2.14.0-2/debian/s390-tools-zkey.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-zkey.postinst	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,14 @@
+#!/bin/sh
+set -e
+
+if [ "$1" = configure ]; then
+    if ! getent group zkeyadm >/dev/null; then
+	addgroup --system zkeyadm
+    fi
+    chown root:zkeyadm /etc/zkey /etc/zkey/repository
+    chmod 0770 /etc/zkey /etc/zkey/repository
+fi
+
+#DEBHELPER#
+
+exit 0
diff -pruN 2.14.0-2/debian/s390-tools-zkey-udeb.dirs 2.15.1-0ubuntu2/debian/s390-tools-zkey-udeb.dirs
--- 2.14.0-2/debian/s390-tools-zkey-udeb.dirs	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-zkey-udeb.dirs	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,2 @@
+/etc/zkey
+/etc/zkey/repository
diff -pruN 2.14.0-2/debian/s390-tools-zkey-udeb.install 2.15.1-0ubuntu2/debian/s390-tools-zkey-udeb.install
--- 2.14.0-2/debian/s390-tools-zkey-udeb.install	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/s390-tools-zkey-udeb.install	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,2 @@
+usr/bin/zkey
+usr/bin/zkey-cryptsetup
diff -pruN 2.14.0-2/debian/system/mon_fsstatd.service 2.15.1-0ubuntu2/debian/system/mon_fsstatd.service
--- 2.14.0-2/debian/system/mon_fsstatd.service	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/system/mon_fsstatd.service	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,10 @@
+[Unit]
+Description=mon_fsstatd service for Linux on z Systems
+Documentation=man:mon_fsstatd(8)
+ConditionVirtualization=zvm
+
+[Service]
+ExecStart=/usr/sbin/mon_fsstatd -a
+
+[Install]
+WantedBy=multi-user.target
diff -pruN 2.14.0-2/debian/system/mon_procd.service 2.15.1-0ubuntu2/debian/system/mon_procd.service
--- 2.14.0-2/debian/system/mon_procd.service	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/system/mon_procd.service	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,10 @@
+[Unit]
+Description=mon_procd service for Linux on z Systems
+Documentation=man:mon_procd(8)
+ConditionVirtualization=zvm
+
+[Service]
+ExecStart=/usr/sbin/mon_procd -a
+
+[Install]
+WantedBy=multi-user.target
diff -pruN 2.14.0-2/debian/watch 2.15.1-0ubuntu2/debian/watch
--- 2.14.0-2/debian/watch	2020-08-23 13:20:23.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/watch	2020-11-09 15:04:40.000000000 +0000
@@ -1,3 +1,4 @@
 version=4
-opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/s390-tools-$1\.tar\.gz/ \
-  https://github.com/ibm-s390-tools/s390-tools/tags .*/v?(\d\S+)\.tar\.gz
+opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%s390-tools-$1.tar.gz%" \
+     https://github.com/ibm-s390-tools/s390-tools/tags \
+     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
diff -pruN 2.14.0-2/debian/zdev-root-update 2.15.1-0ubuntu2/debian/zdev-root-update
--- 2.14.0-2/debian/zdev-root-update	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/zdev-root-update	2020-11-09 15:04:40.000000000 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+exec update-initramfs -u
diff -pruN 2.14.0-2/debian/ziomon.install 2.15.1-0ubuntu2/debian/ziomon.install
--- 2.14.0-2/debian/ziomon.install	2018-02-04 18:24:02.000000000 +0000
+++ 2.15.1-0ubuntu2/debian/ziomon.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-usr/sbin/ziomon*
-usr/sbin/ziorep*
-usr/share/man/man*/ziomon*
-usr/share/man/man*/ziorep*
diff -pruN 2.14.0-2/etc/init.d/dumpconf 2.15.1-0ubuntu2/etc/init.d/dumpconf
--- 2.14.0-2/etc/init.d/dumpconf	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/etc/init.d/dumpconf	2020-10-28 14:31:59.000000000 +0000
@@ -225,7 +225,7 @@ function CheckDeviceString() {
 	fi
 }
 
-setup_device()
+setup_ccw_device()
 {
 	DEV="$(CheckDeviceString $DEVICE)"
 	if [ "$DEV" != "" ]; then
@@ -235,27 +235,37 @@ setup_device()
 		pr_error "ERROR: Invalid DEVICE '$DEVICE'." $ERRMSG
 		return
 	fi
-	if [ $2 == "fcp" ]; then
-		echo $WWPN > $1/fcp/wwpn 2>/dev/null || RETVAL=1
-		if [ $RETVAL -eq 1 ]; then
-			pr_error "ERROR: Invalid WWPN '$WWPN'." $ERRMSG
-			return
-		fi
-		echo $LUN > $1/fcp/lun 2>/dev/null || RETVAL=1
-		if [ $RETVAL -eq 1 ]; then
-			pr_error "ERROR: Invalid LUN '$LUN'." $ERRMSG
-			return
-		fi
-		echo $BOOTPROG > $1/fcp/bootprog 2>/dev/null || RETVAL=1
-		if [ $RETVAL -eq 1 ]; then
-			pr_error "ERROR: Invalid BOOTPROG '$BOOTPROG'." $ERRMSG
-			return
-		fi
-		echo $BR_LBA > $1/fcp/br_lba 2>/dev/null || RETVAL=1
-		if [ $RETVAL -eq 1 ]; then
-			pr_error "ERROR: Invalid BR_LBA '$BR_LBA'." $ERRMSG
-			return
-		fi
+}
+
+setup_fcp_device()
+{
+	DEV="$(CheckDeviceString $DEVICE)"
+	if [ "$DEV" != "" ]; then
+		echo $DEV > $1/$2/device
+	else
+		RETVAL=1
+		pr_error "ERROR: Invalid DEVICE '$DEVICE'." $ERRMSG
+		return
+	fi
+	echo $WWPN > $1/fcp/wwpn 2>/dev/null || RETVAL=1
+	if [ $RETVAL -eq 1 ]; then
+		pr_error "ERROR: Invalid WWPN '$WWPN'." $ERRMSG
+		return
+	fi
+	echo $LUN > $1/fcp/lun 2>/dev/null || RETVAL=1
+	if [ $RETVAL -eq 1 ]; then
+		pr_error "ERROR: Invalid LUN '$LUN'." $ERRMSG
+		return
+	fi
+	echo $BOOTPROG > $1/fcp/bootprog 2>/dev/null || RETVAL=1
+	if [ $RETVAL -eq 1 ]; then
+		pr_error "ERROR: Invalid BOOTPROG '$BOOTPROG'." $ERRMSG
+		return
+	fi
+	echo $BR_LBA > $1/fcp/br_lba 2>/dev/null || RETVAL=1
+	if [ $RETVAL -eq 1 ]; then
+		pr_error "ERROR: Invalid BR_LBA '$BR_LBA'." $ERRMSG
+		return
 	fi
 }
 
@@ -264,6 +274,30 @@ setup_nss_device()
 	echo $NSS_NAME > $1/nss/name || RETVAL=1
 }
 
+setup_nvme_device()
+{
+	echo $FID > $1/nvme/fid 2>/dev/null || RETVAL=1
+	if [ $RETVAL -eq 1 ]; then
+		pr_error "ERROR: Invalid FID '$FID'." $ERRMSG
+		return
+	fi
+	echo $NSID > $1/nvme/nsid 2>/dev/null || RETVAL=1
+	if [ $RETVAL -eq 1 ]; then
+		pr_error "ERROR: Invalid NSID '$NSID'." $ERRMSG
+		return
+	fi
+	echo $BOOTPROG > $1/nvme/bootprog 2>/dev/null || RETVAL=1
+	if [ $RETVAL -eq 1 ]; then
+		pr_error "ERROR: Invalid BOOTPROG '$BOOTPROG'." $ERRMSG
+		return
+	fi
+	echo $BR_LBA > $1/nvme/br_lba 2>/dev/null || RETVAL=1
+	if [ $RETVAL -eq 1 ]; then
+		pr_error "ERROR: Invalid BR_LBA '$BR_LBA'." $ERRMSG
+		return
+	fi
+}
+
 setup_reipl()
 {
 	if [ "$REIPL_TYPE" == "" ]; then
@@ -271,15 +305,25 @@ setup_reipl()
 		return
 	fi
 
-	if [ "$REIPL_TYPE" == "ccw" ] || [ "$REIPL_TYPE" == "fcp" ]; then
-		setup_device $REIPL_CONFIG_DIR $REIPL_TYPE
-	elif [ "$REIPL_TYPE" == "nss" ]; then
-		setup_nss_device $REIPL_CONFIG_DIR
-	else
-		pr_error "ERROR: Unknown reipl type '$REIPL_TYPE'." $ERRMSG
-		RETVAL=1
-		return
-	fi
+	case "$REIPL_TYPE" in
+		ccw)
+			setup_ccw_device $REIPL_CONFIG_DIR $REIPL_TYPE
+			;;
+		fcp)
+			setup_fcp_device $REIPL_CONFIG_DIR $REIPL_TYPE
+			;;
+		nvme)
+			setup_nvme_device $REIPL_CONFIG_DIR
+			;;
+		nss)
+			setup_nss_device $REIPL_CONFIG_DIR
+			;;
+		*)
+			pr_error "ERROR: Unknown reipl type '$REIPL_TYPE'." $ERRMSG
+			RETVAL=1
+			return
+			;;
+	esac
 
 	echo $REIPL_TYPE > $REIPL_CONFIG_DIR/reipl_type || RETVAL=1
 
@@ -292,13 +336,24 @@ setup_reipl()
 
 setup_dump()
 {
-	if [ "$DUMP_TYPE" == "ccw" ] || [ "$DUMP_TYPE" == "fcp" ]; then
-		setup_device $DUMP_CONFIG_DIR $DUMP_TYPE
-	elif [ "$DUMP_TYPE" != "none" ]; then
-		pr_error "ERROR: Unknown dump type '$DUMP_TYPE'." $ERRMSG
-		RETVAL=1
-		return
-	fi
+	case "$DUMP_TYPE" in
+		ccw)
+			setup_ccw_device $DUMP_CONFIG_DIR $DUMP_TYPE
+			;;
+		fcp)
+			setup_fcp_device $DUMP_CONFIG_DIR $DUMP_TYPE
+			;;
+		nvme)
+			setup_nvme_device $DUMP_CONFIG_DIR
+			;;
+		none)
+			;;
+		*)
+			pr_error "ERROR: Unknown dump type '$DUMP_TYPE'." $ERRMSG
+			RETVAL=1
+			return
+			;;
+	esac
 
 	echo $DUMP_TYPE > $DUMP_CONFIG_DIR/dump_type || RETVAL=1
 
@@ -358,6 +413,18 @@ print_ccw_device()
 	pr_info "device..: $DEVICE"
 }
 
+print_nvme_device()
+{
+	FID=$(cat $1/nvme/fid) || RETVAL=1
+	pr_info "fid.....: $FID"
+	NSID=$(cat $1/nvme/nsid) || RETVAL=1
+	pr_info "nsid....: $NSID"
+	BOOTPROG=$(cat $1/nvme/bootprog) || RETVAL=1
+	pr_info "bootprog: $BOOTPROG"
+	BR_LBA=$(cat $1/nvme/br_lba) || RETVAL=1
+	pr_info "br_lba..: $BR_LBA"
+}
+
 print_nss_name()
 {
 	NAME=$(cat $1/nss/device) || RETVAL=1
@@ -367,35 +434,52 @@ print_nss_name()
 status_dump()
 {
 	CONF_DUMP_TYPE=$(cat $DUMP_CONFIG_DIR/dump_type) || RETVAL=1
-	if [ "$CONF_DUMP_TYPE" == "none" ]; then
-		pr_info "type....: no dump device configured"
-	elif [ "$CONF_DUMP_TYPE" == "ccw" ]; then
-		pr_info "type....: ccw"
-		print_ccw_device $DUMP_CONFIG_DIR
-		verify_ccw_dump_device $(cat $DUMP_CONFIG_DIR/ccw/device)
-	elif [ "$CONF_DUMP_TYPE" == "fcp" ]; then
-		pr_info "type....: fcp"
-		print_fcp_device $DUMP_CONFIG_DIR
-	else
-		pr_error "ERROR: Unknown dump device type '$CONF_DUMP_TYPE'!"
-		pr_error "       Please check if you have the latest dumpconf package!"
-	fi
+	case "$CONF_DUMP_TYPE" in
+		none)
+			pr_info "type....: no dump device configured"
+			;;
+		ccw)
+			pr_info "type....: ccw"
+			print_ccw_device $DUMP_CONFIG_DIR
+			verify_ccw_dump_device $(cat $DUMP_CONFIG_DIR/ccw/device)
+			;;
+		fcp)
+			pr_info "type....: fcp"
+			print_fcp_device $DUMP_CONFIG_DIR
+			;;
+		nvme)
+			pr_info "type....: nvme"
+			print_nvme_device $DUMP_CONFIG_DIR
+			;;
+		*)
+			pr_error "ERROR: Unknown dump device type '$CONF_DUMP_TYPE'!"
+			pr_error "       Please check if you have the latest dumpconf package!"
+			;;
+	esac
 }
 
 status_reipl()
 {
 	REIPL_TYPE=$(cat $REIPL_CONFIG_DIR/reipl_type) || RETVAL=1
 	pr_info "type....: $REIPL_TYPE"
-	if [ "$REIPL_TYPE" == "ccw" ]; then
-		print_ccw_device $REIPL_CONFIG_DIR
-	elif [ "$REIPL_TYPE" == "fcp" ]; then
-		print_fcp_device $REIPL_CONFIG_DIR
-	elif [ "$REIPL_TYPE" == "nss" ]; then
-		print_nss_name $REIPL_CONFIG_DIR
-	else
-		pr_error "ERROR: Unknown reipl device type '$REIPL_TYPE'!"
-		pr_error "       Please check if you have the latest dumpconf package!"
-	fi
+	case "$REIPL_TYPE" in
+		ccw)
+			print_ccw_device $REIPL_CONFIG_DIR
+			;;
+		fcp)
+			print_fcp_device $REIPL_CONFIG_DIR
+			;;
+		nvme)
+			print_nvme_device $REIPL_CONFIG_DIR
+			;;
+		nss)
+			print_nss_name $REIPL_CONFIG_DIR
+			;;
+		*)
+			pr_error "ERROR: Unknown reipl device type '$REIPL_TYPE'!"
+			pr_error "       Please check if you have the latest dumpconf package!"
+			;;
+	esac
 }
 
 status_dump_reipl()
diff -pruN 2.14.0-2/etc/sysconfig/dumpconf 2.15.1-0ubuntu2/etc/sysconfig/dumpconf
--- 2.14.0-2/etc/sysconfig/dumpconf	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/etc/sysconfig/dumpconf	2020-10-28 14:31:59.000000000 +0000
@@ -40,6 +40,16 @@
 # BR_LBA=0
 
 #
+# Dump on nvme device (NVMe Disk)
+#
+# ON_PANIC=dump
+# DUMP_TYPE=nvme
+# FID=0x00000300
+# NSID=0x00000001
+# BOOTPROG=3
+# BR_LBA=0
+
+#
 # Use VMDUMP
 #
 # ON_PANIC=vmcmd
diff -pruN 2.14.0-2/genprotimg/boot/Makefile 2.15.1-0ubuntu2/genprotimg/boot/Makefile
--- 2.14.0-2/genprotimg/boot/Makefile	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/genprotimg/boot/Makefile	2020-10-28 14:31:59.000000000 +0000
@@ -12,7 +12,7 @@ ALL_CFLAGS := $(NO_PIE_CFLAGS) -Os -g \
 	-DENABLE_SCLP_ASCII=1 \
 	-DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
 	-fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
-	-fno-delete-null-pointer-checks \
+	-fno-delete-null-pointer-checks -fno-stack-protector \
 	-fexec-charset=IBM1047 -m64 -mpacked-stack \
 	-mstack-size=4096 -mstack-guard=128 -msoft-float \
 	-Wall -Wformat-security -Wextra -Werror
diff -pruN 2.14.0-2/.gitignore 2.15.1-0ubuntu2/.gitignore
--- 2.14.0-2/.gitignore	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/.gitignore	2020-10-28 14:31:59.000000000 +0000
@@ -34,6 +34,11 @@ iucvterm/src/iucvconn
 iucvterm/src/iucvtty
 iucvterm/src/ttyrun
 iucvterm/test/test_afiucv
+libekmfweb/check-dep-libekmfweb
+libekmfweb/detect-openssl-version.dep
+libekmfweb/libekmfweb.so
+libekmfweb/libekmfweb.so.1
+libekmfweb/libekmfweb.so.1.0
 libutil/util_base_example
 libutil/util_file_example
 libutil/util_libc_example
@@ -44,8 +49,9 @@ libutil/util_path_example
 libutil/util_prg_example
 libutil/util_rec_example
 libutil/util_scandir_example
-libzds/libzds.a
 libvmcp/vmcp_example
+libzds/libzds.a
+lsstp/lsstp
 mon_tools/mon_fsstatd
 mon_tools/mon_procd
 osasnmpd/osasnmpd
@@ -75,10 +81,10 @@ zdev/src/lszdev
 zdev/src/lszdev_usage.c
 zdsfs/zdsfs
 zdump/zgetdump
+zfcpdump/10-zfcpdump.install
 zfcpdump/cpioinit
-zfcpdump/zfcpdump_part
 zfcpdump/zfcpdump-initrd
-zfcpdump/10-zfcpdump.install
+zfcpdump/zfcpdump_part
 ziomon/ziomon_mgr
 ziomon/ziomon_util
 ziomon/ziomon_zfcpdd
@@ -90,9 +96,11 @@ zipl/boot/data.h
 zipl/src/chreipl_helper.device-mapper
 zipl/src/zipl
 zipl/src/zipl_helper.device-mapper
-zkey/zkey
-zkey/zkey-cryptsetup
 zkey/check-dep-zkey
 zkey/check-dep-zkey-cryptsetup
 zkey/detect-libcryptsetup.dep
+zkey/ekmfweb/libekmfweb.dep
+zkey/ekmfweb/zkey-ekmfweb.so
+zkey/zkey
+zkey/zkey-cryptsetup
 zpcictl/zpcictl
diff -pruN 2.14.0-2/include/ekmfweb/ekmfweb.h 2.15.1-0ubuntu2/include/ekmfweb/ekmfweb.h
--- 2.14.0-2/include/ekmfweb/ekmfweb.h	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/include/ekmfweb/ekmfweb.h	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,1071 @@
+/*
+ * libekmfweb - EKMFWeb client library
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+
+#ifndef LIB_EKMFWEB_H
+#define LIB_EKMFWEB_H
+
+#include <stddef.h>
+#include <stdbool.h>
+
+typedef void CURL;
+
+struct ekmf_config {
+	/** The base URL of the server. Should use https:// ! */
+	const char *base_url;
+	/** Optional: File name of the CA bundle PEM file, or a name of a
+	 *  directory the multiple CA certificates. If this is NULL, then the
+	 *  default system path for CA certificates is used */
+	const char *tls_ca;
+	/** Optional: File name of the client certificate PEM file */
+	const char *tls_client_cert;
+	/** Optional: File name of the clients key PEM file */
+	const char *tls_client_key;
+	/** Optional: Passphrase to read the clients key PEM file */
+	const char *tls_client_key_passphrase;
+	/** Optional: File name of a PEM file holding a CA certificate of the
+	 *  issuer */
+	const char *tls_issuer_cert;
+	/** Optional: File name of a PEM file containing the servers pinned
+	 *  public key. Public key pinning requires that verify_peer or
+	 *  verify_host (or both) is true. */
+	const char *tls_pinned_pubkey;
+	/** Optional: File name of a PEM file containing the server's
+	 *  certificate. This can be used to allow peer verification with
+	 *  self-signed server certificates */
+	const char *tls_server_cert;
+	/** If true, the peer certificate is verified */
+	bool tls_verify_peer;
+	/** If true, that the server certificate is for the server it is known
+	 *  as (i.e. the hostname in the url) */
+	bool tls_verify_host;
+	/** Maximum number of redirects to follow. Zero means that redirects are
+	 *  not followed. -1 means to infinitely follow redirects. */
+	long max_redirs;
+	/** File name of the login token (JSON Web Token) used for the last
+	 *  login. */
+	const char *login_token;
+	/** File name of a file containing the client identity secure key blob.
+	 *  This key represents the client identity against EKMFWeb. Some
+	 *  requests sent to EKMFWeb are signed with this (secure) key */
+	const char *identity_secure_key;
+	/** File name of a PEM file containing the EKMFWeb servers public key
+	 *  used to sign key export responses. */
+	const char *ekmf_server_pubkey;
+};
+
+struct ekmf_cca_lib {
+	void *cca_lib; /* Handle of CCA host library loaded via dlopen */
+};
+
+enum ekmf_ext_lib_type {
+	EKMF_EXT_LIB_CCA = 1,
+};
+
+struct ekmf_ext_lib {
+	enum ekmf_ext_lib_type type;
+	union {
+		struct ekmf_cca_lib *cca; /* Used if type = EKMF_EXT_LIB_CCA */
+	};
+};
+
+/**
+ * Connects to the specified server url and obtains the servers certificate
+ * and its chain of signing certificates and stores them in the specified
+ * PEM files.
+ *
+ * @param config            the configuration structure. Only the base_url must
+ *                          be specified, all others are optional.
+ * @param server_cert_pem   Optional: name of a PEM file to store the servers
+ *                          certificate
+ * @param server_pubkey_pem Optional: name of a PEM file to store the servers
+ *                          public key (can be used for public key pinning)
+ * @param ca_bundle_pem     Optional: name of a PEM file to store the CA
+ *                          certificate chain as a bundle
+ * @param verified          On return: If the server 's certificate has been
+ *                          verified using the CA specification from the config
+ *                          (if ca = NULL: default system CAs, otherwise path
+ *                          or file to CAs).
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ */
+int ekmf_get_server_cert_chain(const struct ekmf_config *config,
+			       const char *server_cert_pem,
+			       const char *server_pubkey_pem,
+			       const char *ca_bundle_pem,
+			       bool *verified, char **error_msg, bool verbose);
+
+/**
+ * Print the certificate(s) contained in the specified PEM file.
+ *
+ * @param cert_pem          the file name of the PEM file to print
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns -EIO if the file could not be opened. -ENOENT if the PEM file
+ *          does not contain any certificates. 0 if success.
+ */
+int ekmf_print_certificates(const char *cert_pem, bool verbose);
+
+/**
+ * Checks if the login token stored in the file denoted by field login_token
+ * of the config structure is valid or not. The file (if existent) contains a
+ * JSON Web Token (JWT, see RFC7519). It is valid if the current date and time
+ * is before its expiration time ("exp" claim), and after or equal its
+ * not-before time ("nbf" claim).
+ * Note: The signature (if any) of the JWT is not checked, nor any other JWT
+ * fields.
+ *
+ * @param config            the configuration structure
+ * @param valid             On return: true if the token is valid, false if not
+ * @param login_token       On return: If not NULL: the login token, if the
+ *                          token is still valid. The returned string must
+ *                          be freed by the caller when no longer needed.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int ekmf_check_login_token(const struct ekmf_config *config, bool *valid,
+			   char **login_token, bool verbose);
+
+/**
+ * Performs a login of the specified user with a passcode. On success the
+ * returned login token is stored in the file denoted by field login_token
+ * of the config structure, so that it can be used by subsequent requests.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param user_id           the user-ID to log-in.
+ * @param passcode          the passcode to log-in the user.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if the passcode is no longer valid.
+ */
+int ekmf_login(const struct ekmf_config *config, CURL **curl_handle,
+	       const char *user_id, const char *passcode, char **error_msg,
+	       bool verbose);
+
+enum ekmf_key_type {
+	EKMF_KEY_TYPE_ECC = 1,
+	EKMF_KEY_TYPE_RSA = 2,
+};
+
+struct ekmf_key_gen_info {
+	enum ekmf_key_type type;
+	union {
+		struct {
+			int curve_nid;
+		} ecc;
+		struct {
+			size_t modulus_bits;
+			unsigned int pub_exp;
+		} rsa;
+	} params;
+};
+
+/**
+ * Generate a secure identity key used to identify the client to EKMFWeb.
+ * The secure key blob is stored in a file specified in field
+ * identity_secure_key of the config structure. If an secure key already exists
+ * at that location, it is overwritten.
+ *
+ * @param config            the configuration structure. Only field
+ *                          identity_secure_key must be specified, all others
+ *                          are optional.
+ * @param info              key generation info, such as key type (ECC or RSA)
+ *                          and key parameters.
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int ekmf_generate_identity_key(const struct ekmf_config *config,
+			       const struct ekmf_key_gen_info *info,
+			       const struct ekmf_ext_lib *ext_lib,
+			       bool verbose);
+
+/**
+ * Re-encipher the secure identity key (form field identity_secure_key in
+ * config) used to identify the client to EKMFWeb.
+ * The secure key blob is encrypted using the HSM master key. Whenever the HSM
+ * master key is being changed, the secure identity key must be re-enciphered.
+ * You can either pro-actively re-encipher a secure key once the new master key
+ * has been prepared (but not yet made active): to_new = true; or you can
+ * re-encipher a secure key when the HSM master key has already been changed:
+ * to_new = false. This requires that the HSM still has the old master key.
+ * Not all HSMs support this.
+ *
+ * For pro-active re-encipherment it is suggested to store the re-enciphered
+ * secure key on a separate place, until the new HSM master key has been made
+ * active. Specify a file name in reenc_secure_key to do so. For an in-place
+ * re-encipherment, set reenc_secure_key = NULL.
+ *
+ * @param config            the configuration structure. Only field
+ *                          identity_secure_key must be specified, all others
+ *                          are optional.
+ * @param to_new            If true: the identity key is re-enciphered from the
+ *                          current to the new master key.
+ *                          If false: the identity key is re-enciphered from the
+ *                          old to the current master key.
+ * @param reenc_secure_key  if not NULL, then the re-enciphered secure key is
+ *                          stored into the filename specified here. Otherwise
+ *                          the re-enciphered secure key replaces the original
+ *                          secure identity key.
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ * A -ENODEV indicates that the master keys are not loaded.
+ */
+int ekmf_reencipher_identity_key(const struct ekmf_config *config,
+				 bool to_new, const char *reenc_secure_key,
+				 const struct ekmf_ext_lib *ext_lib,
+				 bool verbose);
+
+struct ekmf_rsa_pss_params {
+	int salt_len;        /* salt length in bytes, or OpenSSL constants
+				RSA_PSS_SALTLEN_DIGEST (-1),
+				RSA_PSS_SALTLEN_AUTO (-2), or
+				RSA_PSS_SALTLEN_MAX(-3) */
+	int mgf_digest_nid;  /* OpenSSl digest nid, or zero to use the same
+				digest algorithm as the signature algorithm */
+};
+
+/**
+ * Generate a certificate signing request using the secure identity key (field
+ * identity_secure_key in config structure) with the specified subject name,
+ * certificate extensions (if any), and writes the CSR to the specified file
+ * in PEM format.
+ *
+ * To renew an existing certificate, specify renew_cert = true. In this case
+ * the existing certificate (field sign_certificate in config struct) is read,
+ * and the subject name is extracted from it. Any specified subject name RDNs
+ * are added to the CSR. Also, the extensions are taken from the existing
+ * certificate, and any specified extensions are added to the CSR.
+ *
+ * The CSR is signed using the secure identity key (field identity_secure_key in
+ * config structure) with an signing algorithm matching the identity key (ECDSA,
+ * RSA-PKCS, or RSA-PSS if rsa_pss is true), and the specified digest. If the
+ * digest nid is zero, then a default digest is used.
+ *
+ * @param config            the configuration structure. Only field
+ *                          identity_secure_key must be specified, all others
+ *                          are optional.
+ * @param subject_rdns      an array of strings, each string representing an
+ *                          RDN in the form '[+]type=value'. If the type is
+ *                          prepended with a '+', then this RDN is added to the
+ *                          previous one.
+ * @param num_subject_rdns  number of RDN elements in the array.
+ * @param subject_utf8      if true, RDNs of type MBSTRING_UTF8 are created,
+ *                          otherwise type is MBSTRING_ASC is used.
+ * @param renew_cert_filename if not NULL, specifies the file name of a PEM file
+ *                          containing an existing certificate that is renewed
+ * @param extensions        an array of strings, each string representing an
+ *                          certificate extension in the form 'type=value'.
+ * @param num_extensions    number of extension elements in the array.
+ * @param digest_nid        the OpenSSL digest nid to use with the signature
+ *                          algorithm, or 0 to use the default
+ * @param rsa_pss_params    if not NULL and the identity key is an RSA key, then
+ *                          the CSR is signed with RSA-PSS using the specified
+ *                          PSS parameters. Ignored if the identity key is an EC
+ *                          key
+ * @param csr_pem_filename  the name of the PEM file to which the CSR is written
+ * @param new_hdr           if true, output "NEW" in the PEM header lines
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success:
+ *          -EINVAL: invalid parameter
+ *          -ENOMEM: Failed to allocate memory
+ *          -EBADMSG: an RDN or extension is not formatted correctly
+ *          -EIO: OpenSSL failed to create the CSR
+ *          -EEXIST: if one of the RDN name entries or extensions to add is a
+ *                   duplicate
+ *          -ENOTSUP: the specified digest is not supported
+ *          any other errno from file I/O routines
+ */
+int ekmf_generate_csr(const struct ekmf_config *config,
+		      const char *subject_rdns[], size_t num_subject_rdns,
+		      bool subject_utf8, const char *renew_cert_filename,
+		      const char *extensions[], size_t num_extensions,
+		      int digest_nid,
+		      struct ekmf_rsa_pss_params *rsa_pss_params,
+		      const char *csr_pem_filename, bool new_hdr,
+		      const struct ekmf_ext_lib *ext_lib, bool verbose);
+
+/**
+ * Generate a self signed certificate using the secure identity key (field
+ * identity_secure_key in config structure) with the specified subject name,
+ * certificate extensions (if any), and writes the certificate the specified
+ * file in PEM format.
+ *
+ * To renew an existing certificate, specify renew_cert = true. In this case
+ * the existing certificate (field sign_certificate in config struct) is read,
+ * and the subject name is extracted from it. Any specified subject name RDNs
+ * are added to the certificate. Also, the extensions are taken from the
+ * existing certificate, and any specified extensions are added to the new
+ * certificate.
+ *
+ * The certificate is signed using the secure identity key (field
+ * identity_secure_key in config structure) with an signing algorithm matching
+ * the identity key (ECDSA, RSA-PKCS, or RSA-PSS if rsa_pss is true), and the
+ * specified digest. If the digest nid is zero, then a default digest is used.
+ *
+ * @param config            the configuration structure. Only field
+ *                          identity_secure_key must be specified, all others
+ *                          are optional.
+ * @param subject_rdns      an array of strings, each string representing an
+ *                          RDN in the form '[+]type=value'. If the type is
+ *                          prepended with a '+', then this RDN is added to the
+ *                          previous one.
+ * @param num_subject_rdns  number of RDN elements in the array.
+ * @param subject_utf8      if true, RDNs of type MBSTRING_UTF8 are created,
+ *                          otherwise type is MBSTRING_ASC is used.
+ * @param renew_cert_filename if not NULL, specifies the file name of a PEM file
+ *                          containing an existing certificate that is renewed
+ * @param extensions        an array of strings, each string representing an
+ *                          certificate extension in the form 'type=value'.
+ * @param num_extensions    number of extension elements in the array.
+ * @param validity_days     number if day from the current date how long the
+ *                          certificate is valid.
+ * @param digest_nid        the OpenSSL digest nid to use with the signature
+ *                          algorithm, or 0 to use the default
+ * @param rsa_pss_params    if not NULL and the identity key is an RSA key, then
+ *                          the certificate is signed with RSA-PSS using the
+ *                          specified PSS parameters. Ignored if the identity
+ *                          key is an EC key
+ * @param cert_pem_filename the name of the PEM file to which the Certificate
+ *                          is written
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ *          -EINVAL: invalid parameter
+ *          -ENOMEM: Failed to allocate memory
+ *          -EBADMSG: an RDN or extension is not formatted correctly
+ *          -EIO: OpenSSL failed to create the certificate
+ *          -EEXIST: if one of the RDN name entries or extensions to add is a
+ *                   duplicate
+ *          -ENOTSUP: the specified digest is not supported
+ *          any other errno from file I/O routines
+ */
+int ekmf_generate_ss_cert(const struct ekmf_config *config,
+			  const char *subject_rdns[], size_t num_subject_rdns,
+			  bool subject_utf8, const char *renew_cert_filename,
+			  const char *extensions[], size_t num_extensions,
+			  int validity_days, int digest_nid,
+			  struct ekmf_rsa_pss_params *rsa_pss_params,
+			  const char *cert_pem_filename,
+			  const struct ekmf_ext_lib *ext_lib, bool verbose);
+
+/**
+ * Retrieves settings from the EKMFWeb server, such as the template names for
+ * generating keys in EKMFWeb.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param identity_template on return: If not NULL, the name of the template
+ *                          used to generate identity keys with. The caller
+ *                          must free the error string when it is not NULL.
+ * @param xts_key1_template on return: If not NULL, the name of the template
+ *                          used to generate the first XTS key with. The caller
+ *                          must free the error string when it is not NULL.
+ * @param xts_key1_template on return: If not NULL, the name of the template
+ *                          used to generate the second XTS key with. The caller
+ *                          must free the error string when it is not NULL.
+ * @param xts_key1_template on return: If not NULL, the name of the template
+ *                          used to generate a non-XTS key with. The caller
+ *                          must free the error string when it is not NULL.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ */
+int ekmf_get_settings(const struct ekmf_config *config, CURL **curl_handle,
+		      char **identity_template, char **xts_key1_template,
+		      char **xts_key2_template, char **non_xts_template,
+		      char **error_msg, bool verbose);
+
+/**
+ * Checks if the EKMFWeb server has the required Pervasive Encryption feature
+ * installed
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -ENOTSUP is returned, if the feature is not installed.
+ */
+int ekmf_check_feature(const struct ekmf_config *config, CURL **curl_handle,
+		       char **error_msg, bool verbose);
+
+/**
+ * Request the EKMFWeb server's public signing key and store it into PEM file
+ * specified in field server_pubkey of the config structure.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ */
+int ekmf_get_public_key(const struct ekmf_config *config, CURL **curl_handle,
+			char **error_msg, bool verbose);
+
+/**
+ * Requests a key to be retrieved from EKMFweb and imported under the current
+ * HSM's master key.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to retrieve
+ * @param sess_ec_curve_nid The OpenSSL nid of the EC curve used for the session
+ *                          ECC key. If 0, then the default curve is used.
+ * @param sign_rsa_digest_nid The OpenSSL nid of a digest used to sign the
+ *                          request with if the identity key is an RSA-type key.
+ *                          If 0, then the default digest is used.
+ *                          Ignored for ECC-type identity keys.
+ * @param use_rsa_pss       If true, and the identity key is an RSA-type key,
+ *                          use RSA-PSS to sign the request.
+ * @param signature_kid     the Key ID for the signature of the request
+ * @param key_blob          a buffer to store the retrieved key blob to
+ * @param key_blob_length   On entry: the size ofthe buffer
+ *                          On return: the size of the key blob retrieved
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          retrieve the key
+ */
+int ekmf_retrieve_key(const struct ekmf_config *config, CURL **curl_handle,
+		      const char *key_uuid, int sess_ec_curve_nid,
+		      int sign_rsa_digest_nid, bool use_rsa_pss,
+		      const char *signature_kid, unsigned char *key_blob,
+		      size_t *key_blob_length, char **error_msg,
+		      const struct ekmf_ext_lib *ext_lib, bool verbose);
+
+struct ekmf_tag_definition {
+	/** name of the tag */
+	const char *name;
+	/** Optional: description of the tag (can be NULL) */
+	const char *description;
+};
+
+struct ekmf_tag_def_list {
+	/** array of tag definitions */
+	struct ekmf_tag_definition *tag_defs;
+	/** number of tag definitions in array above */
+	size_t num_tag_defs;
+};
+
+struct ekmf_template_info {
+	/** name of the template */
+	const char *name;
+	/** UUID of the template */
+	const char *uuid;
+	/** type of the keys generated with this template , e.g. CIPHER */
+	const char *key_type;
+	/** algorithm of the keys generated with this template, e.g. AES */
+	const char *algorithm;
+	/** bit size of the keys generated with this template */
+	size_t key_size;
+	/** state of the template , e.g. ACTIVE */
+	const char *state;
+	/** state of the keys generated with this template , e.g. ACTIVE */
+	const char *key_state;
+	/** label template when generating keys with this template */
+	const char *label_template;
+	/** label tag definition list */
+	struct ekmf_tag_def_list label_tags;
+	/** true if keys generated with this template can be exported */
+	bool export_allowed;
+	/** the keystore type of the keys generated with this template */
+	const char *keystore_type;
+	/** Type of ECC curve, e.g. PRIME_CURVE (for algorithm = ECC) */
+	const char *curve;
+	/** timestamp when the template was created */
+	const char *created_on;
+	/** timestamp when the template was updated */
+	const char *updated_on;
+};
+
+struct ekmf_tag {
+	/** name of the tag */
+	const char *name;
+	/** value of the tag */
+	const char *value;
+};
+
+struct ekmf_tag_list {
+	/** array of tags */
+	struct ekmf_tag *tags;
+	/** number of tags in array above */
+	size_t num_tags;
+};
+
+struct ekmf_exporting_key {
+	/** name of the exporting key */
+	const char *name;
+	/** uuid of the exporting key */
+	const char *uuid;
+};
+
+struct ekmf_export_control {
+	/** If true, export is allowed using the exporting keys below */
+	bool export_allowed;
+	/** array of erporting keys */
+	struct ekmf_exporting_key *exporting_keys;
+	/** number of keys in array above */
+	size_t num_exporting_keys;
+};
+
+struct ekmf_key_info {
+	/** label (name) of the key */
+	const char *label;
+	/** Optional: description of the key (can be NULL) */
+	const char *description;
+	/** UUID of the key */
+	const char *uuid;
+	/** type of the key, e.g. CIPHER */
+	const char *key_type;
+	/** algorithm of the key, e.g. AES */
+	const char *algorithm;
+	/** bit size of the key */
+	size_t key_size;
+	/** state of the key, e.g. ACTIVE */
+	const char *state;
+	/** type of the keystore, e.g. PERVASIVE_ENCRYPTION */
+	const char *keystore_type;
+	/** name of the template used to generate the key */
+	const char *template;
+	/** UUID of the template used to generate the key */
+	const char *template_uuid;
+	/** label tag list */
+	struct ekmf_tag_list label_tags;
+	/** custom tag list */
+	struct ekmf_tag_list custom_tags;
+	/** export control information */
+	struct ekmf_export_control export_control;
+	/** timestamp when the key was activated */
+	const char *activate_on;
+	/** timestamp when the key expires */
+	const char *expires_on;
+	/** timestamp when the key was created */
+	const char *created_on;
+	/** timestamp when the key was updated */
+	const char *updated_on;
+};
+
+#define EKMF_KEY_STATE_PRE_ACTIVATION		"PRE-ACTIVATION"
+#define EKMF_KEY_STATE_ACTIVE			"ACTIVE"
+#define EKMF_KEY_STATE_DEACTIVATED		"DEACTIVATED"
+#define EKMF_KEY_STATE_COMPROMISED		"COMPROMISED"
+#define EKMF_KEY_STATE_DESTROYED		"DESTROYED"
+#define EKMF_KEY_STATE_DESTROYED_COMPROMISED	"DESTROYED-COMPROMISED"
+
+/**
+ * Callback function used with the ekmf_list_templates function. This
+ * callback is called for each template found.
+ *
+ * @param curl_handle      a CURL handle that can be used to perform further
+ *                         EKMFWeb functions within the callback.
+ * @param template_info    a struct containing information about the template.
+ *                         If any of the information needs to be kept, then the
+ *                         callback function must make a copy of the
+ *                         information. The memory holding the information
+ *                         passed to the callback is no longer valid after the
+ *                         callback has returned.
+ * @param private          the private pointer that was specified with the
+ *                         ekmf_list_templates invocation.
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ * When a nonzero return code is returned, the template listing process stops,
+ * and ekmf_list_templates returns the return code from the callback.
+ */
+typedef int (*ekmf_template_cb_t)(CURL *curl_handle,
+				  struct ekmf_template_info *template_info,
+				  void *private);
+
+/**
+ * List available key templates. Only templates in state ACTIVE, with key
+ * algorithm AES and keystore type PERVASIVE_ENCRYPTION are listed. The
+ * templates are ordered by name in ascending order.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param template_cb       a callback function that is called for each template
+ *                          found
+ * @param private           a pointer that is passed as-is to the callback
+ * @param name_pattern      a pattern to filter by name, or NULL to list all.
+ * @param state             the state of the templates to list. If NULL then
+ *                          templates in state 'ACTIVE' are listed
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          list the templates
+ */
+int ekmf_list_templates(const struct ekmf_config *config, CURL **curl_handle,
+			ekmf_template_cb_t template_cb, void *private,
+			const char *name_pattern, const char *state,
+			char **error_msg, bool verbose);
+
+/**
+ * Get a template by its UUID.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param template_uuid     the UUID of the template to get
+ * @param template          an address of a template info pointer. On return
+ *                          the pointer is updated to point to a newly allocated
+ *                          template info struct. It must be freed by the caller
+ *                          using ekmf_free_template_info when no longer needed.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          get the template
+ */
+int ekmf_get_template(const struct ekmf_config *config, CURL **curl_handle,
+		      const char *template_uuid,
+		      struct ekmf_template_info **template, char **error_msg,
+		      bool verbose);
+
+/**
+ * Get the last used sequence number of a template by its UUID.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param template_uuid     the UUID of the template to get
+ * @param seqNumber         On return: the last used sequence number of this
+ *                          template.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          get the template
+ */
+int ekmf_get_last_seq_no(const struct ekmf_config *config, CURL **curl_handle,
+			 const char *template_uuid, unsigned int *seqNumber,
+			 char **error_msg, bool verbose);
+
+/**
+ * Clones a template info structure by making a deep copy of all strings and
+ * arrays.
+ * The copied template info must be freed using ekmf_free_template_info() by
+ * the caller.
+ *
+ * @param src               the source template info structure
+ * @param dest              the destination template info structure
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int ekmf_clone_template_info(const struct ekmf_template_info *src,
+			     struct ekmf_template_info **dest);
+
+/**
+ * Free a template info structure.
+ *
+ * @param template          the template to free
+ */
+void ekmf_free_template_info(struct ekmf_template_info *template);
+
+/**
+ * Callback function used with the ekmf_list_keys function. This
+ * callback is called for each ky found.
+ *
+ * @param curl_handle      a CURL handle that can be used to perform further
+ *                         EKMFWeb functions within the callback.
+ * @param template_info    a struct containing information about the key.
+ *                         If any of the information needs to be kept, then the
+ *                         callback function must make a copy of the
+ *                         information. The memory holding the information
+ *                         passed to the callback is no longer valid after the
+ *                         callback has returned.
+ * @param private          the private pointer that was specified with the
+ *                         ekmf_list_keys invocation.
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ * When a nonzero return code is returned, the key listing process stops,
+ * and ekmf_list_keys returns the return code from the callback.
+ */
+typedef int (*ekmf_key_cb_t)(CURL *curl_handle,
+			     struct ekmf_key_info *key_info,
+			     void *private);
+
+/**
+ * List available keys. The keys are ordered by name in ascending order.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_cb            a callback function that is called for each key
+ *                          found
+ * @param private           a pointer that is passed as-is to the callback
+ * @param name_pattern      a pattern to filter by name, or NULL to list all.
+ * @param states            the states of the keys to list, or NULL to list keys
+ *                          in ACTIVE state only. Multiple states can be
+ *                          specified separated by comma.*
+ * @param tags              a list of custom tags to use as filter, or NULL
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          list the keys
+ */
+int ekmf_list_keys(const struct ekmf_config *config, CURL **curl_handle,
+		   ekmf_key_cb_t key_cb, void *private,
+		   const char *name_pattern, const char *states,
+		   const struct ekmf_tag_list *tags,
+		   char **error_msg, bool verbose);
+
+/**
+ * Get information about a key by its UUID.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to get info for
+ * @param key               an address of a key info pointer. On return
+ *                          the pointer is updated to point to a newly allocated
+ *                          key info struct. It must be freed by the caller
+ *                          using ekmf_free_key_info when no longer needed.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          get the key info
+ */
+int ekmf_get_key_info(const struct ekmf_config *config, CURL **curl_handle,
+		      const char *key_uuid, struct ekmf_key_info **key,
+		      char **error_msg, bool verbose);
+
+/**
+ * Changes the state of a key identified by its UUID. To update a key,
+ * the timestamp from the last update is required. This can be found in
+ * the key info struct in field update_on.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to get info for
+ * @param new_state         the new state of the key
+ * @param updated_on        the timestamp of the last update (must match)
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          update the key.
+ *          -EAGAIN is returned if the timestamp does not match, indicating that
+ *          the key has been updated in the meantime.
+ */
+int ekmf_set_key_state(const struct ekmf_config *config, CURL **curl_handle,
+		       const char *key_uuid, const char *new_state,
+		       const char *updated_on, char **error_msg, bool verbose);
+
+/**
+ * Sets (changed/adds) custom tags of a key identified by its UUID. To update a
+ * key, the timestamp from the last update is required. This can be found in
+ * the key info struct in field update_on.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to get info for
+ * @param tags              a list of tags to set
+ * @param updated_on        the timestamp of the last update (must match)
+ * @param new_updated_on    on return: if not NULL, the new timestamp of the
+ *                          current update. Can be used for subsequent updates
+ *                          on the key.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          update the key.
+ *          -EAGAIN is returned if the timestamp does not match, indicating that
+ *          the key has been updated in the meantime.
+ */
+int ekmf_set_key_tags(const struct ekmf_config *config, CURL **curl_handle,
+		       const char *key_uuid, const struct ekmf_tag_list *tags,
+		       const char *updated_on, char **new_updated_on,
+		       char **error_msg, bool verbose);
+
+/**
+ * Deletes custom tags of a key identified by its UUID. To update a
+ * key, the timestamp from the last update is required. This can be found in
+ * the key info struct in field update_on.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to get info for
+ * @param tags              a list of tags to delete. Only the name of the tags
+ *                          must be present in the tag structs of the list, the
+ *                          values are ignored.
+ * @param updated_on        the timestamp of the last update (must match)
+ * @param new_updated_on    on return: if not NULL, the new timestamp of the
+ *                          current update. Can be used for subsequent updates
+ *                          on the key.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          update the key.
+ *          -EAGAIN is returned if the timestamp does not match, indicating that
+ *          the key has been updated in the meantime.
+ */
+int ekmf_delete_key_tags(const struct ekmf_config *config, CURL **curl_handle,
+			 const char *key_uuid, const struct ekmf_tag_list *tags,
+			 const char *updated_on, char **new_updated_on,
+			 char **error_msg, bool verbose);
+
+/**
+ * Clones a key info structure by making a deep copy of all strings and
+ * arrays.
+ * The copied key info must be freed using ekmf_free_key_info() by
+ * the caller.
+ *
+ * @param src               the source key info structure
+ * @param dest              the destination key info structure
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int ekmf_clone_key_info(const struct ekmf_key_info *src,
+			struct ekmf_key_info **dest);
+
+/**
+ * Free a key info structure.
+ *
+ * @param key               the key info to free
+ */
+void ekmf_free_key_info(struct ekmf_key_info *key);
+
+/**
+ * Generates a new key in EKMFWeb
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param template          the name of the template to generate the key with
+ * @param description       Optional: a textual description of the key (can be
+ *                          NULL)
+ * @param label_tags        list of label tags. The label tags are required as
+ *                          defined in the template
+ * @param custom_tags       Optional: list of custom tags (can be NULL)
+ * @param exporting_key     Optional: The uuid of the key that is allowed to
+ *                          export the newly generated key (can be NULL).
+ * @param certificate       Optional: The certificate to generate an identity
+ *                          key from. Should be NULL for generating AES keys.
+ * @param certificate_size  Optional: the size of the certificate. Required if
+ *                          certificate is not NULL.
+ * @param key_info          Optional: On return: If not NULL, a key info struct
+ *                          is returned here containing key information. This
+ *                          must be freed by the caller with ekmf_free_key_info
+ *                          when no longer needed.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          generate keys
+ */
+int ekmf_generate_key(const struct ekmf_config *config, CURL **curl_handle,
+		      const char *template, const char *description,
+		      const struct ekmf_tag_list *label_tags,
+		      const struct ekmf_tag_list *custom_tags,
+		      const char *exporting_key,
+		      const unsigned char *certificate, size_t certificate_size,
+		      struct ekmf_key_info **key_info,
+		      char **error_msg, bool verbose);
+
+/**
+ * Close the connection to the EKMFWeb server by destroying the CURL handle.
+ *
+ * @param curl_handle       the CURL handle to destroy
+ */
+void ekmf_curl_destroy(CURL *curl_handle);
+
+#endif
diff -pruN 2.14.0-2/include/lib/util_file.h 2.15.1-0ubuntu2/include/lib/util_file.h
--- 2.14.0-2/include/lib/util_file.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/include/lib/util_file.h	2020-10-28 14:31:59.000000000 +0000
@@ -12,8 +12,10 @@
 #define LIB_UTIL_FILE_H
 
 int util_file_read_line(char *str, size_t size, const char *fmt, ...);
+int util_file_read_i(int *val, int base, const char *fmt, ...);
 int util_file_read_l(long *val, int base, const char *fmt, ...);
 int util_file_read_ll(long long *val, int base, const char *fmt, ...);
+int util_file_read_ui(unsigned int *val, int base, const char *fmt, ...);
 int util_file_read_ul(unsigned long *val, int base, const char *fmt, ...);
 int util_file_read_ull(unsigned long long *val, int base, const char *fmt, ...);
 
@@ -23,4 +25,5 @@ int util_file_write_ll(long long val, in
 int util_file_write_ul(unsigned long val, int base, const char *fmt, ...);
 int util_file_write_ull(unsigned long long val, int base, const char *fmt, ...);
 
+int util_file_read_va(const char *path, const char *fmt, ...);
 #endif /** LIB_UTIL_FILE_H @} */
diff -pruN 2.14.0-2/include/lib/util_sys.h 2.15.1-0ubuntu2/include/lib/util_sys.h
--- 2.14.0-2/include/lib/util_sys.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/include/lib/util_sys.h	2020-10-28 14:31:59.000000000 +0000
@@ -12,6 +12,11 @@
 #ifndef LIB_UTIL_SYS_H
 #define LIB_UTIL_SYS_H
 
+#include <stdbool.h>
+
 int util_sys_get_dev_addr(const char *dev, char *addr);
+bool util_sys_dev_is_partition(dev_t dev);
+int util_sys_get_partnum(dev_t dev);
+int util_sys_get_base_dev(dev_t dev, dev_t *base_dev);
 
 #endif /** LIB_UTIL_SYS_H @} */
diff -pruN 2.14.0-2/ipl_tools/cmd_chreipl.c 2.15.1-0ubuntu2/ipl_tools/cmd_chreipl.c
--- 2.14.0-2/ipl_tools/cmd_chreipl.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/ipl_tools/cmd_chreipl.c	2020-10-28 14:31:59.000000000 +0000
@@ -79,6 +79,7 @@ static const char *const usage_chreipl =
 "  -s  --nsid <NAMESPACE_ID> Namespace ID of NVME IPL device (decimal, default 1)\n"
 "  -b, --bootprog <BPROG>    Bootprog specification\n"
 "  -L, --loadparm <PARM>     Loadparm specification\n"
+"  -c, --clear 0|1         Control if memory is cleared on re-IPL\n"
 "\n"
 "Options for nss target:\n"
 "  -n, --name <NAME>       Identifier of the NSS\n"
@@ -794,6 +795,11 @@ static void chreipl_nvme(void)
 			 strlen(l.bootparms), BOOTPARMS_FCP_MAX);
 	}
 
+	if (l.reipl_clear >= 0) {
+		check_exists("reipl/nvme/clear", "NVME re-IPL clear attribute");
+		write_str(l.reipl_clear ? "1" : "0", "reipl/nvme/clear");
+	}
+
 	write_str_optional(l.loadparm, "reipl/nvme/loadparm", l.loadparm_set,
 			   "loadparm");
 	write_str_optional(l.bootparms, "reipl/nvme/scp_data", l.bootparms_set,
diff -pruN 2.14.0-2/ipl_tools/cmd_lsreipl.c 2.15.1-0ubuntu2/ipl_tools/cmd_lsreipl.c
--- 2.14.0-2/ipl_tools/cmd_lsreipl.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/ipl_tools/cmd_lsreipl.c	2020-10-28 14:31:59.000000000 +0000
@@ -92,6 +92,7 @@ void print_nvme(int show_ipl, int dump)
 	char *path_loadparm = show_ipl ? "/sys/firmware/ipl/loadparm" :
 		"/sys/firmware/reipl/nvme/loadparm";
 	char loadparm[9], loadparm_path[PATH_MAX];
+	char *path_reipl_clear = "/sys/firmware/reipl/nvme/clear";
 
 	if (dump)
 		printf("%-12s nvme_dump\n", get_ipl_banner(show_ipl));
@@ -111,6 +112,8 @@ void print_nvme(int show_ipl, int dump)
 	}
 	if (access(path_bootparms, R_OK) == 0)
 		print_fw_str("Bootparms:   \"%s\"\n", dir, "scp_data");
+	if (!show_ipl && access(path_reipl_clear, R_OK) == 0)
+		print_fw_str("clear:       %s\n", dir, "clear");
 }
 
 void print_ccw(int show_ipl)
diff -pruN 2.14.0-2/ipl_tools/man/chreipl.8 2.15.1-0ubuntu2/ipl_tools/man/chreipl.8
--- 2.14.0-2/ipl_tools/man/chreipl.8	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/ipl_tools/man/chreipl.8	2020-10-28 14:31:59.000000000 +0000
@@ -238,6 +238,13 @@ configuration that is defined by the
 boot menu. Instead it can be used to control higher level boot loaders
 like GRUB. For more details refer to distribution specific documentation.
 
+.TP
+.BR "\-c" " or " "\-\-clear"
+Specify whether memory should be cleared on re-IPL. Possible values are 0 to
+disable and 1 to enable memory clearing on re-IPL.
+Memory clearing is supported if the "clear" attribute is present in
+/sys/firmware/reipl/nvme/.
+
 .PP
 \fBExamples:\fP
 .br
diff -pruN 2.14.0-2/libdasd/dasd_sys.c 2.15.1-0ubuntu2/libdasd/dasd_sys.c
--- 2.14.0-2/libdasd/dasd_sys.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/libdasd/dasd_sys.c	2020-10-28 14:31:59.000000000 +0000
@@ -214,7 +214,7 @@ int dasd_get_host_access_count(char *dev
 	char *path;
 	long value;
 
-	if (!util_sys_get_dev_addr(device, busid))
+	if (util_sys_get_dev_addr(device, busid) != 0)
 		return 0;
 
 	path = util_path_sysfs("bus/ccw/devices/%s/host_access_count", busid);
diff -pruN 2.14.0-2/libekmfweb/cca.c 2.15.1-0ubuntu2/libekmfweb/cca.c
--- 2.14.0-2/libekmfweb/cca.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/libekmfweb/cca.c	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,1793 @@
+/*
+ * libekmfweb - EKMFWeb client library
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+#include <dlfcn.h>
+#include <stdio.h>
+#include <string.h>
+#include <errno.h>
+#include <err.h>
+
+#include "lib/zt_common.h"
+
+#include <openssl/sha.h>
+#include <openssl/rsa.h>
+#include <openssl/ecdsa.h>
+
+#include "cca.h"
+#include "utilities.h"
+
+#define pr_verbose(verbose, fmt...)	do {				\
+						if (verbose)		\
+							warnx(fmt);	\
+					} while (0)
+
+/* Internal CCA definitions */
+
+#define CCA_KEYWORD_SIZE		8
+#define CCA_KEY_ID_SIZE			64
+
+struct cca_ecc_key_pair_value_struct {
+	uint8_t		curve_type;
+	uint8_t		reserved;
+	uint16_t	curve_length;
+	uint16_t	priv_key_length;
+	uint16_t	public_key_len;
+} __packed;
+
+struct cca_rsa_key_pair_value_struct {
+	uint16_t	modulus_bit_length;
+	uint16_t	modulus_length;
+	uint16_t	public_exp_length;
+	uint16_t	reserved;
+	uint16_t	p_length;
+	uint16_t	q_length;
+	uint16_t	dp_length;
+	uint16_t	dq_length;
+	uint16_t	u_length;
+	unsigned char	public_exponent[3];
+} __packed;
+
+struct cca_ecc_pub_key_value_struct {
+	uint8_t		curve_type;
+	uint8_t		reserved;
+	uint16_t	curve_length;
+	uint16_t	public_key_len;
+} __packed;
+
+#define CCA_PRIME_CURVE			0x00
+#define CCA_BRAINPOOL_CURVE		0x01
+
+struct cca_token_header {
+	uint8_t		token_identifier;
+	uint8_t		token_version1; /* Used for PKA key tokens */
+	uint16_t	token_length;
+	uint8_t		token_version2; /* Used for symmetric key tokens */
+	uint8_t		reserved[3];
+} __packed;
+
+/* Key token identifiers */
+#define CCA_TOKEN_ID_NULL			0x00
+#define CCA_TOKEN_ID_INTERNAL_SYMMETRIC		0x01
+#define CCA_TOKEN_ID_EXTERNAL_SYMMETRIC		0x02
+#define CCA_TOKEN_ID_EXTERNAL_PKA		0x1e
+#define CCA_TOKEN_ID_INTERNAL_PKA		0x1f
+
+/* Key token versions */
+#define CCA_TOKEN_VERS1_V0			0x00
+#define CCA_TOKEN_VERS2_DES_V0			0x00
+#define CCA_TOKEN_VERS2_DES_V1			0x01
+#define CCA_TOKEN_VERS2_AES_DATA		0x04
+#define CCA_TOKEN_VERS2_AES_CIPHER		0x05
+
+struct cca_section_header {
+	uint8_t		section_identifier;
+	uint8_t		section_version;
+	uint16_t	section_length;
+} __packed;
+
+#define CCA_SECTION_ID_RSA_ME_1024_PRIV		0x02
+#define CCA_SECTION_ID_RSA_PUBL			0x04
+#define CCA_SECTION_ID_RSA_CRT_2048_PRIV	0x05
+#define CCA_SECTION_ID_RSA_ME_1024_OPK_PRIV	0x06
+#define CCA_SECTION_ID_RSA_CRT_4096_OPK_PRIV	0x08
+#define CCA_SECTION_ID_RSA_ME_4096_PRIV		0x09
+#define CCA_SECTION_ID_ECC_PRIV			0x20
+#define CCA_SECTION_ID_ECC_PUBL			0x21
+#define CCA_SECTION_ID_RSA_ME_1024_EOPK_PRIV	0x30
+#define CCA_SECTION_ID_RSA_CRT_4096_EOPK_PRIV	0x31
+
+struct cca_ecc_pub_key_section {
+	struct cca_section_header section_header;
+	uint8_t		reserved1[4];
+	uint8_t		curve_type;
+	uint8_t		reserved2;
+	uint16_t	prime_bits_length;
+	uint16_t	pub_key_length; /* Incl. compression indication byte */
+	/* Public key of length pub_key_length */
+} __packed;
+
+struct cca_rsa_pub_key_section {
+	struct cca_section_header section_header;
+	uint16_t	reserved1;
+	uint16_t	pub_exp_length;
+	uint16_t	modulus_bits_length;
+	uint16_t	modulus_length; /* if 0 -> see priv key section */
+	/* Public exponent of length pub_exp_length */
+	/* Modulus of length modulus_length */
+} __packed;
+
+struct cca_rsa_crt_priv_key_section {
+	struct cca_section_header section_header;
+	uint16_t	assoc_data_length;
+	uint16_t	payload_length;
+	uint16_t	reserved1;
+	uint8_t		assoc_data_version;
+	uint8_t		key_format;
+	uint8_t		key_source;
+	uint8_t		reserved2;
+	uint8_t		hash_type;
+	uint8_t		hash[32];
+	uint8_t		reserved3[3];
+	uint8_t		key_usage;
+	uint8_t		format_restriction;
+	uint16_t	p_length;
+	uint16_t	q_length;
+	uint16_t	dp_length;
+	uint16_t	dq_length;
+	uint16_t	u_length;
+	uint16_t	modulus_length;
+	uint32_t	reserved4;
+	uint8_t		opk[48];
+	uint8_t		kvp[16];
+	uint16_t	reserved6;
+	/* Public modulus in length modulus_length */
+	/* Encrypted payload (AESKW-wrapped key material) */
+} __packed;
+
+#define POINT_CONVERSION_COMPRESSED	0x02
+#define POINT_CONVERSION_UNCOMPRESSED	0x04
+#define POINT_CONVERSION_HYBRID		0x06
+#define POINT_CONVERSION_ODD_EVEN	0x01
+
+/**
+ * Gets the CCA library function entry points from the library handle
+ */
+static int _cca_get_library_functions(const struct ekmf_cca_lib *cca_lib,
+				      struct cca_lib *cca)
+{
+	if (cca_lib == NULL || cca == NULL)
+		return -EINVAL;
+
+	cca->dll_CSNDPKB = (CSNDPKB_t)dlsym(cca_lib->cca_lib, "CSNDPKB");
+	cca->dll_CSNDPKG = (CSNDPKG_t)dlsym(cca_lib->cca_lib, "CSNDPKG");
+	cca->dll_CSNDKTC = (CSNDKTC_t)dlsym(cca_lib->cca_lib, "CSNDKTC");
+	cca->dll_CSNDDSG = (CSNDDSG_t)dlsym(cca_lib->cca_lib, "CSNDDSG");
+	cca->dll_CSNBKTB2 = (CSNBKTB2_t)dlsym(cca_lib->cca_lib, "CSNBKTB2");
+	cca->dll_CSNDEDH = (CSNDEDH_t)dlsym(cca_lib->cca_lib, "CSNDEDH");
+	cca->dll_CSNDSYI2 = (CSNDSYI2_t)dlsym(cca_lib->cca_lib, "CSNDSYI2");
+
+	if (cca->dll_CSNDPKB == NULL || cca->dll_CSNDPKG == NULL ||
+	    cca->dll_CSNDKTC == NULL || cca->dll_CSNDDSG == NULL ||
+	    cca->dll_CSNBKTB2 == NULL || cca->dll_CSNDEDH == NULL ||
+	    cca->dll_CSNDSYI2 == NULL)
+		return -EIO;
+
+	return 0;
+}
+
+/**
+ * Generates an CCA ECC key of the specified curve type and length using the
+ * CCA host library.
+ *
+ * @param cca_lib           the CCA library structure
+ * @param curve_nid         the nid specifying the curve.
+ * @param key_token         a buffer to store the generated key token
+ * @param key_token_length  On entry: the size of the buffer
+ *                          On return: the size of the key token
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_generate_ecc_key_pair(const struct ekmf_cca_lib *cca_lib,
+			      int curve_nid, unsigned char *key_token,
+			      size_t *key_token_length, bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	unsigned char transport_key_identifier[CCA_KEY_ID_SIZE] = { 0, };
+	unsigned char key_skeleton[CCA_MAX_PKA_KEY_TOKEN_SIZE] = { 0, };
+	long key_value_structure_length, private_key_name_length = 0;
+	unsigned char regeneration_data[CCA_KEY_ID_SIZE] = { 0, };
+	struct cca_ecc_key_pair_value_struct key_value_structure;
+	unsigned char private_key_name[CCA_KEY_ID_SIZE] = { 0, };
+	unsigned char rule_array[3 * CCA_KEYWORD_SIZE] = { 0, };
+	long regeneration_data_length = 0, key_skeleton_length;
+	unsigned char *exit_data = NULL;
+	unsigned char *param2 = NULL;
+	struct cca_lib cca;
+	long token_length;
+	long param1 = 0;
+	int rc;
+
+	if (cca_lib == NULL || key_token == NULL || key_token_length == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	memset(key_token, 0, *key_token_length);
+	token_length = *key_token_length;
+
+	memset(&key_value_structure, 0, sizeof(key_value_structure));
+	if (ecc_is_prime_curve(curve_nid)) {
+		key_value_structure.curve_type = CCA_PRIME_CURVE;
+	} else if (ecc_is_brainpool_curve(curve_nid)) {
+		key_value_structure.curve_type = CCA_BRAINPOOL_CURVE;
+	} else {
+		pr_verbose(verbose, "Unsupported curve: %d", curve_nid);
+		return -EINVAL;
+	}
+	key_value_structure.curve_length = ecc_get_curve_prime_bits(curve_nid);
+	key_value_structure_length = sizeof(key_value_structure);
+
+	rule_array_count = 3;
+	memcpy(rule_array, "ECC-PAIR", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + CCA_KEYWORD_SIZE, "KEY-MGMT", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + 2 * CCA_KEYWORD_SIZE, "ECC-VER1", CCA_KEYWORD_SIZE);
+
+	key_skeleton_length = sizeof(key_skeleton);
+
+	cca.dll_CSNDPKB(&return_code, &reason_code,
+			&exit_data_len, exit_data,
+			&rule_array_count, rule_array,
+			&key_value_structure_length,
+			(unsigned char *)&key_value_structure,
+			&private_key_name_length, private_key_name,
+			&param1, param2, &param1, param2,
+			&param1, param2, &param1, param2,
+			&param1, param2,
+			&key_skeleton_length, key_skeleton);
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDPKB (EC KEY TOKEN BUILD) failed: "
+			  "return_code: %ld reason_code: %ld", return_code,
+			  reason_code);
+		return -EIO;
+	}
+
+	rule_array_count = 1;
+	memset(rule_array, 0, sizeof(rule_array));
+	memcpy(rule_array, "MASTER  ", (size_t)CCA_KEYWORD_SIZE);
+
+	cca.dll_CSNDPKG(&return_code, &reason_code,
+			NULL, NULL,
+			&rule_array_count, rule_array,
+			&regeneration_data_length, regeneration_data,
+			&key_skeleton_length, key_skeleton,
+			transport_key_identifier,
+			&token_length, key_token);
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDPKG (EC KEY GENERATE) failed: "
+			  "return_code: %ld reason_code: %ld", return_code,
+			  reason_code);
+		return -EIO;
+	}
+
+	*key_token_length = token_length;
+
+	return 0;
+}
+
+/**
+ * Generates an CCA RSA key of the specified key size and optionally the
+ * specified public exponent using the CCA host library.
+ *
+ * @param cca_lib           the CCA library structure
+ * @param modulus_bits      the size of the key in bits (512, 1024, 2048, 4096)
+ * @param pub_exp           the public exponent or zero. Possible values are:
+ *                          3, 5, 17, 257, or 65537. Specify zero to choose the
+ *                          exponent by random (only possible for modulus_bits
+ *                          up to 2048).
+ * @param key_token         a buffer to store the generated key token
+ * @param key_token_length  On entry: the size of the buffer
+ *                          On return: the size of the key token
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_generate_rsa_key_pair(const struct ekmf_cca_lib *cca_lib,
+			      size_t modulus_bits, unsigned int pub_exp,
+			      unsigned char *key_token,
+			      size_t *key_token_length, bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	unsigned char transport_key_identifier[CCA_KEY_ID_SIZE] = { 0, };
+	unsigned char key_skeleton[CCA_MAX_PKA_KEY_TOKEN_SIZE] = { 0, };
+	long key_value_structure_length, private_key_name_length = 0;
+	unsigned char regeneration_data[CCA_KEY_ID_SIZE] = { 0, };
+	struct cca_rsa_key_pair_value_struct key_value_structure;
+	unsigned char private_key_name[CCA_KEY_ID_SIZE] = { 0, };
+	unsigned char rule_array[2 * CCA_KEYWORD_SIZE] = { 0, };
+	long regeneration_data_length = 0, key_skeleton_length;
+	unsigned char *exit_data = NULL;
+	unsigned char *param2 = NULL;
+	struct cca_lib cca;
+	long token_length;
+	long param1 = 0;
+	int rc;
+
+	if (cca_lib == NULL || key_token == NULL || key_token_length == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	memset(key_token, 0, *key_token_length);
+	token_length = *key_token_length;
+
+	memset(&key_value_structure, 0, sizeof(key_value_structure));
+	key_value_structure.modulus_bit_length = modulus_bits;
+	switch (pub_exp) {
+	case 0:
+		if (modulus_bits > 2048) {
+			pr_verbose(verbose, "cannot auto-generate public "
+				   "exponent for keys > 2048");
+			return -EINVAL;
+		}
+		key_value_structure.public_exp_length = 0;
+		break;
+	case 3:
+		key_value_structure.public_exp_length = 1;
+		key_value_structure.public_exponent[0] = 3;
+		break;
+	case 5:
+		key_value_structure.public_exp_length = 1;
+		key_value_structure.public_exponent[0] = 5;
+		break;
+	case 17:
+		key_value_structure.public_exp_length = 1;
+		key_value_structure.public_exponent[0] = 17;
+		break;
+	case 257:
+		key_value_structure.public_exp_length = 2;
+		key_value_structure.public_exponent[0] = 0x01;
+		key_value_structure.public_exponent[0] = 0x01;
+		break;
+	case 65537:
+		key_value_structure.public_exp_length = 3;
+		key_value_structure.public_exponent[0] = 0x01;
+		key_value_structure.public_exponent[1] = 0x00;
+		key_value_structure.public_exponent[2] = 0x01;
+		break;
+	default:
+		pr_verbose(verbose, "Invalid public exponent: %d", pub_exp);
+		return -EINVAL;
+	}
+
+	key_value_structure_length = sizeof(key_value_structure) +
+				key_value_structure.public_exp_length;
+
+	rule_array_count = 2;
+	memcpy(rule_array, "RSA-AESC", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + CCA_KEYWORD_SIZE, "KEY-MGMT", CCA_KEYWORD_SIZE);
+
+	key_skeleton_length = sizeof(key_skeleton);
+
+	cca.dll_CSNDPKB(&return_code, &reason_code,
+			&exit_data_len, exit_data,
+			&rule_array_count, rule_array,
+			&key_value_structure_length,
+			(unsigned char *)&key_value_structure,
+			&private_key_name_length, private_key_name,
+			&param1, param2, &param1, param2,
+			&param1, param2, &param1, param2,
+			&param1, param2,
+			&key_skeleton_length, key_skeleton);
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDPKB (RSA KEY TOKEN BUILD) failed: "
+			  "return_code: %ld reason_code: %ld", return_code,
+			  reason_code);
+		return -EIO;
+	}
+
+	rule_array_count = 1;
+	memset(rule_array, 0, sizeof(rule_array));
+	memcpy(rule_array, "MASTER  ", (size_t)CCA_KEYWORD_SIZE);
+
+	cca.dll_CSNDPKG(&return_code, &reason_code,
+			NULL, NULL,
+			&rule_array_count, rule_array,
+			&regeneration_data_length, regeneration_data,
+			&key_skeleton_length, key_skeleton,
+			transport_key_identifier,
+			&token_length, key_token);
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDPKG (RSA KEY GENERATE) failed: "
+			  "return_code: %ld reason_code: %ld", return_code,
+			  reason_code);
+		return -EIO;
+	}
+
+	*key_token_length = token_length;
+
+	return 0;
+}
+
+/**
+ * Finds a specific section of a CCA internal PKA key token.
+ */
+static const void *_cca_get_pka_section(const unsigned char *key_token,
+					size_t key_token_length,
+					unsigned int section_id, bool verbose)
+{
+	const struct cca_section_header *section_hdr;
+	const struct cca_token_header *token_hdr;
+	size_t ofs;
+
+	if (key_token == NULL)
+		return NULL;
+
+	if (key_token_length < sizeof(struct cca_token_header)) {
+		pr_verbose(verbose, "key token length too small");
+		return NULL;
+	}
+
+	token_hdr = (struct cca_token_header *)key_token;
+	if (token_hdr->token_length > key_token_length) {
+		pr_verbose(verbose, "key token length too small");
+		return NULL;
+	}
+	if (token_hdr->token_identifier != CCA_TOKEN_ID_INTERNAL_PKA) {
+		pr_verbose(verbose, "not an internal PKA token");
+		return NULL;
+	}
+	if (token_hdr->token_version1 != CCA_TOKEN_VERS1_V0) {
+		pr_verbose(verbose, "invalid token version");
+		return NULL;
+	}
+
+	ofs = sizeof(struct cca_token_header);
+	section_hdr = (struct cca_section_header *)&key_token[ofs];
+
+	while (section_hdr->section_identifier != section_id) {
+		ofs += section_hdr->section_length;
+		if (ofs >= token_hdr->token_length) {
+			pr_verbose(verbose, "section %u not found", section_id);
+			return NULL;
+		}
+		section_hdr = (struct cca_section_header *)&key_token[ofs];
+	}
+
+	if (ofs + section_hdr->section_length > token_hdr->token_length) {
+		pr_verbose(verbose, "section exceed the token length");
+		return NULL;
+	}
+
+	return section_hdr;
+}
+
+/**
+ * Queries the PKEY type of the key token.
+ *
+ * @param key_token         the key token containing an CCA ECC key
+ * @param key_token_length  the size of the key token
+ * @param pkey_type         On return: the PKEY type of the key token
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_get_key_type(const unsigned char *key_token, size_t key_token_length,
+		     int *pkey_type)
+{
+	if (key_token == NULL || pkey_type == NULL)
+		return -EINVAL;
+
+	if (_cca_get_pka_section(key_token, key_token_length,
+				 CCA_SECTION_ID_ECC_PUBL, false) != NULL)
+		*pkey_type = EVP_PKEY_EC;
+	else if (_cca_get_pka_section(key_token, key_token_length,
+				      CCA_SECTION_ID_RSA_PUBL, false) != NULL)
+		*pkey_type = EVP_PKEY_RSA;
+	else
+		return -EINVAL;
+
+	return 0;
+}
+
+/**
+ * Extracts the ECC public key from an CCA internal ECC key token, and returns a
+ * it a OpenSSL PKEY.
+ *
+ * @param key_token         the key token containing an CCA ECC key
+ * @param key_token_length  the size of the key token
+ * @param pkey              On return: a PKEY containing the public key
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_get_ecc_pub_key_as_pkey(const unsigned char *key_token,
+				size_t key_token_length,
+				EVP_PKEY **pkey, bool verbose)
+{
+	struct cca_ecc_pub_key_section *ecc_pub_section;
+	const unsigned char *ecc_pub_key, *x, *y;
+	unsigned char *buf = NULL;
+	size_t prime_len;
+	int nid, y_bit = 0;
+	int rc = 0;
+
+	if (key_token == NULL ||  pkey == NULL)
+		return -EINVAL;
+
+	ecc_pub_section = (struct cca_ecc_pub_key_section *)
+			_cca_get_pka_section(key_token, key_token_length,
+					     CCA_SECTION_ID_ECC_PUBL, verbose);
+	if (ecc_pub_section == NULL)
+		return -EINVAL;
+	if (ecc_pub_section->section_header.section_version != 0x00) {
+		pr_verbose(verbose, "invalid ECC public key section version");
+		return -EINVAL;
+	}
+	if (ecc_pub_section->section_header.section_length <
+				sizeof(struct cca_ecc_pub_key_section)) {
+		pr_verbose(verbose, "invalid ECC public key section length");
+		return -EINVAL;
+	}
+
+	ecc_pub_key = ((unsigned char *)ecc_pub_section) +
+				sizeof(struct cca_ecc_pub_key_section);
+
+	if (ecc_pub_section->curve_type == CCA_PRIME_CURVE)
+		nid = ecc_get_prime_curve_by_prime_bits(
+				ecc_pub_section->prime_bits_length);
+	else if (ecc_pub_section->curve_type == CCA_BRAINPOOL_CURVE)
+		nid = ecc_get_brainpool_curve_by_prime_bits(
+				ecc_pub_section->prime_bits_length);
+	else
+		nid = 0;
+	if (nid == 0) {
+		pr_verbose(verbose, "unsupported curve");
+		rc = -EIO;
+		goto out;
+	}
+	prime_len = ecc_get_curve_prime_length(nid);
+
+	x = ecc_pub_key + 1;
+
+	/* First byte of public key contains indication of key compression */
+	switch (ecc_pub_key[0]) {
+	case POINT_CONVERSION_COMPRESSED:
+	case POINT_CONVERSION_COMPRESSED + POINT_CONVERSION_ODD_EVEN:
+		/* Compressed form, only x is available */
+		y_bit = (ecc_pub_key[0] & POINT_CONVERSION_ODD_EVEN) ? 1 : 0;
+
+		buf = malloc(prime_len);
+		if (buf == NULL) {
+			pr_verbose(verbose, "malloc failed");
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = ecc_calculate_y_coordinate(nid, prime_len, x, y_bit, buf);
+		if (rc != 0) {
+			pr_verbose(verbose, "ecc_calculate_y_coordinate "
+				   "failed");
+			goto out;
+		}
+
+		y = buf;
+		break;
+
+	case POINT_CONVERSION_UNCOMPRESSED:
+	case POINT_CONVERSION_HYBRID:
+	case POINT_CONVERSION_HYBRID + POINT_CONVERSION_ODD_EVEN:
+		/* Uncompressed or hybrid, x and y are available */
+		y = x + prime_len;
+		break;
+
+	default:
+		pr_verbose(verbose, "invalid compression indication");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = ecc_pub_key_as_pkey(nid, prime_len, x, y, pkey);
+	if (rc != 0) {
+		pr_verbose(verbose, "ecc_pub_key_as_pkey failed");
+		goto out;
+	}
+
+out:
+	if (buf != NULL)
+		free(buf);
+
+	return rc;
+}
+
+/**
+ * Extracts the ECC public key from an CCA internal ECC key token, and returns a
+ * JSON object representing the public key as JSON Web Key (JWK, see RFC7517).
+ * The returned JSON objects must be freed by the caller using json_object_put()
+ * when no longer needed.
+ *
+ * @param key_token         the key token containing an CCA ECC key
+ * @param key_token_length  the size of the key token
+ * qparam jwk               the ECC public key as JWT JSON object
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_get_ecc_pub_key_as_json_web_key(const unsigned char *key_token,
+					size_t key_token_length,
+					json_object **jwk, bool verbose)
+{
+	const struct cca_ecc_pub_key_section *ecc_pub_section;
+	const struct cca_section_header *section_hdr;
+	const struct cca_token_header *token_hdr;
+	const unsigned char *ecc_pub_key, *x, *y;
+	json_object *jwk_obj = NULL;
+	unsigned char *buf = NULL;
+	size_t ofs, prime_len;
+	int nid, y_bit = 0;
+	int rc = 0;
+
+	if (key_token == NULL ||  jwk == NULL)
+		return -EINVAL;
+
+	if (key_token_length < sizeof(struct cca_token_header)) {
+		pr_verbose(verbose, "key token length too small");
+		return -EINVAL;
+	}
+
+	token_hdr = (struct cca_token_header *)key_token;
+	if (token_hdr->token_length > key_token_length) {
+		pr_verbose(verbose, "key token length too small");
+		return -EINVAL;
+	}
+	if (token_hdr->token_identifier != CCA_TOKEN_ID_INTERNAL_PKA) {
+		pr_verbose(verbose, "not an internal PKA token");
+		return -EINVAL;
+	}
+	if (token_hdr->token_version1 != CCA_TOKEN_VERS1_V0) {
+		pr_verbose(verbose, "invalid token version");
+		return -EINVAL;
+	}
+
+	ofs = sizeof(struct cca_token_header);
+	section_hdr = (struct cca_section_header *)&key_token[ofs];
+
+	while (section_hdr->section_identifier != CCA_SECTION_ID_ECC_PUBL) {
+		ofs += section_hdr->section_length;
+		if (ofs >= token_hdr->token_length) {
+			pr_verbose(verbose, "no ECC public key section found");
+			return -EINVAL;
+		}
+		section_hdr = (struct cca_section_header *)&key_token[ofs];
+	}
+
+	if (section_hdr->section_version != 0x00) {
+		pr_verbose(verbose, "invalid ECC public key section version");
+		return -EINVAL;
+	}
+	if (section_hdr->section_length <
+				sizeof(struct cca_ecc_pub_key_section)) {
+		pr_verbose(verbose, "invalid ECC public key section length");
+		return -EINVAL;
+	}
+
+	ecc_pub_section = (struct cca_ecc_pub_key_section *)section_hdr;
+	ofs += sizeof(struct cca_ecc_pub_key_section);
+	ecc_pub_key = &key_token[ofs];
+
+	if (ecc_pub_section->curve_type == CCA_PRIME_CURVE)
+		nid = ecc_get_prime_curve_by_prime_bits(
+				ecc_pub_section->prime_bits_length);
+	else if (ecc_pub_section->curve_type == CCA_BRAINPOOL_CURVE)
+		nid = ecc_get_brainpool_curve_by_prime_bits(
+				ecc_pub_section->prime_bits_length);
+	else
+		nid = 0;
+	if (nid == 0) {
+		pr_verbose(verbose, "unsupported curve");
+		rc = -EIO;
+		goto out;
+	}
+	prime_len = ecc_get_curve_prime_length(nid);
+
+	x = ecc_pub_key + 1;
+
+	/* First byte of public key contains indication of key compression */
+	switch (ecc_pub_key[0]) {
+	case POINT_CONVERSION_COMPRESSED:
+	case POINT_CONVERSION_COMPRESSED + POINT_CONVERSION_ODD_EVEN:
+		/* Compressed form, only x is available */
+		y_bit = (ecc_pub_key[0] & POINT_CONVERSION_ODD_EVEN) ? 1 : 0;
+
+		buf = malloc(prime_len);
+		if (buf == NULL) {
+			pr_verbose(verbose, "malloc failed");
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = ecc_calculate_y_coordinate(nid, prime_len, x, y_bit, buf);
+		if (rc != 0) {
+			pr_verbose(verbose, "ecc_calculate_y_coordinate "
+				   "failed");
+			goto out;
+		}
+
+		y = buf;
+		break;
+
+	case POINT_CONVERSION_UNCOMPRESSED:
+	case POINT_CONVERSION_HYBRID:
+	case POINT_CONVERSION_HYBRID + POINT_CONVERSION_ODD_EVEN:
+		/* Uncompressed or hybrid, x and y are available */
+		y = x + prime_len;
+		break;
+
+	default:
+		pr_verbose(verbose, "invalid compression indication");
+		rc = -EIO;
+		goto out;
+	}
+
+	/* construct the JWK */
+	jwk_obj = json_object_new_object();
+	if (jwk_obj == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	/*
+	 * Note: The order of the fields is important, EKMFWeb expects it in
+	 * exactly this order!
+	 */
+	rc = json_object_object_add_ex(jwk_obj, "kty",
+				       json_object_new_string("EC"), 0);
+	rc |= json_object_object_add_ex(jwk_obj, "crv", json_object_new_string(
+					ecc_get_curve_id(nid)), 0);
+	rc |= json_object_object_add_ex(jwk_obj, "x",
+					json_object_new_base64url(x, prime_len),
+					0);
+	rc |= json_object_object_add_ex(jwk_obj, "y",
+					json_object_new_base64url(y, prime_len),
+					0);
+	if (rc != 0) {
+		rc = -EIO;
+		goto out;
+	}
+
+	*jwk = jwk_obj;
+
+out:
+	if (buf != NULL)
+		free(buf);
+	if (rc != 0 && jwk_obj != NULL)
+		json_object_put(jwk_obj);
+	return rc;
+}
+
+/**
+ * Extracts the RSA public key from an CCA internal RSA key token, and returns a
+ * it a OpenSSL PKEY.
+ *
+ * @param key_token         the key token containing an CCA RSA key
+ * @param key_token_length  the size of the key token
+ * @param pkey_type         the PKEY type (EVP_PKEY_RSA or EVP_PKEY_RSA_PSS)*
+ * @param pkey              On return: a PKEY containing the public key
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_get_rsa_pub_key_as_pkey(const unsigned char *key_token,
+				size_t key_token_length,
+				int pkey_type, EVP_PKEY **pkey, bool verbose)
+{
+	const struct cca_rsa_crt_priv_key_section *rsa_priv_section;
+	const struct cca_rsa_pub_key_section *rsa_pub_section;
+	const unsigned char *pub_exp, *modulus;
+	size_t modulus_length;
+	int rc = 0;
+
+	if (key_token == NULL ||  pkey == NULL)
+		return -EINVAL;
+
+	rsa_pub_section = (struct cca_rsa_pub_key_section *)
+			_cca_get_pka_section(key_token, key_token_length,
+				CCA_SECTION_ID_RSA_PUBL, verbose);
+	if (rsa_pub_section == NULL)
+		return -EINVAL;
+	if (rsa_pub_section->section_header.section_version != 0x00) {
+		pr_verbose(verbose, "invalid RSA public key section version");
+		return -EINVAL;
+	}
+	if (rsa_pub_section->section_header.section_length <
+				sizeof(struct cca_ecc_pub_key_section)) {
+		pr_verbose(verbose, "invalid RSA public key section length");
+		return -EINVAL;
+	}
+
+	pub_exp = ((unsigned char *)rsa_pub_section) +
+				sizeof(struct cca_rsa_pub_key_section);
+	modulus = pub_exp + rsa_pub_section->pub_exp_length;
+	modulus_length = rsa_pub_section->modulus_length;
+
+	/*
+	 * The public key section may have a modulus_length of zero, need to
+	 * get the modulus from the private key section instead.
+	 */
+	if (rsa_pub_section->modulus_length == 0) {
+		rsa_priv_section = (struct cca_rsa_crt_priv_key_section *)
+			_cca_get_pka_section(key_token, key_token_length,
+				CCA_SECTION_ID_RSA_CRT_4096_EOPK_PRIV, verbose);
+
+		if (rsa_priv_section == NULL)
+			return -EINVAL;
+		if (rsa_priv_section->section_header.section_version != 0x00) {
+			pr_verbose(verbose, "invalid RSA private key section "
+				   "version");
+			return -EINVAL;
+		}
+		if (rsa_priv_section->section_header.section_length <
+				sizeof(struct cca_rsa_crt_priv_key_section)) {
+			pr_verbose(verbose, "invalid RSA private key section "
+				   "length");
+			return -EINVAL;
+		}
+
+		modulus =  ((unsigned char *)rsa_priv_section) +
+				sizeof(struct cca_rsa_crt_priv_key_section);
+		modulus_length = rsa_priv_section->modulus_length;
+	}
+
+	rc = rsa_pub_key_as_pkey(modulus, modulus_length, pub_exp,
+				 rsa_pub_section->pub_exp_length,
+				 pkey_type, pkey);
+	if (rc != 0) {
+		pr_verbose(verbose, "rsa_pub_key_as_pkey failed");
+		goto out;
+	}
+
+out:
+	return rc;
+}
+
+/**
+ * Re-enciphers a key token with a new CCA master key.
+ *
+ * @param cca_lib           the CCA library structure
+ * @param key_token         the key token containing an CCA ECC or RSA key.
+ *                          The re-enciphered key token is returned in the same
+ *                          buffer. The size of the re-enciphered key token
+ *                          remains the same.
+ * @param key_token_length  the size of the key token
+ * @param to_new            If true: the key token is re-enciphered from the
+ *                          current to the new master key.
+ *                          If false: the key token is re-enciphered from the
+ *                          old to the current master key.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ * -ENODEV is returned if the master keys are not loaded.
+ */
+int cca_reencipher_key(const struct ekmf_cca_lib *cca_lib,
+		       const unsigned char *key_token, size_t key_token_length,
+		       bool to_new, bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	unsigned char rule_array[2 * CCA_KEYWORD_SIZE] = { 0, };
+	unsigned char *exit_data = NULL;
+	struct cca_lib cca;
+	long token_length;
+	int rc, type;
+
+	if (cca_lib == NULL || key_token == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	rc = cca_get_key_type(key_token, key_token_length, &type);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to determine the key token type");
+		return rc;
+	}
+
+	rule_array_count = 2;
+	switch (type) {
+	case EVP_PKEY_EC:
+		memcpy(rule_array, "ECC     ", CCA_KEYWORD_SIZE);
+		break;
+	case EVP_PKEY_RSA:
+	case EVP_PKEY_RSA_PSS:
+		memcpy(rule_array, "RSA     ", CCA_KEYWORD_SIZE);
+		break;
+	default:
+		pr_verbose(verbose, "Invalid key token type: %d", type);
+		return -EINVAL;
+	}
+
+	if (to_new)
+		memcpy(rule_array + CCA_KEYWORD_SIZE, "RTNMK   ",
+		       CCA_KEYWORD_SIZE);
+	else
+		memcpy(rule_array + CCA_KEYWORD_SIZE, "RTCMK   ",
+		       CCA_KEYWORD_SIZE);
+
+	token_length = key_token_length;
+
+	cca.dll_CSNDKTC(&return_code, &reason_code,
+			&exit_data_len, exit_data,
+			&rule_array_count, rule_array,
+			&token_length, (unsigned char *)key_token);
+
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDKTC (PKA KEY TOKEN CHANGE) failed:"
+			  " return_code: %ld reason_code: %ld", return_code,
+			  reason_code);
+
+		if (return_code == 12 && reason_code == 764) {
+			pr_verbose(verbose, "The master keys are not loaded");
+			return -ENODEV;
+		}
+
+		return -EIO;
+	}
+
+	return 0;
+}
+
+/**
+ * Import a CCA key from a JSON object representing a key as JSON Web Key (JWK,
+ * see RFC7517). The JWK can either be an ECC public key (kty=EC), or an
+ * symmetric key (kty=oct) containing an CCA external variable length key token
+ * (alg=A256KW-CCA).
+ *
+ * @param cca_lib           the CCA library structure
+ * @param jwk               the JWT JSON object containing the key to import
+ * @param key_token         a buffer to store the imported key token
+ * @param key_token_length  On entry: the size of the buffer
+ *                          On return: the size of the key token
+
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_import_key_from_json_web_key(const struct ekmf_cca_lib *cca_lib,
+				     json_object *jwk, unsigned char *key_token,
+				     size_t *key_token_length, bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	long key_value_struct_length, private_key_name_length = 0;
+	struct cca_ecc_pub_key_value_struct *key_value_struct = NULL;
+	unsigned char private_key_name[CCA_KEY_ID_SIZE] = { 0, };
+	unsigned char rule_array[1 * CCA_KEYWORD_SIZE] = { 0, };
+	unsigned char *exit_data = NULL;
+	size_t prime_len, q_len, len;
+	unsigned char *param2 = NULL;
+	struct cca_token_header *hdr;
+	const char *kty, *crv, *alg;
+	struct cca_lib cca;
+	long token_length;
+	unsigned char *q;
+	long param1 = 0;
+	int nid, rc = 0;
+
+	if (cca_lib == NULL || jwk == NULL || key_token == NULL ||
+	    key_token_length == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	memset(key_token, 0, *key_token_length);
+
+	kty = json_get_string(jwk, "kty");
+	if (kty == NULL) {
+		pr_verbose(verbose, "JWK does not contain field 'kty'");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (strcmp(kty, "EC") == 0) {
+		crv = json_get_string(jwk, "crv");
+		if (crv == NULL) {
+			pr_verbose(verbose, "JWK does not contain field 'crv'");
+			rc = -EIO;
+			goto out;
+		}
+
+		nid = ecc_get_curve_by_id(crv);
+		if (nid == 0) {
+			pr_verbose(verbose, "curve '%s' not supported", crv);
+			rc = -EIO;
+			goto out;
+		}
+
+		prime_len = ecc_get_curve_prime_length(nid);
+		if (prime_len == 0) {
+			pr_verbose(verbose, "curve %d not supported", nid);
+			rc = -EIO;
+			goto out;
+		}
+
+		q_len = 1 + 2 * prime_len;
+		key_value_struct_length =
+			sizeof(struct cca_ecc_pub_key_value_struct) + q_len;
+		key_value_struct = (struct cca_ecc_pub_key_value_struct *)
+			malloc(key_value_struct_length);
+		if (key_value_struct == NULL) {
+			pr_verbose(verbose, "malloc failed");
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		memset(key_value_struct, 0, sizeof(*key_value_struct));
+		if (ecc_is_prime_curve(nid)) {
+			key_value_struct->curve_type = CCA_PRIME_CURVE;
+		} else if (ecc_is_brainpool_curve(nid)) {
+			key_value_struct->curve_type = CCA_BRAINPOOL_CURVE;
+		} else {
+			pr_verbose(verbose, "Unsupported curve: %d", nid);
+			rc = -EINVAL;
+			goto out;
+		}
+		key_value_struct->curve_length = ecc_get_curve_prime_bits(nid);
+		key_value_struct->public_key_len = q_len;
+
+		q = ((unsigned char *)key_value_struct) +
+				sizeof(struct cca_ecc_pub_key_value_struct);
+		q[0] = POINT_CONVERSION_UNCOMPRESSED;
+
+		len = prime_len;
+		rc = json_object_get_base64url(jwk, "x", &q[1], &len);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to get and decode x");
+			goto out;
+		}
+
+		len = prime_len;
+		rc = json_object_get_base64url(jwk, "y", &q[1 + prime_len],
+					       &len);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to get and decode y");
+			goto out;
+		}
+
+		rule_array_count = 1;
+		memcpy(rule_array, "ECC-PUBL", CCA_KEYWORD_SIZE);
+
+		token_length = *key_token_length;
+
+		cca.dll_CSNDPKB(&return_code, &reason_code,
+				&exit_data_len, exit_data,
+				&rule_array_count, rule_array,
+				&key_value_struct_length,
+				(unsigned char *)key_value_struct,
+				&private_key_name_length, private_key_name,
+				&param1, param2, &param1, param2,
+				&param1, param2, &param1, param2,
+				&param1, param2,
+				&token_length, key_token);
+		if (return_code != 0) {
+			pr_verbose(verbose, "CCA CSNDPKB (EC KEY TOKEN BUILD) "
+				  "failed: return_code: %ld reason_code: %ld",
+				  return_code, reason_code);
+			return -EIO;
+		}
+
+		*key_token_length = token_length;
+	} else if (strcmp(kty, "oct") == 0) {
+		alg = json_get_string(jwk, "alg");
+		if (alg == NULL) {
+			pr_verbose(verbose, "JWK does not contain field 'alg'");
+			rc = -EIO;
+			goto out;
+		}
+
+		if (strcmp(alg, "A256KW-CCA") != 0) {
+			pr_verbose(verbose, "JWK alg is not A256KW-CCA");
+			rc = -EIO;
+			goto out;
+		}
+
+		rc = json_object_get_base64url(jwk, "k", key_token,
+					       key_token_length);
+		if (rc != 0) {
+			pr_verbose(verbose, "failed to get and decode k");
+			goto out;
+		}
+
+		/* Ensure that this is an CCA external AES CIPHER key token */
+		if (*key_token_length < sizeof(struct cca_token_header)) {
+			pr_verbose(verbose, "key token is too small");
+			rc = -EIO;
+			goto out;
+		}
+		hdr = (struct cca_token_header *)key_token;
+		if (hdr->token_identifier != CCA_TOKEN_ID_EXTERNAL_SYMMETRIC ||
+		    hdr->token_version2 != CCA_TOKEN_VERS2_AES_CIPHER ||
+		    *key_token_length < hdr->token_length) {
+			pr_verbose(verbose, "key token is not a valid CCA "
+				   "external AES CIPHER key");
+			rc = -EIO;
+			goto out;
+		}
+	} else {
+		pr_verbose(verbose, "Key type '%s' not supported", kty);
+		rc = -EIO;
+		goto out;
+	}
+
+out:
+	if (key_value_struct != NULL)
+		free(key_value_struct);
+
+	return rc;
+}
+
+/**
+ * Drives an AES-256 key using the ED-DH key derivation method using a local ECC
+ * private/public key pair, a foreign public ECC key, and a shared party
+ * information data. The derived key is an internal CCA AES key token containing
+ * the derived key in its IMPORTER key form.
+ *
+ * @param cca_lib           the CCA library structure
+ * @param priv_ecc_keyf_token the ECC private key token
+ * @param priv_ecc_key_token_length the length of the ECC private key token
+ * @param pub_ecc_key_token the ECC public key token of the other side
+ * @param pub_ecc_key_token_length the length of the ECC public key token
+ * @param party_info        the shared data used on both sides
+ * @param party_info_length the length of the shared data
+ * @param kdf               the key derivation function to use
+ * @param derived_key_token a buffer to store the derived key token
+ * @param derived_key_token_length  On entry: the size of the buffer
+ *                          On return: the size of the derived key token
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_ec_dh_derive_importer(const struct ekmf_cca_lib *cca_lib,
+			      const unsigned char *priv_ecc_key_token,
+			      size_t priv_ecc_key_token_length,
+			      const unsigned char *pub_ecc_key_token,
+			      size_t pub_ecc_key_token_length,
+			      const unsigned char *party_info,
+			      size_t party_info_length,
+			      enum cca_kdf kdf,
+			      unsigned char *derived_key_token,
+			      size_t *derived_key_token_length,
+			      bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	long priv_length, pub_length, info_length, derived_length;
+	unsigned char rule_array[3 * CCA_KEYWORD_SIZE] = { 0, };
+	unsigned char key_name[CCA_KEY_ID_SIZE] = { 0, };
+	long key_name_length = 0, key_skeleton_length;
+	unsigned char *exit_data = NULL;
+	unsigned char *param2 = NULL;
+	long key_bit_length = 256;
+	struct cca_lib cca;
+	long param1 = 0;
+	int rc;
+
+	if (cca_lib == NULL || priv_ecc_key_token == NULL ||
+	    pub_ecc_key_token == NULL || party_info == NULL ||
+	    derived_key_token == NULL || derived_key_token_length == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	memset(derived_key_token, 0, *derived_key_token_length);
+
+	rule_array_count = 3;
+	memcpy(rule_array, "INTERNAL", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + CCA_KEYWORD_SIZE, "AES     ", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + 2 * CCA_KEYWORD_SIZE, "IMPORTER", CCA_KEYWORD_SIZE);
+
+	key_skeleton_length = *derived_key_token_length;
+
+	cca.dll_CSNBKTB2(&return_code, &reason_code,
+			 &exit_data_len, exit_data,
+			 &rule_array_count, rule_array,
+			 &param1, param2,
+			 &key_name_length, key_name,
+			 &param1, param2,
+			 &param1, param2,
+			 &param1, param2,
+			 &key_skeleton_length, derived_key_token);
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNBKTB2 (KEY TOKEN BUILD2) failed: "
+			  "return_code: %ld reason_code: %ld", return_code,
+			  reason_code);
+		return -EIO;
+	}
+
+	switch (kdf) {
+	case CCA_KDF_ANS_X9_63_CCA:
+		rule_array_count = 1;
+		memcpy(rule_array, "DERIV01 ", CCA_KEYWORD_SIZE);
+		break;
+	case CCA_KDF_ANS_X9_63_SHA224:
+		rule_array_count = 2;
+		memcpy(rule_array, "DERIV02 ", CCA_KEYWORD_SIZE);
+		memcpy(rule_array + CCA_KEYWORD_SIZE, "SHA-224 ",
+		       CCA_KEYWORD_SIZE);
+		break;
+	case CCA_KDF_ANS_X9_63_SHA256:
+		rule_array_count = 2;
+		memcpy(rule_array, "DERIV02 ", CCA_KEYWORD_SIZE);
+		memcpy(rule_array + CCA_KEYWORD_SIZE, "SHA-256 ",
+		       CCA_KEYWORD_SIZE);
+		break;
+	case CCA_KDF_ANS_X9_63_SHA384:
+		rule_array_count = 2;
+		memcpy(rule_array, "DERIV02 ", CCA_KEYWORD_SIZE);
+		memcpy(rule_array + CCA_KEYWORD_SIZE, "SHA-384 ",
+		       CCA_KEYWORD_SIZE);
+		break;
+	case CCA_KDF_ANS_X9_63_SHA512:
+		rule_array_count = 2;
+		memcpy(rule_array, "DERIV02 ", CCA_KEYWORD_SIZE);
+		memcpy(rule_array + CCA_KEYWORD_SIZE, "SHA-512 ",
+		       CCA_KEYWORD_SIZE);
+		break;
+	default:
+		pr_verbose(verbose, "Invalid CCA KDF: %d", kdf);
+		return -EINVAL;
+	}
+
+	priv_length = priv_ecc_key_token_length;
+	pub_length = pub_ecc_key_token_length;
+	derived_length = *derived_key_token_length;
+	info_length = party_info_length;
+
+	cca.dll_CSNDEDH(&return_code, &reason_code,
+			&exit_data_len, exit_data,
+			&rule_array_count, rule_array,
+			&priv_length, (unsigned char *)priv_ecc_key_token,
+			&param1, param2,
+			&pub_length, (unsigned char *)pub_ecc_key_token,
+			&param1, param2,
+			&info_length, (unsigned char *)party_info,
+			&key_bit_length,
+			&param1, param2, &param1, param2,
+			&param1, param2, &param1, param2,
+			&param1, param2, &param1, param2,
+			&derived_length, derived_key_token);
+
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDEDH (EC DIFFIE-HELLMAN) failed: "
+			  "return_code: %ld reason_code: %ld", return_code,
+			  reason_code);
+		return -EIO;
+	}
+
+	*derived_key_token_length = derived_length;
+
+	return 0;
+}
+
+/**
+ * Imports an CCA external variable length AES key token using a wrapping key
+ * in IMPORTER key form.
+ *
+ * @param cca_lib           the CCA library structure
+ * @param external_key_token the external key to import
+ * @param external_key_token_length the length of the external key
+ * @param importer_key_token the wrapping key in IMPORTER key form
+ * @param importer_key_token_length the length of the wrapping key
+ * @param imported_key_token a buffer to store the derived key token
+ * @param imported_key_token_length  On entry: the size of the buffer
+ *                          On return: the size of the imported key token
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_import_external_key(const struct ekmf_cca_lib *cca_lib,
+			    const unsigned char *external_key_token,
+			    size_t external_key_token_length,
+			    const unsigned char *importer_key_token,
+			    size_t importer_key_token_length,
+			    unsigned char *imported_key_token,
+			    size_t *imported_key_token_length,
+			    bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	unsigned char rule_array[2 * CCA_KEYWORD_SIZE] = { 0, };
+	unsigned char key_name[CCA_KEY_ID_SIZE] = { 0, };
+	long ext_length, importer_length, imp_length;
+	unsigned char *exit_data = NULL;
+	long key_name_length = 0;
+	struct cca_lib cca;
+	int rc;
+
+	if (cca_lib == NULL || external_key_token == NULL ||
+	    importer_key_token == NULL || imported_key_token == NULL ||
+	    imported_key_token_length == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	memset(imported_key_token, 0, *imported_key_token_length);
+
+	rule_array_count = 2;
+	memcpy(rule_array, "AES     ", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + CCA_KEYWORD_SIZE, "AESKW   ", CCA_KEYWORD_SIZE);
+
+	ext_length = external_key_token_length;
+	importer_length = importer_key_token_length;
+	imp_length = *imported_key_token_length;
+
+	cca.dll_CSNDSYI2(&return_code, &reason_code,
+			 &exit_data_len, exit_data,
+			 &rule_array_count, rule_array,
+			 &ext_length, (unsigned char *)external_key_token,
+			 &importer_length, (unsigned char *)importer_key_token,
+			 &key_name_length, key_name,
+			 &imp_length, imported_key_token);
+
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDSYI2 (SYMM. KEY IMPORT) failed: "
+			  "return_code: %ld reason_code: %ld", return_code,
+			  reason_code);
+		return -EIO;
+	}
+
+	*imported_key_token_length = imp_length;
+
+	return 0;
+}
+
+static const unsigned char der_DigestInfo_SHA1[] = {
+	0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x0e,
+	0x03, 0x02, 0x1a, 0x05, 0x00, 0x04, 0x14, };
+static const unsigned char der_DigestInfo_SHA224[] = {
+	0x30, 0x2d, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
+	0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x04, 0x05,
+	0x00, 0x04, 0x1C, };
+static const unsigned char der_DigestInfo_SHA256[] = {
+	0x30, 0x31, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
+	0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x01, 0x05,
+	0x00, 0x04, 0x20, };
+static const unsigned char der_DigestInfo_SHA384[] = {
+	0x30, 0x41, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
+	0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x02, 0x05,
+	0x00, 0x04, 0x30, };
+static const unsigned char der_DigestInfo_SHA512[] = {
+	0x30, 0x51, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
+	0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x03, 0x05,
+	0x00, 0x04, 0x40, };
+static const unsigned char der_DigestInfo_SHA3_224[] = {
+	0x30, 0x2d, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
+	0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x07, 0x05,
+	0x00, 0x04, 0x1C, };
+static const unsigned char der_DigestInfo_SHA3_256[] = {
+	0x30, 0x31, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
+	0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x08, 0x05,
+	0x00, 0x04, 0x20, };
+static const unsigned char der_DigestInfo_SHA3_384[] = {
+	0x30, 0x41, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
+	0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x09, 0x05,
+	0x00, 0x04, 0x30, };
+static const unsigned char der_DigestInfo_SHA3_512[] = {
+	0x30, 0x51, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
+	0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x0a, 0x05,
+	0x00, 0x04, 0x40, };
+
+struct digest_info {
+	int digest_nid;
+	size_t digest_size;
+	const char *cca_keyword;
+	const unsigned char *der;
+	size_t der_size;
+};
+
+static const struct digest_info digest_list[] = {
+	{ .digest_nid = NID_sha1, .digest_size = SHA_DIGEST_LENGTH,
+	  .cca_keyword = "SHA-1   ", .der = der_DigestInfo_SHA1,
+	  .der_size = sizeof(der_DigestInfo_SHA1), },
+	{ .digest_nid = NID_sha224, .digest_size = SHA224_DIGEST_LENGTH,
+	  .cca_keyword = "SHA-224 ", .der = der_DigestInfo_SHA224,
+	  .der_size = sizeof(der_DigestInfo_SHA224), },
+	{ .digest_nid = NID_sha256, .digest_size = SHA256_DIGEST_LENGTH,
+	  .cca_keyword = "SHA-256 ", .der = der_DigestInfo_SHA256,
+	  .der_size = sizeof(der_DigestInfo_SHA256), },
+	{ .digest_nid = NID_sha384, .digest_size = SHA384_DIGEST_LENGTH,
+	  .cca_keyword = "SHA-384 ", .der = der_DigestInfo_SHA384,
+	  .der_size = sizeof(der_DigestInfo_SHA384), },
+	{ .digest_nid = NID_sha512, .digest_size = SHA512_DIGEST_LENGTH,
+	  .cca_keyword = "SHA-512 ", .der = der_DigestInfo_SHA512,
+	  .der_size = sizeof(der_DigestInfo_SHA512), },
+	{ .digest_nid = NID_sha3_224, .digest_size = SHA224_DIGEST_LENGTH,
+	  .cca_keyword = NULL, .der = der_DigestInfo_SHA3_224,
+	  .der_size = sizeof(der_DigestInfo_SHA3_224), },
+	{ .digest_nid = NID_sha3_256, .digest_size = SHA256_DIGEST_LENGTH,
+	  .cca_keyword = NULL, .der = der_DigestInfo_SHA3_256,
+	  .der_size = sizeof(der_DigestInfo_SHA3_256), },
+	{ .digest_nid = NID_sha3_384, .digest_size = SHA384_DIGEST_LENGTH,
+	  .cca_keyword = NULL, .der = der_DigestInfo_SHA3_384,
+	  .der_size = sizeof(der_DigestInfo_SHA3_384), },
+	{ .digest_nid = NID_sha3_512, .digest_size = SHA512_DIGEST_LENGTH,
+	  .cca_keyword = NULL, .der = der_DigestInfo_SHA3_512,
+	  .der_size = sizeof(der_DigestInfo_SHA3_512), },
+};
+
+static const int digest_list_num = sizeof(digest_list) /
+						sizeof(struct digest_info);
+
+static const struct digest_info *get_digest_info(int digest_nid)
+{
+	int i;
+
+	for (i = 0; i < digest_list_num; i++) {
+		if (digest_list[i].digest_nid == digest_nid)
+			return &digest_list[i];
+	}
+
+	return NULL;
+}
+
+struct cca_private_data {
+	CSNDDSG_t dll_CSNDDSG;
+	bool verbose;
+};
+
+/**
+ * Sign data using RSA.
+ *
+ * @param cca_lib           the CCA library structure
+ * @param key_token         the RSA key token
+ * @param key_token_length  the length of the key token
+ * @param sig               a buffer to store the signature on return.
+ * @param siglen            on input: the size if the signature buffer
+ *                          on return: the size of the signature
+ * @param tbs               the data to be signed.
+ * @param tbslen            the size of the data to be signed
+ * @param padding_type      the OpenSSL padding type (RSA_X931_PADDING or
+ *                          RSA_PKCS1_PADDING)
+ * @param digest_nid        the OpenSSL nid of the message digest used to
+ *                          produce the data to be signed
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_rsa_sign(const struct ekmf_cca_lib *cca_lib,
+		 const unsigned char *key_token, size_t key_token_length,
+		 unsigned char *sig, size_t *siglen,
+		 const unsigned char *tbs, size_t tbslen,
+		 int padding_type, int md_nid, bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	long token_length, hash_length, sign_bit_length, sign_length;
+	unsigned char rule_array[3 * CCA_KEYWORD_SIZE] = { 0, };
+	unsigned char *hash = NULL, *buf = NULL;
+	const struct digest_info *digest;
+	unsigned char *exit_data = NULL;
+	struct cca_lib cca;
+	int rc;
+
+	if (cca_lib == NULL || key_token == NULL || sig == NULL ||
+	    siglen == NULL || tbs == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	rule_array_count = 3;
+	memcpy(rule_array, "RSA     ", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + CCA_KEYWORD_SIZE, "HASH    ", CCA_KEYWORD_SIZE);
+
+	switch (padding_type) {
+	case RSA_X931_PADDING:
+		hash = (unsigned char *)tbs;
+		hash_length = tbslen;
+
+		memcpy(rule_array + 2 * CCA_KEYWORD_SIZE, "X9.31   ",
+		       CCA_KEYWORD_SIZE);
+		break;
+
+	case RSA_PKCS1_PADDING:
+		digest = get_digest_info(md_nid);
+		if (digest == NULL) {
+			pr_verbose(verbose, "Invalid digest nid: %d", md_nid);
+			return -EINVAL;
+		}
+
+		if (tbslen != digest->digest_size) {
+			pr_verbose(verbose, "Invalid data length: %lu", tbslen);
+			return -EINVAL;
+		}
+
+		hash_length = digest->der_size + tbslen;
+		buf = (unsigned char *)malloc(hash_length);
+		if (buf == NULL) {
+			pr_verbose(verbose, "malloc failed");
+			return -ENOMEM;
+		}
+
+		memcpy(buf, digest->der, digest->der_size);
+		memcpy(buf + digest->der_size, tbs, tbslen);
+		hash = buf;
+
+		memcpy(rule_array + 2 * CCA_KEYWORD_SIZE, "PKCS-1.1",
+		       CCA_KEYWORD_SIZE);
+		break;
+
+	default:
+		pr_verbose(verbose, "Invalid padding type: %d", padding_type);
+		return -EINVAL;
+	}
+
+	token_length = key_token_length;
+	sign_length = *siglen;
+
+	cca.dll_CSNDDSG(&return_code, &reason_code,
+			&exit_data_len, exit_data,
+			&rule_array_count, rule_array,
+			&token_length, (unsigned char *)key_token,
+			&hash_length, hash,
+			&sign_length, &sign_bit_length, sig);
+
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDDSG (DIG. SIGNATURE CREATE, RSA) "
+			  "failed: return_code: %ld reason_code: %ld",
+			  return_code, reason_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	*siglen = sign_length;
+	rc = 0;
+
+out:
+	if (buf != NULL)
+		free(buf);
+
+	return rc;
+}
+
+/**
+ * Sign data using RSA-PSS.
+ *
+ * @param cca_lib           the CCA library structure
+ * @param key_token         the RSA key token
+ * @param key_token_length  the length of the key token
+ * @param sig               a buffer to store the signature on return.
+ * @param siglen            on input: the size if the signature buffer
+ *                          on return: the size of the signature
+ * @param tbs               the data to be signed.
+ * @param tbslen            the size of the data to be signed
+ * @param digest_nid        the OpenSSL nid of the message digest used to
+ *                          produce the data to be signed
+ * @param mgf_digest_nid    the OpenSSL nid of the mask generation function for
+ *                          PSS padding
+ * @param saltlen           the length of the salt for PSS
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_rsa_pss_sign(const struct ekmf_cca_lib *cca_lib,
+		     const unsigned char *key_token, size_t key_token_length,
+		     unsigned char *sig, size_t *siglen,
+		     const unsigned char *tbs, size_t tbslen,
+		     int digest_nid, int mgf_digest_nid, int saltlen,
+		     bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	unsigned char rule_array[4 * CCA_KEYWORD_SIZE] = { 0, };
+	long token_length, hash_length, sign_bit_length, sign_length;
+	const struct digest_info *digest;
+	unsigned char *exit_data = NULL;
+	unsigned char *buf = NULL;
+	struct cca_lib cca;
+	uint32_t salt_len;
+	int rc;
+
+	if (cca_lib == NULL || key_token == NULL || sig == NULL ||
+	    siglen == NULL || tbs == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	if (mgf_digest_nid != digest_nid) {
+		pr_verbose(verbose, "Mgf nid must be the same as the message "
+			   "digest nid");
+		return -EINVAL;
+	}
+
+	digest = get_digest_info(digest_nid);
+	if (digest == NULL || digest->cca_keyword == NULL) {
+		pr_verbose(verbose, "Invalid mgf nid: %d", digest_nid);
+		return -EINVAL;
+	}
+
+	rule_array_count = 4;
+	memcpy(rule_array, "RSA     ", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + CCA_KEYWORD_SIZE, "PKCS-PSS", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + 2 * CCA_KEYWORD_SIZE, "HASH    ", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + 3 * CCA_KEYWORD_SIZE, digest->cca_keyword,
+	       CCA_KEYWORD_SIZE);
+
+	hash_length = sizeof(uint32_t) + tbslen;
+	buf = (unsigned char *)malloc(hash_length);
+	if (buf == NULL) {
+		pr_verbose(verbose, "malloc failed");
+		return -ENOMEM;
+	}
+
+	salt_len = saltlen;
+	memcpy(buf, &salt_len, sizeof(uint32_t));
+	memcpy(buf + sizeof(uint32_t), tbs, tbslen);
+
+	token_length = key_token_length;
+	sign_length = *siglen;
+
+	cca.dll_CSNDDSG(&return_code, &reason_code,
+			&exit_data_len, exit_data,
+			&rule_array_count, rule_array,
+			&token_length, (unsigned char *)key_token,
+			&hash_length, buf,
+			&sign_length, &sign_bit_length, sig);
+
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDDSG (DIG. SIGNATURE CREATE, "
+			   "RSA-PSS) failed: return_code: %ld reason_code: %ld",
+			   return_code, reason_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	*siglen = sign_length;
+	rc = 0;
+
+out:
+	free(buf);
+
+	return rc;
+}
+
+/**
+ * Sign data using ECDSA.
+ *
+ * @param cca_lib           the CCA library structure
+ * @param key_token         the RSA key token
+ * @param key_token_length  the length of the key token
+ * @param sig               a buffer to store the signature on return.
+ * @param siglen            on input: the size if the signature buffer
+ *                          on return: the size of the signature
+ * @param tbs               the data to be signed.
+ * @param tbslen            the size of the data to be signed
+ * @param digest_nid        the OpenSSL nid of the message digest used to
+ *                          produce the data to be signed
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int cca_ecdsa_sign(const struct ekmf_cca_lib *cca_lib,
+		   const unsigned char *key_token, size_t key_token_length,
+		   unsigned char *sig, size_t *siglen,
+		   const unsigned char *tbs, size_t tbslen,
+		   int UNUSED(digest_nid), bool verbose)
+{
+	long return_code, reason_code, rule_array_count, exit_data_len = 0;
+	long token_length, hash_length, sign_bit_length, sign_length;
+	unsigned char rule_array[2 * CCA_KEYWORD_SIZE] = { 0, };
+	unsigned char *exit_data = NULL;
+	unsigned char *der = NULL;
+	ECDSA_SIG *ec_sig = NULL;
+	BIGNUM *bn_r = NULL;
+	BIGNUM *bn_s = NULL;
+	struct cca_lib cca;
+	int rc, der_len;
+
+	if (cca_lib == NULL || key_token == NULL || sig == NULL ||
+	    siglen == NULL || tbs == NULL)
+		return -EINVAL;
+
+	rc = _cca_get_library_functions(cca_lib, &cca);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CCA functions from library");
+		return rc;
+	}
+
+	rule_array_count = 2;
+	memcpy(rule_array, "ECDSA   ", CCA_KEYWORD_SIZE);
+	memcpy(rule_array + CCA_KEYWORD_SIZE, "HASH    ", CCA_KEYWORD_SIZE);
+
+	hash_length = tbslen;
+	token_length = key_token_length;
+	sign_length = *siglen;
+
+	cca.dll_CSNDDSG(&return_code, &reason_code,
+			&exit_data_len, exit_data,
+			&rule_array_count, rule_array,
+			&token_length, (unsigned char *)key_token,
+			&hash_length, (unsigned char *)tbs,
+			&sign_length, &sign_bit_length, sig);
+
+	if (return_code != 0) {
+		pr_verbose(verbose, "CCA CSNDDSG (DIG. SIGNATURE CREATE, ECDSA)"
+			   " failed: return_code: %ld reason_code: %ld",
+			   return_code, reason_code);
+		return -EIO;
+	}
+
+	ec_sig = ECDSA_SIG_new();
+	if (ec_sig == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	bn_r = BN_bin2bn(sig, sign_length / 2, NULL);
+	bn_s = BN_bin2bn(sig + sign_length / 2, sign_length / 2, NULL);
+	if (bn_r == NULL || bn_s == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	if (ECDSA_SIG_set0(ec_sig, bn_r, bn_s) != 1) {
+		rc = -EIO;
+		goto out;
+	}
+	bn_r = NULL;
+	bn_s = NULL;
+
+	der_len = i2d_ECDSA_SIG(ec_sig, NULL);
+	if (der_len > (int)*siglen) {
+		rc = -ERANGE;
+		goto out;
+	}
+
+	memset(sig, 0, *siglen);
+	der = sig;
+	*siglen = i2d_ECDSA_SIG(ec_sig, &der);
+
+	if (*siglen == 0) {
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = 0;
+out:
+	if (ec_sig != NULL)
+		ECDSA_SIG_free(ec_sig);
+	if (bn_r != NULL)
+		BN_free(bn_r);
+	if (bn_s != NULL)
+		BN_free(bn_s);
+
+	return rc;
+}
+
diff -pruN 2.14.0-2/libekmfweb/cca.h 2.15.1-0ubuntu2/libekmfweb/cca.h
--- 2.14.0-2/libekmfweb/cca.h	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/libekmfweb/cca.h	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,247 @@
+/*
+ * libekmfweb - EKMFWeb client library
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+
+#ifndef CCA_H
+#define CCA_H
+
+#include <stddef.h>
+#include <stdbool.h>
+
+#include <openssl/evp.h>
+
+#include <json-c/json.h>
+
+#include "ekmfweb/ekmfweb.h"
+
+/* CCA PKA Key Generate function */
+typedef void (*CSNDPKG_t)(long *return_code,
+			  long *reason_code,
+			  long *exit_data_length,
+			  unsigned char *exit_data,
+			  long *rule_array_count,
+			  unsigned char *rule_array,
+			  long *regeneration_data_length,
+			  unsigned char *regeneration_data,
+			  long *skeleton_key_token_length,
+			  unsigned char *skeleton_key_token,
+			  unsigned char *transport_key_identifier,
+			  long *generated_key_identifier_length,
+			  unsigned char *generated_key_identifier);
+
+/* CCA PKA Key Token Build function */
+typedef void (*CSNDPKB_t)(long *return_code,
+			  long *reason_code,
+			  long *exit_data_length,
+			  unsigned char *exit_data,
+			  long *rule_array_count,
+			  unsigned char *rule_array,
+			  long *key_values_structure_length,
+			  unsigned char *key_values_structure,
+			  long *key_name_ln,
+			  unsigned char *key_name,
+			  long *reserved_1_length,
+			  unsigned char *reserved_1,
+			  long *reserved_2_length,
+			  unsigned char *reserved_2,
+			  long *reserved_3_length,
+			  unsigned char *reserved_3,
+			  long *reserved_4_length,
+			  unsigned char *reserved_4,
+			  long *reserved_5_length,
+			  unsigned char *reserved_5,
+			  long *token_length, unsigned char *token);
+
+/* CCA PKA Key Token Change function */
+typedef void (*CSNDKTC_t)(long *return_code,
+			  long *reason_code,
+			  long *exit_data_length,
+			  unsigned char *exit_data,
+			  long *rule_array_count,
+			  unsigned char *rule_array,
+			  long *key_identifier_length,
+			  unsigned char *key_identifier);
+
+/* CCA Digital Signature Generate function */
+typedef void (*CSNDDSG_t)(long *return_code,
+			  long *reason_code,
+			  long *exit_data_length,
+			  unsigned char *exit_data,
+			  long *rule_array_count,
+			  unsigned char *rule_array,
+			  long *PKA_private_key_identifier_length,
+			  unsigned char *PKA_private_key_identifier,
+			  long *hash_length,
+			  unsigned char *hash,
+			  long *signature_field_length,
+			  long *signature_bit_length,
+			  unsigned char *signature_field);
+
+/* CCA Key Token Build2 function */
+typedef void (*CSNBKTB2_t)(long *return_code,
+			   long *reason_code,
+			   long *exit_data_length,
+			   unsigned char *exit_data,
+			   long *rule_array_count,
+			   unsigned char *rule_array,
+			   long *clear_key_bit_length,
+			   unsigned char *clear_key_value,
+			   long *key_name_length,
+			   unsigned char *key_name,
+			   long *user_associated_data_length,
+			   unsigned char *user_associated_data,
+			   long *token_data_length,
+			   unsigned char *token_data,
+			   long *verb_data_length,
+			   unsigned char *verb_data,
+			   long *target_key_token_length,
+			   unsigned char *target_key_token);
+
+/* CCA EC Diffie-Hellman function */
+typedef void (*CSNDEDH_t)(long *return_code,
+			  long *reason_code,
+			  long *exit_data_length,
+			  unsigned char *exit_data,
+			  long *rule_array_count,
+			  unsigned char *rule_array,
+			  long *private_key_identifier_length,
+			  unsigned char *private_key_identifier,
+			  long *private_KEK_key_identifier_length,
+			  unsigned char *private_KEK_key_identifier,
+			  long *public_key_identifier_length,
+			  unsigned char *public_key_identifier,
+			  long *chaining_vector_length,
+			  unsigned char *chaining_vector,
+			  long *party_info_length,
+			  unsigned char *party_info,
+			  long *key_bit_length,
+			  long *reserved_1_length,
+			  unsigned char *reserved_1,
+			  long *reserved_2_length,
+			  unsigned char *reserved_2,
+			  long *reserved_3_length,
+			  unsigned char *reserved_3,
+			  long *reserved_4_length,
+			  unsigned char *reserved_4,
+			  long *reserved_5_length,
+			  unsigned char *reserved_5,
+			  long *output_KEK_key_identifier_length,
+			  unsigned char *output_KEK_key_identifier,
+			  long *output_key_identifier_length,
+			  unsigned char *output_key_identifier);
+
+/* CCA Symmetric Key Import2 function */
+typedef void (*CSNDSYI2_t)(long *return_code,
+			   long *reason_code,
+			   long *exit_data_length,
+			   unsigned char *exit_data,
+			   long *rule_array_count,
+			   unsigned char *rule_array,
+			   long *enciphered_key_length,
+			   unsigned char *enciphered_key,
+			   long *transport_key_identifier_length,
+			   unsigned char *transport_key_identifier,
+			   long *key_name_length,
+			   unsigned char *key_name,
+			   long *target_key_identifier_length,
+			   unsigned char *target_key_identifier);
+
+struct cca_lib {
+	CSNDPKB_t dll_CSNDPKB;
+	CSNDPKG_t dll_CSNDPKG;
+	CSNDKTC_t dll_CSNDKTC;
+	CSNDDSG_t dll_CSNDDSG;
+	CSNBKTB2_t dll_CSNBKTB2;
+	CSNDEDH_t dll_CSNDEDH;
+	CSNDSYI2_t dll_CSNDSYI2;
+};
+
+#define CCA_MAX_PKA_KEY_TOKEN_SIZE	3500
+#define CCA_MAX_SYM_KEY_TOKEN_SIZE	725
+
+int cca_generate_ecc_key_pair(const struct ekmf_cca_lib *cca_lib,
+			      int curve_nid, unsigned char *key_token,
+			      size_t *key_token_length, bool verbose);
+
+int cca_generate_rsa_key_pair(const struct ekmf_cca_lib *cca_lib,
+			      size_t modulus_bits, unsigned int pub_exp,
+			      unsigned char *key_token,
+			      size_t *key_token_length, bool verbose);
+
+int cca_get_key_type(const unsigned char *key_token, size_t key_token_length,
+		     int *pkey_type);
+
+int cca_reencipher_key(const struct ekmf_cca_lib *cca_lib,
+		       const unsigned char *key_token, size_t key_token_length,
+		       bool to_new, bool verbose);
+
+int cca_get_ecc_pub_key_as_pkey(const unsigned char *key_token,
+				size_t key_token_length,
+				EVP_PKEY **pkey, bool verbose);
+
+int cca_get_ecc_pub_key_as_json_web_key(const unsigned char *key_token,
+					size_t key_token_length,
+					json_object **jwk, bool verbose);
+
+int cca_get_rsa_pub_key_as_pkey(const unsigned char *key_token,
+				size_t key_token_length,
+				int pkey_type, EVP_PKEY **pkey, bool verbose);
+
+int cca_import_key_from_json_web_key(const struct ekmf_cca_lib *cca_lib,
+				     json_object *jwk, unsigned char *key_token,
+				     size_t *key_token_length, bool verbose);
+
+enum cca_kdf {
+	CCA_KDF_ANS_X9_63_CCA = 1,     /* CCA DERIVE01 method */
+	CCA_KDF_ANS_X9_63_SHA224 = 2,  /* CCA DERIVE02 method with SHA-224 */
+	CCA_KDF_ANS_X9_63_SHA256 = 3,  /* CCA DERIVE02 method with SHA-256 */
+	CCA_KDF_ANS_X9_63_SHA384 = 4,  /* CCA DERIVE02 method with SHA-284 */
+	CCA_KDF_ANS_X9_63_SHA512 = 5,  /* CCA DERIVE02 method with SHA-512 */
+};
+
+int cca_ec_dh_derive_importer(const struct ekmf_cca_lib *cca_lib,
+			      const unsigned char *priv_ecc_key_token,
+			      size_t priv_ecc_key_token_length,
+			      const unsigned char *pub_ecc_key_token,
+			      size_t pub_ecc_key_token_length,
+			      const unsigned char *party_info,
+			      size_t party_info_length,
+			      enum cca_kdf kdf,
+			      unsigned char *derived_key_token,
+			      size_t *derived_key_token_length,
+			      bool verbose);
+
+int cca_import_external_key(const struct ekmf_cca_lib *cca_lib,
+			    const unsigned char *external_key_token,
+			    size_t external_key_token_length,
+			    const unsigned char *importer_key_token,
+			    size_t importer_key_token_length,
+			    unsigned char *imported_key_token,
+			    size_t *imported_key_token_length,
+			    bool verbose);
+
+int cca_rsa_sign(const struct ekmf_cca_lib *cca_lib,
+		 const unsigned char *key_token, size_t key_token_length,
+		 unsigned char *sig, size_t *siglen,
+		 const unsigned char *tbs, size_t tbslen,
+		 int padding_type, int digest_nid, bool verbose);
+
+int cca_rsa_pss_sign(const struct ekmf_cca_lib *cca_lib,
+		     const unsigned char *key_token, size_t key_token_length,
+		     unsigned char *sig, size_t *siglen,
+		     const unsigned char *tbs, size_t tbslen,
+		     int digest_nid, int mgf_digest_nid, int saltlen,
+		     bool verbose);
+
+int cca_ecdsa_sign(const struct ekmf_cca_lib *cca_lib,
+		   const unsigned char *key_token, size_t key_token_length,
+		   unsigned char *sig, size_t *siglen,
+		   const unsigned char *tbs, size_t tbslen, int digest_nid,
+		   bool verbose);
+
+#endif
diff -pruN 2.14.0-2/libekmfweb/ekmfweb.c 2.15.1-0ubuntu2/libekmfweb/ekmfweb.c
--- 2.14.0-2/libekmfweb/ekmfweb.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/libekmfweb/ekmfweb.c	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,5631 @@
+/*
+ * libekmfweb - EKMFWeb client library
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+#include <stdio.h>
+#include <string.h>
+#include <strings.h>
+#include <errno.h>
+#include <err.h>
+#include <stdbool.h>
+#include <sys/stat.h>
+#include <time.h>
+
+#include <curl/curl.h>
+
+#include <openssl/bio.h>
+#include <openssl/pem.h>
+#include <openssl/x509.h>
+#include <openssl/ssl.h>
+#include <openssl/rsa.h>
+#include <openssl/evp.h>
+
+#include <json-c/json.h>
+#ifndef JSON_C_TO_STRING_NOSLASHESCAPE
+#define JSON_C_TO_STRING_NOSLASHESCAPE (1 << 4)
+#endif
+
+#include "lib/zt_common.h"
+
+#include "ekmfweb/ekmfweb.h"
+#include "utilities.h"
+#include "cca.h"
+
+#define SERIAL_NUMBER_BIT_SIZE		159
+
+#define DEFAULT_SESSION_EC_KEY_CURVE	NID_secp521r1
+
+#define MAX_KEY_BLOB_SIZE		CCA_MAX_PKA_KEY_TOKEN_SIZE
+#define MAX_SYM_KEY_BLOB_SIZE		CCA_MAX_SYM_KEY_TOKEN_SIZE
+
+#define EKMF_URI_SYSTEM_PUBKEY		"/api/v1/system/publicKey"
+#define EKMF_URI_SYSTEM_SETTINGS	"/api/v1/system/settings"
+#define EKMF_URI_SYSTEM_FEATURES	"/api/v1/system/features"
+#define EKMF_URI_SYSTEM_LOGIN		"/api/v1/system/login"
+#define EKMF_URI_KEYS_GENERATE		"/api/v1/keys"
+#define EKMF_URI_KEYS_EXPORT		"/api/v1/keys/%s/export"
+#define EKMF_URI_KEYS_TAGS		"/api/v1/keys/%s/tags"
+#define EKMF_URI_KEYS_EXPORT_CONTROL	"/api/v1/keys/%s/exportControl"
+#define EKMF_URI_KEYS_SET_TAG		"/api/v1/keys/%s/tags/%s"
+#define EKMF_URI_KEYS_GET		"/api/v1/keys/%s"
+#define EKMF_URI_KEYS_SET_STATE		"/api/v1/keys/%s"
+#define EKMF_URI_KEYS_LIST		"/api/v1/keys"			\
+					"?state=%s"			\
+					"&orderBy=%s"			\
+					"&namePattern=%s"		\
+					"&tags=%s"
+#define EKMF_URI_KEYS_LIST_STATE	"&state="
+#define EKMF_URI_TEMPLATE_GET		"/api/v1/templates/%s"
+#define EKMF_URI_TEMPLATE_LIST		"/api/v1/templates"		\
+					"?templateStates=%s"		\
+					"&orderBy=%s"			\
+					"&namePattern=%s"
+#define EKMF_URI_TEMPLATE_SEQNO		"/api/v1/templates/%s/sequenceNumber"
+
+#define LIST_ELEMENTS_PER_PAGE		20
+#define TEMPLATE_STATE_ACTIVE		"ACTIVE"
+#define KEY_STATE_ACTIVE		"ACTIVE"
+#define KEY_ALGORITHM_AES		"AES"
+#define KEYSTORE_TYPE_PERV_ENCR		"PERVASIVE_ENCRYPTION"
+#define ORDER_BY_NAME_ASC		"name%3Aasc"
+#define ORDER_BY_LABEL_ASC		"label%3Aasc"
+#define SETTING_ID_IDENTITY_TEMPLATE	"ekmf.web.public.identity.template"
+#define SETTING_ID_XTS_KEY1_TEMPLATE	"ekmf.web.public.xts.template.1"
+#define SETTING_ID_XTS_KEY2_TEMPLATE	"ekmf.web.public.xts.template.2"
+#define SETTING_ID_NON_XTS_TEMPLATE	"ekmf.web.public.non-xts.template"
+#define FEATURE_ID_PERVASIVE_ENCRYPTION					\
+		"com.ibm.ccc.ekmf.web.features.PervasiveEncryptionFeature"
+
+void __attribute__ ((constructor)) ekmf_init(void);
+void __attribute__ ((destructor)) ekmf_exit(void);
+
+#define pr_verbose(verbose, fmt...)	do {				\
+						if (verbose)		\
+							warnx(fmt);	\
+					} while (0)
+
+#define CURL_ERROR_CHECK(rc, text, verbose, label)			\
+		do {							\
+			if (rc != CURLE_OK) {				\
+				pr_verbose(verbose, "%s: %s", text,	\
+					   curl_easy_strerror(rc));	\
+				goto label;				\
+			}						\
+		} while (0)
+
+#define JSON_CHECK_OBJ(obj, type, rc_var, rc, text, verbose, label)	\
+		do {							\
+			if (obj == NULL ||				\
+			    !json_object_is_type(obj, type)) {		\
+				rc_var = rc;				\
+				pr_verbose(verbose, "%s: %s", text,	\
+					   strerror(-rc_var));		\
+				goto label;				\
+			}						\
+		} while (0)
+
+#define JSON_CHECK_ERROR(cond, rc_var, rc, text, verbose, label)	\
+		do {							\
+			if (cond) {					\
+				rc_var = rc;				\
+				pr_verbose(verbose, "%s: %s", text,	\
+					   strerror(-rc_var));		\
+				goto label;				\
+			}						\
+		} while (0)
+
+struct curl_header_cb_data {
+	struct curl_slist **headers;
+	bool error;
+	bool verbose;
+};
+
+struct curl_write_cb_data {
+	json_tokener *tok;
+	json_object *obj;
+	bool error;
+	bool verbose;
+};
+
+struct curl_sslctx_cb_data {
+	const char *tls_server_cert;
+	bool error;
+	bool verbose;
+};
+
+#define CURL_CERTINFO_CERT	"Cert:"
+#define HTTP_HDR_CONTENT_TYPE	"Content-Type:"
+
+static const char *accepted_content_types[] = { "application/json",
+						"text/x-json",
+						NULL};
+
+struct private_data {
+	const struct ekmf_ext_lib *ext_lib;
+	bool verbose;
+};
+
+static int _ekmf_setup_sign_context(const unsigned char *key_blob,
+				    size_t key_blob_size, EVP_PKEY *pkey,
+				    int digest_nid,
+				    struct ekmf_rsa_pss_params *rsa_pss_params,
+				    EVP_MD_CTX **md_ctx,
+				    EVP_PKEY_CTX **pkey_ctx,
+				    struct private_data *private,
+				    bool verbose);
+
+/**
+ * Extract the public key from a certificate in PEM format and store it into a
+ * PEM file
+ */
+static int _ekmf_extract_pubkey(const char *cert, const char *pub_key_pem,
+				bool verbose)
+{
+	EVP_PKEY *pkey = NULL;
+	X509 *x509 = NULL;
+	FILE *fp = NULL;
+	BIO *b = NULL;
+	int rc;
+
+	b = BIO_new_mem_buf(cert, -1);
+	if (b == NULL) {
+		pr_verbose(verbose, "BIO_new_mem_buf failed");
+		return -ENOMEM;
+	}
+
+	x509 = PEM_read_bio_X509(b, NULL, NULL, NULL);
+	if (x509 == NULL) {
+		pr_verbose(verbose, "PEM_read_bio_X509 failed");
+		rc = -EIO;
+		goto out;
+	}
+
+	pkey = X509_get0_pubkey(x509);
+	if (pkey == NULL) {
+		pr_verbose(verbose, "PEM_read_bio_X509 failed");
+		rc = -EIO;
+		goto out;
+	}
+
+	fp = fopen(pub_key_pem, "w");
+	if (fp == NULL) {
+		rc = -errno;
+		pr_verbose(verbose, "File '%s': %s", pub_key_pem,
+			   strerror(-rc));
+		goto out;
+	}
+
+	if (!PEM_write_PUBKEY(fp, pkey)) {
+		pr_verbose(verbose, "PEM_write_PUBKEY failed");
+		rc = -EIO;
+		goto out;
+	}
+
+out:
+	if (fp != NULL)
+		fclose(fp);
+	if (x509 != NULL)
+		X509_free(x509);
+	if (b != NULL)
+		BIO_free(b);
+	return 0;
+}
+
+/**
+ * Process the attributes of a certificate supplied by curl and writes the
+ * PEM-format certificate attribute into the specified file pointer.
+ */
+static int _ekmf_process_certificate(FILE *fp, struct curl_slist *slist,
+				     const char *pub_key_pem, bool verbose)
+{
+	char *cert;
+	int rc;
+
+	for (; slist != NULL; slist = slist->next) {
+		pr_verbose(verbose, "%s", slist->data);
+
+		if (strncmp(slist->data, CURL_CERTINFO_CERT,
+					  strlen(CURL_CERTINFO_CERT)) == 0) {
+			cert = slist->data + strlen(CURL_CERTINFO_CERT);
+
+			if (fp != NULL) {
+				if (fwrite(cert, strlen(cert), 1, fp) != 1) {
+					rc = -errno;
+					pr_verbose(verbose, "fwrite failed: %s",
+						   strerror(-rc));
+					return rc;
+				}
+			}
+
+			if (pub_key_pem != NULL) {
+				rc = _ekmf_extract_pubkey(cert, pub_key_pem,
+							  verbose);
+				if (rc != 0)
+					return rc;
+			}
+		}
+	}
+
+	return 0;
+}
+
+/**
+ * Callback called during curl_easy_perform() to handle received data.
+ * Parse the (potentially partial) JSON data.
+ */
+static size_t _ekmf_dummy_write_cb(void *UNUSED(contents), size_t size,
+				   size_t nmemb, void *UNUSED(userp))
+{
+	return size * nmemb;
+}
+
+/**
+ * Connects to the specified server url and obtains the servers certificate
+ * and its chain of signing certificates and stores them in the specified
+ * PEM files.
+ *
+ * @param config            the configuration structure. Only the base_url must
+ *                          be specified, all others are optional.
+ * @param server_cert_pem   Optional: name of a PEM file to store the servers
+ *                          certificate
+ * @param server_pubkey_pem Optional: name of a PEM file to store the servers
+ *                          public key (can be used for public key pinning)
+ * @param ca_bundle_pem     Optional: name of a PEM file to store the CA
+ *                          certificate chain as a bundle
+ * @param verified          On return: If the server 's certificate has been
+ *                          verified using the CA specification from the config
+ *                          (if ca = NULL: default system CAs, otherwise path
+ *                          or file to CAs).
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ */
+int ekmf_get_server_cert_chain(const struct ekmf_config *config,
+			       const char *server_cert_pem,
+			       const char *server_pubkey_pem,
+			       const char *ca_bundle_pem,
+			       bool *verified, char **error_msg, bool verbose)
+{
+	char error_str[CURL_ERROR_SIZE] = { 0 };
+	struct curl_certinfo *ci;
+	long do_verify = 1;
+	FILE *fp = NULL;
+	struct stat sb;
+	int i, rc = 0;
+
+	CURL *curl;
+
+	if (config == NULL)
+		return -EINVAL;
+
+	if (error_msg != NULL)
+		*error_msg = NULL;
+
+	pr_verbose(verbose, "Getting certificate chain for '%s'",
+		   config->base_url);
+
+	curl = curl_easy_init();
+	if (curl == NULL) {
+		pr_verbose(verbose, "curl_easy_init failed");
+		return CURLE_FAILED_INIT;
+	}
+
+	rc = curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, error_str);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_ERRORBUFFER", verbose,
+			 out);
+
+	rc = curl_easy_setopt(curl, CURLOPT_VERBOSE, verbose ? 1 : 0);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_VERBOSE", verbose, out);
+
+	rc = curl_easy_setopt(curl, CURLOPT_URL, config->base_url);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_URL", verbose, out);
+
+	if (config->tls_ca != NULL) {
+		if (stat(config->tls_ca, &sb) != 0) {
+			rc = -errno;
+			pr_verbose(verbose, "stat failed on '%s': %s",
+				   config->tls_ca, strerror(-rc));
+			goto out;
+		}
+
+		if (S_ISDIR(sb.st_mode)) {
+			rc = curl_easy_setopt(curl, CURLOPT_CAPATH,
+					      config->tls_ca);
+			CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_CAPATH",
+					 verbose, out);
+		} else {
+			rc = curl_easy_setopt(curl, CURLOPT_CAINFO,
+					      config->tls_ca);
+			CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_CAINFO",
+					 verbose, out);
+		}
+	}
+
+	rc = curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 0L);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_FOLLOWLOCATION",
+			 verbose, out);
+
+	if (config->tls_client_cert != NULL) {
+		rc = curl_easy_setopt(curl, CURLOPT_SSLCERT,
+				      config->tls_client_cert);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSLCERT",
+				 verbose, out);
+		rc = curl_easy_setopt(curl, CURLOPT_SSLCERTTYPE, "PEM");
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSLCERTTYPE",
+				 verbose, out);
+	}
+
+	if (config->tls_client_key != NULL) {
+		rc = curl_easy_setopt(curl, CURLOPT_SSLKEY,
+				      config->tls_client_key);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSLKEY", verbose,
+				 out);
+		rc = curl_easy_setopt(curl, CURLOPT_SSLKEYTYPE, "PEM");
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSLKEYTYPE",
+				 verbose, out);
+
+		if (config->tls_client_key_passphrase != NULL) {
+			rc = curl_easy_setopt(curl, CURLOPT_KEYPASSWD,
+					 config->tls_client_key_passphrase);
+			CURL_ERROR_CHECK(rc,
+					 "curl_easy_setopt CURLOPT_KEYPASSWD",
+					 verbose, out);
+		}
+	}
+
+retry:
+	rc = curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, do_verify);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSL_VERIFYPEER", verbose,
+			 out);
+	rc = curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST, 0L);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSL_VERIFYHOST", verbose,
+			 out);
+
+	rc = curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION,
+			      _ekmf_dummy_write_cb);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_WRITEFUNCTION", verbose,
+			 out);
+
+	rc = curl_easy_setopt(curl, CURLOPT_CERTINFO, 1L);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_CERTINFO", verbose, out);
+
+	rc = curl_easy_perform(curl);
+	if (rc == CURLE_SSL_CACERT && do_verify != 0) {
+		do_verify = 0;
+		goto retry;
+	}
+
+	CURL_ERROR_CHECK(rc, "curl_easy_perform", verbose, out);
+
+	/*
+	 * If the first try worked, the server certificate could be verified
+	 * with the specified or default CA.
+	 */
+	if (verified != NULL)
+		*verified = do_verify != 0;
+
+	rc = curl_easy_getinfo(curl, CURLINFO_CERTINFO, &ci);
+	CURL_ERROR_CHECK(rc, "curl_easy_getinfo CURLINFO_CERTINFO", verbose,
+			 out);
+
+	if (server_cert_pem != NULL) {
+		fp = fopen(server_cert_pem, "w");
+		if (fp == NULL) {
+			rc = -errno;
+			pr_verbose(verbose, "File '%s': %s", server_cert_pem,
+				   strerror(-rc));
+			goto out;
+		}
+	}
+
+	pr_verbose(verbose, "%d certificates", ci->num_of_certs);
+
+	/*
+	 * Process all certificates in the list.
+	 * First one is the server certificate, all following are
+	 * CA certificates
+	 */
+	for (i = 0; i < ci->num_of_certs; i++) {
+		pr_verbose(verbose, "Certificate %d:", i);
+
+		rc = _ekmf_process_certificate(fp, ci->certinfo[i], i == 0 ?
+						     server_pubkey_pem : NULL,
+					       verbose);
+		if (rc != 0)
+			break;
+
+		if (i == 0) {
+			if (fp != NULL)
+				fclose(fp);
+			fp = NULL;
+
+			/*
+			 * Save CA-chain if requested, but only if the
+			 * server certificate wasn't verified by the specified
+			 * or default CA.
+			 */
+			if (ci->num_of_certs > 1 && ca_bundle_pem != NULL &&
+			    do_verify == 0) {
+				fp = fopen(ca_bundle_pem, "w");
+				if (fp == NULL) {
+					rc = -errno;
+					pr_verbose(verbose, "File '%s': %s",
+						   ca_bundle_pem,
+						   strerror(-rc));
+					break;
+				}
+			}
+		}
+	}
+
+out:
+	if (fp != NULL)
+		fclose(fp);
+
+	if (rc > 0 && error_msg != NULL && *error_msg == NULL) {
+		pr_verbose(verbose, "Error: %s", error_str);
+		if (asprintf(error_msg, "CURL: %s", strlen(error_str) > 0 ?
+				error_str : curl_easy_strerror(rc)) < 0) {
+			pr_verbose(verbose, "asprintf failed");
+			rc = -ENOMEM;
+		}
+	}
+
+	curl_easy_cleanup(curl);
+
+	if (rc > 0)
+		rc = -EIO;
+	return rc;
+}
+
+/**
+ * Callback called during curl_easy_perform() to handle received headers.
+ * Check for the expected response content type.
+ */
+static size_t _ekmf_header_cb(void *contents, size_t size, size_t nmemb,
+			     void *userp)
+{
+	struct curl_header_cb_data *cb = (struct curl_header_cb_data *)userp;
+	size_t num = size * nmemb;
+	size_t ofs;
+	char *hdr = contents;
+	char *val, *str;
+	int i;
+
+	if (num < 2)
+		return num;
+
+	if (cb->headers != NULL) {
+		str = strndup((char *)contents, num - 2);
+		if (str == NULL) {
+			pr_verbose(cb->verbose, "strndup failed");
+			return 0;
+		}
+		*cb->headers = curl_slist_append(*cb->headers, str);
+		free(str);
+		if (*cb->headers == NULL) {
+			pr_verbose(cb->verbose, "curl_slist_append failed");
+			return 0;
+		}
+	}
+
+	if (num < strlen(HTTP_HDR_CONTENT_TYPE))
+		goto out;
+
+	if (strncasecmp(hdr, HTTP_HDR_CONTENT_TYPE,
+			strlen(HTTP_HDR_CONTENT_TYPE)) != 0)
+		goto out;
+
+	ofs = strlen(HTTP_HDR_CONTENT_TYPE);
+	val = hdr + ofs;
+	while (*val == ' ' && ofs < num) {
+		ofs++;
+		val++;
+	}
+	if (ofs >= num)
+		goto out;
+
+	for (i = 0; accepted_content_types[i] != NULL; i++) {
+		if (num - ofs >= strlen(accepted_content_types[i]) &&
+		    strncasecmp(val, accepted_content_types[i],
+				strlen(accepted_content_types[i])) == 0)
+			goto out;
+	}
+
+	cb->error = true;
+	pr_verbose(cb->verbose, "Unexpected response Content-Type: %.*s",
+		   (int)(num - ofs), val);
+	return 0;
+
+out:
+	return num;
+}
+
+/**
+ * Callback called during curl_easy_perform() to handle received data.
+ * Parse the (potentially partial) JSON data.
+ */
+static size_t _ekmf_write_cb(void *contents, size_t size, size_t nmemb,
+			    void *userp)
+{
+	struct curl_write_cb_data *cb = (struct curl_write_cb_data *)userp;
+	enum json_tokener_error jerr;
+	size_t num = size * nmemb;
+
+	pr_verbose(cb->verbose, "Response Data: ->%.*s<-", (int)num,
+		   (char *)contents);
+
+	if (cb->obj != NULL) {
+		pr_verbose(cb->verbose, "JSON data already complete, but "
+			   "additional data received");
+		cb->error = true;
+		return 0;
+	}
+
+	cb->obj = json_tokener_parse_ex(cb->tok, (const char *)contents, num);
+
+	if (cb->obj == NULL) {
+		jerr = json_tokener_get_error(cb->tok);
+		if (jerr == json_tokener_continue)
+			goto out;
+
+		cb->error = true;
+		pr_verbose(cb->verbose, "json_tokener_parse_ex failed: %s",
+			   json_tokener_error_desc(jerr));
+		return 0;
+	}
+
+out:
+	return num;
+}
+
+/**
+ * Extracts the EKMFWeb API error information form the response object.
+ */
+static int _ekmf_get_api_error(json_object *response_obj, char **error_msg)
+{
+	json_object *field;
+	int code;
+
+	if (response_obj == NULL || error_msg == NULL)
+		return -EINVAL;
+
+	if (!json_object_is_type(response_obj, json_type_object))
+		return -EBADMSG;
+
+	if (!json_object_object_get_ex(response_obj, "code", &field))
+		return -EBADMSG;
+	if (!json_object_is_type(field, json_type_int))
+		return -EBADMSG;
+	code = json_object_get_int(field);
+
+	if (!json_object_object_get_ex(response_obj, "message", &field))
+		return -EBADMSG;
+	if (!json_object_is_type(field, json_type_string))
+		return -EBADMSG;
+
+	if (asprintf(error_msg, "EKMFWeb: %d: %s", code,
+		     json_object_get_string(field)) < 0)
+		return -ENOMEM;
+
+	return 0;
+}
+
+/**
+ * This callback called before the SSL handshake is performed.
+ * It adds a pinned server certificate to the SSL certificate store, so
+ * that it is treated as trusted, although it might be self-signed.
+ */
+static CURLcode _ekmf_sslctx_cb(CURL *UNUSED(curl), void *sslctx, void *parm)
+{
+	struct curl_sslctx_cb_data *sslctx_cb = parm;
+	SSL_CTX *ssl_ctx = (SSL_CTX *)sslctx;
+	X509_STORE *store;
+	X509 *cert = NULL;
+	int rc;
+
+	if (ssl_ctx == NULL || sslctx_cb == NULL)
+		return CURLE_ABORTED_BY_CALLBACK;
+
+	if (sslctx_cb->tls_server_cert == NULL)
+		return CURLE_OK;
+
+	store = SSL_CTX_get_cert_store(ssl_ctx);
+	if (store == NULL) {
+		pr_verbose(sslctx_cb->verbose, "Failed to get SSL Store");
+		return CURLE_ABORTED_BY_CALLBACK;
+	}
+
+	rc = read_x509_certificate(sslctx_cb->tls_server_cert, &cert);
+	if (rc != 0) {
+		pr_verbose(sslctx_cb->verbose, "Failed to read the server "
+			   "certificate from file '%s'",
+			   sslctx_cb->tls_server_cert);
+		return CURLE_ABORTED_BY_CALLBACK;
+	}
+
+	rc = X509_STORE_add_cert(store, cert);
+	if (rc != 1) {
+		pr_verbose(sslctx_cb->verbose, "Failed to add server "
+			   "certificate to SSL Store");
+		X509_free(cert);
+		return CURLE_ABORTED_BY_CALLBACK;
+	}
+
+	X509_free(cert);
+	return CURLE_OK;
+}
+
+/**
+ * Perform an HTTP request to the url constructed from the base_url in config
+ * and th uri specified using the specified HTTP request.
+ * The config structure contains information about TLS certificates.
+ * If specified, it serializes the request data (JSON) and sends it to the
+ * server. The response data (JSON) is parsed and returned in the response data.
+ * If the response content type is not JSON, then an error is returned.
+ * The HTTP status code is returned in status_code.
+ *
+ * @param config            the configuration structure
+ * @param uri               the uri (and query parameters) to concatenate to the
+ *                          base_url from the config structure.
+ * @param request           the HTTP request to perform (e.g. GET, PUT, POST)
+ * @param request_data      the JSON data to be sent with the request.
+ * @param request_headers   a NULL terminated list of pointers to HTTP headers
+ *                          to send along with the request. Can be NULL.
+ * @param login_token       if not NULL, a Bearer token to authorize with
+ * @param response_data     on return the JSON response data is returned. When
+ *                          no longer needed, it must be released using
+ *                          json_object_put()
+ * @param response headers  address of a curl_slist to add response headers to,
+ *                          or NULL to not return any headers.
+ * @param status_code       on return the HTTP status code is returned
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param curl              a CURL handle to perform the request with.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno or a positive CURL error code in
+ *          case of an error
+ */
+static int _ekmf_perform_request(const struct ekmf_config *config,
+				 const char *uri, const char *request,
+				 json_object *request_data,
+				 char **request_headers,
+				 const char *login_token,
+				 json_object **response_data,
+				 struct curl_slist **response_headers,
+				 long *status_code, char **error_msg,
+				 CURL *curl, bool verbose)
+{
+	struct curl_header_cb_data header_cb = { 0 };
+	struct curl_sslctx_cb_data sslctx_cb = { 0 };
+	struct curl_write_cb_data write_cb = { 0 };
+	char error_str[CURL_ERROR_SIZE] = { 0 };
+	struct curl_slist *list = NULL;
+	char *url = NULL;
+	const char *str;
+	struct stat sb;
+	char *auth_hdr;
+	int i, rc;
+
+	if (config == NULL || uri == NULL || request == NULL ||
+	    status_code == NULL || curl == NULL)
+		return -EINVAL;
+
+	if (error_msg != NULL)
+		*error_msg = NULL;
+
+	if (asprintf(&url, "%s%s", config->base_url, uri) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		return -ENOMEM;
+	}
+
+	pr_verbose(verbose, "Performing request for '%s'", url);
+
+	curl_easy_reset(curl);
+
+	rc = curl_easy_setopt(curl, CURLOPT_VERBOSE, verbose ? 1 : 0);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_VERBOSE", verbose, out);
+
+	rc = curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, error_str);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_ERRORBUFFER", verbose,
+			 out);
+
+	rc = curl_easy_setopt(curl, CURLOPT_URL, url);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_URL", verbose, out);
+
+	rc = curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER,
+			 config->tls_verify_peer ? 1L : 0L);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSL_VERIFYPEER", verbose,
+			 out);
+	rc = curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST,
+			 config->tls_verify_host ? 2L : 0L);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSL_VERIFYHOST", verbose,
+			 out);
+
+	if (config->tls_ca != NULL) {
+		if (stat(config->tls_ca, &sb) != 0) {
+			rc = -errno;
+			pr_verbose(verbose, "stat failed on '%s': %s",
+				   config->tls_ca, strerror(-rc));
+			goto out;
+		}
+
+		if (S_ISDIR(sb.st_mode)) {
+			rc = curl_easy_setopt(curl, CURLOPT_CAPATH,
+					      config->tls_ca);
+			CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_CAPATH",
+					 verbose, out);
+		} else {
+			rc = curl_easy_setopt(curl, CURLOPT_CAINFO,
+					      config->tls_ca);
+			CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_CAINFO",
+					 verbose, out);
+		}
+	}
+
+	if (config->tls_client_cert != NULL) {
+		rc = curl_easy_setopt(curl, CURLOPT_SSLCERT,
+				      config->tls_client_cert);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSLCERT",
+				 verbose, out);
+		rc = curl_easy_setopt(curl, CURLOPT_SSLCERTTYPE, "PEM");
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSLCERTTYPE",
+				 verbose, out);
+	}
+
+	if (config->tls_client_key != NULL) {
+		rc = curl_easy_setopt(curl, CURLOPT_SSLKEY,
+				      config->tls_client_key);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSLKEY", verbose,
+				 out);
+		rc = curl_easy_setopt(curl, CURLOPT_SSLKEYTYPE, "PEM");
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSLKEYTYPE",
+				 verbose, out);
+
+		if (config->tls_client_key_passphrase != NULL) {
+			rc = curl_easy_setopt(curl, CURLOPT_KEYPASSWD,
+					 config->tls_client_key_passphrase);
+			CURL_ERROR_CHECK(rc,
+					 "curl_easy_setopt CURLOPT_KEYPASSWD",
+					 verbose, out);
+		}
+	}
+
+	if (config->tls_issuer_cert != NULL) {
+		rc = curl_easy_setopt(curl, CURLOPT_ISSUERCERT,
+				      config->tls_issuer_cert);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_ISSUERCERT",
+				 verbose, out);
+	}
+
+	if (config->tls_pinned_pubkey != NULL) {
+		rc = curl_easy_setopt(curl, CURLOPT_PINNEDPUBLICKEY,
+				 config->tls_pinned_pubkey);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_PINNEDPUBLICKEY",
+				 verbose, out);
+	}
+
+	if (config->max_redirs > 0) {
+		rc = curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_FOLLOWLOCATION",
+				 verbose, out);
+		rc = curl_easy_setopt(curl, CURLOPT_MAXREDIRS,
+				      config->max_redirs);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_MAXREDIRS",
+				 verbose, out);
+		rc = curl_easy_setopt(curl, CURLOPT_POSTREDIR,
+				      CURL_REDIR_POST_ALL);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_POSTREDIR",
+				 verbose, out);
+	} else {
+		rc = curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 0L);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_FOLLOWLOCATION",
+				 verbose, out);
+	}
+
+	if (strcmp(request, "GET") == 0) {
+		rc = curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, NULL);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_CUSTOMREQUEST",
+				 verbose, out);
+		rc = curl_easy_setopt(curl, CURLOPT_HTTPGET, 1L);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_HTTPGET",
+				 verbose, out);
+	} else {
+		rc = curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST,
+				      request);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_CUSTOMREQUEST",
+				 verbose, out);
+
+		if (request_data != NULL) {
+			rc = curl_easy_setopt(curl, CURLOPT_POST, 1L);
+			CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_POST",
+					 verbose, out);
+
+			list = curl_slist_append(list,
+				"Content-Type: application/json;charset=UTF-8");
+			if (list == NULL) {
+				pr_verbose(verbose, "curl_slist_append failed");
+				rc = -ENOMEM;
+				goto out;
+			}
+
+			/*
+			 * The memory returned by json_object_to_json_string_ext
+			 * is freed when the JSON object is freed.
+			 */
+			str = json_object_to_json_string_ext(request_data,
+						JSON_C_TO_STRING_PLAIN |
+						JSON_C_TO_STRING_NOSLASHESCAPE);
+			pr_verbose(verbose, "Request Data: ->%s<-", str);
+			rc = curl_easy_setopt(curl, CURLOPT_POSTFIELDS, str);
+			CURL_ERROR_CHECK(rc,
+					 "curl_easy_setopt CURLOPT_POSTFIELDS",
+					 verbose, out);
+		}
+	}
+
+	list = curl_slist_append(list, "Accept: application/json");
+	if (list == NULL) {
+		pr_verbose(verbose, "curl_slist_append failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+	list = curl_slist_append(list, "Accept-Charset: UTF-8");
+	if (list == NULL) {
+		pr_verbose(verbose, "curl_slist_append failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+	/* Disable "Expect: 100-continue" */
+	list = curl_slist_append(list, "Expect:");
+	if (list == NULL) {
+		pr_verbose(verbose, "curl_slist_append failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	if (login_token != NULL) {
+		/*
+		 * Note: We could alternatively use CURLOPT_XOAUTH2_BEARER, with
+		 * CURLOPT_HTTPAUTH using CURLAUTH_BEARER, but this seems to
+		 * cause a memory leak in some curl versions.
+		 */
+		if (asprintf(&auth_hdr, "Authorization: Bearer %s",
+			     login_token) < 0) {
+			pr_verbose(verbose, "asprintf failed");
+			rc = -ENOMEM;
+			goto out;
+		}
+		list = curl_slist_append(list, auth_hdr);
+		free(auth_hdr);
+		if (list == NULL) {
+			pr_verbose(verbose, "curl_slist_append failed");
+			rc = -ENOMEM;
+			goto out;
+		}
+	}
+
+	for (i = 0; request_headers != NULL &&
+		    request_headers[i] != NULL; i++) {
+		list = curl_slist_append(list, request_headers[i]);
+		if (list == NULL) {
+			pr_verbose(verbose, "curl_slist_append failed");
+			rc = -ENOMEM;
+			goto out;
+		}
+	}
+
+	rc = curl_easy_setopt(curl, CURLOPT_HTTPHEADER, list);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_HTTPHEADER", verbose,
+			 out);
+
+	header_cb.headers = response_headers;
+	header_cb.verbose = verbose;
+
+	write_cb.verbose = verbose;
+	write_cb.tok = json_tokener_new();
+	if (write_cb.tok == NULL) {
+		pr_verbose(verbose, "json_tokener_new failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	sslctx_cb.tls_server_cert = config->tls_server_cert;
+	sslctx_cb.verbose = verbose;
+
+	rc = curl_easy_setopt(curl, CURLOPT_HEADERFUNCTION, _ekmf_header_cb);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_HEADERFUNCTION", verbose,
+			 out);
+	rc = curl_easy_setopt(curl, CURLOPT_HEADERDATA, (void *)&header_cb);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_HEADERDATA", verbose,
+			 out);
+
+	rc = curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, _ekmf_write_cb);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_WRITEFUNCTION", verbose,
+			 out);
+	rc = curl_easy_setopt(curl, CURLOPT_WRITEDATA, (void *)&write_cb);
+	CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_WRITEDATA", verbose,
+			 out);
+
+	if (config->tls_server_cert != NULL) {
+		rc = curl_easy_setopt(curl, CURLOPT_SSL_CTX_FUNCTION,
+				      _ekmf_sslctx_cb);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt "
+				 "CURLOPT_SSL_CTX_FUNCTION", verbose, out);
+		rc = curl_easy_setopt(curl, CURLOPT_SSL_CTX_DATA,
+				      &sslctx_cb);
+		CURL_ERROR_CHECK(rc, "curl_easy_setopt CURLOPT_SSL_CTX_DATA",
+				 verbose, out);
+	}
+
+	rc = curl_easy_perform(curl);
+	if (rc != CURLE_OK) {
+		pr_verbose(verbose, "curl_easy_perform for '%s' failed: %s",
+			   url, curl_easy_strerror(rc));
+		pr_verbose(verbose, "Error: %s", error_str);
+
+		if (header_cb.error) {
+			pr_verbose(verbose, "Unexpected Content-Type");
+			rc = -EBADMSG;
+			if (error_msg != NULL && *error_msg == NULL) {
+				if (asprintf(error_msg, "Unexpected response "
+					     "Content-Type") < 0)
+					error_msg = NULL;
+			}
+		}
+		if (write_cb.error) {
+			pr_verbose(verbose, "JSON parsing failed");
+			rc = -EBADMSG;
+			if (error_msg != NULL && *error_msg == NULL) {
+				if (asprintf(error_msg, "Failed to JSON parse "
+					     "the response content") < 0)
+					error_msg = NULL;
+			}
+		}
+		goto out;
+	}
+
+	rc = curl_easy_getinfo(curl, CURLINFO_RESPONSE_CODE, status_code);
+	CURL_ERROR_CHECK(rc, "curl_easy_getinfo CURLINFO_RESPONSE_CODE",
+			 verbose, out);
+
+	if (*status_code >= 400 && write_cb.obj != NULL &&
+	    error_msg != NULL && *error_msg == NULL) {
+		rc = _ekmf_get_api_error(write_cb.obj, error_msg);
+		json_object_put(write_cb.obj);
+		write_cb.obj = NULL;
+		if (rc != 0)
+			goto out;
+	}
+
+	if (response_data != NULL) {
+		*response_data = write_cb.obj;
+	} else {
+		if (write_cb.obj != NULL)
+			json_object_put(write_cb.obj);
+	}
+
+out:
+	if (write_cb.tok != NULL)
+		json_tokener_free(write_cb.tok);
+	if (url != NULL)
+		free(url);
+	if (list != NULL)
+		curl_slist_free_all(list);
+
+	if (rc > 0 && error_msg != NULL && *error_msg == NULL) {
+		if (asprintf(error_msg, "CURL: %s", strlen(error_str) > 0 ?
+				error_str : curl_easy_strerror(rc)) < 0) {
+			pr_verbose(verbose, "asprintf failed");
+			rc = -ENOMEM;
+		}
+	}
+
+	curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, NULL);
+
+	return rc;
+}
+
+/**
+ * Allocates or reuses a CURL handle. If curl_handle is not NULL, and
+ * points to a non-NULL CURL handle, it is used, otherwise a new CURL handle
+ * is allocated.
+ */
+static int _ekmf_get_curl_handle(CURL **curl_handle, CURL **curl)
+{
+	if (curl == NULL)
+		return -EINVAL;
+
+	if (curl_handle != NULL)
+		*curl = *curl_handle;
+
+	if (*curl == NULL)
+		*curl = curl_easy_init();
+
+	if (*curl == NULL)
+		return -EIO;
+
+	return 0;
+}
+
+/**
+ * Releases a CURL handle. If curl_handle is not NULL, then the used CURL
+ * handle is passed back via *curl_handle. If curl_handle is NULL, then the
+ * used CURL handle is destroyed.
+ */
+static void _ekmf_release_curl_handle(CURL **curl_handle, CURL *curl)
+{
+	if (curl == NULL)
+		return;
+
+	if (curl_handle != NULL)
+		*curl_handle = curl;
+	else
+		curl_easy_cleanup(curl);
+}
+
+/**
+ * Print the certificate(s) contained in the specified PEM file.
+ *
+ * @param cert_pem          the file name of the PEM file to print
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns -EIO if the file could not be opened. -ENOENT if the PEM file
+ *          does not contain any certificates. 0 if success.
+ */
+int ekmf_print_certificates(const char *cert_pem, bool verbose)
+{
+	int rc = -ENOENT;
+	X509 *cert;
+	FILE *fp;
+
+	if (cert_pem == NULL)
+		return -EINVAL;
+
+	fp = fopen(cert_pem, "r");
+	if (fp == NULL) {
+		pr_verbose(verbose, "File '%s': %s", cert_pem, strerror(errno));
+		return -EIO;
+	}
+
+	while (1) {
+		cert = PEM_read_X509(fp, NULL, NULL, NULL);
+		if (cert == NULL)
+			break;
+
+		X509_print_ex_fp(stdout, cert, 0, X509_FLAG_NO_EXTENSIONS);
+
+		X509_free(cert);
+		rc = 0;
+	}
+
+	fclose(fp);
+	return rc;
+}
+
+/**
+ * Checks if the login token stored in the file denoted by field login_token
+ * of the config structure is valid or not. The file (if existent) contains a
+ * JSON Web Token (JWT, see RFC7519). It is valid if the current date and time
+ * is before its expiration time ("exp" claim), and after or equal its
+ * not-before time ("nbf" claim).
+ * Note: The signature (if any) of the JWT is not checked, nor any other JWT
+ * fields.
+ *
+ * @param config            the configuration structure
+ * @param valid             On return: true if the token is valid, false if not
+ * @param login_token       On return: If not NULL: the login token, if the
+ *                          token is still valid. The returned string must
+ *                          be freed by the caller when no longer needed.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int ekmf_check_login_token(const struct ekmf_config *config, bool *valid,
+			   char **login_token, bool verbose)
+{
+	json_object *jwt_payload = NULL;
+	json_object *exp_claim = NULL;
+	json_object *nbf_claim = NULL;
+	char *token = NULL;
+	size_t count, size;
+	int64_t exp, nbf;
+	FILE *fp = NULL;
+	struct stat sb;
+	int rc = 0;
+	time_t now;
+
+	if (config == NULL || valid == NULL)
+		return -EINVAL;
+
+	if (config->login_token == NULL) {
+		*valid = false;
+		return 0;
+	}
+
+	if (login_token != NULL)
+		*login_token = NULL;
+
+	pr_verbose(verbose, "Reading login token from file : '%s'",
+		   config->login_token);
+
+	if (stat(config->login_token, &sb)) {
+		rc = -errno;
+		pr_verbose(verbose, "stat on file %s failed: '%s'",
+			   config->login_token, strerror(-rc));
+		return rc;
+	}
+	size = sb.st_size;
+	if (size == 0) {
+		pr_verbose(verbose, "File %s is empty", config->login_token);
+		rc = -EIO;
+		goto out;
+	}
+
+	token = (char *)malloc(size + 1);
+	if (token == NULL) {
+		pr_verbose(verbose, "Failed to allocate a buffer");
+		return -ENOMEM;
+	}
+
+	fp = fopen(config->login_token, "r");
+	if (fp == NULL) {
+		rc = -errno;
+		pr_verbose(verbose, "Failed to open file %s: '%s'",
+			   config->login_token, strerror(-rc));
+		goto out;
+	}
+
+	count = fread(token, 1, size, fp);
+	if (count != size) {
+		pr_verbose(verbose, "Failed to read the token");
+		rc = -EIO;
+		goto out;
+	}
+	token[size] = '\0';
+	if (token[size - 1] == '\n')
+		token[size - 1] = '\0';
+
+	fclose(fp);
+	fp = NULL;
+
+	time(&now);
+	*valid = true;
+
+	rc = parse_json_web_token(token, NULL, &jwt_payload, NULL, NULL);
+	if (rc != 0) {
+		pr_verbose(verbose, "parse_json_web_token failed");
+		goto out;
+	}
+
+	if (json_object_object_get_ex(jwt_payload, "exp", &exp_claim) &&
+	    json_object_is_type(exp_claim, json_type_int)) {
+		exp = json_object_get_int64(exp_claim);
+		if (exp == 0) {
+			pr_verbose(verbose,
+				   "failed to get value from exp claim");
+			rc = -EIO;
+			goto out;
+		}
+
+		if (now > exp) {
+			pr_verbose(verbose, "JWT is expired");
+			*valid = false;
+		}
+	}
+
+	if (json_object_object_get_ex(jwt_payload, "nbf", &nbf_claim) &&
+	    json_object_is_type(nbf_claim, json_type_int)) {
+		nbf = json_object_get_int64(nbf_claim);
+		if (nbf == 0) {
+			pr_verbose(verbose,
+				   "failed to get value from nbf claim");
+			rc = -EIO;
+			goto out;
+		}
+
+		if (now <= nbf) {
+			pr_verbose(verbose, "JWT is not yet valid");
+			*valid = false;
+		}
+	}
+
+	if (login_token != NULL && *valid) {
+		*login_token = token;
+		token = NULL;
+	}
+
+out:
+	if (jwt_payload != NULL)
+		json_object_put(jwt_payload);
+	if (token != NULL)
+		free(token);
+	if (fp != NULL)
+		fclose(fp);
+
+	return rc;
+}
+
+/**
+ * Performs a login of the specified user with a passcode. On success the
+ * returned login token is stored in the file denoted by field login_token
+ * of the config structure, so that it can be used by subsequent requests.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param user_id           the user-ID to log-in.
+ * @param passcode          the passcode to log-in the user.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if the passcode is no longer valid.
+ */
+int ekmf_login(const struct ekmf_config *config, CURL **curl_handle,
+	       const char *user_id, const char *passcode, char **error_msg,
+	       bool verbose)
+{
+	json_object *response_obj = NULL;
+	json_object *request_obj = NULL;
+	const char *login_token, *tok;
+	CURL *curl = NULL;
+	long status_code;
+	FILE *fp = NULL;
+	size_t count;
+	int rc;
+
+	if (config == NULL || user_id == NULL || passcode == NULL)
+		return -EINVAL;
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	request_obj = json_object_new_object();
+	JSON_CHECK_ERROR(request_obj == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object", verbose, out);
+
+	rc = json_object_object_add_ex(request_obj, "userId",
+				       json_object_new_string(user_id), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+
+	rc = json_object_object_add_ex(request_obj, "passcode",
+				       json_object_new_string(passcode), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+
+	rc = _ekmf_perform_request(config, EKMF_URI_SYSTEM_LOGIN, "POST",
+				   request_obj, NULL, NULL, &response_obj, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 410:
+		pr_verbose(verbose, "The passcode is no longer valid");
+		rc = -EACCES;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_object, rc, -EIO,
+		       "No or invalid response content", verbose, out);
+
+	login_token = json_get_string(response_obj, "authorizationToken");
+	JSON_CHECK_ERROR(login_token == NULL, rc, -EBADMSG,
+			 "Invalid response content", verbose, out);
+
+	if (strncmp(login_token, "Bearer ", 7) != 0) {
+		rc = -EBADMSG;
+		pr_verbose(verbose, "Received token is not a Bearer token");
+		goto out;
+	}
+
+	tok = &login_token[7];
+	while (*tok == ' ')
+		tok++;
+
+	fp = fopen(config->login_token, "w");
+	if (fp == NULL) {
+		rc = -errno;
+		pr_verbose(verbose, "Failed to open file %s: '%s'",
+			   config->login_token, strerror(-rc));
+		goto out;
+	}
+
+	count = fwrite(tok, 1, strlen(tok), fp);
+	if (count != strlen(tok)) {
+		pr_verbose(verbose, "Failed to write the token");
+		rc = -EIO;
+		goto out;
+	}
+
+	pr_verbose(verbose, "Login token successfully updated in file '%s'",
+		   config->login_token);
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (request_obj != NULL)
+		json_object_put(request_obj);
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+	if (fp != NULL)
+		fclose(fp);
+
+	return rc;
+
+}
+
+/**
+ * Request the EKMFWeb server's public signing key and store it into PEM file
+ * specified in field server_pubkey of the config structure.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ */
+int ekmf_get_public_key(const struct ekmf_config *config, CURL **curl_handle,
+			char **error_msg, bool verbose)
+{
+	json_object *response_obj = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	EVP_PKEY *pkey = NULL;
+	CURL *curl = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL)
+		return -EINVAL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, EKMF_URI_SYSTEM_PUBKEY, "GET",
+				   NULL, NULL, login_token, &response_obj, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_object, rc, -EIO,
+		       "No or invalid response content", verbose, out);
+
+	rc = json_web_key_as_pkey(response_obj, EVP_PKEY_RSA, &pkey);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed convert the JWK to PKEY");
+		goto out;
+	}
+
+	rc = write_public_key(config->ekmf_server_pubkey, pkey);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to write public key '%s': %s",
+			   config->ekmf_server_pubkey, strerror(-rc));
+		goto out;
+	}
+
+	pr_verbose(verbose, "EKMFWeb public key written to file '%s'",
+		   config->ekmf_server_pubkey);
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+	if (login_token != NULL)
+		free(login_token);
+	if (pkey != NULL)
+		EVP_PKEY_free(pkey);
+
+	return rc;
+}
+
+/**
+ * Finds the setting with the specified ID in the settings array, and returns
+ * its value if found, or NULL otherwise. The returned string is allocated
+ * and must be freed by the caller when no lnger used.
+ *
+ * @param settings_array    the JSON array containing the settings
+ * @param config            the setting ID to get
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns an allocated string conmtaining the setting value, or NULL
+ */
+static char *_ekmf_find_setting(json_object *settings_array,
+				const char *setting_id, bool verbose)
+{
+	const char *id, *value;
+	json_object *obj;
+	int rc = 0, i;
+
+	JSON_CHECK_OBJ(settings_array, json_type_array, rc, -EIO,
+		       "No settings array", verbose, out);
+
+	for (i = 0; i < (int)json_object_array_length(settings_array); i++) {
+		obj = json_object_array_get_idx(settings_array, i);
+		JSON_CHECK_OBJ(obj, json_type_object, rc, -EIO,
+			       "No settings object", verbose, out);
+
+		id = json_get_string(obj, "id");
+		JSON_CHECK_ERROR(id == NULL, rc, -EIO,
+				 "No id field in settings object", verbose,
+				 out);
+
+		if (strcmp(id, setting_id) != 0)
+			continue;
+
+		value = json_get_string(obj, "value");
+		JSON_CHECK_ERROR(value == NULL, rc, -EIO,
+				 "No value field in settings object", verbose,
+				 out);
+
+		return strdup(value);
+	}
+
+	pr_verbose(verbose, "Setting '%s' not found", setting_id);
+out:
+	return NULL;
+}
+
+/**
+ * Retrieves settings from the EKMFWeb server, such as the template names for
+ * generating keys in EKMFWeb.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param identity_template on return: If not NULL, the name of the template
+ *                          used to generate identity keys with. The caller
+ *                          must free the error string when it is not NULL.
+ * @param xts_key1_template on return: If not NULL, the name of the template
+ *                          used to generate the first XTS key with. The caller
+ *                          must free the error string when it is not NULL.
+ * @param xts_key1_template on return: If not NULL, the name of the template
+ *                          used to generate the second XTS key with. The caller
+ *                          must free the error string when it is not NULL.
+ * @param xts_key1_template on return: If not NULL, the name of the template
+ *                          used to generate a non-XTS key with. The caller
+ *                          must free the error string when it is not NULL.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ */
+int ekmf_get_settings(const struct ekmf_config *config, CURL **curl_handle,
+		      char **identity_template, char **xts_key1_template,
+		      char **xts_key2_template, char **non_xts_template,
+		      char **error_msg, bool verbose)
+{
+	json_object *response_obj = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL)
+		return -EINVAL;
+
+	if (identity_template == NULL && xts_key1_template == NULL &&
+	    xts_key2_template == NULL && non_xts_template == NULL)
+		return 0;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, EKMF_URI_SYSTEM_SETTINGS, "GET",
+				   NULL, NULL, login_token, &response_obj, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_array, rc, -EIO,
+		       "No or invalid response content", verbose, out);
+
+	if (identity_template != NULL) {
+		*identity_template = _ekmf_find_setting(response_obj,
+					SETTING_ID_IDENTITY_TEMPLATE, verbose);
+		if (*identity_template == NULL) {
+			if (error_msg != NULL) {
+				if (asprintf(error_msg, "The EKMF Web setting "
+					     "'Identity Key Template Name' "
+					     "must be configured") < 0)
+					error_msg = NULL;
+			}
+			rc = -EINVAL;
+			goto out;
+		}
+	}
+
+	if (xts_key1_template != NULL) {
+		*xts_key1_template = _ekmf_find_setting(response_obj,
+					SETTING_ID_XTS_KEY1_TEMPLATE, verbose);
+		if (*xts_key1_template == NULL) {
+			if (error_msg != NULL) {
+				if (asprintf(error_msg, "The EKMF Web setting "
+					     "'XTS Key Template Name (Key 1)' "
+					     "must be configured") < 0)
+					error_msg = NULL;
+			}
+			rc = -EINVAL;
+			goto out;
+		}
+	}
+
+	if (xts_key2_template != NULL) {
+		*xts_key2_template = _ekmf_find_setting(response_obj,
+					SETTING_ID_XTS_KEY2_TEMPLATE, verbose);
+		if (*identity_template == NULL) {
+			if (error_msg != NULL) {
+				if (asprintf(error_msg, "The EKMF Web setting "
+					     "'XTS Key Template Name (Key 2)' "
+					     "must be configured") < 0)
+					error_msg = NULL;
+			}
+			rc = -EINVAL;
+			goto out;
+		}
+	}
+
+	if (non_xts_template != NULL) {
+		*non_xts_template = _ekmf_find_setting(response_obj,
+					SETTING_ID_NON_XTS_TEMPLATE, verbose);
+		if (*non_xts_template == NULL) {
+			if (error_msg != NULL) {
+				if (asprintf(error_msg, "The EKMF Web setting "
+					     "'Non-XTS Key Template Name' "
+					     "must be configured") < 0)
+					error_msg = NULL;
+			}
+			rc = -EINVAL;
+			goto out;
+		}
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+	if (login_token != NULL)
+		free(login_token);
+	if (rc != 0) {
+		if (identity_template != NULL && *identity_template != NULL) {
+			free(*identity_template);
+			*identity_template = NULL;
+		}
+		if (xts_key1_template != NULL && *xts_key1_template != NULL) {
+			free(*xts_key1_template);
+			*xts_key1_template = NULL;
+		}
+		if (xts_key2_template != NULL && *xts_key2_template != NULL) {
+			free(*xts_key2_template);
+			*xts_key2_template = NULL;
+		}
+		if (non_xts_template != NULL && *non_xts_template != NULL) {
+			free(*non_xts_template);
+			*non_xts_template = NULL;
+		}
+	}
+
+	return rc;
+}
+
+/**
+ * Checks if the EKMFWeb server has the required Pervasive Encryption feature
+ * installed
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -ENOTSUP is returned, if the feature is not installed.
+ */
+int ekmf_check_feature(const struct ekmf_config *config, CURL **curl_handle,
+		       char **error_msg, bool verbose)
+{
+	json_object *response_obj = NULL, *obj;
+	bool found = false;
+	CURL *curl = NULL;
+	long status_code;
+	const char *id;
+	int rc, i;
+
+	if (config == NULL)
+		return -EINVAL;
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, EKMF_URI_SYSTEM_FEATURES, "GET",
+				   NULL, NULL, NULL, &response_obj, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_array, rc, -EIO,
+		       "No or invalid response content", verbose, out);
+
+	for (i = 0; i < (int)json_object_array_length(response_obj); i++) {
+		obj = json_object_array_get_idx(response_obj, i);
+		JSON_CHECK_OBJ(obj, json_type_object, rc, -EIO,
+			       "No features object", verbose, out);
+
+		id = json_get_string(obj, "id");
+		JSON_CHECK_ERROR(id == NULL, rc, -EIO,
+				 "No id field in settings object", verbose,
+				 out);
+
+		if (strcmp(id, FEATURE_ID_PERVASIVE_ENCRYPTION) != 0)
+			continue;
+
+		found = true;
+		break;
+	}
+
+	if (!found) {
+		pr_verbose(verbose, "Feature '%s' is not installed",
+			   FEATURE_ID_PERVASIVE_ENCRYPTION);
+		rc = -ENOTSUP;
+		if (asprintf(error_msg, "EKMF Web feature "
+			     "'Pervasive Encryption' is not installed.")) {
+			pr_verbose(verbose, "asprintf failed");
+			rc = -ENOMEM;
+		}
+		goto out;
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+
+	return rc;
+}
+
+
+/**
+ * Build the party info JSON object as base64(sha256(key_uuid|timestamp)).
+ * Digest_nid specifies the digest to use, ot 0 to use the default (SHA256).
+ * The function returns the party info JSON object, as well as the raw party
+ * info.
+ */
+static int _ekmf_build_party_info(const char *key_uuid, const char *timestamp,
+				  int digest_nid, unsigned char *party_info,
+				  size_t *party_info_length,
+				  json_object **party_info_obj, bool verbose)
+{
+	unsigned int digest_len;
+	EVP_MD_CTX *ctx = NULL;
+	const EVP_MD *md;
+	int rc;
+
+	md = EVP_get_digestbynid(digest_nid != 0 ? digest_nid : NID_sha256);
+	if (md == NULL) {
+		pr_verbose(verbose, "Failed to get specified digest");
+		rc = -EINVAL;
+		goto out;
+	}
+
+	if (*party_info_length < (size_t)EVP_MD_size(md)) {
+		pr_verbose(verbose, "Party info buffer is too small");
+		return -ERANGE;
+		goto out;
+	}
+
+	ctx = EVP_MD_CTX_create();
+	if (ctx == NULL) {
+		pr_verbose(verbose, "Failed to allocate MD context");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = EVP_DigestInit_ex(ctx, md, NULL);
+	if (rc != 1) {
+		pr_verbose(verbose, "Failed to initialize MD context");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = EVP_DigestUpdate(ctx, key_uuid, strlen(key_uuid));
+	if (rc != 1) {
+		pr_verbose(verbose, "Failed to add data to the MD context");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = EVP_DigestUpdate(ctx, timestamp, strlen(timestamp));
+	if (rc != 1) {
+		pr_verbose(verbose, "Failed to add data to the MD context");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = EVP_DigestFinal_ex(ctx, party_info, &digest_len);
+	if (rc != 1) {
+		pr_verbose(verbose, "Failed to finalize the MD context");
+		rc = -EIO;
+		goto out;
+	}
+
+	*party_info_length = digest_len;
+	*party_info_obj = json_object_new_base64url(party_info, digest_len);
+	rc = 0;
+
+out:
+	if (ctx != NULL)
+		EVP_MD_CTX_destroy(ctx);
+
+	return rc;
+}
+
+/**
+ * Builds a (detached) JSON Web Signature using the secure identity key from
+ * the payload and returns a signature JSON object
+ */
+static int _ekmf_build_signature(unsigned char *key_blob,
+				 size_t key_blob_length,
+				 json_object *payload_obj,
+				 json_object **signature_obj,
+				 int digest_nid, bool use_rsa_pss,
+				 const char *jws_kid,
+				 const struct ekmf_ext_lib *ext_lib,
+				 bool verbose)
+{
+	struct ekmf_rsa_pss_params rsa_pss_params;
+	EVP_PKEY_CTX *pkey_ctx = NULL;
+	struct private_data private;
+	EVP_MD_CTX *md_ctx = NULL;
+	bool pkey_meth = false;
+	EVP_PKEY *pkey = NULL;
+	const char *payload;
+	const char *jws_alg;
+	int rc, curve_nid;
+	char *jws = NULL;
+	int pkey_type;
+	BIO *b;
+
+	switch (ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		rc = cca_get_key_type(key_blob, key_blob_length, &pkey_type);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to get the identity key "
+				   "type");
+			goto out;
+		}
+
+		switch (pkey_type) {
+		case EVP_PKEY_EC:
+			rc = cca_get_ecc_pub_key_as_pkey(key_blob,
+							 key_blob_length,
+							 &pkey, verbose);
+			break;
+		case EVP_PKEY_RSA:
+		case EVP_PKEY_RSA_PSS:
+			rc = cca_get_rsa_pub_key_as_pkey(key_blob,
+							 key_blob_length,
+							 use_rsa_pss ?
+							     EVP_PKEY_RSA_PSS :
+							     EVP_PKEY_RSA,
+							 &pkey, verbose);
+			break;
+		}
+
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to get the identity PKEY");
+			goto out;
+		}
+		break;
+	default:
+		pr_verbose(verbose, "Invalid ext lib type: %d", ext_lib->type);
+		return -EINVAL;
+	}
+
+	/*
+	 * Only the following combinations are allowed per RFC7518 for JSON
+	 * Web Signatures (JWS) using ECC or RSA identity keys:
+	 *   alg=ES256: ECDSA using P-256 and SHA-256
+	 *   alg=ES384: ECDSA using P-384 and SHA-384
+	 *   alg=ES512: ECDSA using P-521 and SHA-512
+	 *   alg=RS256: RSA-PKCS1 using SHA-256
+	 *   alg=RS384: RSA-PKCS1 using SHA-384
+	 *   alg=RS512: RSA-PKCS1 using SHA-512
+	 *   alg=PS256: RSA-PSS using SHA-256, MGF1 with SHA-256, salt=digest
+	 *   alg=PS384: RSA-PSS using SHA-384, MGF1 with SHA-384, salt=digest
+	 *   alg=PS512: RSA-PSS using SHA-512, MGF1 with SHA-512, salt=digest
+	 */
+	switch (EVP_PKEY_id(pkey)) {
+	case EVP_PKEY_EC:
+		curve_nid = EC_GROUP_get_curve_name(EC_KEY_get0_group(
+						EVP_PKEY_get0_EC_KEY(pkey)));
+		switch (curve_nid) {
+		case NID_secp521r1:
+			digest_nid = NID_sha512;
+			jws_alg = "ES512";
+			break;
+		case NID_secp384r1:
+			digest_nid = NID_sha384;
+			jws_alg = "ES384";
+			break;
+		case NID_X9_62_prime256v1:
+			digest_nid = NID_sha256;
+			jws_alg = "ES256";
+			break;
+		default:
+			pr_verbose(verbose, "Unsupported curve");
+			rc = -EINVAL;
+			goto out;
+		}
+		break;
+	case EVP_PKEY_RSA:
+		switch (digest_nid) {
+		case NID_sha256:
+			jws_alg = "RS256";
+			break;
+		case NID_sha384:
+			jws_alg = "RS384";
+			break;
+		case NID_sha512:
+		case 0:
+			jws_alg = "RS512";
+			digest_nid = NID_sha512;
+			break;
+		default:
+			pr_verbose(verbose, "Unsupported digest");
+			rc = -EINVAL;
+			goto out;
+		}
+		break;
+	case EVP_PKEY_RSA_PSS:
+		switch (digest_nid) {
+		case NID_sha256:
+			jws_alg = "PS256";
+			break;
+		case NID_sha384:
+			jws_alg = "PS384";
+			break;
+		case NID_sha512:
+		case 0:
+			jws_alg = "PS512";
+			digest_nid = NID_sha512;
+			break;
+		default:
+			pr_verbose(verbose, "Unsupported digest");
+			rc = -EINVAL;
+			goto out;
+		}
+		rsa_pss_params.mgf_digest_nid = digest_nid;
+		rsa_pss_params.salt_len = RSA_PSS_SALTLEN_DIGEST;
+		break;
+	default:
+		pr_verbose(verbose, "Unsupported key type");
+		rc = -EINVAL;
+		goto out;
+	}
+
+	private.ext_lib = ext_lib;
+	private.verbose = verbose;
+
+	rc = _ekmf_setup_sign_context(key_blob, key_blob_length, pkey,
+				      digest_nid, &rsa_pss_params, &md_ctx,
+				      &pkey_ctx, &private, verbose);
+	if (rc != 0)
+		goto out;
+	pkey_meth = true;
+
+	payload = json_object_to_json_string_ext(payload_obj,
+					JSON_C_TO_STRING_PLAIN |
+					JSON_C_TO_STRING_NOSLASHESCAPE);
+	if (payload == NULL) {
+		pr_verbose(verbose, "Failed to get the payload string");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (verbose) {
+		pr_verbose(verbose, "JWS Payload: ->%s<-", payload);
+		pr_verbose(verbose, "JWS alg: %s", jws_alg);
+		pr_verbose(verbose, "Public signing key:");
+		b = BIO_new_fp(stderr, BIO_NOCLOSE);
+		PEM_write_bio_PUBKEY(b, pkey);
+		BIO_free(b);
+	}
+
+	rc = create_json_web_signature(jws_alg, false, jws_kid,
+				       (unsigned char *)payload,
+				       strlen(payload), true, md_ctx, &jws);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build the JWS");
+		goto out;
+	}
+
+	*signature_obj = json_object_new_string(jws);
+	rc = 0;
+
+out:
+	if (md_ctx != NULL)
+		EVP_MD_CTX_free(md_ctx);
+	if (pkey_meth)
+		cleanup_secure_key_pkey_method(EVP_PKEY_id(pkey));
+	if (pkey != NULL)
+		EVP_PKEY_free(pkey);
+	if (jws != NULL)
+		free(jws);
+
+	return rc;
+}
+
+/**
+ * Verifies the (detached) JSON Web Signature using the server's public signing
+ * key and the response payload.
+ * Note: This function removes the signature field from the response JSON
+ *       object!
+ */
+static int _ekmf_verify_signature(json_object *response_obj,
+				  EVP_PKEY *server_pubkey, bool verbose)
+{
+	json_object *signature_obj = NULL;
+	const char *sign_payload;
+	BIO *b;
+	int rc;
+
+	if (response_obj == NULL)
+		return -EINVAL;
+
+	json_object_object_get_ex(response_obj, "signature",
+				  &signature_obj);
+	JSON_CHECK_OBJ(signature_obj, json_type_string, rc, -EIO,
+		       "Failed to get the response signature", verbose, out);
+
+	json_object_get(signature_obj); /* Take ownership */
+	json_object_object_del(response_obj, "signature");
+
+	sign_payload = json_object_to_json_string_ext(response_obj,
+					JSON_C_TO_STRING_PLAIN |
+					JSON_C_TO_STRING_NOSLASHESCAPE);
+	if (sign_payload == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	if (verbose) {
+		pr_verbose(verbose, "JWS Payload: ->%s<-", sign_payload);
+		pr_verbose(verbose, "Public signing key:");
+		b = BIO_new_fp(stderr, BIO_NOCLOSE);
+		PEM_write_bio_PUBKEY(b, server_pubkey);
+		BIO_free(b);
+	}
+
+	rc = verify_json_web_signature(json_object_get_string(signature_obj),
+				       (const unsigned char *)sign_payload,
+				       strlen(sign_payload), server_pubkey);
+	if (rc != 0) {
+		pr_verbose(verbose, "Signature verify of response failed");
+		goto out;
+	}
+
+	pr_verbose(verbose, "Signature of response successfully verified");
+
+out:
+	if (signature_obj != NULL)
+		json_object_put(signature_obj);
+
+	return rc;
+}
+
+/**
+ * Import the key retrieved from EKMFWeb.
+ */
+static int _ekmf_import_key(unsigned char *req_sess_key,
+			    size_t req_sess_key_length,
+			    unsigned char *req_party_info,
+			    size_t req_party_info_length,
+			    unsigned char *resp_party_info,
+			    size_t resp_party_info_length,
+			    json_object *resp_sess_jwk_obj,
+			    json_object *resp_exp_jwk_obj,
+			    unsigned char *key_blob, size_t *key_blob_length,
+			    const struct ekmf_ext_lib *ext_lib, bool verbose)
+{
+	size_t resp_sess_ec_key_length, resp_exported_key_length;
+	unsigned char resp_exported_key[MAX_SYM_KEY_BLOB_SIZE];
+	unsigned char transport_key[MAX_SYM_KEY_BLOB_SIZE];
+	unsigned char resp_sess_key[MAX_KEY_BLOB_SIZE];
+	size_t party_info_length, transport_key_length;
+	unsigned char *party_info = NULL;
+	int rc;
+
+	party_info_length = req_party_info_length + resp_party_info_length;
+	party_info = malloc(party_info_length);
+	if (party_info == NULL) {
+		pr_verbose(verbose, "Failed to allocate memory");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	memcpy(party_info, req_party_info, req_party_info_length);
+	memcpy(party_info + req_party_info_length, resp_party_info,
+	       resp_party_info_length);
+
+	switch (ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		resp_sess_ec_key_length = sizeof(resp_sess_key);
+		rc = cca_import_key_from_json_web_key(ext_lib->cca,
+						      resp_sess_jwk_obj,
+						      resp_sess_key,
+						      &resp_sess_ec_key_length,
+						      verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to import the session EC "
+				   "key");
+			goto out;
+		}
+
+		transport_key_length = sizeof(transport_key);
+		rc = cca_ec_dh_derive_importer(ext_lib->cca,
+					       req_sess_key,
+					       req_sess_key_length,
+					       resp_sess_key,
+					       resp_sess_ec_key_length,
+					       party_info, party_info_length,
+					       CCA_KDF_ANS_X9_63_CCA,
+					       transport_key,
+					       &transport_key_length,
+					       verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to derive transport key");
+			goto out;
+		}
+
+		resp_exported_key_length = sizeof(resp_exported_key);
+		rc = cca_import_key_from_json_web_key(ext_lib->cca,
+						      resp_exp_jwk_obj,
+						      resp_exported_key,
+						      &resp_exported_key_length,
+						      verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to import the exported "
+				   "key");
+			goto out;
+		}
+
+		rc = cca_import_external_key(ext_lib->cca, resp_exported_key,
+					     resp_exported_key_length,
+					     transport_key,
+					     transport_key_length,
+					     key_blob, key_blob_length,
+					     verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to unwrap the exported "
+				   "key with the transport key");
+			goto out;
+		}
+
+		break;
+	default:
+		pr_verbose(verbose, "Invalid ext lib type: %d", ext_lib->type);
+		return -EINVAL;
+	}
+
+out:
+	if (party_info != NULL)
+		free(party_info);
+
+	return rc;
+}
+
+/**
+ * Requests a key to be retrieved from EKMFweb and imported under the current
+ * HSM's master key.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to retrieve
+ * @param sess_ec_curve_nid The OpenSSL nid of the EC curve used for the session
+ *                          ECC key. If 0, then the default curve is used.
+ * @param sign_rsa_digest_nid The OpenSSL nid of a digest used to sign the
+ *                          request with if the identity key is an RSA-type key.
+ *                          If 0, then the default digest is used.
+ *                          Ignored for ECC-type identity keys.
+ * @param use_rsa_pss       If true, and the identity key is an RSA-type key,
+ *                          use RSA-PSS to sign the request.
+ * @param signature_kid     the Key ID for the signature of the request
+ * @param key_blob          a buffer to store the retrieved key blob to
+ * @param key_blob_length   On entry: the size ofthe buffer
+ *                          On return: the size of the key blob retrieved
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          retrieve the key
+ */
+int ekmf_retrieve_key(const struct ekmf_config *config, CURL **curl_handle,
+		      const char *key_uuid, int sess_ec_curve_nid,
+		      int sign_rsa_digest_nid, bool use_rsa_pss,
+		      const char *signature_kid, unsigned char *key_blob,
+		      size_t *key_blob_length, char **error_msg,
+		      const struct ekmf_ext_lib *ext_lib, bool verbose)
+{
+	size_t req_party_info_length, resp_party_info_length;
+	unsigned char req_party_info[SHA512_DIGEST_LENGTH];
+	size_t req_sess_ec_key_length, identity_key_length;
+	unsigned char req_sess_ec_key[MAX_KEY_BLOB_SIZE];
+	unsigned char identity_key[MAX_KEY_BLOB_SIZE];
+	json_object *resp_originator_obj = NULL;
+	json_object *resp_addl_info_obj = NULL;
+	json_object *req_party_info_obj = NULL;
+	json_object *req_originator_obj = NULL;
+	json_object *req_timestamp_obj = NULL;
+	json_object *req_addl_info_obj = NULL;
+	json_object *req_signature_obj = NULL;
+	unsigned char *resp_party_info = NULL;
+	json_object *resp_sess_jwk_obj = NULL;
+	json_object *req_sess_jwk_obj = NULL;
+	json_object *resp_exp_jwk_obj = NULL;
+	json_object *response_obj = NULL;
+	json_object *request_obj = NULL;
+	EVP_PKEY *server_pubkey = NULL;
+	char *escaped_uuid = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	long status_code;
+	char *uri = NULL;
+	int rc;
+
+	if (config == NULL || key_uuid == NULL || key_blob == NULL ||
+	    key_blob_length == NULL || ext_lib == NULL)
+		return -EINVAL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = read_public_key(config->ekmf_server_pubkey, &server_pubkey);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to read EKMFWeb server's public key"
+			   " '%s': %s", config->ekmf_server_pubkey,
+			   strerror(-rc));
+		goto out;
+	}
+
+	identity_key_length = sizeof(identity_key);
+	rc = read_key_blob(config->identity_secure_key, identity_key,
+			   &identity_key_length);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to read identity key from file "
+			   "'%s': %s", config->identity_secure_key,
+			   strerror(-rc));
+		goto out;
+	}
+
+	switch (ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		req_sess_ec_key_length = sizeof(req_sess_ec_key);
+		rc = cca_generate_ecc_key_pair(ext_lib->cca,
+					       sess_ec_curve_nid != 0 ?
+						  sess_ec_curve_nid :
+						  DEFAULT_SESSION_EC_KEY_CURVE,
+					       req_sess_ec_key,
+					       &req_sess_ec_key_length,
+					       verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to generate a session EC "
+				   "key");
+			goto out;
+		}
+
+		rc = cca_get_ecc_pub_key_as_json_web_key(req_sess_ec_key,
+							 req_sess_ec_key_length,
+							 &req_sess_jwk_obj,
+							 verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to generate session JWK");
+			goto out;
+		}
+		break;
+	default:
+		pr_verbose(verbose, "Invalid ext lib type: %d", ext_lib->type);
+		return -EINVAL;
+	}
+
+	req_timestamp_obj = get_json_timestamp();
+	JSON_CHECK_ERROR(req_timestamp_obj == NULL, rc, -EIO,
+			 "Failed to generate timestamp", verbose, out);
+
+	req_party_info_length = sizeof(req_party_info);
+	rc = _ekmf_build_party_info(key_uuid,
+				    json_object_get_string(req_timestamp_obj),
+				    NID_sha256, req_party_info,
+				    &req_party_info_length,
+				    &req_party_info_obj, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build the party info");
+		goto out;
+	}
+
+	/*
+	 * Note: The order of the fields is important, EKMFWeb expects it in
+	 * exactly this order!
+	 */
+	req_addl_info_obj = json_object_new_object();
+	JSON_CHECK_ERROR(req_addl_info_obj == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object", verbose, out);
+
+	rc = json_object_object_add_ex(req_addl_info_obj, "kdf",
+				       json_object_new_string("ANS-X9.63-CCA"),
+				       0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	rc = json_object_object_add_ex(req_addl_info_obj, "requestedKey",
+				       json_object_new_string(key_uuid), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	rc = json_object_object_add_ex(req_addl_info_obj, "timestamp",
+				       req_timestamp_obj, 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	req_timestamp_obj = NULL;
+
+	req_originator_obj = json_object_new_object();
+	JSON_CHECK_ERROR(req_originator_obj == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object", verbose, out);
+
+	rc = json_object_object_add_ex(req_originator_obj, "session",
+				       req_sess_jwk_obj, 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	req_sess_jwk_obj = NULL;
+	rc = json_object_object_add_ex(req_originator_obj, "partyInfo",
+				       req_party_info_obj, 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	req_party_info_obj = NULL;
+
+	request_obj = json_object_new_object();
+	JSON_CHECK_ERROR(request_obj == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object", verbose, out);
+
+	rc = json_object_object_add_ex(request_obj, "originator",
+				       req_originator_obj, 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	req_originator_obj = NULL;
+	rc = json_object_object_add_ex(request_obj, "additionalInfo",
+				       req_addl_info_obj, 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	req_addl_info_obj = NULL;
+
+	rc = _ekmf_build_signature(identity_key, identity_key_length,
+				   request_obj, &req_signature_obj,
+				   sign_rsa_digest_nid, use_rsa_pss,
+				   signature_kid, ext_lib, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build the signature");
+		goto out;
+	}
+
+	rc = json_object_object_add_ex(request_obj, "signature",
+				       req_signature_obj, 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	req_signature_obj = NULL;
+
+	escaped_uuid = curl_easy_escape(curl, key_uuid, 0);
+	if (escaped_uuid == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the key uuid");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_KEYS_EXPORT, escaped_uuid) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, uri, "POST", request_obj, NULL,
+				   login_token, &response_obj, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	case 404:
+		pr_verbose(verbose, "Not found");
+		rc = -ENOENT;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_object, rc, -EBADMSG,
+		       "No or invalid response", verbose, out);
+
+	rc = _ekmf_verify_signature(response_obj, server_pubkey, verbose);
+	if (rc != 0)
+		goto out;
+
+	json_object_object_get_ex(response_obj, "originator",
+				  &resp_originator_obj);
+	JSON_CHECK_OBJ(resp_originator_obj, json_type_object, rc, -EBADMSG,
+		       "Failed to get the response originator", verbose, out);
+
+	json_object_object_get_ex(resp_originator_obj, "session",
+				  &resp_sess_jwk_obj);
+	JSON_CHECK_OBJ(resp_sess_jwk_obj, json_type_object, rc, -EBADMSG,
+		       "Failed to get the response session key", verbose, out);
+
+	rc = json_object_get_base64url(resp_originator_obj, "partyInfo",
+				       NULL, &resp_party_info_length);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get the response partyInfo");
+		goto out;
+	}
+
+	resp_party_info = malloc(resp_party_info_length);
+	if (resp_party_info == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = json_object_get_base64url(resp_originator_obj, "partyInfo",
+				       resp_party_info,
+				       &resp_party_info_length);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get the response partyInfo");
+		goto out;
+	}
+
+	json_object_object_get_ex(response_obj, "additionalInfo",
+				  &resp_addl_info_obj);
+	JSON_CHECK_OBJ(resp_addl_info_obj, json_type_object, rc, -EBADMSG,
+		       "Failed to get the response addl.info", verbose, out);
+
+	json_object_object_get_ex(resp_addl_info_obj, "exportedKey",
+				  &resp_exp_jwk_obj);
+	JSON_CHECK_OBJ(resp_exp_jwk_obj, json_type_object, rc, -EBADMSG,
+		       "Failed to get the response exported key", verbose, out);
+
+	rc = _ekmf_import_key(req_sess_ec_key, req_sess_ec_key_length,
+			      req_party_info, req_party_info_length,
+			      resp_party_info, resp_party_info_length,
+			      resp_sess_jwk_obj, resp_exp_jwk_obj,
+			      key_blob, key_blob_length, ext_lib, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to import the retrieved key");
+		goto out;
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (req_sess_jwk_obj != NULL)
+		json_object_put(req_sess_jwk_obj);
+	if (req_timestamp_obj != NULL)
+		json_object_put(req_timestamp_obj);
+	if (req_addl_info_obj != NULL)
+		json_object_put(req_addl_info_obj);
+	if (req_party_info_obj != NULL)
+		json_object_put(req_party_info_obj);
+	if (req_originator_obj != NULL)
+		json_object_put(req_originator_obj);
+	if (req_signature_obj != NULL)
+		json_object_put(req_signature_obj);
+	if (request_obj != NULL)
+		json_object_put(request_obj);
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+	if (uri != NULL)
+		free(uri);
+	if (login_token != NULL)
+		free(login_token);
+	if (server_pubkey != NULL)
+		EVP_PKEY_free(server_pubkey);
+	if (resp_party_info != NULL)
+		free(resp_party_info);
+	if (escaped_uuid != NULL)
+		curl_free(escaped_uuid);
+
+	return rc;
+}
+
+/**
+ * Callback function for the _ekmf_list_request function. This callback
+ * is called for each result element. The curl handle can be used to perform
+ * further requests within the callback. However, the curl handle must not be
+ * closed/destroyed!
+ */
+typedef int (*ekmf_element_cb_t)(CURL *curl, json_object *element,
+				 void *private, bool verbose);
+
+/**
+ * Performs a list request (GET) on a base list_uri and iterates over
+ * multiple pages. The response of a list request is expected to be a
+ * JSON array of elements. For each element, the element callback is called
+ * with the element.
+ * The list_uri must contain anything required to list the desired objects,
+ * except the page and perPage UTL parameters. Those are added by this function.
+ */
+static int _ekmf_list_request(const struct ekmf_config *config,
+			      const char *list_uri, CURL *curl,
+			      ekmf_element_cb_t element_cb, void *private,
+			      const char *login_token, char **error_msg,
+			      bool verbose)
+{
+	json_object *response_obj = NULL;
+	json_object *element_obj;
+	int num, i, rc = 0;
+	unsigned int page;
+	char *uri = NULL;
+	long status_code;
+	bool has_query;
+
+	if (config == NULL || list_uri == NULL || element_cb == NULL ||
+	    curl == NULL)
+		return -EINVAL;
+
+	has_query = strchr(list_uri, '?') != NULL;
+
+	for (page = 1; ; page++) {
+		if (asprintf(&uri, "%s%sperPage=%u&page=%u", list_uri,
+			     has_query ? "&" : "?", LIST_ELEMENTS_PER_PAGE,
+			     page) < 0) {
+			pr_verbose(verbose, "asprintf failed");
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = _ekmf_perform_request(config, uri, "GET", NULL, NULL,
+					   login_token, &response_obj, NULL,
+					   &status_code, error_msg, curl,
+					   verbose);
+
+		free(uri);
+		uri = NULL;
+
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed perform the REST call");
+			if (rc > 0)
+				rc = -EIO;
+			goto out;
+		}
+
+		switch (status_code) {
+		case 200:
+			break;
+		case 400:
+			pr_verbose(verbose, "Bad request");
+			rc = -EBADMSG;
+			goto out;
+		case 401:
+			pr_verbose(verbose, "Not authorized");
+			rc = -EACCES;
+			goto out;
+		case 403:
+			pr_verbose(verbose, "Insufficient permissions");
+			rc = -EPERM;
+			goto out;
+		default:
+			pr_verbose(verbose, "REST Call failed with HTTP "
+				   "status code: %ld", status_code);
+			rc = -EIO;
+			goto out;
+		}
+
+		JSON_CHECK_OBJ(response_obj, json_type_array, rc, -EIO,
+			       "No or invalid response content", verbose, out);
+
+		num = json_object_array_length(response_obj);
+		if (num == 0)
+			break;
+
+		for (i = 0; i < num; i++) {
+			element_obj = json_object_array_get_idx(response_obj,
+								i);
+			if (element_obj == NULL) {
+				pr_verbose(verbose, "Failed to get array "
+					   "element for index %d", i);
+				rc = -EBADMSG;
+				goto out;
+			}
+
+			rc = element_cb(curl, element_obj, private, verbose);
+			if (rc != 0) {
+				pr_verbose(verbose, "Element-callback failed "
+					   "for index %d", i);
+				goto out;
+			}
+		}
+
+		if (response_obj != NULL)
+			json_object_put(response_obj);
+		response_obj = NULL;
+
+		if (num < LIST_ELEMENTS_PER_PAGE)
+			break;
+	}
+
+out:
+	if (uri != NULL)
+		free(uri);
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+
+	return rc;
+}
+
+struct ekmf_template_cb_data_t {
+	ekmf_template_cb_t template_cb;
+	void *cb_private;
+};
+
+/**
+ * Callback for template list function. Builds the template info structure
+ * and calls the application callback.
+ */
+static int _ekmf_template_cb(CURL *curl, json_object *element,
+			     void *private, bool verbose)
+{
+	struct ekmf_template_cb_data_t *cb_data = private;
+	struct ekmf_template_info template = { 0 };
+	int rc;
+
+	if (cb_data->template_cb == NULL) {
+		pr_verbose(verbose, "No template callback function");
+		return -EINVAL;
+	}
+
+	rc = json_build_template_info(element, &template, false);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build template info");
+		goto out;
+	}
+
+	rc = cb_data->template_cb(curl, &template, cb_data->cb_private);
+	if (rc != 0) {
+		pr_verbose(verbose, "Template callback rc: %d", rc);
+		goto out;
+	}
+
+out:
+	free_tag_def_list(&template.label_tags, false);
+
+	return rc;
+}
+
+/**
+ * List available key templates. Only templates in state ACTIVE, with key
+ * algorithm AES and keystore type PERVASIVE_ENCRYPTION are listed. The
+ * templates are ordered by name in ascending order.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param template_cb       a callback function that is called for each template
+ *                          found
+ * @param private           a pointer that is passed as-is to the callback
+ * @param name_pattern      a pattern to filter by name, or NULL to list all.
+ * @param state             the state of the templates to list. If NULL then
+ *                          templates in state 'ACTIVE' are listed
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          list the templates
+ */
+int ekmf_list_templates(const struct ekmf_config *config, CURL **curl_handle,
+			ekmf_template_cb_t template_cb, void *private,
+			const char *name_pattern, const char *state,
+			char **error_msg, bool verbose)
+{
+	struct ekmf_template_cb_data_t cb_data;
+	char *escaped_name_pattern = NULL;
+	char *escaped_state = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	char *uri = NULL;
+	int rc;
+
+	if (config == NULL || template_cb == NULL)
+		return -EINVAL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	cb_data.template_cb = template_cb;
+	cb_data.cb_private = private;
+
+	escaped_name_pattern = curl_easy_escape(curl, name_pattern != NULL ?
+							name_pattern : "*", 0);
+	if (escaped_name_pattern == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the name pattern");
+		rc = -EIO;
+		goto out;
+	}
+
+	escaped_state = curl_easy_escape(curl, state != NULL ? state :
+						TEMPLATE_STATE_ACTIVE, 0);
+	if (escaped_state == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the state");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_TEMPLATE_LIST, escaped_state,
+		     ORDER_BY_NAME_ASC, escaped_name_pattern) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_list_request(config, uri, curl, _ekmf_template_cb,
+				&cb_data, login_token, error_msg, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to perform the list request");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (login_token != NULL)
+		free(login_token);
+	if (uri != NULL)
+		free(uri);
+	if (escaped_name_pattern != NULL)
+		curl_free(escaped_name_pattern);
+	if (escaped_state != NULL)
+		curl_free(escaped_state);
+
+	return rc;
+}
+
+/**
+ * Get a template by its UUID.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param template_uuid     the UUID of the template to get
+ * @param template          an address of a template info pointer. On return
+ *                          the pointer is updated to point to a newly allocated
+ *                          template info struct. It must be freed by the caller
+ *                          using ekmf_free_template_info when no longer needed.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          get the template
+ */
+int ekmf_get_template(const struct ekmf_config *config, CURL **curl_handle,
+		      const char *template_uuid,
+		      struct ekmf_template_info **template, char **error_msg,
+		      bool verbose)
+{
+	json_object *response_obj = NULL;
+	char *escaped_uuid = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	char *uri = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL || template_uuid == NULL || template == NULL)
+		return -EINVAL;
+
+	*template = NULL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	escaped_uuid = curl_easy_escape(curl, template_uuid, 0);
+	if (escaped_uuid == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the template uuid");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_TEMPLATE_GET, escaped_uuid) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, uri, "GET", NULL, NULL,
+				   login_token, &response_obj, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	case 404:
+		pr_verbose(verbose, "Not found");
+		rc = -ENOENT;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_object, rc, -EBADMSG,
+		       "No or invalid response", verbose, out);
+
+	*template = calloc(1, sizeof(struct ekmf_template_info));
+	if (*template == NULL) {
+		pr_verbose(verbose, "calloc failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = json_build_template_info(response_obj, *template, true);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build template info");
+		goto out;
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+	if (login_token != NULL)
+		free(login_token);
+	if (uri != NULL)
+		free(uri);
+	if (escaped_uuid != NULL)
+		curl_free(escaped_uuid);
+	if (rc != 0 && *template != NULL) {
+		free_template_info(*template);
+		free(*template);
+		*template = NULL;
+	}
+
+	return rc;
+}
+
+/**
+ * Get the last used sequence number of a template by its UUID.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param template_uuid     the UUID of the template to get
+ * @param seqNumber         On return: the last used sequence number of this
+ *                          template.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          get the template
+ */
+int ekmf_get_last_seq_no(const struct ekmf_config *config, CURL **curl_handle,
+			 const char *template_uuid, unsigned int *seqNumber,
+			 char **error_msg, bool verbose)
+{
+	json_object *response_obj = NULL, *field = NULL;
+	char *escaped_uuid = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	char *uri = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL || template_uuid == NULL || seqNumber == NULL)
+		return -EINVAL;
+
+	*seqNumber = 0;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	escaped_uuid = curl_easy_escape(curl, template_uuid, 0);
+	if (escaped_uuid == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the template uuid");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_TEMPLATE_SEQNO, escaped_uuid) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, uri, "GET", NULL, NULL,
+				   login_token, &response_obj, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	case 404:
+		pr_verbose(verbose, "Not found");
+		rc = -ENOENT;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_object, rc, -EBADMSG,
+		       "No or invalid response", verbose, out);
+
+	json_object_object_get_ex(response_obj, "lastSequenceNumber", &field);
+	JSON_CHECK_OBJ(field, json_type_int, rc, -EBADMSG,
+		       "Invalid response", verbose, out);
+
+	*seqNumber = json_object_get_int(field);
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+	if (login_token != NULL)
+		free(login_token);
+	if (uri != NULL)
+		free(uri);
+	if (escaped_uuid != NULL)
+		curl_free(escaped_uuid);
+
+	return rc;
+}
+
+/**
+ * Clones a template info structure by making a deep copy of all strings and
+ * arrays.
+ * The copied template info must be freed using ekmf_free_template_info() by
+ * the caller.
+ *
+ * @param src               the source template info structure
+ * @param dest              the destination template info structure
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int ekmf_clone_template_info(const struct ekmf_template_info *src,
+			     struct ekmf_template_info **dest)
+{
+	if (src == NULL || dest == NULL)
+		return -EINVAL;
+
+	*dest = calloc(1, sizeof(struct ekmf_template_info));
+	if (*dest == NULL)
+		return -ENOMEM;
+
+	return clone_template_info(src, *dest);
+}
+
+/**
+ * Free a template info structure.
+ *
+ * @param template          the template to free
+ */
+void ekmf_free_template_info(struct ekmf_template_info *template)
+{
+	free_template_info(template);
+
+	free(template);
+}
+
+/**
+ * Gets the custom tags of a key by key-uuid. The custom tags are returned as
+ * JSON array. The returned JSON array must be freed by the caller using
+ * json_object_put().
+ */
+static int _ekmf_get_custom_tags(const struct ekmf_config *config,
+				 const char *key_uuid, CURL *curl,
+				 json_object **custom_tags,
+				 const char *login_token, char **error_msg,
+				 bool verbose)
+{
+	json_object *response_obj = NULL;
+	char *escaped_uuid = NULL;
+	char *uri = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL || key_uuid == NULL || custom_tags == NULL ||
+	    curl == NULL)
+		return -EINVAL;
+
+	escaped_uuid = curl_easy_escape(curl, key_uuid, 0);
+	if (escaped_uuid == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the key uuid");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_KEYS_TAGS, escaped_uuid) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, uri, "GET", NULL, NULL, login_token,
+				   &response_obj, NULL, &status_code, error_msg,
+				   curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_array, rc, -EIO,
+		       "No or invalid response content", verbose, out);
+
+	*custom_tags = response_obj;
+	rc = 0;
+
+out:
+	if (uri != NULL)
+		free(uri);
+	if (escaped_uuid != NULL)
+		curl_free(escaped_uuid);
+	if (rc != 0 && response_obj != NULL)
+		json_object_put(response_obj);
+
+	return rc;
+}
+
+/**
+ * Gets the export control infos of a key by key-uuid. The export control info
+ * is returned as JSON object. The returned JSON object must be freed by the
+ * caller using  json_object_put().
+ */
+static int _ekmf_get_export_control(const struct ekmf_config *config,
+				   const char *key_uuid, CURL *curl,
+				   json_object **export_control,
+				   const char *login_token, char **error_msg,
+				   bool verbose)
+{
+	json_object *response_obj = NULL;
+	char *escaped_uuid = NULL;
+	char *uri = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL || key_uuid == NULL || export_control == NULL ||
+	    curl == NULL)
+		return -EINVAL;
+
+	escaped_uuid = curl_easy_escape(curl, key_uuid, 0);
+	if (escaped_uuid == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the key uuid");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_KEYS_EXPORT_CONTROL, escaped_uuid) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, uri, "GET", NULL, NULL, login_token,
+				   &response_obj, NULL, &status_code, error_msg,
+				   curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_object, rc, -EIO,
+		       "No or invalid response content", verbose, out);
+
+	*export_control = response_obj;
+	rc = 0;
+
+out:
+	if (uri != NULL)
+		free(uri);
+	if (escaped_uuid != NULL)
+		curl_free(escaped_uuid);
+	if (rc != 0 && response_obj != NULL)
+		json_object_put(response_obj);
+
+	return rc;
+}
+
+/**
+ * Get the custom tags for a key and build the key info structure
+ */
+static int _ekmf_build_key_info(const struct ekmf_config *config, CURL *curl,
+				const char *login_token, json_object *obj,
+				struct ekmf_key_info *key, bool copy,
+				char **error_msg, bool verbose)
+{
+	json_object *export_control = NULL;
+	json_object *custom_tags = NULL;
+	int rc;
+
+	rc = _ekmf_get_custom_tags(config, json_get_string(obj, "keyId"),
+				   curl, &custom_tags, login_token, error_msg,
+				   verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get the custom tags for key %s",
+			   json_get_string(obj, "keyId"));
+		goto out;
+	}
+
+	rc = _ekmf_get_export_control(config, json_get_string(obj, "keyId"),
+				      curl, &export_control, login_token,
+				      error_msg, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get the custom tags for key %s",
+			   json_get_string(obj, "keyId"));
+		goto out;
+	}
+
+	rc = json_build_key_info(obj, custom_tags, export_control, key, copy);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build key info");
+		goto out;
+	}
+
+out:
+	/*
+	 * Add custom tags and export control JSON objects to the key object,
+	 * so that these objects are also owned by the key object, and thus are
+	 * freed together with it, when the caller puts/frees the key object.
+	 */
+	if (custom_tags != NULL)
+		json_object_object_add_ex(obj, "_custom_tags_", custom_tags, 0);
+	if (export_control != NULL)
+		json_object_object_add_ex(obj, "_export_control_",
+					  export_control, 0);
+
+	return rc;
+}
+
+
+struct ekmf_key_cb_data_t {
+	const struct ekmf_config *config;
+	const char *login_token;
+	char **error_msg;
+	ekmf_key_cb_t key_cb;
+	void *cb_private;
+};
+
+/**
+ * Callback for key list function. Builds the key info structure
+ * and calls the application callback.
+ */
+static int _ekmf_key_cb(CURL *curl, json_object *element,
+			void *private, bool verbose)
+{
+	struct ekmf_key_cb_data_t *cb_data = private;
+	struct ekmf_key_info key = { 0 };
+	int rc;
+
+	if (cb_data->key_cb == NULL) {
+		pr_verbose(verbose, "No key callback function");
+		return -EINVAL;
+	}
+
+	rc = _ekmf_build_key_info(cb_data->config, curl, cb_data->login_token,
+				  element, &key, false, cb_data->error_msg,
+				  verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build key info");
+		goto out;
+	}
+
+	rc = cb_data->key_cb(curl, &key, cb_data->cb_private);
+	if (rc != 0) {
+		pr_verbose(verbose, "Key callback rc: %d", rc);
+		goto out;
+	}
+
+out:
+	free_tag_list(&key.label_tags, false);
+	free_tag_list(&key.custom_tags, false);
+	free_export_control(&key.export_control, false);
+
+	return rc;
+}
+
+/**
+ * Builds the state URL parameter(s) from a comma separated list of states
+ *
+ * @param curl              the curl handle
+ * @param states            a comma separaed list of states
+ *
+ * @returns an allocated URL parameter value, or NULL in case of an error
+ */
+static char *_ekmf_build_state_filter(CURL *curl, const char *states)
+{
+	char *list, *tok, *ret = NULL, *tmp;
+	char *escaped_state;
+
+	if (states == NULL)
+		goto error;
+
+	list = strdup(states);
+	if (list == NULL)
+		goto error;
+
+	tok = strtok(list, ",");
+	while (tok != NULL) {
+		escaped_state = curl_easy_escape(curl, tok, 0);
+		if (escaped_state == NULL)
+			goto error;
+
+		if (asprintf(&tmp, "%s%s%s", ret != NULL ? ret : "",
+			     ret == NULL ? "" : EKMF_URI_KEYS_LIST_STATE,
+			     escaped_state) < 0)
+			tmp = NULL;
+		curl_free(escaped_state);
+		if (tmp == NULL)
+			goto error;
+		if (ret != NULL)
+			free(ret);
+		ret = tmp;
+
+		tok = strtok(NULL, ",");
+	}
+
+	free(list);
+	return ret;
+
+error:
+	if (ret != NULL)
+		free(ret);
+	return NULL;
+}
+
+/**
+ * List available keys. The keys are ordered by name in ascending order.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_cb            a callback function that is called for each key
+ *                          found
+ * @param private           a pointer that is passed as-is to the callback
+ * @param name_pattern      a pattern to filter by name, or NULL to list all.
+ * @param states            the states of the keys to list, or NULL to list keys
+ *                          in ACTIVE state only. Multiple states can be
+ *                          specified separated by comma.
+ * @param tags              a list of custom tags to use as filter, or NULL
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          list the keys
+ */
+int ekmf_list_keys(const struct ekmf_config *config, CURL **curl_handle,
+		   ekmf_key_cb_t key_cb, void *private,
+		   const char *name_pattern, const char *states,
+		   const struct ekmf_tag_list *tags,
+		   char **error_msg, bool verbose)
+{
+	struct ekmf_key_cb_data_t cb_data;
+	char *escaped_name_pattern = NULL;
+	json_object *tags_obj = NULL;
+	char *state_filter = NULL;
+	char *escaped_tags = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	char *uri = NULL;
+	size_t i;
+	int rc;
+
+	if (config == NULL || key_cb == NULL)
+		return -EINVAL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	cb_data.config = config;
+	cb_data.login_token = login_token;
+	cb_data.error_msg = error_msg;
+	cb_data.key_cb = key_cb;
+	cb_data.cb_private = private;
+
+	escaped_name_pattern = curl_easy_escape(curl, name_pattern != NULL ?
+							name_pattern : "*", 0);
+	if (escaped_name_pattern == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the name pattern");
+		rc = -EIO;
+		goto out;
+	}
+
+	state_filter = _ekmf_build_state_filter(curl, states != NULL ? states :
+						KEY_STATE_ACTIVE);
+	if (state_filter == NULL) {
+		pr_verbose(verbose, "Failed to build the state filter");
+		rc = -EIO;
+		goto out;
+	}
+
+	tags_obj = json_object_new_object();
+	JSON_CHECK_ERROR(tags_obj == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object", verbose, out);
+	for (i = 0; tags != NULL && i < tags->num_tags; i++) {
+		if (tags->tags[i].name == NULL || tags->tags[i].value == NULL) {
+			rc = -EINVAL;
+			goto out;
+		}
+
+		rc = json_object_object_add_ex(tags_obj, tags->tags[i].name,
+					       json_object_new_string(
+							tags->tags[i].value),
+					       0);
+		JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+				 "JSON object", verbose, out);
+	}
+
+	escaped_tags = curl_easy_escape(curl, json_object_to_json_string_ext(
+				tags_obj, JSON_C_TO_STRING_PLAIN |
+					  JSON_C_TO_STRING_NOSLASHESCAPE), 0);
+	if (escaped_tags == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the tags");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_KEYS_LIST, state_filter,
+		     ORDER_BY_LABEL_ASC, escaped_name_pattern,
+		     escaped_tags) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_list_request(config, uri, curl, _ekmf_key_cb,
+				&cb_data, login_token, error_msg, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to perform the list request");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (login_token != NULL)
+		free(login_token);
+	if (uri != NULL)
+		free(uri);
+	if (state_filter != NULL)
+		free(state_filter);
+	if (escaped_name_pattern != NULL)
+		curl_free(escaped_name_pattern);
+	if (escaped_tags != NULL)
+		curl_free(escaped_tags);
+	if (tags_obj != NULL)
+		json_object_put(tags_obj);
+
+	return rc;
+}
+
+/**
+ * Get information about a key by its UUID.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to get info for
+ * @param key               an address of a key info pointer. On return
+ *                          the pointer is updated to point to a newly allocated
+ *                          key info struct. It must be freed by the caller
+ *                          using ekmf_free_key_info when no longer needed.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          get the key info
+ */
+int ekmf_get_key_info(const struct ekmf_config *config, CURL **curl_handle,
+		      const char *key_uuid, struct ekmf_key_info **key,
+		      char **error_msg, bool verbose)
+{
+	json_object *response_obj = NULL;
+	char *escaped_uuid = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	char *uri = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL || key_uuid == NULL || key == NULL)
+		return -EINVAL;
+
+	*key = NULL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	escaped_uuid = curl_easy_escape(curl, key_uuid, 0);
+	if (escaped_uuid == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the key uuid");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_KEYS_GET, escaped_uuid) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_perform_request(config, uri, "GET", NULL, NULL,
+				   login_token, &response_obj, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	case 404:
+		pr_verbose(verbose, "Not found");
+		rc = -ENOENT;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_object, rc, -EBADMSG,
+		       "No or invalid response", verbose, out);
+
+	*key = calloc(1, sizeof(struct ekmf_key_info));
+	if (*key == NULL) {
+		pr_verbose(verbose, "calloc failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = _ekmf_build_key_info(config, curl, login_token, response_obj,
+				  *key, true, error_msg, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build template info");
+		goto out;
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+	if (login_token != NULL)
+		free(login_token);
+	if (uri != NULL)
+		free(uri);
+	if (escaped_uuid != NULL)
+		curl_free(escaped_uuid);
+	if (rc != 0 && *key != NULL) {
+		free_key_info(*key);
+		free(*key);
+		*key = NULL;
+	}
+
+	return rc;
+}
+
+/**
+ * Changes the state of a key identified by its UUID. To update a key,
+ * the timestamp from the last update is required. This can be found in
+ * the key info struct in field update_on.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to get info for
+ * @param new_state         the new state of the key
+ * @param updated_on        the timestamp of the last update (must match)
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          update the key.
+ *          -EAGAIN is returned if the timestamp does not match, indicating that
+ *          the key has been updated in the meantime.
+ */
+int ekmf_set_key_state(const struct ekmf_config *config, CURL **curl_handle,
+		       const char *key_uuid, const char *new_state,
+		       const char *updated_on, char **error_msg, bool verbose)
+{
+	char *request_headers[2] = { NULL, NULL };
+	json_object *request_obj = NULL;
+	char *escaped_uuid = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	char *if_match_hdr = NULL;
+	CURL *curl = NULL;
+	char *uri = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL || key_uuid == NULL || new_state == NULL ||
+	    updated_on == NULL)
+		return -EINVAL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	request_obj = json_object_new_object();
+	JSON_CHECK_ERROR(request_obj == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object", verbose, out);
+
+	rc = json_object_object_add_ex(request_obj, "state",
+				       json_object_new_string(new_state), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+
+	escaped_uuid = curl_easy_escape(curl, key_uuid, 0);
+	if (escaped_uuid == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the key uuid");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_KEYS_SET_STATE, escaped_uuid) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	if (asprintf(&if_match_hdr, "If-Match : %s", updated_on) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+	request_headers[0] = if_match_hdr;
+
+	rc = _ekmf_perform_request(config, uri, "PATCH", request_obj,
+				   request_headers, login_token, NULL, NULL,
+				   &status_code, error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 204:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	case 404:
+		pr_verbose(verbose, "Not found");
+		rc = -ENOENT;
+		goto out;
+	case 409:
+		pr_verbose(verbose, "Key was updated in the meantime");
+		rc = -EAGAIN;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (request_obj != NULL)
+		json_object_put(request_obj);
+	if (login_token != NULL)
+		free(login_token);
+	if (uri != NULL)
+		free(uri);
+	if (escaped_uuid != NULL)
+		curl_free(escaped_uuid);
+	if (if_match_hdr != NULL)
+		free(if_match_hdr);
+
+	return rc;
+}
+
+/**
+ * Sets (adds/changes) a custom tag of a key identified by its UUID. To update
+ * a key, the timestamp from the last update is required. This can be found in
+ * the key info struct in field update_on.
+ *
+ * @param config            the configuration structure
+ * @param curl              the CURL handle
+ * @param login_token       the login token to authenticate
+ * @param key_uuid          the UUID of the key to get info for
+ * @param tag               the tag to set
+ * @param updated_on        the timestamp of the last update (must match)
+ * @param delete            if true, the tag is deleted, otherwise it is updated
+ * @param etag              On return: the new update timestamp returned via
+ *                          the etag HTTP header. Must be freed by the caller.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          update the key.
+ *          -EAGAIN is returned if the timestamp does not match, indicating that
+ *          the key has been updated in the meantime.
+ */
+static int _ekmf_set_key_tag(const struct ekmf_config *config, CURL *curl,
+			     const char *login_token,  const char *key_uuid,
+			     const struct ekmf_tag *tag, const char *updated_on,
+			     bool delete, char **etag, char **error_msg,
+			     bool verbose)
+{
+	struct curl_slist *response_headers = NULL;
+	char *request_headers[2] = { NULL, NULL };
+	json_object *request_obj = NULL;
+	char *escaped_tag_name = NULL;
+	char *escaped_uuid = NULL;
+	char *if_match_hdr = NULL;
+	char *uri = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL || curl == NULL || login_token == NULL ||
+	    key_uuid == NULL || tag == NULL || updated_on == NULL ||
+	    etag == NULL)
+		return -EINVAL;
+
+	*etag = NULL;
+
+	if (!delete) {
+		request_obj = json_object_new_object();
+		JSON_CHECK_ERROR(request_obj == NULL, rc, -ENOMEM,
+				 "Failed to generate JSON object", verbose,
+				 out);
+
+		rc = json_object_object_add_ex(request_obj, "value",
+					json_object_new_string(tag->value), 0);
+		JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+				 "JSON object", verbose, out);
+	}
+
+	escaped_uuid = curl_easy_escape(curl, key_uuid, 0);
+	if (escaped_uuid == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the key uuid");
+		rc = -EIO;
+		goto out;
+	}
+
+	escaped_tag_name = curl_easy_escape(curl, tag->name, 0);
+	if (escaped_tag_name == NULL) {
+		pr_verbose(verbose, "Failed to url-escape the tag name");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (asprintf(&uri, EKMF_URI_KEYS_SET_TAG, escaped_uuid,
+		     escaped_tag_name) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	if (asprintf(&if_match_hdr, "If-Match : %s", updated_on) < 0) {
+		pr_verbose(verbose, "asprintf failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+	request_headers[0] = if_match_hdr;
+
+	rc = _ekmf_perform_request(config, uri, delete ? "DELETE" : "PUT",
+				   request_obj, request_headers, login_token,
+				   NULL, &response_headers, &status_code,
+				   error_msg, curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 200:
+	case 204:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	case 404:
+		pr_verbose(verbose, "Not found");
+		rc = -ENOENT;
+		goto out;
+	case 409:
+		pr_verbose(verbose, "Key was updated in the meantime");
+		rc = -EAGAIN;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	*etag = get_http_header_value(response_headers, "Etag");
+	if (*etag == NULL) {
+		pr_verbose(verbose, "No ETag in response headers");
+		rc = -EBADMSG;
+		goto out;
+	}
+
+out:
+	if (request_obj != NULL)
+		json_object_put(request_obj);
+	if (uri != NULL)
+		free(uri);
+	if (escaped_uuid != NULL)
+		curl_free(escaped_uuid);
+	if (escaped_tag_name != NULL)
+		curl_free(escaped_tag_name);
+	if (if_match_hdr != NULL)
+		free(if_match_hdr);
+	if (response_headers != NULL)
+		curl_slist_free_all(response_headers);
+
+	return rc;
+}
+
+/**
+ * Sets (changed/adds) custom tags of a key identified by its UUID. To update a
+ * key, the timestamp from the last update is required. This can be found in
+ * the key info struct in field update_on.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to get info for
+ * @param tags              a list of tags to set
+ * @param updated_on        the timestamp of the last update (must match)
+ * @param new_updated_on    on return: if not NULL, the new timestamp of the
+ *                          current update. Can be used for subsequent updates
+ *                          on the key.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          update the key.
+ *          -EAGAIN is returned if the timestamp does not match, indicating that
+ *          the key has been updated in the meantime.
+ */
+int ekmf_set_key_tags(const struct ekmf_config *config, CURL **curl_handle,
+		       const char *key_uuid, const struct ekmf_tag_list *tags,
+		       const char *updated_on, char **new_updated_on,
+		       char **error_msg, bool verbose)
+{
+	char *update_ts = (char *)updated_on;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	char *etag = NULL;
+	size_t i;
+	int rc;
+
+	if (config == NULL || key_uuid == NULL || tags == NULL ||
+	    updated_on == NULL)
+		return -EINVAL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	for (i = 0; i < tags->num_tags; i++) {
+		rc = _ekmf_set_key_tag(config, curl, login_token, key_uuid,
+				       &tags->tags[i], update_ts, false, &etag,
+				       error_msg, verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to set tag '%s'",
+				   tags->tags[i].name);
+			goto out;
+		}
+
+		if (update_ts != NULL && update_ts != updated_on)
+			free(update_ts);
+		update_ts = etag;
+		etag = NULL;
+	}
+
+	if (new_updated_on != NULL)
+		*new_updated_on = strdup(update_ts);
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (login_token != NULL)
+		free(login_token);
+	if (update_ts != NULL && update_ts != updated_on)
+		free(update_ts);
+	if (etag != NULL)
+		free(etag);
+
+	return rc;
+}
+
+/**
+ * Deletes custom tags of a key identified by its UUID. To update a
+ * key, the timestamp from the last update is required. This can be found in
+ * the key info struct in field update_on.
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param key_uuid          the UUID of the key to get info for
+ * @param tags              a list of tags to delete. Only the name of the tags
+ *                          must be present in the tag structs of the list, the
+ *                          values are ignored.
+ * @param updated_on        the timestamp of the last update (must match)
+ * @param new_updated_on    on return: if not NULL, the new timestamp of the
+ *                          current update. Can be used for subsequent updates
+ *                          on the key.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          update the key.
+ *          -EAGAIN is returned if the timestamp does not match, indicating that
+ *          the key has been updated in the meantime.
+ */
+int ekmf_delete_key_tags(const struct ekmf_config *config, CURL **curl_handle,
+			 const char *key_uuid, const struct ekmf_tag_list *tags,
+			 const char *updated_on, char **new_updated_on,
+			 char **error_msg, bool verbose)
+{
+	char *update_ts = (char *)updated_on;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	char *etag = NULL;
+	size_t i;
+	int rc;
+
+	if (config == NULL || key_uuid == NULL || tags == NULL ||
+	    updated_on == NULL)
+		return -EINVAL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	for (i = 0; i < tags->num_tags; i++) {
+		rc = _ekmf_set_key_tag(config, curl, login_token, key_uuid,
+				       &tags->tags[i], update_ts, true, &etag,
+				       error_msg, verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to delete tag '%s'",
+				   tags->tags[i].name);
+			goto out;
+		}
+
+		if (update_ts != NULL && update_ts != updated_on)
+			free(update_ts);
+		update_ts = etag;
+		etag = NULL;
+	}
+
+	if (new_updated_on != NULL)
+		*new_updated_on = strdup(update_ts);
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (login_token != NULL)
+		free(login_token);
+	if (update_ts != NULL && update_ts != updated_on)
+		free(update_ts);
+	if (etag != NULL)
+		free(etag);
+
+	return rc;
+}
+
+/**
+ * Clones a key info structure by making a deep copy of all strings and
+ * arrays.
+ * The copied key info must be freed using ekmf_free_key_info() by
+ * the caller.
+ *
+ * @param src               the source key info structure
+ * @param dest              the destination key info structure
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int ekmf_clone_key_info(const struct ekmf_key_info *src,
+			struct ekmf_key_info **dest)
+{
+	if (src == NULL || dest == NULL)
+		return -EINVAL;
+
+	*dest = calloc(1, sizeof(struct ekmf_key_info));
+	if (*dest == NULL)
+		return -ENOMEM;
+
+	return clone_key_info(src, *dest);
+}
+
+/**
+ * Free a key info structure.
+ *
+ * @param key               the key info to free
+ */
+void ekmf_free_key_info(struct ekmf_key_info *key)
+{
+	free_key_info(key);
+
+	free(key);
+}
+
+/**
+ * Build the export control JSON object.
+ *
+ * @param exporting_key     the key to add as exporting key
+ * @param expctl_obj        on return: the export control JSON object
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ */
+static int _ekmf_build_export_control(const char *exporting_key,
+				      json_object **expctl_obj, bool verbose)
+{
+	json_object *exp_keys = NULL;
+	json_object *exp_ref = NULL;
+	char *href = NULL;
+	int rc = 0;
+
+	*expctl_obj = json_object_new_object();
+	JSON_CHECK_ERROR(*expctl_obj == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object",
+			 verbose, out);
+
+	rc = json_object_object_add_ex(*expctl_obj, "exportAllowed",
+				       json_object_new_boolean(true), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+			 "JSON object", verbose, out);
+
+	exp_keys = json_object_new_array();
+	JSON_CHECK_ERROR(exp_keys == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object",
+			 verbose, out);
+
+	exp_ref = json_object_new_object();
+	JSON_CHECK_ERROR(exp_ref == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object",
+			 verbose, out);
+
+	rc = json_object_object_add_ex(exp_ref, "rel",
+			json_object_new_string("exportAllowedWithKey"), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+			 "JSON object", verbose, out);
+
+	JSON_CHECK_ERROR(asprintf(&href, "/keys/%s", exporting_key) < 0, rc,
+			 -ENOMEM, "Failed to allocate string", verbose, out);
+	rc = json_object_object_add_ex(exp_ref, "href",
+				       json_object_new_string(href), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+			 "JSON object", verbose, out);
+
+	rc = json_object_array_add(exp_keys, exp_ref);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+			 "JSON object", verbose, out);
+	exp_ref = NULL;
+
+	rc = json_object_object_add_ex(*expctl_obj, "allowedKeys", exp_keys, 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+			 "JSON object", verbose, out);
+	exp_keys = NULL;
+
+out:
+	if (exp_keys != NULL)
+		json_object_put(exp_keys);
+	if (exp_ref != NULL)
+		json_object_put(exp_ref);
+	if (href != NULL)
+		free(href);
+	if (rc != 0 && *expctl_obj != NULL) {
+		json_object_put(*expctl_obj);
+		*expctl_obj = NULL;
+	}
+
+	return rc;
+}
+
+/**
+ * Base64-encodes the data
+ *
+ * @param data              the data to encode
+ * @param data_size         the size of the data in bytes
+ *
+ * @returns the encoded data or NULL in case of an error.
+ * The caller must free the string when no longer needed.
+ */
+static char *_ekmf_base64_encode(const unsigned char *data, size_t data_size)
+{
+	int outlen, len;
+	char *out;
+
+	outlen = (data_size / 3) * 4;
+	if (data_size % 3 > 0)
+		outlen += 4;
+
+	out = calloc(outlen + 1, 1);
+	if (out == NULL)
+		return NULL;
+
+	len = EVP_EncodeBlock((unsigned char *)out, data, data_size);
+	if (len != outlen) {
+		free(out);
+		return NULL;
+	}
+
+	out[outlen] = '\0';
+	return out;
+}
+
+/**
+ * Build the key material JSON object
+ *
+ * @param certificate       the certificate to generate an identity key from
+ * @param certificate_size  the size of the certificate
+ * @param keymat_obj        on return: the key material JSON object
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ */
+static int _ekmf_build_key_material(const unsigned char *certificate,
+				    size_t certificate_size,
+				    json_object **keymat_obj, bool verbose)
+{
+	char *payload = NULL;
+	int rc = 0;
+
+	*keymat_obj = json_object_new_object();
+	JSON_CHECK_ERROR(*keymat_obj == NULL, rc, -ENOMEM,
+				 "Failed to generate JSON object",
+				 verbose, out);
+
+	rc = json_object_object_add_ex(*keymat_obj, "type",
+			json_object_new_string("ENCODED-CERTIFICATE"), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+			 "JSON object", verbose, out);
+
+	payload = _ekmf_base64_encode(certificate, certificate_size);
+	JSON_CHECK_ERROR(*keymat_obj == NULL, rc, -EIO,
+			 "Failed to base64 encode the certificate",
+			 verbose, out);
+
+	rc = json_object_object_add_ex(*keymat_obj, "payload",
+				json_object_new_string(payload), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+			 "JSON object", verbose, out);
+
+out:
+	if (rc != 0 && *keymat_obj != NULL) {
+		json_object_put(*keymat_obj);
+		*keymat_obj = NULL;
+	}
+	if (payload != NULL)
+		free(payload);
+
+	return rc;
+}
+
+/**
+ * Generates a new key in EKMFWeb
+ *
+ * To perform a single request, set curl_handle to NULL. This will cause the
+ * function to initialize a new CURL handle, use it, and destroy it.
+ * If you plan to perform multiple requests to the same host, supply the address
+ * of a CURL pointer that is initially NULL. This function will then initialize
+ * a new CURL handle on the first call. On subsequent calls, pass in the address
+ * of the same CURL pointer so that the CURL handle is reused. After the last
+ * request, the CURL handle must be destroyed by calling ekmf_curl_destroy).
+ *
+ * @param config            the configuration structure
+ * @param curl_handle       address of a CURL handle used for reusing the same
+ *                          CURL handle with multiple requests.
+ * @param template          the name of the template to generate the key with
+ * @param description       Optional: a textual description of the key (can be
+ *                          NULL)
+ * @param label_tags        list of label tags. The label tags are required as
+ *                          defined in the template
+ * @param custom_tags       Optional: list of custom tags (can be NULL)
+ * @param exporting_key     Optional: The uuid of the key that is allowed to
+ *                          export the newly generated key (can be NULL).
+ * @param certificate       Optional: The certificate to generate an identity
+ *                          key from. Should be NULL for generating AES keys.
+ * @param certificate_size  Optional: the size of the certificate. Required if
+ *                          certificate is not NULL.
+ * @param key_info          Optional: On return: If not NULL, a key info struct
+ *                          is returned here containing key information. This
+ *                          must be freed by the caller with ekmf_free_key_info
+ *                          when no longer needed.
+ * @param error_msg         on return: If not NULL, then a textual error message
+ *                          is returned in case of a failing request. The caller
+ *                          must free the error string when it is not NULL.
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ *          -EACCES is returned, if no or no valid login token is available.
+ *          -EPERM is returned if the login token does not have permission to
+ *          generate keys
+ */
+int ekmf_generate_key(const struct ekmf_config *config, CURL **curl_handle,
+		      const char *template, const char *description,
+		      const struct ekmf_tag_list *label_tags,
+		      const struct ekmf_tag_list *custom_tags,
+		      const char *exporting_key,
+		      const unsigned char *certificate, size_t certificate_size,
+		      struct ekmf_key_info **key_info,
+		      char **error_msg, bool verbose)
+{
+	json_object *response_obj = NULL;
+	json_object *request_obj = NULL;
+	json_object *expctl_obj = NULL;
+	json_object *keymat_obj = NULL;
+	json_object *tags_obj = NULL;
+	char *login_token = NULL;
+	bool token_valid = false;
+	CURL *curl = NULL;
+	long status_code;
+	int rc;
+
+	if (config == NULL || template == NULL || label_tags == NULL ||
+	    label_tags->num_tags == 0 || label_tags->tags == NULL)
+		return -EINVAL;
+	if (custom_tags != NULL && custom_tags->num_tags > 0 &&
+	    custom_tags->tags == NULL)
+		return -EINVAL;
+	if (certificate != NULL && certificate_size == 0)
+		return -EINVAL;
+
+	if (key_info != NULL)
+		*key_info = NULL;
+
+	rc = ekmf_check_login_token(config, &token_valid, &login_token,
+				    verbose);
+	if (rc != 0 || !token_valid) {
+		pr_verbose(verbose, "No valid login token available");
+		rc = -EACCES;
+		goto out;
+	}
+
+	rc = _ekmf_get_curl_handle(curl_handle, &curl);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get CURL handle");
+		rc = -EIO;
+		goto out;
+	}
+
+	request_obj = json_object_new_object();
+	JSON_CHECK_ERROR(request_obj == NULL, rc, -ENOMEM,
+			 "Failed to generate JSON object", verbose, out);
+
+	rc = json_object_object_add_ex(request_obj, "templateName",
+				       json_object_new_string(template), 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+
+	rc = build_json_tag_list(label_tags, &tags_obj);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to build label tag JSON object");
+		goto out;
+	}
+
+	rc = json_object_object_add_ex(request_obj, "labelTags", tags_obj, 0);
+	JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to JSON object",
+			 verbose, out);
+	tags_obj = NULL;
+
+	if (description != NULL) {
+		rc = json_object_object_add_ex(request_obj, "description",
+					json_object_new_string(description), 0);
+		JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+				 "JSON object", verbose, out);
+	}
+
+	if (certificate != NULL) {
+		rc = _ekmf_build_key_material(certificate, certificate_size,
+					      &keymat_obj, verbose);
+		if (rc != 0)
+			goto out;
+
+		rc = json_object_object_add_ex(request_obj, "keyMaterial",
+					       keymat_obj, 0);
+		JSON_CHECK_ERROR(rc != 0, rc, -EIO,
+				 "Failed to add data to JSON object",
+				 verbose, out);
+		keymat_obj = NULL;
+	}
+
+	if (custom_tags != NULL && custom_tags->num_tags > 0) {
+		rc = build_json_tag_list(custom_tags, &tags_obj);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to build custom tag JSON "
+				   "object");
+			goto out;
+		}
+
+		rc = json_object_object_add_ex(request_obj, "customTags",
+					       tags_obj, 0);
+		JSON_CHECK_ERROR(rc != 0, rc, -EIO, "Failed to add data to "
+				 "JSON object", verbose, out);
+		tags_obj = NULL;
+	}
+
+	if (exporting_key != NULL) {
+		rc = _ekmf_build_export_control(exporting_key, &expctl_obj,
+						verbose);
+		if (rc != 0)
+			goto out;
+
+		rc = json_object_object_add_ex(request_obj, "exportControl",
+					       expctl_obj, 0);
+		JSON_CHECK_ERROR(rc != 0, rc, -EIO,
+				 "Failed to add data to JSON object",
+				 verbose, out);
+		expctl_obj = NULL;
+	}
+
+	rc = _ekmf_perform_request(config, EKMF_URI_KEYS_GENERATE, "POST",
+				   request_obj, NULL, login_token,
+				   &response_obj, NULL, &status_code, error_msg,
+				   curl, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed perform the REST call");
+		if (rc > 0)
+			rc = -EIO;
+		goto out;
+	}
+
+	switch (status_code) {
+	case 201:
+		break;
+	case 400:
+		pr_verbose(verbose, "Bad request");
+		rc = -EBADMSG;
+		goto out;
+	case 401:
+		pr_verbose(verbose, "Not authorized");
+		rc = -EACCES;
+		goto out;
+	case 403:
+		pr_verbose(verbose, "Insufficient permissions");
+		rc = -EPERM;
+		goto out;
+	case 409:
+		pr_verbose(verbose, "A key with this label exist already");
+		rc = -EEXIST;
+		goto out;
+	default:
+		pr_verbose(verbose, "REST Call failed with HTTP status code: "
+			   "%ld", status_code);
+		rc = -EIO;
+		goto out;
+	}
+
+	JSON_CHECK_OBJ(response_obj, json_type_object, rc, -EBADMSG,
+		       "No or invalid response", verbose, out);
+
+	if (key_info != NULL) {
+		*key_info = calloc(1, sizeof(struct ekmf_key_info));
+		if (*key_info == NULL) {
+			pr_verbose(verbose, "calloc failed");
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = _ekmf_build_key_info(config, curl, login_token,
+					  response_obj, *key_info, true,
+					  error_msg, verbose);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to build the key info");
+			goto out;
+		}
+	}
+
+out:
+	_ekmf_release_curl_handle(curl_handle, curl);
+
+	if (request_obj != NULL)
+		json_object_put(request_obj);
+	if (response_obj != NULL)
+		json_object_put(response_obj);
+	if (login_token != NULL)
+		free(login_token);
+	if (tags_obj != NULL)
+		json_object_put(tags_obj);
+	if (expctl_obj != NULL)
+		json_object_put(expctl_obj);
+	if (keymat_obj != NULL)
+		json_object_put(keymat_obj);
+	if (rc != 0 && key_info != NULL && *key_info != NULL) {
+		free(*key_info);
+		*key_info = NULL;
+	}
+	return rc;
+}
+
+/**
+ * Generate a secure identity key used to identify the client to EKMFWeb.
+ * The secure key blob is stored in a file specified in field
+ * identity_secure_key of the config structure. If an secure key already exists
+ * at that location, it is overwritten.
+ *
+ * @param config            the configuration structure. Only field
+ *                          identity_secure_key must be specified, all others
+ *                          are optional.
+ * @param info              key generation info, such as key type (ECC or RSA)
+ *                          and key parameters.
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ */
+int ekmf_generate_identity_key(const struct ekmf_config *config,
+			       const struct ekmf_key_gen_info *info,
+			       const struct ekmf_ext_lib *ext_lib, bool verbose)
+{
+	unsigned char key_blob[MAX_KEY_BLOB_SIZE];
+	size_t key_blob_size = sizeof(key_blob);
+	int rc;
+
+	if (config == NULL || info == NULL || ext_lib == NULL)
+		return -EINVAL;
+	if (config->identity_secure_key == NULL)
+		return -EINVAL;
+
+	switch (ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		switch (info->type) {
+		case EKMF_KEY_TYPE_ECC:
+			rc = cca_generate_ecc_key_pair(ext_lib->cca,
+					info->params.ecc.curve_nid,
+					key_blob, &key_blob_size, verbose);
+			break;
+		case EKMF_KEY_TYPE_RSA:
+			rc = cca_generate_rsa_key_pair(ext_lib->cca,
+					info->params.rsa.modulus_bits,
+					info->params.rsa.pub_exp,
+					key_blob, &key_blob_size, verbose);
+			break;
+		default:
+			pr_verbose(verbose, "Invalid key type: %d", info->type);
+			return -EINVAL;
+		}
+		break;
+	default:
+		pr_verbose(verbose, "Invalid ext lib type: %d", ext_lib->type);
+		return -EINVAL;
+	}
+
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to generate a key: rc: %d - %s",
+			   rc, strerror(-rc));
+		return rc;
+	}
+
+	rc = write_key_blob(config->identity_secure_key, key_blob,
+			    key_blob_size);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to write the key to file '%s' "
+			   "rc: %d - %s", config->identity_secure_key, rc,
+			   strerror(-rc));
+		return rc;
+	}
+
+	pr_verbose(verbose, "Secure identity key generated (%lu bytes) "
+		   "and written to file '%s'", key_blob_size,
+		   config->identity_secure_key);
+
+	return 0;
+}
+
+/**
+ * Re-encipher the secure identity key (form field identity_secure_key in
+ * config) used to identify the client to EKMFWeb.
+ * The secure key blob is encrypted using the HSM master key. Whenever the HSM
+ * master key is being changed, the secure identity key must be re-enciphered.
+ * You can either pro-actively re-encipher a secure key once the new master key
+ * has been prepared (but not yet made active): to_new = true; or you can
+ * re-encipher a secure key when the HSM master key has already been changed:
+ * to_new = false. This requires that the HSM still has the old master key.
+ * Not all HSMs support this.
+ *
+ * For pro-active re-encipherment it is suggested to store the re-enciphered
+ * secure key on a separate place, until the new HSM master key has been made
+ * active. Specify a file name in reenc_secure_key to do so. For an in-place
+ * re-encipherment, set reenc_secure_key = NULL.
+ *
+ * @param config            the configuration structure. Only field
+ *                          identity_secure_key must be specified, all others
+ *                          are optional.
+ * @param to_new            If true: the identity key is re-enciphered from the
+ *                          current to the new master key.
+ *                          If false: the identity key is re-enciphered from the
+ *                          old to the current master key.
+ * @param reenc_secure_key  if not NULL, then the re-enciphered secure key is
+ *                          stored into the filename specified here. Otherwise
+ *                          the re-enciphered secure key replaces the original
+ *                          secure identity key.
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ * A -ENODEV indicates that the master keys are not loaded.
+ */
+int ekmf_reencipher_identity_key(const struct ekmf_config *config,
+				 bool to_new, const char *reenc_secure_key,
+				 const struct ekmf_ext_lib *ext_lib,
+				 bool verbose)
+{
+	unsigned char key_blob[MAX_KEY_BLOB_SIZE];
+	size_t key_blob_size = sizeof(key_blob);
+	const char *out_file;
+	int rc;
+
+	if (config == NULL || ext_lib == NULL)
+		return -EINVAL;
+	if (config->identity_secure_key == NULL)
+		return -EINVAL;
+
+	rc = read_key_blob(config->identity_secure_key, key_blob,
+			   &key_blob_size);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to read identity key from file "
+			   "'%s': %s", config->identity_secure_key,
+			   strerror(-rc));
+		return rc;
+	}
+
+	switch (ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		rc = cca_reencipher_key(ext_lib->cca, key_blob, key_blob_size,
+					to_new, verbose);
+		break;
+	default:
+		pr_verbose(verbose, "Invalid ext lib type: %d", ext_lib->type);
+		return -EINVAL;
+	}
+
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to re-encipher the secure identity "
+			   "key from file '%s': %s",
+			   config->identity_secure_key, strerror(-rc));
+		return rc;
+	}
+
+	out_file = reenc_secure_key != NULL ? reenc_secure_key :
+						config->identity_secure_key;
+	rc = write_key_blob(out_file, key_blob, key_blob_size);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to write identity key to file "
+			   "'%s': %s", out_file, strerror(-rc));
+		return rc;
+	}
+
+	return 0;
+}
+
+/**
+ * Wrapper for the RSA sign callback to route the call to the selected
+ * secure key library.
+ */
+static int _ekmf_rsa_sign(const unsigned char *key_blob, size_t key_blob_length,
+			  unsigned char *sig, size_t *siglen,
+			  const unsigned char *tbs, size_t tbslen,
+			  int padding_type, int md_nid, void *private)
+{
+	struct private_data *prv = (struct private_data *)private;
+
+	if (prv == NULL || prv->ext_lib == NULL)
+		return 1;
+
+	switch (prv->ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		return cca_rsa_sign(prv->ext_lib->cca, key_blob,
+				    key_blob_length, sig, siglen, tbs, tbslen,
+				    padding_type, md_nid, prv->verbose);
+	default:
+		return 1;
+	}
+}
+
+/**
+ * Wrapper for the RSA-PSS sign callback to route the call to the selected
+ * secure key library.
+ */
+static int _ekmf_rsa_pss_sign(const unsigned char *key_blob,
+			      size_t key_blob_length, unsigned char *sig,
+			      size_t *siglen, const unsigned char *tbs,
+			      size_t tbslen, int md_nid, int mgfmd_nid,
+			      int saltlen, void *private)
+{
+	struct private_data *prv = (struct private_data *)private;
+
+	if (prv == NULL || prv->ext_lib == NULL)
+		return 1;
+
+	switch (prv->ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		return cca_rsa_pss_sign(prv->ext_lib->cca, key_blob,
+					key_blob_length, sig, siglen, tbs,
+					tbslen, md_nid, mgfmd_nid, saltlen,
+					prv->verbose);
+	default:
+		return 1;
+	}
+}
+
+/**
+ * Wrapper for the ECDSA sign callback to route the call to the selected
+ * secure key library.
+ */
+static int _ekmf_ecdsa_sign(const unsigned char *key_blob,
+			    size_t key_blob_length, unsigned char *sig,
+			    size_t *siglen, const unsigned char *tbs,
+			    size_t tbslen, int md_nid, void *private)
+{
+	struct private_data *prv = (struct private_data *)private;
+
+	if (prv == NULL || prv->ext_lib == NULL)
+		return 1;
+
+	switch (prv->ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		return cca_ecdsa_sign(prv->ext_lib->cca, key_blob,
+				      key_blob_length, sig, siglen, tbs, tbslen,
+				      md_nid, prv->verbose);
+	default:
+		return 1;
+	}
+}
+
+/**
+ * Gets the public key from the key blob as a PKEY object.
+ */
+static int _ekmf_get_pub_key_as_pkey(const unsigned char *key_blob,
+				     size_t key_blob_size, EVP_PKEY **pkey,
+				     bool rsa_pss,
+				     const struct ekmf_ext_lib *ext_lib,
+				     bool verbose)
+{
+	int rc, pkey_type;
+
+	switch (ext_lib->type) {
+	case EKMF_EXT_LIB_CCA:
+		rc = cca_get_key_type(key_blob, key_blob_size, &pkey_type);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to get the identity key "
+				   "type: %s", strerror(-rc));
+			return rc;
+		}
+
+		switch (pkey_type) {
+		case EVP_PKEY_EC:
+			rc = cca_get_ecc_pub_key_as_pkey(key_blob,
+					key_blob_size, pkey, verbose);
+			break;
+		case EVP_PKEY_RSA:
+		case EVP_PKEY_RSA_PSS:
+			rc = cca_get_rsa_pub_key_as_pkey(key_blob,
+					key_blob_size, rsa_pss ?
+						EVP_PKEY_RSA_PSS : pkey_type,
+					pkey, verbose);
+			break;
+		default:
+			pr_verbose(verbose, "Invalid identity key type: %d",
+				   pkey_type);
+			return -EIO;
+		}
+
+		if (rc != 0)
+			return rc;
+		break;
+	default:
+		pr_verbose(verbose, "Invalid ext lib type: %d", ext_lib->type);
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+/**
+ * Setup a signing context for the specified key, digest_nid, and RSA-PSS
+ * parameters.
+ */
+static int _ekmf_setup_sign_context(const unsigned char *key_blob,
+				    size_t key_blob_size, EVP_PKEY *pkey,
+				    int digest_nid,
+				    struct ekmf_rsa_pss_params *rsa_pss_params,
+				    EVP_MD_CTX **md_ctx,
+				    EVP_PKEY_CTX **pkey_ctx,
+				    struct private_data *private,
+				    bool verbose)
+{
+	struct sk_pkey_sign_func sign_func;
+	EVP_PKEY_CTX *pctx = NULL;
+	const EVP_MD *md = NULL;
+	int rc, default_nid;
+	EVP_MD_CTX *ctx;
+
+	rc = setup_secure_key_pkey_method(EVP_PKEY_id(pkey));
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to setup secure key PKEY method");
+		return rc;
+	}
+
+	ctx = EVP_MD_CTX_new();
+	if (ctx == NULL) {
+		pr_verbose(verbose, "Failed to allocate the digest context");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	if (digest_nid != 0) {
+		md = EVP_get_digestbynid(digest_nid);
+		if (md == NULL) {
+			pr_verbose(verbose, "Requested digest not supported");
+			rc = -ENOTSUP;
+			goto out;
+		}
+
+		if (EVP_PKEY_get_default_digest_nid(pkey, &default_nid) == 2 &&
+		    default_nid == 0) {
+			pr_verbose(verbose, "The signing algorithm requires "
+				   "there to be no digest");
+			md = NULL;
+		}
+	}
+
+	rc = EVP_DigestSignInit(ctx, &pctx, md, NULL, pkey);
+	if (rc != 1) {
+		pr_verbose(verbose, "Failed to initialize the signing "
+			   "operation");
+		rc = -EIO;
+		goto out;
+	}
+
+	sign_func.rsa_sign = _ekmf_rsa_sign;
+	sign_func.rsa_pss_sign = _ekmf_rsa_pss_sign;
+	sign_func.ecdsa_sign = _ekmf_ecdsa_sign;
+
+	rc = setup_secure_key_pkey_context(pctx, key_blob, key_blob_size,
+					   &sign_func, private);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to setup the secure key PKEY "
+			   "context: %s", strerror(-rc));
+		goto out;
+	}
+
+	if (EVP_PKEY_id(pkey) == EVP_PKEY_RSA_PSS && rsa_pss_params != NULL) {
+		rc = setup_rsa_pss_pkey_context(pctx, rsa_pss_params);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to setup RSA-PSS context");
+			goto out;
+		}
+	}
+
+	*md_ctx = ctx;
+	*pkey_ctx = pctx;
+
+out:
+	if (rc != 0) {
+		cleanup_secure_key_pkey_method(EVP_PKEY_id(pkey));
+		if (ctx != NULL)
+			EVP_MD_CTX_free(ctx);
+	}
+	return rc;
+}
+
+/**
+ * Generate a certificate signing request using the secure identity key (field
+ * identity_secure_key in config structure) with the specified subject name,
+ * certificate extensions (if any), and writes the CSR to the specified file
+ * in PEM format.
+ *
+ * To renew an existing certificate, specify renew_cert = true. In this case
+ * the existing certificate (field sign_certificate in config struct) is read,
+ * and the subject name is extracted from it. Any specified subject name RDNs
+ * are added to the CSR. Also, the extensions are taken from the existing
+ * certificate, and any specified extensions are added to the CSR.
+ *
+ * The CSR is signed using the secure identity key (field identity_secure_key in
+ * config structure) with an signing algorithm matching the identity key (ECDSA,
+ * RSA-PKCS, or RSA-PSS if rsa_pss is true), and the specified digest. If the
+ * digest nid is zero, then a default digest is used.
+ *
+ * @param config            the configuration structure. Only field
+ *                          identity_secure_key must be specified, all others
+ *                          are optional.
+ * @param subject_rdns      an array of strings, each string representing an
+ *                          RDN in the form '[+]type=value'. If the type is
+ *                          prepended with a '+', then this RDN is added to the
+ *                          previous one.
+ * @param num_subject_rdns  number of RDN elements in the array.
+ * @param subject_utf8      if true, RDNs of type MBSTRING_UTF8 are created,
+ *                          otherwise type is MBSTRING_ASC is used.
+ * @param renew_cert_filename if not NULL, specifies the file name of a PEM file
+ *                          containing an existing certificate that is renewed
+ * @param extensions        an array of strings, each string representing an
+ *                          certificate extension in the form 'type=value'.
+ * @param num_extensions    number of extension elements in the array.
+ * @param digest_nid        the OpenSSL digest nid to use with the signature
+ *                          algorithm, or 0 to use the default
+ * @param rsa_pss_params    if not NULL and the identity key is an RSA key, then
+ *                          the CSR is signed with RSA-PSS using the specified
+ *                          PSS parameters. Ignored if the identity key is an EC
+ *                          key
+ * @param csr_pem_filename  the name of the PEM file to which the CSR is written
+ * @param new_hdr           if true, output "NEW" in the PEM header lines
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success:
+ *          -EINVAL: invalid parameter
+ *          -ENOMEM: Failed to allocate memory
+ *          -EBADMSG: an RDN or extension is not formatted correctly
+ *          -EIO: OpenSSL failed to create the CSR
+ *          -EEXIST: if one of the RDN name entries or extensions to add is a
+ *                   duplicate
+ *          -ENOTSUP: the specified digest is not supported
+ *          any other errno from file I/O routines
+ */
+int ekmf_generate_csr(const struct ekmf_config *config,
+		      const char *subject_rdns[], size_t num_subject_rdns,
+		      bool subject_utf8, const char *renew_cert_filename,
+		      const char *extensions[], size_t num_extensions,
+		      int digest_nid,
+		      struct ekmf_rsa_pss_params *rsa_pss_params,
+		      const char *csr_pem_filename, bool new_hdr,
+		      const struct ekmf_ext_lib *ext_lib, bool verbose)
+{
+	const STACK_OF(X509_EXTENSION) *cert_exts = NULL;
+	unsigned char key_blob[MAX_KEY_BLOB_SIZE];
+	size_t key_blob_size = sizeof(key_blob);
+	X509_NAME *subject_name = NULL;
+	EVP_PKEY_CTX *pkey_ctx = NULL;
+	struct private_data private;
+	EVP_MD_CTX *md_ctx = NULL;
+	bool pkey_meth = false;
+	EVP_PKEY *pkey = NULL;
+	X509_REQ *req = NULL;
+	X509 *cert = NULL;
+	int rc;
+
+	if (config == NULL || ext_lib == NULL || csr_pem_filename == NULL)
+		return -EINVAL;
+	if (config->identity_secure_key == NULL)
+		return -EINVAL;
+	if (renew_cert_filename == NULL &&
+	    (subject_rdns == NULL || num_subject_rdns == 0))
+		return -EINVAL;
+	if (num_extensions != 0 && extensions == NULL)
+		return -EINVAL;
+
+	rc = read_key_blob(config->identity_secure_key, key_blob,
+			   &key_blob_size);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to read identity key from file "
+			   "'%s': %s", config->identity_secure_key,
+			   strerror(-rc));
+		goto out;
+	}
+
+	rc = _ekmf_get_pub_key_as_pkey(key_blob, key_blob_size, &pkey,
+				       rsa_pss_params != NULL, ext_lib,
+				       verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get identity key as PKEY from "
+			   "file '%s': %s", config->identity_secure_key,
+			   strerror(-rc));
+		goto out;
+	}
+
+	req = X509_REQ_new();
+	if (req == NULL) {
+		pr_verbose(verbose, "X509_REQ_new failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = X509_REQ_set_version(req, 0L);
+	if (rc != 1) {
+		pr_verbose(verbose, "X509_REQ_set_version failed: rc: %d", rc);
+		rc = -EIO;
+		goto out;
+	}
+
+	if (renew_cert_filename != NULL) {
+		rc = read_x509_certificate(renew_cert_filename, &cert);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to open renew cert file "
+				   "'%s': %s", renew_cert_filename,
+				   strerror(-rc));
+			goto out;
+		}
+
+		subject_name = X509_NAME_dup(X509_get_subject_name(cert));
+		cert_exts = X509_get0_extensions(cert);
+	}
+
+	if (subject_rdns != NULL && num_subject_rdns > 0) {
+		rc = build_subject_name(&subject_name, subject_rdns,
+					num_subject_rdns, subject_utf8);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to parse the subject name "
+				   "RDSn: %s", strerror(-rc));
+			goto out;
+		}
+	}
+
+	if (subject_name == NULL) {
+		rc = -EINVAL;
+		pr_verbose(verbose, "Subject name can not be empty");
+		goto out;
+	}
+
+	rc = X509_REQ_set_subject_name(req, subject_name);
+	if (rc != 1) {
+		rc = -EIO;
+		pr_verbose(verbose, "Failed to set subject name into request");
+		goto out;
+	}
+
+	rc = build_certificate_extensions(NULL, req, extensions,
+					  num_extensions, cert_exts);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to parse the extensions: "
+			   "%s", strerror(-rc));
+		goto out;
+	}
+
+	rc = X509_REQ_set_pubkey(req, pkey);
+	if (rc != 1) {
+		pr_verbose(verbose, "Failed to set the public key");
+		rc = -EIO;
+		goto out;
+	}
+
+	private.ext_lib = ext_lib;
+	private.verbose = verbose;
+
+	rc = _ekmf_setup_sign_context(key_blob, key_blob_size, pkey, digest_nid,
+				      rsa_pss_params, &md_ctx, &pkey_ctx,
+				      &private, verbose);
+	if (rc != 0)
+		goto out;
+	pkey_meth = true;
+
+	rc = X509_REQ_sign_ctx(req, md_ctx);
+	if (rc <= 0) {
+		pr_verbose(verbose, "Failed to perform the signing operation");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = write_x509_request(csr_pem_filename, req, new_hdr);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to write CSR to file "
+			   "'%s': %s", csr_pem_filename, strerror(-rc));
+		goto out;
+	}
+
+	if (verbose) {
+		pr_verbose(verbose, "Certificate Signing Request created:");
+		X509_REQ_print_fp(stderr, req);
+	}
+
+out:
+	if (md_ctx != NULL)
+		EVP_MD_CTX_free(md_ctx);
+	if (pkey_meth)
+		cleanup_secure_key_pkey_method(EVP_PKEY_id(pkey));
+	if (subject_name != NULL)
+		X509_NAME_free(subject_name);
+	if (cert != NULL)
+		X509_free(cert);
+	if (req != NULL)
+		X509_REQ_free(req);
+	if (pkey != NULL)
+		EVP_PKEY_free(pkey);
+
+	return rc;
+}
+
+/**
+ * Generate a self signed certificate using the secure identity key (field
+ * identity_secure_key in config structure) with the specified subject name,
+ * certificate extensions (if any), and writes the certificate the specified
+ * file in PEM format.
+ *
+ * To renew an existing certificate, specify renew_cert = true. In this case
+ * the existing certificate (field sign_certificate in config struct) is read,
+ * and the subject name is extracted from it. Any specified subject name RDNs
+ * are added to the certificate. Also, the extensions are taken from the
+ * existing certificate, and any specified extensions are added to the new
+ * certificate.
+ *
+ * The certificate is signed using the secure identity key (field
+ * identity_secure_key in config structure) with an signing algorithm matching
+ * the identity key (ECDSA, RSA-PKCS, or RSA-PSS if rsa_pss is true), and the
+ * specified digest. If the digest nid is zero, then a default digest is used.
+ *
+ * @param config            the configuration structure. Only field
+ *                          identity_secure_key must be specified, all others
+ *                          are optional.
+ * @param subject_rdns      an array of strings, each string representing an
+ *                          RDN in the form '[+]type=value'. If the type is
+ *                          prepended with a '+', then this RDN is added to the
+ *                          previous one.
+ * @param num_subject_rdns  number of RDN elements in the array.
+ * @param subject_utf8      if true, RDNs of type MBSTRING_UTF8 are created,
+ *                          otherwise type is MBSTRING_ASC is used.
+ * @param renew_cert_filename if not NULL, specifies the file name of a PEM file
+ *                          containing an existing certificate that is renewed
+ * @param extensions        an array of strings, each string representing an
+ *                          certificate extension in the form 'type=value'.
+ * @param num_extensions    number of extension elements in the array.
+ * @param validity_days     number if day from the current date how long the
+ *                          certificate is valid.
+ * @param digest_nid        the OpenSSL digest nid to use with the signature
+ *                          algorithm, or 0 to use the default
+ * @param rsa_pss_params    if not NULL and the identity key is an RSA key, then
+ *                          the certificate is signed with RSA-PSS using the
+ *                          specified PSS parameters. Ignored if the identity
+ *                          key is an EC key
+ * @param cert_pem_filename the name of the PEM file to which the Certificate
+ *                          is written
+ * @param ext_lib           External secure key crypto library to use
+ * @param verbose           if true, verbose messages are printed
+ *
+ * @returns a negative errno in case of an error, 0 if success.
+ *          -EINVAL: invalid parameter
+ *          -ENOMEM: Failed to allocate memory
+ *          -EBADMSG: an RDN or extension is not formatted correctly
+ *          -EIO: OpenSSL failed to create the certificate
+ *          -EEXIST: if one of the RDN name entries or extensions to add is a
+ *                   duplicate
+ *          -ENOTSUP: the specified digest is not supported
+ *          any other errno from file I/O routines
+ */
+int ekmf_generate_ss_cert(const struct ekmf_config *config,
+			  const char *subject_rdns[], size_t num_subject_rdns,
+			  bool subject_utf8, const char *renew_cert_filename,
+			  const char *extensions[], size_t num_extensions,
+			  int validity_days, int digest_nid,
+			  struct ekmf_rsa_pss_params *rsa_pss_params,
+			  const char *cert_pem_filename,
+			  const struct ekmf_ext_lib *ext_lib, bool verbose)
+{
+	const STACK_OF(X509_EXTENSION) *cert_exts = NULL;
+	unsigned char key_blob[MAX_KEY_BLOB_SIZE];
+	size_t key_blob_size = sizeof(key_blob);
+	X509_NAME *subject_name = NULL;
+	EVP_PKEY_CTX *pkey_ctx = NULL;
+	struct private_data private;
+	EVP_MD_CTX *md_ctx = NULL;
+	bool pkey_meth = false;
+	EVP_PKEY *pkey = NULL;
+	X509 *rcert = NULL;
+	X509 *cert = NULL;
+	int rc;
+
+	if (config == NULL || ext_lib == NULL || cert_pem_filename == NULL)
+		return -EINVAL;
+	if (config->identity_secure_key == NULL)
+		return -EINVAL;
+	if (renew_cert_filename == NULL &&
+	    (subject_rdns == NULL || num_subject_rdns == 0))
+		return -EINVAL;
+	if (num_extensions != 0 && extensions == NULL)
+		return -EINVAL;
+
+	rc = read_key_blob(config->identity_secure_key, key_blob,
+			   &key_blob_size);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to read identity key from file "
+			   "'%s': %s", config->identity_secure_key,
+			   strerror(-rc));
+		goto out;
+	}
+
+	rc = _ekmf_get_pub_key_as_pkey(key_blob, key_blob_size, &pkey,
+				       rsa_pss_params != NULL, ext_lib,
+				       verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to get identity key as PKEY from "
+			   "file '%s': %s", config->identity_secure_key,
+			   strerror(-rc));
+		goto out;
+	}
+
+	cert = X509_new();
+	if (cert == NULL) {
+		pr_verbose(verbose, "X509_new failed");
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = X509_set_version(cert, 2L);
+	if (rc != 1) {
+		pr_verbose(verbose, "X509_set_version failed: rc: %d", rc);
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = generate_x509_serial_number(cert, SERIAL_NUMBER_BIT_SIZE);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to set the serial number: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	if (renew_cert_filename != NULL) {
+		rc = read_x509_certificate(renew_cert_filename, &rcert);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to open renew cert file "
+				   "'%s': %s", renew_cert_filename,
+				   strerror(-rc));
+			goto out;
+		}
+
+		subject_name = X509_NAME_dup(X509_get_subject_name(rcert));
+		cert_exts = X509_get0_extensions(rcert);
+	}
+
+	if (subject_rdns != NULL && num_subject_rdns > 0) {
+		rc = build_subject_name(&subject_name, subject_rdns,
+					num_subject_rdns, subject_utf8);
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to parse the subject name "
+				   "RDSn: %s", strerror(-rc));
+			goto out;
+		}
+	}
+
+	if (subject_name == NULL) {
+		rc = -EINVAL;
+		pr_verbose(verbose, "Subject name can not be empty");
+		goto out;
+	}
+
+	rc = X509_set_subject_name(cert, subject_name);
+	if (rc != 1) {
+		rc = -EIO;
+		pr_verbose(verbose, "Failed to set subject name into cert");
+		goto out;
+	}
+
+	rc = X509_set_issuer_name(cert, subject_name);
+	if (rc != 1) {
+		rc = -EIO;
+		pr_verbose(verbose, "Failed to set issuer name into cert");
+		goto out;
+	}
+
+	rc = build_certificate_extensions(cert, NULL, extensions,
+					  num_extensions, cert_exts);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to parse the extensions: "
+			   "%s", strerror(-rc));
+		goto out;
+	}
+
+	if (X509_gmtime_adj(X509_getm_notBefore(cert), 0) == NULL) {
+		rc = -EIO;
+		pr_verbose(verbose, "Failed to set notBefore time inti cert");
+		goto out;
+	}
+
+	if (X509_time_adj_ex(X509_getm_notAfter(cert),
+			     validity_days, 0, NULL) == NULL) {
+		rc = -EIO;
+		pr_verbose(verbose, "Failed to set notAfter time into cert");
+		goto out;
+	}
+
+	rc = X509_set_pubkey(cert, pkey);
+	if (rc != 1) {
+		pr_verbose(verbose, "Failed to set the public key");
+		rc = -EIO;
+		goto out;
+	}
+
+	private.ext_lib = ext_lib;
+	private.verbose = verbose;
+
+	rc = _ekmf_setup_sign_context(key_blob, key_blob_size, pkey, digest_nid,
+				      rsa_pss_params, &md_ctx, &pkey_ctx,
+				      &private, verbose);
+	if (rc != 0)
+		goto out;
+	pkey_meth = true;
+
+	rc = X509_sign_ctx(cert, md_ctx);
+	if (rc <= 0) {
+		pr_verbose(verbose, "Failed to perform the signing operation");
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = write_x509_certificate(cert_pem_filename, cert);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to write Certificate to file "
+			   "'%s': %s", cert_pem_filename, strerror(-rc));
+		goto out;
+	}
+
+	if (verbose) {
+		pr_verbose(verbose, "Self-signed Certificate created:");
+		X509_print_fp(stderr, cert);
+	}
+
+out:
+	if (md_ctx != NULL)
+		EVP_MD_CTX_free(md_ctx);
+	if (pkey_meth)
+		cleanup_secure_key_pkey_method(EVP_PKEY_id(pkey));
+	if (subject_name != NULL)
+		X509_NAME_free(subject_name);
+	if (cert != NULL)
+		X509_free(cert);
+	if (rcert != NULL)
+		X509_free(rcert);
+	if (pkey != NULL)
+		EVP_PKEY_free(pkey);
+
+	return rc;
+}
+
+/**
+ * Close the connection to the EKMFWeb server by destroying the CURL handle.
+ *
+ * @param curl_handle       the CURL handle to destroy
+ */
+void ekmf_curl_destroy(CURL *curl_handle)
+{
+	if (curl_handle == NULL)
+		return;
+
+	curl_easy_cleanup(curl_handle);
+}
+
+/**
+ * Library constructor
+ */
+void __attribute__ ((constructor)) ekmf_init(void)
+{
+	curl_global_init(CURL_GLOBAL_ALL);
+}
+
+/**
+ * Library destructor
+ */
+void __attribute__ ((destructor)) ekmf_exit(void)
+{
+	curl_global_cleanup();
+}
+
+
diff -pruN 2.14.0-2/libekmfweb/libekmfweb.map 2.15.1-0ubuntu2/libekmfweb/libekmfweb.map
--- 2.14.0-2/libekmfweb/libekmfweb.map	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/libekmfweb/libekmfweb.map	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,30 @@
+LIBEKMFWEB_1.0 {
+    global:
+        ekmf_get_server_cert_chain;
+        ekmf_print_certificates;
+        ekmf_check_login_token;
+        ekmf_login;
+        ekmf_generate_identity_key;
+        ekmf_reencipher_identity_key;
+        ekmf_generate_csr;
+        ekmf_generate_ss_cert;
+        ekmf_get_public_key;
+        ekmf_get_settings;
+        ekmf_check_feature;
+        ekmf_retrieve_key;
+        ekmf_list_templates;
+        ekmf_get_template;
+        ekmf_get_last_seq_no;
+        ekmf_clone_template_info;
+        ekmf_free_template_info;
+        ekmf_list_keys;
+        ekmf_get_key_info;
+        ekmf_set_key_state;
+        ekmf_set_key_tags;
+        ekmf_delete_key_tags;
+        ekmf_clone_key_info;
+        ekmf_free_key_info;
+        ekmf_generate_key;
+        ekmf_curl_destroy;
+    local: *;
+};
diff -pruN 2.14.0-2/libekmfweb/Makefile 2.15.1-0ubuntu2/libekmfweb/Makefile
--- 2.14.0-2/libekmfweb/Makefile	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/libekmfweb/Makefile	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,92 @@
+include ../common.mak
+
+VERSION = 1.0
+VERM = $(shell echo $(VERSION) | cut -d '.' -f 1)
+
+ifneq (${HAVE_OPENSSL},0)
+	ifneq (${HAVE_JSONC},0)
+		ifneq (${HAVE_LIBCURL},0)
+			BUILD_TARGETS += libekmfweb.so.$(VERSION)
+			INSTALL_TARGETS += install-libekmfweb.so.$(VERSION)
+		else
+			BUILD_TARGETS += skip-libekmfweb-curl
+			INSTALL_TARGETS += skip-libekmfweb-curl
+		endif
+	else
+		BUILD_TARGETS += skip-libekmfweb-jsonc
+		INSTALL_TARGETS += skip-libekmfweb-jsonc
+	endif
+else
+	BUILD_TARGETS += skip-libekmfweb-openssl
+	INSTALL_TARGETS += skip-libekmfweb-openssl
+endif
+
+libs = $(rootdir)/libutil/libutil.a
+
+detect-openssl-version.dep:
+	echo "#include <openssl/opensslv.h>" > detect-openssl-version.dep
+	echo "#include <openssl/evp.h>" >> detect-openssl-version.dep
+	echo "#if OPENSSL_VERSION_NUMBER < 0x10101000L" >> detect-openssl-version.dep
+	echo "  #error openssl version 1.1.1 is required" >> detect-openssl-version.dep
+	echo "#endif" >> detect-openssl-version.dep
+	echo "static void __attribute__((unused)) test(void) {" >> detect-openssl-version.dep
+	echo "    EVP_PKEY_meth_remove(NULL);" >> detect-openssl-version.dep
+	echo "}" >> detect-openssl-version.dep
+
+check-dep-libekmfweb: detect-openssl-version.dep
+	$(call check_dep, \
+		"libekmfweb", \
+		"detect-openssl-version.dep", \
+		"openssl-devel version >= 1.1.1", \
+		"HAVE_OPENSSL=0", \
+		-I. -lcrypto)
+	$(call check_dep, \
+		"libekmfweb", \
+		"json-c/json.h", \
+		"json-c-devel", \
+		"HAVE_JSONC=0")
+	$(call check_dep, \
+		"libekmfweb", \
+		"curl/curl.h", \
+		"libcurl-devel", \
+		"HAVE_LIBCURL=0")
+	touch check-dep-libekmfweb
+
+skip-libekmfweb-openssl:
+	echo "  SKIP    libekmfweb due to HAVE_OPENSSL=0"
+
+skip-libekmfweb-jsonc:
+	echo "  SKIP    libekmfweb due to HAVE_JSONC=0"
+
+skip-libekmfweb-curl:
+	echo "  SKIP    libekmfweb due to HAVE_LIBCURL=0"
+
+all: $(BUILD_TARGETS)
+
+ekmfweb.o: check-dep-libekmfweb ekmfweb.c utilities.h cca.h $(rootdir)include/ekmfweb/ekmfweb.h
+utilities.o: check-dep-libekmfweb utilities.c utilities.h $(rootdir)include/ekmfweb/ekmfweb.h
+cca.o: check-dep-libekmfweb cca.c cca.h utilities.h $(rootdir)include/ekmfweb/ekmfweb.h
+
+libekmfweb.so.$(VERSION): ALL_CFLAGS += -fPIC
+libekmfweb.so.$(VERSION): LDLIBS = -ljson-c -lcrypto -lssl -lcurl -ldl
+libekmfweb.so.$(VERSION): ALL_LDFLAGS += -shared -Wl,--version-script=libekmfweb.map \
+	-Wl,-z,defs,-Bsymbolic -Wl,-soname,libekmfweb.so.$(VERM)
+libekmfweb.so.$(VERSION): ekmfweb.o utilities.o cca.o
+	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
+	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so.$(VERM)
+	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so
+
+install-libekmfweb.so.$(VERSION): libekmfweb.so.$(VERSION)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION)
+	ln -srf $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERM)
+	ln -srf $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so
+	$(INSTALL) -d -m 770 $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $(rootdir)include/ekmfweb/ekmfweb.h $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb
+
+install: all $(INSTALL_TARGETS)
+
+clean:
+	rm -f *.o libekmfweb.so* check-dep-libekmfweb detect-openssl-version.dep
+
+.PHONY: all install clean skip-libekmfweb-openssl skip-libekmfweb-jsonc \
+	skip-libekmfweb-curl install-libekmfweb.so.$(VERSION)
diff -pruN 2.14.0-2/libekmfweb/utilities.c 2.15.1-0ubuntu2/libekmfweb/utilities.c
--- 2.14.0-2/libekmfweb/utilities.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/libekmfweb/utilities.c	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,3528 @@
+/*
+ * libekmfweb - EKMFWeb client library
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <stdbool.h>
+#include <sys/stat.h>
+#include <sys/time.h>
+
+#include <openssl/evp.h>
+#include <openssl/pem.h>
+#include <openssl/sha.h>
+#include <openssl/bn.h>
+#include <openssl/ec.h>
+#include <openssl/rsa.h>
+#include <openssl/x509v3.h>
+
+#include "lib/zt_common.h"
+
+#include "utilities.h"
+
+#ifndef JSON_C_TO_STRING_NOSLASHESCAPE
+#define JSON_C_TO_STRING_NOSLASHESCAPE (1 << 4)
+#endif
+
+/**
+ * Decodes a Base64URL encoded string. Base64URL is like Base64, but using a
+ * URL and Filename Safe Alphabet, not using characters like '+', '/', or '='.
+ *
+ * The function converts the Base64URL input into standard Base64 data and then
+ * decodes it using OpenSSL EVP_DecodeBlock.
+ *
+ * @param output            a buffer to store the output. If NULL, then the
+ *                          required size in bytes is returned in outlen and
+ *                          no decoding is performed.
+ * @param outlen            on entry: Size of the output buffer in bytes.
+ *                          on exit: Size of the decoded data in bytes.
+ * @param input             the Base64URL encoded data to decode
+ * @param inlen             the size of the input data in bytes
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: a function parameter is invalid
+ *          -ERANGE: the output buffer size is too small. outlen contains the
+ *                   required size on return.
+ *          -ENOMEM: failed to allocate memory
+ *          -EIO: OpenSSL failed to decode the data
+ */
+int decode_base64url(unsigned char *output, size_t *outlen,
+		     const char *input, size_t inlen)
+{
+	size_t raw_outlen, padded_outlen, padded_inlen;
+	char *padded_input = NULL;
+	char *padded_output;
+	int len, rc = 0;
+	size_t i;
+
+	if (input == NULL || outlen == NULL)
+		return -EINVAL;
+
+	/* Base64URL might optionally include padding chars ('='), remove it */
+	for (; inlen > 0 && input[inlen - 1] == '='; inlen--)
+		;
+
+	/* Might need to pad with standard base64 padding character '=' */
+	padded_inlen = inlen;
+	if ((inlen % 4) > 0)
+		padded_inlen += 4 - (inlen % 4);
+
+	/* Also the output will be padded while decoding */
+	padded_outlen = (padded_inlen / 4) * 3;
+	raw_outlen = (inlen / 4) * 3 + ((inlen % 4) >= 2 ? (inlen % 4) - 1 : 0);
+
+	if (output == NULL) /* size query */
+		goto out;
+	if (*outlen < raw_outlen) {
+		rc = -ERANGE;
+		goto out;
+	}
+
+	padded_input = (char *)malloc(padded_inlen + padded_outlen);
+	if (padded_input == NULL)
+		return -ENOMEM;
+	padded_output = padded_input + padded_inlen;
+
+	memcpy(padded_input, input, inlen);
+	memset(padded_input + inlen, '=', padded_inlen - inlen);
+
+	/* Replace '-' by '+', and '_' by '/' */
+	for (i = 0; i < inlen; i++) {
+		if (padded_input[i] == '-')
+			padded_input[i] = '+';
+		else if (padded_input[i] == '_')
+			padded_input[i] = '/';
+	}
+
+	len = EVP_DecodeBlock((unsigned char *)padded_output,
+			      (unsigned char *)padded_input, padded_inlen);
+	if (len != (int)padded_inlen * 3 / 4) {
+		rc = -EIO;
+		goto out;
+	}
+
+	memcpy(output, padded_output, raw_outlen);
+
+out:
+	*outlen = raw_outlen;
+
+	if (padded_input != NULL)
+		free(padded_input);
+
+	return rc;
+}
+
+/**
+ * Encodes a data using Base64URL. Base64URL is like Base64, but using a
+ * URL and Filename Safe Alphabet, not using characters like '+', '/', or '='.
+ *
+ * The function encodes the data into standard Base64 data using OpenSSL
+ * EVP_EncodeBlock and then converts it into Base64URL data
+ *
+ * @param output            a buffer to store the output. If NULL, then the
+ *                          required size in bytes is returned in outlen and
+ *                          no encoding is performed.
+ *                          The NUL character is added to the output at the end
+ *                          of the encoded data.
+ * @param outlen            on entry: Size of the output buffer in bytes.
+ *                          on exit: Size of the encoded data in bytes,
+ *                                   including the NUL character.
+ * @param input             the data to Base64URL-encode
+ * @param inlen             the size of the input data in bytes
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: a function parameter is invalid
+ *          -ERANGE: the output buffer size is too small. outlen contains the
+ *                   required size on return.
+ *          -ENOMEM: failed to allocate memory
+ *          -EIO: OpenSSL failed to decode the data
+ */
+int encode_base64url(char *output, size_t *outlen,
+		     const unsigned char *input, size_t inlen)
+{
+	size_t padded_outlen, raw_outlen, ofs = 0;
+	char *padded_output = NULL;
+	int len, rc = 0;
+
+	if (input == NULL || outlen == NULL)
+		return -EINVAL;
+
+	padded_outlen = (inlen / 3) * 4;
+	if (inlen % 3 > 0)
+		padded_outlen += 4;
+
+	raw_outlen = (inlen / 3) * 4 + ((inlen % 3) > 0 ? (inlen % 3) + 1 : 0);
+
+	if (output == NULL)
+		goto out;
+
+	if (*outlen < raw_outlen + 1) {
+		rc = -ERANGE;
+		goto out;
+	}
+
+	padded_output = (char *)malloc(padded_outlen + 1);
+	if (padded_output == NULL)
+		return -ENOMEM;
+
+	len = EVP_EncodeBlock((unsigned char *)padded_output,
+			      (unsigned char *)input, inlen);
+	if (len != (int)padded_outlen) {
+		rc = -EIO;
+		goto out;
+	}
+
+	/* Replace '+' by '-', and '/' by '_', and stop at first '=' */
+	for (ofs = 0; ofs < padded_outlen; ofs++) {
+		if (padded_output[ofs] == '+')
+			padded_output[ofs] = '-';
+		else if (padded_output[ofs] == '/')
+			padded_output[ofs] = '_';
+		else if (padded_output[ofs] == '=')
+			break;
+	}
+	if (ofs != raw_outlen) {
+		rc = -EIO;
+		goto out;
+	}
+
+	memcpy(output, padded_output, raw_outlen);
+	output[raw_outlen] = '\0';
+
+out:
+	*outlen = raw_outlen + 1;
+
+	if (padded_output != NULL)
+		free(padded_output);
+
+	return rc;
+}
+
+/**
+ * Parses a JSON Web Token (JWT) and extracts the header and payload parts as
+ * parsed JSON object. The returned JSON objects must be freed by the caller
+ * using json_object_put() when no longer needed. The returned signature must
+ * also be freed by the caller when no longer needed.
+ *
+ * @param token             the JSON Web Tolken to parse
+ * @param header_obj        if not NULL, the parsed JWT header as JSON Object
+ * @param payload_obj       if not NULL, the parsed JWT payload as JSON Object
+ * @param signature         if not NULL, a pointer to the decoded signature
+ * @param signature_len     if not NULL, the size of the signature in bytes
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: a function parameter is invalid
+ *          -EBADMSG: If the token could not be parsed into parts
+ *          -ENOMEM: failed to allocate memory
+ *          -EIO: Base64 parsing error
+ */
+int parse_json_web_token(const char *token, json_object **header_obj,
+			 json_object **payload_obj, unsigned char **signature,
+			 size_t *signature_len)
+{
+	json_object *hdr = NULL, *pld = NULL, *b64_obj = NULL;
+	char *ch, *header, *payload, *json = NULL;
+	size_t header_len, payload_len, json_len;
+	bool b64 = true;
+	int rc = 0;
+
+	if (token == NULL)
+		return -EINVAL;
+
+	if (header_obj != NULL)
+		*header_obj = NULL;
+	if (payload_obj != NULL)
+		*payload_obj = NULL;
+	if (signature != NULL)
+		*signature = NULL;
+	if (signature_len != NULL)
+		*signature_len = 0;
+
+	/*
+	 * A JSON Web Token consists of several parts, each part Base64URL
+	 * encoded, and separated by a colon '.' from each other.
+	 * The first part is the JOSE (JSON Object Signing and Encryption)
+	 * Header. The second part is the JWS Payload containing the JWS claims,
+	 * and the following parts (if any) are used for JWS Signature, or JWE
+	 * Encryption (not considered here).
+	 */
+	header = (char *)token;
+
+	ch = strchr(token, '.');
+	if (ch == NULL) {
+		rc = -EBADMSG;
+		goto out;
+	}
+	header_len = ch - token;
+
+	payload = ++ch;
+
+	ch = strchr(ch, '.');
+	if (ch == NULL) {
+		rc = -EBADMSG;
+		goto out;
+	}
+
+	payload_len = ch - payload;
+	ch++;
+
+	rc = decode_base64url(NULL, &json_len, header, header_len);
+	if (rc != 0)
+		goto out;
+
+	json = malloc(json_len + 1);
+	if (json == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = decode_base64url((unsigned char *)json, &json_len,
+			      header, header_len);
+	if (rc != 0)
+		goto out;
+
+	json[json_len] = '\0';
+
+	hdr = json_tokener_parse(json);
+	if (hdr == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	if (json_object_object_get_ex(hdr, "b64", &b64_obj) &&
+	    json_object_is_type(b64_obj, json_type_boolean))
+		b64 = json_object_get_boolean(b64_obj);
+
+	free(json);
+	json = NULL;
+
+	if (payload_obj != NULL) {
+		if (b64) {
+			rc = decode_base64url(NULL, &json_len, payload,
+					      payload_len);
+			if (rc != 0)
+				goto out;
+
+			json = malloc(json_len + 1);
+			if (json == NULL) {
+				rc = -ENOMEM;
+				goto out;
+			}
+
+			rc = decode_base64url((unsigned char *)json, &json_len,
+					      payload, payload_len);
+			if (rc != 0)
+				goto out;
+
+			json[json_len] = '\0';
+		} else {
+			json = strndup(payload, payload_len);
+		}
+
+		pld = json_tokener_parse(json);
+		if (pld == NULL) {
+			rc = -EIO;
+			goto out;
+		}
+
+		free(json);
+		json = NULL;
+	}
+
+	if (signature != NULL && signature_len != NULL) {
+		rc = decode_base64url(NULL, signature_len, ch, strlen(ch));
+		if (rc != 0)
+			goto out;
+
+		*signature = malloc(*signature_len);
+		if (*signature == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = decode_base64url(*signature, signature_len, ch,
+				      strlen(ch));
+		if (rc != 0)
+			goto out;
+	}
+
+out:
+	if (header_obj != NULL && rc == 0)
+		*header_obj = hdr;
+	else
+		json_object_put(hdr);
+	if (payload_obj != NULL && rc == 0)
+		*payload_obj = pld;
+	else
+		json_object_put(pld);
+	if (signature != NULL && rc != 0) {
+		free(signature);
+		signature = NULL;
+		*signature_len = 0;
+	}
+	if (json != NULL)
+		free(json);
+
+	return rc;
+}
+
+/**
+ * Creates a JSON Web Signature object with the specified parts and returns a
+ * a character string containing the serialized JWS (see RFC 7515 for details)
+ *
+ * @param algorithm         the JWS algorithm (e.g. ES512) (in the JWS header)
+ * @param b64               the b64 property of the JWS header. If b64 is true,
+ *                          then the payload (if any) is base64url encoded,
+ *                          if false, the payload (if any) is used as-is.
+ * @param kid               the Key ID JWS header field (can be NULL)
+ * @param payload           the JWS payload.
+ * @param payload_len       the length of the payload in bytes
+ * @param detached_payload  if true a JWS with detached payload is created (see
+ *                          RFC 7515 Appendix F)
+ * @param md_ctx            An OpenSSL MD that has been set up with the desired
+ *                          digest and signing algorithm, options, and key
+ * @param jws               On return: a C-string allocated by this function
+ *                          containing the serialized JWS. The caller must
+ *                          free the memory used by the returned string.
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int create_json_web_signature(const char *algorithm, bool b64, const char *kid,
+			      const unsigned char *payload, size_t payload_len,
+			      bool detached_payload, EVP_MD_CTX *md_ctx,
+			      char **jws)
+{
+	unsigned char *signature = NULL;
+	json_object *header_obj = NULL;
+	json_object *crit_obj = NULL;
+	size_t signature_b64_len = 0;
+	size_t payload_b64_len = 0;
+	char *signature_b64 = NULL;
+	size_t header_b64_len = 0;
+	size_t signature_len = 0;
+	char *payload_b64 = NULL;
+	ECDSA_SIG *ec_sig = NULL;
+	char *header_b64 = NULL;
+	const unsigned char *p;
+	const char *header;
+	size_t prime_len;
+	EVP_PKEY *pkey;
+	int rc;
+
+	if (algorithm == NULL || payload == NULL || md_ctx == NULL ||
+	    jws == NULL)
+		return -EINVAL;
+
+	pkey = EVP_PKEY_CTX_get0_pkey(EVP_MD_CTX_pkey_ctx(md_ctx));
+	if (pkey == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	header_obj = json_object_new_object();
+	if (header_obj == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	/*
+	 * Note: The order of the fields is important, EKMFWeb expects it in
+	 * exactly this order!
+	 */
+	rc = json_object_object_add_ex(header_obj, "alg",
+				       json_object_new_string(algorithm), 0);
+	if (kid != NULL)
+		rc |= json_object_object_add_ex(header_obj, "kid",
+						json_object_new_string(kid), 0);
+	rc |= json_object_object_add_ex(header_obj, "b64",
+					json_object_new_boolean(b64), 0);
+	crit_obj = json_object_new_array();
+	rc |= (crit_obj == NULL ? -1 : 0);
+	rc |= json_object_array_add(crit_obj, json_object_new_string("b64"));
+	rc |= json_object_object_add_ex(header_obj, "crit", crit_obj, 0);
+	crit_obj = NULL;
+	if (rc != 0) {
+		rc = -EIO;
+		goto out;
+	}
+
+	header = json_object_to_json_string_ext(header_obj,
+						JSON_C_TO_STRING_PLAIN |
+						JSON_C_TO_STRING_NOSLASHESCAPE);
+	if (header == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = encode_base64url(NULL, &header_b64_len, (unsigned char *)header,
+			      strlen(header));
+	if (rc != 0)
+		goto out;
+
+	header_b64 = malloc(header_b64_len);
+	if (header_b64 == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = encode_base64url(header_b64, &header_b64_len,
+			      (unsigned char *)header, strlen(header));
+	if (rc != 0)
+		goto out;
+
+	if (b64) {
+		rc = encode_base64url(NULL, &payload_b64_len, payload,
+				      payload_len);
+		if (rc != 0)
+			goto out;
+
+		payload_b64 = malloc(payload_b64_len);
+		if (payload_b64 == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = encode_base64url(payload_b64, &payload_b64_len, payload,
+				      payload_len);
+		if (rc != 0)
+			goto out;
+	}
+
+	/* Sign: BASE64URL(UTF8(JWSHeader)) | '.' | [BASE64URL](JWS Payload) */
+	rc = EVP_DigestSignUpdate(md_ctx, header_b64, strlen(header_b64));
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = EVP_DigestSignUpdate(md_ctx, ".", 1);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	if (b64)
+		rc = EVP_DigestSignUpdate(md_ctx, payload_b64,
+					  strlen(payload_b64));
+	else
+		rc = EVP_DigestSignUpdate(md_ctx, payload, payload_len);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	signature_len = EVP_PKEY_size(pkey);
+	signature = malloc(signature_len);
+	if (signature == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = EVP_DigestSignFinal(md_ctx, signature, &signature_len);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	switch (EVP_PKEY_id(pkey)) {
+	case EVP_PKEY_EC:
+		prime_len = ecc_get_curve_prime_length(EC_GROUP_get_curve_name(
+				EC_KEY_get0_group(EVP_PKEY_get0_EC_KEY(pkey))));
+
+		p = signature;
+		if (d2i_ECDSA_SIG(&ec_sig, &p, signature_len) == NULL) {
+			rc = -EIO;
+			goto out;
+		}
+
+		if (signature_len < 2 * prime_len) {
+			rc = -EINVAL;
+			goto out;
+		}
+
+		memset(signature, 0, signature_len);
+		BN_bn2binpad(ECDSA_SIG_get0_r(ec_sig), signature, prime_len);
+		BN_bn2binpad(ECDSA_SIG_get0_s(ec_sig), signature + prime_len,
+			     prime_len);
+		signature_len = 2 * prime_len;
+		break;
+
+	case EVP_PKEY_RSA:
+	case EVP_PKEY_RSA_PSS:
+		/* No signature encoding for RSA */
+		break;
+
+	default:
+		rc = -EINVAL;
+		goto out;
+	}
+
+	rc = encode_base64url(NULL, &signature_b64_len, signature,
+			      signature_len);
+	if (rc != 0)
+		goto out;
+
+	signature_b64 = malloc(signature_b64_len);
+	if (signature_b64 == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = encode_base64url(signature_b64, &signature_b64_len, signature,
+			      signature_len);
+	if (rc != 0)
+		goto out;
+
+	if (detached_payload) {
+		if (asprintf(jws, "%s..%s", header_b64, signature_b64) < 0) {
+			rc = -ENOMEM;
+			goto out;
+		}
+	} else if (b64) {
+		if (asprintf(jws, "%s.%s.%s", header_b64, payload_b64,
+			     signature_b64) < 0) {
+			rc = -ENOMEM;
+			goto out;
+		}
+	} else {
+		if (asprintf(jws, "%s.%.*s.%s", header_b64, (int)payload_len,
+			     payload, signature_b64) < 0) {
+			rc = -ENOMEM;
+			goto out;
+		}
+	}
+
+	rc = 0;
+
+out:
+	if (header_obj != NULL)
+		json_object_put(header_obj);
+	if (header_b64 != NULL)
+		free(header_b64);
+	if (payload_b64 != NULL)
+		free(payload_b64);
+	if (signature != NULL)
+		free(signature);
+	if (signature_b64 != NULL)
+		free(signature_b64);
+	if (ec_sig != NULL)
+		ECDSA_SIG_free(ec_sig);
+
+	return rc;
+}
+
+/**
+ * Verifies a JSON Web Signature object (see RFC 7515 for details).
+ *
+ * @param jws               the JWS string
+ * @param payload           if not NULL: the detached JWS payload.
+ * @param payload_len       the length of the detached payload in bytes
+ * @param md_ctx            An OpenSSL MD that has been set up with the desired
+ *                          digest and signing algorithm, options, and key
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int verify_json_web_signature(const char *jws, const unsigned char *payload,
+			      size_t payload_len, EVP_PKEY *pkey)
+{
+	size_t header_len, hdr_pld_len, payload_b64_len, signature_len = 0;
+	unsigned char *signature = NULL, *der = NULL, *sig = NULL;
+	json_object *header_obj = NULL, *b64_obj = NULL;
+	int der_len, rc, curve_nid = 0, digest_nid = 0;
+	struct ekmf_rsa_pss_params rsa_pss_params;
+	bool b64 = true, rsa_pss = false;
+	EVP_MD_CTX *md_ctx = NULL;
+	EVP_PKEY_CTX *pctx = NULL;
+	ECDSA_SIG *ec_sig = NULL;
+	char *payload_b64 = NULL;
+	const EVP_MD *md = NULL;
+	BIGNUM *bn_r = NULL;
+	BIGNUM *bn_s = NULL;
+	const char *alg;
+	size_t sig_len;
+	char *ch;
+
+	if (jws == NULL || pkey == NULL)
+		return -EINVAL;
+
+	rc = parse_json_web_token(jws, &header_obj, NULL, &signature,
+				  &signature_len);
+	if (rc != 0)
+		goto out;
+
+	ch = strchr(jws, '.');
+	if (ch == NULL) {
+		rc = -EBADMSG;
+		goto out;
+	}
+	header_len = ch - jws;
+
+	ch = strchr(++ch, '.');
+	if (ch == NULL) {
+		rc = -EBADMSG;
+		goto out;
+	}
+	hdr_pld_len = ch - jws;
+
+	if (EVP_PKEY_id(pkey) == EVP_PKEY_EC) {
+		curve_nid = EC_GROUP_get_curve_name(EC_KEY_get0_group(
+						EVP_PKEY_get0_EC_KEY(pkey)));
+	}
+
+	alg = json_get_string(header_obj, "alg");
+	if (alg == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	/*
+	 * Only the following combinations are allowed per RFC7518 for JSON
+	 * Web Signatures (JWS) using ECC or RSA signing keys:
+	 *   alg=ES256: ECDSA using P-256 and SHA-256
+	 *   alg=ES384: ECDSA using P-384 and SHA-384
+	 *   alg=ES512: ECDSA using P-521 and SHA-512
+	 *   alg=RS256: RSA-PKCS1 using SHA-256
+	 *   alg=RS384: RSA-PKCS1 using SHA-384
+	 *   alg=RS512: RSA-PKCS1 using SHA-512
+	 *   alg=PS256: RSA-PSS using SHA-256, MGF1 with SHA-256, salt=digest
+	 *   alg=PS384: RSA-PSS using SHA-384, MGF1 with SHA-384, salt=digest
+	 *   alg=PS512: RSA-PSS using SHA-512, MGF1 with SHA-512, salt=digest
+	 */
+	if (strncmp(alg, "ES", 2) == 0) {
+		if (EVP_PKEY_id(pkey) != EVP_PKEY_EC) {
+			rc = EINVAL;
+			goto out;
+		}
+		if ((strncmp(alg + 2, "512", 3) == 0 &&
+					curve_nid != NID_secp521r1) ||
+		    (strncmp(alg + 2, "384", 3) == 0 &&
+					curve_nid != NID_secp384r1) ||
+		    (strncmp(alg + 2, "256", 3) == 0 &&
+					curve_nid != NID_X9_62_prime256v1)) {
+			rc = EINVAL;
+			goto out;
+		}
+	} else if (strncmp(alg, "RS", 2) == 0) {
+		if (EVP_PKEY_id(pkey) != EVP_PKEY_RSA) {
+			rc = EINVAL;
+			goto out;
+		}
+	} else if (strncmp(alg, "PS", 2) == 0) {
+		if (EVP_PKEY_id(pkey) != EVP_PKEY_RSA &&
+		    EVP_PKEY_id(pkey) != EVP_PKEY_RSA_PSS) {
+			rc = EINVAL;
+			goto out;
+		}
+		rsa_pss = true;
+	} else {
+		rc = -ENOTSUP;
+		goto out;
+	}
+
+	if (strncmp(alg + 2, "512", 3) == 0)
+		digest_nid = NID_sha512;
+	else if (strncmp(alg + 2, "384", 3) == 0)
+		digest_nid = NID_sha384;
+	else if (strncmp(alg + 2, "256", 3) == 0)
+		digest_nid = NID_sha256;
+	if (digest_nid == 0) {
+		rc = -ENOTSUP;
+		goto out;
+	}
+
+	md = EVP_get_digestbynid(digest_nid);
+	if (md == NULL) {
+		rc = -ENOTSUP;
+		goto out;
+	}
+
+	md_ctx = EVP_MD_CTX_new();
+	if (md_ctx == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = EVP_DigestVerifyInit(md_ctx, &pctx, md, NULL, pkey);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	if (rsa_pss) {
+		rsa_pss_params.mgf_digest_nid = digest_nid;
+		rsa_pss_params.salt_len = RSA_PSS_SALTLEN_DIGEST;
+		rc = setup_rsa_pss_pkey_context(pctx, &rsa_pss_params);
+		if (rc != 0)
+			goto out;
+	}
+
+	switch (EVP_PKEY_id(pkey)) {
+	case EVP_PKEY_EC:
+		ec_sig = ECDSA_SIG_new();
+		if (ec_sig == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		bn_r = BN_bin2bn(signature, signature_len / 2, NULL);
+		bn_s = BN_bin2bn(signature + signature_len / 2,
+				 signature_len / 2, NULL);
+		if (bn_r == NULL || bn_s == NULL) {
+			rc = -EIO;
+			goto out;
+		}
+
+		if (ECDSA_SIG_set0(ec_sig, bn_r, bn_s) != 1) {
+			rc = -EIO;
+			goto out;
+		}
+		bn_r = NULL;
+		bn_s = NULL;
+
+		der_len = i2d_ECDSA_SIG(ec_sig, &der);
+		if (der_len <= 0) {
+			rc = -EIO;
+			goto out;
+		}
+
+		sig = der;
+		sig_len = der_len;
+		break;
+
+	case EVP_PKEY_RSA:
+	case EVP_PKEY_RSA_PSS:
+		/* No signature encoding for RSA */
+		sig = signature;
+		sig_len = signature_len;
+		break;
+
+	default:
+		rc = -EINVAL;
+		goto out;
+	}
+
+	if (payload != NULL && payload_len > 0) {
+		/* Detached payload */
+		if (json_object_object_get_ex(header_obj, "b64", &b64_obj) &&
+		    json_object_is_type(b64_obj, json_type_boolean))
+			b64 = json_object_get_boolean(b64_obj);
+
+		if (b64) {
+			rc = encode_base64url(NULL, &payload_b64_len, payload,
+					      payload_len);
+			if (rc != 0)
+				goto out;
+
+			payload_b64 = malloc(payload_b64_len);
+			if (payload_b64 == NULL) {
+				rc = -ENOMEM;
+				goto out;
+			}
+
+			rc = encode_base64url(payload_b64, &payload_b64_len,
+					      payload, payload_len);
+			if (rc != 0)
+				goto out;
+		}
+
+		/* Take header plus '.' as is */
+		rc = EVP_DigestVerifyUpdate(md_ctx, jws, header_len + 1);
+		if (rc != 1) {
+			rc = -EIO;
+			goto out;
+		}
+
+		if (b64)
+			rc = EVP_DigestVerifyUpdate(md_ctx, payload_b64,
+						    payload_b64_len);
+		else
+			rc = EVP_DigestVerifyUpdate(md_ctx, payload,
+						    payload_len);
+		if (rc != 1) {
+			rc = -EIO;
+			goto out;
+		}
+	} else {
+		/* Take header plus '.' plus payload as is */
+		rc = EVP_DigestVerifyUpdate(md_ctx, jws, hdr_pld_len);
+		if (rc != 1) {
+			rc = -EIO;
+			goto out;
+		}
+	}
+
+	rc = EVP_DigestVerifyFinal(md_ctx, sig, sig_len);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = 0;
+
+out:
+	if (header_obj != NULL)
+		json_object_put(header_obj);
+	if (signature != NULL)
+		free(signature);
+	if (payload_b64 != NULL)
+		free(payload_b64);
+	if (ec_sig != NULL)
+		ECDSA_SIG_free(ec_sig);
+	if (der != NULL)
+		OPENSSL_free(der);
+	if (bn_r != NULL)
+		BN_free(bn_r);
+	if (bn_s != NULL)
+		BN_free(bn_s);
+	if (md_ctx != NULL)
+		EVP_MD_CTX_free(md_ctx);
+
+	return rc;
+}
+
+/**
+ * Builds a JSON Object containing a timestamp value in ISO 8601 format, e.g.
+ * { "timestamp": "2020-04-27T10:02:18.123Z" }. The time is expressed in UTC,
+ * regardless of the local time zone.
+ *
+ * @returns a JSON object containing the timestamp, or NULL in case of an error.
+ */
+json_object *get_json_timestamp(void)
+{
+	char timestamp[100];
+	struct timeval tv;
+	struct tm *tm;
+	char temp[20];
+
+	if (gettimeofday(&tv, NULL) != 0)
+		return NULL;
+
+	tm = gmtime(&tv.tv_sec);
+	if (strftime(timestamp, sizeof(timestamp), "%FT%T", tm) == 0)
+		return NULL;
+
+	snprintf(temp, sizeof(temp), ".%06ldZ", tv.tv_usec);
+	strcat(timestamp, temp);
+
+	return json_object_new_string(timestamp);
+}
+
+/**
+ * If copy is true, returns a copy of str (via strdup), else returns str itself.
+ * If str is NULL, then NULL is returned.
+ */
+static char *cond_strdup(const char *str, bool copy)
+{
+	if (str == NULL)
+		return NULL;
+
+	if (copy)
+		return strdup(str);
+	else
+		return (char *)str;
+}
+
+/**
+ * Returns the start of the UUId part of a href link.
+ * Returns NULL if href is NULL, or if the UUID is not found.
+ * The returned pointer (if not NULL) is within the specified href string!
+ */
+static const char *get_uuid_from_href(const char *href)
+{
+	const char *ch;
+
+	if (href == NULL)
+		return NULL;
+
+	ch = strrchr(href, '/');
+	if (ch == NULL)
+		return NULL;
+
+	return ch + 1;
+}
+
+/**
+ * Builds a list of tag definitions from a JSON array.
+ *
+ * @param array             a JSON array of tag definitions
+ * @param tag_def_list      the tag definition list to build
+ * @param copy              if true, the string values are copied (via strdup),
+ *                          if false, the string values re-use the JSON object's
+ *                          string buffer (see json_object_get_string).
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int json_build_tag_def_list(json_object *array,
+			    struct ekmf_tag_def_list *tag_def_list,
+			    bool copy)
+{
+	const char *descr;
+	json_object *obj;
+	int rc = 0;
+	size_t i;
+
+	if (array == NULL || tag_def_list == NULL ||
+	    !json_object_is_type(array, json_type_array))
+		return -EINVAL;
+
+	tag_def_list->num_tag_defs = json_object_array_length(array);
+	tag_def_list->tag_defs = calloc(tag_def_list->num_tag_defs,
+					sizeof(struct ekmf_tag_definition));
+	if (tag_def_list->tag_defs == NULL)
+		return -ENOMEM;
+
+	for (i = 0; i < tag_def_list->num_tag_defs; i++) {
+		obj =  json_object_array_get_idx(array, i);
+		if (obj == NULL) {
+			rc = -EBADMSG;
+			goto out;
+		}
+
+		tag_def_list->tag_defs[i].name = cond_strdup(
+				json_get_string(obj, "name"), copy);
+		if (tag_def_list->tag_defs[i].name == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		descr = json_get_string(obj, "description");
+		if (descr != NULL) {
+			tag_def_list->tag_defs[i].description =
+						cond_strdup(descr, copy);
+			if (tag_def_list->tag_defs[i].description == NULL) {
+				rc = -ENOMEM;
+				goto out;
+			}
+		}
+	}
+
+out:
+	if (rc != 0)
+		free_tag_def_list(tag_def_list, copy);
+
+	return rc;
+}
+
+/**
+ * Clones (copies) a tag definition list
+ *
+ * @param src               the source tag definition list
+ * @param dest              the destination tag definition list
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int clone_tag_def_list(const struct ekmf_tag_def_list *src,
+		       struct ekmf_tag_def_list *dest)
+{
+	int rc = 0;
+	size_t i;
+
+	if (src == NULL || dest == NULL)
+		return -EINVAL;
+
+	dest->num_tag_defs = src->num_tag_defs;
+	dest->tag_defs = calloc(dest->num_tag_defs,
+					sizeof(struct ekmf_tag_definition));
+	if (dest->tag_defs == NULL)
+		return -ENOMEM;
+
+	for (i = 0; i < dest->num_tag_defs; i++) {
+		dest->tag_defs[i].name = cond_strdup(src->tag_defs[i].name,
+						     true);
+		if (dest->tag_defs[i].name == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+		if (src->tag_defs[i].description != NULL) {
+			dest->tag_defs[i].description =
+					strdup(src->tag_defs[i].description);
+			if (dest->tag_defs[i].description != NULL) {
+				rc = -ENOMEM;
+				goto out;
+			}
+		}
+	}
+
+out:
+	if (rc != 0)
+		free_tag_def_list(dest, true);
+	return rc;
+}
+
+/**
+ * Free a tag definition list
+ *
+ * @param tag_def_list      the tag definition list to free
+ * @param free_tags         if true, the tag name and description string s are
+ *                          freed, otherwise only the array is freed.
+ */
+void free_tag_def_list(struct ekmf_tag_def_list *tag_def_list, bool free_tags)
+{
+	size_t i;
+
+	if (tag_def_list == NULL || tag_def_list->tag_defs == NULL)
+		return;
+
+	for (i = 0; free_tags && i < tag_def_list->num_tag_defs; i++) {
+		free((char *)tag_def_list->tag_defs[i].name);
+		free((char *)tag_def_list->tag_defs[i].description);
+	}
+
+	free(tag_def_list->tag_defs);
+	tag_def_list->tag_defs = NULL;
+	tag_def_list->num_tag_defs = 0;
+}
+
+/**
+ * Builds a template info structure from a JSON object.
+ *
+ * @param obj               a JSON object containing the template info
+ * @param template          the template info struct build
+ * @param copy              if true, the string values are copied (via strdup),
+ *                          if false, the string values re-use the JSON object's
+ *                          string buffer (see json_object_get_string).
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int json_build_template_info(json_object *obj,
+			     struct ekmf_template_info *template,
+			     bool copy)
+{
+	json_object *field, *label_tags = NULL;
+	int rc;
+
+	if (obj == NULL || template == NULL ||
+	   !json_object_is_type(obj, json_type_object))
+		return -EINVAL;
+
+	template->name = cond_strdup(json_get_string(obj, "name"), copy);
+	template->uuid = cond_strdup(json_get_string(obj, "templateId"), copy);
+	template->key_type = cond_strdup(json_get_string(obj, "keyType"), copy);
+	template->algorithm = cond_strdup(json_get_string(obj, "algorithm"),
+					  copy);
+	if (json_object_object_get_ex(obj, "keyLength", &field) &&
+	    json_object_is_type(field, json_type_int))
+		template->key_size = json_object_get_int(field);
+	template->state = cond_strdup(json_get_string(obj, "templateState"),
+				      copy);
+	template->key_state = cond_strdup(json_get_string(obj, "keyState"),
+					  copy);
+	template->label_template = cond_strdup(json_get_string(obj,
+							"labelTemplate"), copy);
+	if (json_object_object_get_ex(obj, "exportAllowed", &field) &&
+	    json_object_is_type(field, json_type_boolean))
+		template->export_allowed = json_object_get_boolean(field);
+	template->keystore_type = cond_strdup(json_get_string(obj,
+							      "keystoreType"),
+					      copy);
+	template->curve = cond_strdup(json_get_string(obj, "curve"), copy);
+	template->created_on = cond_strdup(json_get_string(obj, "createdOn"),
+					   copy);
+	template->updated_on = cond_strdup(json_get_string(obj, "updatedOn"),
+					   copy);
+
+	if (template->name == NULL || template->uuid == NULL ||
+	    template->algorithm == NULL || template->label_template == NULL ||
+	    template->state == NULL || template->key_state == NULL ||
+	    template->keystore_type == NULL || template->created_on == NULL ||
+	    template->updated_on == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	json_object_object_get_ex(obj, "labelTags", &label_tags);
+	rc = json_build_tag_def_list(label_tags, &template->label_tags, copy);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (rc != 0) {
+		free_tag_def_list(&template->label_tags, copy);
+		if (copy)
+			free_template_info(template);
+	}
+
+	return rc;
+}
+
+/**
+ * Clones (copies) a template info structure
+ *
+ * @param src               the source template info structure
+ * @param dest              the destination template info structure
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int clone_template_info(const struct ekmf_template_info *src,
+			struct ekmf_template_info *dest)
+{
+	int rc;
+
+	if (src == NULL || dest == NULL)
+		return -EINVAL;
+
+	dest->name = cond_strdup(src->name, true);
+	dest->uuid = cond_strdup(src->uuid, true);
+	dest->key_type = cond_strdup(src->key_type, true);
+	dest->algorithm = cond_strdup(src->algorithm, true);
+	dest->key_size = src->key_size;
+	dest->state = cond_strdup(src->state, true);
+	dest->key_state = cond_strdup(src->key_state, true);
+	dest->label_template = cond_strdup(src->label_template, true);
+	dest->export_allowed = src->export_allowed;
+	dest->keystore_type = cond_strdup(src->keystore_type, true);
+	dest->curve = cond_strdup(src->curve, true);
+	dest->created_on = cond_strdup(src->created_on, true);
+	dest->updated_on = cond_strdup(src->updated_on, true);
+	if (dest->name == NULL || dest->uuid == NULL ||
+	    dest->algorithm == NULL || dest->state == NULL ||
+	    dest->key_state == NULL || dest->label_template == NULL ||
+	    dest->keystore_type == NULL || dest->created_on == NULL ||
+	    dest->updated_on == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = clone_tag_def_list(&src->label_tags, &dest->label_tags);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (rc != 0)
+		free_template_info(dest);
+	return rc;
+}
+
+/**
+ * Free a template info structure
+ *
+ * @param template          the template to free
+ */
+void free_template_info(struct ekmf_template_info *template)
+{
+	if (template == NULL)
+		return;
+
+	free((char *)template->name);
+	free((char *)template->uuid);
+	free((char *)template->key_type);
+	free((char *)template->algorithm);
+	free((char *)template->state);
+	free((char *)template->key_state);
+	free((char *)template->label_template);
+	free((char *)template->keystore_type);
+	free((char *)template->curve);
+	free((char *)template->created_on);
+	free((char *)template->updated_on);
+
+	free_tag_def_list(&template->label_tags, true);
+}
+
+/**
+ * Builds a list of tags from a JSON array.
+ *
+ * @param array             a JSON array of tags
+ * @param tag_list          the tag list to build
+ * @param copy              if true, the string values are copied (via strdup),
+ *                          if false, the string values re-use the JSON object's
+ *                          string buffer (see json_object_get_string).
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int json_build_tag_list(json_object *array, struct ekmf_tag_list *tag_list,
+			bool copy)
+{
+	json_object *obj;
+	size_t i;
+	int rc = 0;
+
+	if (array == NULL || tag_list == NULL ||
+	    !json_object_is_type(array, json_type_array))
+		return -EINVAL;
+
+	tag_list->num_tags = json_object_array_length(array);
+	tag_list->tags = calloc(tag_list->num_tags, sizeof(struct ekmf_tag));
+	if (tag_list->tags == NULL)
+		return -ENOMEM;
+
+	for (i = 0; i < tag_list->num_tags; i++) {
+		obj =  json_object_array_get_idx(array, i);
+		if (obj == NULL)
+			return -EBADMSG;
+
+		tag_list->tags[i].name = cond_strdup(
+				json_get_string(obj, "name"), copy);
+		tag_list->tags[i].value = cond_strdup(
+				json_get_string(obj, "value"), copy);
+
+		if (tag_list->tags[i].name == NULL ||
+		    tag_list->tags[i].value == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+	}
+
+out:
+	if (rc != 0)
+		free_tag_list(tag_list, copy);
+
+	return rc;
+}
+
+/**
+ * Builds an JSON array with tag objects from a list of tags.
+ * The returned JSON object must be freed using json_object_put by the caller.
+ */
+
+/**
+ * Builds an JSON array with tag objects from a list of tags.
+ * The returned JSON object must be freed using json_object_put by the caller.
+ *
+ * @param tag_list          the tag list
+ * @param tags_obj          On return: a JSOn array containig the tags
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int build_json_tag_list(const struct ekmf_tag_list *tag_list,
+			json_object **tags_obj)
+{
+	json_object *tag_obj = NULL;
+	int rc = 0;
+	size_t i;
+
+	if (tag_list == NULL || tags_obj == NULL)
+		return -EINVAL;
+
+	*tags_obj = json_object_new_array();
+	if (*tags_obj == NULL)
+		return -ENOMEM;
+
+	for (i = 0; i < tag_list->num_tags; i++) {
+		if (tag_list->tags[i].name == NULL ||
+		    tag_list->tags[i].value == NULL) {
+			rc = -EINVAL;
+			goto out;
+		}
+
+		tag_obj = json_object_new_object();
+		if (tag_obj == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = json_object_object_add_ex(tag_obj, "name",
+			json_object_new_string(tag_list->tags[i].name), 0);
+		if (rc != 0) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = json_object_object_add_ex(tag_obj, "value",
+			json_object_new_string(tag_list->tags[i].value), 0);
+		if (rc != 0) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = json_object_array_add(*tags_obj, tag_obj);
+		if (rc != 0) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		tag_obj = NULL;
+	}
+	rc = 0;
+
+out:
+	if (rc != 0) {
+		if (*tags_obj != NULL)
+			json_object_put(*tags_obj);
+		if (tag_obj != NULL)
+			json_object_put(tag_obj);
+	}
+
+	return rc;
+}
+
+/**
+ * Clones (copies) a tag list
+ *
+ * @param src               the source tag list
+ * @param dest              the destination tag list
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int clone_tag_list(const struct ekmf_tag_list *src,
+		   struct ekmf_tag_list *dest)
+{
+	size_t i;
+	int rc = 0;
+
+	if (src == NULL || dest == NULL)
+		return -EINVAL;
+
+	dest->num_tags = src->num_tags;
+	if (dest->num_tags == 0) {
+		dest->tags = NULL;
+		return 0;
+	}
+
+	dest->tags = calloc(dest->num_tags, sizeof(struct ekmf_tag));
+	if (dest->tags == NULL)
+		return -ENOMEM;
+
+	for (i = 0; i < dest->num_tags; i++) {
+		dest->tags[i].name = cond_strdup(src->tags[i].name, true);
+		if (dest->tags[i].name == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+		dest->tags[i].value = cond_strdup(src->tags[i].value, true);
+		if (dest->tags[i].value == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+	}
+
+out:
+	if (rc != 0)
+		free_tag_list(dest, true);
+	return rc;
+}
+
+/**
+ * Free a tag list
+ *
+ * @param tag_list          the tag list to free
+ * @param free_tags         if true, the tag name and value string s are
+ *                          freed, otherwise only the array is freed.
+ */
+void free_tag_list(struct ekmf_tag_list *tag_list, bool free_tags)
+{
+	size_t i;
+
+	if (tag_list == NULL || tag_list->tags == NULL)
+		return;
+
+	for (i = 0; free_tags && i < tag_list->num_tags; i++) {
+		free((char *)tag_list->tags[i].name);
+		free((char *)tag_list->tags[i].value);
+	}
+
+	free(tag_list->tags);
+	tag_list->tags = NULL;
+	tag_list->num_tags = 0;
+}
+
+/**
+ * Builds the export control information from a JSON object.
+ *
+ * @param export_control    the JSON oibject
+ * @param tag_def_list      the tag list to build
+ * @param copy              if true, the string values are copied (via strdup),
+ *                          if false, the string values re-use the JSON object's
+ *                          string buffer (see json_object_get_string).
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int json_build_export_control(json_object *export_control,
+			      struct ekmf_export_control *export_info,
+			      bool copy)
+{
+	json_object *obj, *array;
+	size_t i;
+	int rc = 0;
+
+	if (export_control == NULL || export_info == NULL ||
+	    !json_object_is_type(export_control, json_type_object))
+		return -EINVAL;
+
+	if (!json_object_object_get_ex(export_control, "exportAllowed", &obj) ||
+	    !json_object_is_type(obj, json_type_boolean))
+		return -EINVAL;
+
+	export_info->export_allowed = json_object_get_boolean(obj);
+
+	if (!json_object_object_get_ex(export_control, "allowedKeys", &array) ||
+	    !json_object_is_type(array, json_type_array))
+		return -EINVAL;
+
+	export_info->num_exporting_keys = json_object_array_length(array);
+	export_info->exporting_keys = calloc(export_info->num_exporting_keys,
+					     sizeof(struct ekmf_exporting_key));
+	if (export_info->exporting_keys == NULL)
+		return -ENOMEM;
+
+	for (i = 0; i < export_info->num_exporting_keys; i++) {
+		obj =  json_object_array_get_idx(array, i);
+		if (obj == NULL)
+			return -EBADMSG;
+
+		export_info->exporting_keys[i].name = cond_strdup(
+				json_get_string(obj, "title"), copy);
+		export_info->exporting_keys[i].uuid = cond_strdup(
+				get_uuid_from_href(
+					json_get_string(obj, "href")), copy);
+
+		if (export_info->exporting_keys[i].name == NULL ||
+		    export_info->exporting_keys[i].uuid == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+	}
+
+out:
+	if (rc != 0)
+		free_export_control(export_info, copy);
+
+	return rc;
+}
+
+/**
+ * Clones (copies) an export control info
+ *
+ * @param src               the source export control
+ * @param dest              the destination export control
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int clone_export_control(const struct ekmf_export_control *src,
+			 struct ekmf_export_control *dest)
+{
+	size_t i;
+	int rc = 0;
+
+	if (src == NULL || dest == NULL)
+		return -EINVAL;
+
+	dest->export_allowed = src->export_allowed;
+
+	dest->num_exporting_keys = src->num_exporting_keys;
+	if (dest->num_exporting_keys == 0) {
+		dest->exporting_keys = NULL;
+		return 0;
+	}
+
+	dest->exporting_keys = calloc(dest->num_exporting_keys,
+				      sizeof(struct ekmf_exporting_key));
+	if (dest->exporting_keys == NULL)
+		return -ENOMEM;
+
+	for (i = 0; i < dest->num_exporting_keys; i++) {
+		dest->exporting_keys[i].name =
+				cond_strdup(src->exporting_keys[i].name, true);
+		if (dest->exporting_keys[i].name == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+		dest->exporting_keys[i].uuid =
+				cond_strdup(src->exporting_keys[i].uuid, true);
+		if (dest->exporting_keys[i].uuid == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+	}
+
+out:
+	if (rc != 0)
+		free_export_control(dest, true);
+	return rc;
+}
+
+/**
+ * Free export control infos
+ *
+ * @param export_control    the export control infos to free
+ * @param free_tags         if true, the exporting keys name and uuid strings
+ *                          are freed, otherwise only the array is freed.
+ */
+void free_export_control(struct ekmf_export_control *export_control,
+			 bool free_keys)
+{
+	size_t i;
+
+	if (export_control == NULL || export_control->exporting_keys == NULL)
+		return;
+
+	for (i = 0; free_keys && i < export_control->num_exporting_keys; i++) {
+		free((char *)export_control->exporting_keys[i].name);
+		free((char *)export_control->exporting_keys[i].uuid);
+	}
+
+	free(export_control->exporting_keys);
+	export_control->exporting_keys = NULL;
+	export_control->num_exporting_keys = 0;
+}
+
+/**
+ * Builds a key info structure from a JSON object.
+ *
+ * @param obj               a JSON object containing the key info
+ * @param custom_tags       a JSON array containing the custom tags
+ * @param export_control    a JSON object containing the export_control infos
+ * @param key               the key info struct to build
+ * @param copy              if true, the string values are copied (via strdup),
+ *                          if false, the string values re-use the JSON object's
+ *                          string buffer (see json_object_get_string).
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int json_build_key_info(json_object *obj, json_object *custom_tags,
+			json_object *export_control,
+			struct ekmf_key_info *key, bool copy)
+{
+	json_object *field, *label_tags = NULL;
+	int rc = 0;
+
+	if (obj == NULL || custom_tags == NULL || key == NULL ||
+	    !json_object_is_type(obj, json_type_object) ||
+	    !json_object_is_type(custom_tags, json_type_array))
+		return -EINVAL;
+
+	key->label = cond_strdup(json_get_string(obj, "label"), copy);
+	key->description = cond_strdup(json_get_string(obj, "description"),
+				       copy);
+	key->uuid = cond_strdup(json_get_string(obj, "keyId"), copy);
+	key->key_type = cond_strdup(json_get_string(obj, "type"), copy);
+	key->algorithm = cond_strdup(json_get_string(obj, "algorithm"), copy);
+	if (json_object_object_get_ex(obj, "length", &field) &&
+	    json_object_is_type(field, json_type_int))
+		key->key_size = json_object_get_int(field);
+	else
+		rc = -EBADMSG;
+
+	key->state = cond_strdup(json_get_string(obj, "state"), copy);
+	key->keystore_type = cond_strdup(json_get_string(obj, "keystoreType"),
+					 copy);
+	if (json_object_object_get_ex(obj, "template", &field) &&
+	    json_object_is_type(field, json_type_object)) {
+		key->template = cond_strdup(json_get_string(field, "title"),
+					    copy);
+		key->template_uuid = cond_strdup(get_uuid_from_href(
+					json_get_string(field, "href")), copy);
+	} else {
+		rc = -EBADMSG;
+	}
+	key->activate_on = cond_strdup(json_get_string(obj, "activationDate"),
+				       copy);
+	key->expires_on = cond_strdup(json_get_string(obj, "expirationDate"),
+				      copy);
+	key->created_on = cond_strdup(json_get_string(obj, "createdOn"), copy);
+	key->updated_on = cond_strdup(json_get_string(obj, "updatedOn"), copy);
+
+	if (rc != 0 || key->label == NULL || key->uuid == NULL ||
+	    key->algorithm == NULL || key->state == NULL ||
+	    key->keystore_type == NULL || key->template == NULL ||
+	    key->template_uuid == NULL || key->activate_on == NULL ||
+	    key->expires_on == NULL || key->created_on == NULL ||
+	    key->updated_on == NULL) {
+		rc = (rc != 0 ? rc : -ENOMEM);
+		goto out;
+	}
+
+	json_object_object_get_ex(obj, "labelTags", &label_tags);
+	rc = json_build_tag_list(label_tags, &key->label_tags, copy);
+	if (rc != 0)
+		goto out;
+
+	rc = json_build_tag_list(custom_tags, &key->custom_tags, copy);
+	if (rc != 0)
+		goto out;
+
+	rc = json_build_export_control(export_control, &key->export_control,
+				       copy);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (rc != 0) {
+		free_tag_list(&key->label_tags, copy);
+		free_tag_list(&key->custom_tags, copy);
+		free_export_control(&key->export_control, copy);
+		if (copy)
+			free_key_info(key);
+	}
+
+	return rc;
+}
+
+/**
+ * Clones (copies) a key info structure
+ *
+ * @param src               the source key info structure
+ * @param dest              the destination key info structure
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int clone_key_info(const struct ekmf_key_info *src,
+		   struct ekmf_key_info *dest)
+{
+	int rc;
+
+	if (src == NULL || dest == NULL)
+		return -EINVAL;
+
+	dest->label = cond_strdup(src->label, true);
+	dest->description = cond_strdup(src->description, true);
+	dest->uuid = cond_strdup(src->uuid, true);
+	dest->key_type = cond_strdup(src->key_type, true);
+	dest->algorithm = cond_strdup(src->algorithm, true);
+	dest->key_size = src->key_size;
+	dest->state = cond_strdup(src->state, true);
+	dest->keystore_type = cond_strdup(src->keystore_type, true);
+	dest->template = cond_strdup(src->template, true);
+	dest->template_uuid = cond_strdup(src->template_uuid, true);
+	dest->activate_on = cond_strdup(src->activate_on, true);
+	dest->expires_on = cond_strdup(src->expires_on, true);
+	dest->created_on = cond_strdup(src->created_on, true);
+	dest->updated_on = cond_strdup(src->updated_on, true);
+	if (dest->label == NULL || dest->uuid == NULL ||
+	    dest->algorithm == NULL || dest->state == NULL ||
+	    dest->keystore_type == NULL || dest->template == NULL ||
+	    dest->template_uuid == NULL || dest->activate_on == NULL ||
+	    dest->expires_on == NULL || dest->created_on == NULL ||
+	    dest->updated_on == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = clone_tag_list(&src->label_tags, &dest->label_tags);
+	if (rc != 0)
+		goto out;
+
+	rc = clone_tag_list(&src->custom_tags, &dest->custom_tags);
+	if (rc != 0)
+		goto out;
+out:
+	if (rc != 0)
+		free_key_info(dest);
+	return rc;
+}
+
+/**
+ * Free a key info structure
+ *
+ * @param key               the key info to free
+ */
+void free_key_info(struct ekmf_key_info *key)
+{
+	if (key == NULL)
+		return;
+
+	free((char *)key->label);
+	free((char *)key->description);
+	free((char *)key->uuid);
+	free((char *)key->key_type);
+	free((char *)key->algorithm);
+	free((char *)key->state);
+	free((char *)key->keystore_type);
+	free((char *)key->template);
+	free((char *)key->template_uuid);
+	free((char *)key->activate_on);
+	free((char *)key->expires_on);
+	free((char *)key->created_on);
+	free((char *)key->updated_on);
+
+	free_tag_list(&key->label_tags, true);
+	free_tag_list(&key->custom_tags, true);
+	free_export_control(&key->export_control, true);
+}
+
+/**
+ * Finds the specified HTTP header in the list of HTTP headers. Returns a newly
+ * allocated string containing the header value. The caller must free the string
+ * when no longer needed.
+ *
+ * @param headers           the list of HTTP headers
+ * @param name              the name of the header to look for.
+ *
+ * @returns a newly allocated string, or NULL if the header is not found
+ */
+char *get_http_header_value(const struct curl_slist *headers, const char *name)
+{
+	const struct curl_slist *hdr
+;
+	char *ch;
+
+	if (headers == NULL || name == NULL)
+		return NULL;
+
+	for (hdr = headers; hdr != NULL; hdr = hdr->next) {
+		if (hdr->data == NULL)
+			continue;
+
+		ch = strchr(hdr->data, ':');
+		if (ch == NULL)
+			continue;
+		if (strncasecmp(hdr->data, name, ch - hdr->data) != 0)
+			continue;
+
+		for (ch++; *ch == ' '; ch++)
+			;
+		return strdup(ch);
+	}
+
+	return NULL;
+}
+
+struct ecc_curve_info {
+	int curve_nid;
+	enum {
+		ECC_TYPE_PRIME = 0,
+		ECC_TYPE_BRAINPOOL = 1,
+	} type;
+	size_t prime_bits;
+	size_t prime_len;
+	const char *curve_id;
+};
+
+static const struct ecc_curve_info ecc_curve_list[] = {
+	{ .curve_nid = NID_X9_62_prime192v1, .type = ECC_TYPE_PRIME,
+	  .prime_bits = 192, .prime_len = 24, .curve_id = "P-192" },
+	{ .curve_nid = NID_secp224r1,        .type = ECC_TYPE_PRIME,
+	  .prime_bits = 224, .prime_len = 28, .curve_id = "P-224" },
+	{ .curve_nid = NID_X9_62_prime256v1, .type = ECC_TYPE_PRIME,
+	  .prime_bits = 256, .prime_len = 32, .curve_id = "P-256" },
+	{ .curve_nid = NID_secp384r1,        .type = ECC_TYPE_PRIME,
+	  .prime_bits = 384, .prime_len = 48, .curve_id = "P-384" },
+	{ .curve_nid = NID_secp521r1,        .type = ECC_TYPE_PRIME,
+	  .prime_bits = 521, .prime_len = 66, .curve_id = "P-521" },
+	{ .curve_nid = NID_brainpoolP160r1,  .type = ECC_TYPE_BRAINPOOL,
+	  .prime_bits = 160, .prime_len = 20, .curve_id = "brainpoolP160r1" },
+	{ .curve_nid = NID_brainpoolP192r1,  .type = ECC_TYPE_BRAINPOOL,
+	  .prime_bits = 192, .prime_len = 24, .curve_id = "brainpoolP192r1" },
+	{ .curve_nid = NID_brainpoolP224r1,  .type = ECC_TYPE_BRAINPOOL,
+	  .prime_bits = 224, .prime_len = 28, .curve_id = "brainpoolP224r1" },
+	{ .curve_nid = NID_brainpoolP256r1,  .type = ECC_TYPE_BRAINPOOL,
+	  .prime_bits = 256, .prime_len = 32, .curve_id = "brainpoolP256r1" },
+	{ .curve_nid = NID_brainpoolP320r1,  .type = ECC_TYPE_BRAINPOOL,
+	  .prime_bits = 320, .prime_len = 40, .curve_id = "brainpoolP320r1" },
+	{ .curve_nid = NID_brainpoolP384r1,  .type = ECC_TYPE_BRAINPOOL,
+	  .prime_bits = 384, .prime_len = 48, .curve_id = "brainpoolP384r1" },
+	{ .curve_nid = NID_brainpoolP512r1,  .type = ECC_TYPE_BRAINPOOL,
+	  .prime_bits = 512, .prime_len = 64, .curve_id = "brainpoolP512r1" },
+};
+
+static const int ecc_curve_num =
+		sizeof(ecc_curve_list) / sizeof(struct ecc_curve_info);
+
+/**
+ * Returns the prime bit length of the specified curve, or 0 if the curve
+ * is not known.
+ */
+size_t ecc_get_curve_prime_bits(int curve_nid)
+{
+	int i;
+
+	for (i = 0; i < ecc_curve_num; i++) {
+		if (ecc_curve_list[i].curve_nid == curve_nid)
+			return ecc_curve_list[i].prime_bits;
+	}
+	return 0;
+}
+
+/**
+ * Returns the prime length in bytes of the specified curve, or 0 if the curve
+ * is not known.
+ */
+size_t ecc_get_curve_prime_length(int curve_nid)
+{
+	int i;
+
+	for (i = 0; i < ecc_curve_num; i++) {
+		if (ecc_curve_list[i].curve_nid == curve_nid)
+			return ecc_curve_list[i].prime_len;
+	}
+	return 0;
+}
+
+/**
+ * Returns the textual curve ID of the specified curve, or NULL if the curve
+ * is not known.
+ */
+const char *ecc_get_curve_id(int curve_nid)
+{
+	int i;
+
+	for (i = 0; i < ecc_curve_num; i++) {
+		if (ecc_curve_list[i].curve_nid == curve_nid)
+			return ecc_curve_list[i].curve_id;
+	}
+	return NULL;
+}
+
+/**
+ * Returns true if the specified curve is a Prime curve, false if not, or if
+ * the curve is not known.
+ */
+bool ecc_is_prime_curve(int curve_nid)
+{
+	int i;
+
+	for (i = 0; i < ecc_curve_num; i++) {
+		if (ecc_curve_list[i].curve_nid == curve_nid)
+			return ecc_curve_list[i].type == ECC_TYPE_PRIME;
+	}
+	return false;
+}
+
+/**
+ * Returns true if the specified curve is a Brainpool curve, false if not, or if
+ * the curve is not known.
+ */
+bool ecc_is_brainpool_curve(int curve_nid)
+{
+	int i;
+
+	for (i = 0; i < ecc_curve_num; i++) {
+		if (ecc_curve_list[i].curve_nid == curve_nid)
+			return ecc_curve_list[i].type == ECC_TYPE_BRAINPOOL;
+	}
+	return false;
+}
+
+/**
+ * Returns the nid of the curve of the specified curve ID, or 0 if the curve
+ * is not known.
+ */
+int ecc_get_curve_by_id(const char *curve_id)
+{
+	int i;
+
+	for (i = 0; i < ecc_curve_num; i++) {
+		if (strcmp(ecc_curve_list[i].curve_id, curve_id) == 0)
+			return ecc_curve_list[i].curve_nid;
+	}
+	return 0;
+}
+
+/**
+ * Returns the nid of the Prime curve by its specified prime bit size, or 0
+ * if the curve is not knwon.
+ */
+int ecc_get_prime_curve_by_prime_bits(size_t prime_bits)
+{
+	int i;
+
+	for (i = 0; i < ecc_curve_num; i++) {
+		if (ecc_curve_list[i].type == ECC_TYPE_PRIME &&
+		    ecc_curve_list[i].prime_bits == prime_bits)
+			return ecc_curve_list[i].curve_nid;
+	}
+	return 0;
+}
+
+/**
+ * Returns the nid of the Brainpool curve by its specified prime bit size, or 0
+ * if the curve is not knwon.
+ */
+int ecc_get_brainpool_curve_by_prime_bits(size_t prime_bits)
+{
+	int i;
+
+	for (i = 0; i < ecc_curve_num; i++) {
+		if (ecc_curve_list[i].type == ECC_TYPE_BRAINPOOL &&
+		    ecc_curve_list[i].prime_bits == prime_bits)
+			return ecc_curve_list[i].curve_nid;
+	}
+	return 0;
+}
+
+/**
+ * Calculates the y coordinate of a point on an EC curve using the x coordinate
+ * and the y bit. x and y must be supplied by the caller with prime_len bytes.
+ * On return y contains the calculated y coordinate.
+ *
+ * @param nid               the OpenSSL nid of the ECC curve used
+ * @param prime_len         the length of the prime in bytes. This is also the
+ *                          length of the x and y coordinates.
+ * @param x                 the x coordinate as big endian binary number in
+ *                          prime_len size
+ * @param y_bit             the y-bit to identify which of the two possible
+ *                          values for y should be used
+ * @param y                 buffer to store the y coordinate as big endian
+ *                          binary number in prime_len size.
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: a function parameter is invalid
+ *          -ENOMEM: failed to allocate memory
+ *          -EIO: OpenSSL failed to calculate the y coordinate
+ *          -ENOENT: OpenSSL does not know/support the curve (nid)
+ */
+int ecc_calculate_y_coordinate(int nid, size_t prime_len,
+			       const unsigned char *x, int y_bit,
+			       unsigned char *y)
+{
+	EC_GROUP *group = NULL;
+	EC_POINT *point = NULL;
+	BIGNUM *bn_x = NULL;
+	BIGNUM *bn_y = NULL;
+	BN_CTX *ctx = NULL;
+	int rc = 0;
+
+	if (x == NULL || y == NULL)
+		return -EINVAL;
+
+	bn_x = BN_bin2bn(x, prime_len, NULL);
+	if (bn_x == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	group = EC_GROUP_new_by_curve_name(nid);
+	if (group == NULL) {
+		rc = -ENOENT;
+		goto out;
+	}
+
+	point = EC_POINT_new(group);
+	if (point == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	bn_y = BN_new();
+	if (bn_y == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	ctx = BN_CTX_new();
+	if (ctx == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	if (!EC_POINT_set_compressed_coordinates(group, point, bn_x,
+						 y_bit, ctx)) {
+		rc = -EIO;
+		goto out;
+	}
+
+	if (!EC_POINT_is_on_curve(group, point, ctx)) {
+		rc = -EIO;
+		goto out;
+	}
+
+	if (!EC_POINT_get_affine_coordinates(group, point, bn_x, bn_y,
+					     ctx)) {
+		rc = -EIO;
+		goto out;
+	}
+
+	BN_bn2binpad(bn_y, y, prime_len);
+
+out:
+	if (ctx != NULL)
+		BN_CTX_free(ctx);
+	if (point != NULL)
+		EC_POINT_free(point);
+	if (group != NULL)
+		EC_GROUP_free(group);
+	if (bn_x != NULL)
+		BN_free(bn_x);
+	if (bn_y != NULL)
+		BN_free(bn_y);
+
+	return rc;
+}
+
+/**
+ * Converts an ECC public key given by the nid and the x and y coordinates into
+ * an OpenSSL PKEY.
+ *
+ * @param nid               the OpenSSL nid of the ECC curve used
+ * @param prime_len         the length of the prime in bytes. This is also the
+ *                          length of the x and y coordinates.
+ * @param x                 the x coordinate as big endian binary number in
+ *                          prime_len size
+ * @param y                 the y coordinate as big endian binary number in
+ *                          prime_len size
+ * @param pkey              On return: A PKEY containing the ECC public key.
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: a function parameter is invalid
+ *          -ENOMEM: failed to allocate memory
+ *          -EIO: OpenSSL failed to generate the PKEY
+ *          -ENOENT: OpenSSL does not know/support the curve (nid)
+ */
+int ecc_pub_key_as_pkey(int nid, size_t prime_len, const unsigned char *x,
+			const unsigned char *y, EVP_PKEY **pkey)
+{
+	BIGNUM *bn_x = NULL, *bn_y = NULL;
+	EC_GROUP *group = NULL;
+	EC_KEY *ec = NULL;
+	int rc;
+
+	if (pkey == NULL || x == NULL || y == NULL)
+		return -EINVAL;
+
+	*pkey = NULL;
+
+	bn_x = BN_bin2bn(x, prime_len, NULL);
+	bn_y = BN_bin2bn(y, prime_len, NULL);
+	if (bn_x == NULL || bn_y == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	group = EC_GROUP_new_by_curve_name(nid);
+	if (group == NULL) {
+		rc = -ENOENT;
+		goto out;
+	}
+
+	ec = EC_KEY_new();
+	if (ec == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = EC_KEY_set_group(ec, group);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = EC_KEY_set_public_key_affine_coordinates(ec, bn_x, bn_y);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	*pkey = EVP_PKEY_new();
+	if (*pkey == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = EVP_PKEY_assign_EC_KEY(*pkey, ec);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = 0;
+out:
+	if (bn_x != NULL)
+		BN_free(bn_x);
+	if (bn_y != NULL)
+		BN_free(bn_y);
+	if (group != NULL)
+		EC_GROUP_free(group);
+	if (rc != 0 && *pkey != NULL) {
+		EVP_PKEY_free(*pkey);
+		*pkey = NULL;
+	}
+	return rc;
+}
+
+/**
+ * Converts an RSA public key given by the modulus and public exponent into
+ * an OpenSSL PKEY.
+ *
+ * @param modulus           the modulus as big endian number
+ * @param modulus_length    the length of the modulus in bytes
+ * @param pub_exp           the public exponent as big endian number
+ * @param pub_exp_length    the length of the public exponent in bytes
+ * @param pkey_type         the PKEY type (EVP_PKEY_RSA or EVP_PKEY_RSA_PSS)
+ * @param pkey              On return: A PKEY containing the RSA public key.
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: a function parameter is invalid
+ *          -ENOMEM: failed to allocate memory
+ *          -EIO: OpenSSL failed to generate the PKEY
+ */
+int rsa_pub_key_as_pkey(const unsigned char *modulus, size_t modulus_length,
+			const unsigned char *pub_exp, size_t pub_exp_length,
+			int pkey_type, EVP_PKEY **pkey)
+{
+	BIGNUM *bn_modulus = NULL, *bn_pub_exp = NULL;
+	RSA *rsa;
+	int rc;
+
+	if (pkey == NULL || modulus == NULL || pub_exp == NULL)
+		return -EINVAL;
+
+	if (pkey_type != EVP_PKEY_RSA && pkey_type != EVP_PKEY_RSA_PSS)
+		return -EINVAL;
+
+	*pkey = NULL;
+
+	bn_modulus = BN_bin2bn(modulus, modulus_length, NULL);
+	bn_pub_exp = BN_bin2bn(pub_exp, pub_exp_length, NULL);
+	if (bn_modulus == NULL || bn_pub_exp == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rsa = RSA_new();
+	if (rsa == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = RSA_set0_key(rsa, bn_modulus, bn_pub_exp, NULL);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	*pkey = EVP_PKEY_new();
+	if (*pkey == NULL) {
+		rc = -ENOMEM;
+		goto out;
+	}
+
+	rc = EVP_PKEY_assign(*pkey, pkey_type, rsa);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = 0;
+
+out:
+	if (rc != 0 && bn_modulus != NULL)
+		BN_free(bn_modulus);
+	if (rc != 0 && bn_pub_exp != NULL)
+		BN_free(bn_pub_exp);
+
+	return rc;
+}
+
+/**
+ * Converts a JSON Web Key (ECC or RSA) into a OpenSSL PKEY
+ *
+ * @param jwk               The JSON Web Key to convert
+ * @param pkey_type         If the JWK contains an RSA key, then the pkey_type
+ *                          can be EVP_PKEY_RSA or EVP_PKEY_RSA_PSS
+ * @param pkey              On return: the OpenSSL PKEY
+ *
+ * @returns zero for success, a negative errno in case of an error
+ */
+int json_web_key_as_pkey(json_object *jwk, int pkey_type, EVP_PKEY **pkey)
+{
+	unsigned char *x = NULL, *y = NULL, *n = NULL, *e = NULL;
+	size_t prime_len, len, n_len, e_len;
+	const char *kty, *crv;
+	int nid, rc = 0;
+
+	if (jwk == NULL || pkey == NULL)
+		return -EINVAL;
+
+	*pkey = NULL;
+
+	kty = json_get_string(jwk, "kty");
+	if (kty == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	if (strcmp(kty, "EC") == 0) {
+		crv = json_get_string(jwk, "crv");
+		if (crv == NULL) {
+			rc = -EIO;
+			goto out;
+		}
+
+		nid = ecc_get_curve_by_id(crv);
+		if (nid == 0) {
+			rc = -EIO;
+			goto out;
+		}
+
+		prime_len = ecc_get_curve_prime_length(nid);
+		if (prime_len == 0) {
+			rc = -EIO;
+			goto out;
+		}
+
+		x = malloc(prime_len);
+		y = malloc(prime_len);
+		if (x == NULL || y == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		len = prime_len;
+		rc = json_object_get_base64url(jwk, "x", x, &len);
+		if (rc != 0)
+			goto out;
+
+		len = prime_len;
+		rc = json_object_get_base64url(jwk, "y", y, &len);
+		if (rc != 0)
+			goto out;
+
+		rc = ecc_pub_key_as_pkey(nid, prime_len, x, y, pkey);
+		if (rc != 0)
+			goto out;
+	} else if (strcmp(kty, "RSA") == 0) {
+		n_len = 0;
+		rc = json_object_get_base64url(jwk, "n", NULL, &n_len);
+		if (rc != 0)
+			goto out;
+
+		n = malloc(n_len);
+		if (n == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = json_object_get_base64url(jwk, "n", n, &n_len);
+		if (rc != 0)
+			goto out;
+
+		e_len = 0;
+		rc = json_object_get_base64url(jwk, "e", NULL, &e_len);
+		if (rc != 0)
+			goto out;
+
+		e = malloc(e_len);
+		if (e == NULL) {
+			rc = -ENOMEM;
+			goto out;
+		}
+
+		rc = json_object_get_base64url(jwk, "e", e, &e_len);
+		if (rc != 0)
+			goto out;
+
+		rc = rsa_pub_key_as_pkey(n, n_len, e, e_len, pkey_type, pkey);
+		if (rc != 0)
+			goto out;
+
+	} else {
+		return -EIO;
+	}
+
+out:
+	if (x != NULL)
+		free(x);
+	if (y != NULL)
+		free(y);
+	if (n != NULL)
+		free(n);
+	if (e != NULL)
+		free(e);
+	return rc;
+}
+
+
+/**
+ * Write a secure key blob to the specified file.
+ *
+ * @param filename           the name of the file to write to
+ * @param key_blob           the key blob to write
+ * @param key_blob_len       the size of the key blob in bytes
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EIO: error during writing out the key blob
+ *          any other errno as returned by fopen
+ */
+int write_key_blob(const char *filename, unsigned char *key_blob,
+		   size_t key_blob_len)
+{
+	size_t count;
+	FILE *fp;
+
+	if (filename == NULL || key_blob == NULL || key_blob_len == 0)
+		return -EINVAL;
+
+	fp = fopen(filename, "w");
+	if (fp == NULL)
+		return -errno;
+
+	count = fwrite(key_blob, 1, key_blob_len, fp);
+	if (count != key_blob_len) {
+		fclose(fp);
+		return -EIO;
+	}
+
+	fclose(fp);
+	return 0;
+}
+
+/**
+ * Read a secure key blob from the specified file.
+ *
+ * @param filename           the name of the file to write to
+ * @param key_blob           a buffer to read the key blob to. If NULL, then
+ *                           only the size of the key blob is returned in
+ *                           key_blob_len.
+ * @param key_blob_len       On entry: the size of the buffer in bytes
+ *                           On return: the size of the key blob read
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -ERANGE: The supplied buffer is too short. key_blob_len is set to
+ *                   the required size.
+ *          -EIO: error during reading in the key blob
+ *          any other errno as returned by stat or fopen
+ */
+int read_key_blob(const char *filename, unsigned char *key_blob,
+		  size_t *key_blob_len)
+{
+	size_t count, size;
+	struct stat sb;
+	FILE *fp;
+
+	if (filename == NULL || key_blob_len == NULL)
+		return -EINVAL;
+
+	if (stat(filename, &sb))
+		return -errno;
+	size = sb.st_size;
+
+	if (key_blob == NULL) {
+		*key_blob_len = size;
+		return 0;
+	}
+
+	if (size > *key_blob_len) {
+		*key_blob_len = size;
+		return -ERANGE;
+	}
+
+	fp = fopen(filename, "r");
+	if (fp == NULL)
+		return -errno;
+
+	count = fread(key_blob, 1, size, fp);
+	if (count != size) {
+		fclose(fp);
+		return -EIO;
+	}
+
+	*key_blob_len = size;
+	fclose(fp);
+	return 0;
+}
+
+/**
+ * Reads a X.509 certificate from the specified PEM file.
+ *
+ * @param pem_filename       the name of the PEM file to read
+ * @param cert               on Return: the X.509 certificate object
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EIO: error during reading in the certificate
+ *          any other errno as returned by fopen
+ */
+int read_x509_certificate(const char *pem_filename, X509 **cert)
+{
+	FILE *fp;
+
+	if (pem_filename == NULL || cert == NULL)
+		return -EINVAL;
+
+	fp = fopen(pem_filename, "r");
+	if (fp == NULL)
+		return -errno;
+
+	*cert = PEM_read_X509(fp, NULL, NULL, NULL);
+
+	fclose(fp);
+
+	if (*cert == NULL)
+		return -EIO;
+
+	return 0;
+}
+
+/**
+ * Writes a X.509 certificate to the specified PEM file.
+ *
+ * @param pem_filename       the name of the PEM file to write to
+ * @param cert               the X.509 certificate object to write
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EIO: error during writing out the certificate
+ *          any other errno as returned by fopen
+ */
+int write_x509_certificate(const char *pem_filename, X509 *cert)
+{
+	FILE *fp;
+	int rc;
+
+	if (pem_filename == NULL || cert == NULL)
+		return -EINVAL;
+
+	fp = fopen(pem_filename, "w");
+	if (fp == NULL)
+		return -errno;
+
+	rc = PEM_write_X509(fp, cert);
+
+	fclose(fp);
+
+	if (rc != 1)
+		return -EIO;
+
+	return 0;
+}
+
+/**
+ * Writes a X.509 certificate signing request to the specified PEM file.
+ *
+ * @param pem_filename       the name of the PEM file to write to
+ * @param req                the X.509 request object to write
+ * @param new_hdr            if true, output "NEW" in the PEM header lines
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EIO: error during writing out the certificate
+ *          any other errno as returned by fopen
+ */
+int write_x509_request(const char *pem_filename, X509_REQ *req, bool new_hdr)
+{
+	FILE *fp;
+	int rc;
+
+	if (pem_filename == NULL || req == NULL)
+		return -EINVAL;
+
+	fp = fopen(pem_filename, "w");
+	if (fp == NULL)
+		return -errno;
+
+	if (new_hdr)
+		rc = PEM_write_X509_REQ_NEW(fp, req);
+	else
+		rc = PEM_write_X509_REQ(fp, req);
+
+	fclose(fp);
+
+	if (rc != 1)
+		return -EIO;
+
+	return 0;
+}
+
+/**
+ * Reads a public key from the specified PEM file.
+ *
+ * @param pem_filename       the name of the PEM file to read
+ * @param pkey               on Return: the PKEY object
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EIO: error during reading in the certificate
+ *          any other errno as returned by fopen
+ */
+int read_public_key(const char *pem_filename, EVP_PKEY **pkey)
+{
+	FILE *fp;
+
+	if (pem_filename == NULL || pkey == NULL)
+		return -EINVAL;
+
+	fp = fopen(pem_filename, "r");
+	if (fp == NULL)
+		return -errno;
+
+	*pkey = PEM_read_PUBKEY(fp, NULL, NULL, NULL);
+
+	fclose(fp);
+
+	if (*pkey == NULL)
+		return -EIO;
+
+	return 0;
+}
+
+/**
+ * Writes apublic key to the specified PEM file.
+ *
+ * @param pem_filename       the name of the PEM file to write to
+ * @param pkey               the PKEY object to write
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EIO: error during writing out the certificate
+ *          any other errno as returned by fopen
+ */
+int write_public_key(const char *pem_filename, EVP_PKEY *pkey)
+{
+	FILE *fp;
+	int rc;
+
+	if (pem_filename == NULL || pkey == NULL)
+		return -EINVAL;
+
+	fp = fopen(pem_filename, "w");
+	if (fp == NULL)
+		return -errno;
+
+	rc = PEM_write_PUBKEY(fp, pkey);
+
+	fclose(fp);
+
+	if (rc != 1)
+		return -EIO;
+
+	return 0;
+}
+
+/* Secure key PKEY context control */
+#define EVP_PKEY_CTRL_SK_KEY_BLOB		0x10000001
+#define EVP_PKEY_CTRL_SK_SIGN_FUNCTIONS		0x10000002
+#define EVP_PKEY_CTRL_SK_PRIVATE_DATA		0x10000003
+
+/* Secure key PKEY context data */
+struct sk_pkey_ctx {
+	rsa_sign_t         rsa_sign;
+	rsa_pss_sign_t     rsa_pss_sign;
+	ecdsa_sign_t       ecdsa_sign;
+
+	unsigned char      *key_blob;
+	size_t             key_blob_length;
+
+	const EVP_MD       *md;
+	int                rsa_padding;
+	int                rsa_pss_saltlen;
+	const EVP_MD       *rsa_pss_mgfmd;
+
+	void               *private;
+};
+
+/**
+ * Initialize an secure key PKEY context
+ *
+ * @param ctx                the PKEY context to initialize
+ *
+ * @returns 1 for success, 0 in case of an error
+ */
+static int sk_pkey_meth_init(EVP_PKEY_CTX *ctx)
+{
+	struct sk_pkey_ctx *sk_ctx;
+	EVP_PKEY *pkey;
+
+	pkey = EVP_PKEY_CTX_get0_pkey(ctx);
+	if (pkey == NULL)
+		return 0;
+
+	sk_ctx = OPENSSL_zalloc(sizeof(struct sk_pkey_ctx));
+	if (sk_ctx == NULL)
+		return 0;
+
+	if (EVP_PKEY_id(pkey) == EVP_PKEY_RSA_PSS) {
+		sk_ctx->rsa_pss_saltlen = RSA_PSS_SALTLEN_AUTO;
+		sk_ctx->rsa_padding = RSA_PKCS1_PSS_PADDING;
+	}
+	if (EVP_PKEY_id(pkey) == EVP_PKEY_RSA)
+		sk_ctx->rsa_padding = RSA_PKCS1_PADDING;
+
+	EVP_PKEY_CTX_set_data(ctx, sk_ctx);
+
+	return 1;
+}
+
+/**
+ * Cleanup an secure key PKEY context
+ *
+ * @param ctx                the PKEY context to to clean
+ */
+static void sk_pkey_meth_cleanup(EVP_PKEY_CTX *ctx)
+{
+	struct sk_pkey_ctx *sk_ctx;
+
+	sk_ctx = EVP_PKEY_CTX_get_data(ctx);
+	if (sk_ctx != NULL) {
+		OPENSSL_free(sk_ctx);
+		EVP_PKEY_CTX_set_data(ctx, NULL);
+	}
+}
+
+/**
+ * Copy an secure key PKEY context
+ *
+ * @param dst                the source PKEY context to copy from
+ * @param src                the destinationPKEY context to copy to
+ *
+ * @returns 1 for success, 0 in case of an error
+ */
+static int sk_pkey_meth_copy(EVP_PKEY_CTX *dst, EVP_PKEY_CTX *src)
+{
+	struct sk_pkey_ctx *sk_ctx_src, *sk_ctx_dst;
+
+	if (sk_pkey_meth_init(dst) != 1)
+		return 0;
+
+	sk_ctx_src = EVP_PKEY_CTX_get_data(src);
+	if (sk_ctx_src == NULL)
+		return 0;
+
+	sk_ctx_dst = EVP_PKEY_CTX_get_data(dst);
+	if (sk_ctx_dst == NULL)
+		return 0;
+
+	sk_ctx_dst->rsa_sign = sk_ctx_src->rsa_sign;
+	sk_ctx_dst->rsa_pss_sign = sk_ctx_src->rsa_pss_sign;
+	sk_ctx_dst->ecdsa_sign = sk_ctx_src->ecdsa_sign;
+	sk_ctx_dst->key_blob = sk_ctx_src->key_blob;
+	sk_ctx_dst->key_blob_length = sk_ctx_src->key_blob_length;
+	sk_ctx_dst->md = sk_ctx_src->md;
+	sk_ctx_dst->rsa_pss_saltlen = sk_ctx_src->rsa_pss_saltlen;
+	sk_ctx_dst->rsa_padding = sk_ctx_src->rsa_padding;
+	sk_ctx_dst->rsa_pss_mgfmd = sk_ctx_src->rsa_pss_mgfmd;
+	sk_ctx_dst->private = sk_ctx_src->private;
+
+	return 1;
+}
+
+/**
+ * Perform a sign operation with the secure key PKEY context.
+ * The data to be signed has already been hashed.
+ *
+ * The key to perform the sign operation with is available in the PKEY context.
+ * For this secure key case, the pkey as well as the secure key blob is
+ * available.
+ *
+ * @param ctx                the PKEY context to sign with
+ * @param sig                the buffer to store the signature
+ * @param siglen             On input: the size of the signature buffer
+ *                           On return: the size of the signature
+ * @param tbs                the data to be signed
+ * @param tbslen             the size of the data to be signed
+ *
+ * @returns 1 for success, 0 in case of an error
+ */
+static int sk_pkey_meth_sign(EVP_PKEY_CTX *ctx, unsigned char *sig,
+			     size_t *siglen, const unsigned char *tbs,
+			     size_t tbslen)
+{
+	int rc, md_type, mgf_md_type, saltlen, max_saltlen, hlen;
+	struct sk_pkey_ctx *sk_ctx;
+	EVP_PKEY *pkey;
+
+	sk_ctx = EVP_PKEY_CTX_get_data(ctx);
+	if (sk_ctx == NULL)
+		return 0;
+
+	pkey = EVP_PKEY_CTX_get0_pkey(ctx);
+	if (pkey == NULL)
+		return 0;
+
+	md_type = sk_ctx->md != NULL ? EVP_MD_type(sk_ctx->md) : NID_sha1;
+
+	switch (EVP_PKEY_id(pkey)) {
+	case EVP_PKEY_RSA:
+		if (sk_ctx->rsa_sign == NULL)
+			return 0;
+		rc = sk_ctx->rsa_sign(sk_ctx->key_blob, sk_ctx->key_blob_length,
+				      sig, siglen, tbs, tbslen,
+				      sk_ctx->rsa_padding, md_type,
+				      sk_ctx->private);
+		break;
+
+	case EVP_PKEY_RSA_PSS:
+		if (sk_ctx->rsa_pss_sign == NULL)
+			return 0;
+
+		if (sk_ctx->md != NULL)
+			hlen = EVP_MD_size(sk_ctx->md);
+		else
+			hlen = SHA_DIGEST_LENGTH;
+
+		if (sk_ctx->rsa_pss_mgfmd != NULL) {
+			mgf_md_type = EVP_MD_type(sk_ctx->rsa_pss_mgfmd);
+			hlen = EVP_MD_size(sk_ctx->rsa_pss_mgfmd);
+		} else {
+			mgf_md_type = md_type;
+		}
+
+		/*
+		 * We should be using RSA_bits(EVP_PKEY_get0_RSA(pkey)) here,
+		 * but EVP_PKEY_get0_RSA(pkey) does not work with PKEY/type
+		 * EVP_PKEY_RSA_PSS on older OpenSSL versions, so we fall back
+		 * on EVP_PKEY_bits in this case.
+		 */
+		max_saltlen = (EVP_PKEY_get0_RSA(pkey) != NULL ?
+					RSA_bits(EVP_PKEY_get0_RSA(pkey)) :
+					EVP_PKEY_bits(pkey)) / 8 - hlen - 2;
+
+		switch (sk_ctx->rsa_pss_saltlen) {
+		case RSA_PSS_SALTLEN_DIGEST:
+			saltlen = hlen;
+			break;
+		case RSA_PSS_SALTLEN_AUTO:
+		case RSA_PSS_SALTLEN_MAX:
+			saltlen = max_saltlen;
+			break;
+		default:
+			saltlen = sk_ctx->rsa_pss_saltlen;
+			break;
+		}
+
+		if (saltlen > max_saltlen || saltlen < 0)
+			return 0;
+
+		rc = sk_ctx->rsa_pss_sign(sk_ctx->key_blob,
+					  sk_ctx->key_blob_length,
+					  sig, siglen, tbs, tbslen,
+					  md_type, mgf_md_type, saltlen,
+					  sk_ctx->private);
+		break;
+
+	case EVP_PKEY_EC:
+		if (sk_ctx->ecdsa_sign == NULL)
+			return 0;
+
+		rc = sk_ctx->ecdsa_sign(sk_ctx->key_blob,
+					sk_ctx->key_blob_length, sig, siglen,
+					tbs, tbslen, md_type, sk_ctx->private);
+		break;
+
+	default:
+		rc = -1;
+	}
+
+	return rc == 0 ? 1 : 0;
+}
+
+/**
+ * Control options of the secure key PKEY context
+ *
+ * Besides some standard controls, the following secure key PKEY context
+ * specific controls are available:
+ *   EVP_PKEY_CTRL_SK_KEY_BLOB         set the secure key blob into the context
+ *   EVP_PKEY_CTRL_SK_SIGN_FUNCTIONS   set the sign functions for the context
+ *   EVP_PKEY_CTRL_SK_PRIVATE_DATA     set the private data to the context
+ *
+ * @param ctx                the PKEY context to control
+ * @param type               the control type
+ * @param p1                 an integer option
+ * @param p2                 a pointer option
+ *
+ * @returns 1 for success, 0 in case of an error, -2 if the control is not
+ * supported by the context
+ */
+static int sk_pkey_meth_ctrl(EVP_PKEY_CTX *ctx, int type, int p1, void *p2)
+{
+	struct sk_pkey_sign_func *func;
+	struct sk_pkey_ctx *sk_ctx;
+	EVP_PKEY *pkey;
+	int md_type;
+
+	sk_ctx = EVP_PKEY_CTX_get_data(ctx);
+	if (sk_ctx == NULL)
+		return 0;
+
+	pkey = EVP_PKEY_CTX_get0_pkey(ctx);
+	if (pkey == NULL)
+		return 0;
+
+	switch (type) {
+	case EVP_PKEY_CTRL_SK_KEY_BLOB:
+		sk_ctx->key_blob = p2;
+		sk_ctx->key_blob_length = p1;
+		break;
+
+	case EVP_PKEY_CTRL_SK_SIGN_FUNCTIONS:
+		func = (struct sk_pkey_sign_func *)p2;
+		sk_ctx->rsa_sign = func->rsa_sign;
+		sk_ctx->rsa_pss_sign = func->rsa_pss_sign;
+		sk_ctx->ecdsa_sign = func->ecdsa_sign;
+		break;
+
+	case EVP_PKEY_CTRL_SK_PRIVATE_DATA:
+		sk_ctx->private = p2;
+		break;
+
+	case EVP_PKEY_CTRL_MD:
+		md_type = EVP_MD_type((const EVP_MD *)p2);
+		if (md_type != NID_sha1 &&
+		    md_type != NID_ecdsa_with_SHA1 &&
+		    md_type != NID_sha224 &&
+		    md_type != NID_sha256 &&
+		    md_type != NID_sha384 &&
+		    md_type != NID_sha512 &&
+		    md_type != NID_sha3_224 &&
+		    md_type != NID_sha3_256 &&
+		    md_type != NID_sha3_384 &&
+		    md_type != NID_sha3_512)
+			return 0;
+		sk_ctx->md = p2;
+		break;
+
+	case EVP_PKEY_CTRL_GET_MD:
+		*(const EVP_MD **)p2 = sk_ctx->md;
+		break;
+
+	case EVP_PKEY_CTRL_RSA_PADDING:
+		switch (EVP_PKEY_id(pkey)) {
+		case EVP_PKEY_EC:
+			return -2;
+		case EVP_PKEY_RSA:
+			break;
+		case EVP_PKEY_RSA_PSS:
+			if (p1 != RSA_PKCS1_PSS_PADDING)
+				return -2;
+			break;
+		}
+		sk_ctx->rsa_padding = p1;
+		break;
+
+	case EVP_PKEY_CTRL_GET_RSA_PADDING:
+		switch (EVP_PKEY_id(pkey)) {
+		case EVP_PKEY_EC:
+			return -1;
+		case EVP_PKEY_RSA:
+		case EVP_PKEY_RSA_PSS:
+			*(int *)p2 = sk_ctx->rsa_padding;
+			break;
+		}
+		break;
+
+	case EVP_PKEY_CTRL_RSA_PSS_SALTLEN:
+		if (sk_ctx->rsa_padding != RSA_PKCS1_PSS_PADDING)
+			return -2;
+		if (p1 < RSA_PSS_SALTLEN_MAX)
+			return -2;
+		if (p1 == RSA_PSS_SALTLEN_MAX)
+			sk_ctx->rsa_pss_saltlen = RSA_PSS_SALTLEN_MAX_SIGN;
+		else
+			sk_ctx->rsa_pss_saltlen = p1;
+		break;
+
+	case EVP_PKEY_CTRL_GET_RSA_PSS_SALTLEN:
+		if (sk_ctx->rsa_padding != RSA_PKCS1_PSS_PADDING)
+			return -2;
+		*(int *)p2 = sk_ctx->rsa_pss_saltlen;
+		break;
+
+	case EVP_PKEY_CTRL_RSA_MGF1_MD:
+		if (sk_ctx->rsa_padding != RSA_PKCS1_PSS_PADDING)
+			return -2;
+		sk_ctx->rsa_pss_mgfmd = p2;
+		break;
+
+	case EVP_PKEY_CTRL_GET_RSA_MGF1_MD:
+		if (sk_ctx->rsa_padding != RSA_PKCS1_PSS_PADDING)
+			return -2;
+		*(const EVP_MD **)p2 = sk_ctx->rsa_pss_mgfmd != NULL ?
+					sk_ctx->rsa_pss_mgfmd : sk_ctx->md;
+		break;
+
+	case EVP_PKEY_CTRL_DIGESTINIT:
+	case EVP_PKEY_CTRL_PEER_KEY:
+	case EVP_PKEY_CTRL_PKCS7_SIGN:
+	case EVP_PKEY_CTRL_CMS_SIGN:
+		break;
+
+	default:
+		return -2;
+	}
+
+	return 1;
+}
+
+/**
+ * Sets up a secure key PKEY method to handle PKEY sign operations of the
+ * specified PKEY id (type) using secure key functions, instead of the default
+ * ones.
+ *
+ * Note: This should be done only right before the sign operation is used, and
+ * should be cleaned up using cleanup_secure_key_pkey_method() right after the
+ * sign operation is finished, to not interfere with other PKEY usage.
+ *
+ * @param pkey_id            the PKEY id (type) to setup special handling
+ *                           for. Use EVP_PKEY_id() to get the id of an existing
+ *                           pkey.
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -ENOMEM: failed to allocate memory
+ *          -EIO: OpenSSL failed to setup the method
+ */
+int setup_secure_key_pkey_method(int pkey_id)
+{
+	EVP_PKEY_METHOD *pkey_meth;
+
+	pkey_meth = EVP_PKEY_meth_new(pkey_id, 0);
+	if (pkey_meth == NULL)
+		return -ENOMEM;
+
+	EVP_PKEY_meth_set_init(pkey_meth, sk_pkey_meth_init);
+	EVP_PKEY_meth_set_cleanup(pkey_meth, sk_pkey_meth_cleanup);
+	EVP_PKEY_meth_set_copy(pkey_meth, sk_pkey_meth_copy);
+	EVP_PKEY_meth_set_ctrl(pkey_meth, sk_pkey_meth_ctrl, NULL);
+	EVP_PKEY_meth_set_sign(pkey_meth, NULL, sk_pkey_meth_sign);
+
+	if (EVP_PKEY_meth_add0(pkey_meth) != 1)
+		return -EIO;
+
+	return 0;
+}
+
+/**
+ * Cleans up the secure key PKEY method to handle PKEY sign operations of the
+ * specified PKEY id (type) using secure key functions.
+ *
+ * Note: Only call this function of you have previously setup the PKEY method
+ *       using setup_secure_key_pkey_method().
+ *
+ * @param pkey_id            the PKEY id (type) to setup special handling
+ *                           for. Use EVP_PKEY_id() to get the id of an existing
+ *                           pkey.
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -ENOENT: method not found
+ *          -EIO: OpenSSL failed to cleanup the method
+ */
+int cleanup_secure_key_pkey_method(int pkey_id)
+{
+	const EVP_PKEY_METHOD *pkey_meth;
+
+	pkey_meth = EVP_PKEY_meth_find(pkey_id);
+	if (pkey_meth == NULL)
+		return -ENOENT;
+
+	if (EVP_PKEY_meth_remove(pkey_meth) != 1)
+		return -EIO;
+
+	EVP_PKEY_meth_free((EVP_PKEY_METHOD *)pkey_meth);
+
+	return 0;
+}
+
+/**
+ * Sets up a secure key PKEY context to handle PKEY sign operations using the
+ * specified secure key blob, and secure key sign functions. The secure key blob
+ * must match the PKEY that was used to create the context with. The pkey
+ * contains the public key parts only, the secure key blob contains the
+ * private (and possibly public) key parts of the same key.
+ *
+ * Note: Only call this function of you have previously setup the PKEY method
+ *       using setup_secure_key_pkey_method().
+ *
+ * @param pkey_ctx           the PKEY context to setup special handling for
+ * @param key_blob           the secure key blob to sign with
+ * @param key_blob_len       the size of the key bob in bytes
+ * @param sign_funcs         secure key specific sign functions
+ * @param private            a pointer passed as is to the sign functions
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid argument
+ *          -EIO: OpenSSL failed to setup the context
+ */
+int setup_secure_key_pkey_context(EVP_PKEY_CTX *pkey_ctx,
+				  const unsigned char *key_blob,
+				  size_t key_blob_len,
+				  struct sk_pkey_sign_func *sign_funcs,
+				  void *private)
+{
+	int rc;
+
+	if (pkey_ctx == NULL || sign_funcs == NULL)
+		return -EINVAL;
+
+	rc = EVP_PKEY_CTX_ctrl(pkey_ctx, -1, -1, EVP_PKEY_CTRL_SK_KEY_BLOB,
+			       key_blob_len, (void *)key_blob);
+	if (rc != 1)
+		return -EIO;
+
+	rc = EVP_PKEY_CTX_ctrl(pkey_ctx, -1, -1,
+			       EVP_PKEY_CTRL_SK_SIGN_FUNCTIONS,
+			       0, sign_funcs);
+	if (rc != 1)
+		return -EIO;
+
+	rc = EVP_PKEY_CTX_ctrl(pkey_ctx, -1, -1, EVP_PKEY_CTRL_SK_PRIVATE_DATA,
+			       0, private);
+	if (rc != 1)
+		return -EIO;
+
+	return 0;
+}
+
+/**
+ * Sets up a PKEY context with RSA-PSS parameters.
+ *
+ * @param pkey_ctx           the PKEY context to setup special handling for
+ * @param rsa_pss_params     the RSA-PSS paramaters
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid argument
+ *          -EIO: OpenSSL failed to setup the context
+ */
+int setup_rsa_pss_pkey_context(EVP_PKEY_CTX *pkey_ctx,
+			       struct ekmf_rsa_pss_params *rsa_pss_params)
+{
+	const EVP_MD *mgf_md;
+	int rc;
+
+	if (pkey_ctx == NULL || rsa_pss_params == NULL)
+		return -EINVAL;
+
+	rc = EVP_PKEY_CTX_set_rsa_padding(pkey_ctx,
+					  RSA_PKCS1_PSS_PADDING);
+	if (rc != 1)
+		return -EIO;
+
+	rc = EVP_PKEY_CTX_set_rsa_pss_saltlen(pkey_ctx,
+					      rsa_pss_params->salt_len);
+	if (rc != 1)
+		return -EIO;
+
+	if (rsa_pss_params->mgf_digest_nid != 0) {
+		mgf_md = EVP_get_digestbynid(
+				rsa_pss_params->mgf_digest_nid);
+		if (mgf_md == NULL)
+			return -ENOENT;
+
+		rc = EVP_PKEY_CTX_set_rsa_mgf1_md(pkey_ctx, mgf_md);
+		if (rc != 1)
+			return -EIO;
+	}
+
+	return 0;
+}
+
+/**
+ * Checks if an exact duplicate of the name entry is part of the name already.
+ */
+static bool is_duplicate_name_entry(X509_NAME *name, X509_NAME_ENTRY *entry)
+{
+	X509_NAME_ENTRY *ne;
+	int count, i;
+
+	count = X509_NAME_entry_count(name);
+	for (i = 0; i < count; i++) {
+		ne = X509_NAME_get_entry(name, i);
+		if (ne == NULL)
+			break;
+
+		if (OBJ_cmp(X509_NAME_ENTRY_get_object(entry),
+			    X509_NAME_ENTRY_get_object(ne)) == 0 &&
+		    ASN1_STRING_cmp(X509_NAME_ENTRY_get_data(entry),
+				    X509_NAME_ENTRY_get_data(ne)) == 0)
+			return true;
+	}
+
+	return false;
+}
+
+/**
+ * Parse an array of relative distinguished names and builds an X.509 subject
+ * name. The RDNs are created with type MBSTRING_ASC, unless utf8 is requested,
+ * then they are created with MBSTRING_UTF8.
+ * To create a multiple-RDS name, prepend the RDS to add to the previous RDS
+ * with a '+' character.
+ *
+ * @param name               the X.509 name created. If *name is not NULL, then
+ *                           the RDNs are added to the existing X.509 name.
+ * @param rdns               an array of strings, each string representing an
+ *                           RDN in the form '[+]type=value'. If the type is
+ *                           prepended with a '+', then this RDN is added to the
+ *                           previous one.
+ * @param num_rdns           number of elements in the array.
+ * @param utf8               if true, RDNs of type MBSTRING_UTF8 are created,
+ *                           otherwise type is MBSTRING_ASC is used.
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EBADMSG: an RDN is not formatted correctly
+ *          -EIO: OpenSSL failed to create an X.509 name entry
+ *          -EEXIST: if one of the name entries to add is a duplicate
+ */
+int build_subject_name(X509_NAME **name, const char *rdns[], size_t num_rdns,
+		       bool utf8)
+{
+	char *rdn, *type, *value;
+	X509_NAME_ENTRY *ne;
+	X509_NAME *n;
+	int rc = 0;
+	bool multi;
+	size_t i;
+
+	if (name == NULL || rdns == NULL)
+		return -EINVAL;
+
+	if (*name != NULL)
+		n = *name;
+	else
+		n = X509_NAME_new();
+	if (n == NULL)
+		return -ENOMEM;
+
+	for (i = 0; i < num_rdns; i++) {
+		if (rdns[i] == NULL) {
+			rc = -EINVAL;
+			break;
+		}
+
+		rdn = strdup(rdns[i]);
+		if (rdn == NULL) {
+			rc = -ENOMEM;
+			break;
+		}
+
+		multi = (rdn[0] == '+');
+		type = &rdn[multi ? 1 : 0];
+
+		for (value = type; *value != '=' && *value != '\0'; value++)
+			;
+		if (*value != '=') {
+			rc = -EBADMSG;
+			free(rdn);
+			break;
+		}
+		*value = '\0';
+		value++;
+
+		ne = X509_NAME_ENTRY_create_by_txt(NULL, type,
+						   utf8 ? MBSTRING_UTF8 :
+								MBSTRING_ASC,
+						   (unsigned char *)value, -1);
+		if (ne == NULL) {
+			rc = -EBADMSG;
+			free(rdn);
+			break;
+		}
+
+		if (is_duplicate_name_entry(n, ne)) {
+			rc = -EEXIST;
+			X509_NAME_ENTRY_free(ne);
+			free(rdn);
+			break;
+		}
+
+		rc = X509_NAME_add_entry(n, ne, -1, multi ? -1 : 0);
+
+		free(rdn);
+		X509_NAME_ENTRY_free(ne);
+
+		if (rc != 1) {
+			rc = -EIO;
+			break;
+		}
+		rc = 0;
+	}
+
+	if (rc == 0)
+		*name = n;
+	else if (*name == NULL)
+		X509_NAME_free(n);
+
+	return rc;
+}
+
+/**
+ * Compares X509 Extensions by their nid
+ */
+static int X509_EXTENSION_compfunc(const X509_EXTENSION * const* a,
+				   const X509_EXTENSION * const* b)
+{
+
+	return (OBJ_obj2nid(X509_EXTENSION_get_object((X509_EXTENSION *)a)) -
+		OBJ_obj2nid(X509_EXTENSION_get_object((X509_EXTENSION *)b)));
+}
+
+/**
+ * Parse an array of textual X.509 certificate extensions and adds them to
+ * either an X.509 certificate signing request, or an X.509 certificate.
+ *
+ * When adding extensions, a check is performed if an extension with the same
+ * nid is already added. If so, a duplicate extension is not added, even if
+ * its value is different from the existing one.
+ *
+ * @param cert               the X.509 certificate to add the extensions to.
+ *                           Either req or cert can be specified.
+ * @param req                the X.509 certificate signing request to add the
+ *                           extensions to. Either req or cert can be specified.
+ * @param exts               an array of strings, each string representing an
+ *                           certificate extension in the form 'type=value'.
+ *                           can be NULL if num_exts is zero.
+ * @param num_exts           number of elements in the array.
+ * @param addl_exts          a stack of extensions to add (can be NULL)
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EBADMSG: an extension is not formatted correctly
+ *          -EIO: OpenSSL failed to create an X.509 extension
+ *          -EEXIST: if one of the extensions to add is a duplicate
+ */
+int build_certificate_extensions(X509 *cert, X509_REQ *req,
+				 const char *exts[], size_t num_exts,
+				 const STACK_OF(X509_EXTENSION) *addl_exts)
+{
+	STACK_OF(X509_EXTENSION) *sk_ext;
+	char *ext, *type, *value;
+	X509V3_CTX x509v3_ctx;
+	int count, k, rc = 0;
+	X509_EXTENSION *ex;
+	size_t i;
+
+	if (num_exts > 0 && exts == NULL)
+		return -EINVAL;
+	if (cert == NULL && req == NULL)
+		return -EINVAL;
+	if (cert != NULL && req != NULL)
+		return -EINVAL;
+
+	sk_ext = sk_X509_EXTENSION_new_null();
+	if (sk_ext == NULL)
+		return -ENOMEM;
+
+	sk_X509_EXTENSION_set_cmp_func(sk_ext, X509_EXTENSION_compfunc);
+
+	for (i = 0; exts != NULL && i < num_exts; i++) {
+		if (exts[i] == NULL) {
+			rc = -EINVAL;
+			break;
+		}
+
+		ext = strdup(exts[i]);
+		if (ext == NULL) {
+			rc = -ENOMEM;
+			break;
+		}
+
+		type = &ext[0];
+
+		for (value = type; *value != '=' && *value != '\0'; value++)
+			;
+		if (*value != '=') {
+			rc = -EBADMSG;
+			free(ext);
+			break;
+		}
+		*value = '\0';
+		value++;
+
+		rc = -EBADMSG;
+		ex = X509V3_EXT_conf(NULL, NULL, type, value);
+		if (ex != NULL) {
+			if (sk_X509_EXTENSION_find(sk_ext, ex) >= 0) {
+				rc = -EEXIST;
+				free(ext);
+				break;
+			}
+
+			rc = sk_X509_EXTENSION_push(sk_ext, ex);
+			if (rc < 1) {
+				rc = -EIO;
+				free(ext);
+				break;
+			}
+			rc = 0;
+		}
+
+		free(ext);
+	}
+
+	if (rc != 0)
+		goto out;
+
+	if (addl_exts != NULL) {
+		count = sk_X509_EXTENSION_num(addl_exts);
+		for (k = 0; k < count; k++) {
+			ex = sk_X509_EXTENSION_value(addl_exts, k);
+			if (ex != NULL) {
+				if (sk_X509_EXTENSION_find(sk_ext, ex) >= 0) {
+					rc = -EEXIST;
+					break;
+				}
+
+				rc = sk_X509_EXTENSION_push(sk_ext,
+						X509_EXTENSION_dup(ex));
+				if (rc < 1) {
+					rc = -EIO;
+					break;
+				}
+				rc = 0;
+			}
+		}
+	}
+
+	if (rc != 0)
+		goto out;
+
+	if (req != NULL && sk_X509_EXTENSION_num(sk_ext) > 0) {
+		if (X509_REQ_add_extensions(req, sk_ext) != 1)
+			rc = -EIO;
+		sk_X509_EXTENSION_pop_free(sk_ext, X509_EXTENSION_free);
+		sk_ext = NULL;
+		goto out;
+	}
+
+	if (cert != NULL && sk_X509_EXTENSION_num(sk_ext) > 0) {
+		X509V3_set_ctx_nodb(&x509v3_ctx);
+		X509V3_set_ctx(&x509v3_ctx, cert, cert, NULL, NULL, 0);
+
+		rc = 0;
+		while ((ex = sk_X509_EXTENSION_pop(sk_ext)) != NULL) {
+			if (rc == 0) {
+				if (X509_add_ext(cert, ex, -1) != 1)
+					rc = -EIO;
+			}
+			X509_EXTENSION_free(ex);
+		}
+	}
+
+out:
+	if (sk_ext != NULL)
+		sk_X509_EXTENSION_pop_free(sk_ext, X509_EXTENSION_free);
+	return rc;
+}
+
+/**
+ * Generates a serial number of a specified bit size by random and sets it
+ * as serial number into the certificate.
+ *
+ * @param cert               the certificate to set the serial number for
+ * @param sn_bit_size        the size of the serial number in bits
+ *
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: invalid parameter
+ *          -EIO: error during serial number generation
+ */
+int generate_x509_serial_number(X509 *cert, size_t sn_bit_size)
+{
+	ASN1_INTEGER *ai = NULL;
+	BIGNUM *bn = NULL;
+	int rc;
+
+	if (cert == NULL)
+		return -EINVAL;
+
+	bn =  BN_new();
+	if (bn == NULL)
+		return -ENOMEM;
+
+	rc = BN_rand(bn, sn_bit_size, BN_RAND_TOP_ANY, BN_RAND_BOTTOM_ANY);
+	if (rc != 1) {
+		rc = -EIO;
+		goto out;
+	}
+
+	ai = X509_get_serialNumber(cert);
+	if (ai == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	if (BN_to_ASN1_INTEGER(bn, ai) == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = 0;
+
+out:
+	if (bn != NULL)
+		BN_free(bn);
+
+	return rc;
+}
+
+/**
+ * Gets a String field from a JSON object.
+ *
+ * @param obj                the JSON object
+ * @param name               the name of the String field to get
+ *
+ * @returns the contents of the String field or NULL.
+ * Note: The memory returned is owned by the JSON object, and must not be freed
+ *       by the caller. It is valid until the JSON object is freed, which also
+ *       frees the memory used for the string value.
+ */
+const char *json_get_string(json_object *obj, const char *name)
+{
+	json_object *field;
+
+	if (!json_object_object_get_ex(obj, name, &field) ||
+	    !json_object_is_type(field, json_type_string))
+		return NULL;
+
+	return json_object_get_string(field);
+}
+
+/**
+ * Gets a base64url field form a JSON object, decodes it and returns the
+ * decoded data.
+ *
+ * @param obj                the JSON object
+ * @param name               the name of the String field to get
+ * @param data               buffer to return the decoded data, or NULL to
+ *                           return only the required buffer size
+ * @param data_len           on entry: the size of tne buffer
+ *                           on exit: the size of the decoded data
+ * @returns zero for success, a negative errno in case of an error:
+ *          -EINVAL: a function parameter is invalid
+ *          -ENOMEM: failed to allocate memory
+ *          -EIO: OpenSSL failed to calculate the y coordinate
+ */
+int json_object_get_base64url(json_object *obj, const char *name,
+			      unsigned char *data, size_t *data_len)
+{
+	const char *b64;
+
+	b64 = json_get_string(obj, name);
+	if (b64 == NULL)
+		return -ENOENT;
+
+	return decode_base64url(data, data_len, b64, strlen(b64));
+}
+
+/**
+ * Base64URL encodes the data and creates a JSON string object of it
+ *
+ * @param data              the data to base64url encode
+ * @param len               the length of the data
+
+ * @returns a new JSON object, or NULL in case of an error
+ */
+json_object *json_object_new_base64url(const unsigned char *data, size_t len)
+{
+	json_object *ret = NULL;
+	char *b64 = NULL;
+	size_t b64len;
+	int rc;
+
+	rc = encode_base64url(NULL, &b64len, data, len);
+	if (rc != 0)
+		goto out;
+
+	b64 = malloc(b64len);
+	if (b64 == NULL)
+		goto out;
+
+	rc = encode_base64url(b64, &b64len, data, len);
+	if (rc != 0)
+		goto out;
+
+	ret = json_object_new_string(b64);
+
+out:
+	if (b64 != NULL)
+		free(b64);
+
+	return ret;
+}
+
+#ifdef IMPLEMENT_LOCAL_JSON_OBJECT_OBJECT_ADD
+
+/**
+ * JSON-C of version 0.12 does not have json_object_object_add_ex(), and
+ * json_object_object_add does not return a return code, so implement
+ * json_object_object_add_ex here instead.
+ */
+int json_object_object_add_ex(struct json_object *obj, const char *const key,
+			      struct json_object *const val,
+			      const unsigned int UNUSED(opts))
+{
+	json_object_object_add(obj, key, val);
+	return 0;
+}
+#endif
diff -pruN 2.14.0-2/libekmfweb/utilities.h 2.15.1-0ubuntu2/libekmfweb/utilities.h
--- 2.14.0-2/libekmfweb/utilities.h	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/libekmfweb/utilities.h	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,179 @@
+/*
+ * libekmfweb - EKMFWeb client library
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+
+#ifndef UTILITIES_H
+#define UTILITIES_H
+
+#include <stddef.h>
+#include <stdbool.h>
+
+#include <openssl/x509.h>
+#include <openssl/obj_mac.h>
+#include <openssl/evp.h>
+
+#include <json-c/json.h>
+#include <curl/curl.h>
+
+#include "ekmfweb/ekmfweb.h"
+
+int decode_base64url(unsigned char *output, size_t *outlen,
+		     const char *input, size_t inlen);
+
+int encode_base64url(char *output, size_t *outlen,
+		     const unsigned char *input, size_t inlen);
+
+int parse_json_web_token(const char *token, json_object **header_obj,
+			 json_object **payload_obj, unsigned char **signature,
+			 size_t *signature_len);
+
+int create_json_web_signature(const char *algorithm, bool b64, const char *kid,
+			      const unsigned char *payload, size_t payload_len,
+			      bool detached_payload, EVP_MD_CTX *md_ctx,
+			      char **jws);
+
+int verify_json_web_signature(const char *jws, const unsigned char *payload,
+			      size_t payload_len, EVP_PKEY *pkey);
+
+json_object *get_json_timestamp(void);
+
+int json_build_tag_def_list(json_object *array,
+			    struct ekmf_tag_def_list *tag_def_list,
+			    bool copy);
+int clone_tag_def_list(const struct ekmf_tag_def_list *src,
+		       struct ekmf_tag_def_list *dest);
+void free_tag_def_list(struct ekmf_tag_def_list *tag_def_list, bool free_tags);
+
+int json_build_template_info(json_object *obj,
+			     struct ekmf_template_info *template,
+			     bool copy);
+int clone_template_info(const struct ekmf_template_info *src,
+			struct ekmf_template_info *dest);
+void free_template_info(struct ekmf_template_info *template);
+
+int json_build_tag_list(json_object *array, struct ekmf_tag_list *tag_list,
+			bool copy);
+int build_json_tag_list(const struct ekmf_tag_list *tag_list,
+			json_object **tags_obj);
+int clone_tag_list(const struct ekmf_tag_list *src,
+		   struct ekmf_tag_list *dest);
+void free_tag_list(struct ekmf_tag_list *tag_list, bool free_tags);
+
+int json_build_export_control(json_object *export_control,
+			      struct ekmf_export_control *export_info,
+			      bool copy);
+int clone_export_control(const struct ekmf_export_control *src,
+			 struct ekmf_export_control *dest);
+void free_export_control(struct ekmf_export_control *export_control,
+			 bool free_keys);
+
+int json_build_key_info(json_object *obj, json_object *custom_tags,
+			json_object *export_control,
+			struct ekmf_key_info *key, bool copy);
+int clone_key_info(const struct ekmf_key_info *src,
+		   struct ekmf_key_info *dest);
+void free_key_info(struct ekmf_key_info *key);
+
+char *get_http_header_value(const struct curl_slist *headers, const char *name);
+
+size_t ecc_get_curve_prime_bits(int curve_nid);
+size_t ecc_get_curve_prime_length(int curve_nid);
+const char *ecc_get_curve_id(int curve_nid);
+bool ecc_is_prime_curve(int curve_nid);
+bool ecc_is_brainpool_curve(int curve_nid);
+int ecc_get_curve_by_id(const char *curve_id);
+int ecc_get_prime_curve_by_prime_bits(size_t prime_bits);
+int ecc_get_brainpool_curve_by_prime_bits(size_t prime_bits);
+
+int ecc_calculate_y_coordinate(int nid, size_t prime_len,
+			       const unsigned char *x, int y_bit,
+			       unsigned char *y);
+
+int ecc_pub_key_as_pkey(int nid, size_t prime_len, const unsigned char *x,
+			const unsigned char *y, EVP_PKEY **pkey);
+
+int rsa_pub_key_as_pkey(const unsigned char *modulus, size_t modulus_length,
+			const unsigned char *pub_exp, size_t pub_exp_length,
+			int pkey_type, EVP_PKEY **pkey);
+
+int json_web_key_as_pkey(json_object *jwk, int pkey_type, EVP_PKEY **pkey);
+
+int write_key_blob(const char *filename, unsigned char *key_blob,
+		   size_t key_blob_len);
+
+int read_key_blob(const char *filename, unsigned char *key_blob,
+		  size_t *key_blob_len);
+
+int read_x509_certificate(const char *pem_filename, X509 **cert);
+
+int write_x509_certificate(const char *pem_filename, X509 *cert);
+
+int write_x509_request(const char *pem_filename, X509_REQ *req, bool new_hdr);
+
+int read_public_key(const char *pem_filename, EVP_PKEY **pkey);
+
+int write_public_key(const char *pem_filename, EVP_PKEY *pkey);
+
+typedef int (*rsa_sign_t)(const unsigned char *key_blob, size_t key_blob_length,
+			  unsigned char *sig, size_t *siglen,
+			  const unsigned char *tbs, size_t tbslen,
+			  int padding_type, int md_nid,
+			  void *private);
+typedef int (*rsa_pss_sign_t)(const unsigned char *key_blob,
+			      size_t key_blob_length, unsigned char *sig,
+			      size_t *siglen, const unsigned char *tbs,
+			      size_t tbslen, int md_nid, int mfgmd_nid,
+			      int saltlen, void *private);
+typedef int (*ecdsa_sign_t)(const unsigned char *key_blob,
+			    size_t key_blob_length, unsigned char *sig,
+			    size_t *siglen, const unsigned char *tbs,
+			    size_t tbslen, int md_nid, void *private);
+
+struct sk_pkey_sign_func {
+	rsa_sign_t      rsa_sign;
+	rsa_pss_sign_t  rsa_pss_sign;
+	ecdsa_sign_t    ecdsa_sign;
+};
+
+int setup_secure_key_pkey_method(int pkey_id);
+int cleanup_secure_key_pkey_method(int pkey_id);
+int setup_secure_key_pkey_context(EVP_PKEY_CTX *pkey_ctx,
+				  const unsigned char *key_blob,
+				  size_t key_blob_len,
+				  struct sk_pkey_sign_func *sign_funcs,
+				  void *private);
+
+int setup_rsa_pss_pkey_context(EVP_PKEY_CTX *pkey_ctx,
+			       struct ekmf_rsa_pss_params *rsa_pss_params);
+
+int build_subject_name(X509_NAME **name, const char *rdns[], size_t num_rdns,
+		       bool utf8);
+
+int build_certificate_extensions(X509 *cert, X509_REQ *req,
+				 const char *exts[], size_t num_exts,
+				 const STACK_OF(X509_EXTENSION) *addl_exts);
+
+int generate_x509_serial_number(X509 *cert, size_t sn_bit_size);
+
+const char *json_get_string(json_object *obj, const char *name);
+
+int json_object_get_base64url(json_object *obj, const char *name,
+			      unsigned char *data, size_t *data_len);
+
+json_object *json_object_new_base64url(const unsigned char *data, size_t len);
+
+#ifndef JSON_C_OBJECT_ADD_KEY_IS_NEW
+#define JSON_C_OBJECT_ADD_KEY_IS_NEW (1 << 1)
+#define IMPLEMENT_LOCAL_JSON_OBJECT_OBJECT_ADD
+
+int json_object_object_add_ex(struct json_object *obj, const char *const key,
+			      struct json_object *const val,
+			      const unsigned int opts);
+#endif
+
+#endif
diff -pruN 2.14.0-2/libutil/Makefile 2.15.1-0ubuntu2/libutil/Makefile
--- 2.14.0-2/libutil/Makefile	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/libutil/Makefile	2020-10-28 14:31:59.000000000 +0000
@@ -43,6 +43,7 @@ util_prg_example: util_prg_example.o $(l
 util_rec_example: util_rec_example.o $(lib)
 
 $(lib): $(objects)
+$(lib): ALL_CFLAGS += -fPIC
 
 install: all
 
diff -pruN 2.14.0-2/libutil/util_file.c 2.15.1-0ubuntu2/libutil/util_file.c
--- 2.14.0-2/libutil/util_file.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/libutil/util_file.c	2020-10-28 14:31:59.000000000 +0000
@@ -282,6 +282,44 @@ int util_file_write_ull(unsigned long lo
 }
 
 /**
+ * Read a file and convert it to signed int according to given base
+ *
+ * @param[out] val      Buffer for value
+ * @param[in]  base     Base for conversion, either 8, 10, or 16
+ * @param[in]  fmt      Format string for generation of the path name
+ * @param[in]  ...      Parameters for format string
+ *
+ * @retval     0        Integer has been read correctly
+ * @retval    -1        Error while reading file
+ */
+int util_file_read_i(int *val, int base, const char *fmt, ...)
+{
+	char path[PATH_MAX], buf[512];
+	va_list ap;
+	int count;
+
+	/* Construct the file name */
+	UTIL_VSPRINTF(path, fmt, ap);
+
+	if (file_gets(buf, sizeof(buf), path))
+		return -1;
+	switch (base) {
+	case 8:
+		count = sscanf(buf, "%do", val);
+		break;
+	case 10:
+		count = sscanf(buf, "%dd", val);
+		break;
+	case 16:
+		count = sscanf(buf, "%dx", val);
+		break;
+	default:
+		util_panic("Invalid base: %d\n", base);
+	}
+	return (count == 1) ? 0 : -1;
+}
+
+/**
  * Read a file and convert it to signed long according to given base
  *
  * @param[out] val      Buffer for value
@@ -358,6 +396,44 @@ int util_file_read_ll(long long *val, in
 }
 
 /**
+ * Read a file and convert it to unsigned int according to given base
+ *
+ * @param[out] val      Buffer for value
+ * @param[in]  base     Base for conversion, either 8, 10, or 16
+ * @param[in]  fmt      Format string for generation of the path name
+ * @param[in]  ...      Parameters for format string
+ *
+ * @retval     0        Integer has been read correctly
+ * @retval    -1        Error while reading file
+ */
+int util_file_read_ui(unsigned int *val, int base, const char *fmt, ...)
+{
+	char path[PATH_MAX], buf[512];
+	va_list ap;
+	int count;
+
+	/* Construct the file name */
+	UTIL_VSPRINTF(path, fmt, ap);
+
+	if (file_gets(buf, sizeof(buf), path))
+		return -1;
+	switch (base) {
+	case 8:
+		count = sscanf(buf, "%uo", val);
+		break;
+	case 10:
+		count = sscanf(buf, "%uu", val);
+		break;
+	case 16:
+		count = sscanf(buf, "%ux", val);
+		break;
+	default:
+		util_panic("Invalid base: %d\n", base);
+	}
+	return (count == 1) ? 0 : -1;
+}
+
+/**
  * Read a file and convert it to unsigned long according to given base
  *
  * @param[out] val      Buffer for value
@@ -432,3 +508,31 @@ int util_file_read_ull(unsigned long lon
 	}
 	return (count == 1) ? 0 : -1;
 }
+
+/**
+ * Read a file and convert it according to format string
+ *
+ * @param[in]  path     File name to read
+ * @param[in]  fmt      Format string for parsing the content
+ * @param[out] ...      Parameters for format string
+ *
+ * @retval     != -1    Number of values parsed correctly
+ * @retval    -1        Error while reading file
+ */
+
+int util_file_read_va(const char *path, const char *fmt, ...)
+{
+	char buf[512];
+	va_list ap;
+	int ret;
+
+	if (file_gets(buf, sizeof(buf), path))
+		return -1;
+
+	va_start(ap, fmt);
+	ret = vsscanf(buf, fmt, ap);
+	va_end(ap);
+	if (ret == EOF)
+		return -1;
+	return ret;
+}
diff -pruN 2.14.0-2/libutil/util_sys.c 2.15.1-0ubuntu2/libutil/util_sys.c
--- 2.14.0-2/libutil/util_sys.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/libutil/util_sys.c	2020-10-28 14:31:59.000000000 +0000
@@ -11,17 +11,114 @@
 
 #include <err.h>
 #include <errno.h>
+#include <linux/fs.h>
 #include <stdlib.h>
+#include <stdio.h>
 #include <string.h>
 #include <sys/stat.h>
 #include <sys/sysmacros.h>
 #include <unistd.h>
 
+#include "lib/util_file.h"
+#include "lib/util_libc.h"
 #include "lib/util_path.h"
 #include "lib/util_sys.h"
 
 /* lstat() doesn't work for sysfs files, a fixed size is therefore inevitable */
 #define READLINK_SIZE	256
+#define PAGE_SIZE	4096
+
+/**
+ * Return the partition number of a given partition.
+ *
+ * @param[in]	dev	Device node of interest
+ *
+ * @retval	int	Partition number of the device
+ * @retval	-1	Error when trying to read the partition number.
+ */
+int util_sys_get_partnum(dev_t dev)
+{
+	int partnum = -1;
+	char *path;
+
+	path = util_path_sysfs("dev/block/%u:%u/partition",
+			       major(dev), minor(dev));
+	if (util_file_read_i(&partnum, 10, path)) {
+		warnx("Could not read from path '%s'", path);
+		goto out;
+	}
+	if (partnum <= 0) {
+		warnx("Bad partition number in '%s'", path);
+		partnum = -1;
+		goto out;
+	}
+
+out:
+	free(path);
+	return partnum;
+}
+
+/**
+ * Determine if the given device is a partition.
+ *
+ * @param[in]	dev	Device node of interest
+ *
+ * @retval	true	Device is partition
+ * @retval	false	Device is not a partition
+ */
+bool util_sys_dev_is_partition(dev_t dev)
+{
+	bool is_part;
+	char *path;
+
+	path = util_path_sysfs("dev/block/%u:%u/partition",
+			       major(dev), minor(dev));
+	is_part = util_path_exists(path);
+	free(path);
+
+	return is_part;
+}
+
+/**
+ * Determine base device
+ *
+ * This function determines the base device \p base_dev of a given
+ * device \p dev. If \p dev is a base device, \p base_dev becomes \p dev.
+ *
+ * @param[in]	dev		Device node of interest
+ * @param[out]	base_dev	Identified base device
+ *
+ * @retval	 0		Success
+ * @retval	-1		Error while reading device information or
+ *				constructed path
+ */
+int util_sys_get_base_dev(dev_t dev, dev_t *base_dev)
+{
+	int base_major, base_minor;
+	char buf[PAGE_SIZE];
+	char *path;
+
+	/* check if the device already is a base device */
+	if (!util_sys_dev_is_partition(dev)) {
+		*base_dev = makedev(major(dev), minor(dev));
+		return 0;
+	}
+	path = util_path_sysfs("dev/block/%d:%d/../dev",
+			       major(dev), minor(dev));
+	if (util_file_read_line(buf, sizeof(buf), path)) {
+		warnx("Could not read from path '%s'", path);
+		free(path);
+		return -1;
+	}
+	free(path);
+	if (sscanf(buf, "%i:%i", &base_major, &base_minor) != 2) {
+		warn("Could not parse major:minor from string '%s'", buf);
+		return -1;
+	}
+	*base_dev = makedev(base_major, base_minor);
+
+	return 0;
+}
 
 /**
  * Identify device address
@@ -44,13 +141,17 @@ int util_sys_get_dev_addr(const char *de
 	unsigned int maj, min;
 	struct stat s;
 	ssize_t len;
+	dev_t base;
 	char *path;
 
 	if (stat(dev, &s) != 0)
 		return -1;
 
-	maj = major(s.st_rdev);
-	min = minor(s.st_rdev);
+	if (util_sys_get_base_dev(s.st_rdev, &base))
+		return -1;
+
+	maj = major(base);
+	min = minor(base);
 
 	if (S_ISBLK(s.st_mode))
 		path = util_path_sysfs("dev/block/%u:%u/device", maj, min);
diff -pruN 2.14.0-2/lsstp/lsstp.8 2.15.1-0ubuntu2/lsstp/lsstp.8
--- 2.14.0-2/lsstp/lsstp.8	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/lsstp/lsstp.8	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,79 @@
+.\" Copyright 2020 IBM Corp.
+.\" s390-tools is free software; you can redistribute it and/or modify
+.\" it under the terms of the MIT license. See LICENSE for details.
+.\"
+.TH LSSTP 8 "Jul 2020" "s390-tools" "Linux Administrator's Manual"
+.SH NAME
+.B "lsstp "
+\- Show STP configuration information
+.SH SYNOPSIS
+.BI "lsstp "
+
+.SH DESCRIPTION
+.B lsstp
+displays information about the current Server Time Protocol (STP) configuration
+like coordinated time network (CTN) ID, timing state and leap seconds.
+.SH OUTPUT
+.TP
+.B STP online
+Indication of the online state
+.TP
+.B CTN ID
+The ID of the coordinated time network. If it can be decoded as EBCDIC it is shown as an EBCDIC string, otherwise a hexadecimal representation is shown.
+.TP
+.B CTN Type
+The type of timing network.
+.IP
+.B No CTN
+STP is not configured for attachment to a CTN.
+.IP
+.B STP-only
+STP is configured and attached to a CTN with only STP nodes.
+.IP
+.B Mixed
+STP is configured and attached to a CTN with both STP and external time reference (ETR) nodes.
+.TP
+.B Stratum
+The number of servers in the timing path between the local STP clock and the selected primary time server.
+.TP
+.B Timing mode
+.IP
+.B Local
+The Time-of-day (TOD) clock is stepped by the local hardware oscillator and is not steered by the STP facility.
+.IP
+.B ETR
+The TOD clock is synchronized with an attached 9037 Sysplex Timer.
+.IP
+.B STP
+The TOD clock is steered by the STP facility to maintain synchronization with a Coordinated Server Time (CST).
+.IP
+.B Uninitialized
+The TOD clock is not initialized. The STP facility is allowed to perform a step adjustment to the TOD clock for synchronization.
+.TP
+.B Timing state
+The synchronization state of the STP facility. Can be unsynchronized, synchronized or stopped.
+.TP
+.B DST offset
+The daylight savings time offset relative to UTC in minutes.
+.TP
+.B Timezone offset
+The offset of the local time relative to UTC in minutes.
+.TP
+.B Time offset
+The total time offset at the server. This field is only valid in mixed CTN configurations.
+.TP
+.B Active leap seconds
+The number of leap seconds that are currently in effect at the STP facility.
+.TP
+.B Leap second <insertion|deletion> at
+If a leap second insertion or deletion is scheduled in the STP facility, this field shows the day and time of the scheduled change.
+.SH OPTIONS
+.TP
+.BI "-v|--version"
+Print version number.
+.TP
+.BI "-h|--help"
+Print usage text.
+
+.SH AUTHORS
+Sven Schnelle <svens@linux.ibm.com>
diff -pruN 2.14.0-2/lsstp/lsstp.c 2.15.1-0ubuntu2/lsstp/lsstp.c
--- 2.14.0-2/lsstp/lsstp.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/lsstp/lsstp.c	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,218 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdarg.h>
+#include <stdint.h>
+#include <string.h>
+#include <errno.h>
+#include <time.h>
+#include <iconv.h>
+#include <inttypes.h>
+
+#include "lib/util_opt.h"
+#include "lib/util_file.h"
+#include "lib/util_prg.h"
+#include "lib/util_path.h"
+
+static const struct util_prg prg = {
+	.desc = "Display STP system information",
+	.args = "",
+	.copyright_vec = {
+		{
+			.owner = "IBM Corp.",
+			.pub_first = 2020,
+		},
+		UTIL_PRG_COPYRIGHT_END
+	}
+};
+
+static struct util_opt opt_vec[] = {
+	UTIL_OPT_HELP,
+	UTIL_OPT_VERSION,
+	UTIL_OPT_END
+};
+
+struct stp_parms {
+	uint64_t ctn_id;
+	unsigned int online;
+	unsigned int leap_seconds;
+	int leap_seconds_diff;
+	unsigned int leap_seconds_utc;
+	unsigned int stratum;
+	unsigned int ctn_type;
+	unsigned int timing_mode;
+	unsigned int timing_state;
+	int dst_offset;
+	int time_offset;
+	int time_zone_offset;
+};
+
+static int convert_ctn_id(char *in, char *out)
+{
+	iconv_t ic;
+	size_t inlen = sizeof(unsigned long long);
+	size_t outlen = sizeof(unsigned long long);
+
+	ic = iconv_open("ISO-8859-1", "EBCDIC-US");
+	if (ic == (iconv_t)-1) {
+		warn("Could not initialize EBCDIC to ISO-8859-1 conversion table");
+		return -1;
+	}
+
+	if (iconv(ic, &in, &inlen, (char **)&out, &outlen) == (size_t)-1) {
+		warn("Code page translation EBCDIC to ISO-8859-1 failed");
+		iconv_close(ic);
+		return -1;
+	}
+	iconv_close(ic);
+	return 0;
+}
+
+static const char *ctn_type_str(int type)
+{
+	switch (type) {
+	case 0:
+		return "No CTN defined";
+	case 1:
+		return "STP-only";
+	case 2:
+		return "mixed";
+	default:
+		return "unknown";
+	}
+}
+
+static const char *tmd_to_str(int mode)
+{
+	switch (mode) {
+	case 0:
+		return "Local";
+	case 1:
+		return "ETR";
+	case 2:
+		return "STP";
+	case 15:
+		return "Uninitialized";
+	default:
+		return "unknown";
+	}
+}
+
+static const char *tst_to_str(int mode)
+{
+	switch (mode) {
+	case 0:
+		return "Unsynchronized";
+	case 1:
+		return "Synchronized";
+	case 2:
+		return "Physical clock stopped";
+	default:
+		return "unknown";
+	}
+}
+
+static const char *yesno_str(int val)
+{
+	return val ? "yes" : "no";
+}
+
+#define read_sysfs_attr(attr, parm, func, base)							\
+	do {											\
+		path = util_path_sysfs("devices/system/stp/%s", attr);				\
+		ret = func(parm, base, path);							\
+		if (ret) {									\
+			fprintf(stderr, "failed to open %s: %s\n", path, strerror(errno));	\
+			free(path);								\
+			exit(EXIT_FAILURE);							\
+		}										\
+		free(path);									\
+	} while (0)
+
+int main(int argc, char **argv)
+{
+	struct stp_parms parm = { 0 };
+	char ctn_id[32] = { 0 };
+	char *path;
+	int ret, c;
+
+	util_prg_init(&prg);
+	util_opt_init(opt_vec, NULL);
+
+	for (;;) {
+		c = util_opt_getopt_long(argc, argv);
+		if (c == -1)
+			break;
+
+		switch (c) {
+		case 'v':
+			util_prg_print_version();
+			exit(EXIT_SUCCESS);
+		case 'h':
+			util_prg_print_help();
+			util_opt_print_help();
+			exit(EXIT_SUCCESS);
+		default:
+			fprintf(stderr, "Try 'lsstp --help' for more information.\n");
+			exit(EXIT_FAILURE);
+		}
+	}
+
+	read_sysfs_attr("online", &parm.online, util_file_read_ui, 10);
+	if (!parm.online) {
+		printf("STP disabled\n");
+		goto out;
+	}
+
+	read_sysfs_attr("ctn_id", &parm.ctn_id, util_file_read_ul, 16);
+	read_sysfs_attr("ctn_type", &parm.ctn_type, util_file_read_ui, 10);
+	read_sysfs_attr("stratum", &parm.stratum, util_file_read_ui, 10);
+	read_sysfs_attr("leap_seconds", &parm.leap_seconds, util_file_read_ui, 10);
+	read_sysfs_attr("timing_mode", &parm.timing_mode, util_file_read_ui, 10);
+	read_sysfs_attr("timing_state", &parm.timing_state, util_file_read_ui, 10);
+	read_sysfs_attr("dst_offset", &parm.dst_offset, util_file_read_i, 10);
+	read_sysfs_attr("time_offset", &parm.time_offset, util_file_read_i, 10);
+	read_sysfs_attr("time_zone_offset", &parm.time_zone_offset, util_file_read_i, 10);
+
+	if (convert_ctn_id((char *)&parm.ctn_id, ctn_id))
+		snprintf(ctn_id, sizeof(ctn_id)-1, "%016" PRIx64, parm.ctn_id);
+
+	printf("STP online:            %s\n"
+	       "CTN ID:                %s\n"
+	       "CTN type:              %s\n"
+	       "Stratum:               %d\n"
+	       "Timing mode:           %s\n"
+	       "Timing state:          %s\n"
+	       "DST offset:            %d\n"
+	       "Timezone offset:       %d\n"
+	       "Time offset:           %d\n"
+	       "Active leap seconds:   %d\n",
+	       yesno_str(parm.online),
+	       ctn_id,
+	       ctn_type_str(parm.ctn_type),
+	       parm.stratum,
+	       tmd_to_str(parm.timing_mode),
+	       tst_to_str(parm.timing_state),
+	       parm.dst_offset,
+	       parm.time_zone_offset,
+	       parm.time_offset,
+	       parm.leap_seconds);
+
+	printf("Scheduled leap second: ");
+
+	path = util_path_sysfs("devices/system/stp/leap_seconds_scheduled");
+	if (util_file_read_va(path, "%d,%d", &parm.leap_seconds_utc,
+				&parm.leap_seconds_diff) == 2 &&
+			parm.leap_seconds_diff && parm.leap_seconds_utc) {
+		time_t lsoup = parm.leap_seconds_utc;
+
+		printf("%s at: %s UTC",
+			parm.leap_seconds_diff > 0 ? "insertion" : "deletion",
+			ctime(&lsoup));
+	} else {
+		printf("-\n");
+	}
+	free(path);
+	return 0;
+out:
+	return 1;
+}
diff -pruN 2.14.0-2/lsstp/Makefile 2.15.1-0ubuntu2/lsstp/Makefile
--- 2.14.0-2/lsstp/Makefile	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/lsstp/Makefile	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,18 @@
+include ../common.mak
+
+libs = $(rootdir)/libutil/libutil.a
+all: lsstp
+
+lsstp: lsstp.o $(libs)
+
+install: all
+	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) \
+		$(DESTDIR)$(MANDIR)/man8
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 lsstp $(DESTDIR)$(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 lsstp.8 \
+		$(DESTDIR)$(MANDIR)/man8
+
+clean:
+	rm -f *.o *~ lsstp core
+
+.PHONY: all install clean
diff -pruN 2.14.0-2/Makefile 2.15.1-0ubuntu2/Makefile
--- 2.14.0-2/Makefile	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/Makefile	2020-10-28 14:31:59.000000000 +0000
@@ -3,13 +3,13 @@ ARCH := $(shell uname -m | sed -e s/i.86
 # Include common definitions
 include common.mak
 
-LIB_DIRS = libvtoc libutil libzds libdasd libvmdump libccw libvmcp
+LIB_DIRS = libvtoc libutil libzds libdasd libvmdump libccw libvmcp libekmfweb
 TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
 	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
 	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
 	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
 	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
-	   genprotimg
+	   genprotimg lsstp
 
 SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)
 
diff -pruN 2.14.0-2/man/dumpconf.8 2.15.1-0ubuntu2/man/dumpconf.8
--- 2.14.0-2/man/dumpconf.8	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/man/dumpconf.8	2020-10-28 14:31:59.000000000 +0000
@@ -45,7 +45,7 @@ vmcmd: Trigger CP command according to t
 
 .TP
 \fB  - DUMP_TYPE:\fR
-Type of dump device. Possible values are 'ccw' and 'fcp'.
+Type of dump device. Possible values are 'ccw', 'fcp' and 'nvme'.
 
 .TP
 \fB  - DEVICE:\fR
@@ -60,6 +60,14 @@ WWPN for SCSI dump device.
 LUN for SCSI dump device.
 
 .TP
+\fB  - FID\fR
+Function ID for NVMe dump device.
+
+.TP
+\fB  - NSID\fR
+Namespace ID for NVMe dump device.
+
+.TP
 \fB  - BOOTPROG:\fR
 Boot program selector.
 
@@ -156,6 +164,25 @@ LUN=0x4713000000000000
 .br
 BOOTPROG=0
 .br
+BR_LBA=0
+.br
+
+#
+.br
+# Example configuration for an NVMe dump device (NVMe Disk)
+.br
+#
+.br
+ON_PANIC=dump
+.br
+DUMP_TYPE=nvme
+.br
+FID=0x0300
+.br
+NSID=0x0001
+.br
+BOOTPROG=0
+.br
 BR_LBA=0
 .br
 
diff -pruN 2.14.0-2/README.md 2.15.1-0ubuntu2/README.md
--- 2.14.0-2/README.md	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/README.md	2020-10-28 14:31:59.000000000 +0000
@@ -243,6 +243,12 @@ Package contents
    Provides simple tools to create a binary that can be used to implement
    simple network boot setups following the PXELINUX conventions.
 
+ * libekmfweb:
+   A shared library that provides functions to communicate with an EKMF Web
+   server via REST calls over HTTPS. EKMF Web stands for IBM Enterprise Key
+   Management Foundation - Web Edition, and is used to manage keys in an
+   enterprise.
+
 For more information refer to the following publications:
 
   * "Device Drivers, Features, and Commands" chapter "Useful Linux commands"
@@ -267,10 +273,11 @@ build options:
 | pfm            | `HAVE_PFM`         | cpacfstats                            |
 | net-snmp       | `HAVE_SNMP`        | osasnmpd                              |
 | glibc-static   | `HAVE_LIBC_STATIC` | zfcpdump                              |
-| openssl        | `HAVE_OPENSSL`     | genprotimg,zkey                       |
+| openssl        | `HAVE_OPENSSL`     | genprotimg, zkey, libekmfweb          |
 | cryptsetup     | `HAVE_CRYPTSETUP2` | zkey-cryptsetup                       |
-| json-c         | `HAVE_JSONC`       | zkey-cryptsetup                       |
+| json-c         | `HAVE_JSONC`       | zkey-cryptsetup, libekmfweb           |
 | glib2          | `HAVE_GLIB2`       | genprotimg                            |
+| libcurl        | `HAVE_LIBCURL`     | libekmfweb                            |
 
 This table lists additional build or install options:
 
@@ -397,3 +404,11 @@ the different tools are provided:
   tool must be added to this group. The owner of the default key repository
   '/etc/zkey/repository' must be set to group 'zkeyadm' with write permission
   for this group.
+
+* libekmfweb:
+  For building the libekmfweb shared library you need openssl version 1.1.1 or
+  newer installed (openssl-devel.rpm). Also required are json-c version 0.13 or
+  newer (json-c-devel.rpm), and libcurl version 7.59 or newer
+  (libcurl-devel.rpm).
+  Tip: you may skip the libekmfweb build by adding `HAVE_OPENSSL=0`,
+  `HAVE_JSONC=0`, or `HAVE_LIBCURL=0` to the make invocation.
diff -pruN 2.14.0-2/zconf/zcrypt/chzcrypt.8 2.15.1-0ubuntu2/zconf/zcrypt/chzcrypt.8
--- 2.14.0-2/zconf/zcrypt/chzcrypt.8	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zconf/zcrypt/chzcrypt.8	2020-10-28 14:31:59.000000000 +0000
@@ -1,8 +1,10 @@
-.\" Copyright 2019 IBM Corp.
+.\" chzcrypt.8
+.\"
+.\" Copyright 2020 IBM Corp.
 .\" s390-tools is free software; you can redistribute it and/or modify
 .\" it under the terms of the MIT license. See LICENSE for details.
 .\"
-.TH CHZCRYPT 8 "AUG 2019" "s390-tools"
+.TH CHZCRYPT 8 "OCT 2020" "s390-tools"
 .SH NAME
 chzcrypt \- modify zcrypt configuration
 .SH SYNOPSIS
@@ -16,6 +18,14 @@ chzcrypt \- modify zcrypt configuration
 [...] )
 .TP
 .B chzcrypt
+.B --config-on
+.RB "|"
+.B --config-off
+.RB "( " -a " | "
+.I <device id>
+[...] )
+.TP
+.B chzcrypt
 .RB "[ " -p " | " -n " ] [ " -t
 .I <timeout>
 ]
@@ -54,11 +64,22 @@ Set the given cryptographic device(s) of
 .B -a, --all
 Set all available cryptographic device(s) online or offline.
 .TP 8
+.B --config-on
+Set the given cryptographic card device(s) config on ('configured').
+.TP 8
+.B --config-off
+Set the given cryptographic card device(s) config off ('deconfigured').
+.TP 8
 .B <device id>
-Specifies a cryptographic device which will be set either online or offline.
-The device can either be a card device or a queue device.
-A queue device can only get switched online when the providing card is online.
-
+Specifies a cryptographic device which will be set either online or
+offline or configured on or off. For online and offline the device can
+either be a card device or a queue device. A queue device can only get
+switched online when the providing card is online.
+.br
+For config on/off the device needs to be a card device. A card or
+queue device cannot get switched online if the card is in deconfigured
+state.
+.br
 Please note that the card device and queue device representation are both
 in hexadecimal notation.
 .TP 8
@@ -103,11 +124,25 @@ Will set the cryptographic device '10.00
 .B chzcrypt -d -a
 Will set all available cryptographic devices offline.
 .TP
+.B chzcrypt --config-on -a -V
+Set all available crypto cards to config on, be verbose.
+.TP
+.B chzcrypt -V --config-off card01 card03
+Switch the two crypto cards 1 and 3 to deconfigured, be verbose.
+.TP
 .B chzcrypt -c 60 -n
 Will set configuration timer for re-scanning the AP bus to 60 seconds and
 disable zcrypt's poll thread.
 .TP
 .B chzcrypt -q 67
 Will set the default domain to 67.
+.SH NOTES
+Support for crypto cards to get switched config on or off requires a
+Linux kernel supporting this. If the required sysfs attribute file
+does not exist, it is assumed there is an older kernel running and
+chzcrypt exits with an appropriate message. Even more config on/off
+may require support from a hypervisor like KVM or zVM and may fail if
+the Linux kernel is unable to perform the SCLP command. Check syslog
+on failure.
 .SH SEE ALSO
 \fBlszcrypt\fR(8)
diff -pruN 2.14.0-2/zconf/zcrypt/chzcrypt.c 2.15.1-0ubuntu2/zconf/zcrypt/chzcrypt.c
--- 2.14.0-2/zconf/zcrypt/chzcrypt.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zconf/zcrypt/chzcrypt.c	2020-10-28 14:31:59.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * chzcrypt - Tool to modify zcrypt configuration
  *
- * Copyright IBM Corp. 2008, 2019
+ * Copyright IBM Corp. 2008, 2020
  *
  * s390-tools is free software; you can redistribute it and/or modify
  * it under the terms of the MIT license. See LICENSE for details.
@@ -47,7 +47,7 @@ const struct util_prg prg = {
 		{
 			.owner = "IBM Corp.",
 			.pub_first = 2008,
-			.pub_last = 2019,
+			.pub_last = 2020,
 		},
 		UTIL_PRG_COPYRIGHT_END
 	}
@@ -56,6 +56,10 @@ const struct util_prg prg = {
 /*
  * Configuration of command line options
  */
+
+#define OPT_CONFIG_ON  0x80
+#define OPT_CONFIG_OFF 0x81
+
 static struct util_opt opt_vec[] = {
 	{
 		.option = { "enable", no_argument, NULL, 'e'},
@@ -74,6 +78,18 @@ static struct util_opt opt_vec[] = {
 			"with the enable or disable option",
 	},
 	{
+		.option = { "config-on", no_argument, NULL, OPT_CONFIG_ON},
+		.argument = "DEVICE_IDS",
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.desc = "Set the given cryptographic card device(s) configured"
+	},
+	{
+		.option = { "config-off", no_argument, NULL, OPT_CONFIG_OFF},
+		.argument = "DEVICE_IDS",
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.desc = "Set the given cryptographic card device(s) deconfigured"
+	},
+	{
 		.option = { "poll-thread-enable", no_argument, NULL, 'p'},
 		.desc = "Enable zcrypt's poll thread",
 	},
@@ -212,6 +228,116 @@ static void default_domain_set(const cha
 	free(attr);
 }
 
+static void set_online(const char *online, const char *online_text,
+		       char *dev_list, size_t len)
+{
+	long value;
+	int id, dom;
+	char *dev, *dev_path;
+	char device[256], online_read[32];
+
+	for (dev = dev_list; dev != NULL; dev = argz_next(dev_list, len, dev)) {
+		if (strncmp(dev, "card", 4) == 0) {
+			/* dev == "card2" */
+			if (sscanf(dev, "card%02x", &id) != 1)
+				errx(EXIT_FAILURE, "Error - unable to parse '%s'.", dev);
+			sprintf(device, "card%02x", id);
+		} else if (strncmp(dev, "0x", 2) == 0) {
+			/* dev == "0x.." */
+			if (sscanf(dev, "0x%02x", &id) != 1)
+				errx(EXIT_FAILURE, "Error - unable to parse '%s'.", dev);
+			sprintf(device, "card%02x", id);
+		} else if (misc_regex_match(dev, "^[0-9a-fA-F]+$")) {
+			/* dev == "2" */
+			if (sscanf(dev, "%02x", &id) != 1)
+				errx(EXIT_FAILURE, "Error - unable to parse '%s'.", dev);
+			sprintf(device, "card%02x", id);
+		} else {
+			/* Form: 01.0003 ? */
+			if (sscanf(dev, "%02x.%04x", &id, &dom) != 2)
+				errx(EXIT_FAILURE,
+				     "Error - cryptographic device %s malformed.", dev);
+			sprintf(device, "card%02x/%02x.%04x", id, id, dom);
+		}
+		dev_path = util_path_sysfs("bus/ap/devices/%s", device);
+		if (!util_path_is_dir(dev_path))
+			errx(EXIT_FAILURE,
+			     "Error - cryptographic device %s does not exist.", device);
+		if (!util_path_is_writable("%s/online", dev_path))
+			errx(EXIT_FAILURE, "Error - can't write to %s/online.\n"
+			     " Wrong permissions or wrong tools version.", dev_path);
+		if (*online == '1' && util_path_is_readable("%s/config", dev_path)) {
+			util_file_read_l(&value, 10, "%s/config", dev_path);
+			if (value <= 0) {
+				warnx("Warning - device %s is deconfigured,"
+				      " can't set to online.\n", dev);
+				goto next;
+			}
+		}
+		verbose("Setting cryptographic device %s %s\n", device, online_text);
+		util_file_write_s(online, "%s/online", dev_path);
+		util_file_read_line(online_read, sizeof(online_read), "%s/online", dev_path);
+		if (strcmp(online, online_read) != 0)
+			errx(EXIT_FAILURE, "Error - unable to set cryptographic device %s %s.",
+			     device, online_text);
+next:
+		free(dev_path);
+	}
+}
+
+static void set_config(const char *config, const char *config_text,
+		       char *dev_list, size_t len)
+{
+	int id;
+	char *dev, *dev_path;
+	char device[256], config_read[32];
+
+	for (dev = dev_list; dev != NULL; dev = argz_next(dev_list, len, dev)) {
+		if (strncmp(dev, "card", 4) == 0) {
+			/* dev == "card2" */
+			if (sscanf(dev, "card%02x", &id) != 1)
+				errx(EXIT_FAILURE, "Error - unable to parse '%s'.", dev);
+			sprintf(device, "card%02x", id);
+		} else if (strncmp(dev, "0x", 2) == 0) {
+			/* dev == "0x.." */
+			if (sscanf(dev, "0x%02x", &id) != 1)
+				errx(EXIT_FAILURE, "Error - unable to parse '%s'.", dev);
+			sprintf(device, "card%02x", id);
+		} else if (misc_regex_match(dev, "^[0-9a-fA-F]+$")) {
+			/* dev == "2" */
+			if (sscanf(dev, "%02x", &id) != 1)
+				errx(EXIT_FAILURE, "Error - unable to parse '%s'.", dev);
+			sprintf(device, "card%02x", id);
+		} else {
+			errx(EXIT_FAILURE, "Error - invalid device %s\n"
+			     " Config on/off is only valid for card devices.", dev);
+		}
+		dev_path = util_path_sysfs("bus/ap/devices/%s", device);
+		if (!util_path_is_dir(dev_path))
+			errx(EXIT_FAILURE,
+			     "Error - cryptographic device %s does not exist.", device);
+		if (!util_path_is_readable("%s/config", dev_path))
+			errx(EXIT_FAILURE, "Error - can't read %s/config.\n"
+			     "File may not exist due to an older zcrypt device driver.", dev_path);
+		util_file_read_line(config_read, sizeof(config_read), "%s/config", dev_path);
+		if (strcmp(config, config_read) == 0) {
+			warnx("Warning - device %s is already %s.", device, config_text);
+			goto next;
+		}
+		if (!util_path_is_writable("%s/config", dev_path))
+			errx(EXIT_FAILURE, "Error - can't write to %s/config.\n"
+			     "Wrong permissions or wrong tools version.", dev_path);
+		verbose("Setting cryptographic device %s %s\n", device, config_text);
+		util_file_write_s(config, "%s/config", dev_path);
+		util_file_read_line(config_read, sizeof(config_read), "%s/config", dev_path);
+		if (strcmp(config, config_read) != 0)
+			errx(EXIT_FAILURE, "Error - unable to set cryptographic device %s %s.",
+			     device, config_text);
+next:
+		free(dev_path);
+	}
+}
+
 /*
  * Print invalid commandline error message and then exit with error code
  */
@@ -276,7 +402,6 @@ void print_adapter_id_help(void)
 	printf("  Enable the cryptographic devices with card id '03' and domain id '0005'.\n");
 	printf("  #>chzcrypt -e 03.0005\n");
 	printf("  \n");
-
 }
 
 /*
@@ -284,19 +409,19 @@ void print_adapter_id_help(void)
  */
 int main(int argc, char *argv[])
 {
-	const char *online, *online_text = NULL, *poll_thread, *config_time;
-	const char *poll_timeout, *default_domain;
-	char *path, *dev_path, *dev, *dev_list, device[256], online_read[32];
+	const char *online = NULL, *online_text = NULL, *poll_thread = NULL;
+	const char *config_time = NULL, *poll_timeout = NULL;
+	const char *default_domain = NULL, *config = NULL, *config_text = NULL;
+	char *path, *dev_list;
 	bool all = false, actionset = false;
 	size_t len;
-	int id, dom, c, i, j;
+	int c, i, j;
 
 	for (i=0; i < argc; i++)
 		for (j=2; j < (int) strlen(argv[i]); j++)
 			if (argv[i][j] == '_')
 				argv[i][j] = '-';
 
-	online = poll_thread = config_time = poll_timeout = default_domain = NULL;
 	util_prg_init(&prg);
 	util_opt_init(opt_vec, NULL);
 	while (1) {
@@ -348,6 +473,16 @@ int main(int argc, char *argv[])
 		case 'v':
 			util_prg_print_version();
 			return EXIT_SUCCESS;
+		case OPT_CONFIG_ON:
+			actionset = true;
+			config = "1";
+			config_text = "config on";
+			break;
+		case OPT_CONFIG_OFF:
+			actionset = true;
+			config = "0";
+			config_text = "config off";
+			break;
 		default:
 			util_opt_print_parse_error(c, argv);
 			return EXIT_FAILURE;
@@ -380,42 +515,13 @@ int main(int argc, char *argv[])
 	else
 		dev_list_argv(&dev_list, &len, &argv[optind]);
 
-	if (online && len == 0)
+	if ((online || config) && len == 0)
 		errx(EXIT_FAILURE, "Error - missing cryptographic device id(s).");
 
-	for (dev = dev_list; dev != NULL; dev = argz_next(dev_list, len, dev)) {
-		if (strncmp(dev, "card", 4) == 0) {
-			/* dev == "card2" */
-			sscanf(dev, "card%02x", &id);
-			sprintf(device, "card%02x", id);
-		} else if (strncmp(dev, "0x", 2) == 0) {
-			/* dev == "0x.." */
-			sscanf(dev, "0x%02x", &id);
-			sprintf(device, "card%02x", id);
-		} else if (misc_regex_match(dev, "^[0-9a-fA-F]+$")) {
-			/* dev == "2" */
-			sscanf(dev, "%02x", &id);
-			sprintf(device, "card%02x", id);
-		} else {
-			/* Form: 01.0003 ? */
-			if (sscanf(dev, "%02x.%04x", &id, &dom) != 2)
-				errx(EXIT_FAILURE, "Error - cryptographic device %s malformed.", dev);
-			sprintf(device, "card%02x/%02x.%04x", id, id, dom);
-		}
-		dev_path = util_path_sysfs("bus/ap/devices/%s", device);
-		if (!util_path_is_dir(dev_path))
-			errx(EXIT_FAILURE, "Error - cryptographic device %s does not exist.", device);
-		if (!util_path_is_writable("%s/online", dev_path))
-			errx(EXIT_FAILURE, "Error - can't write to %s/online.\n Wrong permissions"
-			     " or wrong tools version.", dev_path);
-		verbose("Setting cryptographic device %s %s\n", device, online_text);
-		util_file_write_s(online, "%s/online", dev_path);
-		util_file_read_line(online_read, sizeof(online_read), "%s/online", dev_path);
-		if (strcmp(online, online_read) != 0)
-			errx(EXIT_FAILURE, "Error - unable to set cryptographic device %s %s.",
-			     device, online_text);
-		free(dev_path);
-	}
-	free(dev_list);
+	if (online)
+		set_online(online, online_text, dev_list, len);
+	else if (config)
+		set_config(config, config_text, dev_list, len);
+
 	return EXIT_SUCCESS;
 }
diff -pruN 2.14.0-2/zconf/zcrypt/lszcrypt.8 2.15.1-0ubuntu2/zconf/zcrypt/lszcrypt.8
--- 2.14.0-2/zconf/zcrypt/lszcrypt.8	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zconf/zcrypt/lszcrypt.8	2020-10-28 14:31:59.000000000 +0000
@@ -10,7 +10,7 @@
 .\"   nroff -man lszcrypt.8
 .\" to process this source
 .\"
-.TH LSZCRYPT 8 "AUG 2019" "s390-tools"
+.TH LSZCRYPT 8 "OCT 2020" "s390-tools"
 .SH NAME
 lszcrypt \- display zcrypt device and configuration information
 .SH SYNOPSIS
@@ -111,9 +111,9 @@ Displays help text and exits.
 .TP 8
 .B -v, --version
 Displays version information and exits.
-.SH VERBOSE LISTING DETAILS
-Some of the columns showing up in verbose listing mode may need some
-explanation:
+.SH LISTING DETAILS
+Here is an explanation of the columns displayed. Please note that some
+of the columns show up in verbose mode only.
 .TP
 .B TYPE and HWTYPE
 The HWTYPE is a numeric value showing which type of hardware the zcrypt
@@ -124,6 +124,31 @@ The TYPE is a human readable value showi
 function type (A=Accelerator, C=CCA Coprocessor, P=EP11 Coprocessor). So
 for example CEX6P means a CEX6 card in EP11 Coprocessor mode.
 .TP
+.B MODE
+A crypto card can be configured to run into one of 3 modes:
+.br
+Accelerator - Acceleration of clear key RSA (CRT and ME) cryptographic
+operations.
+.br
+CCA Coprocessor - Support CCA secure key cryptographic operations.
+.br
+EP11 Coprocessor - Support EP11 secure key cryptographic operations.
+.TP
+.B STATUS
+A crypto card and/or a crypto queue may be switched offline to
+prohibit it's use. There are two levels of offline state. A software
+online/offline state is kept by the zcrypt device driver and can be
+switched on or off with the help of the chzcrypt application.
+.br
+A crypto card can also be 'configured' or 'deconfigured'. This state
+may be adjusted on the HMC or SE. The chzcrypt application can also
+trigger this state with the --config-on and --config-off options.
+.br
+lszcrypt shows 'online' when a card or queue is available for
+cryptograhic operations. 'offline' is displayed when a card or queue
+is switched to (software) offline. If a card is 'deconfigured' via
+HMC, SE or chzcrypt the field shows 'deconfig'.
+.TP
 .B REQUESTS
 This is the counter value of successful processed requests on card or queue
 level. Successful here means the request was processed without any failure
diff -pruN 2.14.0-2/zconf/zcrypt/lszcrypt.c 2.15.1-0ubuntu2/zconf/zcrypt/lszcrypt.c
--- 2.14.0-2/zconf/zcrypt/lszcrypt.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zconf/zcrypt/lszcrypt.c	2020-10-28 14:31:59.000000000 +0000
@@ -1,7 +1,7 @@
 /**
  * lszcrypt - Display zcrypt devices and configuration settings
  *
- * Copyright IBM Corp. 2008, 2019
+ * Copyright IBM Corp. 2008, 2020
  *
  * s390-tools is free software; you can redistribute it and/or modify
  * it under the terms of the MIT license. See LICENSE for details.
@@ -86,7 +86,7 @@ const struct util_prg prg = {
 		{
 			.owner = "IBM Corp.",
 			.pub_first = 2008,
-			.pub_last = 2019,
+			.pub_last = 2020,
 		},
 		UTIL_PRG_COPYRIGHT_END
 	}
@@ -339,6 +339,7 @@ static void show_capability(const char *
 static void read_subdev_rec_default(struct util_rec *rec, const char *grp_dev,
 				    const char *sub_dev)
 {
+	long value;
 	char buf[256];
 	unsigned long facility;
 
@@ -347,14 +348,25 @@ static void read_subdev_rec_default(stru
 	else
 		util_rec_set(rec, "type", buf);
 
-	if (util_file_read_line(buf, sizeof(buf), "%s/%s/online",
-				grp_dev, sub_dev))
-		util_rec_set(rec, "online", "-");
-	else
-		if (strcmp(buf, "0") == 0)
-			util_rec_set(rec, "online", "offline");
-		else
+	if (util_path_is_readable("%s/%s/online", grp_dev, sub_dev)) {
+		util_file_read_l(&value, 10, "%s/%s/online", grp_dev, sub_dev);
+		if (value > 0)
 			util_rec_set(rec, "online", "online");
+		else {
+			/* device is offline, check config (if available) */
+			if (util_path_is_readable("%s/%s/config", grp_dev, sub_dev)) {
+				util_file_read_l(&value, 10, "%s/%s/config", grp_dev, sub_dev);
+				if (value > 0)
+					util_rec_set(rec, "online", "offline");
+				else
+					util_rec_set(rec, "online", "deconfig");
+			} else
+				util_rec_set(rec, "online", "offline");
+		}
+	} else {
+		/* no online attribute */
+		util_rec_set(rec, "online", "-");
+	}
 
 	util_file_read_ul(&facility, 16, "%s/ap_functions", grp_dev);
 	if (facility & MASK_COPRO)
@@ -457,6 +469,7 @@ static void show_subdevices(struct util_
  */
 static void read_rec_default(struct util_rec *rec, const char *grp_dev)
 {
+	long value;
 	char buf[256];
 	unsigned long facility;
 
@@ -475,13 +488,21 @@ static void read_rec_default(struct util
 	else
 		util_rec_set(rec, "mode", "Unknown");
 
-	if (util_file_read_line(buf, sizeof(buf), "%s/online", grp_dev))
-		util_rec_set(rec, "online", "-");
-	else
-		if (strcmp(buf, "0") == 0)
-			util_rec_set(rec, "online", "offline");
-		else
+	if (util_path_is_readable("%s/online", grp_dev)) {
+		util_file_read_l(&value, 10, "%s/online", grp_dev);
+		if (value > 0)
 			util_rec_set(rec, "online", "online");
+		else {
+			if (util_path_is_readable("%s/config", grp_dev)) {
+				util_file_read_l(&value, 10, "%s/config", grp_dev);
+				if (value > 0)
+					util_rec_set(rec, "online", "offline");
+				else
+					util_rec_set(rec, "online", "deconfig");
+			} else
+				util_rec_set(rec, "online", "offline");
+		}
+	}
 
 	util_file_read_line(buf, sizeof(buf), "%s/request_count", grp_dev);
 	util_rec_set(rec, "requests", buf);
@@ -567,7 +588,7 @@ static void define_rec_default(struct ut
 	util_rec_def(rec, "card", UTIL_REC_ALIGN_LEFT, 11, "CARD.DOMAIN");
 	util_rec_def(rec, "type", UTIL_REC_ALIGN_LEFT, 5, "TYPE");
 	util_rec_def(rec, "mode", UTIL_REC_ALIGN_LEFT, 11, "MODE");
-	util_rec_def(rec, "online", UTIL_REC_ALIGN_LEFT, 7, "STATUS");
+	util_rec_def(rec, "online", UTIL_REC_ALIGN_LEFT, 8, "STATUS");
 	util_rec_def(rec, "requests", UTIL_REC_ALIGN_RIGHT, 8, "REQUESTS");
 }
 
diff -pruN 2.14.0-2/zdump/dfi_s390mv.c 2.15.1-0ubuntu2/zdump/dfi_s390mv.c
--- 2.14.0-2/zdump/dfi_s390mv.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zdump/dfi_s390mv.c	2020-10-28 14:31:59.000000000 +0000
@@ -21,6 +21,7 @@
 #include <time.h>
 #include <unistd.h>
 
+#include "lib/util_file.h"
 #include "lib/util_path.h"
 
 #include "zgetdump.h"
@@ -98,6 +99,24 @@ static void em_init(struct vol *vol)
 		l.dump_incomplete = 1;
 }
 
+/*
+ * Check whether a device with a given busid is online
+ */
+static unsigned int dev_is_online(const char *busid)
+{
+	unsigned int online;
+	char *path;
+
+	path = util_path_sysfs("%s/%s/online", SYSFS_BUSDIR, busid);
+	if (util_file_read_ui(&online, 10, path) != 0) {
+		warnx("Could not open \"%s\" (%s)", path, strerror(errno));
+		free(path);
+		exit(EXIT_FAILURE);
+	}
+	free(path);
+
+	return online;
+}
 
 /*
  * Check sysfs, whether a device specified by its bus ID is defined and online.
@@ -106,67 +125,40 @@ static void em_init(struct vol *vol)
 static enum dev_status dev_from_busid(char *bus_id, dev_t *dev)
 {
 	struct dirent *direntp;
-	int fh, minor, major;
+	int minor, major;
 	char buf[10];
 	DIR *fh_dir;
 	char *sysfs;
 
 	sysfs = util_path_sysfs("%s/%s", SYSFS_BUSDIR, bus_id);
-	fh_dir = opendir(sysfs);
-	free(sysfs);
-	if (!fh_dir)
+	if (!util_path_is_dir(sysfs)) {
+		free(sysfs);
 		return DEV_UNDEFINED;
-
-	sysfs = util_path_sysfs("%s/%s/online", SYSFS_BUSDIR, bus_id);
-	fh = open(sysfs, O_RDONLY);
-	if (fh == -1) {
-		warnx("Could not open \"%s\" (%s)", sysfs, strerror(errno));
-		goto err;
 	}
 	free(sysfs);
-	if (read(fh, buf, 1) == -1)
-		ERR_EXIT_ERRNO("Could not read online attribute");
-	close(fh);
 
-	if (buf[0] != '1')
+	if (!dev_is_online(bus_id))
 		return DEV_OFFLINE;
 
+	sysfs = util_path_sysfs("%s/%s/block", SYSFS_BUSDIR, bus_id);
+	fh_dir = opendir(sysfs);
+	if (!fh_dir) {
+		warnx("Could not open \"%s\" (%s) ", sysfs, strerror(errno));
+		goto err;
+	}
 	while ((direntp = readdir(fh_dir)))
-		if (strncmp(direntp->d_name, "block:", 6) == 0)
+		if (strncmp(direntp->d_name, "dasd", 4) == 0)
 			break;
-	closedir(fh_dir);
-
 	if (direntp == NULL) {
-		sysfs = util_path_sysfs("%s/%s/block", SYSFS_BUSDIR, bus_id);
-		fh_dir = opendir(sysfs);
-		if (!fh_dir) {
-			warnx("Could not open \"%s\" (%s) ",
-			      sysfs, strerror(errno));
-			goto err;
-		}
-		while ((direntp = readdir(fh_dir)))
-			if (strncmp(direntp->d_name, "dasd", 4) == 0)
-				break;
-		closedir(fh_dir);
-		if (direntp == NULL) {
-			warnx("Problem with contents of \"%s\"", sysfs);
-			goto err;
-		}
-		free(sysfs);
-	}
-
-	sysfs = util_path_sysfs("%s/%s/%s/dev",
-				SYSFS_BUSDIR, bus_id, direntp->d_name);
-	fh = open(sysfs, O_RDONLY);
-	if (fh == -1) {
-		warnx("Could not open \"%s\" (%s)", sysfs, strerror(errno));
+		warnx("Problem with contents of \"%s\"", sysfs);
 		goto err;
 	}
-	if (read(fh, buf, sizeof(buf)) == -1) {
+	if (util_file_read_line(buf, sizeof(buf), "%s/%s/dev", sysfs, direntp->d_name)) {
 		warnx("Could not read dev file (%s)", strerror(errno));
 		goto err;
 	}
-	close(fh);
+	closedir(fh_dir);
+
 	if (sscanf(buf, "%i:%i", &major, &minor) != 2) {
 		warnx("Malformed content of \"%s\": %s", sysfs, buf);
 		goto err;
@@ -178,6 +170,8 @@ static enum dev_status dev_from_busid(ch
 	return DEV_ONLINE;
 
 err:
+	if (fh_dir)
+		closedir(fh_dir);
 	free(sysfs);
 	exit(EXIT_FAILURE);
 }
diff -pruN 2.14.0-2/zfcpdump/README.part 2.15.1-0ubuntu2/zfcpdump/README.part
--- 2.14.0-2/zfcpdump/README.part	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zfcpdump/README.part	2020-10-28 14:31:59.000000000 +0000
@@ -31,7 +31,7 @@ configuration.
  * Issue "make bzImage" to build the zfcpdump kernel image.
 
 In a Linux distribution the zfcpdump enabled kernel image must be copied to
-/lib/s390-tools/zfcpdump/zfcpdump_part.image, where the s390 zipl tool is
+/lib/s390-tools/zfcpdump/zfcpdump-image, where the s390 zipl tool is
 looking for the dump kernel when preparing a SCSI dump disk.
 
 Create and install initrd
diff -pruN 2.14.0-2/ziomon/ziorep_printers.cpp 2.15.1-0ubuntu2/ziomon/ziorep_printers.cpp
--- 2.14.0-2/ziomon/ziorep_printers.cpp	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/ziomon/ziorep_printers.cpp	2020-10-28 14:31:59.000000000 +0000
@@ -420,7 +420,7 @@ void VirtAdapterPrinter::print_virt_adpt
 					int *rc)
 {
 	if (m_csv)
-		fprintf(fp, "%x,%x.%x.%04x,",
+		fprintf(fp, "%x,%x.%x.%04x",
 			       m_cfg->get_chpid_by_devno(devno, rc),
 			       ZIOREP_BUSID_UNPACKED(devno));
 	else
@@ -517,7 +517,7 @@ void VirtAdapterPrinter::print_num_reque
 void VirtAdapterPrinter::print_topline(FILE *fp)
 {
 	if (m_csv)
-		fprintf(fp, "timestamp,aggregated,CHPID,Bus-ID,qdio utilization max %%,qdio utilization avg %%,queue full,fail erc,throughput read / MS/s,throughput write / MS/s,I/O requests read,I/O requqests write\n");
+		fprintf(fp, "timestamp,aggregated,CHPID,Bus-ID,qdio utilization max %%,qdio utilization avg %%,queue full,fail erc,throughput read / MS/s,throughput write / MS/s,I/O requests read,I/O requests write\n");
 	else {
 		fprintf(fp, "CHP Bus-ID  |qdio util.%%|queu|fail|-thp in MB/s-|I/O reqs-|\n");
 		fprintf(fp, " ID            max   avg full  erc     rd    wrt   rd  wrt\n");
diff -pruN 2.14.0-2/zipl/boot/Makefile 2.15.1-0ubuntu2/zipl/boot/Makefile
--- 2.14.0-2/zipl/boot/Makefile	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zipl/boot/Makefile	2020-10-28 14:31:59.000000000 +0000
@@ -7,7 +7,7 @@ INCLUDE_PARMS := $(addprefix -I,$(INCLUD
 ALL_CFLAGS = $(NO_PIE_CFLAGS) -Os -g $(INCLUDE_PARMS) \
 	  -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
 	  -fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
-	  -fno-delete-null-pointer-checks \
+	  -fno-delete-null-pointer-checks -fno-stack-protector \
 	  -fexec-charset=IBM1047 -m64 -mpacked-stack \
 	  -mstack-size=4096 -mstack-guard=128 -msoft-float \
 	  -W -Wall -Wformat-security
diff -pruN 2.14.0-2/zipl/src/disk.c 2.15.1-0ubuntu2/zipl/src/disk.c
--- 2.14.0-2/zipl/src/disk.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zipl/src/disk.c	2020-10-28 14:31:59.000000000 +0000
@@ -25,6 +25,7 @@
 #include <linux/fiemap.h>
 
 #include "lib/util_proc.h"
+#include "lib/util_sys.h"
 
 #include "disk.h"
 #include "error.h"
@@ -89,88 +90,6 @@ disk_determine_dasd_type(struct disk_inf
 	return 0;
 }
 
-static int blkext_get_partnum(dev_t dev)
-{
-	char path[PATH_MAX], *buf;
-	int dev_major, dev_minor, partnum = -1;
-
-	dev_major = major(dev);
-	dev_minor = minor(dev);
-	snprintf(path, PATH_MAX, "/sys/dev/block/%d:%d/partition",
-		dev_major, dev_minor);
-
-	if (misc_read_special_file(path, &buf, NULL, 1)) {
-		error_text("Could not read from path '%s'", path);
-		return -1;
-	}
-
-	partnum = atoi(buf);
-	free(buf);
-	if (partnum < 0) {
-		error_text("Bad partition number in '%s'", path);
-		return -1;
-	}
-
-	return partnum;
-}
-
-static int blkext_is_base_device(dev_t dev)
-{
-	int dev_major, dev_minor;
-	char path[PATH_MAX];
-	struct stat stats;
-
-	dev_major = major(dev);
-	dev_minor = minor(dev);
-
-	snprintf(path, PATH_MAX, "/sys/dev/block/%d:%d/partition",
-		dev_major, dev_minor);
-	return (stat(path, &stats));
-}
-
-static int blkext_get_base_dev(dev_t dev, dev_t *base_dev)
-{
-	int base_major, base_minor;
-	char dev_path[PATH_MAX], base_path[PATH_MAX];
-	char *temp_path, *buf;
-
-	misc_asprintf(&temp_path, "/sys/dev/block/%d:%d", major(dev), minor(dev));
-	if (!realpath(temp_path, dev_path)) {
-		error_reason(strerror(errno));
-		error_text("Could not resolve link %s", temp_path);
-		free(temp_path);
-		return -1;
-	}
-	free(temp_path);
-
-	misc_asprintf(&temp_path, "%s/..", dev_path);
-	if (!realpath(temp_path, base_path)) {
-		error_reason(strerror(errno));
-		error_text("Could not resolve path %s", temp_path);
-		free(temp_path);
-		return -1;
-	}
-	free(temp_path);
-
-	misc_asprintf(&temp_path, "%s/dev", base_path);
-	if (misc_read_special_file(temp_path, &buf, NULL, 1)) {
-		error_text("Could not read from path '%s'", temp_path);
-		free(temp_path);
-		return -1;
-	}
-	free(temp_path);
-
-	if (sscanf(buf, "%i:%i", &base_major, &base_minor) != 2) {
-		error_text("Could not parse major:minor from string '%s'", buf);
-		free(buf);
-		return -1;
-	}
-
-	free(buf);
-	*base_dev = makedev(base_major, base_minor);
-	return 0;
-}
-
 /* Return non-zero for ECKD type. */
 int
 disk_is_eckd(disk_type_t type)
@@ -492,15 +411,15 @@ disk_get_info(const char* device, struct
 		data->devno = -1;
 		data->type = disk_type_scsi;
 
-		if (blkext_is_base_device(stats.st_rdev)) {
-			data->device = stats.st_rdev;
-			data->partnum = 0;
-		} else {
-			if (blkext_get_base_dev(stats.st_rdev, &data->device))
+		if (util_sys_dev_is_partition(stats.st_rdev)) {
+			if (util_sys_get_base_dev(stats.st_rdev, &data->device))
 				goto out_close;
-			data->partnum = blkext_get_partnum(stats.st_rdev);
+			data->partnum = util_sys_get_partnum(stats.st_rdev);
 			if (data->partnum == -1)
 				goto out_close;
+		} else {
+			data->device = stats.st_rdev;
+			data->partnum = 0;
 		}
 	} else {
 		/* Driver name is unknown */
diff -pruN 2.14.0-2/zipl/src/scan.c 2.15.1-0ubuntu2/zipl/src/scan.c
--- 2.14.0-2/zipl/src/scan.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zipl/src/scan.c	2020-10-28 14:31:59.000000000 +0000
@@ -21,6 +21,7 @@
 #define _GNU_SOURCE
 #endif
 
+#include <assert.h>
 #include <ctype.h>
 #include <dirent.h>
 #include <errno.h>
@@ -28,6 +29,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <stdbool.h>
 
 #include <sys/stat.h>
 
@@ -730,6 +732,67 @@ scan_bls_field(struct misc_file_buffer *
 	return 0;
 }
 
+/**
+ * find a line with keyword "title" and move it to the top
+ */
+static int sort_bls_fields(struct misc_file_buffer *file, char *filename)
+{
+	bool is_title = false;
+	size_t title_len = 0;
+	int nr_titles = 0;
+	size_t title_off;
+	char *title;
+	int current;
+	size_t len;
+
+	while (file->length - file->pos > 4 /* for "title" */) {
+		if (strncmp("title", &file->buffer[file->pos], 5) == 0) {
+			is_title = true;
+			nr_titles++;
+			title_off = file->pos;
+		}
+		for (len = 0;; file->pos++, len++) {
+			current = misc_get_char(file, 0);
+			if (current == '\n' || current == EOF)
+				break;
+		}
+		if (is_title == true)
+			title_len = len;
+		if (current == EOF)
+			break;
+		file->pos++;
+	}
+	file->pos = 0;
+
+	if (nr_titles == 0) {
+		error_reason("no title in %s", filename);
+		return -1;
+	}
+	if (nr_titles > 1) {
+		error_reason("more than one title in %s", filename);
+		return -1;
+	}
+	if (title_off == 0)
+		return 0;
+
+	title = misc_malloc(title_len);
+	if (!title)
+		return -1;
+	/*
+	 * copy the title field w/o trailing '\n' to the temporary buffer
+	 */
+	memcpy(title, &file->buffer[title_off], title_len);
+	/*
+	 * shift preceded memory region w/o trailing '\n' to the right
+	 */
+	assert(file->buffer[title_off - 1] == '\n');
+	memmove(&file->buffer[title_len + 1], &file->buffer[0], title_off - 1);
+	file->buffer[title_len] = '\n';
+	memcpy(&file->buffer[0], title, title_len);
+
+	free(title);
+	return 0;
+}
 
 int
 scan_bls(const char* blsdir, struct scan_token** token, int scan_size)
@@ -780,6 +843,10 @@ scan_bls(const char* blsdir, struct scan
 		if (rc)
 			goto err;
 
+		rc = sort_bls_fields(&file, filename);
+		if (rc)
+			goto err;
+
 		while ((size_t)file.pos < file.length) {
 			current = misc_get_char(&file, 0);
 			switch (current) {
diff -pruN 2.14.0-2/zkey/cca.c 2.15.1-0ubuntu2/zkey/cca.c
--- 2.14.0-2/zkey/cca.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/cca.c	2020-10-28 14:31:59.000000000 +0000
@@ -554,7 +554,8 @@ static int get_cca_adapter_version(struc
  *          because the zcrypt kernel module is on an older level. -ENODEV is
  *          returned if the APQN is not available.
  */
-int select_cca_adapter(struct cca_lib *cca, int card, int domain, bool verbose)
+int select_cca_adapter(struct cca_lib *cca, unsigned int card,
+		       unsigned int domain, bool verbose)
 {
 	unsigned int adapters, adapter;
 	char adapter_serialnr[9];
@@ -633,12 +634,12 @@ struct find_mkvp_info {
 	u8		mkvp[MKVP_LENGTH];
 	unsigned int	flags;
 	bool		found;
-	int		card;
-	int		domain;
+	unsigned int	card;
+	unsigned int	domain;
 	bool		verbose;
 };
 
-static int find_mkvp(int card, int domain, void *handler_data)
+static int find_mkvp(unsigned int card, unsigned int domain, void *handler_data)
 {
 	struct find_mkvp_info *info = (struct find_mkvp_info *)handler_data;
 	struct mk_info mk_info;
@@ -711,7 +712,7 @@ int select_cca_adapter_by_mkvp(struct cc
 
 	pr_verbose(verbose, "Select mkvp %s in APQNs %s for the CCA host "
 		   "library", printable_mkvp(CARD_TYPE_CCA, mkvp),
-		   apqns == 0 ? "ANY" : apqns);
+		   apqns == NULL ? "ANY" : apqns);
 
 	memcpy(info.mkvp, mkvp, sizeof(info.mkvp));
 	info.flags = flags;
diff -pruN 2.14.0-2/zkey/cca.h 2.15.1-0ubuntu2/zkey/cca.h
--- 2.14.0-2/zkey/cca.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/cca.h	2020-10-28 14:31:59.000000000 +0000
@@ -123,7 +123,8 @@ int key_token_change(struct cca_lib *cca
 		     u8 *secure_key, unsigned int secure_key_size,
 		     char *method, bool verbose);
 
-int select_cca_adapter(struct cca_lib *cca, int card, int domain, bool verbose);
+int select_cca_adapter(struct cca_lib *cca, unsigned int card,
+		       unsigned int domain, bool verbose);
 
 #define FLAG_SEL_CCA_MATCH_CUR_MKVP	0x01
 #define FLAG_SEL_CCA_MATCH_OLD_MKVP	0x02
diff -pruN 2.14.0-2/zkey/ekmfweb/Makefile 2.15.1-0ubuntu2/zkey/ekmfweb/Makefile
--- 2.14.0-2/zkey/ekmfweb/Makefile	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/ekmfweb/Makefile	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,56 @@
+include ../../common.mak
+
+VERSION = 1.0
+VERM = $(shell echo $(VERSION) | cut -d '.' -f 1)
+
+all: zkey-ekmfweb.so
+
+libs = $(rootdir)/libutil/libutil.a
+
+export LIBRARY_PATH = $(rootdir)/libekmfweb:$LIBRARY_PATH
+
+zkey-ekmfweb.o: zkey-ekmfweb.c zkey-ekmfweb.h ../kms-plugin.h \
+	../cca.h ../utils.h ../pkey.h ../properties.h \
+	$(rootdir)include/ekmfweb/ekmfweb.h libekmfweb.dep
+
+properties.o: ../properties.c ../properties.h
+	$(CC) $(ALL_CPPFLAGS) $(ALL_CFLAGS) -fPIC -c $< -o $@
+
+pkey.o: ../pkey.c ../pkey.h ../cca.h ../ep11.h ../utils.h
+	$(CC) $(ALL_CPPFLAGS) $(ALL_CFLAGS) -fPIC -c $< -o $@
+
+cca.o: ../cca.c ../cca.h ../pkey.h ../ep11.h ../utils.h
+	$(CC) $(ALL_CPPFLAGS) $(ALL_CFLAGS) -fPIC -c $< -o $@
+
+ep11.o: ../ep11.c ../ep11.h ../pkey.h ../cca.h ../utils.h
+	$(CC) $(ALL_CPPFLAGS) $(ALL_CFLAGS) -fPIC -c $< -o $@
+
+utils.o: ../utils.c ../utils.h ../pkey.h ../cca.h ../ep11.h
+	$(CC) $(ALL_CPPFLAGS) $(ALL_CFLAGS) -fPIC -c $< -o $@
+
+zkey-ekmfweb.so: ALL_CFLAGS += -fPIC
+zkey-ekmfweb.so: LDLIBS = -lekmfweb -ldl -lcrypto
+zkey-ekmfweb.so: ALL_LDFLAGS += -shared -Wl,--version-script=zkey-ekmfweb.map \
+	-Wl,-z,defs,-Bsymbolic -Wl,-soname,zkey-ekmfweb.so.$(VERM)
+zkey-ekmfweb.so: zkey-ekmfweb.o properties.o pkey.o cca.o ep11.o utils.o $(libs)
+	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
+
+install-libekmfweb.dep:
+	$(MAKE) -C $(rootdir)/libekmfweb/ TOPDIR=$(TOPDIR) ARCH=$(ARCH) install
+	touch install-libekmfweb.dep
+
+libekmfweb.dep:
+	$(MAKE) -C $(rootdir)/libekmfweb/ TOPDIR=$(TOPDIR) ARCH=$(ARCH) all
+	touch libekmfweb.dep
+
+install: all install-libekmfweb.dep zkey-ekmfweb.so
+	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
+	$(INSTALL) -m 644 -c zkey-ekmfweb.1 $(DESTDIR)$(MANDIR)/man1
+	$(INSTALL) -d -m 755 $(DESTDIR)$(USRLIB64DIR)
+	$(INSTALL) -d -m 755 $(DESTDIR)$(USRLIB64DIR)/zkey
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T zkey-ekmfweb.so $(DESTDIR)$(USRLIB64DIR)/zkey/zkey-ekmfweb.so
+
+clean:
+	rm -f *.o zkey-ekmfweb.so install-libekmfweb.dep libekmfweb.dep
+
+.PHONY: all install clean
\ No newline at end of file
diff -pruN 2.14.0-2/zkey/ekmfweb/zkey-ekmfweb.1 2.15.1-0ubuntu2/zkey/ekmfweb/zkey-ekmfweb.1
--- 2.14.0-2/zkey/ekmfweb/zkey-ekmfweb.1	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/ekmfweb/zkey-ekmfweb.1	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,497 @@
+.\" Copyright IBM Corp. 2020
+.\" s390-tools is free software; you can redistribute it and/or modify
+.\" it under the terms of the MIT license. See LICENSE for details.
+.\"
+.TH ZKEY\-EKMFWEB 1 "July 2020" "s390-tools"
+.SH NAME
+zkey\-ekmfweb \- Key management system plugin for EKMF Web (IBM Enterprise Key
+Management Foundation \- Web Edition)
+.
+.
+.
+.SH DESCRIPTION
+The \fBzkey\-ekmfweb.so\fP library is a key management system plugin for
+\fBzkey\fP and provides an interface to \fBEKMF Web\fP (IBM Enterprise Key
+Management Foundation \- Web Edition). It allows to integrate the external key
+management system EKMF Web into zkey.
+.PP
+Secure AES keys can be generated in EKMF Web and are then imported into the zkey
+secure key repository. The keys can be used to encrypt volumes, the same way
+as with secure AES keys generated by zkey locally.
+.PP
+EKMF Web supports secure keys of type \fBCCA\-AESCIPHER\fP, and requires one or
+multiple \fBIBM cryptographic adapters in CCA coprocessor mode\fP of version 6
+or later, e.g. a CEX6C.
+.
+.SS "Bind the zkey secure key repository to EKMF Web"
+.
+To use EKMF Web with zkey, the zkey secure key repository must first be bound to
+the EKMF Web key management system plugin.
+.PP
+Use the \fBzkey kms plugins\fP command to list available key management system
+plugins. The EKMF Web plugin appears as plugin \fBEKMFWeb\fP in the list of
+available plugins. If it does not appear, check if it is configured properly in
+configuration file \fB/etc/zkey/kms\-plugins.conf\fP. Refer to the \fBzkey\fP
+man page for details about this configuration file.
+.PP
+Use the \fBzkey kms bind EKMFWeb\fP command to bind the EKMF Web key management
+system plugin to the zkey repository. You must then configure the EKMF Web
+plugin with command \fBzkey kms configure\fP before it can be used.
+.
+.SS "Display information about the EKMF Web key management system plugin"
+.
+Use the \fBzkey kms info\fP command to display information about the EKMF Web
+key management system plugin and its configuration. If any of the settings are
+displayed as \fB'(configuration required)'\fP, then you must configure these
+settings before you can use the EKMF Web plugin. Use the \fBzkey kms
+configure\fP to do so.
+.
+.SS "Configure the EKMF Web key management system plugin"
+.
+Use the \fBzkey kms configure\fP command to configure or re\-configure the
+EKMF Web plugin. Use command \fBzkey kms configure \-\-help\fP to display the
+possible command line options to perform the configuration.
+.PP
+Configuring the EKMF Web plugin may be a multi-step task. You can supply all
+configuration options at once or use the \fBzkey kms configure\fP command
+several times supplying only one or a few configuration options each time.
+.PP
+The following settings must be configured:
+.RS 2
+.IP "\(bu" 2
+The \fBAPQNs\fP associated with the EKMF Web key management system plugin. These
+APQNs are used by the EKMF Web plugin to generate internally used secure keys
+(i.e. the identity key), as well as to import secure AES keys from EKMF Web into
+the zkey repository, enciphered with the current CCA master key. Secure keys
+imported from EKMF Web will automatically be associated with the APQNs
+associated with the EKMF Web plugin. Use the \fB\-\-apqns\fP option to specify
+the APQNs to associate with the EKMF Web plugin.
+.
+.IP "\(bu" 2
+The \fBconnection to the EKMF Web server\fP. The EKMF Web plugin communicates
+with EKMF Web via RESTful web services over HTTPS (Hypertext Transfer Protocol
+Secure). Use option \fB\-\-ekmfweb\-url\fP to specify the URL of the EKMF Web
+server. The URL should start with \fB'https://'\fP, and may contain a port
+number separated by a colon. If no port number is specified, 443 is used for
+HTTPS. Additional TLS (Transport Layer Security) specific options can be
+specified to control the behavior of the TLS protocol and the validation of the
+EKMF Web server's certificate. Use command \fBzkey kms configure \-\-help\fP to
+display the possible command line options.
+.
+.IP "\(bu" 2
+The \fBEKMF Web settings\fP, such as the EKMF Web server's public key and the
+key templates used by EKMF Web to generate keys. These settings are
+automatically retrieved from EKMF Web, once the connection to the EKMF Web
+server has been configured. Use option \fB\-\-refresh\-settings\fP to refresh
+the settings, when they have changed in EKMF Web.
+.
+.IP "\(bu" 2
+The secure \fBidentity key\fP used to identify the zkey client with EKMF Web,
+and to cryptographically sign requests sent to EKMF Web. The identity key
+is a secure key, and is automatically generated once the connection to the
+EKMF Web server has been configured. Use option \fB\-\-gen\-identity\-key\fP to
+re-generate the identity key, if needed. You must re-generate a
+registration certificate with the newly generated identity key and re-register
+this zkey client with the EKMF Web server.
+.
+.IP "\(bu" 2
+The \fBregistration certificate\fP to register the zkey client with EKMF Web.
+The registration certificate is an X.509 certificate generated with the secure
+identity key. Use option \fB\-\-gen\-csr\fP to generate a \fBcertificate signing
+request\fP (CSR) with the identity key. You pass this CSR to a certificate
+authority (CA) to have it issue a CA signed certificate for the EKMF Web
+plugin. Alternatively, use option \fB\-\-gen\-self\-signed\-cert\fP to generate
+a \fBself signed certificate\fP with the identity key for the EKMF Web plugin.
+Use options \fB\-\-cert\-subject\fP and \fB\-\-cert\-extensions\fP to specify
+the certificate subject name and extensions (if any). To renew an existing
+certificate, use option \fB\-\-renew\-cert\fP. The subject name and extensions
+are then read from the certificate that is to be renewed.
+.
+.IP "\(bu" 2
+\fBRegister\fP the zkey client with EKMF Web. Use option \fB\-\-register\fP to
+register the zkey client using the \fBregistration certificate\fP from the
+previous step. An identity key is generated in EKMF Web using the public
+key from the certificate. You may also need to use option
+\fB\-\-label\-tags\fP to specify the label tags for creating the identity key
+in EKMF Web. Use command \fBzkey kms info\fP to find out which label tags the
+identity key template uses.
+.RE
+.
+.SS "Re-encipher the secure identity key"
+.
+Use the \fBzkey kms reencipher\fP command to re-encipher the secure identity
+key of the EKMF Web plugin with a new master key.
+The secure identity key must be re-enciphered when the \fBAPKA master key\fP
+of the CCA cryptographic adapter changes.
+.PP
+See the man page of \fBzkey\fP for a description of the the \fBzkey kms
+reencipher\fP command.
+.PP
+\fBNote:\fP The \fBzkey kms reencipher\fP command does \fBnot\fP re-encipher
+secure keys that have been generated by or have been imported from EKMF Web and
+are now stored in the secure key repository. Use the regular \fBzkey
+reencipher\fP command to re-encipher those secure keys.
+.
+.SS "Generating secure AES keys with EKMF Web"
+.
+Use the \fBzkey generate\fP command to generate secure AES keys in EKMF Web and
+import the newly generated key into the secure key repository. When the zkey
+repository is bound to the EKMF Web plugin, then the \fBzkey generate\fP command
+always generates the keys in EKMF Web, except when the \fB\-\-local\fP
+option is specified.
+.PP
+Keys generated in EKMF Web are always of type \fBCCA\-AESCIPHER\fP. The
+cryptographic size of the keys depend on the underlying EKMF Web template.
+Use \fBzkey kms info\fP to display the names of the key templates configured.
+If option \fB\-\-key\-bits\fP is specified, it must match the key size in the
+template.
+.PP
+You may need to use option \fB\-\-label\-tags\fP to specify the label tags
+for creating keys in EKMF Web. Use command \fBzkey kms info\fP to find out
+which label tags the configured key template uses.
+.PP
+Keys generated with EKMF Web are bound to EKMF Web, and also inherit the APQN
+association from the EKMF Web plugin. You cannot associate different APQNs to
+a key that is bound to EKMF Web. Other additional information can be associated
+with a secure key as usual, using the \fB\-\-description\fP, \fB\-\-volumes\fP,
+\fB\-\-volume\-type\fP, or the \fB\-\-sector\-size\fP options. This associated
+information is also stored in EKMF Web with the key.
+.
+.SS "Remove secure keys bound to EKMF Web from the key repository"
+.
+Use the \fBzkey remove\fP command to remove an existing secure key from the
+secure key repository. If the key is bound to EKMF Web, then you can also
+change the state of the key in EKMF Web, while removing it. Use option
+\fB\-\-state\fP to specify the new state of the key in EKMF Web. If no state is
+specified, the key remains unchanged in EKMF Web, but is removed from the local
+secure key repository only.
+.
+.SS "Change secure keys bound to EKMF Web"
+.
+Use the \fBzkey change\fP command to change the description, the associated
+volumes, the sector size, and the volume type of a secure key contained in the
+secure key repository. If the key is bound to EKMF Web, then the changed
+information is also updated for the key in EKMF Web.
+.PP
+You cannot change the associated cryptographic adapters (APQNs) of a key that
+is bound to EKMF Web, because it inherits the APQN association from the EKMF
+Web plugin. To change the APQNs associated with the EKMF Web plugin, use the
+\fBzkey kms configure\fP command with the \fB--apqns\fP option. This also
+changes the APQN associations of all secure keys in the secure key repository,
+that are bound to the EKMF Web plugin.
+.
+.SS "Rename secure keys bound to EKMF Web"
+.
+Use the \fBzkey rename\fP command to rename an existing secure key in the
+secure key repository. If the key is bound to EKMF Web, then the new name
+is also updated for the key in EKMF Web. Note that the key label as it
+is known in EKMF Web cannot be changed. Only the associated zkey name is
+updated.
+.
+.SS "List secure keys managed by EKMF Web"
+.
+Use the \fBzkey kms list\fP command to display eligible secure keys managed by
+EKMF Web. You can filter the displayed list by key label, key name, associated
+volumes, and volume type. Refer to the man page of \fBzkey\fP for the details
+on these filter options.
+.PP
+Use option \fB\-\-states\fP to filter the list by the key state in EKMF Web.
+You can specify multiple states, separated by comma. If this option is omitted,
+then only keys in \fBACTIVE\fP state are displayed.
+.PP
+By default, only keys are displayed, which this zkey client is allowed to use.
+Only keys where the export control options include the identity key of this zkey
+client as allowed exporting key can be used by this zkey client.
+Specify option \fB\-\-all\fP to also list keys that this zkey client is
+not allowed to use. The EKMF Web operator can change the export control options
+of a key to allow a certain zkey identity key to export the key.
+.
+.SS "Import secure keys managed by EKMF Web into the repository"
+.
+Use the \fBzkey kms import\fP command to import secure keys managed by EKMF Web
+into the secure key repository. You can filter the list of keys to be imported
+by key label, key name, associated volumes, and volume type. Refer to the man
+page of \fBzkey\fP for the details on these filter options.
+.PP
+Only keys are imported, which this zkey client is allowed to use. Only keys
+where the export control options include the identity key of this zkey
+client as allowed exporting key can be used by this zkey client. The EKMF Web
+operator can change the export control options of a key, to allow a certain
+zkey identity key to export the key.
+.
+.SS "Refresh secure keys bound to EKMF Web"
+.
+Use the \fBzkey kms refresh\fP command to refresh secure keys that are bound to
+EKMF Web. You can filter the list of keys to be refreshed by name, associated
+volumes, volume type, and key type. Refreshing a key updates the secure key by
+re-importing it from EKMF Web. Use option \fB\-\-refresh\-properties\fP to also
+update the associated information, such as the textual description, associated
+volumes, volume type, and sector size, with the information stored with the key
+in EKMF Web. Refer to the man page of \fBzkey\fP for the details on the \fBzkey
+kms refresh\fP command.
+.PP
+The \fBzkey kms refresh\fP command can also help if the secure keys have not
+been re-enciphered properly after a CCA master key change, and thus became
+invalid. By refreshing the keys using the \fBzkey kms refresh\fP command, the
+secure key is re-imported under the current CCA master key. So this command
+could also be used as an alternative to the \fBzkey reencipher\fP command for
+keys that are bound to EKMF Web.
+.
+.
+.
+.SH OPTIONS
+This section describes the EKMF Web plugin specific options of the \fBzkey\fP
+commands. Refer to the \fBzkey\fP man page for the remaining, non EKMF Web
+plugin specific options.
+.
+.SS "Options for the zkey kms configure command"
+.TP
+.BR \-u ", " \-\-ekmfweb\-url\~\fIurl\fP
+Specifies the URL of the EKMF Web server. The URL should start with
+\fBhttps://\fP, and may contain a port number separated by a colon. If no
+port number is specified, 443 is used for HTTPS.
+.TP
+.BR \-b ", " \-\-tls\-ca\-bundle\~\fIca\-bundle\fP
+Specifies the CA bundle PEM file or directory containing the CA certificates
+used to verify the EKMF Web server certificate during TLS handshake. If this
+specifies a directory path, then this directory must have been prepared
+with OpenSSL's \fBc_rehash\fP utility. Default are the system CA certificates.
+.TP
+.BR \-\-tls\-client\-cert\~\fIpem\-file\fP
+Specifies the PEM file containing the client's TLS certificate for use with
+TLS client authentication.
+.TP
+.BR \-\-tls\-client\-key\~\fIpem\-file\fP
+Specifies the PEM file containing the client's private key for use with TLS
+client authentication.
+.TP
+.BR \-\-tls\-client\-key\-passphrase\~\fIpassphrase\fP
+If the PEM file is passphrase protected, this option specifies the passphrase
+to unlock the PEM file that is specified with option \fB\-\-tls\-client\-key\fP.
+.TP
+.BR \-\-tls\-pin\-server\-pubkey
+Pin the EKMF Web server's public key to verify on every connection that the
+public key of the EKMF Web server's certificate is the same that was used when
+the connection to the EKMF Web server was configured. This option can only be
+used with CA signed EKMF Web server certificates.
+.TP
+.BR \-\-tls\-trust\-server\-cert
+Trust the EKMF Web server's certificate even if it is a  self signed
+certificate, or could not be verified due to other reasons. This option can be
+used instead of option \fB\-\-tls\-pin\-server\-pubkey\fP with self signed
+EKMF Web server certificates.
+.TP
+.BR \-\-tls\-dont\-verify\-server\-cert
+Do not verify the authenticity of the EKMF Web server's certificate. For self
+signed EKMF Web server certificates, this is the default. Use option
+\fB\-\-tls\-pin\-server\-cert\fP to ensure the self signed certificate's
+authenticity explicitly. CA signed EKMF Web server certificates are verified by
+default. This option disables the verification.
+.TP
+.BR \-\-tls\-verify\-hostname
+ Verify that the EKMF Web server certificate's \fBCommon Name\fP field or a
+\fBSubject Alternate Name\fP field matches the host name used to connect to the
+EKMF Web server.
+.TP
+.BR \-R ", " \-\-refresh\-settings
+Refresh the EKMF Web server settings. This is automatically performed when the
+connection to the EKMF Web server is (re-)configured. Use this option when the
+settings of the already configured EKMF Web server have changed.
+.TP
+.BR \-i ", " \-\-gen\-identity\-key
+Generate an identity key for the EKMF Web plugin. An identity key is
+automatically generated when the EKMF Web server connection has been configured.
+Use this option to generate a new identity key. You need to re-generate a
+registration certificate with the newly generated identity key, and re-register
+this zkey client with the EKMF Web server.
+.TP
+.BR \-c ", " \-\-gen\-csr\~\fIcsr\-pem\-file\fP
+Generate a certificate signing request (CSR) with the identity key and store it
+into the specified PEM file. You pass this CSR to a certificate authority (CA)
+to have it issue a CA signed certificate for the EKMF Web plugin. You need to
+register the certificate with EKMF Web before you can access EKMF Web.
+.TP
+.BR \-C ", " \-\-gen\-self\-signed\-cert\~\fIcert\-pem\-file\fP
+Generate a self signed certificate with the identity key and store it into the
+specified PEM file. You need to register the certificate with EKMF Web before
+you can access EKMF Web.
+.TP
+.BR \-s ", " \-\-cert\-subject\~\fIsubject\-rdns\fP
+Specifies the subject name for generating a certificate signing request (CSR)
+or self signed certificate, in the form
+\fB<type>=<value>(;<type>=<value>)*[;]\fP with types recognized by OpenSSL.
+.TP
+.BR \-s ", " \-\-cert\-extensions\~\fIextensions\fP
+Specifies the certificate extensions for generating a certificate signing
+request (CSR) or self signed certificate, in the form
+\fB<name>=[critical,]<value(s)>(;<name>=[critical,]<value(s)>)*[;]\fP
+with extension names and values  recognized by OpenSSL.
+.TP
+.BR \-N ", " \-\-renew\-cert\~\fIcert\-pem\-file\fP
+Specifies an existing PEM file containing  the certificate to be renewed. The
+certificate's subject name and extensions are used to generate the certificate
+signing request (CSR) or renewed self signed certificate.
+.TP
+.BR \-n ", " \-\-csr\-new\-header
+Adds the word \fBNEW\fP to the PEM file header and footer lines on the
+certificate signing request. Some software and some CAs need this.
+.TP
+.BR \-d ", " \-\-cert\-validity\-days\~\fIdays\fP
+Specifies the number of days to certify the self signed certificate. The
+default is 30 days.
+.TP
+.BR \-D ", " \-\-cert\-digest\~\fIdigest\fP
+Specifies the digest algorithm to use when generating a certificate signing
+request or self signed certificate. The default is determined by OpenSSL.
+.TP
+.BR \-r ", " \-\-register\~\fIcert\-file\fP
+Register the zkey client with EKMF Web by generating an identity key in EKMF
+Web using the certificate from the specified file. Supported  certificate files
+formats are \fB.pem\fP, \fB.crt\fP, \fB.cert\fP, \fB.cer\fP, and \fB.der\fP
+(i.e. either base64 or DER encoded). If you want to register a self signed
+certificate that you are about to generate using option
+\fB\-\-gen\-self\-signed\-cert\fP, then  specify the same certificate file
+name here, and the generated certificate is registered right away.
+.TP
+.BR \-T ", " \-\-label\-tags\~\fIlabel\-tags\fP
+Specifies the label tags for generating the identity key in EKMF Web when
+registering the zkey client, in the form
+\fB<tag>=<value>(,<tag>=<value>)*[,]\fP with tags as defined by the key
+template. Use the \fBzkey kms info\fP command to display the key templates used
+by zkey. For registration, the template for identity keys is used.
+.
+.SS "Options for the zkey generate command"
+.
+.TP
+.BR \-T ", " \-\-label\-tags\~\fIlabel\-tags\fP
+Specifies the label tags for generating a secure key in EKMF Web, in the form
+\fB<tag>=<value>(,<tag>=<value>)*[,]\fP with tags as defined by the key
+template. Use the \fBzkey kms info\fP command to display the key templates used
+by zkey. For XTS type keys the two templates for \fBXTS-Key1\fP and
+\fBXTS-Key2\fP are used. For non-XTS type keys, the template for \fBNon-XTS\fP
+keys is used.
+.
+.SS "Options for the zkey remove command"
+.
+.TP
+.BR \-s ", " \-\-state\~\fIstate\fP
+Specifies the state to which to change the key in EKMF Web, after removing
+the secure key from the local secure key repository. Possible states are
+\fBDEACTIVATED\fP, \fBCOMPROMISED\fP, \fBDESTROYED\fP, and
+\fBDESTROYED\-COMPROMISED\fP. If this option is not specified, the state of the
+key in EKMF Web is not changed, but the key is removed from the local secure
+key repository only.
+.
+.SS "Options for the zkey kms list command"
+.
+.TP
+.BR \-s ", " \-\-states\~\fIstates\fP
+Specifies the states of the keys that are to be listed. Multiple states can be
+separated by comma. Possible states are \fBPRE\-ACTIVATION\fP, \fBACTIVE\fP,
+\fBDEACTIVATED\fP, \fBCOMPROMISED\fP, \fBDESTROYED\fP, and
+\fBDESTROYED\-COMPROMISED\fP. If this option is not specified, only keys in
+state \fBACTIVE\fP are listed.
+.TP
+.BR \-a ", " \-\-all
+List all keys that can be used for volume encryption. If this option is not
+specified, then only volume encryption keys that are allowed to be exported by
+EKMF Web using the identity key of this zkey client are listed.
+.
+.
+.
+.SH EXAMPLES
+.TP
+.B zkey kms plugins
+Lists available key manamgement system plugins.
+.TP
+.B zkey kms bind EKMFWeb
+Binds the EKMF Web plugin to the current secure key repository.
+.TP
+.B zkey kms configure \-\-apqns 03.004c
+Configures the APQN '03.004c' to be associated with the EKMF Web plugin.
+.TP
+.B zkey kms configure \-\-ekmfweb\-url https://my.ekmfweb.server
+Configures the connection to the EKMF Web server on 'my.ekmfweb.server'.
+.TP
+.B zkey kms configure \-\-ekmfweb\-url https://my.ekmfweb.server \-\-tls\-pin\-server\-pubkey \-\-tls\-verify\-hostname
+Configures the connection to the EKMF Web server on 'my.ekmfweb.server' and
+pins the server's public key from the server's TSL certificate as well as
+enables verification of the host nmae to match the server's Common Name in the
+certificate.
+.TP
+.B zkey kms configure \-\-gen\-csr csr.pem \-\-cert\-subject \(dqCN=my.zkey.client;OU=Example;C=US\(dq
+Generates a certificate signing request with the identity key and the specified
+subject name and stores it in file 'csr.pem'.
+.TP
+.B zkey kms configure \-\-gen\-csr csr.pem \-\-renew\-cert cert.pem
+Generates a certificate signing request with the identity key to renew the
+existing certificate in file cert.pem and stores it in file 'csr.pem'.
+.TP
+.B zkey kms configure \-\-gen\-self\-signed\-cert cert.pem \-\-cert\-subject \(dqCN=my.zkey.client;OU=Example;C=US\(dq \-\-cert\-validity\-days 50
+Generates a self signed certificate with the identity key and the specified
+subject name and a validity of 50 days, and stores it in file 'cert.pem'.
+.TP
+.B zkey kms configure \-\-gen\-self\-signed\-cert cert.pem \-\-cert\-subject \(dqCN=my.zkey.client;OU=Example;C=US\(dq \-\-cert\-extensions \(dqkeyUsage=critical,digitalSignature,keyAgreement\(dq
+Generates a self signed certificate with the identity key and the specified
+subject name and a certificate extension to limit the key usage, and stores it
+in file 'cert.pem'.
+.TP
+.B zkey kms configure \-\-register cert.pem
+Registers the zkey client with EKMF Web using the certifcate in file 'cert.pem'.
+.TP
+.B zkey kms configure \-\-register cert.pem \-\-label\-tags \(dqENV=TEST,APP=LINUX\(dq
+Registers the zkey client with EKMF Web using the certifcate in file 'cert.pem'
+and the label tags 'ENV=TEST' and 'APP=LINUX' for the identity key.
+.TP
+.B zkey kms info
+Displays information about the EKMF Web plugin and its configuration.
+.TP
+.B zkey kms reencipher --staged
+Re-enciphers the EKMF Plugin's identity key with a new CCA master key in staged
+mode
+.TP
+.B zkey generate \-\-name seckey \-\-volumes /dev/dasdc1:encvol \-\-label\-tags \(dqENV=TEST,APP=LINUX\(dq
+Generates a secure AES key in EKMF Web using the label tags 'ENV=TEST' and
+'APP=LINUX' and stores it in the secure key repository using the name 'seckey'
+and associates it with block device '/dev/dasdc1' and device-mapper name
+'encvol'.
+.TP
+.B zkey generate \-\-name seckey \-\-xts \-\-volumes /dev/dasdc1:encvol \-\-volume-type luks2 \-\-label\-tags \(dqENV=TEST,APP=LINUX\(dq
+Generates a secure AES key for the XTS cipher mode in EKMF Web using the label
+tags 'ENV=TEST' and 'APP=LINUX' and stores it in the secure key repository
+using the name 'seckey' and associates it with block device '/dev/dasdc1' and
+device-mapper name 'encvol', and a volume type of luks2.
+.TP
+.B zkey remove \-\-name seckey \-\-state DEACTIVATED
+Removes secure key 'seckey' from the repository and sets the state of the key
+to 'DEACTIVATED' in EKMF Web.
+.TP
+.B zkey kms list
+Displays eligible secure keys managed by EKMF Web which this zkey client is
+allowed to use and are in state 'ACTIVE'
+.TP
+.B zkey kms list \-\-states ACTIVE,DEACTIVATED
+Displays eligible secure keys managed by EKMF Web which this zkey client is
+allowed to use and are in state 'ACTIVE' or 'DEACTIVATED'
+.TP
+.B zkey kms list \-\-all
+Displays eligible secure keys managed by EKMF Web, regardless if this zkey
+client is allowed to use it or not.
+.TP
+.B zkey kms list \-\-label \(dq*LUKS2*\(dq
+Displays eligible secure keys managed by EKMF Web where the label name in EKMF
+Web contains the work 'LUKS2'.
+.TP
+.B zkey kms import \-\-name seckey
+Imports the secure key managed by EKMF Web with a zkey name of 'seckey'.
+.TP
+.B zkey kms import \-\-volume\-type LUKS2
+Imports secure keys managed by EKMF Web that are associated with volumes of
+volume type LUKS2.
+.TP
+.B zkey kms refresh \-\-name \(dqsec*\(dq
+Refreshes secure keys from EKMF Web where the name starts with 'sec'.
+.TP
+.B zkey kms refresh \-\-name seckey \-\-refresh\-properties
+Refreshes the secure key with the name 'seckey' from EKMF Web and also refreshs
+the key properties.
\ No newline at end of file
diff -pruN 2.14.0-2/zkey/ekmfweb/zkey-ekmfweb.c 2.15.1-0ubuntu2/zkey/ekmfweb/zkey-ekmfweb.c
--- 2.14.0-2/zkey/ekmfweb/zkey-ekmfweb.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/ekmfweb/zkey-ekmfweb.c	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,5745 @@
+/*
+ * zkey-ekmfweb - EKMFWeb zkey KMS plugin
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+
+#include <argz.h>
+#include <ctype.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <dlfcn.h>
+#include <stdarg.h>
+#include <string.h>
+#include <errno.h>
+#include <err.h>
+#include <sys/utsname.h>
+
+#include <openssl/evp.h>
+#include <openssl/x509.h>
+#include <openssl/pem.h>
+
+#include "lib/zt_common.h"
+#include "lib/util_libc.h"
+#include "lib/util_panic.h"
+#include "lib/util_path.h"
+#include "lib/util_base.h"
+#include "lib/util_rec.h"
+
+#include "zkey-ekmfweb.h"
+#include "../kms-plugin.h"
+#include "../cca.h"
+#include "../utils.h"
+#include "../pkey.h"
+#include "../properties.h"
+
+#define pr_verbose(handle, fmt...)				\
+	do {							\
+		if (handle->verbose) {				\
+			fprintf(stderr, "zkey-ekmfweb: ");	\
+			fprintf(stderr, fmt);			\
+			fprintf(stderr, "\n");			\
+		}						\
+	} while (0)
+
+#define FREE_AND_SET_NULL(ptr)					\
+	do {							\
+		if ((ptr) != NULL)				\
+			free((void *)ptr);			\
+		(ptr) = NULL;					\
+	} while (0)
+
+/**
+ * Clears the error message in the plugin handle
+ *
+ * @param ph                the plugin handle
+ */
+static void _clear_error(struct plugin_handle *ph)
+{
+	memset(ph->error_msg, 0, sizeof(ph->error_msg));
+}
+
+/**
+ * Sets the error message in the plugin handle
+ *
+ * @param ph                the plugin handle
+ * @param fmt               the format string for sprintf
+ */
+static void _set_error(struct plugin_handle *ph, const char *fmt, ...)
+{
+	va_list ap;
+
+	va_start(ap, fmt);
+	vsnprintf(ph->error_msg, sizeof(ph->error_msg), fmt, ap);
+	va_end(ap);
+}
+
+/**
+ * Informs a KMS plugin that it is bound to a zkey repository.
+ *
+ * Note: This function is called before kms_initialize()!
+ *
+ * @param config_path       name of a directory where the KMS plugin can store
+ *                          its configuration and other files it needs to store
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+int kms_bind(const char *UNUSED(config_path))
+{
+	return 0;
+}
+
+/**
+ * Load the EKMFWeb plugin config file
+ *
+ * @param ph                the plugin handle
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _load_config(struct plugin_handle *ph)
+{
+	char *file_name = NULL;
+	int rc;
+
+	util_asprintf(&file_name, "%s/%s", ph->config_path,
+		      EKMFWEB_CONFIG_FILE);
+
+	rc = properties_load(ph->properties, file_name, true);
+	if (rc != 0)
+		pr_verbose(ph, "Failed to load plugin config file '%s': %s",
+			   file_name, strerror(-rc));
+	else
+		pr_verbose(ph, "Config file '%s' loaded", file_name);
+
+	free(file_name);
+	return rc;
+}
+
+/**
+ * Sets the file permissions of the file to the permissions and the group
+ * of configuration directory
+ *
+ * @param ph                the plugin handle
+ * @param filename           the name of the file to set permissions for
+ *
+ * @returns 0 on success, or a negative errno value on failure
+ */
+static int _set_file_permission(struct plugin_handle *ph, const char *filename)
+{
+	int rc;
+
+	if (chmod(filename, ph->config_path_mode) != 0) {
+		rc = -errno;
+		_set_error(ph, "chmod failed on file '%s': %s", filename,
+			   strerror(-rc));
+		return rc;
+	}
+
+	if (chown(filename, geteuid(), ph->config_path_owner) != 0) {
+		rc = -errno;
+		_set_error(ph, "chown failed on file '%s': %s", filename,
+			   strerror(-rc));
+		return rc;
+	}
+
+	return 0;
+}
+
+/**
+ * Makes a temporary file an active file, by first removing the current active
+ * file (if existent), and then renaming the temporary file to the active file.
+ * The active file permissions are also set to the permissions and the group of
+ * configuration directory.
+ *
+ * @param ph                the plugin handle
+ * @param temp_file         the name of the temporary file
+ * @param active_file       the name of the active file
+ *
+ * @returns 0 on success, or a negative errno value on failure
+ */
+static int _activate_temp_file(struct plugin_handle *ph, const char *temp_file,
+			       const char *active_file)
+{
+	int rc;
+
+	if (util_path_exists(active_file)) {
+		rc = remove(active_file);
+		if (rc != 0) {
+			rc = -errno;
+			_set_error(ph, "remove failed on file '%s': %s",
+				   active_file, strerror(-rc));
+			return rc;
+		}
+	}
+
+	rc = rename(temp_file, active_file);
+	if (rc != 0) {
+		rc = -errno;
+		_set_error(ph, "rename failed on file '%s': %s",
+			   temp_file, strerror(-rc));
+		return rc;
+	}
+
+	return _set_file_permission(ph, active_file);
+}
+
+/**
+ * Save the EKMFWeb plugin config file
+ *
+ * @param ph                the plugin handle
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _save_config(struct plugin_handle *ph)
+{
+	char *file_name = NULL;
+	int rc;
+
+	util_asprintf(&file_name, "%s/%s", ph->config_path,
+		      EKMFWEB_CONFIG_FILE);
+
+	pr_verbose(ph, "Saving '%s'", file_name);
+
+	rc = properties_save(ph->properties, file_name, true);
+	if (rc != 0) {
+		_set_error(ph, "Failed to save plugin config file '%s': %s",
+			   file_name, strerror(-rc));
+		goto out;
+	}
+
+	rc = _set_file_permission(ph, file_name);
+	if (rc != 0)
+		goto out;
+
+out:
+	free(file_name);
+	return rc;
+}
+
+/**
+ * Base64-encodes the passphrase to make it unreadable.
+ *
+ * @param passphrase        the passphrase to encode
+ *
+ * @returns the encoded passphrase or NULL in case of an error.
+ * The caller must free the string when no longer needed.
+ */
+static char *_encode_passphrase(const char *passphrase)
+{
+	int inlen, outlen, len;
+	char *out;
+
+	inlen = strlen(passphrase);
+	outlen = (inlen / 3) * 4;
+	if (inlen % 3 > 0)
+		outlen += 4;
+
+	out = util_malloc(outlen + 1);
+	memset(out, 0, outlen + 1);
+
+	len = EVP_EncodeBlock((unsigned char *)out, (unsigned char *)passphrase,
+			      inlen);
+	if (len != outlen) {
+		free(out);
+		return NULL;
+	}
+
+	out[outlen] = '\0';
+	return out;
+}
+
+/**
+ * Base64-decodes the passphrase
+ *
+ * @param passphrase        the passphrase to decode
+ *
+ * @returns the decoded passphrase or NULL in case of an error.
+ * The caller must free the string when no longer needed.
+ */
+static char *_decode_passphrase(const char *passphrase)
+{
+	int inlen, outlen, len;
+	char *out;
+
+	inlen = strlen(passphrase);
+	outlen = (inlen / 4) * 3;
+	if (inlen % 4 > 0)
+		outlen += 3;
+
+	out = util_malloc(outlen + 1);
+	memset(out, 0, outlen + 1);
+
+	len = EVP_DecodeBlock((unsigned char *)out, (unsigned char *)passphrase,
+			      inlen);
+	if (len != outlen) {
+		free(out);
+		return NULL;
+	}
+
+	out[outlen] = '\0';
+	return out;
+}
+
+/**
+ * Sets or removes a property. If value is NULL it is removed, otherwise it
+ * is set.
+ *
+ * @param ph                the plugin handle
+ * @param name              the name of the property
+ * @param value             the value of the property or NULL
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _set_or_remove_property(struct plugin_handle *ph, const char *name,
+				   const char *value)
+{
+	int rc = 0;
+
+	if (value != NULL) {
+		rc = properties_set(ph->properties, name, value);
+		if (rc != 0) {
+			_set_error(ph, "Failed to set property '%s': %s", name,
+				   strerror(-rc));
+			goto out;
+		}
+	} else {
+		rc = properties_remove(ph->properties, name);
+		if (rc != 0 && rc != -ENOENT) {
+			_set_error(ph, "Failed to remove property '%s': %s",
+				   name, strerror(-rc));
+			goto out;
+		}
+		rc = 0;
+	}
+
+out:
+	return rc;
+}
+
+/**
+ * Checks if a plugin config propertiy is set and not empty
+ *
+ * @param ph                the plugin handle
+ * @param name              the name of the property
+ *
+ * @returns true if the property is set and is not empty, false otherwise
+ */
+static bool _check_property(struct plugin_handle *ph, const char *name)
+{
+	bool ok = true;
+	char *value;
+
+	value = properties_get(ph->properties, name);
+	pr_verbose(ph, "Property '%s': %s", name,
+		   value != NULL ? value : "(missing)");
+
+	ok &= (value != NULL && strlen(value) > 0);
+
+	if (value != NULL)
+		free(value);
+
+	return ok;
+}
+
+/**
+ * Checks if the plugin configuration is complete. Sets the appropriate flags
+ * in the plugin handle
+ *
+ * @param ph                the plugin handle
+ */
+static void _check_config_complete(struct plugin_handle *ph)
+{
+	ph->apqns_configured = _check_property(ph, EKMFWEB_CONFIG_APQNS);
+
+	ph->connection_configured =
+		_check_property(ph, EKMFWEB_CONFIG_URL) &&
+		_check_property(ph, EKMFWEB_CONFIG_VERIFY_SERVER_CERT) &&
+		_check_property(ph, EKMFWEB_CONFIG_VERIFY_HOSTNAME);
+
+	ph->settings_retrieved =
+		_check_property(ph, EKMFWEB_CONFIG_EKMFWEB_PUBKEY);
+
+	ph->templates_retrieved =
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_XTS1) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_XTS2) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_NONXTS) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_IDENTITY) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_XTS1_LABEL) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_XTS2_LABEL) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_NONXTS_LABEL) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_IDENTITY_LABEL) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_XTS1_ID) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_XTS2_ID) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_NONXTS_ID) &&
+		_check_property(ph, EKMFWEB_CONFIG_TEMPLATE_IDENTITY_ID);
+
+	ph->identity_key_generated =
+		_check_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY) &&
+		_check_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY_ALGORITHM) &&
+		_check_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY_PARAMS);
+
+	ph->registered =
+		_check_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY_LABEL) &&
+		_check_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY_ID);
+
+	ph->config_complete = ph->apqns_configured &&
+			      ph->connection_configured &&
+			      ph->settings_retrieved &&
+			      ph->templates_retrieved &&
+			      ph->identity_key_generated &&
+			      ph->registered;
+}
+
+/**
+ * Gets the EKMF config structure contents from the plugin properties
+ *
+ * @param ph                the plugin handle
+ *
+ * @returns a KMS plugin handle, or NULL in case of an error.
+ */
+static int _get_ekmf_config(struct plugin_handle *ph)
+{
+	char *tmp;
+
+	ph->ekmf_config.identity_secure_key = properties_get(ph->properties,
+						EKMFWEB_CONFIG_IDENTITY_KEY);
+
+	ph->ekmf_config.base_url = properties_get(ph->properties,
+						  EKMFWEB_CONFIG_URL);
+	ph->ekmf_config.tls_ca = properties_get(ph->properties,
+						EKMFWEB_CONFIG_CA_BUNDLE);
+	ph->ekmf_config.tls_client_cert = properties_get(ph->properties,
+						EKMFWEB_CONFIG_CLIENT_CERT);
+	ph->ekmf_config.tls_client_key = properties_get(ph->properties,
+						EKMFWEB_CONFIG_CLIENT_KEY);
+
+	tmp = properties_get(ph->properties,
+			    EKMFWEB_CONFIG_CLIENT_KEY_PASSPHRASE);
+	if (tmp != NULL) {
+		ph->ekmf_config.tls_client_key_passphrase =
+				_decode_passphrase(tmp);
+		free(tmp);
+	}
+	ph->ekmf_config.tls_issuer_cert = NULL;
+	ph->ekmf_config.tls_pinned_pubkey = properties_get(ph->properties,
+						EKMFWEB_CONFIG_SERVER_PUBKEY);
+	ph->ekmf_config.tls_server_cert = properties_get(ph->properties,
+						EKMFWEB_CONFIG_SERVER_CERT);
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_VERIFY_SERVER_CERT);
+	ph->ekmf_config.tls_verify_peer =
+				(tmp != NULL && strcasecmp(tmp, "yes") == 0);
+	if (tmp != NULL)
+		free(tmp);
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_VERIFY_HOSTNAME);
+	ph->ekmf_config.tls_verify_host =
+				(tmp != NULL && strcasecmp(tmp, "yes") == 0);
+	if (tmp != NULL)
+		free(tmp);
+	ph->ekmf_config.max_redirs = 0;
+
+	ph->ekmf_config.login_token = properties_get(ph->properties,
+						EKMFWEB_CONFIG_LOGIN_TOKEN);
+
+	ph->ekmf_config.ekmf_server_pubkey = properties_get(ph->properties,
+						EKMFWEB_CONFIG_EKMFWEB_PUBKEY);
+
+	return 0;
+}
+
+/**
+ * Frees the EKMF config structure contents
+ *
+ * @param ph                the plugin handle
+ */
+static void _free_ekmf_config(struct plugin_handle *ph)
+{
+	if (ph->ekmf_config.base_url != NULL)
+		free((void *)ph->ekmf_config.base_url);
+	if (ph->ekmf_config.tls_ca != NULL)
+		free((void *)ph->ekmf_config.tls_ca);
+	if (ph->ekmf_config.tls_client_cert != NULL)
+		free((void *)ph->ekmf_config.tls_client_cert);
+	if (ph->ekmf_config.tls_client_key != NULL)
+		free((void *)ph->ekmf_config.tls_client_key);
+	if (ph->ekmf_config.tls_client_key_passphrase != NULL)
+		free((void *)ph->ekmf_config.tls_client_key_passphrase);
+	if (ph->ekmf_config.tls_issuer_cert != NULL)
+		free((void *)ph->ekmf_config.tls_issuer_cert);
+	if (ph->ekmf_config.tls_pinned_pubkey != NULL)
+		free((void *)ph->ekmf_config.tls_pinned_pubkey);
+	if (ph->ekmf_config.tls_server_cert != NULL)
+		free((void *)ph->ekmf_config.tls_server_cert);
+	if (ph->ekmf_config.login_token != NULL)
+		free((void *)ph->ekmf_config.login_token);
+	if (ph->ekmf_config.identity_secure_key != NULL)
+		free((void *)ph->ekmf_config.identity_secure_key);
+	if (ph->ekmf_config.ekmf_server_pubkey != NULL)
+		free((void *)ph->ekmf_config.ekmf_server_pubkey);
+}
+
+/**
+ * Removes the login token file, if the error indicates an authorization or
+ * authentication error (-EACCES or -EPERM)
+ *
+ * @param ph                the plugin handle
+ * @param error             the negative errno value of the last error
+ */
+static void _remove_login_token_if_error(struct plugin_handle *ph, int error)
+{
+	switch (error) {
+	case -EACCES:
+	case -EPERM:
+		remove(ph->ekmf_config.login_token);
+		FREE_AND_SET_NULL(ph->ekmf_config.login_token);
+		break;
+	default:
+		break;
+	}
+
+	return;
+}
+
+/**
+ * UnlLoads the CCA library
+ *
+ * @param ph                the plugin handle
+ */
+static void _unload_cca_library(struct plugin_handle *ph)
+{
+	if (ph->cca.cca_lib != NULL)
+		dlclose(ph->cca.cca_lib);
+	ph->cca.cca_lib = NULL;
+
+	ph->ext_lib.type = 0;
+	ph->ext_lib.cca = NULL;
+}
+
+/**
+ * Selects one the CCA APQNs associated with this plugin, and loads the CCA
+ * library and sets up the external library field in the plugin handle.
+ *
+ * @param ph                the plugin handle
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _select_cca_adapter(struct plugin_handle *ph)
+{
+	struct cca_lib cca = { 0 };
+	unsigned int card, domain;
+	char **apqn_list = NULL;
+	bool selected = false;
+	int rc = 0, i;
+	char *apqns;
+
+	apqns = properties_get(ph->properties, EKMFWEB_CONFIG_APQNS);
+	if (apqns == NULL) {
+		_set_error(ph, "No APQN are associated with the plugin.");
+		rc = -ENODEV;
+		goto out;
+	}
+
+	pr_verbose(ph, "Associated APQNs: %s", apqns);
+
+	_unload_cca_library(ph);
+
+	apqn_list = str_list_split(apqns);
+	for (i = 0; apqn_list[i] != NULL; i++) {
+		if (sscanf(apqn_list[i], "%x.%x", &card, &domain) != 2)
+			continue;
+
+		if (sysfs_is_apqn_online(card, domain, CARD_TYPE_CCA) != 1)
+			continue;
+
+		rc = select_cca_adapter(&cca, card, domain, ph->verbose);
+		if (rc != 0) {
+			_set_error(ph, "Failed to select APQN %02x.%04x: %s",
+				   card, domain, strerror(-rc));
+			goto out;
+		}
+
+		selected = true;
+		break;
+	}
+
+	if (!selected) {
+		_set_error(ph, "None of the associated APQNs is available: %s",
+			   apqns);
+		rc = -ENODEV;
+		goto out;
+	}
+
+	pr_verbose(ph, "Selected APQN %02x.%04x", card, domain);
+
+	ph->cca.cca_lib = cca.lib_csulcca;
+	ph->ext_lib.type = EKMF_EXT_LIB_CCA;
+	ph->ext_lib.cca = &ph->cca;
+
+out:
+	if (apqns != NULL)
+		free(apqns);
+	if (apqn_list != NULL)
+		str_list_free_string_array(apqn_list);
+
+	if (rc != 0 && cca.lib_csulcca != NULL)
+		dlclose(cca.lib_csulcca);
+
+	return rc;
+}
+
+/**
+ * Initializes a KMS plugin for usage by zkey. When a repository is bound to a
+ * KMS plugin, zkey calls this function when opening the repository.
+ *
+ * @param config_path       name of a directory where the KMS plugin can store
+ *                          its configuration and other files it needs to store
+ * @param verbose           if true, the plugin should write verbose or debug
+ *                          messages to stderr during further processing.
+ *
+ * @returns a KMS plugin handle, or NULL in case of an error.
+ */
+kms_handle_t kms_initialize(const char *config_path, bool verbose)
+{
+	struct plugin_handle *ph;
+	struct stat sb;
+	int rc;
+
+	util_assert(config_path != NULL, "Internal error: config_path is NULL");
+
+	ph = util_malloc(sizeof(struct plugin_handle));
+	memset(ph, 0, sizeof(struct plugin_handle));
+
+	ph->config_path = util_strdup(config_path);
+	ph->verbose = verbose;
+
+	pr_verbose(ph, "Plugin initializing, config_path: '%s'", config_path);
+
+	if (stat(config_path, &sb) != 0) {
+		warnx("Can not access '%s': %s", config_path, strerror(errno));
+		goto error;
+	}
+	if (!S_ISDIR(sb.st_mode)) {
+		warnx("'%s' is not a directory", config_path);
+		goto error;
+	}
+	if (!util_path_is_readable(config_path) ||
+	    !util_path_is_writable(config_path)) {
+		warnx("Permission denied for '%s'", config_path);
+		goto error;
+	}
+	if (sb.st_mode & S_IWOTH) {
+		warnx("Directory '%s' is writable for others, this is not "
+		      "accepted", config_path);
+		goto error;
+	}
+
+	ph->config_path_owner = sb.st_gid;
+	ph->config_path_mode = sb.st_mode & (S_IRUSR | S_IWUSR |
+					     S_IRGRP  | S_IWGRP |
+					     S_IROTH);
+
+	ph->properties = properties_new();
+	rc = _load_config(ph);
+	if (rc != 0 && rc != -EIO) {
+		warnx("Failed to load plugin config file: %s", strerror(-rc));
+		goto error;
+	}
+
+	rc = _get_ekmf_config(ph);
+	if (rc != 0)
+		goto error;
+
+	_check_config_complete(ph);
+	pr_verbose(ph, "Plugin configuration is %scomplete",
+		   ph->config_complete ? "" : "in");
+
+	return (kms_handle_t)ph;
+
+error:
+	kms_terminate(ph);
+	return NULL;
+}
+
+/**
+ * Terminates the use of a KMS plugin. When a repository is bound to a KMS
+ * plugin, zkey calls this function when closing the repository.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_terminate(const kms_handle_t handle)
+{
+	struct plugin_handle *ph = handle;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+
+	pr_verbose(ph, "Plugin terminated");
+
+	_free_ekmf_config(ph);
+	_unload_cca_library(ph);
+
+	if (ph->curl_handle != NULL)
+		ekmf_curl_destroy(ph->curl_handle);
+
+	if (ph->config_path != NULL)
+		free((void *)ph->config_path);
+	if (ph->properties != NULL)
+		properties_free(ph->properties);
+	free(ph);
+
+	return 0;
+}
+
+/**
+ * Returns a textual message about the last occurred error that occurred in the
+ * last called KMS plugin function. If no error occurred (i.e. the last plugin
+ * function returned rc = 0), then NULL is returned.
+ * The returned string is static or contained within the handle. It is valid
+ * only until the next KMS plugin function is called.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns an error message of NULL
+ */
+const char *kms_get_last_error(const kms_handle_t handle)
+{
+	struct plugin_handle *ph = handle;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+
+	pr_verbose(ph, "Last error: '%s'", ph->error_msg);
+
+	if (strlen(ph->error_msg) == 0)
+		return NULL;
+
+	return ph->error_msg;
+}
+
+/**
+ * Returns true if the KMS plugin supports the specified key type.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_type          the zkey key type, euch as 'CCA-AESDATA',
+ *                          'CCA-AESCIPHER', 'EP11-AES'.
+ *
+ * @returns true if the KMS plugin supports the key type, false otherwise.
+ */
+bool kms_supports_key_type(const kms_handle_t handle,
+			   const char *key_type)
+{
+	struct plugin_handle *ph = handle;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(key_type != NULL, "Internal error: key_type is NULL");
+
+	_clear_error(ph);
+
+	if (strcasecmp(key_type, KEY_TYPE_CCA_AESCIPHER) == 0)
+		return true;
+
+	return false;
+}
+
+/**
+ * Returns information about the public key in the PEM file
+ *
+ * @param ph               the plugin handle
+ * @param pem_file         the name of a PEM file containing the public key
+ * @param pkey_type        on return: If not NULL, the PKEY type (EVP_PKEY_EC
+ *                         or EVP_PKEY_RSA)
+ * @param ecc_curve_nid    on return: If not NULL and it is an ECC key, the
+ *                         OpenSSL NID of the curve of the ECC key.
+ * @param rsa_mod_bits     on return: If not NULL and it is an RSA key, the
+ *                         modulus bit size of the RSA key.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _get_pub_key_info(struct plugin_handle *ph, const char *pem_file,
+			     int *pkey_type, int *ecc_curve_nid,
+			     int *rsa_mod_bits)
+{
+	int rc = 0, curve_nid, mod_len;
+	EVP_PKEY *pkey;
+	FILE *fp;
+
+	fp = fopen(pem_file, "r");
+	if (fp == NULL) {
+		rc = -errno;
+		_set_error(ph, "Failed to open pubkey PEM file '%s': %s",
+			   pem_file, strerror(-rc));
+		return rc;
+	}
+
+	pkey = PEM_read_PUBKEY(fp, NULL, NULL, NULL);
+
+	fclose(fp);
+
+	if (pkey == NULL) {
+		rc = -EIO;
+		_set_error(ph, "Failed to read pubkey from PEM file '%s': %s",
+			   pem_file, strerror(-rc));
+		return rc;
+	}
+
+	if (pkey_type != NULL)
+		*pkey_type = EVP_PKEY_id(pkey);
+
+	switch (EVP_PKEY_id(pkey)) {
+	case EVP_PKEY_EC:
+		curve_nid = EC_GROUP_get_curve_name(EC_KEY_get0_group(
+						EVP_PKEY_get0_EC_KEY(pkey)));
+		if (ecc_curve_nid != NULL)
+			*ecc_curve_nid = curve_nid;
+		break;
+
+	case EVP_PKEY_RSA:
+		mod_len = BN_num_bits(RSA_get0_n(EVP_PKEY_get0_RSA(pkey)));
+		if (rsa_mod_bits != NULL)
+			*rsa_mod_bits = mod_len;
+		break;
+
+	default:
+		rc = -EIO;
+		_set_error(ph, "Unknown pubkey type: %d", EVP_PKEY_id(pkey));
+		break;
+	}
+
+	EVP_PKEY_free(pkey);
+	return rc;
+}
+
+/**
+ * Displays information about the KMS Plugin and its current configuration on
+ * stdout.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_display_info(const kms_handle_t handle)
+{
+	int rc, type = 0, curve = 0, mod_bits = 0;
+	struct plugin_handle *ph = handle;
+	char *tmp = NULL;
+	bool rsa = false;
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+	char *info;
+#endif
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+
+	pr_verbose(ph, "Display Info");
+
+	_clear_error(ph);
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_URL);
+	printf("  EKMF Web server:      %s\n", tmp != NULL ? tmp :
+			"(configuration required)");
+	if (tmp != NULL)
+		free(tmp);
+	else
+		return 0;
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_CA_BUNDLE);
+	printf("  CA-bundle:            %s\n", tmp != NULL ? tmp :
+			"System's CA certificates");
+	if (tmp != NULL)
+		free(tmp);
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_CLIENT_CERT);
+	printf("  Client certificate:   %s\n", tmp != NULL ? tmp : "(none)");
+	if (tmp != NULL)
+		free(tmp);
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_CLIENT_KEY);
+	printf("  Client private key:   %s\n", tmp != NULL ? tmp : "(none)");
+	if (tmp != NULL) {
+		free(tmp);
+		tmp = properties_get(ph->properties,
+				     EKMFWEB_CONFIG_CLIENT_KEY_PASSPHRASE);
+		if (tmp != NULL) {
+			printf("                        "
+			       "(passphrase protected)\n");
+			free(tmp);
+		}
+	}
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_SERVER_CERT);
+	if (tmp != NULL) {
+		printf("  Trusting the server certificate\n");
+		free(tmp);
+	}
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_SERVER_PUBKEY);
+	if (tmp != NULL) {
+		printf("  Using server public key pinning\n");
+		free(tmp);
+	}
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_VERIFY_SERVER_CERT);
+	if (tmp != NULL) {
+		if (strcasecmp(tmp, "yes") == 0)
+			printf("  The server's certificate must be valid\n");
+		free(tmp);
+	} else {
+		printf("  The server's certificate is not verified\n");
+	}
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_VERIFY_HOSTNAME);
+	if (tmp != NULL) {
+		if (strcasecmp(tmp, "yes") == 0)
+			printf("  The server's certificate must match the "
+			       "hostname\n");
+		free(tmp);
+	}
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_EKMFWEB_PUBKEY);
+	if (tmp != NULL) {
+		rc = _get_pub_key_info(ph, tmp, &type, &curve, &mod_bits);
+		if (rc == 0) {
+			switch (type) {
+			case EVP_PKEY_EC:
+				printf("  EBMF Web public key:  ECC (%s)\n",
+				       OBJ_nid2sn(curve));
+				break;
+			case EVP_PKEY_RSA:
+				printf("  EBMF Web public key:  RSA "
+				       "(%d bits)\n", mod_bits);
+				break;
+			default:
+				printf("  EBMF Web public key:  "
+				       "(unknown key type)\n");
+				break;
+			}
+		} else {
+			printf("  EBMF Web public key:  (not available)\n");
+		}
+		free(tmp);
+	} else {
+		printf("  EBMF Web public key:  (configuration required)\n");
+	}
+
+	printf("  Key templates:\n");
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_TEMPLATE_IDENTITY);
+	printf("    Identity:           %s\n", tmp != NULL ? tmp :
+			"(configuration required)");
+	if (tmp != NULL)
+		free(tmp);
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_TEMPLATE_IDENTITY_LABEL);
+	if (tmp != NULL) {
+		printf("      Label template:   %s\n", tmp);
+		free(tmp);
+	}
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_TEMPLATE_XTS1);
+	printf("    XTS-Key1:           %s\n", tmp != NULL ? tmp :
+			"(configuration required)");
+	if (tmp != NULL)
+		free(tmp);
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_TEMPLATE_XTS1_LABEL);
+	if (tmp != NULL) {
+		printf("      Label template:   %s\n", tmp);
+		free(tmp);
+	}
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_TEMPLATE_XTS2);
+	printf("    XTS-Key2:           %s\n", tmp != NULL ? tmp :
+			"(configuration required)");
+	if (tmp != NULL)
+		free(tmp);
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_TEMPLATE_XTS2_LABEL);
+	if (tmp != NULL) {
+		printf("      Label template:   %s\n", tmp);
+		free(tmp);
+	}
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_TEMPLATE_NONXTS);
+	printf("    Non-XTS:            %s\n", tmp != NULL ? tmp :
+			"(configuration required)");
+	if (tmp != NULL)
+		free(tmp);
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_TEMPLATE_NONXTS_LABEL);
+	if (tmp != NULL) {
+		printf("      Label template:   %s\n", tmp);
+		free(tmp);
+	}
+
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_IDENTITY_KEY_ALGORITHM);
+	if (tmp != NULL) {
+		printf("  Identity key:         %s", tmp);
+		rsa = strcmp(tmp, EKMFWEB_KEY_ALGORITHM_RSA) == 0;
+		free(tmp);
+		tmp = properties_get(ph->properties,
+				     EKMFWEB_CONFIG_IDENTITY_KEY_PARAMS);
+		if (tmp != NULL) {
+			printf(" (%s%s)", tmp, rsa ? " bits" : "");
+			free(tmp);
+		}
+		printf("\n");
+	} else {
+		printf("  Identity key:         (configuration required)\n");
+	}
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_IDENTITY_KEY_REENC);
+	if (tmp != NULL) {
+		printf("                        (re-enciphering pending)\n");
+		free(tmp);
+	}
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_IDENTITY_KEY_LABEL);
+	printf("  Registered key label: %s\n", tmp != NULL ?
+			tmp : "(registration required)");
+	if (tmp != NULL)
+		free(tmp);
+
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+	printf("  Key transport settings:\n");
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_SESSION_KEY_CURVE);
+	printf("    Session Key:        ECC (%s)\n",
+	       tmp != NULL ? tmp : "secp521r1");
+	if (tmp != NULL)
+		free(tmp);
+
+	info = properties_get(ph->properties, EKMFWEB_CONFIG_IDENTITY_KEY_INFO);
+	if (info != NULL && strncmp(info, "RSA", 3) == 0) {
+		tmp = properties_get(ph->properties,
+				     EKMFWEB_CONFIG_SESSION_RSA_SIGN_DIGEST);
+		printf("    RSA sign digest:    %s\n",
+		       tmp != NULL ? tmp : "SHA512");
+		if (tmp != NULL)
+			free(tmp);
+		tmp = properties_get(ph->properties,
+				     EKMFWEB_CONFIG_SESSION_RSA_SIGN_PSS);
+		printf("    RSA sign alorithm:  %s\n",
+		       tmp != NULL && strcasecmp(tmp, "yes") == 0 ?
+							"RSA-PSS" : "RSA");
+		if (tmp != NULL)
+			free(tmp);
+	}
+	if (info != NULL)
+		free(info);
+#endif
+
+	return 0;
+}
+#define OPT_TLS_CLIENT_CERT			256
+#define OPT_TLS_CLIENT_KEY			257
+#define OPT_TLS_CLIENT_KEY_PASSPHRASE		258
+#define OPT_TLS_PIN_SERVER_PUBKEY		259
+#define OPT_TLS_TRUST_SERVER_CERT		260
+#define OPT_TLS_DONT_VERIFY_SERVER_CERT		261
+#define OPT_TLS_VERIFY_HOSTNAME			262
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+#define OPT_KT_RSA_SIGNATURE_DIGEST		263
+#define OPT_KT_RSA_PSS_SIGNATURE		264
+#endif
+
+static const struct util_opt configure_options[] = {
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "EKMFWEB SPECIFIC OPTIONS FOR THE SERVER CONNECTION",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "ekmfweb-url", required_argument, NULL, 'u'},
+		.argument = "URL",
+		.desc = "The URL of the EKMF Web server. The URL should start "
+			"with 'https://', and may contain a port number "
+			"separated by a colon. If no port number is specified, "
+			"443 is used for HTTPS.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "tls-ca-bundle", required_argument, NULL, 'b'},
+		.argument = "CA-BUNDLE",
+		.desc = "The CA bundle PEM file or directory containing the CA "
+			"certificates used to verify the EKMF Web server "
+			"certificate during TLS handshake. If this specifies a "
+			"directory path, then this directory must have been "
+			"prepared with OpenSSL's c_rehash utility. Default are "
+			"the system CA certificates.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "tls-client-cert", required_argument, NULL,
+							OPT_TLS_CLIENT_CERT },
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.argument = "PEM-FILE",
+		.desc = "The PEM file containing the client's TLS certificate "
+			"for use with TLS client authentication.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "tls-client-key", required_argument, NULL,
+							OPT_TLS_CLIENT_KEY },
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.argument = "PEM-FILE",
+		.desc = "The PEM file containing the client's private key "
+			"for use with TLS client authentication.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "tls-client-key-passphrase", required_argument,
+					NULL, OPT_TLS_CLIENT_KEY_PASSPHRASE },
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.argument = "PASSPHRASE",
+		.desc = "If the PEM file is passphrase protected, this option "
+			"specifies the passphrase to unlock the PEM file that "
+			"is specified with option '--tls-client-key'.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "tls-pin-server-pubkey", 0, NULL,
+				OPT_TLS_PIN_SERVER_PUBKEY },
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.desc = "Pin the EKMF Web server's public key to verify on "
+			"every connection that the public key of the EKMF Web "
+			"server's certificate is the same that was used when "
+			"the connection to the EKMF Web server was configured. "
+			"This option can only be used with CA signed EKMF Web "
+			"server certificates.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "tls-trust-server-cert", 0, NULL,
+				OPT_TLS_TRUST_SERVER_CERT },
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.desc = "Trust the EKMF Web server's certificate even if it is "
+			"a self signed certificate, or could not be verified "
+			"due to other reasons. This option can be used instead "
+			"of option '--tls-pin-server-pubkey' with self signed "
+			"EKMF Web server certificates.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "tls-dont-verify-server-cert", 0, NULL,
+					OPT_TLS_DONT_VERIFY_SERVER_CERT },
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.desc = "Do not verify the authenticity of the EKMF Web "
+			"server's certificate. For self signed EKMF Web server "
+			"certificates, this is the default. Use option "
+			"'--tls-pin-server-cert' to ensure the self signed "
+			"certificate's authenticity explicitely. CA signed "
+			"EKMF Web server certificates are verified by default. "
+			"This option disables the verification.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "tls-verify-hostname", 0, NULL,
+						OPT_TLS_VERIFY_HOSTNAME },
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.desc = "Verify that the EKMF Web server certificate's 'Common "
+			"Name' field or a 'Subject Alternate Name' field "
+			"matches the host name used to connect to the EKMF "
+			"Web server.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "refresh-settings", 0, NULL, 'R' },
+		.desc = "Refresh the EKMF Web server settings. This is "
+			"automatically performed when the connection to the "
+			"EKMF Web server is (re-)configured. Use this option "
+			"when the settings of the already configured EKMF Web "
+			"server have changed",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "EKMFWEB SPECIFIC OPTIONS FOR IDENTITY KEY GENERATION",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "gen-identity-key", 0, NULL, 'i'},
+		.desc = "Generate an identity key for the EKMF Web plugin. "
+			"An identity key is automatically generated when the "
+			"EKMF Web server connection has been configured. Use "
+			"this option to generate a new identity key. You need "
+			"to re-generate a registration certificate with the "
+			"newly generated identity key, and re-register this "
+			"zkey client with the EKMF Web server.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "EKMFWEB SPECIFIC OPTIONS FOR CERTIFICATE GENERATION",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "gen-csr", required_argument, NULL, 'c'},
+		.argument = "CSR-PEM-FILE",
+		.desc = "Generate a certificate signing request (CSR) with the "
+			"identity key and store it into the specified PEM "
+			"file. You pass this CSR to a certificate authority "
+			"(CA) to have it issue a CA signed certificate for the "
+			"EKMF Web plugin. You need to register the certificate "
+			"with EKMF Web before you can access EKMF Web.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "gen-self-signed-cert", required_argument, NULL,
+			    'C'},
+		.argument = "CERT-PEM-FILE",
+		.desc = "Generate a self signed certificate with the "
+			"identity key and store it into the specified PEM "
+			"file. You need to register the certificate with EKMF "
+			"Web before you can access EKMF Web.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "cert-subject", required_argument, NULL, 's'},
+		.argument = "SUBJECT-RDNS",
+		.desc = "The subject name for generating a certificate signing "
+			"request (CSR) or self signed certificate, in the form "
+			"'<type>=<value>(;<type>=<value>)*[;]' with types "
+			"recognized by OpenSSL.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "cert-extensions", required_argument, NULL, 'e'},
+		.argument = "EXTENSIONS",
+		.desc = "The certificate extensions for generating a "
+			"certificate signing request (CSR) or self signed "
+			"certificate, in the form '<name>=[critical,]<value(s)>"
+			" (;<name>=[critical,]<value(s)>)*[;]' with extension "
+			"names and values recognized by OpenSSL.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "renew-cert", required_argument, NULL, 'N'},
+		.argument = "CERT-PEM-FILE",
+		.desc = "An existing PEM file containing the certificate to be "
+			"renewed. The certificate's subject name and extensions"
+			" are used to generate the certificate signing request "
+			"(CSR) or renewed self signed certificate.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "csr-new-header", 0, NULL, 'n'},
+		.desc = "Adds the word NEW to the PEM file header and footer "
+			"lines on the certificate signing request. Some "
+			"software and some CAs need this.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "cert-validity-days", required_argument, NULL, 'd'},
+		.argument = "DAYS",
+		.desc = "The number of days to certify the self signed "
+			"certificate. The default is 30 days.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "cert-digest", required_argument, NULL, 'D'},
+		.argument = "DIGEST",
+		.desc = "The digest algorithm to use when generating a "
+			"certificate signing request or self signed "
+			"certificate. The default is determined by OpenSSL.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+#ifdef EKMF_SUPPORTS_RSA_PSS_CERTIFICATES
+	{
+		.option = { "cert-rsa-pss", 0, NULL, 'P'},
+		.desc = "Use the RSA-PSS algorithm to sign the certificate "
+			"signing request or the self signed certificate. This "
+			"option is only honored when the identity key type is "
+			"RSA, it is ignored otherwise.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+#endif
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "EKMFWEB SPECIFIC OPTIONS FOR REGISTRATION",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "register", required_argument, NULL, 'r'},
+		.argument = "CERT-FILE",
+		.desc = "Register the zkey client with EKMF Web by generating "
+			"an identity key in EKMF Web using the certificate "
+			"from the specified file. Supported certificate files "
+			"formats are .pem, .crt, .cert, .cer, and .der (i.e. "
+			"either base64 or DER encoded). If you want to "
+			"register a self signed certificate that you are about "
+			"to generate using option '--gen-self-signed-cert', "
+			"then specify the same certificate file name here, "
+			"and the generated certificate is registered "
+			"right away.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "label-tags", required_argument, NULL, 'T'},
+		.argument = "LABEL-TAGS",
+		.desc = "The label tags for generating the identity key in "
+			"EKMF Web when registering the zkey client, in the "
+			"form '<tag>=<value>(,<tag>=<value>)*[,]' with tags as "
+			"defined by the key template. Use 'zkey kms info' to "
+			"display the key templates used by zkey. For "
+			"registration, the template for identity keys is used.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "EKMFWEB SPECIFIC OPTIONS FOR KEY TRANSPORT",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "session-rsa-sign-digest", required_argument, NULL,
+						OPT_KT_RSA_SIGNATURE_DIGEST },
+		.argument = "DIGEST",
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.desc = "The digest algorithm to use for signing the key "
+			"transport request, when the identity key type is "
+			"RSA. Ignored otherwise. The default is SHA512.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.option = { "session-rsa-sign-algo", required_argument, NULL,
+						OPT_KT_RSA_PSS_SIGNATURE },
+		.argument = "ALGORITHM",
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+		.desc = "The algorithm to use for signing the key transport "
+			"request, when the identity key type is RSA, ignored "
+			"otherwise. Supported algorithms are 'RSA'and "
+			"'RSA-PSS'.",
+		.command = KMS_COMMAND_CONFIGURE,
+	},
+#endif
+	UTIL_OPT_END,
+};
+
+static const struct util_opt generate_options[] = {
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "EKMFWEB SPECIFIC OPTIONS",
+		.command = KMS_COMMAND_GENERATE,
+	},
+	{
+		.option = { "label-tags", required_argument, NULL, 'T'},
+		.argument = "LABEL-TAGS",
+		.desc = "The label tags for generating a secure key in EKMF "
+			"Web, in the form '<tag>=<value>(,<tag>=<value>)*[,]' "
+			"with tags as defined by the key template. Use 'zkey "
+			"kms info' to display the key templates used by zkey. "
+			"For XTS type keys the two templates for XTS-Key1 and "
+			"XTS-Key2 are used. For non-XTS type keys, the "
+			"template for Non-XTS keys is used.",
+		.command = KMS_COMMAND_GENERATE,
+	},
+	UTIL_OPT_END,
+};
+
+static const struct util_opt remove_options[] = {
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "EKMFWEB SPECIFIC OPTIONS",
+		.command = KMS_COMMAND_REMOVE,
+	},
+	{
+		.option = { "state", required_argument, NULL, 's'},
+		.argument = "STATE",
+		.desc = "The state to which to change the key in EKMF Web, "
+			"after removing the secure key from the local secure "
+			"key repository. Possible states are 'DEACTIVATED', "
+			"'COMPROMISED', 'DESTROYED', and "
+			"'DESTROYED-COMPROMISED'. If this option is not "
+			"specified, the state of the key in EKMF Web is not "
+			"changed, but the key is removed from the local "
+			"secure key repository only.",
+		.command = KMS_COMMAND_REMOVE,
+	},
+	UTIL_OPT_END,
+};
+
+static const struct util_opt list_options[] = {
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "EKMFWEB SPECIFIC OPTIONS",
+		.command = KMS_COMMAND_LIST,
+	},
+	{
+		.option = { "states", required_argument, NULL, 's'},
+		.argument = "STATES",
+		.desc = "The states of the keys that are to be listed. "
+			"Multiple states can be separated by comma. Possible "
+			"states are 'PRE-ACTIVATION', 'ACTIVE', 'DEACTIVATED', "
+			"'COMPROMISED', 'DESTROYED', and "
+			"'DESTROYED-COMPROMISED'. If this "
+			"option is not specified, only keys in state 'ACTIVE' "
+			"are listed.",
+		.command = KMS_COMMAND_LIST,
+	},
+	{
+		.option = { "all", 0, NULL, 'a'},
+		.desc = "List all keys that can be used for volume encryption. "
+			"If this option is not specified, then only volume "
+			"encryption keys that are allowed to be exported by "
+			"EKMF Web using the identity key of this zkey client "
+			"are listed.",
+		.command = KMS_COMMAND_LIST,
+	},
+	UTIL_OPT_END,
+};
+
+/**
+ * Returns a list of KMS specific command line options that zkey should accept
+ * and pass to the appropriate KMS plugin function. The option list must be
+ * terminated by an UTIL_OPT_END entry (see util_opt.h). The options returned
+ * must not interfere with the already defined options of the zkey command.
+ * Field 'command' of the returned options should either be NULL or specify
+ * the command that it is for.
+ *
+ * If max_opts is not -1, then only up to max_opts options are allowed. If more
+ * options are returned, only up to max_opts options are used by zkey.
+ *
+ * @param command           the command for which the KMS-specific options are
+ *                          to be returned, see KMS_COMMAND_xxx defines
+ * @param max_opts          maximum number of options allowed. If -1 then there
+ *                          is no limit.
+ *
+ * @returns a list of options terminated by an UTIL_OPT_END entry, or NULL in
+ * case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+const struct util_opt *kms_get_command_options(const char *command,
+					       int UNUSED(max_opts))
+{
+	util_assert(command != NULL, "Internal error: command is NULL");
+
+	if (strcasecmp(command, KMS_COMMAND_CONFIGURE) == 0)
+		return configure_options;
+	if (strcasecmp(command, KMS_COMMAND_GENERATE) == 0)
+		return generate_options;
+	if (strcasecmp(command, KMS_COMMAND_REMOVE) == 0)
+		return remove_options;
+	if (strcasecmp(command, KMS_COMMAND_LIST) == 0)
+		return list_options;
+
+	return NULL;
+}
+
+/**
+ * Queries the APKA master key states and verification patterns of the current
+ * CCA adapter
+ *
+ * @param ph               the plugin handle
+ * @param cca              the CCA library structure
+ * @param apka_mk_info     the master key info of the APKA master key
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _get_cca_apka_mk_info(struct plugin_handle *ph, struct cca_lib *cca,
+				 struct mk_info *apka_mk_info)
+{
+	long exit_data_len = 0, rule_array_count, verb_data_length = 0;
+	unsigned char rule_array[16 * 8] = { 0, };
+	unsigned char exit_data[4] = { 0, };
+	long return_code, reason_code;
+	struct cca_staticsb {
+		u16	sym_old_mk_mdc4_len;
+		u16	sym_old_mk_mdc4_id;
+		u8	sym_old_mk_mdc4_hp[16];
+		u16	sym_cur_mk_mdc4_len;
+		u16	sym_cur_mk_mdc4_id;
+		u8	sym_cur_mk_mdc4_hp[16];
+		u16	sym_new_mk_mdc4_len;
+		u16	sym_new_mk_mdc4_id;
+		u8	sym_new_mk_mdc4_hp[16];
+		u16	asym_old_mk_mdc4_len;
+		u16	asym_old_mk_mdc4_id;
+		u8	asym_old_mk_mdc4_hp[16];
+		u16	asym_cur_mk_mdc4_len;
+		u16	asym_cur_mk_mdc4_id;
+		u8	asym_cur_mk_mdc4_hp[16];
+		u16	asym_new_mk_mdc4_len;
+		u16	asym_new_mk_mdc4_id;
+		u8	asym_new_mk_mdc4_hp[16];
+		u16	sym_old_mk_vp_len;
+		u16	sym_old_mk_vp_id;
+		u8	sym_old_mk_vp[8];
+		u16	sym_cur_mk_vp_len;
+		u16	sym_cur_mk_vp_id;
+		u8	sym_cur_mk_vp[8];
+		u16	sym_new_mk_vp_len;
+		u16	sym_new_mk_vp_id;
+		u8	sym_new_mk_vp[8];
+		u16	sym_new_mk_mkap_len;
+		u16	sym_new_mk_mkap_id;
+		u8	sym_new_mk_mkap[8];
+		u16	aes_old_mk_vp_len;
+		u16	aes_old_mk_vp_id;
+		u8	aes_old_mk_vp[8];
+		u16	aes_cur_mk_vp_len;
+		u16	aes_cur_mk_vp_id;
+		u8	aes_cur_mk_vp[8];
+		u16	aes_new_mk_vp_len;
+		u16	aes_new_mk_vp_id;
+		u8	aes_new_mk_vp[8];
+		u16	apka_old_mk_vp_len;
+		u16	apka_old_mk_vp_id;
+		u8	apka_old_mk_vp[8];
+		u16	apka_cur_mk_vp_len;
+		u16	apka_cur_mk_vp_id;
+		u8	apka_cur_mk_vp[8];
+		u16	apka_new_mk_vp_len;
+		u16	apka_new_mk_vp_id;
+		u8	apka_new_mk_vp[8];
+	} statis_csb = { 0 };
+
+	util_assert(cca != NULL, "Internal error: cca is NULL");
+	util_assert(apka_mk_info != NULL,
+		    "Internal error: apka_mk_info is NULL");
+
+	memset(apka_mk_info, 0, sizeof(struct mk_info));
+
+	memset(rule_array, 0, sizeof(rule_array));
+	memcpy(rule_array, "STATICSB", 8);
+	rule_array_count = 1;
+
+	verb_data_length = sizeof(statis_csb);
+
+	cca->dll_CSUACFQ(&return_code, &reason_code,
+			 &exit_data_len, exit_data,
+			 &rule_array_count, rule_array,
+			 &verb_data_length, (unsigned char *)&statis_csb);
+
+	pr_verbose(ph, "CSUACFQ (Cryptographic Facility Query) returned: "
+		   "return_code: %ld, reason_code: %ld", return_code,
+		   reason_code);
+	if (return_code != 0)
+		return -EIO;
+
+	switch (rule_array[10 * 8]) {
+	case '3':
+		apka_mk_info->new_mk.mk_state = MK_STATE_FULL;
+		break;
+	case '2':
+		apka_mk_info->new_mk.mk_state = MK_STATE_PARTIAL;
+		break;
+	case '1':
+	default:
+		apka_mk_info->new_mk.mk_state = MK_STATE_EMPTY;
+		break;
+	}
+	memcpy(apka_mk_info->new_mk.mkvp, statis_csb.apka_new_mk_vp,
+	       sizeof(statis_csb.apka_new_mk_vp));
+
+	switch (rule_array[11 * 8]) {
+	case '2':
+		apka_mk_info->cur_mk.mk_state = MK_STATE_VALID;
+		break;
+	case '1':
+	default:
+		apka_mk_info->cur_mk.mk_state = MK_STATE_INVALID;
+		break;
+	}
+	memcpy(apka_mk_info->cur_mk.mkvp, statis_csb.apka_cur_mk_vp,
+	       sizeof(statis_csb.apka_cur_mk_vp));
+
+	switch (rule_array[12 * 8]) {
+	case '2':
+		apka_mk_info->old_mk.mk_state = MK_STATE_VALID;
+		break;
+	case '1':
+	default:
+		apka_mk_info->old_mk.mk_state = MK_STATE_INVALID;
+		break;
+	}
+	memcpy(apka_mk_info->old_mk.mkvp, statis_csb.apka_old_mk_vp,
+	       sizeof(statis_csb.apka_old_mk_vp));
+
+	return 0;
+}
+
+/**
+ * Print the APKA master key infos of the selected APQNs
+ *
+ * @param ph                the plugin handle
+ * @param cca               CCA library structure
+ * @param apqns             a list of APQNs
+ * @param num_apqns         number of APQNs in above array
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+
+static int _print_apka_mks(struct plugin_handle *ph, struct cca_lib *cca,
+			   const struct kms_apqn *apqns, size_t num_apqns)
+{
+	struct mk_info mk_info;
+	struct util_rec *rec;
+	enum card_type type;
+	int rc = 0, level;
+	size_t i;
+
+	rec = util_rec_new_wide("-");
+	util_rec_def(rec, "APQN", UTIL_REC_ALIGN_LEFT, 11, "CARD.DOMAIN");
+	util_rec_def(rec, "NEW", UTIL_REC_ALIGN_LEFT, 16, "NEW APKA MK");
+	util_rec_def(rec, "CUR", UTIL_REC_ALIGN_LEFT, 16, "CURRENT APKA MK");
+	util_rec_def(rec, "OLD", UTIL_REC_ALIGN_LEFT, 16, "OLD APKA MK");
+	util_rec_def(rec, "TYPE", UTIL_REC_ALIGN_LEFT, 6, "TYPE");
+	util_rec_print_hdr(rec);
+
+	for (i = 0; i < num_apqns; i++) {
+		rc = select_cca_adapter(cca, apqns[i].card, apqns[i].domain,
+					ph->verbose);
+		if (rc != 0) {
+			_set_error(ph, "Failed to select APQN %02x.%04x: %s",
+				   apqns[i].card, apqns[i].domain,
+				   strerror(-rc));
+			goto out;
+		}
+
+		rc = _get_cca_apka_mk_info(ph, cca, &mk_info);
+		if (rc != 0) {
+			_set_error(ph, "Failed to get the APKA master key "
+				   "infos for APQN %02x.%04x: %s",
+				   apqns[i].card, apqns[i].domain,
+				   strerror(-rc));
+			goto out;
+		}
+
+		level = sysfs_get_card_level(apqns[i].card);
+		type = sysfs_get_card_type(apqns[i].card);
+
+		util_rec_set(rec, "APQN", "%02x.%04x", apqns[i].card,
+			     apqns[i].domain);
+
+		if (mk_info.new_mk.mk_state == MK_STATE_FULL ||
+		    mk_info.new_mk.mk_state == MK_STATE_COMMITTED)
+			util_rec_set(rec, "NEW", "%s",
+				     printable_mkvp(type, mk_info.new_mk.mkvp));
+		else if (mk_info.new_mk.mk_state == MK_STATE_PARTIAL)
+			util_rec_set(rec, "NEW", "partially loaded");
+		else if (mk_info.new_mk.mk_state == MK_STATE_UNCOMMITTED)
+			util_rec_set(rec, "NEW", "uncommitted");
+		else
+			util_rec_set(rec, "NEW", "-");
+
+		if (mk_info.cur_mk.mk_state ==  MK_STATE_VALID)
+			util_rec_set(rec, "CUR", "%s",
+				     printable_mkvp(type, mk_info.cur_mk.mkvp));
+		else
+			util_rec_set(rec, "CUR", "-");
+
+		if (mk_info.old_mk.mk_state ==  MK_STATE_VALID)
+			util_rec_set(rec, "OLD", "%s",
+				     printable_mkvp(type, mk_info.old_mk.mkvp));
+		else
+			util_rec_set(rec, "OLD", "-");
+
+		if (level > 0 && type != CARD_TYPE_ANY)
+			util_rec_set(rec, "TYPE", "CEX%d%c", level,
+				     type == CARD_TYPE_CCA ? 'C' : 'P');
+		else
+			util_rec_set(rec, "TYPE", "?");
+
+		util_rec_print(rec);
+	}
+
+out:
+	util_rec_free(rec);
+
+	return rc;
+}
+
+/**
+ * Cross checks the APQNs associated with the plugin. Checks if the CCA master
+ * keys of all APQNs for the APKA master key are the same.
+ *
+ * @param ph                the plugin handle
+ * @param apqns             a list of APQNs
+ * @param num_apqns         number of APQNs in above array
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _cross_check_apqns(struct plugin_handle *ph,
+			      const struct kms_apqn *apqns, size_t num_apqns)
+{
+	u8 new_mkvp[MKVP_LENGTH] = { 0, };
+	u8 mkvp[MKVP_LENGTH] = { 0, };
+	struct cca_lib cca = { 0 };
+	struct mk_info mk_info;
+	bool mismatch = false;
+	bool print = false;
+	int rc = -ENODEV;
+	char temp[200];
+	size_t i;
+
+	for (i = 0; i < num_apqns; i++) {
+		rc = select_cca_adapter(&cca, apqns[i].card, apqns[i].domain,
+					ph->verbose);
+		if (rc != 0) {
+			_set_error(ph, "Failed to select APQN %02x.%04x: %s",
+				   apqns[i].card, apqns[i].domain,
+				   strerror(-rc));
+			goto out;
+		}
+
+		rc = _get_cca_apka_mk_info(ph, &cca, &mk_info);
+		if (rc != 0) {
+			_set_error(ph, "Failed to get the APKA master key "
+				   "infos for APQN %02x.%04x: %s",
+				   apqns[i].card, apqns[i].domain,
+				   strerror(-rc));
+			goto out;
+		}
+
+		if (mk_info.new_mk.mk_state == MK_STATE_PARTIAL) {
+			print = true;
+			sprintf(temp, "INFO: APQN %02x.%04x: The NEW APKA "
+				"master key register is only partially loaded.",
+				apqns[i].card, apqns[i].domain);
+			util_print_indented(temp, 0);
+		}
+
+		if (MKVP_ZERO(new_mkvp) &&
+		    mk_info.new_mk.mk_state == MK_STATE_FULL)
+			memcpy(new_mkvp, mk_info.new_mk.mkvp, sizeof(new_mkvp));
+
+		if (mk_info.new_mk.mk_state == MK_STATE_FULL &&
+		    !MKVP_EQ(mk_info.new_mk.mkvp, new_mkvp)) {
+			print = true;
+			sprintf(temp, "WARNING: APQN %02x.%04x: The NEW APKA "
+				"master key register contains a different "
+				"master key than the NEW APKA register of "
+				"other APQNs.", apqns[i].card, apqns[i].domain);
+			util_print_indented(temp, 0);
+		}
+
+		if (mk_info.cur_mk.mk_state != MK_STATE_VALID) {
+			mismatch = true;
+			print = true;
+			printf("WARNING: APQN %02x.%04x: No APKA master key is "
+			       "set.\n", apqns[i].card, apqns[i].domain);
+			continue;
+		}
+
+		if (mk_info.old_mk.mk_state == MK_STATE_VALID &&
+		    MKVP_EQ(mk_info.old_mk.mkvp, mk_info.cur_mk.mkvp)) {
+			print = true;
+			sprintf(temp, "INFO: APQN %02x.%04x: The OLD APKA "
+				"master key register contains the same master "
+				"key as the CURRENT APKA master key register.",
+				apqns[i].card, apqns[i].domain);
+			util_print_indented(temp, 0);
+		}
+
+		if (mk_info.new_mk.mk_state == MK_STATE_FULL &&
+		    MKVP_EQ(mk_info.new_mk.mkvp, mk_info.cur_mk.mkvp)) {
+			print = true;
+			sprintf(temp, "INFO: APQN %02x.%04x: The NEW APKA "
+				"master key register contains the same master "
+				"key as the CURRENT APKA master key register.",
+				apqns[i].card, apqns[i].domain);
+			util_print_indented(temp, 0);
+		}
+
+		if (mk_info.new_mk.mk_state == MK_STATE_FULL &&
+		    mk_info.old_mk.mk_state == MK_STATE_VALID &&
+		    MKVP_EQ(mk_info.new_mk.mkvp, mk_info.old_mk.mkvp)) {
+			print = true;
+			sprintf(temp, "INFO: APQN %02x.%04x: The NEW APKA "
+				"master key register contains the same master "
+				"key as the OLD APKA master key register.",
+				apqns[i].card, apqns[i].domain);
+			util_print_indented(temp, 0);
+		}
+
+		if (MKVP_ZERO(mkvp))
+			memcpy(mkvp, mk_info.cur_mk.mkvp, sizeof(mkvp));
+
+		if (!MKVP_EQ(mk_info.cur_mk.mkvp, mkvp)) {
+			mismatch = true;
+			print = true;
+			sprintf(temp, "WARNING: APQN %02x.%04x: The CURRENT "
+				"APKA master key register contains a different "
+				"master key than the CURRENT APKA register of "
+				"other APQNs.", apqns[i].card, apqns[i].domain);
+			util_print_indented(temp, 0);
+		}
+	}
+
+	if (mismatch) {
+		_set_error(ph, "Your APKA master key setup is improper");
+		rc = -ENODEV;
+	}
+
+	if (print)
+		_print_apka_mks(ph, &cca, apqns, num_apqns);
+
+out:
+	if (cca.lib_csulcca != NULL)
+		dlclose(cca.lib_csulcca);
+
+	return rc;
+}
+
+/**
+ * Build an APQN string from an APQN array
+ *
+ * @param apqns           An array of APQNs
+ * @param num_apqns       The number of elements in above array
+ *
+ * @return an allocated string with the APQNs
+ */
+static char *_build_apqn_string(const struct kms_apqn *apqns, size_t num_apqns)
+{
+	char *apqn_str, *str;
+	size_t size, i;
+
+	if (num_apqns == 0) {
+		apqn_str = util_malloc(1);
+		*apqn_str = '\0';
+		return apqn_str;
+	}
+
+	size = num_apqns * 8; /* 'cc.dddd' plus ',' or '\0' */
+	apqn_str = util_malloc(size);
+
+	str = apqn_str;
+	for (i = 0; i < num_apqns; i++) {
+		if (i != 0) {
+			*str = ',';
+			str++;
+		}
+
+		sprintf(str, "%02x.%04x", apqns[i].card, apqns[i].domain);
+		str += 7;
+	}
+
+	return apqn_str;
+}
+
+/**
+ * Gets the OpenSSL curve NID from the infos from the identity template.
+ *
+ * @param ph                the plugin handle
+ * @param curve             the name of the curve from the template
+ * @param key_size          the size of the key in bits
+ *
+ * @returns the OpenSSL NID for the curve, or NID_undef in case of an error
+ */
+static int _get_curve_nid(struct plugin_handle *ph, const char *curve,
+			  size_t key_size)
+{
+	int nid = NID_undef;
+
+	if (strcmp(curve, EKMFWEB_CURVE_PRIME) == 0) {
+		switch (key_size) {
+		case 192:
+			nid = NID_X9_62_prime192v1;
+			break;
+		case 224:
+			nid = NID_secp224r1;
+			break;
+		case 256:
+			nid = NID_X9_62_prime256v1;
+			break;
+		case 384:
+			nid = NID_secp384r1;
+			break;
+		case 521:
+			nid = NID_secp521r1;
+			break;
+		default:
+			_set_error(ph, "Unsupported bit size %u of curve '%s'",
+				   key_size, curve);
+			goto out;
+		}
+	} else if (strcmp(curve, EKMFWEB_CURVE_BAINPOOL) == 0) {
+		switch (key_size) {
+		case 160:
+			nid = NID_brainpoolP160r1;
+			break;
+		case 192:
+			nid = NID_brainpoolP192r1;
+			break;
+		case 224:
+			nid = NID_brainpoolP224r1;
+			break;
+		case 256:
+			nid = NID_brainpoolP256r1;
+			break;
+		case 320:
+			nid = NID_brainpoolP320r1;
+			break;
+		case 384:
+			nid = NID_brainpoolP384r1;
+			break;
+		case 512:
+			nid = NID_brainpoolP512r1;
+			break;
+		default:
+			_set_error(ph, "Unsupported bit size %u of curve '%s'",
+				   key_size, curve);
+			goto out;
+		}
+	} else {
+		_set_error(ph, "Unsupported curve '%s'", curve);
+		goto out;
+	}
+
+out:
+	return nid;
+}
+
+struct template_cb_data {
+	const char *template;
+	struct ekmf_template_info **info;
+};
+
+/**
+ * Callback for ekmf_list_templates function to get template info by name
+ *
+ * @param curl_handle      a CURL handle that can be used to perform further
+ *                         EKMFWeb functions within the callback.
+ * @param template_info    a struct containing information about the template.
+ *                         If any of the information needs to be kept, then the
+ *                         callback function must make a copy of the
+ *                         information. The memory holding the information
+ *                         passed to the callback is no longer valid after the
+ *                         callback has returned.
+ * @param private          the private pointer that was specified with the
+ *                         ekmf_list_templates invocation.
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _template_cb(CURL *UNUSED(curl_handle),
+			struct ekmf_template_info *template_info,
+			void *private)
+{
+	struct template_cb_data *data = private;
+	int rc;
+
+	if (*data->info != NULL)
+		return 0;
+
+	if (strcmp(template_info->name, data->template) != 0)
+		return 0;
+
+	rc = ekmf_clone_template_info(template_info, data->info);
+
+	return rc;
+}
+
+/**
+ * Get information about a template by name
+ *
+ * @param ph                the plugin handle
+ * @param template          the name of the template
+ * @param info              On return: the template info. Must be freed by the
+ *                          caller via ekmf_free_template_info.
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _get_template_by_name(struct plugin_handle *ph, const char *template,
+				 struct ekmf_template_info **info)
+{
+	struct template_cb_data data;
+	char *error_msg = NULL;
+	int rc;
+
+	*info = NULL;
+
+	data.template = template;
+	data.info = info;
+
+	rc = ekmf_list_templates(&ph->ekmf_config, &ph->curl_handle,
+				 _template_cb, &data, template,
+				 EKMFWEB_TEMPLATE_STATE_ACTIVE,
+				 &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get the template '%s': %s", template,
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+	if (*info == NULL) {
+		rc = -ENOENT;
+		_set_error(ph, "Template '%s' does not exist", template);
+		goto out;
+	}
+
+out:
+	if (error_msg != NULL)
+		free(error_msg);
+
+	return rc;
+}
+
+/**
+ * Check a template if it is using the desired settings
+ *
+ * @param ph                the plugin handle
+ * @param info              the template info
+ * @param keystore_type     the expected keystore type
+ * @param no_warnig         if true, do not issue warning messages
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _check_template(struct plugin_handle *ph,
+			   struct ekmf_template_info *info,
+			   const char *keystore_type, bool no_warning)
+{
+	char *identity_key_param = NULL;
+	char *identity_key_alg = NULL;
+	size_t modulus_bits;
+	char *msg = NULL;
+	int curve_nid;
+	int rc = 0;
+
+	if (strcmp(info->state, EKMFWEB_TEMPLATE_STATE_ACTIVE) != 0) {
+		if (strcmp(info->state, EKMFWEB_TEMPLATE_STATE_HISTORY) == 0)
+			_set_error(ph, "Template '%s' is in state '%s'. "
+				   "If the template has been recently changed, "
+				   "run 'zkey kms configure --refresh-settings'"
+				   " to refresh the templates.", info->name,
+				   EKMFWEB_TEMPLATE_STATE_HISTORY);
+		else
+			_set_error(ph, "Template '%s' is in state '%s', "
+				   "but only templates in state '%s' can "
+				   "be used.", info->name, info->state,
+				   EKMFWEB_TEMPLATE_STATE_ACTIVE);
+		rc = -EINVAL;
+		goto out;
+	}
+
+	if (strcmp(info->key_state, EKMFWEB_KEY_STATE_ACTIVE) != 0) {
+		_set_error(ph, "Template '%s' generates key in state '%s', but "
+			   "only templates that generate keys in state '%s' "
+			   "are supported.", info->name, info->key_state,
+			   EKMFWEB_KEY_STATE_ACTIVE);
+		rc = -EINVAL;
+		goto out;
+	}
+
+	if (strcmp(info->keystore_type, keystore_type) != 0) {
+		_set_error(ph, "Template '%s' uses key store type '%s', but "
+			   "only key store type '%s' is supported for %s.",
+			   info->name, info->keystore_type, keystore_type,
+			   strcmp(keystore_type,
+				  EKMFWEB_KEYSTORE_TYPE_PERV_ENCR) == 0 ?
+				"volume encryption keys" : "identity keys");
+		rc = -EINVAL;
+		goto out;
+	}
+
+	if (strcmp(info->keystore_type, EKMFWEB_KEYSTORE_TYPE_PERV_ENCR) == 0) {
+		if (strcmp(info->key_type, EKMFWEB_KEY_TYPE_CIPHER) != 0) {
+			_set_error(ph, "Template '%s' generates keys of type "
+				   "'%s', but only key type '%s' is supported "
+				   "for volume encryption keys.",
+				   info->name, info->key_type,
+				   EKMFWEB_KEY_TYPE_CIPHER);
+			rc = -EINVAL;
+			goto out;
+		}
+
+		if (strcmp(info->algorithm, EKMFWEB_KEY_ALGORITHM_AES) != 0) {
+			_set_error(ph, "Template '%s' generates keys with "
+				   "algorithm '%s', but only algorithm '%s' is "
+				   "supported for volume encryption keys.",
+				   info->name, info->algorithm,
+				   EKMFWEB_KEY_ALGORITHM_AES);
+			rc = -EINVAL;
+			goto out;
+		}
+
+		if (info->export_allowed == false) {
+			_set_error(ph, "Template '%s' generates key that are "
+				   "not allowed to be exported, but only "
+				   "templates that generate keys that are "
+				   "allowed to be exported are supported for "
+				   "volume encryption keys.",
+				   info->name);
+			rc = -EINVAL;
+			goto out;
+		}
+	}
+
+	if (strcmp(info->keystore_type, EKMFWEB_KEYSTORE_TYPE_IDENTITY) == 0) {
+		if (strcmp(info->algorithm, EKMFWEB_KEY_ALGORITHM_ECC) != 0 &&
+		    strcmp(info->algorithm, EKMFWEB_KEY_ALGORITHM_RSA) != 0) {
+			_set_error(ph, "Template '%s' generates keys with "
+				   "algorithm '%s', but only algorithms '%s' "
+				   "and '%s' are supported for identity keys.",
+				   info->name, info->algorithm,
+				   EKMFWEB_KEY_ALGORITHM_ECC,
+				   EKMFWEB_KEY_ALGORITHM_RSA);
+			rc = -EINVAL;
+			goto out;
+		}
+
+		if (no_warning)
+			goto out;
+
+		identity_key_alg = properties_get(ph->properties,
+					EKMFWEB_CONFIG_IDENTITY_KEY_ALGORITHM);
+		if (identity_key_alg == NULL)
+			goto out;
+
+		if (strcmp(info->algorithm, identity_key_alg) != 0) {
+			util_asprintf(&msg, "WARNING: Template '%s' uses "
+				      "algorithm '%s', but the existing "
+				      "identity key uses algorithm '%s'. You "
+				      "may need to generate a new identity "
+				      "key and re-register this zkey client.",
+				      info->name, info->algorithm,
+				      identity_key_alg);
+			util_print_indented(msg, 0);
+			free(msg);
+			goto out;
+		}
+
+		identity_key_param = properties_get(ph->properties,
+					EKMFWEB_CONFIG_IDENTITY_KEY_PARAMS);
+		if (identity_key_param == NULL)
+			goto out;
+
+		if (strcmp(identity_key_alg, EKMFWEB_KEY_ALGORITHM_ECC) == 0) {
+			curve_nid = _get_curve_nid(ph, info->curve,
+						   info->key_size);
+			if (curve_nid == NID_undef) {
+				rc = -EINVAL;
+				goto out;
+			}
+			if (OBJ_txt2nid(identity_key_param) != curve_nid) {
+				util_asprintf(&msg, "WARNING: Template '%s' "
+					      "uses algorithm ECC with curve "
+					      "'%s', but the existing identity "
+					      "key uses curve '%s'. You may "
+					      "need to generate a new identity "
+					      "key and re-register this zkey "
+					      "client.", info->name,
+					      OBJ_nid2sn(curve_nid),
+					      identity_key_param);
+				util_print_indented(msg, 0);
+				free(msg);
+			}
+		} else if (strcmp(identity_key_alg, EKMFWEB_KEY_ALGORITHM_RSA)
+									== 0) {
+			modulus_bits = strtoul(identity_key_param, NULL, 10);
+			if (modulus_bits != info->key_size) {
+				util_asprintf(&msg, "WARNING: Template '%s' "
+					      "uses algorithm RSA with a "
+					      "modulus bit size of %lu, but "
+					      "the existing identity key uses "
+					      "%lu bits. You may need to "
+					      "generate a new identity key and "
+					      "re-register this zkey client.",
+					      info->name, info->key_size,
+					      modulus_bits);
+				util_print_indented(msg, 0);
+				free(msg);
+			}
+		}
+	}
+
+out:
+	if (identity_key_alg != NULL)
+		free(identity_key_alg);
+	if (identity_key_param != NULL)
+		free(identity_key_param);
+
+	return rc;
+}
+
+/**
+ * Check the 2 XTS templates
+ *
+ * @param ph                the plugin handle
+ * @param xts1_info         the template info if XTS key 1
+ * @param xts2_info         the template info if XTS key 2
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _check_xts_templates(struct plugin_handle *ph,
+				struct ekmf_template_info *xts1_info,
+				struct ekmf_template_info *xts2_info)
+{
+	size_t i;
+
+	if (strcasecmp(xts1_info->label_template,
+		       xts2_info->label_template) == 0) {
+		_set_error(ph, "The 2 XTS templates can not have the same "
+			   "label template.");
+		return -EINVAL;
+	}
+
+	if (xts1_info->key_size != xts2_info->key_size) {
+		_set_error(ph, "The 2 XTS templates must have the same key "
+			   "size.");
+		return -EINVAL;
+	}
+
+	if (xts1_info->label_tags.num_tag_defs !=
+				xts2_info->label_tags.num_tag_defs) {
+		_set_error(ph, "The 2 XTS templates must have the same label "
+			   "tags. The templates differ in the number of label "
+			   "tags: '%s' '%s'", xts1_info->label_template,
+			   xts2_info->label_template);
+		return -EINVAL;
+	}
+
+	for (i = 0; i < xts1_info->label_tags.num_tag_defs; i++) {
+		if (strcasecmp(xts1_info->label_tags.tag_defs[i].name,
+			       xts2_info->label_tags.tag_defs[i].name) != 0) {
+			_set_error(ph, "The 2 XTS templates must have the same "
+				   "label tags. Mismatch in tag '%s': "
+				   "'%s' '%s'",
+				   xts1_info->label_tags.tag_defs[i].name,
+				   xts1_info->label_template,
+				   xts2_info->label_template);
+			return -EINVAL;
+		}
+	}
+
+	return 0;
+}
+
+struct template_infos {
+	char *template;
+	struct ekmf_template_info *info;
+	const char *name_prop;
+	const char *label_prop;
+	const char *id_prop;
+	const char *keystore_type;
+};
+
+#define NUM_TEMPLATES		4
+#define IDENTITY		0
+#define XTS1			1
+#define XTS2			2
+#define NONXTS			3
+
+/**
+ * Retrieves the key templates to be used by the plugin
+ *
+ * @param ph                the plugin handle
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _get_templates(struct plugin_handle *ph)
+{
+	struct template_infos tmpl[NUM_TEMPLATES] = {
+		{ .template = NULL, .info = NULL,
+		  .name_prop = EKMFWEB_CONFIG_TEMPLATE_IDENTITY,
+		  .label_prop = EKMFWEB_CONFIG_TEMPLATE_IDENTITY_LABEL,
+		  .id_prop = EKMFWEB_CONFIG_TEMPLATE_IDENTITY_ID,
+		  .keystore_type = EKMFWEB_KEYSTORE_TYPE_IDENTITY, },
+		{ .template = NULL, .info = NULL,
+		  .name_prop = EKMFWEB_CONFIG_TEMPLATE_XTS1,
+		  .label_prop = EKMFWEB_CONFIG_TEMPLATE_XTS1_LABEL,
+		  .id_prop = EKMFWEB_CONFIG_TEMPLATE_XTS1_ID,
+		  .keystore_type = EKMFWEB_KEYSTORE_TYPE_PERV_ENCR, },
+		{ .template = NULL, .info = NULL,
+		  .name_prop = EKMFWEB_CONFIG_TEMPLATE_XTS2,
+		  .label_prop = EKMFWEB_CONFIG_TEMPLATE_XTS2_LABEL,
+		  .id_prop = EKMFWEB_CONFIG_TEMPLATE_XTS2_ID,
+		  .keystore_type = EKMFWEB_KEYSTORE_TYPE_PERV_ENCR, },
+		{ .template = NULL, .info = NULL,
+		  .name_prop = EKMFWEB_CONFIG_TEMPLATE_NONXTS,
+		  .label_prop = EKMFWEB_CONFIG_TEMPLATE_NONXTS_LABEL,
+		  .id_prop = EKMFWEB_CONFIG_TEMPLATE_NONXTS_ID,
+		  .keystore_type = EKMFWEB_KEYSTORE_TYPE_PERV_ENCR, },
+	};
+	char *error_msg = NULL;
+	int t, rc;
+
+	rc = ekmf_get_settings(&ph->ekmf_config, &ph->curl_handle,
+			       &tmpl[IDENTITY].template, &tmpl[XTS1].template,
+			       &tmpl[XTS2].template, &tmpl[NONXTS].template,
+			       &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get settings from EKMF Web: %s",
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		goto out;
+	}
+
+	for (t = 0; t < NUM_TEMPLATES; t++) {
+		rc = _get_template_by_name(ph, tmpl[t].template, &tmpl[t].info);
+		if (rc != 0)
+			goto out;
+	}
+
+	rc = _check_xts_templates(ph, tmpl[XTS1].info, tmpl[XTS2].info);
+	if (rc != 0)
+		goto out;
+
+	for (t = 0; t < NUM_TEMPLATES; t++) {
+		rc = _check_template(ph, tmpl[t].info, tmpl[t].keystore_type,
+				     false);
+		if (rc != 0)
+			goto out;
+
+		rc = _set_or_remove_property(ph, tmpl[t].name_prop,
+					     tmpl[t].template);
+		if (rc != 0)
+			goto out;
+		rc = _set_or_remove_property(ph, tmpl[t].label_prop,
+					     tmpl[t].info->label_template);
+		if (rc != 0)
+			goto out;
+		rc = _set_or_remove_property(ph, tmpl[t].id_prop,
+					     tmpl[t].info->uuid);
+		if (rc != 0)
+			goto out;
+	}
+
+out:
+	for (t = 0; t < NUM_TEMPLATES; t++) {
+		if (tmpl[t].info != NULL)
+			ekmf_free_template_info(tmpl[t].info);
+		if (tmpl[t].template != NULL)
+			free(tmpl[t].template);
+	}
+	if (error_msg != NULL)
+		free(error_msg);
+
+	return rc;
+}
+
+/**
+ * Retrieves the EKMF Web system settings. This requires a login. If no
+ * valid login token is available, a login is performed.
+ *
+ * @param ph                the plugin handle
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _get_ekmfweb_settings(struct plugin_handle *ph)
+{
+	int rc, type = 0, curve = NID_undef;
+	char *error_msg = NULL;
+
+	_check_config_complete(ph);
+
+	if (ph->ekmf_config.login_token != NULL) {
+		remove(ph->ekmf_config.login_token);
+		FREE_AND_SET_NULL(ph->ekmf_config.login_token);
+	}
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_LOGIN_TOKEN, NULL);
+	if (rc != 0)
+		goto out;
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_PASSCODE_URL, NULL);
+	if (rc != 0)
+		goto out;
+
+	rc = ekmf_check_feature(&ph->ekmf_config, &ph->curl_handle,
+				&error_msg, ph->verbose);
+	if (rc != 0) {
+		if (rc == -ENOTSUP)
+			_set_error(ph, "%s", error_msg);
+		else
+			_set_error(ph, "Failed to check the features of the "
+				   "EKMF Web server at '%s': %s",
+				   ph->ekmf_config.base_url,
+				   error_msg != NULL ? error_msg :
+							   strerror(-rc));
+		goto out;
+	}
+
+	rc = kms_login((kms_handle_t)ph);
+	if (rc != 0)
+		goto out;
+
+	if (ph->ekmf_config.ekmf_server_pubkey != NULL)
+		remove(ph->ekmf_config.ekmf_server_pubkey);
+	FREE_AND_SET_NULL(ph->ekmf_config.ekmf_server_pubkey);
+
+	util_asprintf((char **)&ph->ekmf_config.ekmf_server_pubkey,
+		      "%s/%s", ph->config_path,
+		      EKMFWEB_CONFIG_EKMFWEB_PUBKEY_FILE);
+
+	rc = ekmf_get_public_key(&ph->ekmf_config, &ph->curl_handle,
+				 &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get the public key of the EKMF Web "
+			   "server at '%s': %s", ph->ekmf_config.base_url,
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	rc = _set_file_permission(ph, ph->ekmf_config.ekmf_server_pubkey);
+	if (rc != 0)
+		goto out;
+
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_EKMFWEB_PUBKEY,
+				     ph->ekmf_config.ekmf_server_pubkey);
+	if (rc != 0)
+		goto out;
+
+	rc = _get_pub_key_info(ph, ph->ekmf_config.ekmf_server_pubkey, &type,
+			       &curve, NULL);
+	if (rc != 0)
+		goto out;
+	if (type != EVP_PKEY_EC || curve == NID_undef)
+		curve = NID_secp521r1;
+
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_SESSION_KEY_CURVE,
+				     OBJ_nid2sn(curve));
+	if (rc != 0)
+		goto out;
+
+	rc = _get_templates(ph);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (error_msg != NULL)
+		free(error_msg);
+
+	return rc;
+}
+
+/**
+ * Check if the certificate is a self signed certificate, and if it is expired
+ * or not yet valid.
+ *
+ * @param ph                the plugin handle
+ * @param cert_file         the file name of the PEM file containing the cert
+ * @param self_signed       on return: true if the cetr is a self signed cert
+ * @param valid             on return: false if the cert is expired or not yet
+ *                          valid
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _check_certificate(struct plugin_handle *ph,
+			      const char *cert_file, bool *self_signed,
+			      bool *valid)
+{
+	X509 *cert;
+	FILE *fp;
+	int rc;
+
+	fp = fopen(cert_file, "r");
+	if (fp == NULL) {
+		rc = -errno;
+		_set_error(ph, "Failed to open certificate PEM file '%s': %s",
+			   cert_file, strerror(-rc));
+		return rc;
+	}
+
+	cert = PEM_read_X509(fp, NULL, NULL, NULL);
+	fclose(fp);
+
+	if (cert == NULL) {
+		_set_error(ph, "Failed to read certificate PEM file '%s'",
+			   cert_file);
+		return -EIO;
+	}
+
+
+	*self_signed = (X509_NAME_cmp(X509_get_subject_name(cert),
+				      X509_get_issuer_name(cert)) == 0);
+
+	*valid = (X509_cmp_current_time(X509_get0_notBefore(cert)) < 0 &&
+		  X509_cmp_current_time(X509_get0_notAfter(cert)) > 0);
+
+	X509_free(cert);
+
+	return 0;
+}
+
+/**
+ * Configures the connection to the EKMF Web server
+ *
+ * @param ph                the plugin handle
+ * @param ekmfweb_url       the URL of the EKMF Web server
+ * @param tls_ca_bundle     the file or directory name of the CA bundle to use
+ * @param tls_client_cert   the file name of the client certificate
+ * @param tls_client_key   the file name of the client private key
+ * @param tls_client_key_passphrase   the passphrase to unlock the key
+ * @param tls_pin_server_pubkey if true, pin the server public key
+ * @param tls_trust_server_cert if true, trust the server certificate
+ * @param tls_dont_verify_server_cert if true, don't verify the server cert
+ * @param tls_verify_hostname if true verify the server's hostname
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _configure_connection(struct plugin_handle *ph,
+				 const char *ekmfweb_url,
+				 const char *tls_ca_bundle,
+				 const char *tls_client_cert,
+				 const char *tls_client_key,
+				 const char *tls_client_key_passphrase,
+				 bool tls_pin_server_pubkey,
+				 bool tls_trust_server_cert,
+				 bool tls_dont_verify_server_cert,
+				 bool tls_verify_hostname)
+{
+	char *server_pubkey_temp = NULL;
+	char *server_pubkey_file = NULL;
+	char *server_cert_file = NULL;
+	char *server_cert_temp = NULL;
+	bool self_signed = false;
+	bool add_https = false;
+	bool verified = false;
+	bool valid = false;
+	char *error = NULL;
+	char *url = NULL;
+	int rc = 0;
+	char *tmp;
+
+	if (tls_client_cert != NULL && tls_client_key == NULL) {
+		_set_error(ph, "Option '--tls-client-key' is required when "
+			   "option '--tls-client-cert' is specified.");
+		return -EINVAL;
+	}
+	if (tls_client_key != NULL && tls_client_cert == NULL) {
+		_set_error(ph, "Option '--tls-client-cert' is required when "
+			   "option '--tls-client-key' is specified.");
+		return -EINVAL;
+	}
+	if (tls_client_key_passphrase != NULL && tls_client_key == NULL) {
+		_set_error(ph, "Option '--tls-client-key-passphrase' is only "
+			   "valid together with option "
+			   "'--tls-client-key'.");
+		return -EINVAL;
+	}
+	if (tls_pin_server_pubkey && tls_trust_server_cert) {
+		_set_error(ph, "Option ' --tls-pin-server-pubkey' is not valid "
+			   "together with option '--tls-pin-server-cert");
+		return -EINVAL;
+	}
+
+	if (ph->ekmf_config.base_url != NULL) {
+		util_print_indented("ATTENTION: The EKMF Web server connection "
+				    "has already been configured!\n"
+				    "When you re-configure the EKMF Web server "
+				    "connection, you may need to re-register "
+				    "this zkey client with the changed EKMF "
+				    "Web server.", 0);
+		printf("%s: Re-configure the EKMF Web server connection "
+		       "[y/N]? ",
+		       program_invocation_short_name);
+		if (!prompt_for_yes(ph->verbose)) {
+			_set_error(ph, "Opertion aborted by user");
+			return -ECANCELED;
+		}
+	}
+
+	if (strncmp(ekmfweb_url, "http://", 6) == 0) {
+		_set_error(ph, "The use of insecured HTTP is not allowed.");
+		return -EINVAL;
+	}
+
+	if (strncmp(ekmfweb_url, "https://", 7) != 0)
+		add_https = true;
+
+	util_asprintf(&url, "%s%s", add_https ? "https://" : "", ekmfweb_url);
+	if (url[strlen(url) - 1] == '/')
+		url[strlen(url) - 1] = '\0';
+
+	pr_verbose(ph, "url: '%s'", url);
+
+	FREE_AND_SET_NULL(ph->ekmf_config.base_url);
+	ph->ekmf_config.base_url = url;
+
+	rc = properties_set(ph->properties, EKMFWEB_CONFIG_URL, url);
+	if (rc != 0) {
+		_set_error(ph, "Failed to set URL property: "
+			   "%s", strerror(-rc));
+		goto out;
+	}
+
+	FREE_AND_SET_NULL(ph->ekmf_config.tls_ca);
+	if (tls_ca_bundle != NULL)
+		ph->ekmf_config.tls_ca = util_strdup(tls_ca_bundle);
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_CA_BUNDLE,
+				     tls_ca_bundle);
+
+	FREE_AND_SET_NULL(ph->ekmf_config.tls_client_cert);
+	if (tls_client_cert != NULL)
+		ph->ekmf_config.tls_client_cert = util_strdup(tls_client_cert);
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_CLIENT_CERT,
+				     tls_client_cert);
+	if (rc != 0)
+		goto out;
+
+	FREE_AND_SET_NULL(ph->ekmf_config.tls_client_key);
+	if (tls_client_key != NULL)
+		ph->ekmf_config.tls_client_key = util_strdup(tls_client_key);
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_CLIENT_KEY,
+				     tls_client_key);
+	if (rc != 0)
+		goto out;
+
+	tmp = NULL;
+	FREE_AND_SET_NULL(ph->ekmf_config.tls_client_key_passphrase);
+	if (tls_client_key_passphrase != NULL) {
+		ph->ekmf_config.tls_client_key_passphrase =
+				util_strdup(tls_client_key_passphrase);
+		tmp = _encode_passphrase(tls_client_key_passphrase);
+		if (tmp == NULL) {
+			_set_error(ph, "Failed to encode the passphrase");
+			rc = -EIO;
+			goto out;
+		}
+	}
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_CLIENT_KEY_PASSPHRASE,
+				     tmp);
+	if (tmp != NULL)
+		free(tmp);
+	if (rc != 0)
+		goto out;
+
+	util_asprintf(&server_cert_temp, "%s/%s-tmp", ph->config_path,
+		      EKMFWEB_CONFIG_SERVER_CERT_FILE);
+	util_asprintf(&server_pubkey_temp, "%s/%s-tmp", ph->config_path,
+		      EKMFWEB_CONFIG_SERVER_PUBKEY_FILE);
+
+	rc = ekmf_get_server_cert_chain(&ph->ekmf_config,
+					server_cert_temp,
+					server_pubkey_temp,
+					NULL, &verified,
+					&error, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to connect to EKMF Web server at '%s': "
+			   "%s", ph->ekmf_config.base_url,
+			   error != NULL ? error : strerror(-rc));
+		goto out;
+	}
+
+	rc = _check_certificate(ph, server_cert_temp, &self_signed, &valid);
+	if (rc != 0)
+		goto out;
+
+	pr_verbose(ph, "verified: %d", verified);
+	pr_verbose(ph, "self signed: %d", self_signed);
+	pr_verbose(ph, "valid: %d", valid);
+
+	util_print_indented("The EKMF Web server presented the following "
+			    "certificate to identify itself:", 0);
+
+	rc = ekmf_print_certificates(server_cert_temp, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to print the server certificate: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	printf("\n");
+	if (!valid)
+		printf("ATTENTION: The certificate is expired or not yet "
+		       "valid.\n");
+	if (self_signed) {
+		printf("ATTENTION: The certificate is self signed "
+			      "and thus could not be verified.\n");
+	} else if (!verified) {
+		if (!tls_dont_verify_server_cert) {
+			if (tls_ca_bundle != NULL)
+				_set_error(ph, "The certificate could not be "
+					   "verified using the specified CA "
+					   "bundle '%s'. Use option "
+					   "'--tls-dont-verify-server-cert' to "
+					   "connect to this server anyway.",
+					   tls_ca_bundle);
+			else
+				_set_error(ph, "The certificate could not be "
+					   "verified using the system's "
+					   "CA certificates. Use option "
+					   "'--tls-dont-verify-server-cert' to "
+					   "connect to this server anyway.");
+			rc = -EINVAL;
+			goto out;
+		}
+	}
+	printf("%s: Is this the EKMF Web server you intent to work with "
+	      "[y/N]? ", program_invocation_short_name);
+	if (!prompt_for_yes(ph->verbose)) {
+		_set_error(ph, "Opertion aborted by user");
+		rc = -ECANCELED;
+		goto out;
+	}
+
+	ph->ekmf_config.tls_verify_peer = !self_signed || tls_trust_server_cert;
+	if (tls_dont_verify_server_cert)
+		ph->ekmf_config.tls_verify_peer = false;
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_VERIFY_SERVER_CERT,
+				     ph->ekmf_config.tls_verify_peer ?
+						     "yes" : "no");
+	if (rc != 0)
+		goto out;
+
+	ph->ekmf_config.tls_verify_host = tls_verify_hostname;
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_VERIFY_HOSTNAME,
+				     ph->ekmf_config.tls_verify_host ?
+						     "yes" : "no");
+	if (rc != 0)
+		goto out;
+
+	rc = _get_ekmfweb_settings(ph);
+	if (rc != 0) {
+		util_print_indented("The server you are connected with is not "
+				     "a valid EKMF Web server, or is not "
+				     "configured properly", 0);
+		goto out;
+	}
+
+	FREE_AND_SET_NULL(ph->ekmf_config.tls_server_cert);
+	util_asprintf(&server_cert_file, "%s/%s", ph->config_path,
+		      EKMFWEB_CONFIG_SERVER_CERT_FILE);
+	if (tls_trust_server_cert) {
+		ph->ekmf_config.tls_server_cert = util_strdup(server_cert_file);
+		rc = _activate_temp_file(ph, server_cert_temp,
+					 server_cert_file);
+		if (rc != 0)
+			goto out;
+	} else {
+		remove(server_cert_file);
+	}
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_SERVER_CERT,
+				     tls_trust_server_cert ?
+						server_cert_file : NULL);
+	if (rc != 0)
+		goto out;
+
+	FREE_AND_SET_NULL(ph->ekmf_config.tls_pinned_pubkey);
+	util_asprintf(&server_pubkey_file, "%s/%s", ph->config_path,
+		      EKMFWEB_CONFIG_SERVER_PUBKEY_FILE);
+	if (tls_pin_server_pubkey) {
+		ph->ekmf_config.tls_pinned_pubkey =
+				util_strdup(server_pubkey_file);
+		rc = _activate_temp_file(ph, server_pubkey_temp,
+					 server_pubkey_file);
+		if (rc != 0)
+			goto out;
+	} else {
+		remove(server_pubkey_file);
+	}
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_SERVER_PUBKEY,
+				     tls_pin_server_pubkey ?
+						server_pubkey_file : NULL);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (server_cert_temp != NULL) {
+		remove(server_cert_temp);
+		free(server_cert_temp);
+	}
+	if (server_cert_file != NULL)
+		free(server_cert_file);
+	if (server_pubkey_temp != NULL) {
+		remove(server_pubkey_temp);
+		free(server_pubkey_temp);
+	}
+	if (server_pubkey_file != NULL)
+		free(server_pubkey_file);
+	if (error != NULL)
+		free(error);
+
+	return rc;
+}
+
+struct config_options {
+	const char *ekmfweb_url;
+	const char *tls_ca_bundle;
+	const char *tls_client_cert;
+	const char *tls_client_key;
+	const char *tls_client_key_passphrase;
+	bool tls_pin_server_pubkey;
+	bool tls_trust_server_cert;
+	bool tls_dont_verify_server_cert;
+	bool tls_verify_hostname;
+	bool refresh_settings;
+	bool generate_identity_key;
+	const char *sscert_pem_file;
+	const char *csr_pem_file;
+	const char *cert_subject;
+	const char *cert_extensions;
+	const char *renew_cert_pem_file;
+	bool csr_new_header;
+	const char *cert_validity_days;
+	const char *cert_digest;
+#ifdef EKMF_SUPPORTS_RSA_PSS_CERTIFICATES
+	bool cert_rsa_pss;
+#endif
+	const char *register_cert_file;
+	const char *register_label_tags;
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+	const char *session_rsa_sign_digest;
+	const char *session_rsa_sign_algo;
+#endif
+};
+
+/**
+ * Checks that none of the options for seting up a connection  is specified,
+ * and sets up the error message and return code if
+ * so.
+ *
+ * @param ph                the plugin handle
+ * @param opts              the config options structure
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _error_connection_opts(struct plugin_handle *ph,
+				  struct config_options *opts)
+{
+	int rc = 0;
+
+	if (opts->tls_ca_bundle != NULL) {
+		_set_error(ph, "Option '--tls-ca-bundle' is only valid "
+			   "together with option '--ekmfweb-url'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->tls_client_cert != NULL) {
+		_set_error(ph, "Option '--tls-client-cert' is only valid "
+			   "together with option '--ekmfweb-url'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->tls_client_key != NULL) {
+		_set_error(ph, "Option '--tls-client-key' is only valid "
+			   "together with option '--ekmfweb-url'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->tls_client_key_passphrase != NULL) {
+		_set_error(ph, "Option '--tls-client-key-passphrase' is only "
+			   "valid together with option '--ekmfweb-url'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->tls_pin_server_pubkey) {
+		_set_error(ph, "Option '--tls-pin-server-pubkey' is only valid "
+			   "together with option '--ekmfweb-url'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->tls_trust_server_cert) {
+		_set_error(ph, "Option '--tls-trust-server-cert' is only valid "
+			   "together with option '--ekmfweb-url'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->tls_dont_verify_server_cert) {
+		_set_error(ph, "Option '--tls-dont-verify-server-cert' is only "
+			   "valid together with option '--ekmfweb-url'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->tls_verify_hostname) {
+		_set_error(ph, "Option '--tls-verify-hostname' is only valid "
+			   "together with option '--ekmfweb-url'.");
+		rc = -EINVAL;
+		goto out;
+	}
+
+out:
+	return rc;
+}
+
+/**
+ * Generates (or re-generates) a identity key for the plugin using the
+ * settings from the identity template
+ *
+ * @param ph                the plugin handle
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _generate_identity_key(struct plugin_handle *ph)
+{
+	struct ekmf_template_info *template_info = NULL;
+	struct ekmf_key_gen_info gen_info;
+	char *template_uuid = NULL;
+	char *reenc_file = NULL;
+	char *error_msg = NULL;
+	char key_params[200];
+	int rc = 0;
+
+	_check_config_complete(ph);
+
+	if (!ph->apqns_configured) {
+		_set_error(ph, "The configuration is incomplete, you must "
+			   "first configure the APQNs used with this plugin.");
+		return -EINVAL;
+	}
+	if (!ph->templates_retrieved) {
+		_set_error(ph, "The configuration is incomplete, you must "
+			   "first configure the EKMF Web server connection.");
+		return -EINVAL;
+	}
+
+	rc = kms_login((kms_handle_t)ph);
+	if (rc != 0)
+		goto out;
+
+	template_uuid = properties_get(ph->properties,
+				       EKMFWEB_CONFIG_TEMPLATE_IDENTITY_ID);
+	if (template_uuid == NULL) {
+		rc = -EIO;
+		_set_error(ph, "No identity key template configured");
+		goto out;
+	}
+
+	rc = ekmf_get_template(&ph->ekmf_config, &ph->curl_handle,
+			       template_uuid, &template_info,
+			       &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get identity key template '%s': %s",
+			   template_uuid, error_msg != NULL ? error_msg :
+			   strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	rc = _check_template(ph, template_info, EKMFWEB_KEYSTORE_TYPE_IDENTITY,
+			     true);
+	if (rc != 0)
+		goto out;
+
+	pr_verbose(ph, "Identity template algorithm: '%s'",
+			template_info->algorithm);
+	pr_verbose(ph, "Identity template key size: %lu",
+			template_info->key_size);
+
+	if (strcmp(template_info->algorithm, EKMFWEB_KEY_ALGORITHM_ECC) == 0) {
+		pr_verbose(ph, "Identity template curve: '%s'",
+					template_info->curve);
+
+		gen_info.type = EKMF_KEY_TYPE_ECC;
+		gen_info.params.ecc.curve_nid =
+				_get_curve_nid(ph, template_info->curve,
+					       template_info->key_size);
+		if (gen_info.params.ecc.curve_nid == NID_undef)
+			return -EINVAL;
+
+		strcpy(key_params, OBJ_nid2sn(gen_info.params.ecc.curve_nid));
+	} else if (strcmp(template_info->algorithm,
+			  EKMFWEB_KEY_ALGORITHM_RSA) == 0) {
+		gen_info.type = EKMF_KEY_TYPE_RSA;
+		switch (template_info->key_size) {
+		case 512:
+		case 1024:
+		case 2048:
+		case 4096:
+			gen_info.params.rsa.modulus_bits =
+					template_info->key_size;
+			break;
+		default:
+			_set_error(ph, "Invalid modulus bits: '%s'",
+				   template_info->key_size);
+			return -EINVAL;
+		}
+		gen_info.params.rsa.pub_exp =
+					DEFAULT_IDENTITY_KEY_PUBLIC_EXPONENT;
+
+		sprintf(key_params, "%lu", gen_info.params.rsa.modulus_bits);
+	} else {
+		_set_error(ph, "Invalid identity template algorithm type '%s'",
+			   template_info->algorithm);
+		return -EINVAL;
+	}
+
+	if (ph->ekmf_config.identity_secure_key != NULL) {
+		printf("ATTENTION: An identity key already exists!\n");
+		util_print_indented("When you generate a new identity key, "
+				    "you will need to re-register this zkey "
+				    "client with the EKMF Web server.", 0);
+		printf("%s: Re-generate the identity key [y/N]? ",
+		       program_invocation_short_name);
+		if (!prompt_for_yes(ph->verbose)) {
+			_set_error(ph, "Opertion aborted by user");
+			return -ECANCELED;
+		}
+	} else {
+		util_asprintf((char **)&ph->ekmf_config.identity_secure_key,
+			      "%s/%s", ph->config_path,
+			      EKMFWEB_CONFIG_IDENTITY_KEY_FILE);
+
+		rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY,
+					ph->ekmf_config.identity_secure_key);
+		if (rc != 0)
+			goto out;
+	}
+
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY_ALGORITHM,
+				     template_info->algorithm);
+	if (rc != 0)
+		goto out;
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY_PARAMS,
+				     key_params);
+	if (rc != 0)
+		goto out;
+
+	rc = _select_cca_adapter(ph);
+	if (rc != 0)
+		goto out;
+
+	rc = ekmf_generate_identity_key(&ph->ekmf_config, &gen_info,
+					&ph->ext_lib, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to generate the identity key: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	rc = _set_file_permission(ph, ph->ekmf_config.identity_secure_key);
+	if (rc != 0)
+		goto out;
+
+	reenc_file = properties_get(ph->properties,
+				    EKMFWEB_CONFIG_IDENTITY_KEY_REENC);
+	if (reenc_file != NULL) {
+		remove(reenc_file);
+		free(reenc_file);
+		properties_remove(ph->properties,
+				  EKMFWEB_CONFIG_IDENTITY_KEY_REENC);
+	}
+
+	properties_remove(ph->properties, EKMFWEB_CONFIG_IDENTITY_KEY_LABEL);
+	properties_remove(ph->properties, EKMFWEB_CONFIG_IDENTITY_KEY_ID);
+
+	pr_verbose(ph, "Generated identity key into '%s'",
+		   ph->ekmf_config.identity_secure_key);
+
+out:
+	if (template_uuid != NULL)
+		free(template_uuid);
+	if (error_msg != NULL)
+		free(error_msg);
+	if (template_info != NULL)
+		ekmf_free_template_info(template_info);
+
+	return rc;
+}
+
+/**
+ * Parses an unsigned number from a string.
+ *
+ * @param str                the string to parse
+ *
+ * @returns the parsed number, or -1 in case of an error.
+ */
+static long _parse_unsigned(const char *str)
+{
+	long val;
+	char *endp;
+
+	val = strtol(str, &endp, 0);
+	if (*str == '\0' || *endp != '\0' ||
+	    (val == LONG_MAX && errno == ERANGE))
+		return -1;
+
+	return val;
+}
+
+/**
+ * Parse a semi-colon separated list and return an allocated array of the
+ * elements.
+ *
+ * @param list              the semi-colon separated list
+ * @param elements          on return, an allocated array of elements
+ * @param num_elements      on return, the number of elements in the array
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _parse_list(const char *list, char ***elements,
+		       size_t *num_elements)
+{
+	char *copy, *tok;
+	size_t count;
+	int i;
+
+	for (i = 0, count = 1; list[i] != '\0'; i++)
+		if (list[i] == ';')
+			count++;
+
+	*elements = util_zalloc(count * sizeof(char *));
+
+	copy = util_strdup(list);
+	tok = strtok(copy, ";");
+	i = 0;
+	while (tok != NULL) {
+		if (strlen(tok) > 0) {
+			(*elements)[i] = util_strdup(tok);
+			i++;
+		}
+		tok = strtok(NULL, ";");
+	}
+	*num_elements = i;
+
+	free(copy);
+
+	return 0;
+}
+
+/**
+ * Generates certificate signing request or self signed certificate using the
+ * identity key
+ *
+ * @param ph                the plugin handle
+ * @param csr_pem_file      name of the PEM file to store a CSR to. NULL if no
+ *                          CSR is to be generated.
+ * @param sscert_pem_file   name of the PEM file to store a self signed
+ *                          certificate to. NULL if no certificate is to be
+ *                          generated.
+ * @param subject           the subject RNDs separated by semicolon (;). Can be
+ *                          NULL if a renew certificate is specified.
+ * @param extensions        the extensions separated by semicolon (;). Can be
+ *                          NULL.
+ * @param renew_cert_pem_file name of a PEM file containing a certificate to
+ *                          renew. Can be NULL.
+ * @param csr_new_header    if true output NEW header and footer lines in CSR
+ * @param validity_days     the number of days the certificate is valid. Only
+ *                          valid when generating a self signed certificate.
+ *                          Can be NULL.
+ * @param digest            the digest to use with CSR and certificates. Can be
+ *                          NULL
+ * @param rsa_pss           if true, RSA-PSS is used with RSA-based identity
+ *                          keys
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _generate_csr_sscert(struct plugin_handle *ph,
+				const char *csr_pem_file,
+				const char *sscert_pem_file,
+				const char *subject, const char *extensions,
+				const char *renew_cert_pem_file,
+				bool csr_new_header, const char *validity_days,
+				const char *digest, bool rsa_pss)
+{
+	struct ekmf_rsa_pss_params rsa_pss_parms = {
+		.salt_len = RSA_PSS_SALTLEN_MAX, .mgf_digest_nid = 0 };
+	char **subject_rdn_list = NULL;
+	char **extension_list = NULL;
+	size_t num_subject_rdns = 0;
+	int digest_nid = NID_undef;
+	size_t num_extensions = 0;
+	int days = 30;
+	int rc = 0;
+	size_t i;
+
+	_check_config_complete(ph);
+
+	if (!ph->apqns_configured) {
+		_set_error(ph, "The configuration is incomplete, you must "
+			   "first configure the APQNs used with this plugin.");
+		return -EINVAL;
+	}
+	if (!ph->identity_key_generated) {
+		_set_error(ph, "The configuration is incomplete, you must "
+			   "first configure the EKMF Web server connection.");
+		return -EINVAL;
+	}
+
+	if (csr_pem_file != NULL && sscert_pem_file != NULL) {
+		_set_error(ph, "Either '--gen-csr' or option "
+			   "'--gen-self-signed-cert' can be specified.");
+		return -EINVAL;
+	}
+	if (csr_new_header && csr_pem_file == NULL) {
+		_set_error(ph, "Option '--csr-new-header' is only valid with "
+			   "option '--gen-csr'.");
+		return -EINVAL;
+	}
+	if (validity_days != NULL && sscert_pem_file == NULL) {
+		_set_error(ph, "Option '--cert-validity-days' is only valid "
+			   "with option '--gen-self-signed-cert'.");
+		return -EINVAL;
+	}
+	if (subject == NULL && renew_cert_pem_file == NULL) {
+		_set_error(ph, "Option '--cert-subject' is required, unless "
+			   " option '--renew-cert' is specified.");
+		return -EINVAL;
+	}
+
+	if (validity_days != NULL) {
+		days = _parse_unsigned(validity_days);
+		if (days <= 0) {
+			_set_error(ph, "Invalid validity days: '%s'",
+				   validity_days);
+			return -EINVAL;
+		}
+	}
+
+	if (digest != NULL) {
+		digest_nid = OBJ_txt2nid(digest);
+		if (digest_nid == NID_undef) {
+			_set_error(ph, "Invalid digest: '%s'", digest);
+			return -EINVAL;
+		}
+	}
+
+	if (subject != NULL) {
+		rc = _parse_list(subject, &subject_rdn_list,
+				 &num_subject_rdns);
+		if (rc != 0)
+			goto out;
+	}
+
+	if (extensions != NULL) {
+		rc = _parse_list(extensions, &extension_list, &num_extensions);
+		if (rc != 0)
+			goto out;
+	}
+
+	rc = _select_cca_adapter(ph);
+	if (rc != 0)
+		goto out;
+
+	if (csr_pem_file != NULL) {
+		rc = ekmf_generate_csr(&ph->ekmf_config,
+				       (const char **)subject_rdn_list,
+				       num_subject_rdns, true,
+				       renew_cert_pem_file,
+				       (const char **)extension_list,
+				       num_extensions, digest_nid,
+				       rsa_pss ? &rsa_pss_parms : NULL,
+				       csr_pem_file, csr_new_header,
+				       &ph->ext_lib, ph->verbose);
+	} else {
+		rc = ekmf_generate_ss_cert(&ph->ekmf_config,
+				       (const char **)subject_rdn_list,
+				       num_subject_rdns, true,
+				       renew_cert_pem_file,
+				       (const char **)extension_list,
+				       num_extensions, days, digest_nid,
+				       rsa_pss ? &rsa_pss_parms : NULL,
+				       sscert_pem_file, &ph->ext_lib,
+				       ph->verbose);
+	}
+	switch (rc) {
+	case 0:
+		break;
+	case -EBADMSG:
+		_set_error(ph, "The subject or extensions could not be parsed "
+			   "or are not recognized by OpenSSL.");
+		rc = -EINVAL;
+		goto out;
+	case -EEXIST:
+		_set_error(ph, "One of the subject name entries or extensions "
+			   "is a duplicate.");
+		rc = -EINVAL;
+		goto out;
+	case -ENOTSUP:
+		_set_error(ph, "The specified digest is not supported.");
+		rc = -EINVAL;
+		goto out;
+	default:
+		_set_error(ph, "Failed to generate the %s: %s",
+			   csr_pem_file != NULL ? "certificate signing request"
+					   : "self signed certificate",
+			   strerror(-rc));
+		goto out;
+	}
+
+	if (csr_pem_file != NULL)
+		pr_verbose(ph, "Generated certificate signing request into "
+			   "'%s'", csr_pem_file);
+	else
+		pr_verbose(ph, "Generated self signed certificate into '%s'",
+			   sscert_pem_file);
+
+out:
+	if (subject_rdn_list != NULL) {
+		for (i = 0; i < num_subject_rdns; i++)
+			free(subject_rdn_list[i]);
+		free(subject_rdn_list);
+	}
+	if (extension_list != NULL) {
+		for (i = 0; i < num_extensions; i++)
+			free(extension_list[i]);
+		free(extension_list);
+	}
+
+	return rc;
+}
+
+/**
+ * Checks that none of the options for generating a CSR or self signed
+ * certificate is specified, and sets up the error message and return code if
+ * so.
+ *
+ * @param ph                the plugin handle
+ * @param opts              the config options structure
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _error_gen_csr_sscert_opts(struct plugin_handle *ph,
+				      struct config_options *opts)
+{
+	int rc = 0;
+
+	if (opts->cert_subject != NULL) {
+		_set_error(ph, "Option '--cert-subject' is only valid "
+			   "together with options '--gen-csr' or "
+			   "'--gen-self-signed-cert'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->cert_extensions != NULL) {
+		_set_error(ph, "Option '--cert-extensions' is only "
+			   "valid together with options '--gen-csr' or "
+			   "'--gen-self-signed-cert'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->renew_cert_pem_file != NULL) {
+		_set_error(ph, "Option '--renew-cert' is only "
+			   "valid together with options '--gen-csr' or "
+			   "'--gen-self-signed-cert'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->csr_new_header == true) {
+		_set_error(ph, "Option '--csr-new-header' is only "
+			   "valid together with option '--gen-csr'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->cert_validity_days != NULL) {
+		_set_error(ph, "Option '--cert-validity-days' is only "
+			   "valid together with option "
+			   "'--gen-self-signed-cert'.");
+		rc = -EINVAL;
+		goto out;
+	}
+	if (opts->cert_digest != NULL) {
+		_set_error(ph, "Option '--cert-digest' is only "
+			   "valid together with options '--gen-csr' or "
+			   "'--gen-self-signed-cert'.");
+		rc = -EINVAL;
+		goto out;
+	}
+#ifdef EKMF_SUPPORTS_RSA_PSS_CERTIFICATES
+	if (opts->cert_rsa_pss == true) {
+		_set_error(ph, "Option '--cert-rsa-pss' is only "
+			   "valid together with option '--gen-csr' or "
+			   "'--gen-self-signed-cert'");
+		rc = -EINVAL;
+		goto out;
+	}
+#endif
+
+out:
+	return rc;
+}
+
+/**
+ * Frees an EKMF tag list
+ *
+ * @param ekmf_tag_list     the EKMF tag list
+ */
+static void _free_ekmf_tags(struct ekmf_tag_list *ekmf_tag_list)
+{
+	size_t i;
+
+	if (ekmf_tag_list->tags == NULL)
+		return;
+
+	for (i = 0;  i < ekmf_tag_list->num_tags; i++) {
+		free((char *)ekmf_tag_list->tags[i].name);
+		free((char *)ekmf_tag_list->tags[i].value);
+	}
+
+	free(ekmf_tag_list->tags);
+	ekmf_tag_list->tags = NULL;
+	ekmf_tag_list->num_tags = 0;
+}
+
+/**
+ * Gets the next sequence number of the template
+ *
+ * @param ph                the plugin handle
+ * @param template_uuid     the template UUID
+ *
+ * @returns an allocated string, or NULL in case of an error.
+ */
+static char *_get_seqno(struct plugin_handle *ph, const char *template_uuid)
+{
+	unsigned int seqno = 0;
+	char *error_msg = NULL;
+	char *ret = NULL;
+	int rc;
+
+	rc = ekmf_get_last_seq_no(&ph->ekmf_config, &ph->curl_handle,
+				  template_uuid, &seqno, &error_msg,
+				  ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get last used sequence number for "
+			   "template '%s': %s",
+			   template_uuid, error_msg != NULL ? error_msg :
+			   strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	seqno++;
+	util_asprintf(&ret, "%05u", seqno);
+
+	pr_verbose(ph, "Seqno: '%s'", ret);
+
+out:
+	if (error_msg != NULL)
+		free(error_msg);
+
+	return ret;
+}
+
+/**
+ * Parses the label tags passed in via option (<tag>=<value>;<tag>=<value;....)
+ * and allocates an array of KMS properties. The tags must be freed by the
+ * caller.
+ *
+ * @param ph                the plugin handle
+ * @param template_info     the template info
+ * @param label_tags        the label tags option value (can be NULL)
+ * @param ekmf_tag_list     On return: a list of label tags
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _parse_label_tags(struct plugin_handle *ph,
+			     const struct ekmf_template_info *template_info,
+			     const char *label_tags,
+			     struct ekmf_tag_list *ekmf_tag_list)
+{
+	const struct ekmf_tag_def_list *tag_defs;
+	char *tag, *value = NULL;
+	char **tag_list = NULL;
+	size_t i, k;
+	int rc = 0;
+
+	tag_defs = &template_info->label_tags;
+
+	pr_verbose(ph, "Label tags: '%s'", label_tags);
+
+	if (label_tags != NULL && strlen(label_tags) == 0)
+		label_tags = NULL;
+	tag_list = str_list_split(label_tags != NULL ? label_tags : "");
+
+	ekmf_tag_list->tags = util_malloc(sizeof(struct ekmf_tag) *
+						tag_defs->num_tag_defs);
+	ekmf_tag_list->num_tags = tag_defs->num_tag_defs;
+
+	memset(ekmf_tag_list->tags, 0,
+	       sizeof(struct ekmf_tag) * tag_defs->num_tag_defs);
+
+	for (i = 0, k = 0; i < tag_defs->num_tag_defs; i++) {
+		pr_verbose(ph, "Expected tag: '%s'",
+			   tag_defs->tag_defs[i].name);
+		pr_verbose(ph, "Specified tag: '%s'", tag_list[k]);
+
+		tag = tag_list[k] != NULL ? util_strdup(tag_list[k]) : NULL;
+		if (tag != NULL) {
+			value = strchr(tag, '=');
+			if (value != NULL) {
+				*value = '\0';
+				value++;
+			}
+		}
+
+		ekmf_tag_list->tags[i].name =
+				util_strdup(tag_defs->tag_defs[i].name);
+
+		if (strcasecmp(tag_defs->tag_defs[i].name,
+			       EKMFWEB_SEQNO_TAG) == 0) {
+			/* <seqno> tag may or may not be specified */
+			if (tag != NULL && strcasecmp(tag,
+						      EKMFWEB_SEQNO_TAG) == 0) {
+				/* <seqno> tag may or may not have a value */
+				if (value != NULL) {
+					ekmf_tag_list->tags[i].value =
+							util_strdup(value);
+				} else {
+					ekmf_tag_list->tags[i].value =
+						_get_seqno(ph,
+							   template_info->uuid);
+					if (ekmf_tag_list->tags[i].value ==
+									NULL) {
+						rc = -EIO;
+						goto out;
+					}
+				}
+				k++;
+			} else {
+				ekmf_tag_list->tags[i].value =
+						_get_seqno(ph,
+							   template_info->uuid);
+				if (ekmf_tag_list->tags[i].value == NULL) {
+					rc = -EIO;
+					goto out;
+				}
+			}
+		} else {
+			if (tag == NULL) {
+				if (label_tags != NULL)
+					_set_error(ph, "Failed to parse label "
+						   "tags. Expected tag '%s', "
+						   "but no more tags are "
+						   "specified.",
+						   tag_defs->tag_defs[i].name);
+				else
+					_set_error(ph, "Option '--label-tags' "
+						   "is required. Use 'zkey kms "
+						   "info' to see which label "
+						   "tags are required by the "
+						   "key template(s)");
+				rc = -EINVAL;
+				goto out;
+			}
+			if (strcasecmp(tag, tag_defs->tag_defs[i].name) != 0) {
+				_set_error(ph, "Failed to parse the specified "
+					   "label tags: Expected tag '%s', but "
+					   "found '%s'.",
+					   tag_defs->tag_defs[i].name, tag);
+				rc = -EINVAL;
+				goto out;
+			}
+			if (value == NULL) {
+				_set_error(ph, "Failed to parse the specified "
+					   "label tags: Tag '%s' has no value",
+					   tag_defs->tag_defs[i].name);
+				rc = -EINVAL;
+				goto out;
+			}
+
+			ekmf_tag_list->tags[i].value = util_strdup(value);
+			k++;
+		}
+
+		util_str_toupper((char *)ekmf_tag_list->tags[i].value);
+
+		pr_verbose(ph, "Tag: '%s', Value: '%s'",
+			   ekmf_tag_list->tags[i].name,
+			   ekmf_tag_list->tags[i].value);
+
+		if (tag != NULL)
+			free(tag);
+		tag = NULL;
+	}
+
+	if (tag_list[k] != NULL) {
+		_set_error(ph, "Failed to parse the specified label tags: More "
+			   "tags specified than expected: '%s'", tag_list[k]);
+		rc = -EINVAL;
+		goto out;
+	}
+
+out:
+	if (tag != NULL)
+		free(tag);
+	if (tag_list != NULL)
+		str_list_free_string_array(tag_list);
+	if (rc != 0)
+		_free_ekmf_tags(ekmf_tag_list);
+
+	return rc;
+}
+
+/**
+ * Loads the certificate from a file into memory.
+ *
+ * @param ph                the plugin handle
+ * @param cert_file         the file name of the certificate file
+ * @param cert              On return: an allocated buffer containing the data
+ * @param cert_size         On return: the size of the certificate data
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _load_certificate(struct plugin_handle *ph, const char *cert_file,
+			     unsigned char **cert, size_t *cert_size)
+{
+	size_t count, size;
+	unsigned char *buf;
+	struct stat sb;
+	int rc = 0;
+	FILE *fp;
+
+	if (stat(cert_file, &sb)) {
+		rc = -errno;
+		_set_error(ph, "Failed to read certificate from file '%s': %s",
+			   cert_file, strerror(-rc));
+		return rc;
+	}
+	size = sb.st_size;
+
+	fp = fopen(cert_file, "r");
+	if (fp == NULL) {
+		rc = -errno;
+		_set_error(ph, "Failed to read certificate from file '%s': %s",
+			   cert_file, strerror(-rc));
+		return rc;
+	}
+
+	buf = util_malloc(size);
+	count = fread(buf, 1, size, fp);
+	if (count != size) {
+		rc = ferror(fp) ? -errno : -EIO;
+		_set_error(ph, "Failed to read certificate from file '%s': %s",
+			   cert_file, strerror(-rc));
+		goto out;
+	}
+
+	*cert_size = size;
+	*cert = buf;
+
+	pr_verbose(ph, "%lu bytes read from file '%s'", size, cert_file);
+out:
+	if (rc != 0)
+		free(buf);
+	fclose(fp);
+
+	return rc;
+}
+
+/**
+ * Registers the client with EKMF Web
+ *
+ * @param ph                the plugin handle
+ * @param cert_file         the certificate file to register
+ * @param label_tags        the label tags for generating an identity key
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _register_client(struct plugin_handle *ph, const char *cert_file,
+			    const char *label_tags)
+{
+	struct ekmf_template_info *template_info = NULL;
+	struct ekmf_tag_list label_tag_list = { 0 };
+	struct ekmf_key_info *key_info = NULL;
+	const char *template_uuid = NULL;
+	unsigned char *cert = NULL;
+	char *description = NULL;
+	struct utsname utsname;
+	char *error_msg = NULL;
+	size_t cert_size = 0;
+	char *key_id = NULL;
+	int rc;
+
+	_check_config_complete(ph);
+
+	if (!ph->apqns_configured) {
+		_set_error(ph, "The configuration is incomplete, you must "
+			   "first configure the APQNs used with this plugin.");
+		return -EINVAL;
+	}
+	if (!ph->identity_key_generated) {
+		_set_error(ph, "The configuration is incomplete, you must "
+			   "first configure the EKMF Web server connection.");
+		return -EINVAL;
+	}
+
+	rc = kms_login((kms_handle_t)ph);
+	if (rc != 0)
+		goto out;
+
+	key_id = properties_get(ph->properties,
+				EKMFWEB_CONFIG_IDENTITY_KEY_LABEL);
+	if (key_id != NULL) {
+		free(key_id);
+		util_print_indented("ATTENTION: The zkey client has already "
+				    "been registered with EKMF Web!\n"
+				    "When you re-register with EKMF Web you "
+				    "will no longer have access to keys that "
+				    "have been generated in EKMF Web with your "
+				    "previous registration, until an EKMF Web "
+				    "operator approves the export of these "
+				    "keys for the identity key that is being "
+				    "generated with this registration.", 0);
+		printf("%s: Re-register the zkey client [y/N]? ",
+		       program_invocation_short_name);
+		if (!prompt_for_yes(ph->verbose)) {
+			_set_error(ph, "Opertion aborted by user");
+			return -ECANCELED;
+		}
+	}
+
+	rc  = _load_certificate(ph, cert_file, &cert, &cert_size);
+	if (rc != 0)
+		goto out;
+
+	template_uuid = properties_get(ph->properties,
+				       EKMFWEB_CONFIG_TEMPLATE_IDENTITY_ID);
+	if (template_uuid == NULL) {
+		rc = -EIO;
+		_set_error(ph, "No identity key template configured");
+		goto out;
+	}
+
+	rc = ekmf_get_template(&ph->ekmf_config, &ph->curl_handle,
+			       template_uuid, &template_info,
+			       &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get identity key template '%s': %s",
+			   template_uuid, error_msg != NULL ? error_msg :
+			   strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	rc = _check_template(ph, template_info, EKMFWEB_KEYSTORE_TYPE_IDENTITY,
+			     false);
+	if (rc != 0)
+		goto out;
+
+	rc = _parse_label_tags(ph, template_info, label_tags, &label_tag_list);
+	if (rc != 0)
+		goto out;
+
+	if (uname(&utsname) != 0) {
+		rc = -errno;
+		_set_error(ph, "Failed to obtain the system's hostname: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	util_asprintf(&description, "Identity key for zkey client on system %s",
+		      utsname.nodename);
+
+	rc = ekmf_generate_key(&ph->ekmf_config, &ph->curl_handle,
+			      template_info->name, description,
+			      &label_tag_list, NULL, NULL, cert, cert_size,
+			      &key_info, &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to generate identity key in EKMF Web:"
+			   " %s", error_msg != NULL ? error_msg :
+			   strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY_ID,
+				     key_info->uuid);
+	if (rc != 0)
+		goto out;
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_IDENTITY_KEY_LABEL,
+				     key_info->label);
+	if (rc != 0)
+		goto out;
+
+	pr_verbose(ph, "Generated identity key id: '%s'", key_info->uuid);
+	pr_verbose(ph, "Generated identity key label: '%s'", key_info->label);
+
+out:
+	if (template_uuid != NULL)
+		free((char *)template_uuid);
+	if (error_msg != NULL)
+		free(error_msg);
+	if (template_info != NULL)
+		ekmf_free_template_info(template_info);
+	_free_ekmf_tags(&label_tag_list);
+	if (key_info != NULL)
+		ekmf_free_key_info(key_info);
+	if (cert != NULL)
+		free(cert);
+	if (description != NULL)
+		free(description);
+
+	return rc;
+}
+
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+/*
+ * Configures the key transport specific settings
+ *
+ * @param ph                the plugin handle
+ * @param session_rsa_sign_digest the name of the digest for RSA signatures
+ * @param session_rsa_sign_algo the signature algorithm for RSA signatures
+ *
+ * @returns 0 on success, a negative errno in case of an error.
+ */
+static int _configure_key_transport(struct plugin_handle *ph,
+				    const char *session_rsa_sign_digest,
+				    const char *session_rsa_sign_algo)
+{
+	int nid, rc = 0;
+
+	if (session_rsa_sign_digest != NULL) {
+		nid = OBJ_txt2nid(session_rsa_sign_digest);
+		if (nid == NID_undef) {
+			_set_error(ph, "Invalid RSA signature digest '%s'",
+				   session_rsa_sign_digest);
+			return -EINVAL;
+		}
+
+		rc = _set_or_remove_property(ph,
+				    EKMFWEB_CONFIG_SESSION_RSA_SIGN_DIGEST,
+				    session_rsa_sign_digest);
+		if (rc != 0)
+			goto out;
+	}
+
+	if (session_rsa_sign_algo != NULL) {
+		if (strcasecmp(session_rsa_sign_algo, "RSA") == 0) {
+			rc = _set_or_remove_property(ph,
+					EKMFWEB_CONFIG_SESSION_RSA_SIGN_PSS,
+					NULL);
+			if (rc != 0)
+				goto out;
+		} else if (strcasecmp(session_rsa_sign_algo, "RSA-PSS") == 0) {
+			rc = _set_or_remove_property(ph,
+					EKMFWEB_CONFIG_SESSION_RSA_SIGN_PSS,
+					"yes");
+			if (rc != 0)
+				goto out;
+		} else {
+			_set_error(ph, "Invalid RSA signature algorithm '%s'",
+				   session_rsa_sign_algo);
+			return -EINVAL;
+		}
+	}
+
+out:
+	return rc;
+}
+#endif
+
+/**
+ * Configures (or re-configures) a KMS plugin. This function can be called
+ * several times to configure a KMS plugin is several steps (if supported by the
+ * KMS plugin). In case a configuration is not fully complete, this function
+ * may return -EAGAIN to indicate that it has accepted the configuration so far,
+ * but the configuration needs to be completed.
+ *
+ * A KMS plugin must be associated with at least one APQN. Thus, in a multi-step
+ * configuration, a list f APQNs must be specified at least once.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param apqns             a list of APQNs to associate with the KMS plugin, or
+ *                          NULL if no APQNs are specified.
+ * @param num_apqns         number of APQNs in above array. 0 if no APQNs are
+ *                          specified.
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_CONFIGURE.
+ * @param num_options       number of options in above array.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ * -EAGAIN to indicate that the specified configuration was accepted so far, but
+ * the configuration is still incomplete, and needs to be completed.
+ */
+int kms_configure(const kms_handle_t handle,
+		  const struct kms_apqn *apqns, size_t num_apqns,
+		  const struct kms_option *options, size_t num_options)
+{
+	struct config_options opts = { 0 };
+	struct plugin_handle *ph = handle;
+	bool config_changed = false;
+	char *apqn_str = NULL;
+	int rc = 0;
+	size_t i;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(num_apqns == 0 || apqns != NULL,
+		    "Internal error: apqns is NULL  but num_apqns > 0");
+	util_assert(num_options == 0 || options != NULL,
+		    "Internal error: options is NULL but num_options > 0 ");
+
+	pr_verbose(ph, "Configure");
+	for (i = 0; i < num_apqns; i++) {
+		pr_verbose(ph, "  APQN: %02x.%04x", apqns[i].card,
+			   apqns[i].domain);
+	}
+	for (i = 0; i < num_options; i++) {
+		if (isalnum(options[i].option))
+			pr_verbose(ph, "  Option '%c': '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+		else
+			pr_verbose(ph, "  Option %d: '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+	}
+
+	_clear_error(ph);
+
+	if (apqns != NULL) {
+		if (num_apqns > 0) {
+			rc = _cross_check_apqns(ph, apqns, num_apqns);
+			if (rc != 0)
+				goto out;
+		}
+
+		apqn_str = _build_apqn_string(apqns, num_apqns);
+		rc = properties_set(ph->properties, EKMFWEB_CONFIG_APQNS,
+				    apqn_str);
+		if (rc != 0) {
+			_set_error(ph, "Failed to set APQNs property: %s",
+				   strerror(-rc));
+			goto out;
+		}
+
+		config_changed = true;
+	}
+
+	for (i = 0; i < num_options; i++) {
+		switch (options[i].option) {
+		case 'u':
+			opts.ekmfweb_url = options[i].argument;
+			break;
+		case 'b':
+			opts.tls_ca_bundle = options[i].argument;
+			break;
+		case OPT_TLS_CLIENT_CERT:
+			opts.tls_client_cert = options[i].argument;
+			break;
+		case OPT_TLS_CLIENT_KEY:
+			opts.tls_client_key = options[i].argument;
+			break;
+		case OPT_TLS_CLIENT_KEY_PASSPHRASE:
+			opts.tls_client_key_passphrase = options[i].argument;
+			break;
+		case OPT_TLS_PIN_SERVER_PUBKEY:
+			opts.tls_pin_server_pubkey = true;
+			break;
+		case OPT_TLS_TRUST_SERVER_CERT:
+			opts.tls_trust_server_cert = true;
+			break;
+		case OPT_TLS_DONT_VERIFY_SERVER_CERT:
+			opts.tls_dont_verify_server_cert = true;
+			break;
+		case OPT_TLS_VERIFY_HOSTNAME:
+			opts.tls_verify_hostname = true;
+			break;
+		case 'R':
+			opts.refresh_settings = true;
+			break;
+		case 'i':
+			opts.generate_identity_key = true;
+			break;
+		case 'c':
+			opts.csr_pem_file = options[i].argument;
+			break;
+		case 'C':
+			opts.sscert_pem_file = options[i].argument;
+			break;
+		case 's':
+			opts.cert_subject = options[i].argument;
+			break;
+		case 'e':
+			opts.cert_extensions = options[i].argument;
+			break;
+		case 'N':
+			opts.renew_cert_pem_file = options[i].argument;
+			break;
+		case 'n':
+			opts.csr_new_header = true;
+			break;
+		case 'd':
+			opts.cert_validity_days = options[i].argument;
+			break;
+		case 'D':
+			opts.cert_digest = options[i].argument;
+			break;
+#ifdef EKMF_SUPPORTS_RSA_PSS_CERTIFICATES
+		case 'P':
+			opts.cert_rsa_pss = true;
+			break;
+#endif
+		case 'r':
+			opts.register_cert_file = options[i].argument;
+			break;
+		case 'T':
+			opts.register_label_tags = options[i].argument;
+			break;
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+		case OPT_KT_RSA_SIGNATURE_DIGEST:
+			opts.session_rsa_sign_digest = options[i].argument;
+			break;
+		case OPT_KT_RSA_PSS_SIGNATURE:
+			opts.session_rsa_sign_algo = options[i].argument;
+			break;
+#endif
+		default:
+			rc = -EINVAL;
+			if (isalnum(options[i].option))
+				_set_error(ph, "Unsupported option '%c'",
+					   options[i].option);
+			else
+				_set_error(ph, "Unsupported option %d",
+					   options[i].option);
+			goto out;
+		}
+	}
+
+	if (opts.ekmfweb_url != NULL) {
+		rc = _configure_connection(ph, opts.ekmfweb_url,
+					   opts.tls_ca_bundle,
+					   opts.tls_client_cert,
+					   opts.tls_client_key,
+					   opts.tls_client_key_passphrase,
+					   opts.tls_pin_server_pubkey,
+					   opts.tls_trust_server_cert,
+					   opts.tls_dont_verify_server_cert,
+					   opts.tls_verify_hostname);
+		if (rc == 0) {
+			config_changed = true;
+			opts.refresh_settings = false; /* Already done */
+		}
+	} else {
+		rc = _error_connection_opts(ph, &opts);
+	}
+	if (rc != 0)
+		goto out;
+
+	if (opts.refresh_settings) {
+		rc = _get_ekmfweb_settings(ph);
+		if (rc != 0)
+			goto out;
+
+		config_changed = true;
+	}
+
+	if ((ph->connection_configured && !ph->identity_key_generated) ||
+	    opts.generate_identity_key) {
+		rc = _generate_identity_key(ph);
+		if (rc != 0)
+			goto out;
+
+		config_changed = true;
+	}
+
+	if (opts.csr_pem_file != NULL || opts.sscert_pem_file != NULL)
+		rc = _generate_csr_sscert(ph, opts.csr_pem_file,
+					  opts.sscert_pem_file,
+					  opts.cert_subject,
+					  opts.cert_extensions,
+					  opts.renew_cert_pem_file,
+					  opts.csr_new_header,
+					  opts.cert_validity_days,
+					  opts.cert_digest,
+#ifdef EKMF_SUPPORTS_RSA_PSS_CERTIFICATES
+					  opts.cert_rsa_pss,
+#endif
+					  false);
+	else
+		rc = _error_gen_csr_sscert_opts(ph, &opts);
+	if (rc != 0)
+		goto out;
+
+	if (opts.register_cert_file != NULL) {
+		rc = _register_client(ph, opts.register_cert_file,
+				      opts.register_label_tags);
+		if (rc != 0)
+			goto out;
+
+		config_changed = true;
+	} else {
+		if (opts.register_label_tags != NULL) {
+			_set_error(ph, "Option ' --label-tags' is only valid "
+				   "together with option '--register'.");
+			rc = -EINVAL;
+			goto out;
+		}
+	}
+
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+	if (opts.session_rsa_sign_digest != NULL ||
+	    opts.session_rsa_sign_algo != NULL) {
+		rc = _configure_key_transport(ph, opts.session_rsa_sign_digest,
+					      opts.session_rsa_sign_algo);
+		if (rc != 0)
+			goto out;
+
+		config_changed = true;
+	}
+#endif
+
+out:
+	if (apqn_str != NULL)
+		free(apqn_str);
+
+	if (rc == 0) {
+		if (config_changed) {
+			rc = _save_config(ph);
+			if (rc != 0)
+				goto ret;
+
+			_check_config_complete(ph);
+			pr_verbose(ph, "Plugin configuration is %scomplete",
+				   ph->config_complete ? "" : "in");
+		}
+
+		if (!ph->config_complete)
+			rc = -EAGAIN;
+	}
+
+ret:
+	return rc;
+}
+
+/**
+ * De-configures a KMS plugin. This is called by zkey when a repository is
+ * unbound from a KMS plugin. It gives the KMS plugin the chance to gracefully
+ * remove any files that the plugin has stored in its config directory. zkey
+ * will unconditionally remove all left over files when this function returns.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_deconfigure(const kms_handle_t handle)
+{
+	struct plugin_handle *ph = handle;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+
+	pr_verbose(ph, "Deconfigure");
+
+	_clear_error(ph);
+
+	return 0;
+}
+
+/**
+ * Prompts the user for input on stdin, and returns the entered value.
+ * The returned string must be freed by the caller.
+ *
+ * @param ph                the plugin handle
+ * @param msg               the message to prompt for the input (can be NULL)
+ *
+ * @returns the entered value, or NULL in case of an error.
+ */
+static char *_prompt_for_input(struct plugin_handle *ph, const char *msg)
+{
+	size_t input_len = 0;
+	char *input = NULL;
+	int rc;
+
+	while (input_len == 0 || input == NULL || strlen(input) < 1) {
+		if (msg != NULL)
+			printf("%s: %s: ", program_invocation_short_name, msg);
+
+		rc = getline(&input, &input_len, stdin);
+		if (rc < 0) {
+			_set_error(ph, "Failed to read from stdin: %s",
+				   strerror(errno));
+			if (input != NULL)
+				free(input);
+			return NULL;
+		}
+
+		if (input != NULL && input[strlen(input) - 1] == '\n')
+			input[strlen(input) - 1] = '\0';
+	}
+
+	return input;
+}
+
+/**
+ * Allows the KMS plugin to perform a login to the KMS (if required). This
+ * function is called at least once before any key operation function, typically
+ * shortly after opening the repository.
+ * The KMS plugin may prompt the user (by reading from stdin) for its
+ * credentials, if needed.
+ *
+ * It is suggested that a KMS plugin performs a login with the KMS once, and
+ * stores a login token (or similar) in its config directory. The next time
+ * the kms_login function is called, the login token can be reused (if still
+ * valid). This avoids to prompt the user for every key operation.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_login(const kms_handle_t handle)
+{
+	struct plugin_handle *ph = handle;
+	char *passcode_url = NULL;
+	char *error_msg = NULL;
+	char *passcode = NULL;
+	char *user_id = NULL;
+	bool valid = false;
+	int rc;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+
+	pr_verbose(ph, "Login");
+
+	_clear_error(ph);
+
+	if (!ph->connection_configured) {
+		_set_error(ph, "The configuration is incomplete, run 'zkey "
+			  "kms configure [OPTIONS]' to complete the "
+			  "configuration.");
+		return -EINVAL;
+	}
+
+	if (ph->ekmf_config.login_token != NULL) {
+		rc = ekmf_check_login_token(&ph->ekmf_config, &valid, NULL,
+					    ph->verbose);
+		pr_verbose(ph, "Login token valid: %d", valid);
+
+		if (rc == 0 && valid)
+			return 0;
+
+		remove(ph->ekmf_config.login_token);
+		FREE_AND_SET_NULL(ph->ekmf_config.login_token);
+
+		rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_LOGIN_TOKEN,
+					     NULL);
+		if (rc != 0)
+			goto out;
+	}
+
+	passcode_url = properties_get(ph->properties,
+				      EKMFWEB_CONFIG_PASSCODE_URL);
+	if (passcode_url == NULL) {
+		util_asprintf(&passcode_url, "%s%s", ph->ekmf_config.base_url,
+			      EKMFWEB_PASSCODE_URL);
+
+		rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_PASSCODE_URL,
+					     passcode_url);
+		if (rc != 0)
+			goto out;
+	}
+
+	pr_verbose(ph, "passcode url: '%s'", passcode_url);
+
+	user_id = _prompt_for_input(ph, "EKMF Web user ID");
+	if (user_id == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	pr_verbose(ph, "User-id: '%s'", user_id);
+
+	util_print_indented("Go to the following web page in your web browser, "
+			    "login with the same user ID as entered above and "
+			    "your password, and obtain a one time passcode and "
+			    "enter it here.", 0);
+	printf("%s\n", passcode_url);
+
+	passcode = _prompt_for_input(ph, "Passcode");
+	if (passcode == NULL) {
+		rc = -EIO;
+		goto out;
+	}
+
+	pr_verbose(ph, "Passcode: '%s'", passcode);
+
+	util_asprintf((char **)&ph->ekmf_config.login_token, "%s/%s",
+		      ph->config_path, EKMFWEB_CONFIG_LOGIN_TOKEN_FILE);
+
+	rc = ekmf_login(&ph->ekmf_config, &ph->curl_handle, user_id, passcode,
+			&error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to login to EKMF Web server at '%s': "
+			   "%s", ph->ekmf_config.base_url,
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		goto out;
+	}
+
+	rc = _set_file_permission(ph, ph->ekmf_config.login_token);
+	if (rc != 0)
+		goto out;
+
+	rc = _set_or_remove_property(ph, EKMFWEB_CONFIG_LOGIN_TOKEN,
+				     ph->ekmf_config.login_token);
+	if (rc != 0)
+		goto out;
+
+	rc = _save_config(ph);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (passcode_url != NULL)
+		free(passcode_url);
+	if (user_id != NULL)
+		free(user_id);
+	if (passcode != NULL)
+		free(passcode);
+	if (error_msg != NULL)
+		free(error_msg);
+
+	return rc;
+}
+
+/**
+ * Called when the master keys of an APQN associated with the KMS plugin has
+ * been changed. The KMS plugin can then re-encipher all its secure keys (if
+ * any) that it has stored in its config directory.
+ *
+ * Keys that have been generated by the KMS plugin and stored in the zkey
+ * repository do not need to be re-enciphered by the KMS plugin. Those are
+ * re-enciphered by zkey without the help of the KMS plugin.
+ *
+ * HSM have different master key registers. Typically a CURRENT and a NEW master
+ * key register exists. The NEW register may be loaded with the new to be set
+ * master key, and secure keys can be re-enciphered with it proactively.
+ *
+ * CCA also supports an OLD master key register, that contains the previously
+ * used master key. You thus can re-encipher a secure key that is currently
+ * enciphered with the master key from the OLD register with the master key
+ * from the CURRENT register.
+ *
+ * HSMs may also support different master keys for different key types or
+ * algorithms. It is up to the KMS plugin to know which master key registers
+ * are used for its secure keys
+ *
+ * A staged re-encipherment is performed by re-enciphering a secure key with
+ * the new HSM master key, without making it available for use in the first
+ * stage. Only when the staged re-encipherment is completed, then the previously
+ * re-enciphered secure key is make available for use and the old on is removed.
+ *
+ * An in-place re-encipherment replaces the secure key right away with its
+ * re-enciphered version.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param mode              Re-encipherment mode
+ * @param mkreg             Re-encipherment register selection
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_REENCIPHER.
+ * @param num_options       number of options in above array.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_reenciper(const kms_handle_t handle, enum kms_reencipher_mode mode,
+		  enum kms_reenc_mkreg mkreg,
+		  const struct kms_option *options, size_t num_options)
+{
+	struct plugin_handle *ph = handle;
+	char *reenc_file = NULL;
+	const char *tmp = NULL;
+	size_t i;
+	int rc;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(num_options == 0 || options != NULL,
+		    "Internal error: options is NULL but num_options > 0 ");
+
+	pr_verbose(ph, "Re-encipher mode: %d, kmreg=%d", mode, mkreg);
+	for (i = 0; i < num_options; i++) {
+		if (isalnum(options[i].option))
+			pr_verbose(ph, "  Option '%c': '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+		else
+			pr_verbose(ph, "  Option %d: '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+	}
+
+	_clear_error(ph);
+
+	if (ph->ekmf_config.identity_secure_key == NULL)
+		return 0;
+
+	reenc_file = properties_get(ph->properties,
+				    EKMFWEB_CONFIG_IDENTITY_KEY_REENC);
+	if (reenc_file != NULL && mode == KMS_REENC_MODE_AUTO)
+		mode = KMS_REENC_MODE_STAGED_COMPLETE;
+
+	if (mode == KMS_REENC_MODE_STAGED_COMPLETE) {
+		if (reenc_file == NULL) {
+			_set_error(ph, "Staged re-enciphering is not pending");
+			rc = -EINVAL;
+			goto out;
+		}
+
+		printf("Completing re-enciphering of identity key.\n");
+
+		rc = remove(ph->ekmf_config.identity_secure_key);
+		if (rc != 0) {
+			rc = -errno;
+			_set_error(ph, "Failed to remove file '%s': %s",
+				   ph->ekmf_config.identity_secure_key,
+				   strerror(-rc));
+			goto out;
+		}
+
+		rc = rename(reenc_file, ph->ekmf_config.identity_secure_key);
+		if (rc != 0) {
+			rc = -errno;
+			_set_error(ph, "Failed to rename file '%s' to '%s': %s",
+				   reenc_file,
+				   ph->ekmf_config.identity_secure_key,
+				   strerror(-rc));
+			goto out;
+		}
+
+		rc = properties_remove(ph->properties,
+				       EKMFWEB_CONFIG_IDENTITY_KEY_REENC);
+		if (rc != 0) {
+			_set_error(ph, "Failed to remove property %s: %s",
+				   EKMFWEB_CONFIG_IDENTITY_KEY_REENC,
+				   strerror(-rc));
+			goto out;
+		}
+
+		rc = _save_config(ph);
+		if (rc != 0)
+			goto out;
+
+		printf("Successfully completed re-enciphering of identity "
+		       "key.\n");
+
+		rc = 0;
+		goto out;
+	}
+
+	if (reenc_file != NULL)
+		free(reenc_file);
+	reenc_file = NULL;
+
+	rc = _select_cca_adapter(ph);
+	if (rc != 0)
+		goto out;
+
+	switch (mkreg) {
+	case KMS_REENC_MKREG_AUTO:
+	case KMS_REENC_MKREG_TO_NEW:
+		if (mode == KMS_REENC_MODE_AUTO)
+			mode = KMS_REENC_MODE_STAGED;
+
+		if (mode == KMS_REENC_MODE_STAGED)
+			util_asprintf(&reenc_file, "%s/%s", ph->config_path,
+				      EKMFWEB_CONFIG_IDENTITY_KEY_REENC_FILE);
+
+		printf("Re-enciphering the identity key with the APKA master "
+		       "key in the NEW register.\n");
+
+		rc = ekmf_reencipher_identity_key(&ph->ekmf_config, true,
+						  reenc_file, &ph->ext_lib,
+						  ph->verbose);
+		if (rc != 0) {
+			_set_error(ph, "Failed to re-encipher identity key "
+				   "'%s': %s",
+				   ph->ekmf_config.identity_secure_key,
+				   strerror(-rc));
+			goto out;
+		}
+		break;
+
+	case KMS_REENC_MKREG_FROM_OLD:
+		if (mode == KMS_REENC_MODE_AUTO)
+			mode = KMS_REENC_MODE_IN_PLACE;
+
+		if (mode == KMS_REENC_MODE_STAGED)
+			util_asprintf(&reenc_file, "%s/%s", ph->config_path,
+				      EKMFWEB_CONFIG_IDENTITY_KEY_REENC_FILE);
+
+		printf("Re-enciphering the identity key with the APKA master "
+		       "key in the CURRENT register.\n");
+
+		rc = ekmf_reencipher_identity_key(&ph->ekmf_config, false,
+						  reenc_file, &ph->ext_lib,
+						  ph->verbose);
+		if (rc != 0) {
+			_set_error(ph, "Failed to re-encipher identity key "
+				   "'%s': %s",
+				   ph->ekmf_config.identity_secure_key,
+				   strerror(-rc));
+			goto out;
+		}
+		break;
+
+	case KMS_REENC_MKREG_FROM_OLD_TO_NEW:
+		if (mode == KMS_REENC_MODE_AUTO)
+			mode = KMS_REENC_MODE_STAGED;
+
+		if (mode == KMS_REENC_MODE_STAGED)
+			util_asprintf(&reenc_file, "%s/%s", ph->config_path,
+				      EKMFWEB_CONFIG_IDENTITY_KEY_REENC_FILE);
+
+		printf("Re-enciphering the identity key with the APKA master "
+		       "key in the CURRENT and then the NEW register.\n");
+
+		rc = ekmf_reencipher_identity_key(&ph->ekmf_config, false,
+						  reenc_file, &ph->ext_lib,
+						  ph->verbose);
+		if (rc != 0) {
+			_set_error(ph, "Failed to re-encipher identity key "
+				   "'%s': %s",
+				   ph->ekmf_config.identity_secure_key,
+				   strerror(-rc));
+			goto out;
+		}
+
+		if (reenc_file != NULL) {
+			tmp = ph->ekmf_config.identity_secure_key;
+			ph->ekmf_config.identity_secure_key = reenc_file;
+		}
+
+		rc = ekmf_reencipher_identity_key(&ph->ekmf_config, true,
+						  reenc_file, &ph->ext_lib,
+						  ph->verbose);
+
+		if (tmp != NULL)
+			ph->ekmf_config.identity_secure_key = tmp;
+
+		if (rc != 0) {
+			_set_error(ph, "Failed to re-encipher identity key "
+				   "'%s': %s",
+				   ph->ekmf_config.identity_secure_key,
+				   strerror(-rc));
+			goto out;
+		}
+
+		break;
+
+	default:
+		_set_error(ph, "Invalid re-encipher MK register selection");
+		rc = -EINVAL;
+		goto out;
+	}
+
+	if (mode == KMS_REENC_MODE_STAGED) {
+		rc = _set_file_permission(ph, reenc_file);
+		if (rc != 0)
+			goto out;
+
+		rc = properties_set(ph->properties,
+				    EKMFWEB_CONFIG_IDENTITY_KEY_REENC,
+				    reenc_file);
+		if (rc != 0) {
+			_set_error(ph, "Failed to set property %s: %s",
+				   EKMFWEB_CONFIG_IDENTITY_KEY_REENC,
+				   strerror(-rc));
+			goto out;
+		}
+
+	} else {
+		rc = properties_remove(ph->properties,
+				       EKMFWEB_CONFIG_IDENTITY_KEY_REENC);
+		if (rc != 0 && rc != -ENOENT) {
+			_set_error(ph, "Failed to remove property %s: %s",
+				   EKMFWEB_CONFIG_IDENTITY_KEY_REENC,
+				   strerror(-rc));
+			goto out;
+		}
+	}
+
+	rc = _save_config(ph);
+	if (rc != 0)
+		goto out;
+
+	rc = 0;
+
+	if (mode == KMS_REENC_MODE_STAGED)
+		util_print_indented("Staged re-enciphering is initiated for "
+				    "the identity key. After the NEW master "
+				    "key has been set to become the CURRENT "
+				    "master key run 'zkey kms reencipher' with "
+				    "option '--complete' to complete the "
+				    "re-enciphering process.", 0);
+	else
+		printf("Successfully re-enciphered the identity key\n");
+
+out:
+	if (rc != 0 && reenc_file != NULL)
+		remove(reenc_file);
+	if (reenc_file != NULL)
+		free(reenc_file);
+
+	return rc;
+}
+
+/**
+ * Converts a list of KMS properties into a EKMF tag list
+ *
+ * @param ph                the plugin handle
+ * @param properties        a list of properties to associate the key with
+ * @param num_properties    the number of properties in above array
+ * @param ekmf_tag_list     On return: a list of tags
+ * @param null_values_only  if true, only properties with a NULL-value are
+ *                          converted. If false, only properties with a non-NULL
+ *                          value are converted.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _properties_to_ekmf_tags(struct plugin_handle *UNUSED(ph),
+				    const struct kms_property *properties,
+				    size_t num_properties,
+				    struct ekmf_tag_list *ekmf_tag_list,
+				    bool null_values_only)
+{
+	size_t i;
+
+	ekmf_tag_list->num_tags = 0;
+	ekmf_tag_list->tags = util_malloc(
+				sizeof(struct ekmf_tag) * num_properties);
+
+	for (i = 0; i < num_properties; i++) {
+		if (!null_values_only && properties[i].value == NULL)
+			continue;
+		if (null_values_only && properties[i].value != NULL)
+			continue;
+
+		ekmf_tag_list->tags[i].name = util_strdup(properties[i].name);
+		ekmf_tag_list->tags[i].value = properties[i].value != NULL ?
+				util_strdup(properties[i].value) : NULL;
+		ekmf_tag_list->num_tags++;
+	}
+
+	return 0;
+}
+
+/**
+ * Converts an EKMF tag list into a list of KMS properties
+ *
+ * @param ph                the plugin handle
+ * @param ekmf_tag_list     The list of tags
+ * @param properties        On return: a list of properties
+ * @param num_properties    On return: the number of properties in above array
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _ekmf_tags_to_properties(struct plugin_handle *UNUSED(ph),
+				    const struct ekmf_tag_list *ekmf_tag_list,
+				    struct kms_property **properties,
+				    size_t *num_properties)
+{
+	struct kms_property *props;
+	size_t i;
+
+	props = util_malloc(sizeof(struct kms_property) *
+						ekmf_tag_list->num_tags);
+
+	for (i = 0; i < ekmf_tag_list->num_tags; i++) {
+		props[i].name = util_strdup(ekmf_tag_list->tags[i].name);
+		props[i].value = ekmf_tag_list->tags[i].value != NULL ?
+			util_strdup(ekmf_tag_list->tags[i].value) : NULL;
+	}
+
+	*properties = props;
+	*num_properties = ekmf_tag_list->num_tags;
+
+	return 0;
+}
+
+/**
+ * Restricts an retrieved secure key from further export and checks the
+ * required key attributes. If the secure key is not as expected, the user
+ * is prompted to confirm the use of the key.
+ *
+ * @param ph                the plugin handle
+ * @param key_blob          the secure key to restrict
+ * @param key_blob_length   the size of the the secure key
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _restrict_key(struct plugin_handle *ph, unsigned char *key_blob,
+			 size_t key_blob_length)
+{
+	struct cca_lib cca = { 0 };
+	int rc;
+
+	cca.lib_csulcca = ph->cca.cca_lib;
+	cca.dll_CSNBRKA = (t_CSNBRKA)dlsym(cca.lib_csulcca, "CSNBRKA");
+	if (cca.dll_CSNBRKA == NULL) {
+		_set_error(ph, "Failed to get CCA verb CSNBRKA");
+		return -ELIBACC;
+	}
+
+	rc = restrict_key_export(&cca, key_blob, key_blob_length,
+				 ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to export-restrict the retrieved secure "
+			   "key: %s", strerror(-rc));
+		return rc;
+	}
+
+	rc = check_aes_cipher_key(key_blob, key_blob_length);
+	if (rc != 0) {
+		warnx("The secure key retrieved from EKMF Web might not be "
+		      "secure");
+		printf("%s: Do you want to use it anyway [y/N]? ",
+		       program_invocation_short_name);
+		if (!prompt_for_yes(ph->verbose)) {
+			warnx("Operation aborted");
+			return -ECANCELED;
+		}
+	}
+
+	return 0;
+}
+
+/**
+ * Generates a key in or with the KMS and returns a secure key that is
+ * enciphered under the current HSM master key.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_type          the zkey key type, euch as 'CCA-AESDATA',
+ *                          'CCA-AESCIPHER', 'EP11-AES'.
+ * @param key_bits          the key bit size (e.g. 256 for an AES 256 bit key).
+ * @param properties        a list of properties to associate the key with
+ * @param num_properties    the number of properties in above array
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_GENERATE.
+ * @param num_options       number of options in above array.
+ * @param key_blob          a buffer to return the key blob. The size of the
+ *                          buffer is specified in key_blob_length
+ * @param key_blob_length   on entry: the size of the key_blob buffer.
+ *                          on exit: the size of the key blob returned.
+ * @param key_id            a buffer to return the key-ID of the generated key.
+ *                          The key-id is a textual identifier uniquely
+ *                          identifying a key in the KMS and the KMS plugin.
+ *                          The returned key-id contains the terminating zero.
+ * @paran key_id_size       size of the key_id buffer. It should be at least
+ *                          KMS_KEY_ID_SIZE + 1 bytes large.
+ * @param key_label         a buffer to return the key-label of the generated
+ *                          key. The key-label is a textual identifier used to
+ *                          identify a key in the user interface of the KMS.
+ *                          A key label may be equal to the key-ID, or it may
+ *                          different. The returned key-label contains the
+ *                          terminating zero.
+ * @paran key_label_size    size of the key_lanble buffer. It should be at least
+ *                          KMS_KEY_LABEL_SIZE + 1 bytes large.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_generate_key(const kms_handle_t handle, const char *key_type,
+		     size_t key_bits, enum kms_key_mode key_mode,
+		     const struct kms_property *properties,
+		     size_t num_properties,
+		     const struct kms_option *options, size_t num_options,
+		     unsigned char *key_blob, size_t *key_blob_length,
+		     char *key_id, size_t key_id_size,
+		     char *key_label, size_t key_label_size)
+{
+	struct ekmf_template_info *template_info = NULL;
+	struct ekmf_tag_list custom_tag_list = { 0 };
+	struct ekmf_tag_list label_tag_list = { 0 };
+	struct ekmf_key_info *key_info = NULL;
+	int curve_nid = 0, digest_nid = 0;
+	struct plugin_handle *ph = handle;
+	const char *template_uuid = NULL;
+	char *identity_key_uuid = NULL;
+	const char *label_tags = NULL;
+	const char *tmpl_prop_name;
+	char *error_msg = NULL;
+	bool rsa_pss = false;
+	char *tmp;
+	size_t i;
+	int rc;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(num_properties == 0 || properties != NULL,
+		    "Internal error: properties is NULL but num_properties"
+		    " > 0 ");
+	util_assert(num_options == 0 || options != NULL,
+		    "Internal error: options is NULL but num_options > 0 ");
+	util_assert(key_blob != NULL, "Internal error: key_blob is NULL");
+	util_assert(key_blob_length != NULL, "Internal error: key_blob_length "
+		    "is NULL");
+	util_assert(key_id != NULL, "Internal error: key_id is NULL");
+	util_assert(key_label != NULL, "Internal error: key_label is NULL");
+
+	pr_verbose(ph, "Generate key: key-type: '%s', keybits: %lu, mode: %d",
+			key_type, key_bits, key_mode);
+	for (i = 0; i < num_properties; i++) {
+		util_assert(properties[i].name != NULL,
+			    "Internal error: property name is NULL");
+		util_assert(properties[i].value != NULL,
+			    "Internal error: property value is NULL");
+		pr_verbose(ph, "  Property '%s': '%s", properties[i].name,
+			   properties[i].value);
+	}
+	for (i = 0; i < num_options; i++) {
+		if (isalnum(options[i].option))
+			pr_verbose(ph, "  Option '%c': '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+		else
+			pr_verbose(ph, "  Option %d: '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+	}
+
+	_clear_error(ph);
+
+	if (!ph->config_complete) {
+		_set_error(ph, "The configuration is incomplete, run 'zkey "
+			  "kms configure [OPTIONS]' to complete the "
+			  "configuration.");
+		return -EINVAL;
+	}
+
+	if (strcasecmp(key_type, KEY_TYPE_CCA_AESCIPHER) != 0) {
+		_set_error(ph, "Key type '%s' is not supported by EKMF Web",
+			   key_type);
+		return -ENOTSUP;
+	}
+
+	switch (key_mode) {
+	case KMS_KEY_MODE_NON_XTS:
+		tmpl_prop_name = EKMFWEB_CONFIG_TEMPLATE_NONXTS_ID;
+		break;
+	case KMS_KEY_MODE_XTS_1:
+		tmpl_prop_name = EKMFWEB_CONFIG_TEMPLATE_XTS1_ID;
+		break;
+	case KMS_KEY_MODE_XTS_2:
+		tmpl_prop_name = EKMFWEB_CONFIG_TEMPLATE_XTS2_ID;
+		break;
+	default:
+		_set_error(ph, "Unsupported key mode: %d", key_mode);
+		return -EINVAL;
+	}
+
+	identity_key_uuid = properties_get(ph->properties,
+					   EKMFWEB_CONFIG_IDENTITY_KEY_ID);
+	if (identity_key_uuid == NULL) {
+		_set_error(ph, "The zkey client is not registered with EKMF "
+			  "Web, run 'zkey kms configure --register CERT-FILE' "
+			  "to register the zkey client.");
+		return -EINVAL;
+	}
+
+	pr_verbose(ph, "identity_key_uuid: '%s'", identity_key_uuid);
+
+	rc = _select_cca_adapter(ph);
+	if (rc != 0)
+		goto out;
+
+	for (i = 0; i < num_options; i++) {
+		switch (options[i].option) {
+		case 'T':
+			label_tags = options[i].argument;
+			break;
+		default:
+			rc = -EINVAL;
+			if (isalnum(options[i].option))
+				_set_error(ph, "Unsupported option '%c'",
+					   options[i].option);
+			else
+				_set_error(ph, "Unsupported option %d",
+					   options[i].option);
+			goto out;
+		}
+	}
+
+	template_uuid = properties_get(ph->properties, tmpl_prop_name);
+	if (template_uuid == NULL) {
+		rc = -EIO;
+		_set_error(ph, "No key template configured");
+		goto out;
+	}
+
+	rc = ekmf_get_template(&ph->ekmf_config, &ph->curl_handle,
+			       template_uuid, &template_info,
+			       &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get key template '%s': %s",
+			   template_uuid, error_msg != NULL ? error_msg :
+			   strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	rc = _check_template(ph, template_info,
+			     EKMFWEB_KEYSTORE_TYPE_PERV_ENCR, true);
+	if (rc != 0)
+		goto out;
+
+	if (key_bits == 0)
+		key_bits = template_info->key_size;
+	if (key_bits != template_info->key_size) {
+		_set_error(ph, "Key size %u bits is not allowed by the "
+			   "template used to generate the key. The template "
+			   "uses a key size of %u bits.", key_bits,
+			   template_info->key_size);
+		return -EINVAL;
+	}
+
+	rc = _parse_label_tags(ph, template_info, label_tags, &label_tag_list);
+	if (rc != 0)
+		goto out;
+
+	rc = _properties_to_ekmf_tags(ph, properties, num_properties,
+				      &custom_tag_list, false);
+	if (rc != 0)
+		goto out;
+
+	rc = ekmf_generate_key(&ph->ekmf_config, &ph->curl_handle,
+			      template_info->name, "Generated by zkey",
+			      &label_tag_list, &custom_tag_list,
+			      identity_key_uuid, NULL, 0, &key_info,
+			      &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to generate key in EKMF Web: %s",
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_SESSION_KEY_CURVE);
+	if (tmp != NULL) {
+		curve_nid = OBJ_txt2nid(tmp);
+		free(tmp);
+	}
+
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_SESSION_RSA_SIGN_DIGEST);
+	if (tmp != NULL) {
+		digest_nid = OBJ_txt2nid(tmp);
+		free(tmp);
+	}
+
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_SESSION_RSA_SIGN_PSS);
+	if (tmp != NULL) {
+		if (strcasecmp(tmp, "yes") == 0)
+			rsa_pss = true;
+		free(tmp);
+	}
+#endif
+
+	rc = ekmf_retrieve_key(&ph->ekmf_config, &ph->curl_handle,
+				key_info->uuid, curve_nid, digest_nid, rsa_pss,
+				identity_key_uuid, key_blob, key_blob_length,
+				&error_msg, &ph->ext_lib, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to retrieve the generated key from EKMF "
+			   "Web: %s", error_msg != NULL ? error_msg :
+			   strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	rc = _restrict_key(ph, key_blob, *key_blob_length);
+	if (rc != 0)
+		goto out;
+
+	strncpy(key_id, key_info->uuid, key_id_size);
+	key_id[key_id_size - 1] = '\0';
+
+	strncpy(key_label, key_info->label, key_label_size);
+	key_label[key_label_size - 1] = '\0';
+
+	pr_verbose(ph, "Generated key id: '%s'", key_id);
+	pr_verbose(ph, "Generated key label: '%s'", key_label);
+
+out:
+	if (identity_key_uuid != NULL)
+		free(identity_key_uuid);
+	if (template_uuid != NULL)
+		free((char *)template_uuid);
+	if (template_info != NULL)
+		ekmf_free_template_info(template_info);
+	_free_ekmf_tags(&label_tag_list);
+	_free_ekmf_tags(&custom_tag_list);
+	if (error_msg != NULL)
+		free(error_msg);
+	if (key_info != NULL)
+		ekmf_free_key_info(key_info);
+
+	return rc;
+}
+
+/**
+ * Sets (adds/replaces/removes) properties of a key. Already existing properties
+ * with the same property name are replaced, non-existing properties are added.
+ * To remove a property, set the property value to NULL.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_id            the key-ID to set the properties for
+ * @param properties        a list of properties to set
+ * @param num_properties    the number of properties in above array
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_set_key_properties(const kms_handle_t handle, const char *key_id,
+			   const struct kms_property *properties,
+			   size_t num_properties)
+{
+	struct ekmf_tag_list delete_tag_list = { 0 };
+	struct ekmf_tag_list set_tag_list = { 0 };
+	struct ekmf_key_info *key_info = NULL;
+	struct plugin_handle *ph = handle;
+	char *updated_on = NULL;
+	char *error_msg = NULL;
+	size_t i;
+	int rc;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(key_id != NULL, "Internal error: key_id is NULL");
+	util_assert(num_properties == 0 || properties != NULL,
+		    "Internal error: properties is NULL but num_properties"
+		    " > 0 ");
+
+	pr_verbose(ph, "Set key properties: key-ID: '%s'", key_id);
+	for (i = 0; i < num_properties; i++) {
+		util_assert(properties[i].name != NULL,
+			    "Internal error: property name is NULL");
+		util_assert(properties[i].value != NULL,
+			    "Internal error: property value is NULL");
+		pr_verbose(ph, "  Property '%s': '%s", properties[i].name,
+			   properties[i].value);
+	}
+
+	_clear_error(ph);
+
+	if (!ph->config_complete) {
+		_set_error(ph, "The configuration is incomplete, run 'zkey "
+			  "kms configure [OPTIONS]' to complete the "
+			  "configuration.");
+		return -EINVAL;
+	}
+
+	rc = _properties_to_ekmf_tags(ph, properties, num_properties,
+				      &set_tag_list, false);
+	if (rc != 0)
+		goto out;
+
+	rc = _properties_to_ekmf_tags(ph, properties, num_properties,
+				      &delete_tag_list, true);
+	if (rc != 0)
+		goto out;
+
+	rc = ekmf_get_key_info(&ph->ekmf_config, &ph->curl_handle,
+			       key_id, &key_info, &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get key '%s': %s", key_id,
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	if (set_tag_list.num_tags > 0) {
+		rc = ekmf_set_key_tags(&ph->ekmf_config, &ph->curl_handle,
+				       key_id, &set_tag_list,
+				       key_info->updated_on, &updated_on,
+				       &error_msg, ph->verbose);
+		if (rc != 0) {
+			_set_error(ph, "Failed to set custom tags for key "
+				   "'%s': %s", key_id, error_msg != NULL ?
+						   error_msg : strerror(-rc));
+			_remove_login_token_if_error(ph, rc);
+			goto out;
+		}
+	}
+
+	if (delete_tag_list.num_tags > 0) {
+		rc = ekmf_delete_key_tags(&ph->ekmf_config, &ph->curl_handle,
+				       key_id, &delete_tag_list,
+				       updated_on != NULL ? updated_on :
+						       key_info->updated_on,
+				       NULL, &error_msg, ph->verbose);
+		if (rc != 0) {
+			_set_error(ph, "Failed to delete custom tags for key "
+				   "'%s': %s", key_id, error_msg != NULL ?
+						   error_msg : strerror(-rc));
+			_remove_login_token_if_error(ph, rc);
+			goto out;
+		}
+	}
+
+out:
+	_free_ekmf_tags(&set_tag_list);
+	_free_ekmf_tags(&delete_tag_list);
+	if (key_info != NULL)
+		ekmf_free_key_info(key_info);
+	if (updated_on != NULL)
+		free(updated_on);
+	if (error_msg != NULL)
+		free(error_msg);
+
+	return rc;
+}
+
+/**
+ * Gets properties of a key.
+ *
+ * The returned list of properties must be freed by the caller. Each property
+ * name and value must be freed individually (using free()), as well as the
+ * complete array.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_id            the key-ID to set the properties for
+ * @param properties        On return: a list of properties
+ * @param num_properties    On return: the number of properties in above array
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_get_key_properties(const kms_handle_t handle, const char *key_id,
+			   struct kms_property **properties,
+			   size_t *num_properties)
+{
+	struct ekmf_key_info *key_info = NULL;
+	struct plugin_handle *ph = handle;
+	char *error_msg = NULL;
+	int rc;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(key_id != NULL, "Internal error: key_id is NULL");
+	util_assert(properties != NULL, "Internal error: properties is NULL");
+	util_assert(num_properties != NULL,
+		    "Internal error: num_properties is NULL");
+
+	pr_verbose(ph, "Get key properties: key-ID: '%s'", key_id);
+
+	_clear_error(ph);
+
+	if (!ph->config_complete) {
+		_set_error(ph, "The configuration is incomplete, run 'zkey "
+			  "kms configure [OPTIONS]' to complete the "
+			  "configuration.");
+		return -EINVAL;
+	}
+
+	rc = ekmf_get_key_info(&ph->ekmf_config, &ph->curl_handle,
+			       key_id, &key_info, &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get key '%s': %s", key_id,
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	rc = _ekmf_tags_to_properties(ph, &key_info->custom_tags, properties,
+				      num_properties);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (key_info != NULL)
+		ekmf_free_key_info(key_info);
+	if (error_msg != NULL)
+		free(error_msg);
+
+	return rc;
+}
+
+struct key_state {
+	const char *state;
+	const char *new_states[7];
+};
+
+static const struct key_state states[] = {
+	{ .state = EKMFWEB_KEY_STATE_PRE_ACTIVATION,
+	  .new_states = {
+		EKMFWEB_KEY_STATE_ACTIVE,
+		EKMFWEB_KEY_STATE_COMPROMISED,
+		EKMFWEB_KEY_STATE_DESTROYED,
+		NULL },
+	},
+	{ .state = EKMFWEB_KEY_STATE_ACTIVE,
+	  .new_states = {
+		EKMFWEB_KEY_STATE_ACTIVE,
+		EKMFWEB_KEY_STATE_DEACTIVATED,
+		EKMFWEB_KEY_STATE_COMPROMISED,
+		EKMFWEB_KEY_STATE_DESTROYED,
+		NULL },
+	},
+	{ .state = EKMFWEB_KEY_STATE_DEACTIVATED,
+	  .new_states = {
+		EKMFWEB_KEY_STATE_COMPROMISED,
+		EKMFWEB_KEY_STATE_DESTROYED,
+		NULL },
+	},
+	{ .state = EKMFWEB_KEY_STATE_COMPROMISED,
+	  .new_states = {
+		EKMFWEB_KEY_STATE_DESTROYED_COMPROMISED,
+		NULL },
+	},
+	{ .state = EKMFWEB_KEY_STATE_DESTROYED,
+	  .new_states = { NULL },
+	},
+	{ .state = EKMFWEB_KEY_STATE_DESTROYED_COMPROMISED,
+	  .new_states = { NULL },
+	},
+	{ .state = NULL, .new_states = { NULL, }, },
+};
+
+/**
+ * Checks if the new state is a valid state. If the current state is also
+ * specified, then it checks also if the new state can be set from the current
+ * state
+ *
+ * @param ph                the plugin handle
+ * @param name              the key name
+ * @param new_state         the new state to set
+ * @param cur_state         the current state (can be NULL).
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _check_state(struct plugin_handle *ph, const char *name,
+			const char *new_state, const char *cur_state)
+{
+	bool ok = false;
+	int i, k;
+
+	for (i = 0; states[i].state != NULL; i++) {
+		if (strcasecmp(new_state, states[i].state) == 0) {
+			ok = true;
+			break;
+		}
+	}
+
+	if (!ok) {
+		_set_error(ph, "Invalid state specified: '%s'", new_state);
+		return -EINVAL;
+	}
+
+	if (cur_state == NULL)
+		return 0;
+
+	for (i = 0; states[i].state != NULL; i++) {
+		if (strcasecmp(cur_state, states[i].state) == 0) {
+			for (k = 0; states[i].new_states[k] != NULL; k++) {
+				if (strcasecmp(new_state,
+					       states[i].new_states[k]) == 0)
+					return 0;
+			}
+
+			_set_error(ph, "Key '%s' is in state '%s' and can not "
+				   "be changed to state '%s'", name,
+				   cur_state, new_state);
+			return -EINVAL;
+		}
+	}
+
+	_set_error(ph, "Key '%s' is in an invalid state: '%s'", name,
+		   cur_state);
+	return -EINVAL;
+}
+
+/**
+ * Called when zkey removes a KMS-bound key from the zkey repository. The KMS
+ * plugin can then set the state of the key in the KMS, or remove it also from
+ * the KMS (this is usually not done).
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_id            the key-ID to set the properties for
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_REMOVE.
+ * @param num_options       number of options in above array.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_remove_key(const kms_handle_t handle, const char *key_id,
+		   const struct kms_option *options, size_t num_options)
+{
+	struct ekmf_key_info *key_info = NULL;
+	struct plugin_handle *ph = handle;
+	char *error_msg = NULL;
+	char *state = NULL;
+	int rc = 0;
+	size_t i;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(key_id != NULL, "Internal error: key_id is NULL");
+	util_assert(num_options == 0 || options != NULL,
+		    "Internal error: options is NULL but num_options > 0 ");
+
+	pr_verbose(ph, "Remove key: key-ID: '%s'", key_id);
+	for (i = 0; i < num_options; i++) {
+		if (isalnum(options[i].option))
+			pr_verbose(ph, "  Option '%c': '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+		else
+			pr_verbose(ph, "  Option %d: '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+	}
+
+	_clear_error(ph);
+
+	for (i = 0; i < num_options; i++) {
+		switch (options[i].option) {
+		case 's':
+			state = util_strdup(options[i].argument);
+			util_str_toupper(state);
+			break;
+		default:
+			rc = -EINVAL;
+			if (isalnum(options[i].option))
+				_set_error(ph, "Unsupported option '%c'",
+					   options[i].option);
+			else
+				_set_error(ph, "Unsupported option %d",
+					   options[i].option);
+			goto out;
+		}
+	}
+
+	if (state == NULL)
+		goto out;
+
+	pr_verbose(ph, "State to set: '%s'", state);
+
+	if (!ph->config_complete) {
+		_set_error(ph, "The configuration is incomplete, run 'zkey "
+			  "kms configure [OPTIONS]' to complete the "
+			  "configuration.");
+		return -EINVAL;
+	}
+
+	rc = ekmf_get_key_info(&ph->ekmf_config, &ph->curl_handle,
+			       key_id, &key_info, &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to get key '%s': %s", key_id,
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	pr_verbose(ph, "Key state: '%s'", key_info->state);
+
+	rc = _check_state(ph, key_info->label, state, key_info->state);
+	if (rc != 0)
+		goto out;
+
+	rc = ekmf_set_key_state(&ph->ekmf_config, &ph->curl_handle,
+				key_id, state, key_info->updated_on,
+				&error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to set key state '%s': %s",
+				key_id, error_msg != NULL ? error_msg :
+			   strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+out:
+	if (key_info != NULL)
+		ekmf_free_key_info(key_info);
+	if (error_msg != NULL)
+		free(error_msg);
+	if (state != NULL)
+		free(state);
+
+	return rc;
+}
+
+struct list_data {
+	struct plugin_handle *ph;
+	bool list_all;
+	const char *exporting_key;
+	kms_list_callback callback;
+	void *private;
+};
+
+/**
+ * Check if the key can be exported by the exporting key
+ *
+ * @param key_info          the key to check
+ * @param exporting_key     the exporting key
+ *
+ * @returns true if export is allowed, false otherwise
+ */
+static bool _check_exportability(struct ekmf_key_info *key_info,
+				 const char *exporting_key)
+{
+	bool found = false;
+	size_t i;
+
+	if (!key_info->export_control.export_allowed || exporting_key == NULL)
+		return false;
+
+	for (i = 0; i < key_info->export_control.num_exporting_keys; i++) {
+		if (strcmp(key_info->export_control.exporting_keys[i].uuid,
+			   exporting_key) == 0) {
+			found = true;
+			break;
+		}
+	}
+
+	return found;
+}
+
+/*
+ * Like argz_add, but formats the string first
+ */
+static error_t argz_add_fmt(char **argz, size_t *argz_len, const char *fmt, ...)
+{
+	va_list ap;
+	error_t rc;
+	char *str;
+
+	va_start(ap, fmt);
+	util_vasprintf(&str, fmt, ap);
+	va_end(ap);
+
+	rc = argz_add(argz, argz_len, str);
+
+	free(str);
+	return rc;
+}
+
+/**
+ * Callback function used with the ekmf_list_keys function. This
+ * callback is called for each key found.
+ *
+ * @param curl_handle      a CURL handle that can be used to perform further
+ *                         EKMFWeb functions within the callback.
+ * @param template_info    a struct containing information about the key.
+ *                         If any of the information needs to be kept, then the
+ *                         callback function must make a copy of the
+ *                         information. The memory holding the information
+ *                         passed to the callback is no longer valid after the
+ *                         callback has returned.
+ * @param private          the private pointer that was specified with the
+ *                         ekmf_list_keys invocation.
+ *
+ * @returns zero for success, a negative errno in case of an error.
+ * When a nonzero return code is returned, the key listing process stops,
+ * and ekmf_list_keys returns the return code from the callback.
+ */
+static int _list_callback(CURL *curl_handle, struct ekmf_key_info *key_info,
+			  void *private)
+{
+	struct kms_property *properties = NULL;
+	struct list_data *data = private;
+	size_t i, num_properties = 0;
+	size_t addl_info_len = 0;
+	char *addl_info = NULL;
+	int rc = 0;
+
+	data->ph->curl_handle = curl_handle;
+
+	if (strcmp(key_info->keystore_type,
+		   EKMFWEB_KEYSTORE_TYPE_PERV_ENCR) != 0)
+		goto out;
+	if (strcmp(key_info->key_type, EKMFWEB_KEY_TYPE_CIPHER) != 0)
+		goto out;
+	if (strcmp(key_info->algorithm, EKMFWEB_KEY_ALGORITHM_AES) != 0)
+		goto out;
+	if (!data->list_all && !_check_exportability(key_info,
+						     data->exporting_key))
+		goto out;
+
+	rc = _ekmf_tags_to_properties(data->ph, &key_info->custom_tags,
+				      &properties, &num_properties);
+	if (rc != 0)
+		goto out;
+
+	rc = argz_add_fmt(&addl_info, &addl_info_len, "State: %s",
+			  key_info->state);
+	if (rc != 0)
+		goto out;
+	for (i = 0; i < key_info->export_control.num_exporting_keys; i++) {
+		rc = argz_add_fmt(&addl_info, &addl_info_len, "%s %s",
+			i == 0 ? "Exporting keys:" : "               ",
+			key_info->export_control.exporting_keys[i].name);
+		if (rc != 0)
+			goto out;
+	}
+
+	rc = data->callback(key_info->uuid, key_info->label,
+			    KEY_TYPE_CCA_AESCIPHER, key_info->key_size,
+			    properties, num_properties,
+			    addl_info, addl_info_len, data->private);
+
+out:
+	if (addl_info != NULL)
+		free(addl_info);
+	if (properties != NULL) {
+		for (i = 0;  i < num_properties; i++) {
+			free((char *)properties[i].name);
+			free((char *)properties[i].value);
+		}
+		free(properties);
+	}
+
+	return rc;
+}
+
+/**
+ * List keys managed by the KMS. This list is independent of the zkey key
+ * repository. It lists keys as known by the KMS.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param label_pattern     a pattern of the label used to filter the keys, or
+ *                          NULL if no label pattern is specified.
+ * @param properties        a list of properties used to to filter the keys, or
+ *                          NULL if no properties filter is specified.
+ * @param num_properties    the number of properties in above array.
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_LIST.
+ * @param num_options       number of options in above array.*
+ * @param callback          a callback function that is called for each key that
+ *                          matches the filter (if any).
+ * @private_data            a private pointer passed as is to the callback
+ *                          function. Can be used to pass user specific
+ *                          information to the callback.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_list_keys(const kms_handle_t handle, const char *label_pattern,
+		  const struct kms_property *properties, size_t num_properties,
+		  const struct kms_option *options, size_t num_options,
+		  kms_list_callback callback, void *private_data)
+{
+	struct ekmf_tag_list tag_list = { 0 };
+	struct plugin_handle *ph = handle;
+	struct list_data data = { 0 };
+	char **state_list = NULL;
+	char *error_msg = NULL;
+	char *states = NULL;
+	int rc = 0;
+	size_t i;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(num_properties == 0 || properties != NULL,
+		    "Internal error: properties is NULL but num_properties "
+		    "> 0 ");
+	util_assert(callback != NULL, "Internal error: callback is NULL");
+
+	pr_verbose(ph, "List Keys, label-pattern: '%s'",
+		   label_pattern != NULL ? label_pattern : "(null)");
+	for (i = 0; i < num_properties; i++) {
+		util_assert(properties[i].name != NULL,
+			    "Internal error: property name is NULL");
+		util_assert(properties[i].value != NULL,
+			    "Internal error: property value is NULL");
+		pr_verbose(ph, "  Property '%s': '%s", properties[i].name,
+			   properties[i].value);
+	}
+	for (i = 0; i < num_options; i++) {
+		if (isalnum(options[i].option))
+			pr_verbose(ph, "  Option '%c': '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+		else
+			pr_verbose(ph, "  Option %d: '%s'", options[i].option,
+				   options[i].argument != NULL ?
+					options[i].argument : "(null)");
+	}
+
+	_clear_error(ph);
+
+	if (!ph->config_complete) {
+		_set_error(ph, "The configuration is incomplete, run 'zkey "
+			  "kms configure [OPTIONS]' to complete the "
+			  "configuration.");
+		return -EINVAL;
+	}
+
+	data.ph = ph;
+	data.list_all = false;
+	data.callback = callback;
+	data.private = private_data;
+
+	for (i = 0; i < num_options; i++) {
+		switch (options[i].option) {
+		case 's':
+			states = util_strdup(options[i].argument);
+			util_str_toupper(states);
+			break;
+		case 'a':
+			data.list_all = true;
+			break;
+		default:
+			rc = -EINVAL;
+			if (isalnum(options[i].option))
+				_set_error(ph, "Unsupported option '%c'",
+					   options[i].option);
+			else
+				_set_error(ph, "Unsupported option %d",
+					   options[i].option);
+			goto out;
+		}
+	}
+
+	pr_verbose(ph, "State filter: '%s'", states != NULL ? states :
+		   "(none)");
+	pr_verbose(ph, "List all: %d", data.list_all);
+
+	if (states != NULL) {
+		state_list = str_list_split(states);
+		for (i = 0; state_list[i] != NULL; i++) {
+			rc = _check_state(ph, NULL, state_list[i], NULL);
+			if (rc != 0)
+				goto out;
+		}
+	}
+
+	data.exporting_key = properties_get(ph->properties,
+					    EKMFWEB_CONFIG_IDENTITY_KEY_ID);
+
+	rc = _properties_to_ekmf_tags(ph, properties, num_properties,
+				      &tag_list, false);
+	if (rc != 0)
+		goto out;
+
+	rc = ekmf_list_keys(&ph->ekmf_config, &ph->curl_handle,
+			    _list_callback, &data, label_pattern, states,
+			    &tag_list, &error_msg, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to list keys: %s",
+			   error_msg != NULL ? error_msg : strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+out:
+	if (states != NULL)
+		free(states);
+	if (state_list != NULL)
+		str_list_free_string_array(state_list);
+	if (error_msg != NULL)
+		free(error_msg);
+	if (data.exporting_key != NULL)
+		free((char *)data.exporting_key);
+	_free_ekmf_tags(&tag_list);
+
+	return rc;
+}
+
+/**
+ * Imports a key from the KMS and returns a secure key that is
+ * enciphered under the current HSM master key.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_id            the key-ID of the key to import
+ * @param key_blob          a buffer to return the key blob. The size of the
+ *                          buffer is specified in key_blob_length
+ * @param key_blob_length   on entry: the size of the key_blob buffer.
+ *                          on exit: the size of the key blob returned.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_import_key(const kms_handle_t handle, const char *key_id,
+		   unsigned char *key_blob, size_t *key_blob_length)
+{
+	struct plugin_handle *ph = handle;
+	int curve_nid = 0, digest_nid = 0;
+	char *identity_key_uuid = NULL;
+	char *error_msg = NULL;
+	bool rsa_pss = false;
+	int rc = 0;
+	char *tmp;
+
+	util_assert(handle != NULL, "Internal error: handle is NULL");
+	util_assert(key_blob != NULL, "Internal error: key_blob is NULL");
+	util_assert(key_blob_length != NULL, "Internal error: key_blob_length "
+		    "is NULL");
+
+	pr_verbose(ph, "Import Key, key-ID: '%s'", key_id);
+
+	_clear_error(ph);
+
+	if (!ph->config_complete) {
+		_set_error(ph, "The configuration is incomplete, run 'zkey "
+			  "kms configure [OPTIONS]' to complete the "
+			  "configuration.");
+		return -EINVAL;
+	}
+
+	identity_key_uuid = properties_get(ph->properties,
+					   EKMFWEB_CONFIG_IDENTITY_KEY_ID);
+	if (identity_key_uuid == NULL) {
+		_set_error(ph, "The zkey client is not registered with EKMF "
+			  "Web, run 'zkey kms configure --register CERT-FILE' "
+			  "to register the zkey client.");
+		return -EINVAL;
+	}
+
+	pr_verbose(ph, "identity_key_uuid: '%s'", identity_key_uuid);
+
+	rc = _select_cca_adapter(ph);
+	if (rc != 0)
+		goto out;
+
+	tmp = properties_get(ph->properties, EKMFWEB_CONFIG_SESSION_KEY_CURVE);
+	if (tmp != NULL) {
+		curve_nid = OBJ_txt2nid(tmp);
+		free(tmp);
+	}
+
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_SESSION_RSA_SIGN_DIGEST);
+	if (tmp != NULL) {
+		digest_nid = OBJ_txt2nid(tmp);
+		free(tmp);
+	}
+
+	tmp = properties_get(ph->properties,
+			     EKMFWEB_CONFIG_SESSION_RSA_SIGN_PSS);
+	if (tmp != NULL) {
+		if (strcasecmp(tmp, "yes") == 0)
+			rsa_pss = true;
+		free(tmp);
+	}
+#endif
+
+	rc = ekmf_retrieve_key(&ph->ekmf_config, &ph->curl_handle,
+				key_id, curve_nid, digest_nid, rsa_pss,
+				identity_key_uuid, key_blob, key_blob_length,
+				&error_msg, &ph->ext_lib, ph->verbose);
+	if (rc != 0) {
+		_set_error(ph, "Failed to retrieve key '%s' from EKMF "
+			   "Web: %s", key_id, error_msg != NULL ? error_msg :
+			   strerror(-rc));
+		_remove_login_token_if_error(ph, rc);
+		goto out;
+	}
+
+	rc = _restrict_key(ph, key_blob, *key_blob_length);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (identity_key_uuid != NULL)
+		free(identity_key_uuid);
+
+	return rc;
+}
+
+static const struct kms_functions kms_functions = {
+	.api_version = KMS_API_VERSION_1,
+	.kms_bind = kms_bind,
+	.kms_initialize = kms_initialize,
+	.kms_terminate = kms_terminate,
+	.kms_get_last_error = kms_get_last_error,
+	.kms_supports_key_type = kms_supports_key_type,
+	.kms_display_info = kms_display_info,
+	.kms_get_command_options = kms_get_command_options,
+	.kms_configure = kms_configure,
+	.kms_deconfigure = kms_deconfigure,
+	.kms_login = kms_login,
+	.kms_reenciper = kms_reenciper,
+	.kms_generate_key = kms_generate_key,
+	.kms_set_key_properties = kms_set_key_properties,
+	.kms_get_key_properties = kms_get_key_properties,
+	.kms_remove_key = kms_remove_key,
+	.kms_list_keys = kms_list_keys,
+	.kms_import_key = kms_import_key,
+};
+
+/**
+ * Returns an address of a structure containing the KMS plugin functions.
+ * This function is exported by the KMS plugin, and its address is obtain
+ * via dlsym() after loading the plugin via dlopen().
+ * *
+ * @returns the address of a structure or NULL in case of an error.
+ */
+const struct kms_functions *kms_get_functions(void)
+{
+	return &kms_functions;
+}
diff -pruN 2.14.0-2/zkey/ekmfweb/zkey-ekmfweb.h 2.15.1-0ubuntu2/zkey/ekmfweb/zkey-ekmfweb.h
--- 2.14.0-2/zkey/ekmfweb/zkey-ekmfweb.h	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/ekmfweb/zkey-ekmfweb.h	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,108 @@
+/*
+ * zkey-ekmfweb - EKMFWeb zkey KMS plugin
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+
+#ifndef ZKEY_EKMFWEB_H
+#define ZKEY_EKMFWEB_H
+
+#include <stddef.h>
+#include <stdbool.h>
+#include <sys/stat.h>
+
+#include "ekmfweb/ekmfweb.h"
+
+struct plugin_handle {
+	const char *config_path;
+	mode_t config_path_mode;
+	gid_t config_path_owner;
+	struct properties *properties;
+	bool apqns_configured;
+	bool connection_configured;
+	bool settings_retrieved;
+	bool templates_retrieved;
+	bool identity_key_generated;
+	bool registered;
+	bool config_complete;
+	struct ekmf_ext_lib ext_lib;
+	struct ekmf_cca_lib cca;
+	struct ekmf_config ekmf_config;
+	CURL *curl_handle;
+	char error_msg[1024];
+	bool verbose;
+};
+
+#define EKMFWEB_CONFIG_FILE			"ekmfweb.conf"
+#define EKMFWEB_CONFIG_SERVER_CERT_FILE		"server-cert.pem"
+#define EKMFWEB_CONFIG_SERVER_PUBKEY_FILE	"server-pubkey.pem"
+#define EKMFWEB_CONFIG_LOGIN_TOKEN_FILE		"login.token"
+#define EKMFWEB_CONFIG_EKMFWEB_PUBKEY_FILE	"ekmfweb-pubkey.pem"
+#define EKMFWEB_CONFIG_IDENTITY_KEY_FILE	"identity-key.skey"
+#define EKMFWEB_CONFIG_IDENTITY_KEY_REENC_FILE	"identity-key.reenc"
+
+#define EKMFWEB_CONFIG_APQNS			"apqns"
+#define EKMFWEB_CONFIG_URL			"url"
+#define EKMFWEB_CONFIG_CA_BUNDLE		"ca-bundle"
+#define EKMFWEB_CONFIG_CLIENT_CERT		"client-cert"
+#define EKMFWEB_CONFIG_CLIENT_KEY		"client-key"
+#define EKMFWEB_CONFIG_CLIENT_KEY_PASSPHRASE	"client-key-passphrase"
+#define EKMFWEB_CONFIG_SERVER_CERT		"server-cert"
+#define EKMFWEB_CONFIG_SERVER_PUBKEY		"server-pubkey"
+#define EKMFWEB_CONFIG_VERIFY_SERVER_CERT	"verify-server-cert"
+#define EKMFWEB_CONFIG_VERIFY_HOSTNAME		"verify-hostname"
+#define EKMFWEB_CONFIG_LOGIN_TOKEN		"login-token"
+#define EKMFWEB_CONFIG_PASSCODE_URL		"passcode-url"
+#define EKMFWEB_CONFIG_EKMFWEB_PUBKEY		"ekmfweb-pubkey"
+#define EKMFWEB_CONFIG_TEMPLATE_XTS1		"template-xts1"
+#define EKMFWEB_CONFIG_TEMPLATE_XTS2		"template-xts2"
+#define EKMFWEB_CONFIG_TEMPLATE_NONXTS		"template-nonxts"
+#define EKMFWEB_CONFIG_TEMPLATE_IDENTITY	"template-identity"
+#define EKMFWEB_CONFIG_TEMPLATE_XTS1_LABEL	"template-xts1-label"
+#define EKMFWEB_CONFIG_TEMPLATE_XTS2_LABEL	"template-xts2-label"
+#define EKMFWEB_CONFIG_TEMPLATE_NONXTS_LABEL	"template-nonxts-label"
+#define EKMFWEB_CONFIG_TEMPLATE_IDENTITY_LABEL	"template-identity-label"
+#define EKMFWEB_CONFIG_TEMPLATE_XTS1_ID		"template-xts1-id"
+#define EKMFWEB_CONFIG_TEMPLATE_XTS2_ID		"template-xts2-id"
+#define EKMFWEB_CONFIG_TEMPLATE_NONXTS_ID	"template-nonxts-id"
+#define EKMFWEB_CONFIG_TEMPLATE_IDENTITY_ID	"template-identity-id"
+#define EKMFWEB_CONFIG_IDENTITY_KEY		"identity-key"
+#define EKMFWEB_CONFIG_IDENTITY_KEY_ALGORITHM	"identity-key-algorithm"
+#define EKMFWEB_CONFIG_IDENTITY_KEY_PARAMS	"identity-key-params"
+#define EKMFWEB_CONFIG_IDENTITY_KEY_REENC	"identity-key-reenc"
+#define EKMFWEB_CONFIG_IDENTITY_KEY_LABEL	"identity-key-label"
+#define EKMFWEB_CONFIG_IDENTITY_KEY_ID		"identity-key-id"
+#define EKMFWEB_CONFIG_SESSION_KEY_CURVE	"session-key-curve"
+#ifdef EKMFWEB_SUPPORTS_RSA_DIGESTS_AND_PSS_SIGNATURES
+#define EKMFWEB_CONFIG_SESSION_RSA_SIGN_DIGEST	"session-rsa-sign-digest"
+#define EKMFWEB_CONFIG_SESSION_RSA_SIGN_PSS	"session-rsa-sign-pss"
+#endif
+
+#define EKMFWEB_PASSCODE_URL			"/administration/passcode"
+#define EKMFWEB_TEMPLATE_STATE_ACTIVE		"ACTIVE"
+#define EKMFWEB_TEMPLATE_STATE_HISTORY		"HISTORY"
+#define EKMFWEB_KEYSTORE_TYPE_PERV_ENCR		"PERVASIVE_ENCRYPTION"
+#define EKMFWEB_KEYSTORE_TYPE_IDENTITY		"IDENTITY"
+#define EKMFWEB_KEY_ALGORITHM_AES		"AES"
+#define EKMFWEB_KEY_ALGORITHM_ECC		"ECC"
+#define EKMFWEB_KEY_ALGORITHM_RSA		"RSA"
+#define EKMFWEB_KEY_TYPE_CIPHER			"CIPHER"
+#define EKMFWEB_KEY_STATE_PRE_ACTIVATION	"PRE-ACTIVATION"
+#define EKMFWEB_KEY_STATE_ACTIVE		"ACTIVE"
+#define EKMFWEB_KEY_STATE_DEACTIVATED		"DEACTIVATED"
+#define EKMFWEB_KEY_STATE_COMPROMISED		"COMPROMISED"
+#define EKMFWEB_KEY_STATE_DESTROYED		"DESTROYED"
+#define EKMFWEB_KEY_STATE_DESTROYED_COMPROMISED	"DESTROYED-COMPROMISED"
+#define EKMFWEB_CURVE_PRIME			"PRIME_CURVE"
+#define EKMFWEB_CURVE_BAINPOOL			"BRAINPOOL_CURVE"
+#define EKMFWEB_SEQNO_TAG			"seqno"
+
+#define DEFAULT_IDENTITY_KEY_PUBLIC_EXPONENT	65537
+
+#define CCA_LIBRARY_NAME	"libcsulcca.so"
+#define CCA_WEB_PAGE		"http://www.ibm.com/security/cryptocards"
+
+#endif
diff -pruN 2.14.0-2/zkey/ekmfweb/zkey-ekmfweb.map 2.15.1-0ubuntu2/zkey/ekmfweb/zkey-ekmfweb.map
--- 2.14.0-2/zkey/ekmfweb/zkey-ekmfweb.map	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/ekmfweb/zkey-ekmfweb.map	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,5 @@
+ZKEY_EKMFWEB_1.0 {
+    global:
+        kms_get_functions;
+    local: *;
+};
diff -pruN 2.14.0-2/zkey/ep11.c 2.15.1-0ubuntu2/zkey/ep11.c
--- 2.14.0-2/zkey/ep11.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/ep11.c	2020-10-28 14:31:59.000000000 +0000
@@ -182,8 +182,9 @@ int load_ep11_library(struct ep11_lib *e
  *
  * @returns 0 on success, a negative errno in case of errors
  */
-int get_ep11_target_for_apqn(struct ep11_lib *ep11, int card, int domain,
-			     target_t *target, bool verbose)
+int get_ep11_target_for_apqn(struct ep11_lib *ep11, unsigned int card,
+		             unsigned int domain, target_t *target,
+			     bool verbose)
 {
 	ep11_target_t *target_list;
 	struct XCP_Module module;
@@ -248,12 +249,12 @@ struct find_mkvp_info {
 	u8		mkvp[MKVP_LENGTH];
 	unsigned int	flags;
 	bool		found;
-	int		card;
-	int		domain;
+	unsigned int	card;
+	unsigned int	domain;
 	bool		verbose;
 };
 
-static int find_mkvp(int card, int domain, void *handler_data)
+static int find_mkvp(unsigned int card, unsigned int domain, void *handler_data)
 {
 	struct find_mkvp_info *info = (struct find_mkvp_info *)handler_data;
 	struct mk_info mk_info;
@@ -312,8 +313,8 @@ static int find_mkvp(int card, int domai
  */
 int select_ep11_apqn_by_mkvp(struct ep11_lib *ep11, u8 *mkvp,
 			     const char *apqns,  unsigned int flags,
-			     target_t *target, int *card, int *domain,
-			     bool verbose)
+			     target_t *target, unsigned int *card,
+			     unsigned int *domain, bool verbose)
 {
 	struct find_mkvp_info info;
 	int rc;
@@ -323,7 +324,7 @@ int select_ep11_apqn_by_mkvp(struct ep11
 
 	pr_verbose(verbose, "Select mkvp %s in APQNs %s for the EP11 host "
 		   "library", printable_mkvp(CARD_TYPE_EP11, mkvp),
-		   apqns == 0 ? "ANY" : apqns);
+		   apqns == NULL ? "ANY" : apqns);
 
 	memcpy(info.mkvp, mkvp, sizeof(info.mkvp));
 	info.flags = flags;
@@ -369,8 +370,9 @@ int select_ep11_apqn_by_mkvp(struct ep11
  *
  * @returns 0 on success, a negative errno in case of errors
  */
-static int ep11_adm_reencrypt(struct ep11_lib *ep11, target_t target, int card,
-			      int domain, struct ep11keytoken *ep11key,
+static int ep11_adm_reencrypt(struct ep11_lib *ep11, target_t target,
+			      unsigned int card, unsigned int domain,
+			      struct ep11keytoken *ep11key,
 			      unsigned int ep11key_size, bool verbose)
 {
 	CK_BYTE resp[MAX_BLOBSIZE];
@@ -406,8 +408,8 @@ static int ep11_adm_reencrypt(struct ep1
 		return -EIO;
 	}
 
-	rv = ep11->dll_m_admin(resp, &resp_len, NULL, 0, req, req_len, NULL, 0,
-			       target);
+	rv = ep11->dll_m_admin(resp, &resp_len, NULL, NULL, req, req_len, NULL,
+			       0, target);
 	if (rv != CKR_OK || resp_len == 0) {
 		pr_verbose(verbose, "Command XCP_ADM_REENCRYPT failed. "
 			   "rc = 0x%lx, resp_len = %ld", rv, resp_len);
@@ -461,8 +463,8 @@ static int ep11_adm_reencrypt(struct ep1
  *
  * @returns 0 on success, a negative errno in case of errors
  */
-int reencipher_ep11_key(struct ep11_lib *ep11, target_t target, int card,
-			int domain, u8 *secure_key,
+int reencipher_ep11_key(struct ep11_lib *ep11, target_t target,
+			unsigned int card, unsigned int domain, u8 *secure_key,
 			unsigned int secure_key_size, bool verbose)
 {
 	struct ep11keytoken *ep11key = (struct ep11keytoken *)secure_key;
diff -pruN 2.14.0-2/zkey/ep11.h 2.15.1-0ubuntu2/zkey/ep11.h
--- 2.14.0-2/zkey/ep11.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/ep11.h	2020-10-28 14:31:59.000000000 +0000
@@ -158,8 +158,9 @@ struct ep11_lib {
 
 int load_ep11_library(struct ep11_lib *ep11, bool verbose);
 
-int get_ep11_target_for_apqn(struct ep11_lib *ep11, int card, int domain,
-			     target_t *target, bool verbose);
+int get_ep11_target_for_apqn(struct ep11_lib *ep11, unsigned int card,
+			     unsigned int domain, target_t *target,
+			     bool verbose);
 
 void free_ep11_target_for_apqn(struct ep11_lib *ep11, target_t target);
 
@@ -168,11 +169,11 @@ void free_ep11_target_for_apqn(struct ep
 
 int select_ep11_apqn_by_mkvp(struct ep11_lib *ep11, u8 *mkvp,
 			     const char *apqns,  unsigned int flags,
-			     target_t *target, int *card, int *domain,
-			     bool verbose);
+			     target_t *target, unsigned int *card,
+			     unsigned int *domain, bool verbose);
 
-int reencipher_ep11_key(struct ep11_lib *ep11, target_t target, int card,
-			int domain, u8 *secure_key,
+int reencipher_ep11_key(struct ep11_lib *ep11, target_t target,
+			unsigned int card, unsigned int domain, u8 *secure_key,
 			unsigned int secure_key_size, bool verbose);
 
 #endif
diff -pruN 2.14.0-2/zkey/keystore.c 2.15.1-0ubuntu2/zkey/keystore.c
--- 2.14.0-2/zkey/keystore.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/keystore.c	2020-10-28 14:31:59.000000000 +0000
@@ -3,7 +3,7 @@
  *
  * Keystore handling functions
  *
- * Copyright IBM Corp. 2018, 2019
+ * Copyright IBM Corp. 2018, 2020
  *
  * s390-tools is free software; you can redistribute it and/or modify
  * it under the terms of the MIT license. See LICENSE for details.
@@ -49,19 +49,6 @@ struct key_filenames {
 
 #define LOCK_FILE_NAME		".lock"
 
-#define PROP_NAME_KEY_TYPE	"key-type"
-#define PROP_NAME_CIPHER	"cipher"
-#define PROP_NAME_IV_MODE	"iv-mode"
-#define PROP_NAME_DESCRIPTION	"description"
-#define PROP_NAME_VOLUMES	"volumes"
-#define PROP_NAME_APQNS		"apqns"
-#define PROP_NAME_SECTOR_SIZE	"sector-size"
-#define PROP_NAME_CREATION_TIME	"creation-time"
-#define PROP_NAME_CHANGE_TIME	"update-time"
-#define PROP_NAME_REENC_TIME	"reencipher-time"
-#define PROP_NAME_KEY_VP	"verification-pattern"
-#define PROP_NAME_VOLUME_TYPE	"volume-type"
-
 #define VOLUME_TYPE_PLAIN	"plain"
 #define VOLUME_TYPE_LUKS2	"luks2"
 #ifdef HAVE_LUKS2_SUPPORT
@@ -87,12 +74,17 @@ struct key_filenames {
 #define REC_REENC_TIME		"Re-enciphered"
 #define REC_KEY_VP		"Verification pattern"
 #define REC_VOLUME_TYPE		"Volume type"
+#define REC_KMS			"KMS"
+#define REC_KMS_KEY_LABEL	"KMS key label"
 
 #define pr_verbose(keystore, fmt...)	do {				\
 						if (keystore->verbose)	\
 							warnx(fmt);	\
 					} while (0)
 
+static int _keystore_kms_key_unbind(struct keystore *keystore,
+				    struct properties *properties);
+
 /**
  * Gets the file names of the .skey and .info and .renc files for a named
  * key in the key strore's directory
@@ -350,6 +342,35 @@ static int _keystore_valid_key_type(cons
 }
 
 /**
+ * Checks if the keys is KMS-bound
+ *
+ * @param[in] key_props     the key properties
+ * @param[out] kms_name     the name of the KMS plugin, if KMS-bound
+ *
+ * @return true if the key is KMS bound, false otherwise
+ */
+static bool _keystore_is_kms_bound_key(struct properties *key_props,
+				       char **kms_name)
+{
+	bool ret = false;
+	char *kms;
+
+	if (kms_name != NULL)
+		*kms_name = NULL;
+
+	kms = properties_get(key_props, PROP_NAME_KMS);
+	if (kms != NULL && strcasecmp(kms, "LOCAL") != 0)
+		ret = true;
+
+	if (kms_name != NULL && ret == true)
+		*kms_name = kms;
+	else if (kms != NULL)
+		free(kms);
+
+	return ret;
+}
+
+/**
  * Prints a message followed by a list of associated volumes, if volumes are
  * associated and the volume-type matches (if specified)
  *
@@ -681,11 +702,11 @@ static int _keystore_change_association(
 static int _keystore_apqn_match(const char *pattern, const char *apqn,
 				int UNUSED(flags))
 {
-	char *modified;
+	unsigned int card, domain;
 	char *pattern_domain;
 	char *pattern_card;
+	char *modified;
 	char *copy;
-	int card, domain;
 	size_t i;
 	char *ch;
 	int rc;
@@ -945,6 +966,8 @@ typedef int (*process_key_t)(struct keys
  *                           NULL means no APQN filter.
  * @param[in] volume_type    If not NULL, specifies the volume type.
  * @param[in] key_type       The key type. NULL means no key type filter.
+ * @param[in] local          if true, only local keys are processed
+ * @param[in] kms_bound      if true, only KMS-bound keys are processed
  * @param[in] process_func   the callback function called for a matching key
  * @param[in/out] process_private private data passed to the process_func
  *
@@ -958,6 +981,7 @@ static int _keystore_process_filtered(st
 				      const char *apqn_filter,
 				      const char *volume_type,
 				      const char *key_type,
+				      bool local, bool kms_bound,
 				      process_key_t process_func,
 				      void *process_private)
 {
@@ -972,8 +996,10 @@ static int _keystore_process_filtered(st
 	int len;
 
 	pr_verbose(keystore, "Process_filtered: name_filter = '%s', "
-		   "volume_filter = '%s', apqn_filter = '%s'", name_filter,
-		   volume_filter, apqn_filter);
+		   "volume_filter = '%s', apqn_filter = '%s'",
+		   name_filter ? name_filter : "(null)",
+		   volume_filter ? volume_filter : "(null)",
+		   apqn_filter ? apqn_filter : "(null)");
 
 	if (volume_filter != NULL)
 		vol_filter_list = str_list_split(volume_filter);
@@ -1058,6 +1084,21 @@ static int _keystore_process_filtered(st
 			goto free_prop;
 		}
 
+		if (local && _keystore_is_kms_bound_key(key_props, NULL)) {
+			pr_verbose(keystore,
+				   "Key '%s' filtered out because it is KMS "
+				   "bound", name);
+			rc = 0;
+			goto free_prop;
+		}
+		if (kms_bound && !_keystore_is_kms_bound_key(key_props, NULL)) {
+			pr_verbose(keystore,
+				   "Key '%s' filtered out because it is not "
+				   "KMS bound", name);
+			rc = 0;
+			goto free_prop;
+		}
+
 		rc = process_func(keystore, name, key_props, &file_names,
 				  process_private);
 		if (rc != 0) {
@@ -1106,10 +1147,11 @@ static int _keystore_apqn_check(const ch
 				char **normalized, void *private)
 {
 	struct apqn_check *info = (struct apqn_check *)private;
-	int rc, card, domain;
+	unsigned int card, domain;
 	regmatch_t pmatch[1];
-	regex_t reg_buf;
 	unsigned int num;
+	regex_t reg_buf;
+	int rc;
 
 	*normalized = NULL;
 
@@ -1124,9 +1166,8 @@ static int _keystore_apqn_check(const ch
 		goto out;
 	}
 
-	if (sscanf(apqn, "%x.%x%n", &card, &domain, &num) != 2 ||
-	    num != strlen(apqn) || card < 0 || card > 0xff ||
-	    domain < 0 || domain > 0xFFFF) {
+	if (sscanf(apqn, "%x.%x%n", &card, &domain, (int *)&num) != 2 ||
+	    num != strlen(apqn) || card > 0xff || domain > 0xFFFF) {
 		warnx("the APQN '%s' is not valid", apqn);
 		rc = -EINVAL;
 		goto out;
@@ -1161,6 +1202,7 @@ struct volume_check {
 	const char *name;
 	const char *volume;
 	bool set;
+	bool nocheck;
 };
 
 /**
@@ -1250,7 +1292,7 @@ static int _keystore_volume_check(const
 		goto out;
 	}
 
-	if (remove) {
+	if (remove || info->nocheck) {
 		rc = 0;
 		goto out;
 	}
@@ -1270,7 +1312,7 @@ static int _keystore_volume_check(const
 
 	info->set = set;
 	rc = _keystore_process_filtered(info->keystore, NULL, info->volume,
-					NULL, NULL, NULL,
+					NULL, NULL, NULL, false, false,
 					_keystore_volume_check_process, info);
 out:
 	free((void *)info->volume);
@@ -1365,11 +1407,13 @@ static int _keystore_unlock_repository(s
  * Allocates new keystore object
  *
  * @param[in]    directory     the directory where the keystore resides
+ * @param[in]    kms_info      KMS plugin info
  * @param[in]    verbose       if true, verbose messages are printed
  *
  * @returns a new keystore object
  */
-struct keystore *keystore_new(const char *directory, bool verbose)
+struct keystore *keystore_new(const char *directory,
+			      struct kms_info *kms_info, bool verbose)
 {
 	struct keystore *keystore;
 	struct stat sb;
@@ -1408,6 +1452,8 @@ struct keystore *keystore_new(const char
 	if (keystore->directory[strlen(keystore->directory)-1] == '/')
 		keystore->directory[strlen(keystore->directory)-1] = '\0';
 
+	keystore->kms_info = kms_info;
+
 	rc = _keystore_lock_repository(keystore);
 	if (rc != 0) {
 		keystore_free(keystore);
@@ -1548,11 +1594,10 @@ static int _keystore_set_default_propert
 }
 
 /**
- * Creates an initial .info file for a key
+ * Creates the key properties for a key
  *
  * @param[in] keystore    the key store
  * @param[in] name        the name of the key
- * @param[in] info_filename  the file name of the key info file
  * @param[in] description textual description of the key (optional, can be NULL)
  * @param[in] volumes     a comma separated list of volumes associated with this
  *                        key (optional, can be NULL)
@@ -1560,25 +1605,30 @@ static int _keystore_set_default_propert
  *                        key (optional, can be NULL)
  * @param[in] noapqncheck if true, the specified APQN(s) are not checked for
  *                        existence and type.
+ * @param[i] novolscheck  if true, the specified Volume(s) are not checked for
+ *                        existence or duplicate use
  * @param[in] sector_size the sector size to use with dm-crypt. It must be power
  *                        of two and in range 512 - 4096 bytes. 0 means that
  *                        the sector size is not specified and the system
  *                        default is used.
  * @param[in] volume_type the type of volume
  * @param[in] key_type    the type of the key
+ * @param[in] kms         the name of the KMS plugin, or NULL if no KMS is bound
+ * @param[out] props      the properties object is allocated and returned
  */
-static int _keystore_create_info_file(struct keystore *keystore,
-				      const char *name,
-				      const struct key_filenames *filenames,
-				      const char *description,
-				      const char *volumes, const char *apqns,
-				      bool noapqncheck,
-				      size_t sector_size,
-				      const char *volume_type,
-				      const char *key_type)
+static int _keystore_create_info_props(struct keystore *keystore,
+				       const char *name,
+				       const char *description,
+				       const char *volumes, const char *apqns,
+				       bool noapqncheck, bool novolcheck,
+				       size_t sector_size,
+				       const char *volume_type,
+				       const char *key_type,
+				       const char *kms,
+				       struct properties **props)
 {
 	struct volume_check vol_check = { .keystore = keystore, .name = name,
-					  .set = 0 };
+					  .set = 0, .nocheck = novolcheck };
 	struct apqn_check apqn_check = { .noonlinecheck = noapqncheck,
 					 .nomsg = 0,
 					 .cardtype = get_card_type_for_keytype(
@@ -1587,6 +1637,8 @@ static int _keystore_create_info_file(st
 	char temp[10];
 	int rc;
 
+	*props = NULL;
+
 	key_props = properties_new();
 	rc = _keystore_set_default_properties(key_props);
 	if (rc != 0)
@@ -1646,13 +1698,73 @@ static int _keystore_create_info_file(st
 		goto out;
 	}
 
+	if (kms != NULL) {
+		rc = properties_set(key_props, PROP_NAME_KMS, kms);
+		if (rc != 0) {
+			warnx("Invalid characters in KMS");
+			goto out;
+		}
+	}
+
+out:
+	if (rc == 0)
+		*props = key_props;
+	else
+		properties_free(key_props);
+
+	return rc;
+}
+
+
+/**
+ * Creates an initial .info file for a key
+ *
+ * @param[in] keystore    the key store
+ * @param[in] name        the name of the key
+ * @param[in] info_filename  the file name of the key info file
+ * @param[in] description textual description of the key (optional, can be NULL)
+ * @param[in] volumes     a comma separated list of volumes associated with this
+ *                        key (optional, can be NULL)
+ * @param[in] apqns       a comma separated list of APQNs associated with this
+ *                        key (optional, can be NULL)
+ * @param[in] noapqncheck if true, the specified APQN(s) are not checked for
+ *                        existence and type.
+ * @param[in] sector_size the sector size to use with dm-crypt. It must be power
+ *                        of two and in range 512 - 4096 bytes. 0 means that
+ *                        the sector size is not specified and the system
+ *                        default is used.
+ * @param[in] volume_type the type of volume
+ * @param[in] key_type    the type of the key
+ * @param[in] kms         the name of the KMS plugin, or NULL if no KMS is bound
+ */
+static int _keystore_create_info_file(struct keystore *keystore,
+				      const char *name,
+				      const struct key_filenames *filenames,
+				      const char *description,
+				      const char *volumes, const char *apqns,
+				      bool noapqncheck,
+				      size_t sector_size,
+				      const char *volume_type,
+				      const char *key_type,
+				      const char *kms)
+{
+	struct properties *key_props = NULL;
+	int rc;
+
+	rc = _keystore_create_info_props(keystore, name, description, volumes,
+					 apqns, noapqncheck, false, sector_size,
+					 volume_type, key_type, kms,
+					 &key_props);
+	if (rc != 0)
+		return rc;
+
 	rc = _keystore_ensure_vp_exists(keystore, filenames, key_props);
 	if (rc != 0) {
 		warnx("Failed to generate the key verification pattern: %s",
 		      strerror(-rc));
 		warnx("Make sure that kernel module 'paes_s390' is loaded and "
 		      "that the 'paes' cipher is available");
-		return rc;
+		goto out;
 	}
 
 	rc = properties_save(key_props, filenames->info_filename, 1);
@@ -1768,7 +1880,7 @@ int keystore_generate_key(struct keystor
 	rc = _keystore_create_info_file(keystore, name, &file_names,
 					description, volumes, apqns,
 					noapqncheck, sector_size, volume_type,
-					key_type);
+					key_type, NULL);
 	if (rc != 0)
 		goto out_free_props;
 
@@ -1794,6 +1906,164 @@ out_free_key_filenames:
 }
 
 /**
+ * Generates a secure key by using a KMS plugin and adds it to the key store
+ *
+ * @param[in] keystore    the key store
+ * @param[in] name        the name of the key
+ * @param[in] description textual description of the key (optional, can be NULL)
+ * @param[in] volumes     a comma separated list of volumes associated with this
+ *                        key (optional, can be NULL)
+ * @param[in] sector_size the sector size to use with dm-crypt. It must be power
+ *                        of two and in range 512 - 4096 bytes. 0 means that
+ *                        the sector size is not specified and the system
+ *                        default is used.
+ * @param[in] keybits     cryptographical size of the key in bits
+ * @param[in] xts         if true, an XTS key is generated
+ * @param[in] volume_type the type of volume
+ * @param[in] key_type    the type of the key (can be NULL)
+ * @param[in] kms_options an array of KMS options specified, or NULL if no
+ *                         KMS options have been specified
+ * @param[in] num_kms_options the number of options in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error
+ */
+int keystore_generate_key_kms(struct keystore *keystore, const char *name,
+			      const char *description, const char *volumes,
+			      size_t sector_size, size_t keybits, bool xts,
+			      const char *volume_type, const char *key_type,
+			      struct kms_option *kms_options,
+			      size_t num_kms_options)
+{
+	struct key_filenames file_names = { NULL, NULL, NULL };
+	struct properties *key_props = NULL;
+	struct kms_info *kms_info;
+	char *apqns = NULL;
+	int rc, i;
+
+	static const char * const key_types[] = {
+			KEY_TYPE_CCA_AESDATA,
+			KEY_TYPE_CCA_AESCIPHER,
+			KEY_TYPE_EP11_AES,
+			NULL
+	};
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+	util_assert(name != NULL, "Internal error: name is NULL");
+
+	kms_info = keystore->kms_info;
+	if (kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (key_type == NULL) {
+		for (i = 0; kms_info->funcs->kms_supports_key_type != NULL &&
+			    key_types[i] != NULL; i++) {
+			if (kms_info->funcs->kms_supports_key_type(
+					kms_info->handle, key_types[i])) {
+				key_type = key_types[i];
+				break;
+			}
+		}
+		if (key_type == NULL)
+			key_type = KEY_TYPE_CCA_AESDATA;
+	}
+
+	if (!_keystore_valid_key_type(key_type)) {
+		warnx("Invalid key-type specified");
+		return -EINVAL;
+	}
+
+	rc = _keystore_get_key_filenames(keystore, name, &file_names);
+	if (rc != 0)
+		goto out_free_key_filenames;
+
+	rc = _keystore_ensure_keyfiles_not_exist(&file_names, name);
+	if (rc != 0)
+		goto out_free_key_filenames;
+
+	rc = get_kms_apqns_for_key_type(kms_info, key_type, true, &apqns,
+					keystore->verbose);
+	if (rc != 0) {
+		if (rc == -ENOTSUP)
+			warnx("Key-type not supported by the KMS plugin '%s'",
+			      kms_info->plugin_name);
+		goto out_free_key_filenames;
+	}
+
+	pr_verbose(keystore, "APQNs for keytype %s: '%s'", key_type, apqns);
+
+	rc = _keystore_create_info_props(keystore, name, description, volumes,
+					 apqns, false, false, sector_size,
+					 volume_type, key_type,
+					 kms_info->plugin_name, &key_props);
+	if (rc != 0)
+		goto out_free_key_filenames;
+
+	rc = generate_kms_key(kms_info, name, key_type, key_props, xts,
+			      keybits, file_names.skey_filename,
+			      kms_options, num_kms_options, keystore->verbose);
+	if (rc != 0) {
+		warnx("KMS plugin '%s' failed to generate key '%s': %s",
+		      kms_info->plugin_name, name, strerror(-rc));
+		print_last_kms_error(kms_info);
+		goto out_free_props;
+	}
+
+	rc = _keystore_set_file_permission(keystore, file_names.skey_filename);
+	if (rc != 0)
+		goto out_free_props;
+
+	rc = _keystore_ensure_vp_exists(keystore, &file_names, key_props);
+	if (rc != 0) {
+		warnx("Failed to generate the key verification pattern: %s",
+		      strerror(-rc));
+		warnx("Make sure that kernel module 'paes_s390' is loaded and "
+		      "that the 'paes' cipher is available");
+		goto out_free_props;
+	}
+
+	rc = properties_save(key_props, file_names.info_filename, 1);
+	if (rc != 0) {
+		pr_verbose(keystore,
+			   "Key info file '%s' could not be written: %s",
+			   file_names.info_filename, strerror(-rc));
+		goto out_del_info_file;
+	}
+
+	rc = _keystore_set_file_permission(keystore, file_names.info_filename);
+	if (rc != 0) {
+		remove(file_names.info_filename);
+		goto out_del_info_file;
+	}
+
+	pr_verbose(keystore,
+		   "Successfully generated a secure key with KMS plugin '%s' "
+		   "in '%s' and key info in '%s'", kms_info->plugin_name,
+		   file_names.skey_filename, file_names.info_filename);
+
+out_del_info_file:
+	if (rc != 0)
+		remove(file_names.info_filename);
+out_free_props:
+	if (key_props != NULL)
+		properties_free(key_props);
+	if (rc != 0)
+		remove(file_names.skey_filename);
+out_free_key_filenames:
+	_keystore_free_key_filenames(&file_names);
+	if (apqns != NULL)
+		free(apqns);
+
+	if (rc != 0)
+		pr_verbose(keystore, "Failed to generate key '%s' with KMS "
+			   "plugin '%s': %s", name, kms_info->plugin_name,
+			   strerror(-rc));
+	return rc;
+
+}
+
+/**
  * Imports a secure key from a file and adds it to the key store
  *
  * @param[in] keystore    the key store
@@ -1936,7 +2206,7 @@ int keystore_import_key(struct keystore
 	rc = _keystore_create_info_file(keystore, name, &file_names,
 					description, volumes, apqns,
 					noapqncheck, sector_size, volume_type,
-					key_type);
+					key_type, NULL);
 	if (rc != 0)
 		goto out_free_props;
 
@@ -1996,16 +2266,19 @@ int keystore_change_key(struct keystore
 			long int sector_size, const char *volume_type)
 {
 	struct volume_check vol_check = { .keystore = keystore, .name = name,
-					  .set = 0 };
+					  .set = 0, .nocheck = 0 };
 	struct apqn_check apqn_check = { .noonlinecheck = noapqncheck,
 					 .nomsg = 0 };
 	struct key_filenames file_names = { NULL, NULL, NULL };
 	struct properties *key_props = NULL;
+	char *upd_volume_type = NULL;
 	char *apqns_prop, *key_type;
+	char *upd_volumes = NULL;
 	size_t secure_key_size;
 	u8 mkvp[MKVP_LENGTH];
+	char sect_size[30];
 	u8 *secure_key;
-	char temp[30];
+	bool kms_bound;
 	int rc;
 
 	util_assert(keystore != NULL, "Internal error: keystore is NULL");
@@ -2026,6 +2299,8 @@ int keystore_change_key(struct keystore
 		goto out;
 	}
 
+	kms_bound = _keystore_is_kms_bound_key(key_props, NULL);
+
 	if (description != NULL) {
 		rc = properties_set(key_props, PROP_NAME_DESCRIPTION,
 				    description);
@@ -2042,9 +2317,18 @@ int keystore_change_key(struct keystore
 						  &vol_check);
 		if (rc != 0)
 			goto out;
+
+		upd_volumes = properties_get(key_props, PROP_NAME_VOLUMES);
 	}
 
 	if (apqns != NULL) {
+		if (kms_bound) {
+			rc = -EINVAL;
+			warnx("The APQN association of a KMS-bound key can not "
+			      "be changed");
+			goto out;
+		}
+
 		rc = _keystore_change_association(key_props, PROP_NAME_APQNS,
 						  apqns, "APQN",
 						  _keystore_apqn_check,
@@ -2092,9 +2376,9 @@ int keystore_change_key(struct keystore
 			goto out;
 		}
 
-		sprintf(temp, "%lu", sector_size);
+		sprintf(sect_size, "%lu", sector_size);
 		rc = properties_set(key_props, PROP_NAME_SECTOR_SIZE,
-				    temp);
+				    sect_size);
 		if (rc != 0) {
 			warnx("Invalid characters in sector-size");
 			goto out;
@@ -2114,6 +2398,29 @@ int keystore_change_key(struct keystore
 			warnx("Invalid characters in volume-type");
 			goto out;
 		}
+
+		upd_volume_type = properties_get(key_props,
+						 PROP_NAME_VOLUME_TYPE);
+	}
+
+	if (kms_bound) {
+		rc = perform_kms_login(keystore->kms_info, keystore->verbose);
+		if (rc != 0)
+			goto out;
+
+		rc = set_kms_key_properties(keystore->kms_info, key_props, NULL,
+					    description, upd_volumes,
+					    upd_volume_type, sector_size >= 0 ?
+							sect_size : NULL,
+					    keystore->verbose);
+		if (rc != 0) {
+			warnx("KMS plugin '%s' failed to set key properties "
+			      "for key '%s': %s",
+			      keystore->kms_info->plugin_name, name,
+			      strerror(-rc));
+			print_last_kms_error(keystore->kms_info);
+			goto out;
+		}
 	}
 
 	rc = _keystore_ensure_vp_exists(keystore, &file_names, key_props);
@@ -2137,6 +2444,10 @@ out:
 	_keystore_free_key_filenames(&file_names);
 	if (key_props != NULL)
 		properties_free(key_props);
+	if (upd_volumes != NULL)
+		free(upd_volumes);
+	if (upd_volume_type != NULL)
+		free(upd_volume_type);
 
 	if (rc != 0)
 		pr_verbose(keystore, "Failed to change key '%s': %s",
@@ -2159,6 +2470,7 @@ int keystore_rename_key(struct keystore
 	struct key_filenames file_names = { NULL, NULL, NULL };
 	struct key_filenames new_names = { NULL, NULL, NULL };
 	struct properties *key_props = NULL;
+	bool reenc_exists = false;
 	char *msg;
 	int rc;
 
@@ -2192,18 +2504,16 @@ int keystore_rename_key(struct keystore
 		rc = -errno;
 		pr_verbose(keystore, "Failed to rename '%s': %s",
 			   file_names.info_filename, strerror(-rc));
-		rename(new_names.skey_filename, file_names.skey_filename);
+		goto out_rename_skey;
 	}
 	if (_keystore_reencipher_key_exists(&file_names)) {
+		reenc_exists = true;
 		if (rename(file_names.renc_filename,
 			   new_names.renc_filename) != 0) {
 			rc = -errno;
 			pr_verbose(keystore, "Failed to rename '%s': %s",
 				   file_names.renc_filename, strerror(-rc));
-			rename(new_names.skey_filename,
-			       file_names.skey_filename);
-			rename(new_names.info_filename,
-			       file_names.info_filename);
+			goto out_rename_info;
 		}
 	}
 
@@ -2211,7 +2521,25 @@ int keystore_rename_key(struct keystore
 	rc = properties_load(key_props, new_names.info_filename, 1);
 	if (rc != 0) {
 		warnx("Key '%s' does not exist or is invalid", newname);
-		goto out;
+		goto out_rename_info;
+	}
+
+	if (_keystore_is_kms_bound_key(key_props, NULL)) {
+		rc = perform_kms_login(keystore->kms_info, keystore->verbose);
+		if (rc != 0)
+			goto out_rename_info;
+
+		rc = set_kms_key_properties(keystore->kms_info, key_props,
+					    newname, NULL, NULL, NULL, NULL,
+					    keystore->verbose);
+		if (rc != 0) {
+			warnx("KMS plugin '%s' failed to set key properties "
+			      "for key '%s': %s",
+			      keystore->kms_info->plugin_name, name,
+			      strerror(-rc));
+			print_last_kms_error(keystore->kms_info);
+			goto out_rename_info;
+		}
 	}
 
 	util_asprintf(&msg, "The following volumes are associated with the "
@@ -2224,6 +2552,16 @@ int keystore_rename_key(struct keystore
 	pr_verbose(keystore, "Successfully renamed key '%s' to '%s'", name,
 		   newname);
 
+	goto out;
+
+out_rename_info:
+	if (reenc_exists)
+		rename(file_names.renc_filename, new_names.renc_filename);
+	rename(new_names.info_filename, file_names.info_filename);
+
+out_rename_skey:
+	rename(new_names.skey_filename, file_names.skey_filename);
+
 out:
 	_keystore_free_key_filenames(&file_names);
 	_keystore_free_key_filenames(&new_names);
@@ -2272,6 +2610,9 @@ static struct util_rec *_keystore_setup_
 	util_rec_def(rec, REC_VOLUME_TYPE, UTIL_REC_ALIGN_LEFT, 54,
 		     REC_VOLUME_TYPE);
 	util_rec_def(rec, REC_KEY_VP, UTIL_REC_ALIGN_LEFT, 54, REC_KEY_VP);
+	util_rec_def(rec, REC_KMS, UTIL_REC_ALIGN_LEFT, 54, REC_KMS);
+	util_rec_def(rec, REC_KMS_KEY_LABEL, UTIL_REC_ALIGN_LEFT, 54,
+		     REC_KMS_KEY_LABEL);
 	util_rec_def(rec, REC_CREATION_TIME, UTIL_REC_ALIGN_LEFT, 54,
 		     REC_CREATION_TIME);
 	util_rec_def(rec, REC_CHANGE_TIME, UTIL_REC_ALIGN_LEFT, 54,
@@ -2291,9 +2632,14 @@ static void _keystore_print_record(struc
 				   bool is_old_mk, bool reenc_pending, u8 *mkvp)
 {
 	char temp_vp[VERIFICATION_PATTERN_LEN + 2];
+	char *kms_xts_key1_label = NULL;
+	char *kms_xts_key2_label = NULL;
+	char *kms_key_label = NULL;
 	char *volumes_argz = NULL;
+	size_t label_argz_len = 0;
 	size_t volumes_argz_len;
 	char *apqns_argz = NULL;
+	char *label_argz = NULL;
 	size_t sector_size = 0;
 	size_t apqns_argz_len;
 	char *description;
@@ -2305,6 +2651,7 @@ static void _keystore_print_record(struc
 	char *change;
 	char *apqns;
 	char *temp;
+	char *kms;
 	char *vp;
 	int len;
 
@@ -2335,6 +2682,30 @@ static void _keystore_print_record(struc
 	vp = properties_get(properties, PROP_NAME_KEY_VP);
 	volume_type = _keystore_get_volume_type(properties);
 	key_type = properties_get(properties, PROP_NAME_KEY_TYPE);
+	if (_keystore_is_kms_bound_key(properties, &kms)) {
+		if (is_xts) {
+			kms_xts_key1_label = properties_get(properties,
+					PROP_NAME_KMS_XTS_KEY1_LABEL);
+			kms_xts_key2_label = properties_get(properties,
+					PROP_NAME_KMS_XTS_KEY2_LABEL);
+
+			if (kms_xts_key1_label != NULL &&
+			    kms_xts_key2_label != NULL) {
+				label_argz_len = util_asprintf(&label_argz,
+					 "%s%c%s", kms_xts_key1_label, '\0',
+					 kms_xts_key2_label) + 1;
+			}
+		} else {
+			kms_key_label = properties_get(properties,
+					PROP_NAME_KMS_KEY_LABEL);
+
+			if (kms_key_label != NULL) {
+				label_argz = kms_key_label;
+				label_argz_len = strlen(label_argz) + 1;
+				kms_key_label = NULL;
+			}
+		}
+	}
 
 	util_rec_set(rec, REC_KEY, name);
 	if (validation)
@@ -2389,7 +2760,13 @@ static void _keystore_print_record(struc
 		util_rec_set_argz(rec, REC_KEY_VP, temp_vp, len + 1);
 	} else {
 		util_rec_set(rec, REC_KEY_VP, "(not available)");
-		}
+	}
+	util_rec_set(rec, REC_KMS, kms != NULL ? kms : "(local)");
+	if (kms != NULL && label_argz != NULL)
+		util_rec_set_argz(rec, REC_KMS_KEY_LABEL, label_argz,
+				  label_argz_len);
+	else
+		util_rec_set(rec, REC_KMS_KEY_LABEL, "(local)");
 	util_rec_set(rec, REC_CREATION_TIME, creation);
 	util_rec_set(rec, REC_CHANGE_TIME,
 		     change != NULL ? change : "(never)");
@@ -2421,6 +2798,16 @@ static void _keystore_print_record(struc
 		free(volume_type);
 	if (key_type != NULL)
 		free(key_type);
+	if (kms != NULL)
+		free(kms);
+	if (kms_key_label != NULL)
+		free(kms_key_label);
+	if (kms_xts_key1_label != NULL)
+		free(kms_xts_key1_label);
+	if (kms_xts_key2_label != NULL)
+		free(kms_xts_key2_label);
+	if (label_argz != NULL)
+		free(label_argz);
 }
 
 struct validate_info {
@@ -2641,7 +3028,7 @@ int keystore_validate_key(struct keystor
 	info.num_warnings = 0;
 
 	rc = _keystore_process_filtered(keystore, name_filter, NULL,
-					apqn_filter, NULL, NULL,
+					apqn_filter, NULL, NULL, false, false,
 					_keystore_process_validate, &info);
 
 	util_rec_free(rec);
@@ -3009,7 +3396,7 @@ int keystore_reencipher_key(struct keyst
 	info.num_skipped = 0;
 
 	rc = _keystore_process_filtered(keystore, name_filter, NULL,
-					apqn_filter, NULL, NULL,
+					apqn_filter, NULL, NULL, false, false,
 					_keystore_process_reencipher, &info);
 
 	if (rc != 0) {
@@ -3038,18 +3425,20 @@ int keystore_reencipher_key(struct keyst
  * @param[in] newname  the new name of the key
  * @param[in] volumes  a comma separated list of volumes associated with this
  *                     key (optional, can be NULL)
+ * @param[in] local    if true copy a KMS-bound key to a local one
  *
  * @returns 0 for success or a negative errno in case of an error
  */
 int keystore_copy_key(struct keystore *keystore, const char *name,
-		      const char *newname, const char *volumes)
+		      const char *newname, const char *volumes, bool local)
 {
-	struct volume_check vol_check = { .keystore = keystore,
-					  .name = newname, .set = 0 };
+	struct volume_check vol_check = { .keystore = keystore, .name = newname,
+					  .set = 0, .nocheck = 0 };
 	struct key_filenames file_names = { NULL, NULL, NULL };
 	struct key_filenames new_names = { NULL, NULL, NULL };
 	struct properties *key_prop = NULL;
 	size_t secure_key_size;
+	bool kms_bound = false;
 	u8 *secure_key;
 	int rc;
 
@@ -3073,6 +3462,21 @@ int keystore_copy_key(struct keystore *k
 	if (rc != 0)
 		goto out;
 
+	key_prop = properties_new();
+	rc = properties_load(key_prop, file_names.info_filename, 1);
+	if (rc != 0) {
+		warnx("Key '%s' does not exist or is invalid", name);
+		goto out;
+	}
+
+	kms_bound = _keystore_is_kms_bound_key(key_prop, NULL);
+	if (kms_bound && !local) {
+		rc = -EINVAL;
+		warnx("Copying a KMS-bound key requires the "
+		      "'--local|-L' option");
+		goto out;
+	}
+
 	secure_key = read_secure_key(file_names.skey_filename,
 				     &secure_key_size, keystore->verbose);
 	if (secure_key == NULL) {
@@ -3090,14 +3494,6 @@ int keystore_copy_key(struct keystore *k
 	if (rc != 0)
 		goto out;
 
-	key_prop = properties_new();
-	rc = properties_load(key_prop, file_names.info_filename, 1);
-	if (rc != 0) {
-		warnx("Key '%s' does not exist or is invalid", name);
-		remove(file_names.skey_filename);
-		goto out;
-	}
-
 	/*
 	 * Remove any volume association, since a volume can only be associated
 	 * with one key
@@ -3129,9 +3525,15 @@ int keystore_copy_key(struct keystore *k
 	if (rc != 0)
 		goto out;
 
-	rc = properties_save(key_prop, new_names.info_filename, 1);
-	if (rc != 0) {
-		pr_verbose(keystore,
+	if (kms_bound) {
+		rc = _keystore_kms_key_unbind(keystore, key_prop);
+		if (rc != 0)
+			goto out;
+	}
+
+	rc = properties_save(key_prop, new_names.info_filename, 1);
+	if (rc != 0) {
+		pr_verbose(keystore,
 			   "Key info file '%s' could not be written: %s",
 			   new_names.info_filename, strerror(-rc));
 		remove(new_names.skey_filename);
@@ -3263,13 +3665,18 @@ out:
  * @param[in] keystore the key store
  * @param[in] name     the name of the key
  * @param[in] quiet    if true no confirmation prompt is shown
+ * @param[in] kms_options an array of KMS options specified, or NULL if no
+ *                     KMS options have been specified
+ * @param[in] num_kms_options the number of options in above array
  *
  * @returns 0 for success or a negative errno in case of an error
  */
 int keystore_remove_key(struct keystore *keystore, const char *name,
-			bool quiet)
+			bool quiet, struct kms_option *kms_options,
+			size_t num_kms_options)
 {
 	struct key_filenames file_names = { NULL, NULL, NULL };
+	struct properties *key_props = NULL;
 	int rc;
 
 	util_assert(keystore != NULL, "Internal error: keystore is NULL");
@@ -3289,6 +3696,31 @@ int keystore_remove_key(struct keystore
 			goto out;
 	}
 
+	key_props = properties_new();
+	rc = properties_load(key_props, file_names.info_filename, 1);
+	if (rc != 0) {
+		warnx("Key '%s' does not exist or is invalid", name);
+		goto out;
+	}
+
+	if (_keystore_is_kms_bound_key(key_props, NULL)) {
+		rc = perform_kms_login(keystore->kms_info, keystore->verbose);
+		if (rc != 0)
+			goto out;
+
+		rc = remove_kms_key(keystore->kms_info, key_props,
+				    kms_options, num_kms_options,
+				    keystore->verbose);
+
+		if (rc != 0) {
+			warnx("KMS plugin '%s' failed to remove key '%s': %s",
+			      keystore->kms_info->plugin_name, name,
+			      strerror(-rc));
+			print_last_kms_error(keystore->kms_info);
+			goto out;
+		}
+	}
+
 	if (remove(file_names.skey_filename) != 0) {
 		rc = -errno;
 		pr_verbose(keystore, "Failed to remove '%s': %s",
@@ -3311,6 +3743,8 @@ int keystore_remove_key(struct keystore
 
 out:
 	_keystore_free_key_filenames(&file_names);
+	if (key_props != NULL)
+		properties_free(key_props);
 
 	if (rc != 0)
 		pr_verbose(keystore, "Failed to remove key '%s': %s",
@@ -3359,7 +3793,8 @@ static int _keystore_display_key(struct
 			       file_names->skey_filename, secure_key_size,
 			       is_xts_key(secure_key, secure_key_size),
 			       clear_key_bitsize, 0, 0,
-			       _keystore_reencipher_key_exists(file_names), 0);
+			       _keystore_reencipher_key_exists(file_names),
+			       NULL);
 
 out:
 	free(secure_key);
@@ -3383,12 +3818,15 @@ out:
  *                           NULL means no APQN filter.
  * @param[in] volume_type    The volume type. NULL means no volume type filter.
  * @param[in] key_type       The key type. NULL means no key type filter.
+ * @param[in] local          if true, only local keys are listed
+ * @param[in] kms_bound      if true, only KMS-bound keys are listed
  *
  * @returns 0 for success or a negative errno in case of an error
  */
 int keystore_list_keys(struct keystore *keystore, const char *name_filter,
 		       const char *volume_filter, const char *apqn_filter,
-		       const char *volume_type, const char *key_type)
+		       const char *volume_type, const char *key_type,
+		       bool local, bool kms_bound)
 {
 	struct util_rec *rec;
 	int rc;
@@ -3411,6 +3849,7 @@ int keystore_list_keys(struct keystore *
 
 	rc = _keystore_process_filtered(keystore, name_filter, volume_filter,
 					apqn_filter, volume_type, key_type,
+					local, kms_bound,
 					_keystore_display_key, rec);
 	util_rec_free(rec);
 
@@ -3872,7 +4311,7 @@ int keystore_cryptsetup(struct keystore
 	info.process_func = _keystore_process_cryptsetup;
 
 	rc = _keystore_process_filtered(keystore, NULL, volume_filter, NULL,
-					volume_type, NULL,
+					volume_type, NULL, false, false,
 					_keystore_process_crypt, &info);
 
 	str_list_free_string_array(info.volume_filter);
@@ -3933,7 +4372,7 @@ int keystore_crypttab(struct keystore *k
 	info.process_func = _keystore_process_crypttab;
 
 	rc = _keystore_process_filtered(keystore, NULL, volume_filter, NULL,
-					volume_type, NULL,
+					volume_type, NULL, false, false,
 					_keystore_process_crypt, &info);
 
 	str_list_free_string_array(info.volume_filter);
@@ -3995,6 +4434,12 @@ int keystore_convert_key(struct keystore
 		goto out;
 	}
 
+	if (_keystore_is_kms_bound_key(properties, NULL)) {
+		rc = -EINVAL;
+		warnx("A KMS-bound key can not be converted");
+		goto out;
+	}
+
 	cur_key_type = _keystore_get_key_type(properties);
 	if (strcasecmp(cur_key_type, key_type) == 0) {
 		warnx("The secure key '%s' is already of type %s", name,
@@ -4162,6 +4607,849 @@ out:
 	return rc;
 }
 
+struct kms_process {
+	process_key_t process_func;
+	void *process_private;
+};
+
+struct kms_set_prop {
+	const char *prop_name;
+	const char *prop_value;
+	unsigned long num_keys;
+};
+
+/**
+ * Processing function for setting properties of KMS-bound keys
+ *
+ * @param[in] keystore   the keystore
+ * @param[in] name       the name of the key
+ * @param[in] properties the properties object of the key (not used here)
+ * @param[in] file_names the file names used by this key
+ * @param[in] private    private data: struct reencipher_info
+ *
+ * @returns 0 for success, or a negative errno value in case of an error
+ */
+static int _keystore_process_kms_key_set_prop(struct keystore *keystore,
+					      const char *name,
+					      struct properties *properties,
+					      struct key_filenames *file_names,
+					      void *private)
+{
+	struct kms_set_prop *set_prop = private;
+	int rc;
+
+	pr_verbose(keystore, "Setting property for KMS-bound key '%s'", name);
+
+	if (set_prop->prop_value != NULL) {
+		rc = properties_set(properties, set_prop->prop_name,
+				    set_prop->prop_value);
+
+		if (rc != 0) {
+			pr_verbose(keystore, "Invalid characters in property: "
+				   "%s: %s", set_prop->prop_name,
+				   set_prop->prop_value);
+			goto out;
+		}
+
+	} else {
+		rc = properties_remove(properties, set_prop->prop_name);
+		if (rc != 0 && rc != -ENOENT) {
+			pr_verbose(keystore, "Failed to remove  property: "
+				   "%s: %s", set_prop->prop_name,
+				   strerror(-rc));
+			goto out;
+		}
+	}
+
+	rc = properties_save(properties, file_names->info_filename, 1);
+	if (rc != 0) {
+		pr_verbose(keystore,
+			   "Key info file '%s' could not be written: %s",
+			   file_names->info_filename, strerror(-rc));
+		goto out;
+	}
+
+	set_prop->num_keys++;
+
+out:
+	return rc;
+}
+
+/**
+ * Iterates over all keys stored in the keystore. For every key that is bound
+ * to a KMS plugin the specified property is set to the specified value.
+ * If value is NULL, then the property is removed from the key.
+ *
+ * @param[in] keystore   the keystore
+ * @param[in] key_type   the key type. NULL means no key type filter.
+ * @param[in] prop_name  the name of the property to set
+ * @param[in] prop_value the value of the property to set or NULL if the proerty
+ *                       is to be removed.
+ *
+ * @returns 0 for success, or a negative errno value in case of an error
+ */
+int keystore_kms_keys_set_property(struct keystore *keystore,
+				   const char *key_type,
+				   const char *prop_name,
+				   const char *prop_value)
+{
+	struct kms_set_prop set_prop;
+	int rc;
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+	util_assert(prop_name != NULL, "Internal error: prop_name is NULL");
+
+	set_prop.prop_name = prop_name;
+	set_prop.prop_value = prop_value;
+	set_prop.num_keys = 0;
+
+	rc = _keystore_process_filtered(keystore, NULL, NULL, NULL, NULL,
+					key_type, false, true,
+					_keystore_process_kms_key_set_prop,
+					&set_prop);
+	if (rc != 0)
+		pr_verbose(keystore, "Failed to set properties of kms keys: %s",
+			   strerror(-rc));
+	else
+		pr_verbose(keystore, "Successfully set properties of %lu kms "
+			   "keys", set_prop.num_keys);
+
+	return rc;
+}
+
+static const char * const kms_props[] = {
+	PROP_NAME_KMS,
+	PROP_NAME_KMS_KEY_ID,
+	PROP_NAME_KMS_KEY_LABEL,
+	PROP_NAME_KMS_XTS_KEY1_ID,
+	PROP_NAME_KMS_XTS_KEY1_LABEL,
+	PROP_NAME_KMS_XTS_KEY2_ID,
+	PROP_NAME_KMS_XTS_KEY2_LABEL,
+	NULL,
+};
+
+/**
+ * Unbinds the key by removing the KMS specific properties
+ *
+ * @param[in] keystore   the keystore
+ * @param[in] properties the properties object of the key
+ *
+ * @returns 0 for success, or a negative errno value in case of an error
+ */
+static int _keystore_kms_key_unbind(struct keystore *keystore,
+				    struct properties *properties)
+{
+	int i, rc;
+
+	for (i = 0; kms_props[i] != NULL; i++) {
+		rc = properties_remove(properties, kms_props[i]);
+		if (rc != 0 && rc != -ENOENT) {
+			pr_verbose(keystore, "Failed to remove property: "
+				   "%s: %s", kms_props[i], strerror(-rc));
+			return rc;
+		}
+	}
+
+	return 0;
+}
+
+/**
+ * Processing function for unbinding of KMS-bound keys
+ *
+ * @param[in] keystore   the keystore
+ * @param[in] name       the name of the key
+ * @param[in] properties the properties object of the key
+ * @param[in] file_names the file names used by this key
+ * @param[in] private    private data: struct reencipher_info
+ *
+ * @returns 0 for success, or a negative errno value in case of an error
+ */
+static int _keystore_process_kms_key_unbind(struct keystore *keystore,
+					    const char *name,
+					    struct properties *properties,
+					    struct key_filenames *file_names,
+					    void *private)
+{
+	unsigned long *num_keys = private;
+	int rc;
+
+	pr_verbose(keystore, "Unbinding KMS-bound key '%s'", name);
+
+	rc = _keystore_kms_key_unbind(keystore, properties);
+	if (rc != 0)
+		goto out;
+
+	rc = properties_save(properties, file_names->info_filename, 1);
+	if (rc != 0) {
+		pr_verbose(keystore,
+			   "Key info file '%s' could not be written: %s",
+			   file_names->info_filename, strerror(-rc));
+		goto out;
+	}
+
+	(*num_keys)++;
+
+out:
+	return rc;
+}
+
+/**
+ * Iterates over all keys stored in the keystore. For every key that is bound
+ * to a KMS plugin the KMS specific properties are deleted, and thus these keys
+ * are unbound from the KMS plugin.
+ *
+ * @param[in] keystore   the keystore
+ *
+ * @returns 0 for success, or a negative errno value in case of an error
+ */
+int keystore_kms_keys_unbind(struct keystore *keystore)
+{
+	unsigned long num_keys = 0;
+	int rc;
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+
+	rc = _keystore_process_filtered(keystore, NULL, NULL, NULL, NULL,
+					NULL, false, true,
+					_keystore_process_kms_key_unbind,
+					&num_keys);
+
+	if (rc != 0)
+		pr_verbose(keystore, "Failed to unbinds kms keys: %s",
+			   strerror(-rc));
+	else
+		pr_verbose(keystore, "Successfully unbound of %lu kms keys",
+			   num_keys);
+
+	return rc;
+}
+
+struct kms_msg_for_key {
+	const char *msg;
+	unsigned long num_keys;
+};
+
+/**
+ * Processing function for issuing a message for KMS-bound keys
+ *
+ * @param[in] keystore   the keystore
+ * @param[in] name       the name of the key
+ * @param[in] properties the properties object of the key (not used here)
+ * @param[in] file_names the file names used by this key
+ * @param[in] private    private data: struct reencipher_info
+ *
+ * @returns 0 for success, or a negative errno value in case of an error
+ */
+static int _keystore_process_kms_msg_for_key(struct keystore *UNUSED(keystore),
+					     const char *name,
+					     struct properties *
+							UNUSED(properties),
+					     struct key_filenames *
+							UNUSED(file_names),
+					     void *private)
+{
+	struct kms_msg_for_key *msg_for_key = private;
+
+	if (msg_for_key->num_keys == 0)
+		util_print_indented(msg_for_key->msg, 0);
+
+	printf("  %s\n", name);
+	msg_for_key->num_keys++;
+
+	return 0;
+}
+
+/**
+ * Iterates over all keys stored in the keystore. Every key that is bound
+ * to a KMS plugin and has the specified key type is listed together with the
+ * message. If no KMS-bound keys with the specified key type exist in the
+ * keystore, then no message is printed, and -ENOENT is returned.
+ *
+ * @param[in] keystore   the keystore
+ * @param[in] key_type   the key type. NULL means no key type filter.
+ * @param[in] msg        the message to print
+ *
+ * @returns 0 for success, or a negative errno value in case of an error.
+ * -ENOENT if no key macthed
+ */
+int keystore_msg_for_kms_key(struct keystore *keystore, const char *key_type,
+			     const char *msg)
+{
+	struct kms_msg_for_key msg_for_key;
+	int rc;
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+	util_assert(msg != NULL, "Internal error: msg is NULL");
+
+	msg_for_key.msg = msg;
+	msg_for_key.num_keys = 0;
+
+	rc = _keystore_process_filtered(keystore, NULL, NULL, NULL, NULL,
+					key_type, false, true,
+					_keystore_process_kms_msg_for_key,
+					&msg_for_key);
+	if (rc != 0)
+		return rc;
+	return msg_for_key.num_keys == 0 ? -ENOENT : 0;
+}
+
+struct kms_import {
+	struct keystore *keystore;
+	bool batch_mode;
+	bool novolcheck;
+	unsigned long num_imported;
+	unsigned long num_skipped;
+	unsigned long num_failed;
+};
+
+/**
+ * Callback used with the keystore_import_kms_keys() function. Called for each
+ * key.
+ *
+ * @param[in] key1_id           the key-ID of the key (1st key of an XTS key)
+ * @param[in] key1_label        the label of the key (1st key of an XTS key)
+ * @param[in] key2_id           the key-ID of the 2nd XTS key, NULL if not XTS
+ * @param[in] key2_label        the label of the 2nd XTS key, NULL if not XTS
+ * @param[in] xts               if true, this is an XTS key pair
+ * @param[in] name              the zkey name of the key
+ * @param[in] key_type          the type of the key (CCA-AESDATA, etc)
+ * @param[in] key_bits          the key size in bits
+ * @param[in] description       the description of the key (can be NULL)
+ * @param[in] cipher            the cipher of the key (can be NULL)
+ * @param[in] iv_mode           the IV-mode of the key (can be NULL)
+ * @param[in] volumes           the associated volumes of the key (can be NULL)
+ * @param[in] volume_type       the volume type of the volume (can be NULL)
+ * @param[in] sector_size       the sector size of the volume (0 means default)
+ * @param[in] addl_info_argz    an argz string containing additional KMS plugin
+ *                              specific infos to be displayed, or NULL if none.
+ * @param[in] addl_info_len     length of the argz string in addl_info_argz
+ * @param[in] private_data      the private data pointer
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _keystore_process_kms_import(const char *key1_id,
+					const char *key1_label,
+					const char *key2_id,
+					const char *key2_label,
+					bool xts, const char *name,
+					const char *UNUSED(key_type),
+					size_t UNUSED(key_bits),
+					const char *description,
+					const char *UNUSED(cipher),
+					const char *UNUSED(iv_mode),
+					const char *volumes,
+					const char *volume_type,
+					size_t sector_size,
+					const char *UNUSED(addl_info_argz),
+					size_t UNUSED(addl_info_len),
+					void *private_data)
+{
+	struct key_filenames file_names = { NULL, NULL, NULL };
+	struct kms_import *import_data = private_data;
+	u8 secure_key[2 * MAX_SECURE_KEY_SIZE];
+	struct properties *key_props = NULL;
+	char vp[VERIFICATION_PATTERN_LEN];
+	const char *key_name = name;
+	struct keystore *keystore;
+	size_t alt_name_len = 0;
+	size_t secure_key_size;
+	bool fatal_err = false;
+	char *alt_name = NULL;
+	const char *key_type;
+	char *apqns = NULL;
+	int rc;
+
+	keystore = import_data->keystore;
+
+	rc = _keystore_get_key_filenames(keystore, key_name, &file_names);
+	if (rc != 0)
+		goto out;
+
+check_duplicate_key:
+	rc = _keystore_ensure_keyfiles_not_exist(&file_names, key_name);
+	if (rc == -EEXIST) {
+		if (import_data->batch_mode) {
+			rc = 1;
+			goto out;
+		}
+
+		printf("%s: Do you want to enter an alternate name [y/N]? ",
+		       program_invocation_short_name);
+		if (!prompt_for_yes(keystore->verbose)) {
+			rc = 1;
+			goto out;
+		}
+
+prompt_alt_name:
+		printf("%s: Alternate name: ", program_invocation_short_name);
+		rc = getline(&alt_name, &alt_name_len, stdin);
+		if (rc <= 1) {
+			rc = 1;
+			goto out;
+		}
+
+		if (alt_name[strlen(alt_name) - 1] == '\n')
+			alt_name[strlen(alt_name) - 1] = '\0';
+
+		key_name = alt_name;
+		_keystore_free_key_filenames(&file_names);
+		rc = _keystore_get_key_filenames(keystore, key_name,
+						 &file_names);
+		if (rc != 0)
+			goto prompt_alt_name;
+
+		goto check_duplicate_key;
+	} else if (rc != 0) {
+		goto out;
+	}
+
+	secure_key_size = sizeof(secure_key);
+	rc = import_kms_key(keystore->kms_info, key1_id, key2_id, xts, key_name,
+			    secure_key, &secure_key_size, keystore->verbose);
+	if (rc != 0) {
+		warnx("KMS plugin '%s' failed to import key '%s': %s",
+		      keystore->kms_info->plugin_name, key_name, strerror(-rc));
+		print_last_kms_error(keystore->kms_info);
+		if (rc == -ENOTSUP)
+			fatal_err = true;
+		goto out;
+	}
+
+	key_type = get_key_type(secure_key, secure_key_size);
+	if (key_type == NULL) {
+		warnx("Key '%s' is not a valid secure key", key_name);
+		rc = -EINVAL;
+		goto out;
+	}
+
+	rc = get_kms_apqns_for_key_type(keystore->kms_info, key_type, true,
+					&apqns, keystore->verbose);
+	if (rc != 0) {
+		if (rc == -ENOTSUP)
+			warnx("Key-type not supported by the KMS plugin '%s'",
+			      keystore->kms_info->plugin_name);
+		goto out;
+	}
+
+	pr_verbose(keystore, "APQNs for keytype %s: '%s'", key_type, apqns);
+
+	rc = _keystore_create_info_props(keystore, key_name, description,
+					 volumes, apqns, false,
+					 import_data->novolcheck,
+					 sector_size, volume_type, key_type,
+					 keystore->kms_info->plugin_name,
+					 &key_props);
+	if (rc != 0)
+		goto out;
+
+	rc = properties_set(key_props, xts ? PROP_NAME_KMS_XTS_KEY1_ID :
+			    PROP_NAME_KMS_KEY_ID, key1_id);
+	if (rc != 0) {
+		pr_verbose(keystore, "Failed to set key id of key #1: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	rc = properties_set(key_props, xts ? PROP_NAME_KMS_XTS_KEY1_LABEL :
+			    PROP_NAME_KMS_KEY_LABEL, key1_label);
+	if (rc != 0) {
+		pr_verbose(keystore, "Failed to set key label of key #1: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	if (xts) {
+		rc = properties_set(key_props, PROP_NAME_KMS_XTS_KEY2_ID,
+				    key2_id);
+		if (rc != 0) {
+			pr_verbose(keystore, "Failed to set key id of key #2: "
+				   "%s", strerror(-rc));
+			goto out;
+		}
+
+		rc = properties_set(key_props, PROP_NAME_KMS_XTS_KEY2_LABEL,
+				    key2_label);
+		if (rc != 0) {
+			pr_verbose(keystore, "Failed to set key label of key "
+				   "#2: %s", strerror(-rc));
+			goto out;
+		}
+	}
+
+	rc = write_secure_key(file_names.skey_filename, secure_key,
+			      secure_key_size, keystore->verbose);
+	if (rc != 0)
+		goto out;
+
+	rc = _keystore_set_file_permission(keystore, file_names.skey_filename);
+	if (rc != 0)
+		goto out_remove;
+
+	rc = generate_key_verification_pattern(secure_key, secure_key_size,
+					       vp, sizeof(vp),
+					       keystore->verbose);
+	if (rc != 0) {
+		warnx("Failed to generate the key verification pattern: %s",
+		      strerror(-rc));
+		warnx("Make sure that kernel module 'paes_s390' is loaded and "
+		      "that the 'paes' cipher is available");
+		fatal_err = true;
+		goto out_remove;
+	}
+
+	rc = properties_set(key_props, PROP_NAME_KEY_VP, vp);
+	if (rc != 0) {
+		pr_verbose(keystore, "Failed to set verification pattern of "
+			   "key: %s", strerror(-rc));
+
+		goto out_remove;
+	}
+
+	rc = properties_save(key_props, file_names.info_filename, 1);
+	if (rc != 0) {
+		pr_verbose(keystore,
+			   "Key info file '%s' could not be written: %s",
+			   file_names.info_filename, strerror(-rc));
+		goto out;
+	}
+
+	rc = _keystore_set_file_permission(keystore, file_names.info_filename);
+	if (rc != 0) {
+		remove(file_names.info_filename);
+		goto out_remove;
+	}
+
+out_remove:
+	if (rc != 0) {
+		remove(file_names.skey_filename);
+		remove(file_names.info_filename);
+	}
+
+out:
+	if (rc == 0) {
+		printf("Successfully imported key '%s'\n", key_name);
+		import_data->num_imported++;
+	} else if (rc < 0) {
+		warnx("Failed to import key '%s': %s", key_name, strerror(-rc));
+		import_data->num_failed++;
+	} else {
+		warnx("Skipping key '%s'", key_name);
+		import_data->num_skipped++;
+	}
+
+	_keystore_free_key_filenames(&file_names);
+	if (alt_name != NULL)
+		free(alt_name);
+	if (apqns != NULL)
+		free(apqns);
+	if (key_props != NULL)
+		properties_free(key_props);
+
+	return fatal_err ? rc : 0;
+}
+
+/**
+ * Imports secure keys from the KMS and adds it to the key store
+ *
+ * @param[in] keystore        the key store
+ * @param[in] label_filter    the KMS label filter. Can contain wild cards.
+ *                            NULL means no name filter.
+ * @param[in] name_filter     the name filter. Can contain wild cards.
+ *                            NULL means no name filter.
+ * @param[in] volume_filter   the volume filter. Can contain wild cards, and
+ *                            mutliple volume filters separated by commas.
+ *                            If the filter does not contain the ':dm-name'
+ *                            part, then the volumes are matched without the
+ *                            dm-name part. If the filter contains the
+ *                            ':dm-name' part, then the filter is matched
+ *                            including the dm-name part.
+ *                            NULL means no volume filter.
+ * @param[in] volume_type     If not NULL, specifies the volume type.
+ * @param[in] kms_options     an array of KMS options specified, or NULL if no
+ *                            KMS options have been specified
+ * @param[in] num_kms_options the number of options in above array
+ * @param[in] batch_mode      if true, suppress alternate name prompts if a key
+ *                            with an already existing name is to be imported.
+ * @param[in] novolcheck      if true, do not check the associated volumes for
+ *                            existence and duplicate use
+ *
+ * @returns 0 for success or a negative errno in case of an error
+ */
+int keystore_import_kms_keys(struct keystore *keystore,
+			     const char *label_filter,
+			     const char *name_filter,
+			     const char *volume_filter,
+			     const char *volume_type,
+			     struct kms_option *kms_options,
+			     size_t num_kms_options,
+			     bool batch_mode, bool novolcheck)
+{
+	struct kms_import import_data = { 0 };
+	int rc;
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+
+	if (keystore->kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (volume_type != NULL &&
+	    !_keystore_valid_volume_type(volume_type)) {
+		warnx("Invalid volume-type specified");
+		return -EINVAL;
+	}
+
+	import_data.keystore = keystore;
+	import_data.batch_mode = batch_mode;
+	import_data.novolcheck = novolcheck;
+	import_data.num_imported = 0;
+	import_data.num_skipped = 0;
+	import_data.num_failed = 0;
+
+	rc = process_kms_keys(keystore->kms_info, label_filter, name_filter,
+			       volume_filter, volume_type,
+			       kms_options, num_kms_options,
+			       _keystore_process_kms_import, &import_data,
+			       keystore->verbose);
+	if (rc != 0) {
+		pr_verbose(keystore, "Failed to import kms keys: %s",
+			   strerror(-rc));
+	} else {
+		printf("%lu keys imported, %lu keys skipped, %lu keys "
+		       "failed to import\n",
+		       import_data.num_imported, import_data.num_skipped,
+		       import_data.num_failed);
+		if (import_data.num_failed > 0)
+			rc = -EIO;
+	}
+
+	return rc;
+}
+
+struct kms_refresh {
+	bool refresh_properties;
+	bool novolcheck;
+	unsigned long num_refreshed;
+	unsigned long num_failed;
+};
+
+/**
+ * Processing function for the key refresh function.
+ *
+ * @param[in] keystore   the keystore
+ * @param[in] name       the name of the key
+ * @param[in] properties the properties object of the key
+ * @param[in] file_names the file names used by this key
+ * @param[in] private    private data: struct reencipher_info
+ *
+ * @returns 0 if the display is successful, a negative errno value otherwise
+ */
+static int _keystore_refresh_kms_key(struct keystore *keystore,
+				     const char *name,
+				     struct properties *properties,
+				     struct key_filenames *file_names,
+				     void *private)
+{
+	struct volume_check vol_check = { .keystore = keystore, .name = name,
+					  .set = 1, .nocheck = 0 };
+	char *description = NULL, *cipher = NULL, *iv_mode = NULL;
+	struct kms_refresh *refresh_data = private;
+	char *volumes = NULL, *volume_type = NULL;
+	ssize_t sector_size = -1;
+	bool fatal_err = false;
+	char sect_size[30];
+	char *msg;
+	int rc;
+
+	vol_check.nocheck = refresh_data->novolcheck;
+
+	rc = refresh_kms_key(keystore->kms_info, properties,
+			     &description, &cipher, &iv_mode, &volumes,
+			     &volume_type, &sector_size,
+			     file_names->skey_filename, keystore->verbose);
+	if (rc != 0) {
+		warnx("KMS plugin '%s' failed to refresh key '%s': %s",
+		      keystore->kms_info->plugin_name, name, strerror(-rc));
+		print_last_kms_error(keystore->kms_info);
+		if (rc == -ENOTSUP)
+			fatal_err = true;
+		goto out;
+	}
+
+	if (!refresh_data->refresh_properties)
+		goto save_props;
+
+	if (description != NULL) {
+		rc = properties_set(properties, PROP_NAME_DESCRIPTION,
+				    description);
+		if (rc != 0) {
+			warnx("Invalid characters in description");
+			goto out;
+		}
+	}
+
+	if (volumes != NULL) {
+		rc = _keystore_change_association(properties, PROP_NAME_VOLUMES,
+						  volumes, "volume",
+						  _keystore_volume_check,
+						  &vol_check);
+		if (rc != 0)
+			goto out;
+	}
+
+	if (sector_size >= 0) {
+		if (!_keystore_valid_sector_size(sector_size)) {
+			warnx("Invalid sector-size specified");
+			rc = -EINVAL;
+			goto out;
+		}
+
+		sprintf(sect_size, "%lu", sector_size);
+		rc = properties_set(properties, PROP_NAME_SECTOR_SIZE,
+				    sect_size);
+		if (rc != 0) {
+			warnx("Invalid characters in sector-size");
+			goto out;
+		}
+	}
+
+	if (volume_type != NULL) {
+		if (!_keystore_valid_volume_type(volume_type)) {
+			warnx("Invalid volume-type specified");
+			rc = -EINVAL;
+			goto out;
+		}
+
+		rc = properties_set2(properties, PROP_NAME_VOLUME_TYPE,
+				     volume_type, true);
+		if (rc != 0) {
+			warnx("Invalid characters in volume-type");
+			goto out;
+		}
+	}
+
+save_props:
+	rc = _keystore_set_timestamp_property(properties,
+					      PROP_NAME_CHANGE_TIME);
+	if (rc != 0) {
+		warnx("Failed to set the update timestamp property");
+		goto out;
+	}
+
+	rc = properties_save(properties, file_names->info_filename, 1);
+	if (rc != 0) {
+		pr_verbose(keystore,
+			   "Key info file '%s' could not be written: %s",
+			   file_names->info_filename, strerror(-rc));
+		goto out;
+	}
+
+out:
+	if (rc == 0) {
+		printf("Successfully refreshed key '%s'\n", name);
+		refresh_data->num_refreshed++;
+
+		util_asprintf(&msg, "The following LUKS2 volumes are "
+			      "encrypted with key '%s'. To update the secure "
+			      "AES volume key in the LUKS2 header, run command "
+			      "'zkey-cryptsetup setkey <device> "
+			      "--master-key-file %s':", name,
+			      file_names->skey_filename);
+		_keystore_msg_for_volumes(msg, properties, VOLUME_TYPE_LUKS2);
+		free(msg);
+	} else {
+		warnx("Failed to refresh key '%s': %s", name, strerror(-rc));
+		refresh_data->num_failed++;
+	}
+
+	if (description != NULL)
+		free(description);
+	if (cipher != NULL)
+		free(cipher);
+	if (iv_mode != NULL)
+		free(iv_mode);
+	if (volumes != NULL)
+		free(volumes);
+	if (volume_type != NULL)
+		free(volume_type);
+
+	return fatal_err ? rc : 0;
+}
+
+/**
+ * Refreshes secure KMS-bound secure key and updates them from the KMS
+ *
+ * @param[in] keystore        the key store
+ * @param[in] name_filter     the name filter. Can contain wild cards.
+ *                            NULL means no name filter.
+ * @param[in] volume_filter   the volume filter. Can contain wild cards, and
+ *                            mutliple volume filters separated by commas.
+ *                            If the filter does not contain the ':dm-name'
+ *                            part, then the volumes are matched without the
+ *                            dm-name part. If the filter contains the
+ *                            ':dm-name' part, then the filter is matched
+ *                            including the dm-name part.
+ *                            NULL means no volume filter.
+ * @param[in] volume_type     If not NULL, specifies the volume type.
+ * @param[in] key_type       The key type. NULL means no key type filter.
+ * @param[in] refresh_properties   if true, also refresh the key's properties
+ * @param[in] novolcheck      if true, do not check the associated volumes for
+ *                            existence and duplicate use
+ *
+ * @returns 0 for success or a negative errno in case of an error
+ */
+int keystore_refresh_kms_keys(struct keystore *keystore,
+			     const char *name_filter,
+			     const char *volume_filter,
+			     const char *volume_type, const char *key_type,
+			     bool refresh_properties, bool novolcheck)
+{
+	struct kms_refresh refresh_data = { 0 };
+	int rc;
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+
+	if (keystore->kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (volume_type != NULL &&
+	    !_keystore_valid_volume_type(volume_type)) {
+		warnx("Invalid volume-type specified");
+		return -EINVAL;
+	}
+
+	if (key_type != NULL &&
+	    !_keystore_valid_key_type(key_type)) {
+		warnx("Invalid key-type specified");
+		return -EINVAL;
+	}
+
+	refresh_data.refresh_properties = refresh_properties;
+	refresh_data.novolcheck = novolcheck;
+	refresh_data.num_refreshed = 0;
+	refresh_data.num_failed = 0;
+
+	rc = _keystore_process_filtered(keystore, name_filter, volume_filter,
+					NULL, volume_type, key_type, false,
+					true, _keystore_refresh_kms_key,
+					&refresh_data);
+
+	if (rc != 0) {
+		pr_verbose(keystore, "Failed to refresh kms keys: %s",
+			   strerror(-rc));
+	} else {
+		printf("%lu keys refreshed, %lu keys failed to refresh\n",
+		       refresh_data.num_refreshed, refresh_data.num_failed);
+		if (refresh_data.num_failed > 0)
+			rc = -EIO;
+	}
+
+	return rc;
+}
+
 /**
  * Frees a keystore object
  *
diff -pruN 2.14.0-2/zkey/keystore.h 2.15.1-0ubuntu2/zkey/keystore.h
--- 2.14.0-2/zkey/keystore.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/keystore.h	2020-10-28 14:31:59.000000000 +0000
@@ -3,7 +3,7 @@
  *
  * Keystore handling functions
  *
- * Copyright IBM Corp. 2018
+ * Copyright IBM Corp. 2018, 2020
  *
  * s390-tools is free software; you can redistribute it and/or modify
  * it under the terms of the MIT license. See LICENSE for details.
@@ -15,6 +15,7 @@
 #include <stdbool.h>
 
 #include "pkey.h"
+#include "kms.h"
 
 struct keystore {
 	bool verbose;
@@ -22,9 +23,31 @@ struct keystore {
 	int lock_fd;
 	mode_t mode;
 	gid_t owner;
+	struct kms_info *kms_info;
 };
 
-struct keystore *keystore_new(const char *directory, bool verbose);
+#define PROP_NAME_KEY_TYPE		"key-type"
+#define PROP_NAME_CIPHER		"cipher"
+#define PROP_NAME_IV_MODE		"iv-mode"
+#define PROP_NAME_DESCRIPTION		"description"
+#define PROP_NAME_VOLUMES		"volumes"
+#define PROP_NAME_APQNS			"apqns"
+#define PROP_NAME_SECTOR_SIZE		"sector-size"
+#define PROP_NAME_CREATION_TIME		"creation-time"
+#define PROP_NAME_CHANGE_TIME		"update-time"
+#define PROP_NAME_REENC_TIME		"reencipher-time"
+#define PROP_NAME_KEY_VP		"verification-pattern"
+#define PROP_NAME_VOLUME_TYPE		"volume-type"
+#define PROP_NAME_KMS			"kms"
+#define PROP_NAME_KMS_KEY_ID		"kms-key-id"
+#define PROP_NAME_KMS_KEY_LABEL		"kms-key-label"
+#define PROP_NAME_KMS_XTS_KEY1_ID	"kms-xts-key1-id"
+#define PROP_NAME_KMS_XTS_KEY1_LABEL	"kms-xts-key1-label"
+#define PROP_NAME_KMS_XTS_KEY2_ID	"kms-xts-key2-id"
+#define PROP_NAME_KMS_XTS_KEY2_LABEL	"kms-xts-key2-label"
+
+struct keystore *keystore_new(const char *directory,
+			      struct kms_info *kms_info, bool verbose);
 
 int keystore_generate_key(struct keystore *keystore, const char *name,
 			  const char *description, const char *volumes,
@@ -33,6 +56,13 @@ int keystore_generate_key(struct keystor
 			  const char *clear_key_file, const char *volume_type,
 			  const char *key_type, int pkey_fd);
 
+int keystore_generate_key_kms(struct keystore *keystore, const char *name,
+			      const char *description, const char *volumes,
+			      size_t sector_size, size_t keybits, bool xts,
+			      const char *volume_type, const char *key_type,
+			      struct kms_option *kms_options,
+			      size_t num_kms_options);
+
 int keystore_import_key(struct keystore *keystore, const char *name,
 			const char *description, const char *volumes,
 			const char *apqns, bool noapqncheck, size_t sector_size,
@@ -58,17 +88,19 @@ int keystore_reencipher_key(struct keyst
 			    struct ext_lib *lib);
 
 int keystore_copy_key(struct keystore *keystore, const char *name,
-		      const char *newname, const char *volumes);
+		      const char *newname, const char *volumes, bool local);
 
 int keystore_export_key(struct keystore *keystore, const char *name,
 			const char *export_file);
 
 int keystore_remove_key(struct keystore *keystore, const char *name,
-			bool quiet);
+			bool quiet, struct kms_option *kms_options,
+			size_t num_kms_options);
 
 int keystore_list_keys(struct keystore *keystore, const char *name_filter,
 		       const char *volume_filter, const char *apqn_filter,
-		       const char *volume_type, const char *key_type);
+		       const char *volume_type, const char *key_type,
+		       bool local, bool kms_bound);
 
 int keystore_cryptsetup(struct keystore *keystore, const char *volume_filter,
 			bool execute, const char *volume_type,
@@ -84,6 +116,31 @@ int keystore_convert_key(struct keystore
 			 const char *key_type, bool noapqncheck, bool quiet,
 			 int pkey_fd, struct ext_lib *lib);
 
+int keystore_kms_keys_set_property(struct keystore *keystore,
+				   const char *key_type,
+				   const char *prop_name,
+				   const char *prop_value);
+
+int keystore_kms_keys_unbind(struct keystore *keystore);
+
+int keystore_msg_for_kms_key(struct keystore *keystore, const char *key_type,
+			     const char *msg);
+
+int keystore_import_kms_keys(struct keystore *keystore,
+			     const char *label_filter,
+			     const char *name_filter,
+			     const char *volume_filter,
+			     const char *volume_type,
+			     struct kms_option *kms_options,
+			     size_t num_kms_options,
+			     bool batch_mode, bool novolcheck);
+
+int keystore_refresh_kms_keys(struct keystore *keystore,
+			      const char *name_filter,
+			      const char *volume_filter,
+			      const char *volume_type, const char *key_type,
+			      bool refres_properties, bool novolcheck);
+
 void keystore_free(struct keystore *keystore);
 
 
diff -pruN 2.14.0-2/zkey/kms.c 2.15.1-0ubuntu2/zkey/kms.c
--- 2.14.0-2/zkey/kms.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/kms.c	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,3324 @@
+/*
+ * zkey - Generate, re-encipher, and validate secure keys
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+
+#include <argz.h>
+#include <ctype.h>
+#include <dlfcn.h>
+#include <dirent.h>
+#include <err.h>
+#include <errno.h>
+#include <fnmatch.h>
+#include <regex.h>
+#include <stdbool.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <stdint.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <sys/utsname.h>
+#include <unistd.h>
+
+#include "lib/util_base.h"
+#include "lib/util_libc.h"
+#include "lib/util_rec.h"
+#include "lib/util_panic.h"
+#include "lib/util_prg.h"
+
+#include "kms.h"
+#include "utils.h"
+#include "pkey.h"
+
+#define ENVVAR_ZKEY_REPOSITORY		"ZKEY_REPOSITORY"
+#define DEFAULT_KEYSTORE		"/etc/zkey/repository"
+
+#define ENVVAR_ZKEY_KMS_PLUGINS		"ZKEY_KMS_PLUGINS"
+#define DEFAULT_KMS_PLUGINS		"/etc/zkey/kms-plugins.conf"
+#define KMS_PLUGIN_LOCATION		"/usr/lib64/zkey"
+
+#define KMS_CONFIG_FILE			"kms.conf"
+#define KMS_CONFIG_PROP_KMS		"kms"
+#define KMS_CONFIG_PROP_KMS_CONFIG	"config"
+#define KMS_CONFIG_PROP_APQNS		"apqns"
+#define KMS_CONFIG_PROP_CCA_APQNS	"ep11_apqns"
+#define KMS_CONFIG_PROP_EP11_APQNS	"cca_apqns"
+#define KMS_CONFIG_LOCAL		"local"
+
+#define KMS_KEY_PROP_NAME		"zkey-name"
+#define KMS_KEY_PROP_CIPHER		"cipher"
+#define KMS_KEY_PROP_IV_MODE		"iv-mode"
+#define KMS_KEY_PROP_DESCRIPTION	"description"
+#define KMS_KEY_PROP_VOLUMES		"volumes"
+#define KMS_KEY_PROP_VOLUME_TYPE	"volume-type"
+#define KMS_KEY_PROP_SECTOR_SIZE	"sector-size"
+#define KMS_KEY_PROP_XTS_KEY		"xts-key"
+#define KMS_KEY_PROP_XTS_KEY1_ID	"xts-key1-id"
+#define KMS_KEY_PROP_XTS_KEY2_ID	"xts-key2-id"
+#define KMS_KEY_PROP_XTS_KEY1_LABEL	"xts-key1-label"
+#define KMS_KEY_PROP_XTS_KEY2_LABEL	"xts-key2-label"
+
+#define KMS_REC_LABEL			"Key label"
+#define KMS_REC_NAME			"Name"
+#define KMS_REC_KEY_TYPE		"Key type"
+#define KMS_REC_KEY_SIZE		"Key size"
+#define KMS_REC_DESCRIPTION		"Description"
+#define KMS_REC_XTS			"XTS type key"
+#define KMS_REC_VOLUMES			"Volumes"
+#define KMS_REC_VOLUME_TYPE		"Volume type"
+#define KMS_REC_SECTOR_SIZE		"Sector size"
+#define KMS_REC_ADDL_INFOS		"Addl. infos"
+
+static const char * const key_types[] = {
+		KEY_TYPE_CCA_AESDATA,
+		KEY_TYPE_CCA_AESCIPHER,
+		KEY_TYPE_EP11_AES,
+		NULL
+};
+
+typedef const struct kms_functions *(*kms_get_functions_t)(void);
+
+#define pr_verbose(verbose, fmt...)	do {				\
+						if (verbose)		\
+							warnx(fmt);	\
+					} while (0)
+
+#define ARRAY_ADD(array, num_elemnts, element_size, new_element)	\
+	do {								\
+		(num_elemnts)++;					\
+		(array) = util_realloc((array),				\
+				(num_elemnts) * element_size);		\
+		memcpy(&(array)[(num_elemnts) - 1], new_element,	\
+		       element_size);					\
+	} while (0)
+
+#define ARRAY_REMOVE(array, num_elemnts, element_size, index)		\
+	do {								\
+		if ((index) < (num_elemnts) - 1)			\
+			memmove(&(array)[(index)],			\
+				&(array)[(index) + 1],			\
+				((num_elemnts) - (index) - 1) *		\
+							element_size);	\
+		(num_elemnts)--;					\
+		if ((num_elemnts) > 0) {				\
+			(array) = util_realloc((array),			\
+					(num_elemnts) * element_size);	\
+		}							\
+	} while (0)
+
+
+/**
+ * Opens kms-plugins.conf. Looks for the file in /etc/zkey/, or if environment
+ * variable ZKEY_KMS_PLUGINS is set then it uses the file name and path
+ * specified there.
+ */
+static FILE *open_kms_plugins_file(bool verbose)
+{
+	char *conf;
+	FILE *fp;
+
+	conf = getenv(ENVVAR_ZKEY_KMS_PLUGINS);
+	if (conf == NULL)
+		conf = DEFAULT_KMS_PLUGINS;
+
+	pr_verbose(verbose, "Opening KMS plugins config file '%s'", conf);
+	fp = fopen(conf, "r");
+	if (fp == NULL) {
+		warnx("File '%s': %s", conf, strerror(errno));
+		return NULL;
+	}
+
+	return fp;
+}
+
+/**
+ * Lists the KMS plugins defined in kms-plugins.conf
+ *
+ * @param[in] verbose    if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int list_kms_plugins(bool verbose)
+{
+	struct util_rec *rec;
+	char line[4096];
+	int rc = 0;
+	size_t len;
+	FILE *fp;
+	char *ch;
+
+	fp = open_kms_plugins_file(verbose);
+	if (fp == NULL)
+		return -EIO;
+
+	rec = util_rec_new_wide("-");
+	util_rec_def(rec, "PLUGIN", UTIL_REC_ALIGN_LEFT, 25, "KMS-Plugin");
+	util_rec_def(rec, "LIB", UTIL_REC_ALIGN_LEFT, 25, "Shared library");
+	util_rec_print_hdr(rec);
+
+	while (fgets(line, sizeof(line), fp) != NULL) {
+		len = strlen(line);
+		if (len < 1)
+			continue;
+		if (line[0] == '#')
+			continue;
+		if (line[len - 1] == '\n')
+			line[len - 1] = '\0';
+		ch = strchr(line, '=');
+		if (ch == NULL) {
+			rc = -EPERM;
+			warnx("Syntax error in kms-plugins.conf. Line: '%s'",
+			      line);
+			goto out;
+		}
+
+		*ch = '\0';
+		ch++;
+
+		util_rec_set(rec, "PLUGIN", line);
+		util_rec_set(rec, "LIB", ch);
+		util_rec_print(rec);
+	}
+
+out:
+	util_rec_free(rec);
+	fclose(fp);
+
+	return rc;
+}
+
+/**
+ * Loads a KMS plugin by its plugin name. Looks up the shared library in
+ * kms-plugins.conf for the specified plugin name, and loads the shared library
+ * via dlopen
+ *
+ * @param[in] plugin          the plugin name (as in kms-plugins.conf)
+ * @param[out] kms_functions  the plugin functions obtain from the plugin
+ * @param[out] plugin_lib     the library handle (free with dlclose)
+ * @param[out] plugin_name    the full name of the plugin loaded
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int load_kms_plugin(const char *plugin,
+			   const struct kms_functions **kms_functions,
+			   void **plugin_lib, char **plugin_name, bool verbose)
+{
+	kms_get_functions_t _kms_get_functions;
+	char load_so_name[PATH_MAX];
+	char *so_name = NULL;
+	FILE *fp = NULL;
+	char line[4096];
+	int rc = 0;
+	size_t len;
+	char *ch;
+
+	util_assert(plugin != NULL, "Internal error: plugin is NULL");
+	util_assert(kms_functions != NULL,
+		    "Internal error: kms_functions is NULL");
+	util_assert(plugin_lib != NULL, "Internal error: plugin_lib is NULL");
+	util_assert(plugin_name != NULL, "Internal error: plugin_name is NULL");
+
+	fp = open_kms_plugins_file(verbose);
+	if (fp == NULL)
+		return -EIO;
+
+	while (fgets(line, sizeof(line), fp) != NULL) {
+		len = strlen(line);
+		if (len < 1)
+			continue;
+		if (line[0] == '#')
+			continue;
+		if (line[len - 1] == '\n')
+			line[len - 1] = '\0';
+		ch = strchr(line, '=');
+		if (ch == NULL) {
+			rc = -EPERM;
+			warnx("Syntax error in kms-plugins.conf. Line: '%s'",
+			      line);
+			goto out;
+		}
+
+		*ch = '\0';
+		ch++;
+
+		if (strcasecmp(line, plugin) == 0) {
+			so_name = ch;
+			*plugin_name = util_strdup(line);
+			break;
+		}
+	}
+
+	if (so_name == NULL) {
+		rc = -ENOENT;
+		warnx("KMS plugin '%s' not found.", plugin);
+		goto out;
+	}
+
+	/* Try to load via LD_LIBRARY_PATH first */
+	snprintf(load_so_name, sizeof(load_so_name), "%s", so_name);
+	pr_verbose(verbose, "Loading KMS plugin '%s': '%s'", *plugin_name,
+		   load_so_name);
+	*plugin_lib = dlopen(load_so_name, RTLD_GLOBAL | RTLD_NOW);
+	if (*plugin_lib == NULL) {
+		/* Try to load from default plugin location */
+		snprintf(load_so_name, sizeof(load_so_name), "%s/%s",
+			 KMS_PLUGIN_LOCATION, so_name);
+		pr_verbose(verbose, "Loading KMS plugin '%s': '%s'",
+			   *plugin_name, load_so_name);
+
+		*plugin_lib = dlopen(load_so_name, RTLD_GLOBAL | RTLD_NOW);
+		if (*plugin_lib == NULL) {
+			pr_verbose(verbose, "%s", dlerror());
+			warnx("Failed to load KMS plugin '%s': '%s'",
+			      *plugin_name, load_so_name);
+			rc = -ELIBACC;
+			goto out;
+		}
+	}
+
+	_kms_get_functions = (kms_get_functions_t)dlsym(*plugin_lib,
+							"kms_get_functions");
+	if (_kms_get_functions == NULL) {
+		pr_verbose(verbose, "%s", dlerror());
+		warnx("Failed to load KMS plugin '%s': '%s'", *plugin_name,
+		      load_so_name);
+		rc = -ELIBACC;
+		goto out;
+	}
+
+	*kms_functions = _kms_get_functions();
+	if (*kms_functions == NULL) {
+		pr_verbose(verbose, "kms_get_functions() reutned NULL");
+		warnx("Failed to load KMS plugin '%s': '%s'", *plugin_name,
+		      load_so_name);
+		rc = -ELIBACC;
+		goto out;
+	}
+
+	pr_verbose(verbose, "Successfully loaded KMS plugin '%s': '%s' (API "
+			    "version: %u)", *plugin_name, load_so_name,
+			    (*kms_functions)->api_version);
+
+out:
+	if (fp != NULL)
+		fclose(fp);
+	if (rc != 0 && *plugin_lib != NULL) {
+		dlclose(*plugin_lib);
+		*plugin_lib = NULL;
+	}
+	if (rc != 0 && *plugin_name != NULL) {
+		free(*plugin_name);
+		*plugin_name = NULL;
+	}
+
+	return rc;
+}
+
+/**
+ * Load the kms.conf properties file that is located in the repository
+ * directory. The returned properties object must be freed by the caller using
+ * properties_free() when no longer needed.
+ *
+ * @param[in]  repository     the repository directory
+ * @param[out] kms_props      On return: a new properties object with the
+ *                            properties read from kms.conf.
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int load_kms_properties(const char *repository,
+			       struct properties **kms_props, bool verbose)
+{
+	struct properties *props = NULL;
+	char *filename = NULL;
+	int rc;
+
+	util_assert(repository != NULL, "Internal error: repository is NULL");
+	util_assert(kms_props != NULL, "Internal error: kms_props is NULL");
+
+	util_asprintf(&filename, "%s/%s", repository, KMS_CONFIG_FILE);
+
+	pr_verbose(verbose, "Trying to load '%s'", filename);
+
+	props = properties_new();
+	rc = properties_load(props, filename, true);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to load '%s': %s", filename,
+			   strerror(-rc));
+		goto out;
+	}
+
+	*kms_props = props;
+
+out:
+	if (filename != NULL)
+		free(filename);
+	if (rc != 0)
+		properties_free(props);
+
+	return rc;
+}
+
+/**
+ * Save the kms.conf properties file that is located in the repository
+ * directory.
+ *
+ * @param[in] keystore        the keystore
+ * @param[in] kms_props       The properties object to save to kms.conf.
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _save_kms_properties(const struct keystore *keystore,
+				struct properties *kms_props, bool verbose)
+{
+	char *filename = NULL;
+	int rc;
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+	util_assert(kms_props != NULL, "Internal error: kms_props is NULL");
+
+	util_asprintf(&filename, "%s/%s", keystore->directory, KMS_CONFIG_FILE);
+
+	pr_verbose(verbose, "Saving '%s'", filename);
+
+	rc = properties_save(kms_props, filename, true);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to save '%s': %s", filename,
+			   strerror(-rc));
+		goto out;
+	}
+
+	if (chmod(filename, keystore->mode) != 0) {
+		rc = -errno;
+		warnx("chmod failed on file '%s': %s", filename, strerror(-rc));
+		return rc;
+	}
+
+	if (chown(filename, geteuid(), keystore->owner) != 0) {
+		rc = -errno;
+		warnx("chown failed on file '%s': %s", filename, strerror(-rc));
+		return rc;
+	}
+
+out:
+	if (filename != NULL)
+		free(filename);
+
+	return rc;
+}
+
+/**
+ * Check if a KMS plugin is configured for the current repository, and if so,
+ * load the KMS plugin.
+ *
+ * @param[out] kms_info       Filled with information about the KMS plugin and
+ *                            configuration. If no KMS plugin is configured,
+ *                            all fields are set to NULL.
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ * Note: It is not an error case of no plugin is configured.
+ */
+int check_for_kms_plugin(struct kms_info *kms_info, bool verbose)
+{
+	char *directory, *plugin = NULL;
+	int rc;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+
+	memset(kms_info, 0, sizeof(*kms_info));
+
+	directory = getenv(ENVVAR_ZKEY_REPOSITORY);
+	if (directory == NULL)
+		directory = DEFAULT_KEYSTORE;
+
+	rc = load_kms_properties(directory, &kms_info->props, verbose);
+	if (rc != 0) {
+		pr_verbose(verbose, "No KMS plugin is configured");
+		rc = 0;
+		goto out;
+	}
+
+	plugin = properties_get(kms_info->props, KMS_CONFIG_PROP_KMS);
+	if (plugin == NULL || strcasecmp(plugin, KMS_CONFIG_LOCAL) == 0) {
+		pr_verbose(verbose, "No KMS plugin is configured");
+		rc = 0;
+		goto out;
+	}
+
+	rc = load_kms_plugin(plugin, &kms_info->funcs, &kms_info->plugin_lib,
+			     &kms_info->plugin_name, verbose);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (plugin != NULL)
+		free(plugin);
+	if (rc != 0)
+		free_kms_plugin(kms_info);
+
+	return rc;
+}
+
+/**
+ * Initializes the KMS plugin.
+ *
+ * @param[in] kms_info        The KMS Plugin info
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int init_kms_plugin(struct kms_info *kms_info, bool verbose)
+{
+	char *config_path = NULL;
+	char **apqn_list = NULL;
+	char *apqns = NULL;
+	int i, rc = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+
+	config_path = properties_get(kms_info->props,
+				     KMS_CONFIG_PROP_KMS_CONFIG);
+	if (config_path == NULL) {
+		warnx("Incomplete KMS configuration");
+		rc = -EIO;
+		goto out;
+	}
+
+	if (kms_info->funcs->kms_initialize != NULL) {
+		kms_info->handle = kms_info->funcs->kms_initialize(config_path,
+								   verbose);
+		if (kms_info->handle == NULL) {
+			warnx("KMS plugin '%s' failed to initialize",
+			      kms_info->plugin_name);
+			rc = -EIO;
+			goto out;
+		}
+	}
+
+	apqns = properties_get(kms_info->props, KMS_CONFIG_PROP_APQNS);
+	if (apqns != NULL && strlen(apqns) > 0) {
+		apqn_list = str_list_split(apqns);
+		for (i = 0; apqn_list[i] != NULL; i++)
+			;
+		kms_info->num_apqns = i;
+		kms_info->apqns = util_malloc(i * sizeof(struct kms_apqn));
+		for (i = 0; apqn_list[i] != NULL; i++) {
+			if (sscanf(apqn_list[i], "%hx.%hx",
+				   &kms_info->apqns[i].card,
+				   &kms_info->apqns[i].domain) != 2) {
+				warnx("The APQN '%s' is not valid",
+				      apqn_list[i]);
+				rc = -EINVAL;
+				goto out;
+			}
+		}
+	}
+
+out:
+	if (config_path != NULL)
+		free(config_path);
+	if (apqns != NULL)
+		free(apqns);
+	if (apqn_list != NULL)
+		str_list_free_string_array(apqn_list);
+
+	return rc;
+}
+
+/**
+ * Terminates, free and close a KMS plugin
+ *
+ * @param[in] kms_info        The KMS Plugin info to free
+ */
+void free_kms_plugin(struct kms_info *kms_info)
+{
+	if (kms_info == NULL)
+		return;
+
+	if (kms_info->handle != NULL && kms_info->funcs != NULL &&
+	    kms_info->funcs->kms_terminate != NULL)
+		kms_info->funcs->kms_terminate(kms_info->handle);
+	kms_info->handle = NULL;
+
+	if (kms_info->props != NULL)
+		properties_free(kms_info->props);
+	kms_info->props = NULL;
+
+	if (kms_info->plugin_lib != NULL)
+		dlclose(kms_info->plugin_lib);
+	kms_info->plugin_lib = NULL;
+	kms_info->funcs = NULL;
+
+	if (kms_info->plugin_name != NULL)
+		free(kms_info->plugin_name);
+	kms_info->plugin_name = NULL;
+
+	if (kms_info->apqns != NULL)
+		free(kms_info->apqns);
+	kms_info->apqns = NULL;
+	kms_info->num_apqns = 0;
+}
+
+/**
+ * Prints the error message from the KMS plugin's last error
+ */
+void print_last_kms_error(const struct kms_info *kms_info)
+{
+	const char *msg;
+
+	if (kms_info == NULL || kms_info->funcs == NULL ||
+	    kms_info->funcs->kms_get_last_error == NULL ||
+	    kms_info->handle == NULL)
+		return;
+
+	msg = kms_info->funcs->kms_get_last_error(kms_info->handle);
+	if (msg == NULL)
+		return;
+
+	util_print_indented(msg, 0);
+}
+
+/**
+ * Binds the specified KMS plugin to the current repository.
+ * If the repository is already bound to a KMS plugin, then -EALREADY is
+ * returned.
+ *
+ * @param[in] keystore        the keystore to bind to the plugin
+ * @param[in] plugin          the name of the KMS plugin to bind
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int bind_kms_plugin(struct keystore *keystore, const char *plugin,
+		    bool verbose)
+{
+	char *directory, *config_dir = NULL;
+	const struct kms_functions *funcs;
+	struct properties *props = NULL;
+	char *plugin_name = NULL;
+	void *plugin_lib = NULL;
+	bool created = false;
+	int rc;
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+	util_assert(plugin != NULL, "Internal error: plugin is NULL");
+
+	rc = load_kms_properties(keystore->directory, &props, verbose);
+	if (rc == 0) {
+		plugin_name = properties_get(props, KMS_CONFIG_PROP_KMS);
+		if (plugin_name != NULL &&
+		     strcasecmp(plugin_name, KMS_CONFIG_LOCAL) != 0) {
+			warnx("The repository is already bound to KMS plugin "
+			     "'%s'", plugin_name);
+			rc = -EALREADY;
+			goto out;
+		}
+
+		properties_free(props);
+		props = NULL;
+	}
+
+	rc = load_kms_plugin(plugin, &funcs, &plugin_lib, &plugin_name,
+			     verbose);
+	if (rc != 0)
+		goto out;
+
+	directory = getenv(ENVVAR_ZKEY_REPOSITORY);
+	if (directory == NULL)
+		directory = DEFAULT_KEYSTORE;
+	util_asprintf(&config_dir, "%s/%s", directory, plugin_name);
+	pr_verbose(verbose, "Plugin config dir: '%s'", config_dir);
+
+	rc = mkdir(config_dir, keystore->mode);
+	if (rc != 0) {
+		rc = -errno;
+		warnx("Failed to create directory '%s': %s", config_dir,
+		      strerror(-rc));
+		goto out;
+	}
+	created = true;
+
+	if (chmod(config_dir, keystore->mode) != 0) {
+		rc = -errno;
+		warnx("chmod failed on directory '%s': %s", config_dir,
+		      strerror(-rc));
+		return rc;
+	}
+
+	if (chown(config_dir, geteuid(), keystore->owner) != 0) {
+		rc = -errno;
+		warnx("chown failed on directory '%s': %s", config_dir,
+		      strerror(-rc));
+		return rc;
+	}
+
+	if (funcs->kms_bind != NULL) {
+		rc = funcs->kms_bind(config_dir);
+		if (rc != 0) {
+			warnx("KMS plugin '%s' failed to bind to the "
+			      "repository: %s", plugin_name, strerror(-rc));
+			goto out;
+		}
+	}
+
+	props = properties_new();
+	rc = properties_set(props, KMS_CONFIG_PROP_KMS, plugin_name);
+	if (rc != 0)
+		goto out;
+
+	rc = properties_set(props, KMS_CONFIG_PROP_KMS_CONFIG, config_dir);
+	if (rc != 0)
+		goto out;
+
+	rc = _save_kms_properties(keystore, props, verbose);
+	if (rc != 0) {
+		warnx("Failed to save kms.conf into repository directory");
+		goto out;
+	}
+
+out:
+	if (plugin_name != NULL)
+		free(plugin_name);
+	if (props != NULL)
+		properties_free(props);
+	if (plugin_lib != NULL)
+		dlclose(plugin_lib);
+	if (config_dir != NULL) {
+		if (rc != 0 && created)
+			rmdir(config_dir);
+		free(config_dir);
+	}
+
+	return rc;
+}
+
+/**
+ * Removes a directory and all its contents.
+ */
+static int remove_directory_recursively(const char *directory)
+{
+	char *filename = NULL;
+	struct dirent *de;
+	DIR *dirp;
+	int rc = 0;
+
+	dirp = opendir(directory);
+	if (dirp == NULL) {
+		rc = -errno;
+		warnx("Failed to open directory '%s'", directory);
+		return rc;
+	}
+
+	while ((de = readdir(dirp))) {
+		util_asprintf(&filename, "%s/%s", directory, de->d_name);
+		if (de->d_type == DT_DIR) {
+			if (strcmp(de->d_name, ".") != 0 &&
+			    strcmp(de->d_name, "..") != 0)
+				rc = remove_directory_recursively(filename);
+		} else {
+			rc = remove(filename);
+			if (rc != 0) {
+				rc = -errno;
+				warnx("Failed to remove '%s': %s", filename,
+				      strerror(-rc));
+			}
+		}
+		free(filename);
+
+		if (rc != 0)
+			break;
+	}
+	closedir(dirp);
+	if (rc != 0)
+		goto out;
+
+	if (rmdir(directory) != 0) {
+		rc = -errno;
+		warnx("Failed to remove '%s': %s", filename, strerror(-rc));
+		goto out;
+	}
+
+out:
+	return rc;
+}
+
+/**
+ * Unbinds the currently bound KMS plugin from the current repository.
+ * If the repository is not bound to a KMS plugin, then -ENOENT is
+ * returned.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ *                            This function does NOT free the plugin, this must
+ *                            be done by the caller using free_kms_plugin().
+ * @param[in] keystore        the keystore to bind to the plugin
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int unbind_kms_plugin(struct kms_info *kms_info, struct keystore *keystore,
+		      bool UNUSED(verbose))
+{
+	char *config_dir = NULL;
+	char *filename = NULL;
+	int rc;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		goto out;
+	}
+
+	if (kms_info->funcs->kms_deconfigure != NULL &&
+	    kms_info->handle != NULL) {
+		rc = kms_info->funcs->kms_deconfigure(kms_info->handle);
+		if (rc != 0) {
+			warnx("KMS plugin '%s' failed to unbind from the "
+			      "repository: %s", kms_info->plugin_name,
+			      strerror(-rc));
+			print_last_kms_error(kms_info);
+			goto out;
+		}
+	}
+
+	config_dir = properties_get(kms_info->props,
+				    KMS_CONFIG_PROP_KMS_CONFIG);
+	if (config_dir != NULL) {
+		rc = remove_directory_recursively(config_dir);
+		if (rc != 0) {
+			warnx("Failed to remove the KMS plugin's config "
+			      "directory: %s", strerror(-rc));
+			goto out;
+		}
+	}
+
+	util_asprintf(&filename, "%s/%s", keystore->directory, KMS_CONFIG_FILE);
+	rc = remove(filename);
+	if (rc != 0) {
+		rc = -errno;
+		warnx("Failed to remove '%s': %s", filename, strerror(-rc));
+		goto out;
+	}
+
+out:
+	if (config_dir != NULL)
+		free(config_dir);
+	if (filename != NULL)
+		free(filename);
+	return rc;
+}
+
+/**
+ * Displays information about the KMS plugin and its configuration
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int print_kms_info(struct kms_info *kms_info)
+{
+	bool first;
+	int rc = 0;
+	size_t i;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		goto out;
+	}
+
+	printf("KMS-Plugin:             %s\n", kms_info->plugin_name);
+
+	if (kms_info->funcs->kms_supports_key_type != NULL) {
+		for (i = 0, first = true; key_types[i] != NULL; i++) {
+			if (kms_info->funcs->kms_supports_key_type(
+					kms_info->handle, key_types[i])) {
+				printf("  %s  %s\n", first ?
+				       "Supported key types:" :
+				       "                    ", key_types[i]);
+				first = false;
+			}
+		}
+		if (first)
+			printf("  Supported key types:  (none)\n");
+	} else {
+		printf("  Supported key types:  (unknown)\n");
+	}
+
+	if (kms_info->apqns == NULL || kms_info->num_apqns == 0) {
+		printf("  APQNs:                (configuration required)\n");
+		goto kms_info;
+	}
+
+	for (i = 0; i < kms_info->num_apqns; i++)
+		printf("  %s                %02x.%04x\n",
+		       i == 0 ? "APQNs:" : "      ",
+		       kms_info->apqns[i].card,
+		       kms_info->apqns[i].domain);
+
+kms_info:
+	if (kms_info->funcs->kms_display_info == NULL)
+		goto out;
+
+	rc = kms_info->funcs->kms_display_info(kms_info->handle);
+	if (rc != 0) {
+		warnx("Failed to display information about the plugin: %s",
+		      strerror(-rc));
+		print_last_kms_error(kms_info);
+		goto out;
+	}
+
+out:
+	return rc;
+}
+
+/**
+ * Gets the KMS plugin command specific option vector and puts them into the
+ * placeholder slots in opt_vec.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] opt_vec         the option vector to modify.
+ * @param[in] placeholder_cmd the command with which the placeholder option
+ *                            vector entries are marked
+ * @param[in] plugin_command  the plugin command to get the options for
+ * @param[in] opt_vec_command the command to use in the option vector entries
+ * @param[out] first_plugin_opt on return: the index of the first plugin option
+ *                            in opt_vec, or -1 if no plugin options are used.
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int get_kms_options(struct kms_info *kms_info, struct util_opt *opt_vec,
+		    const char *placeholder_cmd, const char *plugin_command,
+		    const char *opt_vec_command, int *first_plugin_opt,
+		    bool verbose)
+{
+	const struct util_opt *plugin_opts;
+	int i, k, first = 0, num_slots = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(opt_vec != NULL, "Internal error: opt_vec is NULL");
+	util_assert(placeholder_cmd != NULL,
+		    "Internal error: placeholder_cmd is NULL");
+	util_assert(plugin_command != NULL,
+		    "Internal error: plugin_command is NULL");
+	util_assert(first_plugin_opt != NULL,
+		    "Internal error: first_plugin_opt is NULL");
+
+	*first_plugin_opt = -1;
+
+	if (kms_info->plugin_lib == NULL) {
+		pr_verbose(verbose, "not bound to a KMS plugin");
+		return 0;
+	}
+
+	if (kms_info->funcs->kms_get_command_options == NULL) {
+		pr_verbose(verbose, "Plugin does not support command options");
+		return 0;
+	}
+
+	if (strcmp(plugin_command, KMS_COMMAND_CONFIGURE) != 0 &&
+	    strcmp(plugin_command, KMS_COMMAND_REENCIPHER) != 0 &&
+	    strcmp(plugin_command, KMS_COMMAND_GENERATE) != 0 &&
+	    strcmp(plugin_command, KMS_COMMAND_REMOVE) != 0 &&
+	    strcmp(plugin_command, KMS_COMMAND_LIST) != 0 &&
+	    strcmp(plugin_command, KMS_COMMAND_LIST_IMPORT) != 0) {
+		pr_verbose(verbose, "Command %s is not eligible for plugin "
+			   "options", plugin_command);
+		return 0;
+	}
+
+	for (i = 0; opt_vec[i].desc != NULL; i++) {
+		if (opt_vec[i].command != NULL &&
+		    strcmp(opt_vec[i].command, placeholder_cmd) == 0) {
+			if (first == 0)
+				first = i;
+			num_slots++;
+		}
+	}
+
+	pr_verbose(verbose, "%u placeholder slots found", num_slots);
+
+	plugin_opts = kms_info->funcs->kms_get_command_options(plugin_command,
+							       num_slots);
+	if (plugin_opts == NULL) {
+		pr_verbose(verbose, "No plugin options for command %s",
+			   plugin_command);
+		return 0;
+	}
+
+	for (k = 0, i = first; plugin_opts[k].desc != NULL &&
+			       i < first + num_slots; i++, k++) {
+		memcpy(&opt_vec[i], &plugin_opts[k], sizeof(struct util_opt));
+		opt_vec[i].command = (char *)opt_vec_command;
+	}
+
+	pr_verbose(verbose, "%u plugin options", k);
+
+	*first_plugin_opt = first;
+
+	return 0;
+}
+
+/**
+ * Checks if the option is a KMS plugin specific option and if so, adds it to
+ * list of KMS options. If the option is not handled by the plugin, then
+ * -ENOENT is returned.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] opt_vec         the option vector.
+ * @param[in] first_kms_option index of first KMS option in opt_vec
+ * @param[in] command         the plugin command to handle
+ * @param[in] option          the option character to handle
+ * @param[in] optarg          the option argument or NULL
+ * @param[out] kms_options    on return: an array of KMS options handled. The
+ *                            array is resized to add more options.
+ * @param[out] num_kms_options on return: The number of options in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ *
+ */
+int handle_kms_option(struct kms_info *kms_info, struct util_opt *opt_vec,
+		      int first_kms_option, const char *command, int option,
+		      const char *optarg, struct kms_option **kms_options,
+		      size_t *num_kms_options, bool verbose)
+{
+	struct kms_option opt = { .option = option, .argument = optarg };
+	int i;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(opt_vec != NULL, "Internal error: opt_vec is NULL");
+	util_assert(command != NULL, "Internal error: command is NULL");
+	util_assert(kms_options != NULL, "Internal error: kms_options is NULL");
+	util_assert(num_kms_options != NULL,
+		    "Internal error: num_kms_options is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		pr_verbose(verbose, "not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (first_kms_option < 0) {
+		pr_verbose(verbose, "No plugin specific options");
+		return -ENOENT;
+	}
+
+	for (i = first_kms_option; opt_vec[i].command != NULL &&
+		strcmp(opt_vec[i].command, command) == 0; i++) {
+		if ((opt_vec[i].flags & UTIL_OPT_FLAG_SECTION) == 0 &&
+		    opt_vec[i].option.val == option) {
+			ARRAY_ADD(*kms_options, *num_kms_options,
+				  sizeof(struct kms_option), &opt);
+			return 0;
+		}
+	}
+
+	return -ENOENT;
+}
+
+struct card_info {
+	enum card_type type;
+	int min_level;
+	struct fw_version min_fw_version;
+	struct kms_apqn *apqns;
+	size_t num_apqns;
+};
+
+/**
+ * Parses an APQN and checks if it is online.
+ *
+ * @param[in] apqn            the APQN to parse
+ * @param[out] kms_apqn       the parse APQN is filled in
+ * @param{in] check           if true, the APQN is checked to be online
+ * @param[in] cards           An array of cards types with its requirements
+ * @param[in] num_cards       The number of elements in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _parse_and_check_apqn(const char *apqn, struct kms_apqn *kms_apqn,
+				 bool check, struct card_info *cards,
+				 size_t num_cards)
+{
+	struct card_info *card_info = NULL;
+	struct fw_version fw_version;
+	unsigned int card, domain;
+	enum card_type type;
+	regmatch_t pmatch[1];
+	unsigned int num;
+	regex_t reg_buf;
+	int rc, level;
+	size_t i;
+
+	rc = regcomp(&reg_buf, "[[:xdigit:]]+\\.[[:xdigit:]]", REG_EXTENDED);
+	if (rc != 0)
+		return -EIO;
+
+	rc = regexec(&reg_buf, apqn, (size_t)1, pmatch, 0);
+	if (rc != 0) {
+		warnx("The APQN '%s' is not valid", apqn);
+		rc = -EINVAL;
+		goto out;
+	}
+
+	if (sscanf(apqn, "%x.%x%n", &card, &domain, (int *)&num) != 2 ||
+	    num != strlen(apqn) || card > 0xff || domain > 0xFFFF) {
+		warnx("The APQN '%s' is not valid", apqn);
+		rc = -EINVAL;
+		goto out;
+	}
+
+	kms_apqn->card = card;
+	kms_apqn->domain = domain;
+
+	if (!check) {
+		rc = 0;
+		goto out;
+	}
+
+	type = sysfs_get_card_type(card);
+	if (type == -1) {
+		warnx("The APQN %02x.%04x is not available or has an "
+		     "unsupported type", card, domain);
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = sysfs_is_apqn_online(card, domain, CARD_TYPE_ANY);
+	if (rc != 1) {
+		warnx("The APQN %02x.%04x is not available or not online",
+		      card, domain);
+		rc = -EIO;
+		goto out;
+	}
+
+	for (i = 0, card_info = NULL; i < num_cards; i++) {
+		if (cards[i].type == type) {
+			card_info = &cards[i];
+			break;
+		}
+	}
+	if (card_info == NULL) {
+		warnx("APQN %02x.%04x: The card type is not supported by the "
+		      "KMS plugin", card, domain);
+		rc = -EIO;
+		goto out;
+	}
+
+	level = sysfs_get_card_level(card);
+	if (level < card_info->min_level) {
+		warnx("APQN %02x.%04x: The card level is less than CEX%dn.",
+		      card, domain, card_info->min_level);
+		rc = -EIO;
+		goto out;
+	}
+
+	rc = sysfs_get_firmware_version(card, &fw_version, false);
+	if (rc == 0) {
+		if (fw_version.api_ordinal <
+				card_info->min_fw_version.api_ordinal) {
+			warnx("APQN %02x.%04x: The firmware version is too "
+			      "less", card, domain);
+			rc = -EIO;
+			goto out;
+		}
+		if (card_info->min_level > 0 && card_info->min_level == level &&
+		    (fw_version.major < card_info->min_fw_version.major ||
+		     (fw_version.major == card_info->min_fw_version.major &&
+		      fw_version.minor < card_info->min_fw_version.minor))) {
+			warnx("APQN %02x.%04x: The firmware version is too "
+			      "less", card, domain);
+			rc = -EIO;
+			goto out;
+		}
+	}
+
+	rc = 0;
+
+out:
+	regfree(&reg_buf);
+	return rc;
+}
+
+/**
+ * Add APQNs to the current APQN association of the KMS plugin
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] apqns           the APQNs specification from --apqns option
+ * @param[in] cards           An array of card types with its requirements
+ * @param[in] num_cardsqs     The number of elements in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _add_kms_apqns(struct kms_info *kms_info, const char *apqns,
+			  struct card_info *cards, size_t num_cards)
+{
+	struct kms_apqn kms_apqn;
+	char **new_apqns;
+	int i, rc = 0;
+	size_t k;
+
+	new_apqns = str_list_split(apqns);
+
+	for (i = 0; new_apqns[i] != NULL; i++) {
+		rc = _parse_and_check_apqn(new_apqns[i], &kms_apqn, true,
+					   cards, num_cards);
+		if (rc != 0)
+			goto out;
+
+		for (k = 0; k < kms_info->num_apqns; k++) {
+			if (kms_apqn.card == kms_info->apqns[k].card &&
+			    kms_apqn.domain == kms_info->apqns[k].domain) {
+				warnx("APQN %02x.%04x is already associated "
+				      "with the KMS plugin", kms_apqn.card,
+				      kms_apqn.domain);
+				rc = -EEXIST;
+				goto out;
+			}
+		}
+
+		ARRAY_ADD(kms_info->apqns, kms_info->num_apqns,
+			  sizeof(struct kms_apqn), &kms_apqn);
+	}
+
+out:
+	str_list_free_string_array(new_apqns);
+
+	return rc;
+}
+
+/**
+ * Remove APQNs from the current APQN association of the KMS plugin
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] apqns           the APQNs specification from --apqns option
+ * @param[in] cards           An array of card types with its requirements
+ * @param[in] num_cards       The number of elements in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _remove_kms_apqns(struct kms_info *kms_info, const char *apqns,
+			     struct card_info *cards, size_t num_cards)
+{
+	struct kms_apqn kms_apqn;
+	char **rem_apqns;
+	int i, rc = 0;
+	size_t k;
+
+	rem_apqns = str_list_split(apqns);
+
+	for (i = 0; rem_apqns[i] != NULL; i++) {
+		rc = _parse_and_check_apqn(rem_apqns[i], &kms_apqn, false,
+					   cards, num_cards);
+		if (rc != 0)
+			goto out;
+
+		for (k = 0; k < kms_info->num_apqns; k++) {
+			if (kms_apqn.card == kms_info->apqns[k].card &&
+			    kms_apqn.domain == kms_info->apqns[k].domain) {
+				ARRAY_REMOVE(kms_info->apqns,
+					     kms_info->num_apqns,
+					     sizeof(struct kms_apqn), k);
+				rc = 0;
+				goto out;
+			}
+		}
+
+		warnx("APQN %02x.%04x is not associated with the KMS plugin",
+		      kms_apqn.card, kms_apqn.domain);
+		rc = -ENOENT;
+		goto out;
+	}
+
+out:
+	free(rem_apqns);
+
+	return rc;
+}
+
+/**
+ * Set the APQN association of the KMS plugin
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] apqns           the APQNs specification from --apqns option
+ * @param[in] cards           An array of card types with its requirements
+ * @param[in] num_cards       The number of elements in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _set_kms_apqns(struct kms_info *kms_info, const char *apqns,
+			  struct card_info *cards, size_t num_cards)
+{
+	if (kms_info->apqns != NULL)
+		free(kms_info->apqns);
+	kms_info->apqns = NULL;
+	kms_info->num_apqns = 0;
+
+	if (strlen(apqns) == 0) {
+		/* Indicate empty list specified */
+		kms_info->apqns = util_malloc(sizeof(struct kms_apqn));
+		return 0;
+	}
+
+	return _add_kms_apqns(kms_info, apqns, cards, num_cards);
+}
+
+/**
+ * Change the APQN association of the KMS plugin
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] apqns           the APQNs specification from --apqns option
+ * @param[in] cards           An array of card types with its requirements
+ * @param[in] num_cards       The number of elements in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _change_kms_apqns(struct kms_info *kms_info, const char *apqns,
+			     struct card_info *cards, size_t num_cards)
+{
+	switch (*apqns) {
+	case '+':
+		if (kms_info->apqns != NULL && kms_info->num_apqns > 0)
+			return _add_kms_apqns(kms_info, &apqns[1], cards,
+					      num_cards);
+		else
+			return _set_kms_apqns(kms_info, &apqns[1], cards,
+					      num_cards);
+	case '-':
+		if (kms_info->apqns != NULL && kms_info->num_apqns > 0)
+			return _remove_kms_apqns(kms_info, &apqns[1], cards,
+						 num_cards);
+
+		warnx("No APQNs are currently associated with the KMS plugin");
+		return -ENOENT;
+	default:
+		return _set_kms_apqns(kms_info, apqns, cards, num_cards);
+	}
+}
+
+/**
+ * Returns the crypto card requirements per card type base on the key types that
+ * the KMS plugin supports.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[out] cards          on return: An array of card types with its
+ *                            requirements. The caller must free this array if
+ *                            no longer used.
+ * @param[out] num_cards      on return: The number of elements in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns the card type
+ */
+static int _get_supported_card_types(struct kms_info *kms_info,
+				     struct card_info **cards,
+				     size_t *num_cards, bool verbose)
+{
+	struct card_info new_card = { 0 };
+	const struct fw_version *fw_ver;
+	struct card_info *req;
+	enum card_type type;
+	int i, level;
+	size_t k;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(cards != NULL, "Internal error: reqs is NULL");
+	util_assert(num_cards != NULL, "Internal error: num_reqs is NULL");
+
+	*cards = NULL;
+	*num_cards = 0;
+
+	if (kms_info->funcs->kms_supports_key_type == NULL)
+		return 0;
+
+	for (i = 0; key_types[i] != NULL; i++) {
+		if (kms_info->funcs->kms_supports_key_type(kms_info->handle,
+							   key_types[i])) {
+			pr_verbose(verbose, "KMS plugin supports key type %s",
+				   key_types[i]);
+
+			type = get_card_type_for_keytype(key_types[i]);
+			level = get_min_card_level_for_keytype(key_types[i]);
+			fw_ver = get_min_fw_version_for_keytype(key_types[i]);
+
+			for (req = NULL, k = 0; k < *num_cards; k++) {
+				if ((*cards)[k].type == type)
+					req = &(*cards)[k];
+			}
+
+			if (req == NULL) {
+				new_card.type = type;
+				new_card.min_level = level;
+				if (fw_ver != NULL)
+					new_card.min_fw_version = *fw_ver;
+
+				ARRAY_ADD(*cards, *num_cards,
+					  sizeof(struct card_info),
+					  &new_card);
+				req = &(*cards)[*num_cards - 1];
+			}
+
+			if (req->min_level < level) {
+				req->min_level = level;
+
+				if (fw_ver != NULL) {
+					if (req->min_fw_version.api_ordinal <
+							fw_ver->api_ordinal ||
+					    req->min_fw_version.major <
+							fw_ver->major ||
+					    (req->min_fw_version.major ==
+							fw_ver->major &&
+					     req->min_fw_version.minor <
+							fw_ver->minor))
+						req->min_fw_version = *fw_ver;
+				}
+			}
+
+			pr_verbose(verbose, "Card type: %d", req->type);
+			pr_verbose(verbose, "Card level: %d", req->min_level);
+			pr_verbose(verbose, "Fw version: %d.%d (API: %d)",
+				   req->min_fw_version.major,
+				   req->min_fw_version.minor,
+				   req->min_fw_version.api_ordinal);
+		}
+	}
+
+	pr_verbose(verbose, "%lu card type are supported", *num_cards);
+
+	return 0;
+}
+
+/**
+ * Builds an APQN list per card type.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] cards           An array of card types to build APQNs lists for
+ * @param[in] num_cards       The number of elements in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _get_apqns_per_card_type(struct kms_info *kms_info,
+				    struct card_info *cards, size_t num_cards)
+{
+	enum card_type type;
+	size_t i, k;
+	bool found;
+
+	for (i = 0; i < kms_info->num_apqns; i++) {
+		if (!sysfs_is_apqn_online(kms_info->apqns[i].card,
+					  kms_info->apqns[i].domain, 0)) {
+			warnx("The APQN %02x.%04x is not online",
+			      kms_info->apqns[i].card,
+			      kms_info->apqns[i].domain);
+			return -EIO;
+		}
+
+		type = sysfs_get_card_type(kms_info->apqns[i].card);
+		for (k = 0, found = false; k < num_cards; k++) {
+			if (cards[k].type == type) {
+				ARRAY_ADD(cards[k].apqns, cards[k].num_apqns,
+					  sizeof(struct kms_apqn),
+					  &kms_info->apqns[i]);
+				found = true;
+			}
+		}
+
+		if (!found) {
+			warnx("The APQN %02x.%04x is not available of has an "
+			      "unsupported type", kms_info->apqns[i].card,
+			      kms_info->apqns[i].domain);
+			return -EIO;
+		}
+	}
+
+	return 0;
+}
+
+/**
+ * Build an APQN string from an APQN array
+ *
+ * @param[in] apqns           An array of APQNs
+ * @param[in] num_apqns       The number of elements in above array
+ *
+ * @return an allocated string with the APQNs
+ */
+static char *_build_apqn_string(struct kms_apqn *apqns, size_t num_apqns)
+{
+	char *apqn_str, *str;
+	size_t size, i;
+
+	if (num_apqns == 0) {
+		apqn_str = util_malloc(1);
+		*apqn_str = '\0';
+		return apqn_str;
+	}
+
+	size = num_apqns * 8; /* 'cc.dddd' plus ',' or '\0' */
+	apqn_str = util_malloc(size);
+
+	str = apqn_str;
+	for (i = 0; i < num_apqns; i++) {
+		if (i != 0) {
+			*str = ',';
+			str++;
+		}
+
+		sprintf(str, "%02x.%04x", apqns[i].card, apqns[i].domain);
+		str += 7;
+	}
+
+	return apqn_str;
+}
+
+/**
+ * Update the APQNS properties in the KMS properties to reflect the list of
+ * APQNs contained in kms_info and supported card types.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] cards           An array of card types supported
+ * @param[in] num_cards       The number of elements in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _update_apqns_properties(struct kms_info *kms_info,
+				    struct card_info *cards, size_t num_cards,
+				    bool verbose)
+{
+	char *apqns = NULL;
+	char *prop;
+	size_t i;
+	int rc;
+
+	rc = properties_remove(kms_info->props,
+			       KMS_CONFIG_PROP_CCA_APQNS);
+	if (rc != 0 && rc != -ENOENT) {
+		pr_verbose(verbose, "Failed to remove the APQNS "
+			   "property: %s", strerror(-rc));
+		return rc;
+	}
+
+	rc = properties_remove(kms_info->props,
+			       KMS_CONFIG_PROP_EP11_APQNS);
+	if (rc != 0 && rc != -ENOENT) {
+		pr_verbose(verbose, "Failed to remove the APQNS "
+			   "property: %s", strerror(-rc));
+		return rc;
+	}
+
+	if (kms_info->num_apqns == 0) {
+		rc = properties_remove(kms_info->props, KMS_CONFIG_PROP_APQNS);
+		if (rc != 0 && rc != -ENOENT) {
+			pr_verbose(verbose, "Failed to remove the APQNS "
+				   "property: %s", strerror(-rc));
+			return rc;
+		}
+
+		pr_verbose(verbose, "APQNs: none");
+		return 0;
+	}
+
+	apqns = _build_apqn_string(kms_info->apqns, kms_info->num_apqns);
+	pr_verbose(verbose, "APQNs: '%s'", apqns);
+
+	rc = properties_set(kms_info->props, KMS_CONFIG_PROP_APQNS, apqns);
+	free(apqns);
+
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to set the APQNS property: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	for (i = 0; i < num_cards; i++) {
+		switch (cards[i].type) {
+		case CARD_TYPE_CCA:
+			prop = KMS_CONFIG_PROP_CCA_APQNS;
+			break;
+		case CARD_TYPE_EP11:
+			prop = KMS_CONFIG_PROP_EP11_APQNS;
+			break;
+		default:
+			continue;
+		}
+
+		apqns = _build_apqn_string(cards[i].apqns, cards[i].num_apqns);
+		pr_verbose(verbose, "%s: '%s'", prop, apqns);
+
+		rc = properties_set(kms_info->props, prop, apqns);
+		free(apqns);
+
+		if (rc != 0) {
+			pr_verbose(verbose, "Failed to set the %s property: %s",
+				   prop, strerror(-rc));
+			goto out;
+		}
+	}
+
+out:
+	return rc;
+}
+
+/**
+ * Cross checks the APQNs per card type
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] cards           An array of card types to build APQNs lists for
+ * @param[in] num_cards       The number of elements in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _cross_check_apqns(struct card_info *cards, size_t num_cards,
+			      bool verbose)
+{
+	char *apqns;
+	size_t i;
+	int rc;
+
+	for (i = 0; i < num_cards; i++) {
+		if (cards[i].num_apqns == 0)
+			continue;
+
+		apqns = _build_apqn_string(cards[i].apqns, cards[i].num_apqns);
+
+		rc = cross_check_apqns(apqns, NULL, cards[i].min_level,
+				       &cards[i].min_fw_version, cards[i].type,
+				       true, verbose);
+		free(apqns);
+
+		if (rc == -ENOTSUP)
+			continue;
+		if (rc != 0)
+			return rc;
+	}
+
+	return 0;
+}
+
+/**
+ * Checks existing KMS-bound keys in the keystore of the new set of APQNs
+ * would make them unusable. The user is prompted if so.
+ *
+ * @param[in] keystore        the keystore
+ * @param[in] cards           An array of card types
+ * @param[in] num_cards       The number of elements in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _check_keystore_keys(struct keystore *keystore,
+				struct card_info *cards, size_t num_cards)
+{
+	struct kms_info *kms_info = keystore->kms_info;
+	struct card_info *card = NULL;
+	enum card_type type;
+	size_t i, k;
+	char *msg;
+	int rc;
+
+	for (i = 0; key_types[i] != NULL; i++) {
+		type = get_card_type_for_keytype(key_types[i]);
+		if (type <= 0)
+			continue;
+
+		for (k = 0; k < num_cards; k++) {
+			if (cards[k].type == type) {
+				card = &cards[k];
+				break;
+			}
+		}
+		if (card == NULL)
+			continue;
+
+		pr_verbose(keystore->verbose, "Checking repository for "
+			   "KMS-bound keys of type %s", key_types[i]);
+
+		if (card->num_apqns > 0) {
+			pr_verbose(keystore->verbose, "Set of APQNs for key "
+				   "type %s is not empty", key_types[i]);
+			continue;
+		}
+
+		util_asprintf(&msg, "The following keys of type '%s' are bound "
+			      "to KMS plugin '%s', and may become unusable "
+			      "with this set of APQNs:", key_types[i],
+			      kms_info->plugin_name);
+		rc = keystore_msg_for_kms_key(keystore, key_types[i], msg);
+		free(msg);
+
+		if (rc == -ENOENT) {
+			pr_verbose(keystore->verbose, "No keys of type %s "
+				   "found", key_types[i]);
+			continue;
+		}
+		if (rc != 0)
+			return rc;
+
+		printf("Do you want to continue [y/N]? ");
+		if (!prompt_for_yes(keystore->verbose)) {
+			warnx("Operation aborted");
+			return -ECANCELED;
+		}
+	}
+
+	return 0;
+}
+
+/**
+ * Updates existing KMS-bound keys in the keystore with the set of APQNs that
+ * match the key type.
+ *
+ * @param[in] keystore        the keystore
+ * @param[in] cards           An array of card types
+ * @param[in] num_cards       The number of elements in above array
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+static int _update_keystore_keys(struct keystore *keystore,
+				 struct card_info *cards, size_t num_cards)
+{
+	struct card_info *card = NULL;
+	enum card_type type;
+	size_t i, k;
+	char *apqns;
+	int rc;
+
+	for (i = 0; key_types[i] != NULL; i++) {
+		type = get_card_type_for_keytype(key_types[i]);
+		if (type <= 0)
+			continue;
+
+		for (k = 0; k < num_cards; k++) {
+			if (cards[k].type == type) {
+				card = &cards[k];
+				break;
+			}
+		}
+		if (card == NULL)
+			continue;
+
+		apqns = _build_apqn_string(card->apqns, card->num_apqns);
+
+		pr_verbose(keystore->verbose, "Changing KMS-bound keys of "
+			   "type %s to: '%s'", key_types[i], apqns);
+
+		rc = keystore_kms_keys_set_property(keystore, key_types[i],
+						    PROP_NAME_APQNS, apqns);
+		free(apqns);
+		if (rc != 0) {
+			warnx("Failed to update APQNs for KMS-bound keys of "
+			      "type %s: %s", key_types[i], strerror(-rc));
+			return rc;
+		}
+	}
+
+	return 0;
+}
+
+/**
+ * Performs configuration of the KMS plugin.
+ *
+ * @param[in] keystore        the keystore
+ * @param[in] apqns           the APQNs specification from --apqns option, or
+ *                            NULL if the option was not specified
+ * @param[in] kms_options     an array of KMS options specified, or NULL if no
+ *                            KMS options have been specified
+ * @param[in] num_kms_options the number of options in above array
+ * @param[in] has_plugin_optins if true, then the KMS plugin uses KMS specific
+ *                            options, false of no options are supported
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ * -EAGAIN to indicate that the specified configuration was accepted so far, but
+ * the configuration is still incomplete, and needs to be completed.
+ */
+int configure_kms_plugin(struct keystore *keystore, const char *apqns,
+			 struct kms_option *kms_options, size_t num_kms_options,
+			 bool has_plugin_optins, bool verbose)
+{
+	struct card_info *cards = NULL;
+	struct kms_info *kms_info;
+	bool incomplete = false;
+	size_t i, num_cards = 0;
+	int rc = 0;
+
+	util_assert(keystore != NULL, "Internal error: keystore is NULL");
+
+	kms_info = keystore->kms_info;
+	if (kms_info->plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		goto out;
+	}
+
+	if (apqns == NULL) {
+		if (kms_info->apqns == NULL || kms_info->num_apqns == 0) {
+			warnx("Option '--apqns|-a' is required when no APQNS "
+			      "are associated with the KMS plugin");
+			util_prg_print_parse_error();
+			rc = -EINVAL;
+			goto out;
+		}
+
+		if (has_plugin_optins && num_kms_options == 0) {
+			warnx("At least one option is required");
+			util_prg_print_parse_error();
+			rc = -EINVAL;
+			goto out;
+		}
+	}
+
+	if (apqns != NULL) {
+		rc = _get_supported_card_types(kms_info, &cards, &num_cards,
+					       verbose);
+		if (rc != 0)
+			goto out;
+		if (num_cards == 0) {
+			warnx("The KMS plugin does not support any key type");
+			rc = -EIO;
+			goto out;
+		}
+
+		rc = _change_kms_apqns(kms_info, apqns, cards, num_cards);
+		if (rc != 0)
+			goto out;
+
+		rc = _get_apqns_per_card_type(kms_info, cards, num_cards);
+		if (rc != 0)
+			goto out;
+
+		rc = _cross_check_apqns(cards, num_cards, verbose);
+		if (rc != 0)
+			goto out;
+
+		rc = _check_keystore_keys(keystore, cards, num_cards);
+		if (rc != 0)
+			goto out;
+
+		rc = _update_apqns_properties(kms_info, cards, num_cards,
+					      verbose);
+		if (rc != 0) {
+			warnx("Failed to update the APQNs: %s", strerror(-rc));
+			goto out;
+		}
+	}
+
+	if (kms_info->funcs->kms_configure != NULL) {
+		rc = kms_info->funcs->kms_configure(kms_info->handle,
+						    apqns != NULL ?
+							kms_info->apqns : NULL,
+						    apqns != NULL ?
+							kms_info->num_apqns : 0,
+						    kms_options,
+						    num_kms_options);
+
+		if (rc == -EAGAIN) {
+			incomplete = true;
+			rc = 0;
+		}
+
+		if (rc != 0) {
+			warnx("Failed to configure the KMS plugin: '%s'",
+			      strerror(-rc));
+			print_last_kms_error(kms_info);
+			goto out;
+		}
+	}
+
+	if (apqns != NULL) {
+		rc = _save_kms_properties(keystore, kms_info->props, verbose);
+		if (rc != 0)
+			goto out;
+
+		rc = _update_keystore_keys(keystore, cards, num_cards);
+		if (rc != 0)
+			goto out;
+
+		if (kms_info->num_apqns == 0)
+			incomplete = true;
+	}
+
+out:
+	if (cards != NULL) {
+		for (i = 0; i < num_cards; i++)
+			if (cards[i].apqns != NULL)
+				free(cards[i].apqns);
+		free(cards);
+	}
+
+	if (rc == 0 && incomplete)
+		rc = -EAGAIN;
+	return rc;
+}
+
+/**
+ * Performs re-enciphering of secure keys internally used by the KMS plugin
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] from_old        If true the keys are reenciphered from the OLD to
+ *                            the CURRENT master key.
+ * @param[in] to_new          If true the keys are reenciphered from the CURRENT
+ *                            to the OLD master key.
+ * @param[in] inplace         if true, the key will be re-enciphere in-place
+ * @param[in] staged          if true, the key will be re-enciphere not in-place
+ * @param[in] complete        if true, a pending re-encipherment is completed
+ * @param[in] kms_options     an array of KMS options specified, or NULL if no
+ *                            KMS options have been  specified
+ * @param[in] num_kms_options the number of options in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ * -EAGAIN to indicate that the specified configuration was accepted so far, but
+ * the configuration is still incomplete, and needs to be completed.
+ */
+int reencipher_kms(struct kms_info *kms_info, bool from_old, bool to_new,
+		   bool inplace, bool staged, bool complete,
+		   struct kms_option *kms_options, size_t num_kms_options,
+		   bool verbose)
+{
+	enum kms_reencipher_mode mode = KMS_REENC_MODE_AUTO;
+	enum kms_reenc_mkreg mkreg = KMS_REENC_MKREG_AUTO;
+	int rc = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		goto out;
+	}
+
+	if (kms_info->funcs->kms_reenciper == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support "
+			   "reencipher");
+		goto out;
+	}
+
+	if (inplace)
+		mode = KMS_REENC_MODE_IN_PLACE;
+	else if (staged)
+		mode = KMS_REENC_MODE_STAGED;
+	else if (complete)
+		mode = KMS_REENC_MODE_STAGED_COMPLETE;
+
+	if (from_old && !to_new) {
+		mkreg = KMS_REENC_MKREG_FROM_OLD;
+		if (mode == KMS_REENC_MODE_AUTO)
+			mode = KMS_REENC_MODE_IN_PLACE;
+	} else if (to_new && !from_old) {
+		mkreg = KMS_REENC_MKREG_TO_NEW;
+		if (mode == KMS_REENC_MODE_AUTO)
+			mode = KMS_REENC_MODE_STAGED;
+	} else if (from_old && to_new) {
+		mkreg = KMS_REENC_MKREG_FROM_OLD_TO_NEW;
+		if (mode == KMS_REENC_MODE_AUTO)
+			mode = KMS_REENC_MODE_STAGED;
+	}
+
+	rc = kms_info->funcs->kms_reenciper(kms_info->handle, mode, mkreg,
+					    kms_options, num_kms_options);
+	if (rc != 0) {
+		warnx("Failed to reencipher KMS plugin internal keys: %s",
+		      strerror(-rc));
+		print_last_kms_error(kms_info);
+		goto out;
+	}
+
+out:
+	return rc;
+}
+
+/**
+ * Performs a login with the KMS plugin, if one is configured
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int perform_kms_login(struct kms_info *kms_info, bool verbose)
+{
+	int rc = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		goto out;
+	}
+
+	if (kms_info->funcs->kms_login == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support login");
+		goto out;
+	}
+
+	rc = kms_info->funcs->kms_login(kms_info->handle);
+	if (rc != 0) {
+		warnx("Failed to login into the KMS: %s",
+		      strerror(-rc));
+		print_last_kms_error(kms_info);
+		goto out;
+	}
+
+out:
+	return rc;
+}
+
+/**
+ * Gets the subset of the APQNs of a KMS plugin for a specific key type
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] key_type        the key type to get the APQNs for, or NULL to
+ *                            get all APQNs associated with the KMS
+ * @param[in] cross_check     if true, the APQNs are cross checked
+ * @param[out] apqns          On return the list of APQNs as comma separated
+ *                            string. Must be freed by the caller.
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ * If the KMS plugin does not support the key type, then -ENOTSUP is returned
+ */
+int get_kms_apqns_for_key_type(struct kms_info *kms_info, const char *key_type,
+			       bool cross_check, char **apqns, bool verbose)
+{
+	const struct fw_version *fw_version;
+	const char *prop_name;
+	int rc = 0, min_level;
+	enum card_type type;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(apqns != NULL, "Internal error: apqns is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (key_type != NULL) {
+		if (kms_info->funcs->kms_supports_key_type == NULL)
+			return -ENOTSUP;
+
+		if (!kms_info->funcs->kms_supports_key_type(kms_info->handle,
+							   key_type))
+			return -ENOTSUP;
+	}
+
+	type = get_card_type_for_keytype(key_type);
+	switch (type) {
+	case CARD_TYPE_CCA:
+		prop_name = KMS_CONFIG_PROP_CCA_APQNS;
+		break;
+	case CARD_TYPE_EP11:
+		prop_name = KMS_CONFIG_PROP_EP11_APQNS;
+		break;
+	default:
+		prop_name = KMS_CONFIG_PROP_APQNS;
+		break;
+	}
+
+	*apqns = properties_get(kms_info->props, prop_name);
+	if (*apqns == NULL)
+		return -ENOTSUP;
+
+	if (str_list_count(*apqns) == 0) {
+		rc = -ENOTSUP;
+		goto out;
+	}
+
+	if (cross_check) {
+		min_level = get_min_card_level_for_keytype(key_type);
+		fw_version = get_min_fw_version_for_keytype(key_type);
+
+		rc = cross_check_apqns(*apqns, NULL, min_level, fw_version,
+				       type, true, verbose);
+		if (rc == -ENOTSUP)
+			rc = 0;
+		if (rc != 0) {
+			warnx("Your master key setup is improper");
+			goto out;
+		}
+	}
+
+out:
+	if (rc != 0) {
+		free(*apqns);
+		*apqns = NULL;
+	}
+
+	return rc;
+}
+
+/**
+ * Returns a system specific version of the specified properties name.
+ * The properties name does not contain any special characters, except '-'
+ * and '_'. The returned string mst be freed by the caller.
+ *
+ * @param[in] prop_name      the base property name
+ *
+ * @returns an allocated string
+ */
+static char *_get_system_specific_prop_name(const char *prop_name)
+{
+	struct utsname utsname;
+	char *ret;
+	int i;
+
+	if (uname(&utsname)) {
+		warnx("uname failed: %s", strerror(errno));
+		return NULL;
+	}
+
+	for (i = 0; utsname.nodename[i] != '\0'; i++)
+		if (!isalnum(utsname.nodename[i]))
+			utsname.nodename[i] = '_';
+
+	util_asprintf(&ret, "%s-%s", prop_name, utsname.nodename);
+	return ret;
+}
+
+#define ADD_KMS_PROPS(props, num, pname, pvalue)			\
+	do {								\
+		util_assert((num) * sizeof(struct kms_property) <	\
+			    sizeof(props), " Internal error: kss "	\
+			    "property array is full");			\
+		(props)[num].name = (pname);				\
+		(props)[num].value = (pvalue);				\
+		(num)++;						\
+	} while (0)
+
+/**
+ * Requests the KMS plugin to generate  a key of the specified key type, size
+ * and mode, and stores the secure key blob into the specified file.
+ *
+ * For an XTS-mode key, 2 keys are generated and those are cross linked using
+ * its properties.
+ *
+ * The key ID(s) and label(s) of the generated keys (2 for XTS) are set into
+ * the properties object.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] name            the name of the key to generate
+ * @param[in] key_type        the key type o the key to generate
+ * @param[in] key_props       a properties object containing the key's initial
+ *                            properties. On return additional properties are
+ *                            added/set for the key ID(s) and label(s).
+ * @param[in] xts             if true, an XTS key (i.e 2 keys) is generated
+ * @param[in] keybits         the key bit size (e.g. 128, 196, 256, 0 to use the
+ *                            plugin's default)
+ * @param[in] filename        the file name to store the key in
+ * @param[in] kms_options     an array of KMS options specified, or NULL if no
+ *                            KMS options have been specified
+ * @param[in] num_kms_options the number of options in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ * If the KMS plugin does not support the key type, then -ENOTSUP is returned
+ */
+int generate_kms_key(struct kms_info *kms_info, const char *name,
+		     const char *key_type, struct properties *key_props,
+		     bool xts, size_t keybits, const char *filename,
+		     struct kms_option *kms_options, size_t num_kms_options,
+		     bool verbose)
+{
+	char *cipher, *iv_mode, *description, *volumes, *vol_type, *sector_size;
+	unsigned char key_blob[MAX_SECURE_KEY_SIZE * 2];
+	char key1_label[KMS_KEY_LABEL_SIZE + 1] = { 0 };
+	char key2_label[KMS_KEY_LABEL_SIZE + 1] = { 0 };
+	char key1_id[KMS_KEY_ID_SIZE + 1] = { 0 };
+	char key2_id[KMS_KEY_ID_SIZE + 1] = { 0 };
+	struct kms_property kms_props[12];
+	int xts_mode_prop = -1, rc = 0;
+	size_t key_size, key_blob_size;
+	enum kms_key_mode key_mode;
+	size_t num_kms_props = 0;
+	char *sys_volumes = NULL;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(name != NULL, "Internal error: name is NULL");
+	util_assert(key_type != NULL, "Internal error: key_type is NULL");
+	util_assert(key_props != NULL, "Internal error: key_props is NULL");
+	util_assert(filename != NULL, "Internal error: filename is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (kms_info->funcs->kms_generate_key == NULL ||
+	    kms_info->funcs->kms_set_key_properties == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support to "
+			   "generate keys or set properties");
+		return -ENOTSUP;
+	}
+
+	if (strcasecmp(key_type, KEY_TYPE_CCA_AESDATA) == 0)
+		key_size = AESDATA_KEY_SIZE;
+	else if (strcasecmp(key_type, KEY_TYPE_CCA_AESCIPHER) == 0)
+		key_size = AESCIPHER_KEY_SIZE;
+	else if (strcasecmp(key_type, KEY_TYPE_EP11_AES) == 0)
+		key_size = EP11_KEY_SIZE;
+	else
+		return -ENOTSUP;
+
+	memset(key_blob, 0, sizeof(key_blob));
+
+	cipher = properties_get(key_props, PROP_NAME_CIPHER);
+	iv_mode = properties_get(key_props, PROP_NAME_IV_MODE);
+	description = properties_get(key_props, PROP_NAME_DESCRIPTION);
+	volumes = properties_get(key_props, PROP_NAME_VOLUMES);
+	vol_type = properties_get(key_props, PROP_NAME_VOLUME_TYPE);
+	sector_size = properties_get(key_props, PROP_NAME_SECTOR_SIZE);
+
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_NAME, name);
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_CIPHER,
+		      cipher != NULL ? cipher : "");
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_IV_MODE,
+		      iv_mode != NULL ? iv_mode : "");
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_DESCRIPTION,
+		      description != NULL ? description : "");
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_VOLUMES,
+		      volumes != NULL ? volumes : "");
+	sys_volumes = _get_system_specific_prop_name(KMS_KEY_PROP_VOLUMES);
+	if (sys_volumes == NULL)
+		return -ENOMEM;
+	ADD_KMS_PROPS(kms_props, num_kms_props, sys_volumes,
+		      volumes != NULL ? volumes : "");
+
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_VOLUME_TYPE,
+		      vol_type != NULL ? vol_type : "");
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_SECTOR_SIZE,
+		      sector_size != NULL ? sector_size : "");
+
+	if (xts) {
+		xts_mode_prop = num_kms_props;
+		ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_XTS_KEY,
+			      "XTS-KEY-1");
+	}
+
+	key_mode = xts ? KMS_KEY_MODE_XTS_1 : KMS_KEY_MODE_NON_XTS;
+
+	key_blob_size = key_size;
+	rc = kms_info->funcs->kms_generate_key(kms_info->handle, key_type,
+					       keybits, key_mode,
+					       kms_props, num_kms_props,
+					       kms_options, num_kms_options,
+					       key_blob, &key_blob_size,
+					       key1_id, sizeof(key1_id),
+					       key1_label, sizeof(key1_label));
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to generate key #1: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	pr_verbose(verbose, "Key1: ID: '%s' Label: '%s'", key1_id, key1_label);
+	pr_verbose(verbose, "Keyblob #1: %lu bytes:'", key_blob_size);
+	if (verbose)
+		util_hexdump_grp(stderr, NULL, key_blob, 4, key_blob_size, 0);
+
+	/* Save ID and label of 1st key */
+	rc = properties_set(key_props, xts ? PROP_NAME_KMS_XTS_KEY1_ID :
+			    PROP_NAME_KMS_KEY_ID, key1_id);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to set key id of key #1: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	rc = properties_set(key_props, xts ? PROP_NAME_KMS_XTS_KEY1_LABEL :
+			    PROP_NAME_KMS_KEY_LABEL, key1_label);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to set key label of key #1: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	if (!xts)
+		goto save_key;
+
+	/* Generate 2nd key of the XTS key */
+	kms_props[xts_mode_prop].value = "XTS-KEY-2";
+	key_mode = KMS_KEY_MODE_XTS_2;
+
+	/* Cross link key 1 with key 2 */
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_XTS_KEY1_ID,
+		      key1_id);
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_XTS_KEY1_LABEL,
+		      key1_label);
+
+	key_blob_size = key_size;
+	rc = kms_info->funcs->kms_generate_key(kms_info->handle, key_type,
+					       keybits, key_mode,
+					       kms_props, num_kms_props,
+					       kms_options, num_kms_options,
+					       &key_blob[key_size],
+					       &key_blob_size,
+					       key2_id, sizeof(key2_id),
+					       key2_label, sizeof(key2_label));
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to generate key #2: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	pr_verbose(verbose, "Key2: ID: '%s' Label: '%s'", key1_id, key1_label);
+	pr_verbose(verbose, "Keyblob #2: %lu bytes:'", key_blob_size);
+	if (verbose)
+		util_hexdump_grp(stderr, NULL, &key_blob[key_size], 4,
+				 key_blob_size, 0);
+
+	/* Save ID and label of 2nd key */
+	rc = properties_set(key_props, PROP_NAME_KMS_XTS_KEY2_ID, key2_id);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to set key id of key #2: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	rc = properties_set(key_props, PROP_NAME_KMS_XTS_KEY2_LABEL,
+			    key2_label);
+	if (rc != 0) {
+		pr_verbose(verbose, "Failed to set key label of key #2: %s",
+			   strerror(-rc));
+		goto out;
+	}
+
+	/* Cross link key 2 with key 1 */
+	num_kms_props = 0;
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_XTS_KEY2_ID,
+		      key2_id);
+	ADD_KMS_PROPS(kms_props, num_kms_props, KMS_KEY_PROP_XTS_KEY2_LABEL,
+		      key2_label);
+
+	rc = kms_info->funcs->kms_set_key_properties(kms_info->handle, key1_id,
+						     kms_props, num_kms_props);
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to set properties of "
+			   "key #1: %s", strerror(-rc));
+		goto out;
+	}
+
+save_key:
+	rc = write_secure_key(filename, key_blob, xts ? key_size * 2 : key_size,
+			      verbose);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (cipher != NULL)
+		free(cipher);
+	if (iv_mode != NULL)
+		free(iv_mode);
+	if (description != NULL)
+		free(description);
+	if (volumes != NULL)
+		free(volumes);
+	if (vol_type != NULL)
+		free(vol_type);
+	if (sector_size != NULL)
+		free(sector_size);
+	if (sys_volumes != NULL)
+		free(sys_volumes);
+
+	return rc;
+}
+
+/**
+ * Sets (adds/replaces) properties of a key. Already existing properties
+ * with the same property name are replaced, non-existing properties are added.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] key_props       a properties object of the key
+ * @param[in] name            the name of the key in zkey (can be NULL)
+ * @param[in] description     the description of the key (can be NULL)
+ * @param[in] volumes         the volumes of the key (can be NULL)
+ * @param[in] vol_type        the volume type of the key (can be NULL)
+ * @param[in] sector_size     the sector_size of the key (can be NULL)
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+
+int set_kms_key_properties(struct kms_info *kms_info,
+			   struct properties *key_props,
+			   const char *name, const char *description,
+			   const char *volumes, const char *vol_type,
+			   const char *sector_size, bool verbose)
+{
+	char *key1_id = NULL, *key2_id = NULL;
+	struct kms_property kms_props[10];
+	size_t num_kms_props = 0;
+	char *sys_volumes = NULL;
+	char *sys_name = NULL;
+	bool xts = false;
+
+	int rc = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(key_props != NULL, "Internal error: key_props is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (kms_info->funcs->kms_set_key_properties == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support to "
+			   "set properties");
+		return -ENOTSUP;
+	}
+
+	key1_id = properties_get(key_props, PROP_NAME_KMS_KEY_ID);
+	if (key1_id == NULL) {
+		key1_id = properties_get(key_props, PROP_NAME_KMS_XTS_KEY1_ID);
+		key2_id = properties_get(key_props, PROP_NAME_KMS_XTS_KEY2_ID);
+		if (key1_id == NULL || key2_id == NULL) {
+			pr_verbose(verbose, "Failed to get key-id(s)");
+			rc = -ENOENT;
+			goto out;
+		}
+		xts = true;
+	}
+
+	if (name != NULL) {
+		sys_name = _get_system_specific_prop_name(KMS_KEY_PROP_NAME);
+		if (sys_name == NULL)
+			return -ENOMEM;
+		ADD_KMS_PROPS(kms_props, num_kms_props, sys_name, name);
+	}
+	if (description != NULL)
+		ADD_KMS_PROPS(kms_props, num_kms_props,
+			      KMS_KEY_PROP_DESCRIPTION, description);
+	if (volumes != NULL) {
+		sys_volumes =
+			_get_system_specific_prop_name(KMS_KEY_PROP_VOLUMES);
+		if (sys_volumes == NULL)
+			return -ENOMEM;
+		ADD_KMS_PROPS(kms_props, num_kms_props, sys_volumes,
+			      volumes);
+	}
+	if (vol_type != NULL)
+		ADD_KMS_PROPS(kms_props, num_kms_props,
+			      KMS_KEY_PROP_VOLUME_TYPE, vol_type);
+	if (sector_size != NULL)
+		ADD_KMS_PROPS(kms_props, num_kms_props,
+			      KMS_KEY_PROP_SECTOR_SIZE, sector_size);
+
+	if (num_kms_props == 0)
+		goto out;
+
+	rc = kms_info->funcs->kms_set_key_properties(kms_info->handle, key1_id,
+						     kms_props, num_kms_props);
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to set properties of "
+			   "key '%s': %s", key1_id, strerror(-rc));
+		goto out;
+	}
+
+	if (xts) {
+		rc = kms_info->funcs->kms_set_key_properties(kms_info->handle,
+							     key2_id,
+							     kms_props,
+							     num_kms_props);
+		if (rc != 0) {
+			pr_verbose(verbose, "KMS plugin failed to set "
+				   "properties of key '%s': %s", key2_id,
+				   strerror(-rc));
+			goto out;
+		}
+	}
+
+out:
+	if (sys_name != NULL)
+		free(sys_name);
+	if (sys_volumes != NULL)
+		free(sys_volumes);
+	if (key1_id != NULL)
+		free(key1_id);
+	if (key2_id != NULL)
+		free(key2_id);
+
+	return rc;
+}
+
+/**
+ * Requests the KMS plugin to remove a KMS managed key. Removing a key mean
+ * to change its state, but not remove it.
+ * *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] key_props       a properties object
+ * @param[in] kms_options     an array of KMS options specified, or NULL if no
+ *                            KMS options have been specified
+ * @param[in] num_kms_options the number of options in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int remove_kms_key(struct kms_info *kms_info, struct properties *key_props,
+		   struct kms_option *kms_options, size_t num_kms_options,
+		   bool verbose)
+{
+	char *key1_id = NULL, *key2_id = NULL;
+	bool xts = false;
+
+	int rc = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(key_props != NULL, "Internal error: key_props is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (kms_info->funcs->kms_remove_key == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support to "
+			   "remove keys");
+		return -ENOTSUP;
+	}
+
+	key1_id = properties_get(key_props, PROP_NAME_KMS_KEY_ID);
+	if (key1_id == NULL) {
+		key1_id = properties_get(key_props, PROP_NAME_KMS_XTS_KEY1_ID);
+		key2_id = properties_get(key_props, PROP_NAME_KMS_XTS_KEY2_ID);
+		if (key1_id == NULL || key2_id == NULL) {
+			pr_verbose(verbose, "Failed to get key-id(s)");
+			rc = -ENOENT;
+			goto out;
+		}
+		xts = true;
+	}
+
+	rc = kms_info->funcs->kms_remove_key(kms_info->handle, key1_id,
+					     kms_options, num_kms_options);
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to remove key '%s': %s",
+			   key1_id, strerror(-rc));
+		goto out;
+	}
+
+	if (xts) {
+		rc = kms_info->funcs->kms_remove_key(kms_info->handle,
+						     key2_id,
+						     kms_options,
+						     num_kms_options);
+		if (rc != 0) {
+			pr_verbose(verbose, "KMS plugin failed to remove key "
+				   "'%s': %s", key2_id, strerror(-rc));
+			goto out;
+		}
+	}
+
+out:
+	if (key1_id != NULL)
+		free(key1_id);
+	if (key2_id != NULL)
+		free(key2_id);
+
+	return rc;
+}
+
+struct process_keys_data {
+	struct kms_info *kms_info;
+	bool verbose;
+	const char *label_filter;
+	const char *name_filter;
+	char **volume_filter;
+	char *volume_type;
+	char *zkey_name_system;
+	char *volume_system;
+	kms_process_callback callback;
+	void *private_data;
+};
+
+/**
+ * Finds a KMS property in the property array and returns its value or NULL if
+ * it has not been found.
+ *
+ * @param properties        a list of properties of the key
+ * @param num_properties    the number of properties in above array
+ * @param prop_name         the name of the property to get
+ *
+ * @returns the properties value, or NULL if not found.
+ * Note: The returned string is the value field from the array element.
+ */
+static const char *_find_property(const struct kms_property *properties,
+				  size_t num_properties, const char *prop_name)
+{
+	size_t i;
+
+	for (i = 0; i < num_properties; i++) {
+		if (strcmp(properties[i].name, prop_name) == 0)
+			return properties[i].value;
+	}
+	return NULL;
+}
+
+/*
+ * Checks if the value matches the filter list. The value is a comma
+ * separated string.
+ *
+ * If the filter values contain a second part separated by a colon (':'), then
+ * the filter matches only if both parts match. If the filter values do not
+ * contain a second part,then only the first part is checked, and the second
+ * parts of the values are ignored.
+ *
+ * @param[in] value     the value to check
+ * @param[in] filter_list a list of filter strings to match the value with
+ * @param[in] match_func the filter match function. If NULL fnmatch() is used.
+ *
+ * @returns 1 for a match, 0 for not matched
+ */
+static int _match_volumes_filter(const char *volumes, char **volumes_filter)
+{
+	char **value_list;
+	int i, k, rc = 0;
+	char *ch;
+
+	if (volumes_filter == NULL)
+		return 1;
+
+	value_list = str_list_split(volumes);
+	for (i = 0; volumes_filter[i] != NULL && rc == 0; i++) {
+		for (k = 0; value_list[k] != NULL; k++) {
+			/*
+			 * Ignore part after ':' of value if filter does
+			 * not also contain a ':' part.
+			 */
+			if (strchr(volumes_filter[i], ':') == NULL) {
+				ch = strchr(value_list[k], ':');
+				if (ch != NULL)
+					*ch = '\0';
+			}
+
+			if (fnmatch(volumes_filter[i], value_list[k], 0) == 0) {
+				rc = 1;
+				break;
+			}
+		}
+	}
+
+	str_list_free_string_array(value_list);
+	return rc;
+}
+
+/**
+ * Callback used with the process_kms_keys() function. Called for each key.
+ *
+ * @param key_id            the key-ID of the key
+ * @param key_label         the label of the key.
+ * @param key_type          the type of the key (CCA-AESDATA, etc)
+ * @param key_bits          the key size in bits
+ * @param properties        a list of properties of the key
+ * @param num_properties    the number of properties in above array
+ * @param addl_info_argz    an argz string containing additional KMS plugin
+ *                          specific infos to be displayed, or NULL if none.
+ * @param addl_info_len     length of the argz string in addl_info_argz
+ * @param private_data      the private data pointer
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _process_kms_keys_cb(const char *key_id, const char *key_label,
+				const char *key_type, size_t key_bits,
+				const struct kms_property *properties,
+				size_t num_properties,
+				const char *addl_info_argz,
+				size_t addl_info_len, void *private_data)
+{
+	struct process_keys_data *process_data = private_data;
+	const char *name, *volumes, *cipher, *iv_mode, *description;
+	const char *xts_key2_id = NULL, *xts_key2_label = NULL;
+	const char *xts_key, *volume_type, *temp;
+	size_t sector_size = 0;
+	bool xts = false;
+
+	pr_verbose(process_data->verbose, "processing key_id: %s", key_id);
+
+	xts_key = _find_property(properties, num_properties,
+				 KMS_KEY_PROP_XTS_KEY);
+	if (xts_key != NULL) {
+		if (strcasecmp(xts_key, "XTS-KEY-1") != 0) {
+			pr_verbose(process_data->verbose,
+				   "skipping '%s' due to %s=%s", key_id,
+				   KMS_KEY_PROP_XTS_KEY, xts_key);
+			return 0;
+		}
+		xts = true;
+
+		xts_key2_id = _find_property(properties, num_properties,
+					      KMS_KEY_PROP_XTS_KEY2_ID);
+		xts_key2_label = _find_property(properties, num_properties,
+						KMS_KEY_PROP_XTS_KEY2_LABEL);
+		if (xts_key2_id == NULL || xts_key2_label == NULL) {
+			pr_verbose(process_data->verbose, "skipping '%s' due "
+				   "to missing XTS cross refs", key_id);
+			return 0;
+		}
+	}
+
+	name = _find_property(properties, num_properties,
+				   process_data->zkey_name_system);
+	if (name == NULL)
+		name = _find_property(properties, num_properties,
+					   KMS_KEY_PROP_NAME);
+	if (name == NULL) {
+		pr_verbose(process_data->verbose, "skipping '%s' due "
+			   "to missing %s", key_id, KMS_KEY_PROP_NAME);
+		return 0;
+	}
+
+	cipher = _find_property(properties, num_properties,
+				KMS_KEY_PROP_CIPHER);
+	iv_mode = _find_property(properties, num_properties,
+				 KMS_KEY_PROP_IV_MODE);
+	description = _find_property(properties, num_properties,
+				     KMS_KEY_PROP_DESCRIPTION);
+	volumes = _find_property(properties, num_properties,
+				 process_data->volume_system);
+	if (volumes == NULL)
+		volumes = _find_property(properties, num_properties,
+					 KMS_KEY_PROP_VOLUMES);
+	volume_type = _find_property(properties, num_properties,
+				     KMS_KEY_PROP_VOLUME_TYPE);
+	temp = _find_property(properties, num_properties,
+				     KMS_KEY_PROP_SECTOR_SIZE);
+	if (temp != NULL)
+		sscanf(temp, "%lu", &sector_size);
+
+	if (process_data->label_filter != NULL) {
+		if (fnmatch(process_data->label_filter, key_label,
+			    FNM_PATHNAME) != 0)
+			return 0;
+
+		if (xts && fnmatch(process_data->label_filter, xts_key2_label,
+				   FNM_PATHNAME) != 0)
+			return 0;
+	}
+
+	if (process_data->name_filter != NULL &&
+	    fnmatch(process_data->name_filter, name, FNM_PATHNAME) != 0)
+		return 0;
+
+	if (process_data->volume_filter != NULL) {
+		if (volumes == NULL)
+			return 0;
+
+		if (!_match_volumes_filter(volumes,
+					   process_data->volume_filter))
+			return 0;
+	}
+
+	if (process_data->volume_type != NULL &&
+	    strcasecmp(process_data->volume_type, volume_type) != 0)
+		return 0;
+
+	return process_data->callback(key_id, key_label, xts_key2_id,
+				      xts_key2_label, xts, name, key_type,
+				      xts ? key_bits * 2 : key_bits,
+				      description, cipher, iv_mode,
+				      volumes, volume_type, sector_size,
+				      addl_info_argz, addl_info_len,
+				      process_data->private_data);
+}
+
+/**
+ * Processes KMS managed keys. The keys can be filtered by label, name, volume,
+ * and volume type.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] label_filter    the KMS label filter. Can contain wild cards.
+ *                            NULL means no name filter.
+ * @param[in] name_filter     the name filter. Can contain wild cards.
+ *                            NULL means no name filter.
+ * @param[in] volume_filter   the volume filter. Can contain wild cards, and
+ *                            mutliple volume filters separated by commas.
+ *                            If the filter does not contain the ':dm-name'
+ *                            part, then the volumes are matched without the
+ *                            dm-name part. If the filter contains the
+ *                            ':dm-name' part, then the filter is matched
+ *                            including the dm-name part.
+ *                            NULL means no volume filter.
+ * @param[in] volume_type     If not NULL, specifies the volume type.
+ * @param[in] callback        the callback that is called for each matching key
+ * @param[in] private_data    the private data of the callback
+ * @param[in] kms_options     an array of KMS options specified, or NULL if no
+ *                            KMS options have been specified
+ * @param[in] num_kms_options the number of options in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int process_kms_keys(struct kms_info *kms_info,
+		     const char *label_filter, const char *name_filter,
+		     const char *volume_filter, const char *volume_type,
+		     struct kms_option *kms_options,  size_t num_kms_options,
+		     kms_process_callback callback, void *private_data,
+		     bool verbose)
+{
+	struct process_keys_data process_data = { 0 };
+	struct kms_property kms_props;
+	size_t num_kms_props = 0;
+	int rc = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(callback != NULL, "Internal error: callback is NULL");
+
+	if (kms_info->funcs->kms_list_keys == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support to "
+			   "list keys");
+		return -ENOTSUP;
+	}
+
+	process_data.kms_info = kms_info;
+	process_data.verbose = verbose;
+	process_data.label_filter = label_filter;
+	process_data.name_filter = name_filter;
+	if (volume_filter != NULL)
+		process_data.volume_filter = str_list_split(volume_filter);
+	if (volume_type != NULL) {
+		process_data.volume_type = util_strdup(volume_type);
+		util_str_toupper(process_data.volume_type);
+	}
+	process_data.callback = callback;
+	process_data.private_data = private_data;
+	process_data.zkey_name_system =
+			_get_system_specific_prop_name(KMS_KEY_PROP_NAME);
+	process_data.volume_system =
+			_get_system_specific_prop_name(KMS_KEY_PROP_VOLUMES);
+
+	if (process_data.volume_type != NULL) {
+		kms_props.name = KMS_KEY_PROP_VOLUME_TYPE;
+		kms_props.value = process_data.volume_type;
+		num_kms_props = 1;
+	}
+
+	rc = kms_info->funcs->kms_list_keys(kms_info->handle, label_filter,
+					    num_kms_props > 0 ?
+						&kms_props : NULL,
+					    num_kms_props, kms_options,
+					    num_kms_options,
+					    _process_kms_keys_cb,
+					    &process_data);
+
+	if (rc != 0) {
+		warnx("KMS plugin '%s' failed to list keys: %s",
+		      kms_info->plugin_name, strerror(-rc));
+		print_last_kms_error(kms_info);
+	}
+
+	free(process_data.zkey_name_system);
+	free(process_data.volume_system);
+	if (process_data.volume_filter != NULL)
+		str_list_free_string_array(process_data.volume_filter);
+	if (process_data.volume_type != NULL)
+		free(process_data.volume_type);
+
+	return rc;
+}
+
+struct list_keys_data {
+	struct util_rec *rec;
+};
+
+/**
+ * Callback used with the list_kms_keys() function. Called for each key.
+ *
+ * @param key1_id           the key-ID of the key (1st key of an XTS key)
+ * @param key1_label        the label of the key (1st key of an XTS key)
+ * @param key2_id           the key-ID of the 2nd XTS key, NULL if not XTS
+ * @param key2_label        the label of the 2nd XTS key, NULL if not XTS
+ * @param xts               if true, this is an XTS key pair
+ * @param name              the zkey name of the key
+ * @param key_type          the type of the key (CCA-AESDATA, etc)
+ * @param key_bits          the key size in bits
+ * @param description       the description of the key (can be NULL)
+ * @param cipher            the cipher of the key (can be NULL)
+ * @param iv_mode           the IV-mode of the key (can be NULL)
+ * @param volumes           the associated volumes of the key (can be NULL)
+ * @param volume_type       the volume type of the volume (can be NULL)
+ * @param sector_size       the sector size of the volume (0 means default)
+ * @param addl_info_argz    an argz string containing additional KMS plugin
+ *                          specific infos to be displayed, or NULL if none.
+ * @param addl_info_len     length of the argz string in addl_info_argz
+ * @param private_data      the private data pointer
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+static int _list_kms_keys_cb(const char *UNUSED(key1_id),
+			     const char *key1_label,
+			     const char *UNUSED(key2_id),
+			     const char *key2_label,
+			     bool xts, const char *name,
+			     const char *key_type, size_t key_bits,
+			     const char *description,
+			     const char *UNUSED(cipher),
+			     const char *UNUSED(iv_mode), const char *volumes,
+			     const char *volume_type, size_t sector_size,
+			     const char *addl_info_argz, size_t addl_info_len,
+			     void *private_data)
+{
+	struct list_keys_data *list_data = private_data;
+	size_t volumes_argz_len, label_argz_len;
+	char *volumes_argz = NULL;
+	char *label_argz = NULL;
+
+	if (xts)
+		label_argz_len = util_asprintf(&label_argz, "%s%c%s",
+					       key1_label, '\0', key2_label);
+	else
+		label_argz_len = util_asprintf(&label_argz, "%s", key1_label);
+	label_argz_len += 1;
+
+	if (volumes != NULL)
+		util_assert(argz_create_sep(volumes, ',',
+					    &volumes_argz,
+					    &volumes_argz_len) == 0,
+			    "Internal error: argz_create_sep failed");
+
+	util_rec_set(list_data->rec, KMS_REC_NAME, name);
+	util_rec_set_argz(list_data->rec, KMS_REC_LABEL, label_argz,
+			  label_argz_len);
+	util_rec_set(list_data->rec, KMS_REC_DESCRIPTION,
+		     description != NULL ? description : "");
+	util_rec_set(list_data->rec, KMS_REC_XTS, xts ? "Yes" : "No");
+	util_rec_set(list_data->rec, KMS_REC_KEY_TYPE, key_type);
+	util_rec_set(list_data->rec, KMS_REC_KEY_SIZE, "%lu bits", key_bits);
+	if (volumes_argz != NULL)
+		util_rec_set_argz(list_data->rec, KMS_REC_VOLUMES, volumes_argz,
+				  volumes_argz_len);
+	else
+		util_rec_set(list_data->rec, KMS_REC_VOLUMES, "(none)");
+	util_rec_set(list_data->rec, KMS_REC_VOLUME_TYPE,
+		     volume_type != NULL ? volume_type : "");
+	if (sector_size == 0)
+		util_rec_set(list_data->rec, KMS_REC_SECTOR_SIZE,
+			     "(system default)");
+	else
+		util_rec_set(list_data->rec, KMS_REC_SECTOR_SIZE, "%lu bytes",
+			     sector_size);
+	if (addl_info_argz != NULL)
+		util_rec_set_argz(list_data->rec, KMS_REC_ADDL_INFOS,
+				  addl_info_argz, addl_info_len);
+	else
+		util_rec_set(list_data->rec, KMS_REC_ADDL_INFOS, "(none)");
+
+	util_rec_print(list_data->rec);
+
+	if (volumes_argz != NULL)
+		free(volumes_argz);
+	if (label_argz != NULL)
+		free(label_argz);
+
+	return 0;
+}
+
+/**
+ * Lists KMS managed keys. The list can be filtered by label, name, volume,
+ * and volume type.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] label_filter    the KMS label filter. Can contain wild cards.
+ *                            NULL means no name filter.
+ * @param[in] name_filter     the name filter. Can contain wild cards.
+ *                            NULL means no name filter.
+ * @param[in] volume_filter   the volume filter. Can contain wild cards, and
+ *                            mutliple volume filters separated by commas.
+ *                            If the filter does not contain the ':dm-name'
+ *                            part, then the volumes are matched without the
+ *                            dm-name part. If the filter contains the
+ *                            ':dm-name' part, then the filter is matched
+ *                            including the dm-name part.
+ *                            NULL means no volume filter.
+ * @param[in] volume_type     If not NULL, specifies the volume type.
+ * @param[in] kms_options     an array of KMS options specified, or NULL if no
+ *                            KMS options have been specified
+ * @param[in] num_kms_options the number of options in above array
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int list_kms_keys(struct kms_info *kms_info, const char *label_filter,
+		  const char *name_filter, const char *volume_filter,
+		  const char *volume_type, struct kms_option *kms_options,
+		  size_t num_kms_options, bool verbose)
+{
+	struct list_keys_data list_data = { 0 };
+	int rc;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (kms_info->funcs->kms_list_keys == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support to "
+			   "list keys");
+		return -ENOTSUP;
+	}
+
+	list_data.rec = util_rec_new_long("-", ":", KMS_REC_NAME, 28, 54);
+	util_rec_def(list_data.rec, KMS_REC_NAME, UTIL_REC_ALIGN_LEFT, 54,
+		     KMS_REC_NAME);
+	util_rec_def(list_data.rec, KMS_REC_LABEL, UTIL_REC_ALIGN_LEFT, 54,
+		     KMS_REC_LABEL);
+	util_rec_def(list_data.rec, KMS_REC_DESCRIPTION, UTIL_REC_ALIGN_LEFT,
+		     54, KMS_REC_DESCRIPTION);
+	util_rec_def(list_data.rec, KMS_REC_KEY_SIZE, UTIL_REC_ALIGN_LEFT, 20,
+		     KMS_REC_KEY_SIZE);
+	util_rec_def(list_data.rec, KMS_REC_XTS, UTIL_REC_ALIGN_LEFT, 20,
+		     KMS_REC_XTS);
+	util_rec_def(list_data.rec, KMS_REC_KEY_TYPE, UTIL_REC_ALIGN_LEFT, 54,
+		     KMS_REC_KEY_TYPE);
+	util_rec_def(list_data.rec, KMS_REC_VOLUMES, UTIL_REC_ALIGN_LEFT, 54,
+		     KMS_REC_VOLUMES);
+	util_rec_def(list_data.rec, KMS_REC_VOLUME_TYPE, UTIL_REC_ALIGN_LEFT,
+		     54, KMS_REC_VOLUME_TYPE);
+	util_rec_def(list_data.rec, KMS_REC_SECTOR_SIZE, UTIL_REC_ALIGN_LEFT,
+		     20, KMS_REC_SECTOR_SIZE);
+	util_rec_def(list_data.rec, KMS_REC_ADDL_INFOS, UTIL_REC_ALIGN_LEFT,
+		     54, KMS_REC_ADDL_INFOS);
+
+	rc = process_kms_keys(kms_info, label_filter, name_filter,
+			       volume_filter, volume_type, kms_options,
+			       num_kms_options, _list_kms_keys_cb,
+			       &list_data, verbose);
+
+	util_rec_free(list_data.rec);
+
+	return rc;
+}
+
+/**
+ * Imports a KMS managed key.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] key1_id         the id of the key to import (1st key for XTS)
+ * @param[in] key2_id         the id of the 2nd XTS key to import (NULL if not
+ *                            XTS)
+ * @param[in] xts             if true, an XTS key is to be imported
+ * @param[in] name            the zkey-name under which the key is imported
+ * @param[in] key_blob        a buffer to return the key blob. The size of the
+ *                            buffer is specified in key_blob_length
+ * @param[out] key_blob_length  on entry: the size of the key_blob buffer.
+ *                              on exit: the size of the key blob returned.
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int import_kms_key(struct kms_info *kms_info, const char *key1_id,
+		   const char *key2_id, bool xts, const char *name,
+		   unsigned char *key_blob, size_t *key_blob_length,
+		   bool verbose)
+{
+	size_t key_blob_size, key_blob_ofs, key_size = 0;
+	struct kms_property kms_prop;
+	char *sys_name = NULL;
+	int rc = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+	util_assert(key1_id != NULL, "Internal error: key1_id is NULL");
+	util_assert(xts == false ||  key2_id != NULL,
+		    "Internal error: key2_id is NULL");
+	util_assert(key_blob != NULL, "Internal error: key_blob is NULL");
+	util_assert(key_blob_length != NULL,
+		    "Internal error: key_blob_length is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (kms_info->funcs->kms_import_key == NULL ||
+	    kms_info->funcs->kms_set_key_properties == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support to "
+			   "import keys");
+		return -ENOTSUP;
+	}
+
+	sys_name = _get_system_specific_prop_name(KMS_KEY_PROP_NAME);
+	if (sys_name == NULL)
+		return -ENOMEM;
+
+	key_blob_size = *key_blob_length;
+	memset(key_blob, 0, key_blob_size);
+
+	rc = kms_info->funcs->kms_import_key(kms_info->handle, key1_id,
+					     key_blob, &key_blob_size);
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to import key '%s': %s",
+			   key1_id, strerror(-rc));
+		goto out;
+	}
+
+	if (is_cca_aes_data_key(key_blob, key_blob_size))
+		key_size =  AESDATA_KEY_SIZE;
+	else if (is_cca_aes_cipher_key(key_blob, key_blob_size))
+		key_size =  AESCIPHER_KEY_SIZE;
+	else if (is_ep11_aes_key(key_blob, key_blob_size))
+		key_size =  EP11_KEY_SIZE;
+
+	if (key_size == 0 || key_blob_size > key_size) {
+		pr_verbose(verbose, "Key '%s' has an unknown or unsupported "
+			   "key type", key1_id);
+		rc = -EIO;
+		goto out;
+	}
+
+	key_blob_ofs = key_size;
+
+	if (xts) {
+		key_blob_size = key_size;
+		rc = kms_info->funcs->kms_import_key(kms_info->handle, key2_id,
+						     key_blob + key_blob_ofs,
+						     &key_blob_size);
+		if (rc != 0) {
+			pr_verbose(verbose, "KMS plugin failed to import key #2"
+				   "'%s': %s", key2_id, strerror(-rc));
+			goto out;
+		}
+
+		key_blob_ofs += key_size;
+	}
+
+	*key_blob_length = key_blob_ofs;
+
+	kms_prop.name = sys_name;
+	kms_prop.value = name;
+
+	rc = kms_info->funcs->kms_set_key_properties(kms_info->handle, key1_id,
+						     &kms_prop, 1);
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to set properties of "
+			   "key '%s': %s", key1_id, strerror(-rc));
+		goto out;
+	}
+
+	if (xts) {
+		rc = kms_info->funcs->kms_set_key_properties(kms_info->handle,
+							     key2_id,
+							     &kms_prop, 1);
+		if (rc != 0) {
+			pr_verbose(verbose, "KMS plugin failed to set "
+				   "properties of key #2 '%s': %s", key1_id,
+				   strerror(-rc));
+			goto out;
+		}
+	}
+
+out:
+	if (sys_name != NULL)
+		free(sys_name);
+	if (rc != 0)
+		*key_blob_length = 0;
+
+	return rc;
+}
+
+/**
+ * Refreshes KMS managed keys.
+ *
+ * @param[in] kms_info        information of the currently bound plugin.
+ * @param[in] key_props       the key properties
+ * @param[out] description    on return: the description property
+ * @param[out] cipher         on return: the cipher property
+ * @param[out] iv_mode        on return: the iv_mode property
+ * @param[out] volumes        on return: the volumes property
+ * @param[out] volume_type    on return: the volume_type property
+ * @param[out] sector_size    on return: the sector_size property
+ * @param[in] filename        the file name to store the refreshed key blob in
+ * @param[in] verbose         if true, verbose messages are printed
+ *
+ * @returns 0 for success or a negative errno in case of an error.
+ */
+int refresh_kms_key(struct kms_info *kms_info, struct properties *key_props,
+		    char **description, char **cipher, char **iv_mode,
+		    char **volumes, char **volume_type, ssize_t *sector_size,
+		    const char *filename, bool verbose)
+{
+	struct kms_property *properties = NULL;
+	u8 key_blob[2 * MAX_SECURE_KEY_SIZE];
+	char *key1_id = NULL, *key2_id = NULL;
+	size_t key_blob_size, key_size = 0;
+	char vp[VERIFICATION_PATTERN_LEN];
+	size_t i, num_properties = 0;
+	char *sys_volumes = NULL;
+	char *orig_vp = NULL;
+	bool xts = false;
+	const char *str;
+	int rc = 0;
+
+	util_assert(kms_info != NULL, "Internal error: kms_info is NULL");
+
+	if (kms_info->plugin_lib == NULL) {
+		warnx("The repository is not bound to a KMS plugin");
+		return -ENOENT;
+	}
+
+	if (kms_info->funcs->kms_import_key == NULL ||
+	    kms_info->funcs->kms_get_key_properties == NULL) {
+		pr_verbose(verbose, "The KMS plugin does not support to "
+			   "import keys or get properties");
+		return -ENOTSUP;
+	}
+
+	key1_id = properties_get(key_props, PROP_NAME_KMS_KEY_ID);
+	if (key1_id == NULL) {
+		key1_id = properties_get(key_props, PROP_NAME_KMS_XTS_KEY1_ID);
+		key2_id = properties_get(key_props, PROP_NAME_KMS_XTS_KEY2_ID);
+		if (key1_id == NULL || key2_id == NULL) {
+			pr_verbose(verbose, "Failed to get key-id(s)");
+			rc = -ENOENT;
+			goto out;
+		}
+		xts = true;
+	}
+
+	rc = kms_info->funcs->kms_get_key_properties(kms_info->handle, key1_id,
+						     &properties,
+						     &num_properties);
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to get attributes of "
+			   "key '%s': %s", key1_id, strerror(-rc));
+		goto out;
+	}
+
+	sys_volumes = _get_system_specific_prop_name(KMS_KEY_PROP_VOLUMES);
+	if (sys_volumes == NULL)
+		return -ENOMEM;
+
+	if (description != NULL) {
+		str = _find_property(properties, num_properties,
+				     KMS_KEY_PROP_DESCRIPTION);
+		*description = (str != NULL) ? util_strdup(str) : NULL;
+	}
+
+	if (cipher != NULL) {
+		str = _find_property(properties, num_properties,
+				     KMS_KEY_PROP_CIPHER);
+		*cipher = (str != NULL) ? util_strdup(str) : NULL;
+	}
+
+	if (iv_mode != NULL) {
+		str = _find_property(properties, num_properties,
+				     KMS_KEY_PROP_IV_MODE);
+		*iv_mode = (str != NULL) ? util_strdup(str) : NULL;
+	}
+
+	if (volumes != NULL) {
+		str = _find_property(properties, num_properties,
+				     sys_volumes);
+		if (str == NULL)
+			str = _find_property(properties, num_properties,
+					     KMS_KEY_PROP_VOLUMES);
+		*volumes = (str != NULL) ? util_strdup(str) : NULL;
+	}
+
+	if (volume_type != NULL) {
+		str = _find_property(properties, num_properties,
+				     KMS_KEY_PROP_VOLUME_TYPE);
+		*volume_type = (str != NULL) ? util_strdup(str) : NULL;
+	}
+
+	if (sector_size != NULL) {
+		*sector_size = -1;
+		str = _find_property(properties, num_properties,
+				     KMS_KEY_PROP_SECTOR_SIZE);
+		if (str != NULL)
+			sscanf(str, "%lu", (long unsigned int *)sector_size);
+	}
+
+	key_blob_size = sizeof(key_blob);
+	memset(key_blob, 0, key_blob_size);
+
+	rc = kms_info->funcs->kms_import_key(kms_info->handle, key1_id,
+					     key_blob, &key_blob_size);
+	if (rc != 0) {
+		pr_verbose(verbose, "KMS plugin failed to import key '%s': %s",
+			   key1_id, strerror(-rc));
+		goto out;
+	}
+
+	if (is_cca_aes_data_key(key_blob, key_blob_size))
+		key_size =  AESDATA_KEY_SIZE;
+	else if (is_cca_aes_cipher_key(key_blob, key_blob_size))
+		key_size =  AESCIPHER_KEY_SIZE;
+	else if (is_ep11_aes_key(key_blob, key_blob_size))
+		key_size =  EP11_KEY_SIZE;
+
+	if (key_size == 0 || key_blob_size > key_size) {
+		pr_verbose(verbose, "Key '%s' has an unknown or unsupported "
+			   "key type", key1_id);
+		rc = -EIO;
+		goto out;
+	}
+
+	if (xts) {
+		key_blob_size = key_size;
+		rc = kms_info->funcs->kms_import_key(kms_info->handle, key2_id,
+						     key_blob + key_size,
+						     &key_blob_size);
+		if (rc != 0) {
+			pr_verbose(verbose, "KMS plugin failed to import key #2"
+				   "'%s': %s", key2_id, strerror(-rc));
+			goto out;
+		}
+	}
+
+	key_blob_size = xts ? key_size * 2 : key_size;
+
+	orig_vp = properties_get(key_props, PROP_NAME_KEY_VP);
+	if (orig_vp != NULL) {
+		rc = generate_key_verification_pattern(key_blob, key_blob_size,
+						       vp, sizeof(vp), verbose);
+		if (rc != 0) {
+			warnx("Failed to generate the verification pattern: %s",
+			      strerror(-rc));
+			warnx("Make sure that kernel module 'paes_s390' is "
+			      "loaded and that the 'paes' cipher is available");
+			goto out;
+		}
+
+		if (strcmp(vp, orig_vp) != 0) {
+			warnx("The key verification pattern of the refreshed "
+			      "secure key does not match the current one.");
+			rc = -EIO;
+			goto out;
+		}
+	}
+
+	rc = write_secure_key(filename, key_blob, key_blob_size, verbose);
+	if (rc != 0)
+		goto out;
+
+out:
+	if (key1_id != NULL)
+		free(key1_id);
+	if (key2_id != NULL)
+		free(key2_id);
+	if (sys_volumes != NULL)
+		free(sys_volumes);
+	if (orig_vp != NULL)
+		free(orig_vp);
+	if (properties != NULL) {
+		for (i = 0; i < num_properties; i++) {
+			free((void *)properties[i].name);
+			free((void *)properties[i].value);
+		}
+		free(properties);
+	}
+
+	return rc;
+}
diff -pruN 2.14.0-2/zkey/kms.h 2.15.1-0ubuntu2/zkey/kms.h
--- 2.14.0-2/zkey/kms.h	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/kms.h	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,123 @@
+/*
+ * zkey - Generate, re-encipher, and validate secure keys
+ *
+ * This header file defines functions for Key Management System (KMS) plugin
+ * handling
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+
+#ifndef KMS_H
+#define KMS_H
+
+#include "kms-plugin.h"
+#include "properties.h"
+#include "keystore.h"
+
+struct kms_info {
+	void *plugin_lib;
+	const struct kms_functions *funcs;
+	char *plugin_name;
+	struct properties *props;
+	struct kms_apqn *apqns;
+	size_t num_apqns;
+	kms_handle_t handle;
+};
+
+struct keystore;
+
+int list_kms_plugins(bool verbose);
+
+int check_for_kms_plugin(struct kms_info *kms_info, bool verbose);
+
+int init_kms_plugin(struct kms_info *kms_info, bool verbose);
+
+void free_kms_plugin(struct kms_info *kms_info);
+
+void print_last_kms_error(const struct kms_info *kms_info);
+
+int bind_kms_plugin(struct keystore *keystore, const char *plugin,
+		    bool verbose);
+
+int unbind_kms_plugin(struct kms_info *kms_info, struct keystore *keystore,
+		      bool verbose);
+
+int print_kms_info(struct kms_info *kms_info);
+
+int get_kms_options(struct kms_info *kms_info, struct util_opt *opt_vec,
+		    const char *placeholder_cmd, const char *plugin_command,
+		    const char *opt_vec_command, int *first_plugin_opt,
+		    bool verbose);
+
+int handle_kms_option(struct kms_info *kms_info, struct util_opt *opt_vec,
+		      int first_kms_option, const char *command, int option,
+		      const char *optarg, struct kms_option **kms_options,
+		      size_t *num_kms_options, bool verbose);
+
+int configure_kms_plugin(struct keystore *keystore, const char *apqns,
+			 struct kms_option *kms_options, size_t num_kms_options,
+			 bool has_plugin_optins, bool verbose);
+
+int reencipher_kms(struct kms_info *kms_info, bool from_old, bool to_new,
+		   bool inplace, bool staged, bool complete,
+		   struct kms_option *kms_options, size_t num_kms_options,
+		   bool verbose);
+
+int perform_kms_login(struct kms_info *kms_info, bool verbose);
+
+int get_kms_apqns_for_key_type(struct kms_info *kms_info, const char *key_type,
+			       bool cross_check, char **apqns, bool verbose);
+
+int generate_kms_key(struct kms_info *kms_info, const char *name,
+		     const char *key_type, struct properties *key_props,
+		     bool xts, size_t keybits, const char *filename,
+		     struct kms_option *kms_options, size_t num_kms_options,
+		     bool verbose);
+
+int set_kms_key_properties(struct kms_info *kms_info,
+			   struct properties *key_props,
+			   const char *name, const char *description,
+			   const char *volumes, const char *vol_type,
+			   const char *sector_size, bool verbose);
+
+int remove_kms_key(struct kms_info *kms_info, struct properties *key_props,
+		   struct kms_option *kms_options, size_t num_kms_options,
+		   bool verbose);
+
+typedef int (*kms_process_callback)(const char *key1_id, const char *key1_label,
+				    const char *key2_id, const char *key2_label,
+				    bool xts, const char *name,
+				    const char *key_type, size_t key_bits,
+				    const char *description, const char *cipher,
+				    const char *iv_mode, const char *volumes,
+				    const char *volume_type, size_t sector_size,
+				    const char *addl_info_argz,
+				    size_t addl_info_len,
+				    void *private_data);
+
+int process_kms_keys(struct kms_info *kms_info,
+		     const char *label_filter, const char *name_filter,
+		     const char *volume_filter, const char *volume_type,
+		     struct kms_option *kms_options,  size_t num_kms_options,
+		     kms_process_callback callback, void *private_data,
+		     bool verbose);
+
+int list_kms_keys(struct kms_info *kms_info, const char *label_filter,
+		  const char *name_filter, const char *volume_filter,
+		  const char *volume_type, struct kms_option *kms_options,
+		  size_t num_kms_options, bool verbose);
+
+int import_kms_key(struct kms_info *kms_info, const char *key1_id,
+		   const char *key2_id, bool xts, const char *name,
+		   unsigned char *key_blob, size_t *key_blob_length,
+		   bool verbose);
+
+int refresh_kms_key(struct kms_info *kms_info, struct properties *key_props,
+		    char **description, char **cipher, char **iv_mode,
+		    char **volumes, char **volume_type, ssize_t *sector_size,
+		    const char *filename, bool verbose);
+
+#endif
diff -pruN 2.14.0-2/zkey/kms-plugin.h 2.15.1-0ubuntu2/zkey/kms-plugin.h
--- 2.14.0-2/zkey/kms-plugin.h	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/kms-plugin.h	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,539 @@
+/*
+ * zkey - Generate, re-encipher, and validate secure keys
+ *
+ * This header file defines the interface to a Key Management System (KMS)
+ * Plugin.
+ *
+ * Copyright IBM Corp. 2020
+ *
+ * s390-tools is free software; you can redistribute it and/or modify
+ * it under the terms of the MIT license. See LICENSE for details.
+ */
+
+#ifndef KMS_PLUGIN_H
+#define KMS_PLUGIN_H
+
+#include <stddef.h>
+#include <stdbool.h>
+
+#include "lib/util_opt.h"
+
+/**
+ * Informs a KMS plugin that it is bound to a zkey repository.
+ *
+ * Note: This function is called before kms_initialize()!
+ *
+ * @param config_path       name of a directory where the KMS plugin can store
+ *                          its configuration and other files it needs to store
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+int kms_bind(const char *config_path);
+
+typedef void *kms_handle_t;
+
+/**
+ * Initializes a KMS plugin for usage by zkey. When a repository is bound to a
+ * KMS plugin, zkey calls this function when opening the repository.
+ *
+ * @param config_path       name of a directory where the KMS plugin can store
+ *                          its configuration and other files it needs to store
+ * @param verbose           if true, the plugin should write verbose or debug
+ *                          messages to stderr during further processing.
+ *
+ * @returns a KMS plugin handle, or NULL in case of an error.
+ */
+kms_handle_t kms_initialize(const char *config_path, bool verbose);
+
+/**
+ * Terminates the use of a KMS plugin. When a repository is bound to a KMS
+ * plugin, zkey calls this function when closing the repository.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_terminate(const kms_handle_t handle);
+
+/**
+ * Returns a textual message about the last occurred error that occurred in the
+ * last called KMS plugin function. If no error occurred (i.e. the last plugin
+ * function returned rc = 0), then NULL is returned.
+ * The returned string is static or contained within the handle. It is valid
+ * only until the next KMS plugin function is called.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns an error message of NULL
+ */
+const char *kms_get_last_error(const kms_handle_t handle);
+
+/**
+ * Returns true if the KMS plugin supports the specified key type.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_type          the zkey key type, euch as 'CCA-AESDATA',
+ *                          'CCA-AESCIPHER', 'EP11-AES'.
+ *
+ * @returns true if the KMS plugin supports the key type, false otherwise.
+ */
+bool kms_supports_key_type(const kms_handle_t handle, const char *key_type);
+
+/**
+ * Displays information about the KMS Plugin and its current configuration on
+ * stdout.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_display_info(const kms_handle_t handle);
+
+#define KMS_COMMAND_CONFIGURE		"configure"
+#define KMS_COMMAND_REENCIPHER		"reencipher"
+#define KMS_COMMAND_GENERATE		"generate"
+#define KMS_COMMAND_REMOVE		"remove"
+#define KMS_COMMAND_LIST		"list"
+#define KMS_COMMAND_LIST_IMPORT		"list-import"
+
+/**
+ * Returns a list of KMS specific command line options that zkey should accept
+ * and pass to the appropriate KMS plugin function. The option list must be
+ * terminated by an UTIL_OPT_END entry (see util_opt.h). The options returned
+ * must not interfere with the already defined options of the zkey command.
+ * Field 'command' of the returned options should either be NULL or specify
+ * the command that it is for.
+ *
+ * If max_opts is not -1, then only up to max_opts options are allowed. If more
+ * options are returned, only up to max_opts options are used by zkey.
+ *
+ * @param command           the command for which the KMS-specific options are
+ *                          to be returned, see KMS_COMMAND_xxx defines
+ * @param max_opts          maximum number of options allowed. If -1 then there
+ *                          is no limit.
+ *
+ * @returns a list of options terminated by an UTIL_OPT_END entry, or NULL in
+ * case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+const struct util_opt *kms_get_command_options(const char *command,
+					       int max_opts);
+
+struct kms_apqn {
+	unsigned short card;
+	unsigned short domain;
+};
+
+struct kms_option {
+	int option;		/** option character as in struct option */
+	const char *argument;   /** argument of the option (if any) */
+};
+
+
+/**
+ * Configures (or re-configures) a KMS plugin. This function can be called
+ * several times to configure a KMS plugin is several steps (if supported by the
+ * KMS plugin). In case a configuration is not fully complete, this function
+ * may return -EAGAIN to indicate that it has accepted the configuration so far,
+ * but the configuration needs to be completed.
+ *
+ * No kms_login is performed before calling this function. If the KMS plugin
+ * requires a login for the configuration, it must perform it itself within this
+ * function.
+ *
+ * A KMS plugin must be associated with at least one APQN. Thus, in a multi-step
+ * configuration, a list f APQNs must be specified at least once.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param apqns             a list of APQNs to associate with the KMS plugin, or
+ *                          NULL if no APQNs are specified.
+ * @param num_apqns         number of APQNs in above array. 0 if no APQNs are
+ *                          specified.
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_CONFIGURE.
+ * @param num_options       number of options in above array.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ * -EAGAIN to indicate that the specified configuration was accepted so far, but
+ * the configuration is still incomplete, and needs to be completed.
+ */
+int kms_configure(const kms_handle_t handle,
+		  const struct kms_apqn *apqns, size_t num_apqns,
+		  const struct kms_option *options, size_t num_options);
+
+/**
+ * De-configures a KMS plugin. This is called by zkey when a repository is
+ * unbound from a KMS plugin. It gives the KMS plugin the chance to gracefully
+ * remove any files that the plugin has stored in its config directory. zkey
+ * will unconditionally remove all left over files when this function returns.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_deconfigure(const kms_handle_t handle);
+
+/**
+ * Allows the KMS plugin to perform a login to the KMS (if required). This
+ * function is called at least once before any key operation function, typically
+ * shortly after opening the repository.
+ * The KMS plugin may prompt the user (by reading from stdin) for its
+ * credentials, if needed.
+ *
+ * It is suggested that a KMS plugin performs a login with the KMS once, and
+ * stores a login token (or similar) in its config directory. The next time
+ * the kms_login function is called, the login token can be reused (if still
+ * valid). This avoids to prompt the user for every key operation.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_login(const kms_handle_t handle);
+
+enum kms_reencipher_mode {
+	KMS_REENC_MODE_AUTO = 0,
+	KMS_REENC_MODE_IN_PLACE = 1,
+	KMS_REENC_MODE_STAGED = 2,
+	KMS_REENC_MODE_STAGED_COMPLETE = 3,
+};
+
+enum kms_reenc_mkreg {
+	KMS_REENC_MKREG_AUTO = 0,
+	KMS_REENC_MKREG_FROM_OLD = 1,
+	KMS_REENC_MKREG_TO_NEW = 2,
+	KMS_REENC_MKREG_FROM_OLD_TO_NEW = 3,
+};
+
+/**
+ * Called when the master keys of an APQN associated with the KMS plugin has
+ * been changed. The KMS plugin can then re-encipher all its secure keys (if
+ * any) that it has stored in its config directory.
+ *
+ * Keys that have been generated by the KMS plugin and stored in the zkey
+ * repository do not need to be re-enciphered by the KMS plugin. Those are
+ * re-enciphered by zkey without the help of the KMS plugin.
+ *
+ * HSM have different master key registers. Typically a CURRENT and a NEW master
+ * key register exists. The NEW register may be loaded with the new to be set
+ * master key, and secure keys can be re-enciphered with it proactively.
+ *
+ * CCA also supports an OLD master key register, that contains the previously
+ * used master key. You thus can re-encipher a secure key that is currently
+ * enciphered with the master key from the OLD register with the master key
+ * from the CURRENT register.
+ *
+ * HSMs may also support different master keys for different key types or
+ * algorithms. It is up to the KMS plugin to know which master key registers
+ * are used for its secure keys
+ *
+ * A staged re-encipherment is performed by re-enciphering a secure key with
+ * the new HSM master key, without making it available for use in the first
+ * stage. Only when the staged re-encipherment is completed, then the previously
+ * re-enciphered secure key is make available for use and the old on is removed.
+ *
+ * An in-place re-encipherment replaces the secure key right away with its
+ * re-enciphered version.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param mode              Re-encipherment mode
+ * @param mkreg             Re-encipherment register selection
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_REENCIPHER.
+ * @param num_options       number of options in above array.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_reenciper(const kms_handle_t handle,
+		  enum kms_reencipher_mode mode, enum kms_reenc_mkreg mkreg,
+		  const struct kms_option *options, size_t num_options);
+
+struct kms_property {
+	const char *name;
+	const char *value;
+};
+
+#define KMS_KEY_ID_SIZE		256
+#define KMS_KEY_LABEL_SIZE	256
+
+enum kms_key_mode {
+	KMS_KEY_MODE_NON_XTS = 0,
+	KMS_KEY_MODE_XTS_1 = 1,
+	KMS_KEY_MODE_XTS_2 = 2,
+};
+
+/**
+ * Generates a key in or with the KMS and returns a secure key that is
+ * enciphered under the current HSM master key.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_type          the zkey key type, euch as 'CCA-AESDATA',
+ *                          'CCA-AESCIPHER', 'EP11-AES'.
+ * @param key_bits          the key bit size (e.g. 256 for an AES 256 bit key).
+ *                          0 to use the plugin's default key size.
+ * @param key_mode          mode of the key, e.g. non-XTS key, or first/second
+ *                          XTS key to be generated. A KMS plugin may need to
+ *                          use different key templates for the different key
+ *                          modes (i.e. key parts).
+ * @param properties        a list of properties to associate the key with
+ * @param num_properties    the number of properties in above array
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_GENERATE.
+ * @param num_options       number of options in above array.
+ * @param key_blob          a buffer to return the key blob. The size of the
+ *                          buffer is specified in key_blob_length
+ * @param key_blob_length   on entry: the size of the key_blob buffer.
+ *                          on exit: the size of the key blob returned.
+ * @param key_id            a buffer to return the key-ID of the generated key.
+ *                          The key-id is a textual identifier uniquely
+ *                          identifying a key in the KMS and the KMS plugin.
+ *                          The returned key-id contains the terminating zero.
+ * @paran key_id_size       size of the key_id buffer. It should be at least
+ *                          KMS_KEY_ID_SIZE + 1 bytes large.
+ * @param key_label         a buffer to return the key-label of the generated
+ *                          key. The key-label is a textual identifier used to
+ *                          identify a key in the user interface of the KMS.
+ *                          A key label may be equal to the key-ID, or it may
+ *                          different. The returned key-label contains the
+ *                          terminating zero.
+ * @paran key_label_size    size of the key_lanble buffer. It should be at least
+ *                          KMS_KEY_LABEL_SIZE + 1 bytes large.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_generate_key(const kms_handle_t handle, const char *key_type,
+		     size_t key_bits, enum kms_key_mode key_mode,
+		     const struct kms_property *properties,
+		     size_t num_properties, const struct kms_option *options,
+		     size_t num_options, unsigned char *key_blob,
+		     size_t *key_blob_length, char *key_id,
+		     size_t key_id_size, char *key_label,
+		     size_t key_label_size);
+
+/**
+ * Sets (adds/replaces/removes) properties of a key. Already existing properties
+ * with the same property name are replaced, non-existing properties are added.
+ * To remove a property, set the property value to NULL.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_id            the key-ID to set the properties for
+ * @param properties        a list of properties to set
+ * @param num_properties    the number of properties in above array
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_set_key_properties(const kms_handle_t handle, const char *key_id,
+			   const struct kms_property *properties,
+			   size_t num_properties);
+
+/**
+ * Gets properties of a key.
+ *
+ * The returned list of properties must be freed by the caller. Each property
+ * name and value must be freed individually (using free()), as well as the
+ * complete array.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_id            the key-ID to set the properties for
+ * @param properties        On return: a list of properties
+ * @param num_properties    On return: the number of properties in above array
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_get_key_properties(const kms_handle_t handle, const char *key_id,
+			   struct kms_property **properties,
+			   size_t *num_properties);
+
+/**
+ * Called when zkey removes a KMS-bound key from the zkey repository. The KMS
+ * plugin can then set the state of the key in the KMS, or remove it also from
+ * the KMS (this is usually not done).
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_id            the key-ID to set the properties for
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_REMOVE.
+ * @param num_options       number of options in above array.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_remove_key(const kms_handle_t handle, const char *key_id,
+		   const struct kms_option *options, size_t num_options);
+
+/**
+ * Callback used with the kms_list_keys() function. Called for each key.
+ *
+ * @param key_id            the key-ID of the key
+ * @param label             the label of the key.
+ * @param key_type          the type of the key (CCA-AESDATA, etc)
+ * @param key_bits          the key size in bits
+ * @param properties        a list of properties of the key
+ * @param num_properties    the number of properties in above array
+ * @param addl_info_argz    an argz string containing additional KMS plugin
+ *                           specific infos to be displayed, or NULL if none.
+ * @param addl_info_len     length of the argz string in addl_info_argz
+ * @param private_data      the private data pointer
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ */
+typedef int (*kms_list_callback)(const char *key_id, const char *label,
+				 const char *key_type, size_t key_bits,
+				 const struct kms_property *properties,
+				 size_t num_properties,
+				 const char *addl_info_argz,
+				 size_t addl_info_len, void *private_data);
+
+/**
+ * List keys managed by the KMS. This list is independent of the zkey key
+ * repository. It lists keys as known by the KMS.
+ *
+ * Note: The list function is used to display a list of keys managed by the KMS,
+ * but also for producing a list of keys to import. Because the two use cases
+ * might require different plugin specific options, kms_get_command_options()
+ * allows two commands to get options for:
+ * - KMS_COMMAND_LIST:        Options for displaying a list.
+ * - KMS_COMMAND_LIST_IMPORT: Options for building a list to import keys.
+ * Functionkms_list_keys() is called for both cases with the appropriate
+ * options as returned by kms_get_command_options() for the case.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param label_pattern     a pattern of the label used to filter the keys, or
+ *                          NULL if no label pattern is specified.
+ * @param properties        a list of properties used to to filter the keys, or
+ *                          NULL if no properties filter is specified.
+ * @param num_properties    the number of properties in above array.
+ * @param options           a list of options as specified by the user. These
+ *                          options are a subset of the possible options as
+ *                          returned by kms_get_command_options() with command
+ *                          KMS_COMMAND_LIST or KMS_COMMAND_LIST_IMPORT.
+ * @param num_options       number of options in above array.*
+ * @param callback          a callback function that is called for each key that
+ *                          matches the filter (if any).
+ * @private_data            a private pointer passed as is to the callback
+ *                          function. Can be used to pass user specific
+ *                          information to the callback.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_list_keys(const kms_handle_t handle, const char *label_pattern,
+		  const struct kms_property *properties, size_t num_properties,
+		  const struct kms_option *options, size_t num_options,
+		  kms_list_callback callback, void *private_data);
+
+/**
+ * Imports a key from the KMS and returns a secure key that is
+ * enciphered under the current HSM master key.
+ *
+ * @param handle            the KMS plugin handle obtained from kms_initialize()
+ * @param key_id            the key-ID of the key to import
+ * @param key_blob          a buffer to return the key blob. The size of the
+ *                          buffer is specified in key_blob_length
+ * @param key_blob_length   on entry: the size of the key_blob buffer.
+ *                          on exit: the size of the key blob returned.
+ *
+ * @returns 0 on success, or a negative errno in case of an error.
+ * Function kms_get_last_error() can be used to obtain more details about the
+ * error.
+ */
+int kms_import_key(const kms_handle_t handle, const char *key_id,
+		   unsigned char *key_blob, size_t *key_blob_length);
+
+#define KMS_API_VERSION_1	1
+
+struct kms_functions {
+	unsigned int api_version;
+	int (*kms_bind)(const char *config_path);
+	kms_handle_t (*kms_initialize)(const char *config_path, bool verbose);
+	int (*kms_terminate)(const kms_handle_t handle);
+	const char *(*kms_get_last_error)(const kms_handle_t handle);
+	bool (*kms_supports_key_type)(const kms_handle_t handle,
+				      const char *key_type);
+	int (*kms_display_info)(const kms_handle_t handle);
+	const struct util_opt *(*kms_get_command_options)(
+			const char *command, int max_opts);
+	int (*kms_configure)(const kms_handle_t handle,
+			     const struct kms_apqn *apqns, size_t num_apqns,
+			     const struct kms_option *options,
+			     size_t num_options);
+	int (*kms_deconfigure)(const kms_handle_t handle);
+	int (*kms_login)(const kms_handle_t handle);
+	int (*kms_reenciper)(const kms_handle_t handle,
+			     enum kms_reencipher_mode mode,
+			     enum kms_reenc_mkreg mkreg,
+			     const struct kms_option *options,
+			     size_t num_options);
+	int (*kms_generate_key)(const kms_handle_t handle,
+				const char *key_type, size_t key_bits,
+				enum kms_key_mode key_mode,
+				const struct kms_property *properties,
+				size_t num_properties,
+				const struct kms_option *options,
+				size_t num_options,
+				unsigned char *key_blob,
+				size_t *key_blob_length, char *key_id,
+				size_t key_id_size, char *key_label,
+				size_t key_label_size);
+	int (*kms_set_key_properties)(const kms_handle_t handle,
+				      const char *key_id,
+				      const struct kms_property *properties,
+				      size_t num_properties);
+	int (*kms_get_key_properties)(const kms_handle_t handle,
+				      const char *key_id,
+				      struct kms_property **properties,
+				      size_t *num_properties);
+	int (*kms_remove_key)(const kms_handle_t handle, const char *key_id,
+			      const struct kms_option *options,
+			      size_t num_options);
+	int (*kms_list_keys)(const kms_handle_t handle,
+			     const char *label_pattern,
+			     const struct kms_property *properties,
+			     size_t num_properties,
+			     const struct kms_option *options,
+			     size_t num_options,
+			     kms_list_callback callback, void *private_data);
+	int (*kms_import_key)(const kms_handle_t handle, const char *key_id,
+			      unsigned char *key_blob,
+			      size_t *key_blob_length);
+};
+
+/**
+ * Returns an address of a structure containing the KMS plugin functions.
+ * This function is exported by the KMS plugin, and its address is obtain
+ * via dlsym() after loading the plugin via dlopen().
+ * *
+ * @returns the address of a structure or NULL in case of an error.
+ */
+const struct kms_functions *kms_get_functions(void);
+
+#endif
diff -pruN 2.14.0-2/zkey/kms-plugins.conf 2.15.1-0ubuntu2/zkey/kms-plugins.conf
--- 2.14.0-2/zkey/kms-plugins.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/kms-plugins.conf	2020-10-28 14:31:59.000000000 +0000
@@ -0,0 +1,4 @@
+# List of zkey KMS plugins
+# Format:
+# <plugin-name>=<shared-library-file>
+EKMFWeb=zkey-ekmfweb.so
\ No newline at end of file
diff -pruN 2.14.0-2/zkey/Makefile 2.15.1-0ubuntu2/zkey/Makefile
--- 2.14.0-2/zkey/Makefile	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/Makefile	2020-10-28 14:31:59.000000000 +0000
@@ -3,6 +3,11 @@ include ../common.mak
 ifneq (${HAVE_OPENSSL},0)
 	BUILD_TARGETS += zkey
 	INSTALL_TARGETS += install-zkey
+	ifneq (${HAVE_JSONC},0)
+		ifneq (${HAVE_LIBCURL},0)
+			SUB_DIRS += ekmfweb
+		endif
+	endif
 else
 	BUILD_TARGETS += zkey-skip
 	INSTALL_TARGETS += zkey-skip
@@ -10,9 +15,14 @@ endif
 
 ifneq (${HAVE_CRYPTSETUP2},0)
 	ifneq (${HAVE_JSONC},0)
-		BUILD_TARGETS += zkey-cryptsetup
-		INSTALL_TARGETS += install-zkey-cryptsetup
-		CPPFLAGS += -DHAVE_LUKS2_SUPPORT
+		ifneq (${HAVE_OPENSSL},0)
+			BUILD_TARGETS += zkey-cryptsetup
+			INSTALL_TARGETS += install-zkey-cryptsetup
+			CPPFLAGS += -DHAVE_LUKS2_SUPPORT
+		else
+			BUILD_TARGETS += zkey-cryptsetup-skip-openssl
+			INSTALL_TARGETS += zkey-cryptsetup-skip-openssl
+		endif
 	else
 		BUILD_TARGETS += zkey-cryptsetup-skip-jsonc
 		INSTALL_TARGETS += zkey-cryptsetup-skip-jsonc
@@ -62,7 +72,10 @@ zkey-cryptsetup-skip-cryptsetup2:
 zkey-cryptsetup-skip-jsonc:
 	echo "  SKIP    zkey-cryptsetup due to HAVE_JSONC=0"
 
-all: $(BUILD_TARGETS)
+zkey-cryptsetup-skip-openssl:
+	echo "  SKIP    zkey-cryptsetup due to HAVE_OPENSSL=0"
+
+all: $(BUILD_TARGETS) $(SUB_DIRS)
 
 zkey.o: zkey.c pkey.h cca.h ep11.h misc.h
 pkey.o: pkey.c pkey.h cca.h ep11.h utils.h
@@ -73,9 +86,10 @@ properties.o: check-dep-zkey properties.
 keystore.o: keystore.c keystore.h properties.h pkey.h cca.h ep11.h utils.h
 zkey-cryptsetup.o: check-dep-zkey-cryptsetup zkey-cryptsetup.c pkey.h cca.h \
 			ep11.h misc.h utils.h
+kms.o: kms.c kms.h kms-plugin.h utils.h pkey.h
 
 zkey: LDLIBS = -ldl -lcrypto
-zkey: zkey.o pkey.o cca.o ep11.o properties.o keystore.o utils.o $(libs)
+zkey: zkey.o pkey.o cca.o ep11.o properties.o keystore.o utils.o kms.o $(libs)
 	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
 
 zkey-cryptsetup: LDLIBS = -ldl -lcryptsetup -ljson-c -lcrypto
@@ -86,22 +100,35 @@ install-common:
 	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
 	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
 
-install-zkey:
+install-zkey: zkey
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey $(DESTDIR)$(USRBINDIR)
 	$(INSTALL) -m 644 -c zkey.1 $(DESTDIR)$(MANDIR)/man1
 	$(INSTALL) -d -m 770 $(DESTDIR)$(SYSCONFDIR)/zkey
 	$(INSTALL) -d -m 770 $(DESTDIR)$(SYSCONFDIR)/zkey/repository
+	$(INSTALL) -m 644 -c kms-plugins.conf $(DESTDIR)$(SYSCONFDIR)/zkey
 
-install-zkey-cryptsetup:
+install-zkey-cryptsetup: zkey-cryptsetup
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey-cryptsetup $(DESTDIR)$(USRBINDIR)
 	$(INSTALL) -m 644 -c zkey-cryptsetup.1 $(DESTDIR)$(MANDIR)/man1
 
-install: all install-common $(INSTALL_TARGETS)
+install: all install-common $(INSTALL_TARGETS) $(SUB_DIRS)
 
-clean:
+clean: $(SUB_DIRS)
 	rm -f *.o zkey zkey-cryptsetup detect-libcryptsetup.dep \
 		check-dep-zkey check-dep-zkey-cryptsetup
 
+#
+# For simple "make" we explicitly set the MAKECMDGOALS to "all".
+#
+ifeq ($(MAKECMDGOALS),)
+MAKECMDGOALS = all
+endif
+
+$(SUB_DIRS):
+	$(foreach goal,$(MAKECMDGOALS), \
+		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
+.PHONY: $(SUB_DIRS)
+
 .PHONY: all install clean zkey-skip zkey-cryptsetup-skip-cryptsetup2 \
 	zkey-cryptsetup-skip-jsonc install-common install-zkey \
 	install-zkey-cryptsetup
diff -pruN 2.14.0-2/zkey/misc.h 2.15.1-0ubuntu2/zkey/misc.h
--- 2.14.0-2/zkey/misc.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/misc.h	2020-10-28 14:31:59.000000000 +0000
@@ -3,7 +3,7 @@
  *
  * Local helper functions
  *
- * Copyright IBM Corp. 2017, 2018
+ * Copyright IBM Corp. 2017, 2020
  *
  * s390-tools is free software; you can redistribute it and/or modify
  * it under the terms of the MIT license. See LICENSE for details.
@@ -26,9 +26,18 @@ static inline void misc_print_missing_co
 }
 
 /**
+ * Subcommand is missing
+ */
+static inline void misc_print_missing_sub_command(void)
+{
+	warnx("Subcommand is required");
+	util_prg_print_parse_error();
+}
+
+/**
  * Invalid command specified (for 'git' like tools)
  */
-void misc_print_invalid_command(const char *command)
+static void misc_print_invalid_command(const char *command)
 {
 	warnx("Invalid command '%s'", command);
 	util_prg_print_parse_error();
@@ -39,7 +48,7 @@ void misc_print_invalid_command(const ch
  *
  * @param[in] parm_name  Parameter string
  */
-void misc_print_required_parm(const char *parm_name)
+static void misc_print_required_parm(const char *parm_name)
 {
 	warnx("Parameter '%s' is required", parm_name);
 	util_prg_print_parse_error();
diff -pruN 2.14.0-2/zkey/pkey.c 2.15.1-0ubuntu2/zkey/pkey.c
--- 2.14.0-2/zkey/pkey.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/pkey.c	2020-10-28 14:31:59.000000000 +0000
@@ -45,8 +45,6 @@
 
 #define MAX_CIPHER_LEN		32
 
-#define DEFAULT_KEYBITS		256
-
 #define INITIAL_APQN_ENTRIES	16
 
 /**
@@ -1394,7 +1392,7 @@ int generate_key_verification_pattern(co
 		goto out;
 	}
 
-	opfd = accept(tfmfd, NULL, 0);
+	opfd = accept(tfmfd, NULL, NULL);
 	if (opfd < 0) {
 		rc = -errno;
 		pr_verbose(verbose, "Failed to accept on the AF_ALG socket");
@@ -1775,10 +1773,6 @@ int check_aes_cipher_key(const u8 *key,
 		       "decryption\n");
 		mismatch = true;
 	}
-	if (cipherkey->kuf1 & 0x2000) {
-		printf("INFO: The secure key can be used for data translate\n");
-		mismatch = true;
-	}
 	if (cipherkey->kuf1 & 0x1000) {
 		printf("WARNING: The secure key can only be used in UDXs\n");
 		mismatch = true;
@@ -1929,8 +1923,8 @@ static int reencipher_ep11_secure_key(st
 				      u8 *mkvp, bool *apqn_selected,
 				      bool verbose)
 {
+	unsigned int card, domain;
 	unsigned int flags;
-	int card, domain;
 	target_t target;
 	int rc;
 
diff -pruN 2.14.0-2/zkey/pkey.h 2.15.1-0ubuntu2/zkey/pkey.h
--- 2.14.0-2/zkey/pkey.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/pkey.h	2020-10-28 14:31:59.000000000 +0000
@@ -115,10 +115,14 @@ struct ep11keytoken {
 #define AESCIPHER_KEY_SIZE	sizeof(struct aescipherkeytoken)
 #define EP11_KEY_SIZE		sizeof(struct ep11keytoken)
 
-#define MAX_SECURE_KEY_SIZE	MAX(EP11_KEY_SIZE, \
-				    MAX(AESDATA_KEY_SIZE, AESCIPHER_KEY_SIZE))
-#define MIN_SECURE_KEY_SIZE	MIN(EP11_KEY_SIZE, \
-				    MIN(AESDATA_KEY_SIZE, AESCIPHER_KEY_SIZE))
+/* MAX/MIN from zt_common.h produces warnings for variable length arrays */
+#define _MIN(a, b)  ((a) < (b) ? (a) : (b))
+#define _MAX(a, b)  ((a) > (b) ? (a) : (b))
+
+#define MAX_SECURE_KEY_SIZE	_MAX(EP11_KEY_SIZE, \
+				     _MAX(AESDATA_KEY_SIZE, AESCIPHER_KEY_SIZE))
+#define MIN_SECURE_KEY_SIZE	_MIN(EP11_KEY_SIZE, \
+				     _MIN(AESDATA_KEY_SIZE, AESCIPHER_KEY_SIZE))
 
 struct pkey_seckey {
 	u8  seckey[AESDATA_KEY_SIZE];  /* the secure key blob */
@@ -263,6 +267,7 @@ struct pkey_apqns4keytype {
 #define KEY_TYPE_CCA_AESCIPHER      "CCA-AESCIPHER"
 #define KEY_TYPE_EP11_AES           "EP11-AES"
 
+#define DEFAULT_KEYBITS             256
 #define PAES_BLOCK_SIZE             16
 #define ENC_ZERO_LEN                (2 * PAES_BLOCK_SIZE)
 #define VERIFICATION_PATTERN_LEN    (2 * ENC_ZERO_LEN + 1)
diff -pruN 2.14.0-2/zkey/utils.c 2.15.1-0ubuntu2/zkey/utils.c
--- 2.14.0-2/zkey/utils.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/utils.c	2020-10-28 14:31:59.000000000 +0000
@@ -45,7 +45,7 @@
  *          0 if offline,
  *          -1 if its not the specified type.
  */
-int sysfs_is_card_online(int card, enum card_type cardtype)
+int sysfs_is_card_online(unsigned int card, enum card_type cardtype)
 {
 	long int online;
 	char *dev_path;
@@ -106,7 +106,8 @@ out:
  *          0 if offline,
  *          -1 if its not the specified type.
  */
-int sysfs_is_apqn_online(int card, int domain, enum card_type cardtype)
+int sysfs_is_apqn_online(unsigned int card, unsigned int domain,
+			 enum card_type cardtype)
 {
 	long int online;
 	char *dev_path;
@@ -144,7 +145,7 @@ out:
  *
  * @returns The card level, or -1 of the level can not be determined.
  */
-int sysfs_get_card_level(int card)
+int sysfs_get_card_level(unsigned int card)
 {
 	char *dev_path;
 	char type[20];
@@ -187,7 +188,7 @@ out:
  *
  * @returns The card type, or -1 of the type can not be determined.
  */
-enum card_type sysfs_get_card_type(int card)
+enum card_type sysfs_get_card_type(unsigned int card)
 {
 	char *dev_path;
 	char type[20];
@@ -235,7 +236,7 @@ out:
  *          -ENOTSUP if the serialnr sysfs attribute is not available, because
  *          the zcrypt kernel module is on an older level.
  */
-int sysfs_get_serialnr(int card, char *serialnr, bool verbose)
+int sysfs_get_serialnr(unsigned int card, char *serialnr, bool verbose)
 {
 	char *dev_path;
 	int rc = 0;
@@ -286,7 +287,7 @@ out:
  *          the zcrypt kernel module is on an older level, or because the card
  *          type does not provide this information.
  */
-int sysfs_get_firmware_version(int card, struct fw_version *fw_version,
+int sysfs_get_firmware_version(unsigned int card, struct fw_version *fw_version,
 			       bool verbose)
 {
 	char *dev_path;
@@ -310,7 +311,7 @@ int sysfs_get_firmware_version(int card,
 		goto out;
 	}
 
-	if (sscanf(buf, "%d.%d", &fw_version->major, &fw_version->minor) != 2) {
+	if (sscanf(buf, "%u.%u", &fw_version->major, &fw_version->minor) != 2) {
 		rc = -ENODEV;
 		goto out;
 	}
@@ -321,7 +322,7 @@ int sysfs_get_firmware_version(int card,
 		goto out;
 	}
 
-	if (sscanf(buf, "%d", &fw_version->api_ordinal) != 1) {
+	if (sscanf(buf, "%u", &fw_version->api_ordinal) != 1) {
 		rc = -ENODEV;
 		goto out;
 	}
@@ -477,7 +478,8 @@ static int parse_ep11_mk_info(char *line
  *          -ENOTSUP if the mkvps sysfs attribute is not available, because the
  *          zcrypt kernel module is on an older level.
  */
-int sysfs_get_mkvps(int card, int domain, struct mk_info *mk_info, bool verbose)
+int sysfs_get_mkvps(unsigned int card, unsigned int domain,
+		    struct mk_info *mk_info, bool verbose)
 {
 	enum card_type cardtype;
 	char *dev_path;
@@ -572,13 +574,14 @@ out:
 	return rc;
 }
 
-static int scan_for_domains(int card, enum card_type cardtype,
+static int scan_for_domains(unsigned int card, enum card_type cardtype,
 			    apqn_handler_t handler, void *handler_data,
 			    bool verbose)
 {
 	struct dirent **namelist;
 	char fname[290];
-	int i, n, domain, rc = 0;
+	int i, n, rc = 0;
+	unsigned int domain;
 
 	sprintf(fname, "/sys/devices/ap/card%02x/", card);
 	n = util_scandir(&namelist, alphasort, fname,
@@ -613,7 +616,8 @@ static int scan_for_apqns(enum card_type
 			  void *handler_data, bool verbose)
 {
 	struct dirent **namelist;
-	int i, n, card, rc = 0;
+	int i, n, rc = 0;
+	unsigned int card;
 
 	if (handler == NULL)
 		return -EINVAL;
@@ -663,7 +667,7 @@ static int scan_for_apqns(enum card_type
 int handle_apqns(const char *apqns, enum card_type cardtype,
 		 apqn_handler_t handler, void *handler_data, bool verbose)
 {
-	int card, domain;
+	unsigned int card, domain;
 	char *copy, *tok;
 	char *save;
 	int rc = 0;
@@ -702,7 +706,8 @@ struct print_apqn_info {
 	bool verbose;
 };
 
-static int print_apqn_mk_info(int card, int domain, void *handler_data)
+static int print_apqn_mk_info(unsigned int card, unsigned int domain,
+			      void *handler_data)
 {
 	struct print_apqn_info *info = (struct print_apqn_info *)handler_data;
 	struct mk_info mk_info;
@@ -819,7 +824,8 @@ struct cross_check_info {
 	bool	verbose;
 };
 
-static int cross_check_mk_info(int card, int domain, void *handler_data)
+static int cross_check_mk_info(unsigned int card, unsigned int domain,
+			       void *handler_data)
 {
 	struct cross_check_info *info = (struct cross_check_info *)handler_data;
 	struct fw_version fw_version;
@@ -1050,7 +1056,7 @@ int cross_check_apqns(const char *apqns,
 		      enum card_type cardtype, bool print_mks, bool verbose)
 {
 	struct cross_check_info info;
-	char temp[200];
+	char temp[250];
 	int rc;
 
 	memset(&info, 0, sizeof(info));
diff -pruN 2.14.0-2/zkey/utils.h 2.15.1-0ubuntu2/zkey/utils.h
--- 2.14.0-2/zkey/utils.h	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/utils.h	2020-10-28 14:31:59.000000000 +0000
@@ -16,17 +16,18 @@
 
 #include "pkey.h"
 
-int sysfs_is_card_online(int card, enum card_type cardtype);
+int sysfs_is_card_online(unsigned int card, enum card_type cardtype);
 
-int sysfs_is_apqn_online(int card, int domain, enum card_type cardtype);
+int sysfs_is_apqn_online(unsigned int card, unsigned int domain,
+			 enum card_type cardtype);
 
-int sysfs_get_card_level(int card);
+int sysfs_get_card_level(unsigned int card);
 
-enum card_type sysfs_get_card_type(int card);
+enum card_type sysfs_get_card_type(unsigned int card);
 
 #define SERIALNR_LENGTH		17
 
-int sysfs_get_serialnr(int card, char *serialnr, bool verbose);
+int sysfs_get_serialnr(unsigned int card, char *serialnr, bool verbose);
 
 struct fw_version {
 	unsigned int	major;
@@ -34,7 +35,7 @@ struct fw_version {
 	unsigned int	api_ordinal;
 };
 
-int sysfs_get_firmware_version(int card, struct fw_version *fw_version,
+int sysfs_get_firmware_version(unsigned int card, struct fw_version *fw_version,
 			       bool verbose);
 
 #define MK_STATE_EMPTY		0
@@ -57,10 +58,11 @@ struct mk_info {
 	struct mk_info_reg	old_mk; /* only available on CCA cards */
 };
 
-int sysfs_get_mkvps(int card, int domain, struct mk_info *mk_info,
-		    bool verbose);
+int sysfs_get_mkvps(unsigned int card, unsigned int domain,
+		    struct mk_info *mk_info, bool verbose);
 
-typedef int(*apqn_handler_t) (int card, int domain, void *handler_data);
+typedef int(*apqn_handler_t) (unsigned int card, unsigned int domain,
+			      void *handler_data);
 
 int handle_apqns(const char *apqns, enum card_type cardtype,
 		 apqn_handler_t handler, void *handler_data, bool verbose);
diff -pruN 2.14.0-2/zkey/zkey.1 2.15.1-0ubuntu2/zkey/zkey.1
--- 2.14.0-2/zkey/zkey.1	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/zkey.1	2020-10-28 14:31:59.000000000 +0000
@@ -1,8 +1,8 @@
-.\" Copyright IBM Corp. 2017, 2018
+.\" Copyright IBM Corp. 2017, 2020
 .\" s390-tools is free software; you can redistribute it and/or modify
 .\" it under the terms of the MIT license. See LICENSE for details.
 .\"
-.TH ZKEY 1 "May 2018" "s390-tools"
+.TH ZKEY 1 "July 2020" "s390-tools"
 .SH NAME
 zkey \- Manage secure AES keys
 .
@@ -15,6 +15,12 @@ zkey \- Manage secure AES keys
 .
 .PP
 .B zkey
+.I command sub-command
+.RB [ OPTIONS ]
+.
+.
+.PP
+.B zkey
 .BR \-\-help | \-h
 .br
 .B zkey
@@ -56,6 +62,17 @@ length of 128, or 256 bits each, for key
 Note that the file size is not related to the key bit size, but is specific for
 the secure key type. The key is enciphered with the master key of the CCA or
 EP11 cryptographic adapter.
+.PP
+Secure keys in a key repository can either be generated locally, or by a \fBkey
+management system (KMS)\fP. A key repository can be bound to a key management
+system (KMS) via a key management system plugin (KMS plugin), which builds the
+interface to the key management system. This allows to integrate a zkey key
+repository into an enterprise key management system, that manages the keys in
+a larger environment.
+When a key repository is bound to a key management system, then all keys are
+generated by the key management system per default, and are thus also bound to
+the key management system. Any additional information associated with the keys
+in the repository is also stored in the key management system.
 .
 .
 .
@@ -108,25 +125,36 @@ key repository.
 .IR clear\-key\-file ]
 .RB [ \-\-key-type | \-K
 .IR type ]
+.RB [ \-\-local | \-L ]
+.RB [ KMS\-plugin\ specific\ options ]
 .RB [ \-\-verbose | \-V ]
 .PP
 Use the
 .B generate
 command to generate a new secure AES key either randomly within the CCA or EP11
-cryptographic adapter, or from a clear AES key specified as input. When specifying
-a clear key as input, the clear key should be kept in a secure place, or be
-securely erased after creation of the secure key. The secure key itself does
-not need to be kept secure, because it can only be used together with a
-CCA or EP11 cryptographic adapter that contains the master key with which the
-secure key was generated.
+cryptographic adapter, from a clear AES key specified as input, or using a key
+management system plugin (KMS plugin). When specifying a clear key as input, the
+clear key should be kept in a secure place, or be securely erased after creation
+of the secure key. The secure key itself does not need to be kept secure,
+because it can only be used together with a CCA or EP11 cryptographic adapter
+that contains the master key with which the secure key was generated.
+.PP
+When the secure key repository is bound to a key management system plugin (KMS
+plugin), then the secure key is generated by using the key management system,
+except the \fB\-\-local\fP option is specified.
+.PP
+A key management system plugin may offer plugin specific options that can be
+specified with the \fBgenerate\fP command. Use \fBgenerate \-\-help\fP
+to display the plugin specific options and their meaning.
 .PP
 The generated secure key can either be stored in a file in the file system,
 or in the secure key repository. To store the generated secure key in a
 file, specify the file name with option \fIsecure\-key\-file\fP. To store the
 secure key in the secure key repository, specify the name of the key using the
 .B \-\-name
-option. When storing the secure key in a key repository,
-additional information can be associated with a secure key using the
+option. Secure keys generated using a key management system plugin can only be
+stored in a secure key repository. When storing the secure key in a key
+repository, additional information can be associated with a secure key using the
 .B \-\-description
 ,
 .B \-\-volumes
@@ -134,13 +162,18 @@ additional information can be associated
 .B \-\-apqns
 , or the
 .B \-\-sector-size
-options.
+options. When the secure key repository is bound to a key management system
+plugin, then you can not associate specific APQNs with such keys, but the keys
+inherit the APQNs that are associated with the key management system plugin.
 .PP
 You can generate different types of secure keys: \fBCCA-AESDATA\fP keys,
 \fBCCA-AESCIPHER\fP, and \fBEP11-AES\fP keys.
 Specify the type of the secure key using the
 .B \-\-key\-type
-option. The default key type is CCA-AESDATA.
+option. Normally, the default key type is CCA-AESDATA. If the secure key
+repository is bound to a key management system plugin, and the plugin does not
+support keys of type CCA-AESDATA, then the default key type is CCA-AESCIPHER, or
+EP11-AES, whichever the plugin supports.
 .PP
 .B Note:
 Secure keys of type \fBCCA-AESCIPHER\fP require an IBM cryptographic
@@ -402,6 +435,8 @@ The exported secure key also remains in
 .IR type ]
 .RB [ \-\-key-type | \-K
 .IR type ]
+.RB [ \-\-local | \-L ]
+.RB [ \-\-kms\-bound | \-M ]
 .RB [ \-\-verbose | \-V ]
 .
 .PP
@@ -409,8 +444,9 @@ Use the
 .B list
 command to display a list of secure keys contained in the secure key repository.
 You can filter the displayed list by key name, associated volumes, associated
-cryptographic adapters (APQNs), and volume type. You can use wildcards for the
-key name, associated APQNs, and associated volumes. The device-mapper name of an
+cryptographic adapters (APQNs), volume type, and whether the keys are local or
+bound to a key management system (MKS). You can use wildcards for the key name,
+associated APQNs, and associated volumes. The device-mapper name of an
 associated volume can be omitted; if it is specified then only those keys are
 listed that are associated with the specified volume and device-mapper name.
 .PP
@@ -419,8 +455,9 @@ The
 command displays the attributes of the secure keys, such as key sizes, key type,
 whether it is a secure key that can be used for the XTS cipher mode, the textual
 description, associated cryptographic adapters (APQNs) and volumes, the
-sector size, the key verification pattern, and timestamps for key creation, last
-modification and last re-encipherment.
+sector size, the key verification pattern, timestamps for key creation, last
+modification and last re-encipherment, and whether the key is local or
+bound to a key management systen (KMS).
 .
 .SS "Remove existing AES secure keys from the secure key repository"
 .
@@ -429,6 +466,7 @@ modification and last re-encipherment.
 .B \-\-name | \-N
 .IR key-name
 .RB [ \-\-force | \-F ]
+.RB [ KMS\-plugin\ specific\ options ]
 .RB [ \-\-verbose | \-V ]
 .
 .PP
@@ -442,6 +480,16 @@ a confirmation, unless you specify the
 .B \-\-force
 option.
 .PP
+When the secure key that is to be removed is bound to a key management system,
+then the key management system plugin might also take an action in the key
+management system. It may for example change the state of the key in the key
+management system, instead of removing the key. Nevertheless, the secure key
+is removed from the local repository.
+.PP
+A key management system plugin may offer plugin specific options that can be
+specified with the \fBremove\fP command. Use \fBremove \-\-help\fP
+to display the plugin specific options and their meaning.
+.PP
 .B Note:
 When removing a secure key that is associated with one or multiple volumes,
 and the key's volume type is \fBplain\fP,
@@ -499,6 +547,12 @@ options. You cannot mix \fI+\fP and
 \fI-\fP in one specification. You can either add or remove (or set) the
 associations with one command.
 .PP
+For secure AES keys that are bound to a key management system (KMS) you can not
+change the APQN association. KMS-bound secure AES keys are always bound to the
+APQNs that are associated with the key management system plugin.
+Other associated information is also changed in the key management system when
+changed using the change command.
+.PP
 .B Note:
 The secure key itself cannot be changed, only information about the secure
 key is changed. To rename a secure key, use the \fBrename\fP command.
@@ -544,6 +598,7 @@ secure key is contained in the LUKS2 hea
 .IR new-key-name
 .RB [ \-\-volumes | \-l
 .IR volume1:dmname1[,volume2:dmname2[,...]] ]
+.RB [ \-\-local | \-L ]
 .RB [ \-\-verbose | \-V ]
 .
 .PP
@@ -563,6 +618,10 @@ a specific volume can only be associated
 option to associate different
 volumes with the copied secure key, or use the \fBchange\fP command to associate
 volumes afterwards.
+.PP
+You can not copy secure keys that are bound to a key management system (KMS),
+except when the \fB\-\-local\fP option is specified. The copied secure key is
+then created as a local key.
 .
 .SS "Generate crypttab entries for volumes associated with secure AES keys"
 .
@@ -720,6 +779,7 @@ Use the
 .B convert
 command to convert an existing secure key from one key type to another type.
 You can convert secure keys of type CCA-AESDATA to type CCA-AESCIPHER only.
+You can not convert keys that are bound to a key management system (KMS).
 
 .B Note:
 Secure keys converted to type \fBCCA-AESCIPHER\fP require an IBM cryptographic
@@ -760,6 +820,334 @@ is 6.3.27 or later. For the supported en
 \fIhttp://www.ibm.com/security/cryptocards\fP
 .
 .
+.SH COMMANDS FOR KEY MANAGEMENT SYSTEM INTEGRATION
+.
+Use the \fBkms\fP command to control the integration into key management
+systems. The \fBkms\fP command offers several subcommands for key management
+specific operations. Use \fBzkey kms \-\-help\fP to show the available
+subcommands.
+.
+.SS "List key management system plugins"
+.
+.B zkey kms
+.BR plugins | pl
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms plugins
+command to display a list of configured key management system plugins (KMS
+plugins). It displays the key management system plugin name, and the shared
+library that implements the plugin.
+.
+.P
+Key management system plugins are configured in configuration file
+\fB/etc/zkey/kms-plugins.conf\fP. This file contains the KMS plugin name and
+its shared library. Set environment variable \fBZKEY_KMS_PLUGINS\fP to point to
+a different file to use a different KMS plugin configuration file.
+.
+.SS "Bind the repository to a key management system"
+.
+.B zkey kms
+.BR bind | bi
+.I KMS\-plugin\-name
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms bind
+command to bind the repository to a key management system (KMS).
+The \fBkms plugins\fP command displays a list of configured key management
+system plugins that can be used.
+.
+.PP
+After binding a repository to a key management system, the KMS plugin must
+first be configured. Use the \fBkms configure\fP command to
+configure the plugin. As a minimum, you must associate APQNs with the key
+management system plugin. The plugin may require additional configuration
+before it is fully functioning. Use the \fBkms info\fP command to display
+information about the key management system plugin and its configuration.
+.
+.PP
+When a key repository is bound to a key management system, then all keys are
+generated by this key management system per default, and are thus also bound to
+the key management system. Any additional information associated with the keys
+in the repository is also stored in the key management system.
+.
+.SS "Unbind the repository from a key management system"
+.
+.B zkey kms
+.BR unbind | unb
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms unbind
+command to unbind the repository from a key management system (KMS). All keys
+that are currently bound to the key management system, are unbound and become
+local keys. You are prompted to confirm the unbinding.
+.
+.SS "Display information about a key management system plugin"
+.
+.B zkey kms
+.BR info | in
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms info
+command to display information about the currently bound key management system
+plugin (KMS plugin) and its configuration.
+.
+.SS "Configure or re\-configure a key management system plugin"
+.
+.B zkey kms
+.BR configure | con
+.RB [ \-\-apqns | \-a
+.IR [+|-]card1.domain1[,card2.domain2[,...]] ]
+.RB [ KMS\-plugin\ specific\ options ]
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms configure
+command to configure or re\-configure the currently bound key management system
+plugin (KMS plugin). As a minimum, you must associate APQNs with the key
+management system plugin. The plugin may require an initial configuration
+before it is fully functioning. Once configured, a plugin may allow you to
+change some configuration settings.
+.PP
+A key management system plugin may offer plugin specific options that can be
+specified with the \fBkms configure\fP command. Use \fBkms configure
+\-\-help\fP to display the plugin specific options and their meaning.
+.PP
+Configuring a key management system plugin may be a multi-step task. You can
+supply all configuration options at once or use the \fBkms configure\fP
+command several times supplying only one or a few configuration options each
+time, dependent on what the plugin supports. A plugin may also require to
+perform additional intermediate steps between two configuration attempts,
+e.g. perform tasks in the key management system user interface, or elsewhere.
+.PP
+Use the \fBkms info\fP command to display information about the key management
+system plugin and its current configuration.
+.
+.SS "Re-encipher secure keys used by a key management system plugin"
+.
+.B zkey kms
+.BR reencipher | re
+.RB [ \-\-to\-new | \-n ]
+.RB [ \-\-from\-old | \-o ]
+.RB [ \-\-in-place | \-i ]
+.RB [ \-\-staged | \-s ]
+.RB [ \-\-complete | \-c ]
+.RB [ KMS\-plugin\ specific\ options ]
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms reencipher
+command to re-encipher secure keys internally used by the currently bound
+key management system plugin (KMS plugin) with a new master key. This command
+must be run when the master keys of the CCA or EP11 cryptographic adapter,
+that are associated with the plugin have been changed. Dependent on what key
+types the key management system plugin supports, it may internally use secure
+keys with CCA or EP11 cryptographic adapters, or both.
+.PP
+A key management system plugin may offer plugin specific options that can be
+specified with the \fBkms reencipher\fP command. Use \fBkms reencipher
+\-\-help\fP to display the plugin specific options and their meaning.
+.PP
+.B Note:
+The \fBkms reencipher\fP command does \fBnot\fP re-encipher secure keys that
+have been generated by or have been imported from the key management system
+plugin and are stored in the repository. Use the regular \fBreencipher\fP
+command to re-encipher those secure keys.
+.PP
+The CCA cryptographic adapter has three different registers to store
+master keys:
+.RS 2
+.IP "\(bu" 2
+The \fBCURRENT\fP register contains the current master key.
+.
+.IP "\(bu" 2
+The \fBOLD\fP register contains the previously used master key.
+Secure keys enciphered with the master key contained in the \fBOLD\fP
+register can still be used until the master key is changed again.
+.
+.IP "\(bu" 2
+The \fBNEW\fP register contains the new master key to be set.
+The master key in the \fBNEW\fP register cannot be used until it is made
+the current master key. You can pro-actively re-encipher a secure key with the
+\fBNEW\fP master key before this key is made the \fBCURRENT\fP key. Use the
+.B \-\-to-new
+option to do this.
+.RE
+.PP
+\fBNote:\fP An EP11 cryptographic adapter has only two registers to store master
+keys, \fBCURRENT\fP and \fBNEW\fP.
+.PP
+Use the
+.B \-\-from\-old
+option to re-encipher a secure key that is currently enciphered with
+the master key in the \fBOLD\fP register with the master key in the
+\fBCURRENT\fP register. This option is only available for CCA-type secure keys.
+.PP
+.PP
+If both the
+.B \-\-from-old
+and
+.B \-\-to-new
+options are specified, a secure key that is currently enciphered
+with the master key in the \fBOLD\fP register is re-enciphered with the
+master key in the \fBNEW\fP register.
+.PP
+If both options are omitted, the key management system plugin may
+automatically detect whether the secure key is currently enciphered with the
+master key in the \fBOLD\fP register or with the master key in the \fBCURRENT\fP
+register. If currently enciphered with the master key in the \fBOLD\fP register,
+it is re-enciphered with the master key in the \fBCURRENT\fP register.
+If currently enciphered with the master key in the \fBCURRENT\fP
+register, it is re-enciphered with the master key in the \fBNEW\fP register.
+If for this case the \fBNEW\fP register does not contain a valid master key,
+then the re-encipher operation fails.
+.PP
+Re-enciphering a secure key used by a key management system plugin can be
+performed \fBin-place\fP, or in \fBstaged\fP mode.
+.PP
+\fB"In-place"\fP immediately replaces the secure key with the re-enciphered
+secure key. Re-enciphering from \fBOLD\fP to \fBCURRENT\fP is performed
+in-place per default. You can use option \fB\-\-in-place\fP to force an
+in-place re-enciphering for the \fBCURRENT\fP to \fBNEW\fP case.
+A secure key that was re-enciphered in-place from \fBCURRENT\fP to \fBNEW\fP
+is no longer valid, until the new CCA or EP11 master key has been made the
+current one.
+.PP
+\fBStaged\fP mode means that the re-enciphered secure key is stored separately.
+Thus the current secure key is still valid at this point. Once the new CCA or
+EP11 master key has been set (made active), you must rerun the \fBkms
+reencipher\fP command with option \fB\-\-complete\fP to complete the staged
+re-enciphering. Re-enciphering from \fBCURRENT\fP to \fBNEW\fP is performed in
+staged mode per default. You can use option \fB\-\-staged\fP to force a staged
+re-enciphering for the \fBOLD\fP to \fBCURRENT\fP case.
+.
+.SS "List secure keys managed by a key management system"
+.
+.B zkey kms
+.BR list | li
+.RB [ \-\-label | \-B
+.IR key-label ]
+.RB [ \-\-name | \-N
+.IR key-name ]
+.RB [ \-\-volumes | \-l
+.IR volume1[:dmname1][,volume2[:dmname2][,...]] ]
+.RB [ \-\-volume-type | \-t
+.IR type ]
+.RB [ KMS\-plugin\ specific\ options ]
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms list
+command to display secure keys managed by a key management system (KMS).
+You can filter the displayed list by key label, key name, associated volumes,
+and volume type. You can use wildcards for the key label, key name, and
+associated volumes. The device-mapper name of an associated volume can be
+omitted. If specified, then only those keys are listed that are associated
+with the specified volume and device-mapper name.
+.PP
+A key management system plugin may offer plugin specific options that can be
+specified with the \fBkms list\fP command. Use \fBkms list \-\-help\fP
+to display the plugin specific options and their meaning.
+.PP
+The
+.B kms list
+command displays the attributes of the secure keys, such as key label, key name,
+whether it is a secure key that can be used for the XTS cipher mode, the textual
+description, associated volumes, the volume type, and sector size.
+.
+.SS "Import secure keys managed by a key management system into the repository"
+.
+.B zkey kms
+.BR import | im
+.RB [ \-\-label | \-B
+.IR key-label ]
+.RB [ \-\-name | \-N
+.IR key-name ]
+.RB [ \-\-volumes | \-l
+.IR volume1[:dmname1][,volume2[:dmname2][,...]] ]
+.RB [ \-\-volume-type | \-t
+.IR type ]
+.RB [ \-\-batch\-mode | \-q ]
+.RB [ \-\-no\-volume\-check ]
+.RB [ KMS\-plugin\ specific\ options ]
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms import
+command to import secure keys managed by a key management system (KMS) into the
+secure key repository.
+You can filter the list of keys to be imported by key label, key name,
+associated volumes, and volume type. You can use wildcards for the key label,
+key name, and associated volumes. The device-mapper name of an associated
+volume can be omitted. If it is specified, then only those keys are listed that
+are associated with the specified volume and device-mapper name.
+.PP
+A key management system plugin may offer plugin specific options that can be
+specified with the \fBkms import\fP command. Use \fBkms import \-\-help\fP
+to display the plugin specific options and their meaning.
+.PP
+If a secure key with the same name as a key to be imported already exists in
+the repository, then you are prompted to enter an alternate name. You can skip
+the import of that key, or enter an alternate name. If option
+\fB\-\-batch\-mode\fP is specified, then already existing keys are skipped.
+.PP
+If a key to be imported is associated with one or multiple volumes, it is
+verified that the volumes are available, and are not already associated with
+another secure key in the repository. If one of the volumes or all of them are
+not available, or are already associated with another secure key, the import
+fails. Use option \fB\-\-no\-volume\-check\fP to omit the volume check, and
+import the keys even if the associated volume(s) do not exist.
+.
+.SS "Refresh secure keys that are bound to a key management system"
+.
+.B zkey kms
+.BR refresh | ref
+.RB [ \-\-name | \-N
+.IR key-name ]
+.RB [ \-\-volumes | \-l
+.IR volume1[:dmname1][,volume2[:dmname2][,...]] ]
+.RB [ \-\-volume-type | \-t
+.IR type ]
+.RB [ \-\-key-type | \-K
+.IR type ]
+.RB [ \-\-refresh\-properties | \-P ]
+.RB [ \-\-no\-volume\-check ]
+.RB [ \-\-verbose | \-V ]
+.
+.PP
+Use the
+.B kms refresh
+command to refresh secure keys that are bound to a key management system (KMS).
+Refreshing a key updates the secure key by re-importing it from the key
+management system. Use option \fB\-\-refresh\-properties\fP to also update the
+associated information, such as the textual description, associated volumes,
+volume type, and sector size, with the information stored in the key management
+system.
+.PP
+You can filter the list of keys to be refreshed by key name, associated volumes,
+volume type, and key type. You can use wildcards for the key name, and
+associated volumes. The device-mapper name of an associated volume can be
+omitted; if it is specified then only those keys are listed that are associated
+with the specified volume and device-mapper name.
+.PP
+If a refreshed key is associated with one or multiple volumes, it is
+verified that the volumes are available, and are not already associated with
+another secure key in the repository. If one of the volumes or all of them are
+not available, or are already associated with another secure key, the refresh
+fails. Use option \fB\-\-no\-volume\-check\fP to omit the volume check, and
+refresh the keys even if the associated volume(s) do not exist.
+.
 .
 .
 .SH OPTIONS
@@ -782,6 +1170,8 @@ determines the size of the AES key.  If
 is specified, the size of the specified file must match the specified
 key size.  Valid file sizes are of 16, 24, or 32 bytes, and of 32 or 64
 bytes for keys to be used with the XTS cipher mode.
+When the secure key is generated using a key management system, then this option
+can not be specified.
 .TP
 .BR \-N ", " \-\-name\~\fIkey-name\fP
 Specifies the name of the secure key in the secure key repository.
@@ -808,6 +1198,8 @@ then the first online APQN is used to ge
 specified, then an APQN is selected automatically. All specified APQNs must be
 online, unless the \fB\-\-no\-apqn\-check\fP option is specified.
 This option is only used for secure keys contained in the secure key repository.
+When the secure key is generated using a key management system, then this option
+can not be specified.
 .TP
 .BR \-\-no\-apqn\-check
 Do not check if the specified APQNs are available. Use this option to
@@ -837,6 +1229,18 @@ Secure keys of type \fBCCA-AESCIPHER\fP
 in CCA coprocessor mode of version 6 or later, e.g. a CEX6C.
 Secure keys of type \fBEP11-AES\fP require an IBM cryptographic adapter
 in EP11 coprocessor mode of version 7 or later, e.g. a CEX7P.
+.TP
+.BR \-L ", "\-\-local
+Generate the secure AES key locally. This is the default when no key management
+system plugin (KMS plugin) is bound to the secure key repository. If the
+repository is bound to a key management system plugin, then keys are generated
+using the key management system by default.
+.TP
+.B KMS-plugin specific options
+A key management system plugin may offer and even require plugin specific
+options that can be specified with the generate command when the secure key
+repository is bound to a key management system plugin. Use \fBgenerate
+\-\-help\fP to display the plugin specific options and their meaning.
 .
 .
 .
@@ -1024,6 +1428,21 @@ Specifies the key type of the secure key
 \fBCCA-AESCIPHER\fP, and \fBEP11-AES\fP. Only keys with the specified key type
 are listed.
 This option is only used for secure keys contained in the secure key repository.
+.TP
+.BR \-L ", " \-\-local\fP
+Lists only local keys. Local keys are not bound to a key management system
+(KMS).
+This option is only used for secure keys contained in the secure key repository,
+and can not be specified together with the
+.BR \-\-kms\-bound
+option.
+.TP
+.BR \-M ", " \-\-kms\-bound\fP
+Lists only keys that are bound to a key management system (KMS).
+This option is only used for secure keys contained in the secure key repository,
+and can not be specified together with the
+.BR \-\-local
+option.
 .
 .
 .
@@ -1039,6 +1458,12 @@ The user is prompted to confirm the remo
 key repository. Use this option to remove a secure key without prompting for
 a confirmation.
 This option is only used for secure keys contained in the secure key repository.
+.TP
+.B KMS-plugin specific options
+A key management system plugin may offer and even require plugin specific
+options that can be specified with the remove command when the secure key
+repository is bound to a key management system plugin. Use \fBremove
+\-\-help\fP to display the plugin specific options and their meaning.
 .
 .
 .
@@ -1133,6 +1558,12 @@ These volumes are to be encrypted using
 volume association also contains the device-mapper name, separated by a colon,
 used with dm-crypt.
 This option is only used for secure keys contained in the secure key repository.
+.TP
+.BR \-L ", "\-\-local
+Copy the secure key to a local key. This is the default when no key management
+system plugin (KMS plugin) is bound to the secure key repository. If the
+repository is bound to a key management system plugin, then the keys are bound
+to the KMS per default, and KMS-bound keys can only be copied to local keys.
 .
 .
 .
@@ -1311,6 +1742,194 @@ to convert a secure key without promptin
 .
 .
 .
+.SS "Options for the kms configure command"
+.TP
+.BR \-a ", " \-\-apqns\~\fI[+|-]card1.domain1[,card2.domain2[,...]]\fP
+Specifies a comma-separated list of cryptographic adapters in CCA or EP11
+coprocessor mode (APQN) which are associated with the key management system
+plugin. Each APQN association specifies a card and domain number separated
+by a period (like lszcrypt displays it).
+To add an APQN to the associated APQNs, prefix the APQN with a \fI+\fP.
+To remove an APQN from the associated APQNs, prefix the APQN with a \fI-\fP.
+To set (replace) the APQN association do not specify a prefix.
+You cannot mix \fI+\fP and \fI-\fP in one specification. You can either add or
+remove (or set) the associations with one command.
+All APQNs being added or set (replaced) must be online.
+.TP
+.B KMS-plugin specific options
+A key management system plugin may offer plugin specific options that can be
+specified with the kms configure command. Use \fBkms configure \-\-help\fP to
+display the plugin specific options and their meaning.
+.
+.
+.
+.SS "Options for the kms reencipher command"
+.TP
+.BR \-n ", " \-\-to\-new
+Re-enciphers key management system plugin internal secure keys that are
+currently enciphered with the master key in the CURRENT register with the
+master key in the NEW register.
+.TP
+.BR \-o ", " \-\-from\-old
+Re-enciphers key management system plugin internal secure keys that are
+currently enciphered with the master key in the OLD register with the master
+key in the CURRENT register.
+This option is only available for CCA-type secure keys.
+.TP
+.BR \-i ", " \-\-in-place
+Forces an in-place re-enciphering of key management system plugin internal
+secure keys. "In-place" immediately replaces the secure key with the
+re-enciphered secure key. Re-enciphering from OLD to CURRENT is performed
+in-place per default.
+.TP
+.BR \-s ", " \-\-staged
+Forces that the re-enciphering of key management system plugin internal secure
+keys is performed in staged mode. Staged mode means that the re-enciphered
+secure keys are stored separately. Thus the current secure keys are still valid
+at this point. Once the new CCA or EP11 master keys have been set (made active),
+you must rerun the \fBkms reencipher\fP command with option \fB\-\-complete\fP
+to complete the staged re-enciphering.
+Re-enciphering from CURRENT to NEW is performed in staged mode per default.
+.TP
+.BR \-p ", " \-\-complete
+Completes a staged re-enciphering. Use this option after the new CCA or EP11
+master keys have been set (made active). This option replaces the secure keys by
+their re-enciphered versions.
+.TP
+.B KMS-plugin specific options
+A key management system plugin may offer plugin specific options that can be
+specified with the kms reencipher command. Use \fBkms reencipher \-\-help\fP to
+display the plugin specific options and their meaning.
+.
+.
+.
+.SS "Options for the kms list command"
+.TP
+.BR \-B ", " \-\-label\~\fIkey-label\fP
+Specifies the label of the secure key in the key management system (KMS).
+You can use wildcards to select multiple secure keys.
+When wildcards are used you must quote the value.
+Only keys with labels that match the pattern are listed.
+.TP
+.BR \-N ", " \-\-name\~\fIkey-name\fP
+Specifies the name of the secure key in the key management system (KMS).
+You can use wildcards to select multiple secure keys.
+When wildcards are used you must quote the value.
+Only keys with names that match the pattern are listed.
+This option is only used for secure keys contained in the secure key repository.
+.TP
+.BR \-l ", " \-\-volumes\~\fIvolume1[:dmname1][,volume2[:dmname2][,...]]\fP
+Specifies a comma-separated list of volumes (block devices) which are
+associated with the secure AES key in the key management system (KMS). Only
+those keys are listed, which are associated with the specified volumes.
+The volume association also contains the device-mapper name, separated by a
+colon, used with dm-crypt. You can omit the device-mapper name; if it is
+specified then only those keys are listed that are associated with the
+specified volume and device-mapper name. You can use wildcards to specify
+the volumes and device-mapper names.
+When wildcards are used you must quote the value.
+.TP
+.BR \-t ", " \-\-volume-type\~\fItype\fP
+Specifies the volume type of the associated volumes used with dm-crypt. Possible
+values are \fBplain\fP and \fBluks2\fP. Only keys with the specified volume
+type are listed.
+This option is only available if
+.B zkey
+has been compiled with LUKS2 support enabled.
+.
+.
+.
+.SS "Options for the kms import command"
+.TP
+.BR \-B ", " \-\-label\~\fIkey-label\fP
+Specifies the label of the secure key in the key management system (KMS).
+You can use wildcards to select multiple secure keys.
+When wildcards are used you must quote the value.
+Only keys with labels that match the pattern are imported.
+.TP
+.BR \-N ", " \-\-name\~\fIkey-name\fP
+Specifies the name of the secure key in the key management system (KMS).
+You can use wildcards to select multiple secure keys.
+When wildcards are used you must quote the value.
+Only keys with names that match the pattern are imported.
+.TP
+.BR \-l ", " \-\-volumes\~\fIvolume1[:dmname1][,volume2[:dmname2][,...]]\fP
+Specifies a comma-separated list of volumes (block devices) which are
+associated with the secure AES key in the key management system (KMS). Only
+those keys are imported, which are associated with the specified volumes.
+The volume association also contains the device-mapper name, separated by a
+colon, used with dm-crypt. You can omit the device-mapper name; if it is
+specified then only those keys are listed that are associated with the
+specified volume and device-mapper name. You can use wildcards to specify
+the volumes and device-mapper names.
+When wildcards are used you must quote the value.
+.TP
+.BR \-t ", " \-\-volume-type\~\fItype\fP
+Specifies the volume type of the associated volumes used with dm-crypt. Possible
+values are \fBplain\fP and \fBluks2\fP. Only keys with the specified volume
+type are imported.
+This option is only available if
+.B zkey
+has been compiled with LUKS2 support enabled.
+.TP
+.BR \-q ", " \-\-batch\-mode
+Suppress prompts to skip or to enter an anternate name, if a secure key with the
+same name as the secure key to be imported already exists in the repository.
+When this option is specified, then keys with an altready existing name are
+skipped.
+.TP
+.BR \-\-no\-volume\-check
+Do not check if the volume(s) associated with the to be imported secure key(s)
+are available, or are already associated with other secure keys in the
+repository.
+.
+.
+.
+.SS "Options for the kms refresh command"
+.TP
+.BR \-N ", " \-\-name\~\fIkey-name\fP
+Specifies the name of the secure key in the secure key repository. You can
+use wildcards to select multiple secure keys in the secure key repository.
+When wildcards are used you must quote the value.
+Only keys with names that match the pattern are refreshed.
+.TP
+.BR \-l ", " \-\-volumes\~\fIvolume1[:dmname1][,volume2[:dmname2][,...]]\fP
+Specifies a comma-separated list of volumes (block devices) which are
+associated with the secure AES key in the repository. Only those keys are
+refreshed, which are associated with the specified volumes.
+The volume association also contains the device-mapper name, separated by a
+colon, used with dm-crypt. You can omit the device-mapper name; if it is
+specified then only those keys are listed that are associated with the
+specified volume and device-mapper name. You can use wildcards to specify
+the volumes and device-mapper names.
+When wildcards are used you must quote the value.
+.TP
+.BR \-t ", " \-\-volume-type\~\fItype\fP
+Specifies the volume type of the associated volumes used with dm-crypt. Possible
+values are \fBplain\fP and \fBluks2\fP. Only keys with the specified volume
+type are refreshed.
+This option is only available if
+.B zkey
+has been compiled with LUKS2 support enabled.
+.TP
+.BR \-K ", " \-\-key-type\~\fItype\fP
+Specifies the key type of the secure key. Possible values are \fBCCA-AESDATA\fP,
+\fBCCA-AESCIPHER\fP, and \fBEP11-AES\fP. Only keys with the specified key type
+are refreshed.
+.TP
+.BR \-q ", " \-\-refresh\-properties
+Also update the associated information, such as the textual description,
+associated volumes, volume type, and sector size, with the information stored in
+the key management system.
+.TP
+.BR \-\-no\-volume\-check
+Do not check if the volume(s) associated with the secure key(s) to be refreshed
+are available, or are already associated with other secure keys in the
+repository. This option only has an effect when specified together with option
+\fB\-\-refresh\-properties\fP.
+.
+.
+.
 .SS "General options"
 .TP
 .BR \-V ", " \-\-verbose
@@ -1410,4 +2029,11 @@ If
 .B $ZKEY_REPOSITORY
 is set, it specifies the location of the secure key repository.
 If it is not set, then the the default location of the secure key
-repository is \fB/etc/zkey/repository\fP.
\ No newline at end of file
+repository is \fB/etc/zkey/repository\fP.
+.TP
+.BR ZKEY_KMS_PLUGINS
+If
+.B $ZKEY_KMS_PLUGINS
+is set, it specifies the name of the KMS plugin configuration file.
+If it is not set, then the default KMS plugin configuration file
+\fB/etc/zkey/kms-plugins.conf\fP is used.
\ No newline at end of file
diff -pruN 2.14.0-2/zkey/zkey.c 2.15.1-0ubuntu2/zkey/zkey.c
--- 2.14.0-2/zkey/zkey.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/zkey.c	2020-10-28 14:31:59.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * zkey - Generate, re-encipher, and validate secure keys
  *
- * Copyright IBM Corp. 2017, 2018
+ * Copyright IBM Corp. 2017, 2020
  *
  * s390-tools is free software; you can redistribute it and/or modify
  * it under the terms of the MIT license. See LICENSE for details.
@@ -33,11 +33,12 @@
 #include "misc.h"
 #include "pkey.h"
 #include "utils.h"
+#include "kms.h"
 
 /*
  * Program configuration
  */
-const struct util_prg prg = {
+static const struct util_prg prg = {
 	.desc = "Manage secure AES keys",
 	.command_args = "COMMAND [SECURE-KEY-FILE]",
 	.args = "",
@@ -45,7 +46,7 @@ const struct util_prg prg = {
 		{
 			.owner = "IBM Corp.",
 			.pub_first = 2017,
-			.pub_last = 2018,
+			.pub_last = 2020,
 		},
 		UTIL_PRG_COPYRIGHT_END
 	}
@@ -71,10 +72,14 @@ static struct zkey_globals {
 	char *volumes;
 	char *apqns;
 	bool noapqncheck;
+	bool novolcheck;
 	long int sector_size;
 	char *volume_type;
 	char *newname;
 	char *key_type;
+	char *label;
+	bool local;
+	bool kms_bound;
 	bool run;
 	bool batch_mode;
 	char *keyfile;
@@ -84,11 +89,16 @@ static struct zkey_globals {
 	bool force;
 	bool open;
 	bool format;
+	bool refresh_properties;
 	struct ext_lib lib;
 	struct cca_lib cca;
 	struct ep11_lib ep11;
 	int pkey_fd;
 	struct keystore *keystore;
+	struct kms_info kms_info;
+	int first_kms_option;
+	struct kms_option *kms_options;
+	size_t num_kms_options;
 } g = {
 	.pkey_fd = -1,
 	.sector_size = -1,
@@ -112,6 +122,25 @@ static struct zkey_globals {
 #define COMMAND_CRYPTTAB	"crypttab"
 #define COMMAND_CRYPTSETUP	"cryptsetup"
 #define COMMAND_CONVERT		"convert"
+#define COMMAND_KMS		"kms"
+#define COMMAND_KMS_PLUGINS	"plugins"
+#define COMMAND_KMS_BIND	"bind"
+#define COMMAND_KMS_UNBIND	"unbind"
+#define COMMAND_KMS_INFO	"info"
+#define COMMAND_KMS_CONFIGURE	"configure"
+#define COMMAND_KMS_REENCIPHER	"reencipher"
+#define COMMAND_KMS_LIST	"list"
+#define COMMAND_KMS_IMPORT	"import"
+#define COMMAND_KMS_REFRESH	"refresh"
+
+#define OPT_COMMAND_PLACEHOLDER	"PLACEHOLDER"
+
+#define OPT_PLACEHOLDER					\
+{							\
+	.option = { "", 0, NULL, ' ' },			\
+	.desc = OPT_COMMAND_PLACEHOLDER,		\
+	.command = OPT_COMMAND_PLACEHOLDER,		\
+}
 
 #define ZKEY_COMMAND_MAX_LEN	10
 
@@ -125,6 +154,8 @@ static struct zkey_globals {
 #define OPT_CRYPTSETUP_OPEN		260
 #define OPT_CRYPTSETUP_FORMAT		261
 #define OPT_NO_APQN_CHECK		262
+#define OPT_NO_VOLUME_CHECK		263
+#define OPT_REFRESH_PROPERTIES		264
 
 /*
  * Configuration of command line options
@@ -232,6 +263,14 @@ static struct util_opt opt_vec[] = {
 			"omitted, the default is '"KEY_TYPE_CCA_AESDATA"'",
 		.command = COMMAND_GENERATE,
 	},
+	{
+		.option = { "local", 0, NULL, 'L'},
+		.desc = "Generate the key locally. This is the default when no "
+			"KMS plugin is bound to the repository. If the "
+			"repository is bound to a KMS plugin, then keys are "
+			"generated by the KMS per default.",
+		.command = COMMAND_GENERATE,
+	},
 	/***********************************************************/
 	{
 		.flags = UTIL_OPT_FLAG_SECTION,
@@ -457,6 +496,18 @@ static struct util_opt opt_vec[] = {
 			"all keys with the specified key type.",
 		.command = COMMAND_LIST,
 	},
+	{
+		.option = { "local", 0, NULL, 'L'},
+		.desc = "List local keys only. Local keys are not bound to a "
+			"KMS plugin.",
+		.command = COMMAND_LIST,
+	},
+	{
+		.option = { "kms-bound", 0, NULL, 'M'},
+		.desc = "List KMS-bound keys only. KMS-bound keys are bound to "
+			"a KMS plugin.",
+		.command = COMMAND_LIST,
+	},
 	/***********************************************************/
 	{
 		.flags = UTIL_OPT_FLAG_SECTION,
@@ -591,6 +642,15 @@ static struct util_opt opt_vec[] = {
 			"specific volume.",
 		.command = COMMAND_COPY,
 	},
+	{
+		.option = { "local", 0, NULL, 'L'},
+		.desc = "Copy the key to a local key. This is the default when "
+			"no KMS plugin is bound to the repository. If the "
+			"repository is bound to a KMS plugin, then keys are "
+			"bound to the KMS per default, and KMS-bound key can "
+			"only be copied to local keys.",
+		.command = COMMAND_COPY,
+	},
 	/***********************************************************/
 	{
 		.flags = UTIL_OPT_FLAG_SECTION,
@@ -805,6 +865,271 @@ static struct util_opt opt_vec[] = {
 	/***********************************************************/
 	{
 		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "OPTIONS",
+		.command = COMMAND_KMS " " COMMAND_KMS_CONFIGURE,
+	},
+	{
+		.option = { "apqns", required_argument, NULL, 'a'},
+		.argument = "[+|-]CARD.DOMAIN[,...]",
+		.desc = "Comma-separated pairs of crypto cards and domains "
+			"that are associated with the key management system "
+			"(KMS) plugin that the repository is bound to, and all "
+			"keys generated with the KMS. To add pairs of crypto "
+			"cards and domains to the key, specify "
+			"'+CARD.DOMAIN[,...]'. To remove pairs of crypto cards "
+			"and domains from the key specify '-CARD.DOMAIN[,...]'",
+		.command = COMMAND_KMS " " COMMAND_KMS_CONFIGURE,
+	},
+	/***********************************************************/
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "OPTIONS",
+		.command = COMMAND_KMS " " COMMAND_KMS_REENCIPHER,
+	},
+	{
+		.option = {"to-new", 0, NULL, 'n'},
+		.desc = "Re-enciphers KMS plugin internal secure keys that are "
+			"currently enciphered with the master key in the "
+			"CURRENT register with the master key in the NEW "
+			"register.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REENCIPHER,
+	},
+	{
+		.option = {"from-old", 0, NULL, 'o'},
+		.desc = "Re-enciphers KMS plugin internal secure keys that are "
+			"currently enciphered with the master key in the OLD "
+			"register with the master key in the CURRENT register.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REENCIPHER,
+	},
+	{
+		.option = {"complete", 0, NULL, 'p'},
+		.desc = "Completes a staged re-enciphering. Use this option "
+			"after the new master key has been set (made "
+			"active).",
+		.command = COMMAND_KMS " " COMMAND_KMS_REENCIPHER,
+	},
+	{
+		.option = {"in-place", 0, NULL, 'i'},
+		.desc = "Forces an in-place re-enchipering of the KMS plugin "
+			"internal secure keys. Re-enciphering from OLD to "
+			"CURRENT is performed in-place per default.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REENCIPHER,
+	},
+	{
+		.option = {"staged", 0, NULL, 's'},
+		.desc = "Forces that the re-enciphering of the KMS plugin "
+			"internal secure keys is performed in staged mode. "
+			"Re-enciphering from CURRENT to NEW is performed in "
+			"staged mode per default.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REENCIPHER,
+	},
+	/***********************************************************/
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "OPTIONS",
+		.command = COMMAND_KMS " " COMMAND_KMS_LIST,
+	},
+	{
+		.option = { "label", required_argument, NULL, 'B'},
+		.argument = "LABEL",
+		.desc = "Label of the secure AES keys as known by the KMS that "
+			"are to be listed. You can use wildcards to select "
+			"the keys to be listed.",
+		.command = COMMAND_KMS " " COMMAND_KMS_LIST,
+	},
+	{
+		.option = { "name", required_argument, NULL, 'N'},
+		.argument = "NAME",
+		.desc = "Name of the secure AES keys as known by zkey that "
+			"are to be listed. You can use wildcards to select "
+			"the keys to be listed.",
+		.command = COMMAND_KMS " " COMMAND_KMS_LIST,
+	},
+	{
+		.option = { "volumes", required_argument, NULL, 'l'},
+		.argument = "VOLUME[:DMNAME][,...]",
+		.desc = "Comma-separated pairs of volume and device-mapper "
+			"names that are associated with the secure AES key in "
+			"the KMS. Use this option to list all keys "
+			"associated with specific volumes. The device-mapper "
+			"name (DMNAME) is optional. If specified, only those "
+			"keys are listed where both, the volume and the device-"
+			"mapper name matches.",
+		.command = COMMAND_KMS " " COMMAND_KMS_LIST,
+	},
+#ifdef HAVE_LUKS2_SUPPORT
+	{
+		.option = { "volume-type", required_argument, NULL, 't'},
+		.argument = "type",
+		.desc = "The type of the associated volume(s). Possible values "
+			"are 'plain' and 'luks2'. Use this option to list all "
+			"keys with the specified volumes type.",
+			.command = COMMAND_KMS " " COMMAND_KMS_LIST,
+	},
+#endif
+	/***********************************************************/
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "OPTIONS",
+		.command = COMMAND_KMS " " COMMAND_KMS_IMPORT,
+	},
+	{
+		.option = { "label", required_argument, NULL, 'B'},
+		.argument = "LABEL",
+		.desc = "Label of the secure AES keys as known by the KMS that "
+			"are to be imported. You can use wildcards to select "
+			"the keys to be imported.",
+		.command = COMMAND_KMS " " COMMAND_KMS_IMPORT,
+	},
+	{
+		.option = { "name", required_argument, NULL, 'N'},
+		.argument = "NAME",
+		.desc = "Name of the secure AES keys as known by zkey that "
+			"are to be imported. You can use wildcards to select "
+			"the keys to be imported.",
+		.command = COMMAND_KMS " " COMMAND_KMS_IMPORT,
+	},
+	{
+		.option = { "volumes", required_argument, NULL, 'l'},
+		.argument = "VOLUME[:DMNAME][,...]",
+		.desc = "Comma-separated pairs of volume and device-mapper "
+			"names that are associated with the secure AES key in "
+			"the KMS. Use this option to import all keys "
+			"associated with specific volumes. The device-mapper "
+			"name (DMNAME) is optional. If specified, only those "
+			"keys are listed where both, the volume and the device-"
+			"mapper name matches.",
+		.command = COMMAND_KMS " " COMMAND_KMS_IMPORT,
+	},
+#ifdef HAVE_LUKS2_SUPPORT
+	{
+		.option = { "volume-type", required_argument, NULL, 't'},
+		.argument = "type",
+		.desc = "The type of the associated volume(s). Possible values "
+			"are 'plain' and 'luks2'. Use this option to import "
+			"all keys with the specified volumes type.",
+		.command = COMMAND_KMS " " COMMAND_KMS_IMPORT,
+	},
+#endif
+	{
+		.option = {"batch-mode", 0, NULL, 'q'},
+		.desc = "Suppresses alternate name questions. When importing a "
+			"key with a name that already exists in the "
+			"repository, do not prompt for an alternate name, but "
+			"skip the import of the duplicate key.",
+		.command = COMMAND_KMS " " COMMAND_KMS_IMPORT,
+	},
+	{
+		.option = {"no-volume-check", 0, NULL, OPT_NO_VOLUME_CHECK},
+		.desc = "Do not check if the volume(s) associated with the "
+			"secure key(s) to be imported are available, or are "
+			"already associated with other secure keys.",
+		.command = COMMAND_KMS " " COMMAND_KMS_IMPORT,
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+	},
+	/***********************************************************/
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
+		.desc = "OPTIONS",
+		.command = COMMAND_KMS " " COMMAND_KMS_REFRESH,
+	},
+	{
+		.option = { "name", required_argument, NULL, 'N'},
+		.argument = "NAME",
+		.desc = "Name of the secure AES keys in the repository that "
+			"are to be refreshed. You can use wildcards to select "
+			"the keys to be refreshed.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REFRESH,
+	},
+	{
+		.option = { "volumes", required_argument, NULL, 'l'},
+		.argument = "VOLUME[:DMNAME][,...]",
+		.desc = "Comma-separated pairs of volume and device-mapper "
+			"names that are associated with the secure AES key in "
+			"the repository. Use this option to refresh all keys "
+			"associated with specific volumes. The device-mapper "
+			"name (DMNAME) is optional. If specified, only those "
+			"keys are refreshed where both, the volume and the "
+			"device-mapper name matches",
+		.command = COMMAND_KMS " " COMMAND_KMS_REFRESH,
+	},
+#ifdef HAVE_LUKS2_SUPPORT
+	{
+		.option = { "volume-type", required_argument, NULL, 't'},
+		.argument = "type",
+		.desc = "The type of the associated volume(s). Possible values "
+			"are 'plain' and 'luks2'. Use this option to refresh "
+			"all keys with the specified volumes type.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REFRESH,
+	},
+#endif
+	{
+		.option = { "key-type", required_argument, NULL, 'K'},
+		.argument = "type",
+		.desc = "The type of the key. Possible values are '"
+			KEY_TYPE_CCA_AESDATA"', '"KEY_TYPE_CCA_AESCIPHER"' "
+			"and '"KEY_TYPE_EP11_AES"'. Use this option to refresh "
+			"all keys with the specified key type.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REFRESH,
+	},
+	{
+		.option = {"refresh-properties", 0, NULL, 'P'},
+		.desc = "Also refresh the properties of the secure AES key "
+			"and update them with the values from the KMS.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REFRESH,
+	},
+	{
+		.option = {"no-volume-check", 0, NULL, OPT_NO_VOLUME_CHECK},
+		.desc = "Do not check if the volume(s) associated with the "
+			"secure key(s) to be refreshed are available, or are "
+			"already associated with other secure keys.",
+		.command = COMMAND_KMS " " COMMAND_KMS_REFRESH,
+		.flags = UTIL_OPT_FLAG_NOSHORT,
+	},
+	/***********************************************************/
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	OPT_PLACEHOLDER,
+	/***********************************************************/
+	{
+		.flags = UTIL_OPT_FLAG_SECTION,
 		.desc = "COMMON OPTIONS"
 	},
 	{
@@ -837,6 +1162,10 @@ struct zkey_command {
 	char *pos_arg_alternate;
 	char **arg_alternate_value;
 	int need_keystore;
+	int use_kms_plugin;
+	char *kms_plugin_opts_cmd;
+	int need_kms_login;
+	struct zkey_command *sub_commands;
 };
 
 static int command_generate(void);
@@ -852,6 +1181,131 @@ static int command_copy(void);
 static int command_crypttab(void);
 static int command_cryptsetup(void);
 static int command_convert(void);
+static int command_kms_plugins(void);
+static int command_kms_bind(void);
+static int command_kms_unbind(void);
+static int command_kms_info(void);
+static int command_kms_configure(void);
+static int command_kms_reencipher(void);
+static int command_kms_list(void);
+static int command_kms_import(void);
+static int command_kms_refresh(void);
+
+static struct zkey_command zkey_kms_commands[] = {
+	{
+		.command = COMMAND_KMS_PLUGINS,
+		.abbrev_len = 2,
+		.function = command_kms_plugins,
+		.short_desc = "Lists key management system plugins",
+		.long_desc = "Lists available key management system (KMS) "
+			     "plugins.",
+		.has_options = 1,
+	},
+	{
+		.command = COMMAND_KMS_BIND,
+		.abbrev_len = 2,
+		.function = command_kms_bind,
+		.short_desc = "Binds the repository to a key management system "
+			      "plugin",
+		.long_desc = "Binds the repository to the specified key "
+			     "management system (KMS) plugin.",
+		.need_keystore = 1,
+		.has_options = 1,
+		.pos_arg = "[KMS-PLUGIN]",
+	},
+	{
+		.command = COMMAND_KMS_UNBIND,
+		.abbrev_len = 3,
+		.function = command_kms_unbind,
+		.short_desc = "Unbinds the repository from a key management "
+			      "system plugin",
+		.long_desc = "Unbinds the repository from the current key "
+			     "management system (KMS) plugin, and turns all "
+			     "KMS-bound keys into local keys",
+		.need_keystore = 1,
+		.has_options = 1,
+		.use_kms_plugin = 1,
+	},
+	{
+		.command = COMMAND_KMS_INFO,
+		.abbrev_len = 2,
+		.function = command_kms_info,
+		.short_desc = "Displays information about a key management "
+			      "system plugin",
+		.long_desc = "Displays information about the current key "
+			     "management system (KMS) plugin",
+		.need_keystore = 1,
+		.has_options = 1,
+		.use_kms_plugin = 1,
+	},
+	{
+		.command = COMMAND_KMS_CONFIGURE,
+		.abbrev_len = 3,
+		.function = command_kms_configure,
+		.short_desc = "Configures a key management system plugin",
+		.long_desc = "Configures or re-configures the current key "
+			     "management system (KMS) plugin",
+		.need_keystore = 1,
+		.has_options = 1,
+		.use_kms_plugin = 1,
+		.kms_plugin_opts_cmd = KMS_COMMAND_CONFIGURE,
+	},
+	{
+		.command = COMMAND_KMS_REENCIPHER,
+		.abbrev_len = 2,
+		.function = command_kms_reencipher,
+		.short_desc = "Re-enciphers secure keys used by a key "
+			      "management system plugin",
+		.long_desc = "Re-enciphers secure keys internally used by a "
+			     "key management system (KMS) plugin",
+		.need_keystore = 1,
+		.has_options = 1,
+		.use_kms_plugin = 1,
+		.kms_plugin_opts_cmd = KMS_COMMAND_REENCIPHER,
+	},
+	{
+		.command = COMMAND_KMS_LIST,
+		.abbrev_len = 2,
+		.function = command_kms_list,
+		.short_desc = "Lists secure keys managed by a key management "
+			      "system",
+		.long_desc = "Lists secure keys managed by a key management "
+			     "system (KMS)",
+		.need_keystore = 1,
+		.has_options = 1,
+		.use_kms_plugin = 1,
+		.need_kms_login = 1,
+		.kms_plugin_opts_cmd = KMS_COMMAND_LIST,
+	},
+	{
+		.command = COMMAND_KMS_IMPORT,
+		.abbrev_len = 2,
+		.function = command_kms_import,
+		.short_desc = "Imports secure keys managed by a key management "
+			      "system",
+		.long_desc = "Imports secure keys managed by a key management "
+			     "system (KMS) into the repository",
+		.need_keystore = 1,
+		.has_options = 1,
+		.use_kms_plugin = 1,
+		.need_kms_login = 1,
+		.kms_plugin_opts_cmd = KMS_COMMAND_LIST_IMPORT,
+	},
+	{
+		.command = COMMAND_KMS_REFRESH,
+		.abbrev_len = 3,
+		.function = command_kms_refresh,
+		.short_desc = "Refreshes secure keys that are bound to a key "
+			      "management system",
+		.long_desc = "Refreshes secure keys that are bound to a key "
+			      "management system (KMS)",
+		.need_keystore = 1,
+		.has_options = 1,
+		.use_kms_plugin = 1,
+		.need_kms_login = 1,
+	},
+	{ .command = NULL }
+};
 
 static struct zkey_command zkey_commands[] = {
 	{
@@ -869,6 +1323,8 @@ static struct zkey_command zkey_commands
 		.pos_arg_optional = 1,
 		.pos_arg_alternate = "--name/-N",
 		.arg_alternate_value = &g.name,
+		.use_kms_plugin = 1,
+		.kms_plugin_opts_cmd = KMS_COMMAND_GENERATE,
 	},
 	{
 		.command = COMMAND_REENCIPHER,
@@ -938,6 +1394,8 @@ static struct zkey_command zkey_commands
 		.long_desc = "Remove a secure AES key from the repository",
 		.has_options = 1,
 		.need_keystore = 1,
+		.use_kms_plugin = 1,
+		.kms_plugin_opts_cmd = KMS_COMMAND_REMOVE,
 	},
 	{
 		.command = COMMAND_CHANGE,
@@ -948,6 +1406,7 @@ static struct zkey_command zkey_commands
 			     "the repository",
 		.has_options = 1,
 		.need_keystore = 1,
+		.use_kms_plugin = 1,
 	},
 	{
 		.command = COMMAND_RENAME,
@@ -957,6 +1416,7 @@ static struct zkey_command zkey_commands
 		.long_desc = "Rename a secure AES key in the repository",
 		.has_options = 1,
 		.need_keystore = 1,
+		.use_kms_plugin = 1,
 	},
 	{
 		.command = COMMAND_COPY,
@@ -1001,34 +1461,83 @@ static struct zkey_command zkey_commands
 		.pos_arg = "[SECURE-KEY-FILE]",
 		.pos_arg_optional = 1,
 	},
+	{
+		.command = COMMAND_KMS,
+		.abbrev_len = 2,
+		.short_desc = "key management system (KMS) support",
+		.long_desc = "Provides subcommands for key management system "
+			     "(KMS) support.",
+		.has_options = 1,
+		.sub_commands = zkey_kms_commands,
+	},
 	{ .command = NULL }
 };
 
 #define pr_verbose(fmt...)	if (g.verbose) \
 					warnx(fmt)
 
-static void print_usage_command(const struct zkey_command *command)
+static void print_usage_sub_command_list(const struct zkey_command *sub_command)
+{
+	struct zkey_command *sub_cmd = (struct zkey_command *)sub_command;
+	char command_str[ZKEY_COMMAND_STR_LEN];
+	unsigned int i;
+
+	printf("SUBCOMMANDS\n");
+	while (sub_cmd->command) {
+		strcpy(command_str, sub_cmd->command);
+		for (i = 0; i < sub_cmd->abbrev_len; i++)
+			command_str[i] =
+				toupper(command_str[i]);
+		printf("  %-*s    %s\n", ZKEY_COMMAND_MAX_LEN,
+		       command_str, sub_cmd->short_desc);
+		sub_cmd++;
+	}
+}
+
+static void print_usage_command(const struct zkey_command *command,
+				const struct zkey_command *sub_command)
 {
+	char sub_command_str[ZKEY_COMMAND_STR_LEN];
 	char command_str[ZKEY_COMMAND_STR_LEN];
+	const struct zkey_command *cmd;
 	unsigned int i;
 
 	strncpy(command_str, command->command, sizeof(command_str) - 1);
 	for (i = 0; i < command->abbrev_len; i++)
 		command_str[i] = toupper(command_str[i]);
 
-	printf("Usage: %s %s",
-	       program_invocation_short_name, command_str);
-	if (command->pos_arg != NULL)
-		printf(" %s", command->pos_arg);
-	if (command->has_options)
+	if (sub_command != NULL) {
+		strncpy(sub_command_str, sub_command->command,
+			sizeof(sub_command_str) - 1);
+		for (i = 0; i < sub_command->abbrev_len; i++)
+			sub_command_str[i] = toupper(sub_command_str[i]);
+
+		printf("Usage: %s %s %s", program_invocation_short_name,
+		       command_str, sub_command_str);
+	} else {
+		printf("Usage: %s %s", program_invocation_short_name,
+		       command_str);
+		if (command->sub_commands != NULL)
+			printf(" SUBCOMMAND");
+	}
+
+	cmd = sub_command != NULL ? sub_command : command;
+
+	if (cmd->pos_arg != NULL)
+		printf(" %s", cmd->pos_arg);
+	if (cmd->has_options)
 		printf(" [OPTIONS]");
+
 	if (prg.args)
 		printf(" %s", prg.args);
 	printf("\n\n");
-	util_print_indented(command->long_desc, 0);
+	util_print_indented(cmd->long_desc, 0);
 
-	if (command->has_options)
+	if (cmd->has_options)
 		printf("\n");
+
+	if (sub_command == NULL && command->sub_commands != NULL)
+		print_usage_sub_command_list(command->sub_commands);
 }
 
 static void print_usage_command_list(void)
@@ -1054,21 +1563,26 @@ static void print_usage_command_list(voi
 /*
  * --help printout
  */
-static void print_help(const struct zkey_command *command)
+static void print_help(const struct zkey_command *command,
+		       const struct zkey_command *sub_command)
 {
 	/* Print usage */
-	if (!command)
+	if (command == NULL)
 		print_usage_command_list();
 	else
-		print_usage_command(command);
+		print_usage_command(command, sub_command);
 
 	/* Print parameter help */
 	util_opt_print_help();
 
-	if (!command) {
+	if (command == NULL) {
 		printf("\n");
 		printf("For more information use '%s COMMAND --help'.\n",
 			program_invocation_short_name);
+	} else if (command->sub_commands != NULL && sub_command == NULL) {
+		printf("\n");
+		printf("For more information use '%s %s SUBCOMMAND --help'.\n",
+			program_invocation_short_name, command->command);
 	}
 }
 
@@ -1117,11 +1631,44 @@ static int command_generate_repository(v
 	if (g.sector_size < 0)
 		g.sector_size = 0;
 
+	if (g.kms_info.plugin_lib != NULL && !g.local) {
+		if (g.apqns != NULL) {
+			warnx("Option '--apqns|-a' is not valid for "
+			      "generating a key in a KMS-bound repository");
+			util_prg_print_parse_error();
+			return EXIT_FAILURE;
+		}
+
+		if (g.clearkeyfile != NULL) {
+			warnx("Option '----clearkey|-c' is not valid for "
+			      "generating a key in a KMS-bound repository, "
+			      "unless option '--local|-L' is also specified");
+			util_prg_print_parse_error();
+			return EXIT_FAILURE;
+		}
+
+		rc = perform_kms_login(&g.kms_info, g.verbose);
+		if (rc != 0)
+			rc = EXIT_FAILURE;
+
+		rc = keystore_generate_key_kms(g.keystore, g.name,
+					       g.description, g.volumes,
+					       g.sector_size, g.keybits, g.xts,
+					       g.volume_type, g.key_type,
+					       g.kms_options,
+					       g.num_kms_options);
+		goto out;
+	}
+
+	if (g.key_type == NULL)
+		g.key_type = KEY_TYPE_CCA_AESDATA;
+
 	rc = keystore_generate_key(g.keystore, g.name, g.description, g.volumes,
 				   g.apqns, g.noapqncheck, g.sector_size,
 				   g.keybits, g.xts, g.clearkeyfile,
 				   g.volume_type, g.key_type, g.pkey_fd);
 
+out:
 	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
 }
 
@@ -1147,10 +1694,10 @@ static int command_generate(void)
 		util_prg_print_parse_error();
 		return EXIT_FAILURE;
 	}
-	if (g.key_type == NULL)
-		g.key_type = KEY_TYPE_CCA_AESDATA;
 	if (g.name != NULL)
 		return command_generate_repository();
+	if (g.key_type == NULL)
+		g.key_type = KEY_TYPE_CCA_AESDATA;
 	if (g.pos_arg != NULL) {
 		if (g.volumes != NULL) {
 			warnx("Option '--volumes|-l' is not valid for "
@@ -1176,6 +1723,12 @@ static int command_generate(void)
 			util_prg_print_parse_error();
 			return EXIT_FAILURE;
 		}
+		if (g.local) {
+			warnx("Option '--local|-L' is not valid for "
+			      "generating a key outside of the repository");
+			util_prg_print_parse_error();
+			return EXIT_FAILURE;
+		}
 
 		rc = cross_check_apqns(NULL, NULL,
 				get_min_card_level_for_keytype(g.key_type),
@@ -1594,8 +2147,16 @@ static int command_list(void)
 {
 	int rc;
 
+	if (g.local && g.kms_bound) {
+		warnx("Either '--local|-L' or '--kms-bound|-M' can be "
+		      "specified, but not both");
+		util_prg_print_parse_error();
+		return EXIT_FAILURE;
+	}
+
 	rc = keystore_list_keys(g.keystore, g.name, g.volumes, g.apqns,
-				g.volume_type, g.key_type);
+				g.volume_type, g.key_type, g.local,
+				g.kms_bound);
 
 	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
 }
@@ -1614,7 +2175,8 @@ static int command_remove(void)
 		return EXIT_FAILURE;
 	}
 
-	rc = keystore_remove_key(g.keystore, g.name, g.force);
+	rc = keystore_remove_key(g.keystore, g.name, g.force, g.kms_options,
+				 g.num_kms_options);
 
 	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
 }
@@ -1687,7 +2249,8 @@ static int command_copy(void)
 		return EXIT_FAILURE;
 	}
 
-	rc = keystore_copy_key(g.keystore, g.name, g.newname, g.volumes);
+	rc = keystore_copy_key(g.keystore, g.name, g.newname, g.volumes,
+			       g.local);
 
 	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
 }
@@ -1933,6 +2496,240 @@ static int command_convert(void)
 	return EXIT_SUCCESS;
 }
 
+/*
+ * Command handler for 'kms plugins'.
+ *
+ * List KMS plugins
+ */
+static int command_kms_plugins(void)
+{
+	int rc;
+
+	rc = list_kms_plugins(g.verbose);
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+/*
+ * Command handler for 'kms bind'.
+ *
+ * Bind repository to a KMS plugin
+ */
+static int command_kms_bind(void)
+{
+	int rc;
+
+	rc = bind_kms_plugin(g.keystore, g.pos_arg, g.verbose);
+
+	if (rc == 0)
+		util_print_indented("The KMS plugin requires configuration, "
+				    "run 'zkey kms configure [OPTIONS]' to "
+				    "complete the KMS binding process", 0);
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+/*
+ * Command handler for 'kms unbind'.
+ *
+ * Unbind repository from a KMS plugin
+ */
+static int command_kms_unbind(void)
+{
+	char *msg;
+	int rc;
+
+	if (g.kms_info.plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		return EXIT_FAILURE;
+	}
+
+	util_asprintf(&msg, "%s: Unbind this repository from KMS plugin '%s' "
+		     "and turn all KMS-bound keys into local keys [y/N]? ",
+		     program_invocation_short_name, g.kms_info.plugin_name);
+	util_print_indented(msg, 0);
+	free(msg);
+	if (!prompt_for_yes(g.verbose)) {
+		warnx("Operation aborted");
+		return EXIT_FAILURE;
+	}
+
+	rc = keystore_kms_keys_unbind(g.keystore);
+	if (rc != 0) {
+		warnx("Failed to turn KMS-bound keys into local keys: %s",
+		      strerror(-rc));
+		return EXIT_FAILURE;
+	}
+
+	rc = unbind_kms_plugin(&g.kms_info, g.keystore, g.verbose);
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+/*
+ * Command handler for 'kms info'.
+ *
+ * Prints information about a KMS plugin
+ */
+static int command_kms_info(void)
+{
+	int rc;
+
+	if (g.kms_info.plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		return EXIT_FAILURE;
+	}
+
+	rc = print_kms_info(&g.kms_info);
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+/*
+ * Command handler for 'kms configure'.
+ *
+ * Configures or re-configures a KMS plugin
+ */
+static int command_kms_configure(void)
+{
+	int rc;
+
+	if (g.kms_info.plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		return EXIT_FAILURE;
+	}
+
+	rc = configure_kms_plugin(g.keystore, g.apqns, g.kms_options,
+				  g.num_kms_options, g.first_kms_option >= 0,
+				  g.verbose);
+	if (rc == -EAGAIN) {
+		util_print_indented("The KMS plugin has accepted the "
+				    "configuration so far, but requires further"
+				    " configuration. Run 'zkey kms info' to "
+				    "find out which KMS plugin settings still "
+				    "require configuration, and run 'zkey kms "
+				    "configure' again with the appropriate "
+				    "options to complete the KMS "
+				    "configuration process", 0);
+		rc = 0;
+	}
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+/*
+ * Command handler for 'kms reencipher'.
+ *
+ * Reenciphers secure keys internally used by a KMS plugin
+ */
+static int command_kms_reencipher(void)
+{
+	int rc;
+
+	if (g.kms_info.plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		return EXIT_FAILURE;
+	}
+
+	if (g.inplace && g.staged) {
+		warnx("Either '--in-place|-i' or '--staged|-s' can be "
+		      "specified, but not both");
+		util_prg_print_parse_error();
+		return EXIT_FAILURE;
+	}
+	if (g.complete) {
+		if (g.inplace) {
+			warnx("Option '--in-place|-i' is not valid together "
+			      "with '--complete|-p'");
+			util_prg_print_parse_error();
+			return EXIT_FAILURE;
+		}
+		if (g.staged) {
+			warnx("Option '--staged|-s' is not valid together "
+			      "with '--complete|-p'");
+			util_prg_print_parse_error();
+			return EXIT_FAILURE;
+		}
+	}
+
+	rc = reencipher_kms(&g.kms_info, g.fromold, g.tonew, g.inplace,
+			   g.staged, g.complete, g.kms_options,
+			   g.num_kms_options, g.verbose);
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+/*
+ * Command handler for 'kms list'.
+ *
+ * List secure keys managed by a KMS
+ */
+static int command_kms_list(void)
+{
+	int rc;
+
+	if (g.kms_info.plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		return EXIT_FAILURE;
+	}
+
+	rc = list_kms_keys(&g.kms_info, g.label, g.name, g.volumes,
+			   g.volume_type, g.kms_options, g.num_kms_options,
+			   g.verbose);
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+/*
+ * Command handler for 'kms import'.
+ *
+ * Imports secure keys managed by a KMS
+ */
+static int command_kms_import(void)
+{
+	int rc;
+
+	if (g.kms_info.plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		return EXIT_FAILURE;
+	}
+
+	rc = keystore_import_kms_keys(g.keystore, g.label, g.name, g.volumes,
+				      g.volume_type, g.kms_options,
+				      g.num_kms_options, g.batch_mode,
+				      g.novolcheck);
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+/*
+ * Command handler for 'kms refresh'.
+ *
+ * Refreshes secure keys managed by a KMS
+ */
+static int command_kms_refresh(void)
+{
+	int rc;
+
+	if (g.kms_info.plugin_lib == NULL) {
+		rc = -ENOENT;
+		warnx("The repository is not bound to a KMS plugin");
+		return EXIT_FAILURE;
+	}
+
+	rc = keystore_refresh_kms_keys(g.keystore, g.name, g.volumes,
+				       g.volume_type, g.key_type,
+				       g.refresh_properties, g.novolcheck);
+
+	return rc != 0 ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
 /**
  * Opens the keystore. The keystore directory is either the
  * default directory or as specified in an environment variable
@@ -1945,7 +2742,7 @@ static int open_keystore(void)
 	if (directory == NULL)
 		directory = DEFAULT_KEYSTORE;
 
-	g.keystore = keystore_new(directory, g.verbose);
+	g.keystore = keystore_new(directory, &g.kms_info, g.verbose);
 
 	return g.keystore == NULL ? EXIT_FAILURE : EXIT_SUCCESS;
 }
@@ -1972,9 +2769,10 @@ static bool is_command(struct zkey_comma
 /*
  * Find the command in the command table
  */
-struct zkey_command *find_command(const char *command)
+static struct zkey_command *find_command(const struct zkey_command *commands,
+				         const char *command)
 {
-	struct zkey_command *cmd = zkey_commands;
+	struct zkey_command *cmd = (struct zkey_command *)commands;
 
 	while (cmd->command) {
 		if (is_command(cmd, command))
@@ -2012,40 +2810,105 @@ static int check_positional_arg(struct z
  */
 int main(int argc, char *argv[])
 {
+	char command_str[2 * ZKEY_COMMAND_STR_LEN + 2];
+	struct zkey_command *sub_command = NULL;
 	struct zkey_command *command = NULL;
+	struct zkey_command *cmd = NULL;
 	int arg_count = argc;
 	char **args = argv;
 	char *endp;
 	int rc, c;
 
 	util_prg_init(&prg);
-	util_opt_init(opt_vec, NULL);
 
-	/* Get command if one is specified */
-	if (argc >= 2 && strncmp(argv[1], "-", 1) != 0) {
-		command = find_command(argv[1]);
+	/* Get command and subcommand if one is specified */
+	if (arg_count >= 2 && strncmp(args[1], "-", 1) != 0) {
+		command = find_command(zkey_commands, args[1]);
 		if (command == NULL) {
-			misc_print_invalid_command(argv[1]);
+			misc_print_invalid_command(args[1]);
 			return EXIT_FAILURE;
 		}
 
-		arg_count = argc - 1;
-		args = &argv[1];
+		arg_count--;
+		args = &args[1];
 
-		if (argc >= 3 && strncmp(argv[2], "-", 1) != 0) {
-			g.pos_arg = argv[2];
-			arg_count = argc - 2;
-			args = &argv[2];
+		if (arg_count >= 2 && strncmp(args[1], "-", 1) != 0 &&
+		    command->sub_commands != NULL) {
+			sub_command = find_command(command->sub_commands,
+						   args[1]);
+			if (sub_command == NULL) {
+				misc_print_invalid_command(args[1]);
+				return EXIT_FAILURE;
+			}
+
+			arg_count--;
+			args = &args[1];
+		}
+
+		if (arg_count >= 2 && strncmp(args[1], "-", 1) != 0) {
+			g.pos_arg = args[1];
+			arg_count--;
+			args = &args[1];
 		}
 	}
 
-	util_opt_set_command(command ? command->command : NULL);
-	util_prg_set_command(command ? command->command : NULL);
+	if (sub_command != NULL) {
+		snprintf(command_str, sizeof(command_str), "%s %s",
+			 command->command, sub_command->command);
+		util_prg_set_command(command_str);
+		util_opt_set_command(command_str);
+	} else {
+		util_prg_set_command(command ? command->command : NULL);
+		util_opt_set_command(command ? command->command : NULL);
+	}
+
+	if (sub_command != NULL && command->sub_commands != NULL)
+		cmd = sub_command;
+	else
+		cmd = command;
+
+	if (cmd != NULL && cmd->use_kms_plugin) {
+		rc = check_for_kms_plugin(&g.kms_info, g.verbose);
+		if (rc != 0)
+			return EXIT_FAILURE;
+
+		if (cmd->kms_plugin_opts_cmd) {
+			rc = get_kms_options(&g.kms_info, opt_vec,
+					     OPT_COMMAND_PLACEHOLDER,
+					     cmd->kms_plugin_opts_cmd,
+					     sub_command != NULL ?
+						command_str : cmd->command,
+					     &g.first_kms_option,
+					     g.verbose);
+			if (rc != 0)
+				return EXIT_FAILURE;
+		}
+	}
+
+	util_opt_init(opt_vec, NULL);
 
 	while (1) {
 		c = util_opt_getopt_long(arg_count, args);
 		if (c == -1)
 			break;
+
+		if (cmd != NULL && cmd->kms_plugin_opts_cmd) {
+			rc = handle_kms_option(&g.kms_info, opt_vec,
+					       g.first_kms_option,
+					       sub_command != NULL ?
+						    command_str : cmd->command,
+					       c, optarg, &g.kms_options,
+					       &g.num_kms_options, g.verbose);
+			if (rc != 0 && rc != -ENOENT) {
+				warnx("Failed to process KMS plugin option: "
+				      "'%c': %s", c, strerror(-rc));
+				return EXIT_FAILURE;
+			}
+
+			if (rc == 0)
+				continue;
+		}
+
 		switch (c) {
 		case 'x':
 			g.xts = 1;
@@ -2097,6 +2960,9 @@ int main(int argc, char *argv[])
 		case OPT_NO_APQN_CHECK:
 			g.noapqncheck = 1;
 			break;
+		case OPT_NO_VOLUME_CHECK:
+			g.novolcheck = 1;
+			break;
 		case 'S':
 			g.sector_size = strtol(optarg, &endp, 0);
 			if (*optarg == '\0' || *endp != '\0' ||
@@ -2178,8 +3044,20 @@ int main(int argc, char *argv[])
 			g.format = 1;
 			break;
 #endif
+		case 'L':
+			g.local = 1;
+			break;
+		case 'M':
+			g.kms_bound = 1;
+			break;
+		case 'B':
+			g.label = optarg;
+			break;
+		case 'P':
+			g.refresh_properties = 1;
+			break;
 		case 'h':
-			print_help(command);
+			print_help(command, sub_command);
 			return EXIT_SUCCESS;
 		case 'v':
 			util_prg_print_version();
@@ -2195,37 +3073,43 @@ int main(int argc, char *argv[])
 		return EXIT_FAILURE;
 	}
 
-	if (command == NULL) {
+	if (cmd == NULL) {
 		misc_print_missing_command();
 		return EXIT_FAILURE;
 	}
 
-	if (command->pos_arg != NULL) {
-		if (check_positional_arg(command) != EXIT_SUCCESS)
+	if (cmd->sub_commands != NULL) {
+		misc_print_missing_sub_command();
+		return EXIT_FAILURE;
+	}
+
+	if (cmd->pos_arg != NULL) {
+		if (check_positional_arg(cmd) != EXIT_SUCCESS)
 			return EXIT_FAILURE;
 	}
 
-	if (command->need_keystore || g.pos_arg == NULL) {
+	if (cmd->need_keystore ||
+	    (cmd->pos_arg_optional && g.pos_arg == NULL)) {
 		rc = open_keystore();
 		if (rc != EXIT_SUCCESS)
 			goto out;
 	}
 
-	if (command->need_cca_library) {
+	if (cmd->need_cca_library) {
 		rc = load_cca_library(&g.cca, g.verbose);
 		if (rc != 0) {
 			rc = EXIT_FAILURE;
 			goto out;
 		}
 	}
-	if (command->need_ep11_library) {
+	if (cmd->need_ep11_library) {
 		rc = load_ep11_library(&g.ep11, g.verbose);
 		if (rc != 0) {
 			rc = EXIT_FAILURE;
 			goto out;
 		}
 	}
-	if (command->need_pkey_device) {
+	if (cmd->need_pkey_device) {
 		g.pkey_fd = open_pkey_device(g.verbose);
 		if (g.pkey_fd == -1) {
 			rc = EXIT_FAILURE;
@@ -2233,11 +3117,28 @@ int main(int argc, char *argv[])
 		}
 	}
 
+	if (g.kms_info.plugin_lib != NULL) {
+		rc = init_kms_plugin(&g.kms_info, g.verbose);
+		if (rc != 0) {
+			rc = EXIT_FAILURE;
+			goto out;
+		}
+
+		if (cmd->need_kms_login) {
+			rc = perform_kms_login(&g.kms_info, g.verbose);
+			if (rc != 0) {
+				rc = EXIT_FAILURE;
+				goto out;
+			}
+		}
+	}
+
 	umask(0077);
 
-	rc = command->function();
+	rc = cmd->function();
 
 out:
+	free_kms_plugin(&g.kms_info);
 	if (g.cca.lib_csulcca)
 		dlclose(g.cca.lib_csulcca);
 	if (g.ep11.lib_ep11)
@@ -2246,5 +3147,7 @@ out:
 		close(g.pkey_fd);
 	if (g.keystore)
 		keystore_free(g.keystore);
+	if (g.kms_options != NULL)
+		free(g.kms_options);
 	return rc;
 }
diff -pruN 2.14.0-2/zkey/zkey-cryptsetup.c 2.15.1-0ubuntu2/zkey/zkey-cryptsetup.c
--- 2.14.0-2/zkey/zkey-cryptsetup.c	2020-08-21 10:12:02.000000000 +0000
+++ 2.15.1-0ubuntu2/zkey/zkey-cryptsetup.c	2020-10-28 14:31:59.000000000 +0000
@@ -73,7 +73,7 @@ static void misc_print_required_parms(co
 /*
  * Program configuration
  */
-const struct util_prg prg = {
+static const struct util_prg prg = {
 	.desc = "Manage secure volume keys of volumes encrypted with LUKS2 and "
 		"the 'paes' cipher",
 	.command_args = "COMMAND DEVICE",
@@ -368,8 +368,8 @@ static void set_int_handler(void)
 	pr_verbose("Installing SIGINT/SIGTERM handler");
 	memset(&sigaction_open, 0, sizeof(struct sigaction));
 	sigaction_open.sa_handler = int_handler;
-	sigaction(SIGINT, &sigaction_open, 0);
-	sigaction(SIGTERM, &sigaction_open, 0);
+	sigaction(SIGINT, &sigaction_open, NULL);
+	sigaction(SIGTERM, &sigaction_open, NULL);
 }
 
 static void print_usage_command(const struct zkey_cryptsetup_command *command)
@@ -2256,7 +2256,7 @@ static bool is_command(struct zkey_crypt
 /*
  * Find the command in the command table
  */
-struct zkey_cryptsetup_command *find_command(const char *command)
+static struct zkey_cryptsetup_command *find_command(const char *command)
 {
 	struct zkey_cryptsetup_command *cmd = zkey_cryptsetup_commands;
 
